/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(J){for(var e=[],D=0,n=J.length;D<n;D++)e[D]=ne[J[D]];return e};define(ne[99],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(ne[48],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,b,E){this.id=R,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(T,R){const b=["codicon","codicon-"+T];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=R.exec(C.id);if(!f)return b(n.error);let[,y,u]=f;const p=["codicon","codicon-"+y];return u&&p.push("codicon-modifier-"+u.substr(1)),p}T.asClassNameArray=b;function E(C){return b(C).join(" ")}T.asClassName=E;function P(C){return"."+b(C).join(".")}T.asCSSSelector=P})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ne[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(P){const C=[];for(let f in P)D.call(P,f)&&C.push(P[f]);return C}e.values=n;function L(P,C){for(let f in P)if(D.call(P,f)&&C({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function A(P,C){const f=Object.create(null);for(const y of P){const u=C(y);let p=f[u];p||(p=f[u]=[]),p.push(y)}return f}e.groupBy=A;function T(P){const C=Object.create(null);return P&&P.forEach((f,y)=>{C[y]=f}),C}e.fromMap=T;function R(P,C){const f=[],y=[];for(let u of P)C.has(u)||f.push(u);for(let u of C)P.has(u)||y.push(u);return{removed:f,added:y}}e.diffSets=R;function b(P,C){const f=[],y=[];for(let[u,p]of P)C.has(u)||f.push(p);for(let[u,p]of C)P.has(u)||y.push(p);return{removed:f,added:y}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let y=this.map.get(C);y||(y=new Set,this.map.set(C,y)),y.add(f)}delete(C,f){const y=this.map.get(C);!y||(y.delete(f),y.size===0&&this.map.delete(C))}forEach(C,f){const y=this.map.get(C);!y||y.forEach(f)}}e.SetMap=E}),define(ne[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(R,b,E)=>{let P=null,C=null;if(typeof E.value=="function"?(P="value",C=E.value):typeof E.get=="function"&&(P="get",C=E.get),!C)throw new Error("not supported");E[P]=T(C,b)}}e.createDecorator=D;function n(T,R,b){let E=null,P=null;if(typeof b.value=="function"?(E="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",P=b.get),!P)throw new Error("not supported");const C=`$memoize$${R}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[C]}}e.memoize=n;function L(T,R,b){return D((E,P)=>{const C=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...y){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),R&&(this[f]=R(this[f],...y),y=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,y),this[f]=b?b():void 0},T)}})}e.debounce=L;function A(T,R,b){return D((E,P)=>{const C=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,y=`$throttle$lastRun$${P}`,u=`$throttle$pending$${P}`;return function(...p){if(this[f]||(this[f]=b?b():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...p)),this[u])return;const d=this[y]+T;d<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=A}),define(ne[9],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(c=>{c(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function A(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=A;function T(l){if(l instanceof Error){let{name:r,message:c}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:c,stack:i}}return l}e.transformErrorForSerialization=T;const R="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=b;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function P(){const l=new Error(R);return l.name=l.message,l}e.canceled=P;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function u(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=u;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=p;class d extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=d;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function v(l,r=Object.create(null)){const c=new Error(l);return r.actions&&(c.actions=r.actions),c}e.createErrorWithActions=v}),define(ne[16],ie([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(W,N=0){return W[W.length-(1+N)]}e.tail=n;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=L;function A(W,N,V=($,B)=>$===B){if(W===N)return!0;if(!W||!N||W.length!==N.length)return!1;for(let $=0,B=W.length;$<B;$++)if(!V(W[$],N[$]))return!1;return!0}e.equals=A;function T(W,N,V){let $=0,B=W.length-1;for(;$<=B;){const te=($+B)/2|0,se=V(W[te],N);if(se<0)$=te+1;else if(se>0)B=te-1;else return te}return-($+1)}e.binarySearch=T;function R(W,N){let V=0,$=W.length;if($===0)return 0;for(;V<$;){const B=Math.floor((V+$)/2);N(W[B])?$=B:V=B+1}return V}e.findFirstInSorted=R;function b(W,N,V){if(W=W|0,W>=N.length)throw new TypeError("invalid index");let $=N[Math.floor(N.length*Math.random())],B=[],te=[],se=[];for(let ce of N){const he=V(ce,$);he<0?B.push(ce):he>0?te.push(ce):se.push(ce)}return W<B.length?b(W,B,V):W<B.length+se.length?se[0]:b(W-(B.length+se.length),te,V)}e.quickSelect=b;function E(W,N){const V=[];let $;for(const B of W.slice(0).sort(N))!$||N($[0],B)!==0?($=[B],V.push($)):$.push(B);return V}e.groupBy=E;function P(W,N,V){const $=[];function B(ce,he,ve){if(he===0&&ve.length===0)return;const pe=$[$.length-1];pe&&pe.start+pe.deleteCount===ce?(pe.deleteCount+=he,pe.toInsert.push(...ve)):$.push({start:ce,deleteCount:he,toInsert:ve})}let te=0,se=0;for(;;){if(te===W.length){B(te,0,N.slice(se));break}if(se===N.length){B(te,W.length-te,[]);break}const ce=W[te],he=N[se],ve=V(ce,he);ve===0?(te+=1,se+=1):ve<0?(B(te,1,[]),te+=1):ve>0&&(B(te,0,[he]),se+=1)}return $}e.sortedDiff=P;function C(W,N,V){const $=P(W,N,V),B=[],te=[];for(const se of $)B.push(...W.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:B,added:te}}e.delta=C;function f(W,N,V){if(V===0)return[];const $=W.slice(0,V).sort(N);return u(W,N,$,V,W.length),$}e.top=f;function y(W,N,V,$,B){return V===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=W.length,he=W.slice(0,V).sort(N);for(let ve=V,pe=Math.min(V+$,ce);ve<ce;ve=pe,pe=Math.min(pe+$,ce)){if(ve>V&&await new Promise(Ee=>setTimeout(Ee)),B&&B.isCancellationRequested)throw(0,D.canceled)();u(W,N,he,ve,pe)}return he})().then(te,se)})}e.topAsync=y;function u(W,N,V,$,B){for(const te=V.length;$<B;$++){const se=W[$];if(N(se,V[te-1])<0){V.pop();const ce=R(V,he=>N(se,he)<0);V.splice(ce,0,se)}}}function p(W){return W.filter(N=>!!N)}e.coalesce=p;function d(W){let N=0;for(let V=0;V<W.length;V++)W[V]&&(W[N]=W[V],N+=1);W.length=N}e.coalesceInPlace=d;function m(W,N,V){W.splice(V,0,W.splice(N,1)[0])}e.move=m;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function g(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=g;function v(W,N=V=>V){const V=new Set;return W.filter($=>{const B=N($);return V.has(B)?!1:(V.add(B),!0)})}e.distinct=v;function l(W){const N=new Set;return V=>{const $=W(V);return N.has($)?!1:(N.add($),!0)}}e.uniqueFilter=l;function r(W,N){const V=c(W,N);if(V!==-1)return W[V]}e.findLast=r;function c(W,N){for(let V=W.length-1;V>=0;V--){const $=W[V];if(N($))return V}return-1}e.lastIndex=c;function i(W,N){return W.length>0?W[0]:N}e.firstOrDefault=i;function t(W,N,V=($,B)=>$===B){let $=0;for(let B=0,te=Math.min(W.length,N.length);B<te&&V(W[B],N[B]);B++)$++;return $}e.commonPrefixLength=t;function o(W){return[].concat(...W)}e.flatten=o;function s(W,N){let V=typeof N=="number"?W:0;typeof N=="number"?V=W:(V=0,N=W);const $=[];if(V<=N)for(let B=V;B<N;B++)$.push(B);else for(let B=V;B>N;B--)$.push(B);return $}e.range=s;function a(W,N,V){return W.reduce(($,B)=>($[N(B)]=V?V(B):B,$),Object.create(null))}e.index=a;function h(W,N){return W.push(N),()=>S(W,N)}e.insert=h;function S(W,N){const V=W.indexOf(N);if(V>-1)return W.splice(V,1),N}e.remove=S;function I(W,N,V){const $=W.slice(0,N),B=W.slice(N);return $.concat(V,B)}e.arrayInsert=I;function _(W,N){let V;if(typeof N=="number"){let $=N;V=()=>{const B=Math.sin($++)*179426549;return B-Math.floor(B)}}else V=Math.random;for(let $=W.length-1;$>0;$-=1){const B=Math.floor(V()*($+1)),te=W[$];W[$]=W[B],W[B]=te}}e.shuffle=_;function O(W,N){const V=W.indexOf(N);V>-1&&(W.splice(V,1),W.unshift(N))}e.pushToStart=O;function F(W,N){const V=W.indexOf(N);V>-1&&(W.splice(V,1),W.push(N))}e.pushToEnd=F;function z(W,N){return Array.isArray(W)?W.map(N):N(W)}e.mapArrayOrNot=z;function k(W){return Array.isArray(W)?W:[W]}e.asArray=k;function U(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=U;function j(W,N){for(const V of W){const $=N(V);if($!==void 0)return $}}e.mapFind=j;function M(W,N,V){const $=K(W,N),B=W.length,te=V.length;W.length=B+te;for(let se=B-1;se>=$;se--)W[se+te]=W[se];for(let se=0;se<te;se++)W[se+$]=V[se]}e.insertInto=M;function G(W,N,V,$){const B=K(W,N),te=W.splice(B,V);return M(W,B,$),te}e.splice=G;function K(W,N){return N<0?Math.max(N+W.length,0):Math.min(N,W.length)}function x(W,N){return(V,$)=>N(W(V),W($))}e.compareBy=x;const q=(W,N)=>W-N;e.numberComparator=q;function X(W,N){if(W.length===0)return;let V=W[0];for(let $=1;$<W.length;$++){const B=W[$];N(B,V)>0&&(V=B)}return V}e.findMaxBy=X;function H(W,N){if(W.length===0)return;let V=W[0];for(let $=1;$<W.length;$++){const B=W[$];N(B,V)>=0&&(V=B)}return V}e.findLastMaxBy=H;function Z(W,N){return X(W,(V,$)=>-N(V,$))}e.findMinBy=Z;class ee{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let V=this.firstIdx;for(;V<this.items.length&&N(this.items[V]);)V++;const $=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,$}takeFromEndWhile(N){let V=this.lastIdx;for(;V>=0&&N(this.items[V]);)V--;const $=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,$}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const V=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,V}}e.ArrayQueue=ee}),define(ne[68],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let A=!1,T;return function(){return A||(A=!0,T=n.apply(L,arguments)),T}}e.once=D}),define(ne[55],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const A=Object.freeze([]);function T(){return A}n.empty=T;function*R(l){yield l}n.single=R;function b(l){return l||A}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}n.first=P;function C(l,r){for(const c of l)if(r(c))return!0;return!1}n.some=C;function f(l,r){for(const c of l)if(r(c))return c}n.find=f;function*y(l,r){for(const c of l)r(c)&&(yield c)}n.filter=y;function*u(l,r){let c=0;for(const i of l)yield r(i,c++)}n.map=u;function*p(...l){for(const r of l)for(const c of r)yield c}n.concat=p;function*d(l){for(const r of l)for(const c of r)yield c}n.concatNested=d;function m(l,r,c){let i=c;for(const t of l)i=r(i,t);return i}n.reduce=m;function*w(l,r,c=l.length){for(r<0&&(r+=l.length),c<0?c+=l.length:c>l.length&&(c=l.length);r<c;r++)yield l[r]}n.slice=w;function g(l,r=Number.POSITIVE_INFINITY){const c=[];if(r===0)return[c,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[c,n.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return i}}]}n.consume=g;function v(l,r,c=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!c(o.value,s.value))return!1}}n.equals=v})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(r,c=!1){let i=0,t=r.length,o="",s=0,a=16,h=0;function S(U){let j=0,M=0;for(;j<U;){const G=r.charCodeAt(i);if(G>=48&&G<=57)M=M*16+G-48;else if(G>=65&&G<=70)M=M*16+G-65+10;else if(G>=97&&G<=102)M=M*16+G-97+10;else break;i++,j++}return j<U&&(M=-1),M}function I(U){i=U,o="",s=0,a=16,h=0}function _(){const U=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return h=3,r.substring(U,i);let j=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;j=i}else h=3;return r.substring(U,j)}function O(){let U="",j=i;for(;;){if(i>=t){U+=r.substring(j,i),h=2;break}const M=r.charCodeAt(i);if(M===34){U+=r.substring(j,i),i++;break}if(M===92){if(U+=r.substring(j,i),i++,i>=t){h=2;break}switch(r.charCodeAt(i++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const K=S(4);K>=0?U+=String.fromCharCode(K):h=4;break}default:h=5}j=i;continue}if(M>=0&&M<=31)if(b(M)){U+=r.substring(j,i),h=2;break}else h=6;i++}return U}function F(){if(o="",h=0,s=i,i>=t)return s=t,a=17;let U=r.charCodeAt(i);if(R(U)){do i++,o+=String.fromCharCode(U),U=r.charCodeAt(i);while(R(U));return a=15}if(b(U))return i++,o+=String.fromCharCode(U),U===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(U){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=O(),a=10;case 47:{const j=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return o=r.substring(j,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const M=t-1;let G=!1;for(;i<M;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,h=1),o=r.substring(j,i),a=13}return o+=String.fromCharCode(U),i++,a=16}case 45:if(o+=String.fromCharCode(U),i++,i===t||!E(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;i<t&&z(U);)i++,U=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(U),i++,a=16}}function z(U){if(R(U)||b(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>i,scan:c?k:F,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>h}}e.createScanner=T;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function C(r,c){const i=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(S,I,_,O){s.value=S,s.offset=I,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{g(r,{onObjectBegin:(S,I)=>{if(c<=S)throw t;o=void 0,a=c>S,i.push("")},onObjectProperty:(S,I,_)=>{if(c<I||(h(S,I,_,"property"),i[i.length-1]=S,c<=I+_))throw t},onObjectEnd:(S,I)=>{if(c<=S)throw t;o=void 0,i.pop()},onArrayBegin:(S,I)=>{if(c<=S)throw t;o=void 0,i.push(0)},onArrayEnd:(S,I)=>{if(c<=S)throw t;o=void 0,i.pop()},onLiteralValue:(S,I,_)=>{if(c<I||(h(S,I,_,l(S)),c<=I+_))throw t},onSeparator:(S,I,_)=>{if(c<=I)throw t;if(S===":"&&o&&o.type==="property")o.colonOffset=I,a=!1,o=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(S){if(S!==t)throw S}return{path:i,previousNode:o,isAtPropertyKey:a,matches:S=>{let I=0;for(let _=0;I<S.length&&_<i.length;_++)if(S[I]===i[_]||S[I]==="*")I++;else if(S[I]!=="**")return!1;return I===S.length}}}e.getLocation=C;function f(r,c=[],i=A.DEFAULT){let t=null,o=[];const s=[];function a(S){Array.isArray(o)?o.push(S):t!==null&&(o[t]=S)}return g(r,{onObjectBegin:()=>{const S={};a(S),s.push(o),o=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const S=[];a(S),s.push(o),o=S,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(S,I,_)=>{c.push({error:S,offset:I,length:_})}},i),o[0]}e.parse=f;function y(r,c=[],i=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(S){t.type==="property"&&(t.length=S-t.offset,t=t.parent)}function s(S){return t.children.push(S),S}g(r,{onObjectBegin:S=>{t=s({type:"object",offset:S,length:-1,parent:t,children:[]})},onObjectProperty:(S,I,_)=>{t=s({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:S,offset:I,length:_,parent:t})},onObjectEnd:(S,I)=>{t.length=S+I-t.offset,t=t.parent,o(S+I)},onArrayBegin:(S,I)=>{t=s({type:"array",offset:S,length:-1,parent:t,children:[]})},onArrayEnd:(S,I)=>{t.length=S+I-t.offset,t=t.parent,o(S+I)},onLiteralValue:(S,I,_)=>{s({type:l(S),offset:I,length:_,parent:t,value:S}),o(I+_)},onSeparator:(S,I,_)=>{t.type==="property"&&(S===":"?t.colonOffset=I:S===","&&o(I))},onError:(S,I,_)=>{c.push({error:S,offset:I,length:_})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=y;function u(r,c){if(!r)return;let i=r;for(let t of c)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function p(r){if(!r.parent||!r.parent.children)return[];const c=p(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;c.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&c.push(i)}return c}e.getNodePath=p;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const c=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(c[i.children[0].value]=d(t))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function m(r,c,i=!1){return c>=r.offset&&c<r.offset+r.length||i&&c===r.offset+r.length}e.contains=m;function w(r,c,i=!1){if(m(r,c,i)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=c;o++){const s=w(t[o],c,i);if(s)return s}return r}}e.findNodeAtOffset=w;function g(r,c,i=A.DEFAULT){const t=T(r,!1);function o(ee){return ee?()=>ee(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(ee){return ee?W=>ee(W,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),h=s(c.onObjectProperty),S=o(c.onObjectEnd),I=o(c.onArrayBegin),_=o(c.onArrayEnd),O=s(c.onLiteralValue),F=s(c.onSeparator),z=o(c.onComment),k=s(c.onError),U=i&&i.disallowComments,j=i&&i.allowTrailingComma;function M(){for(;;){const ee=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:U||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ee){case 12:case 13:U?G(10):z();break;case 16:G(1);break;case 15:case 14:break;default:return ee}}}function G(ee,W=[],N=[]){if(k(ee),W.length+N.length>0){let V=t.getToken();for(;V!==17;){if(W.indexOf(V)!==-1){M();break}else if(N.indexOf(V)!==-1)break;V=M()}}}function K(ee){const W=t.getTokenValue();return ee?O(W):h(W),M(),!0}function x(){switch(t.getToken()){case 11:{let ee=0;try{ee=JSON.parse(t.getTokenValue()),typeof ee!="number"&&(G(2),ee=0)}catch{G(2)}O(ee);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function q(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(F(":"),M(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function X(){a(),M();let ee=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),F(","),M(),t.getToken()===2&&j)break}else ee&&G(6,[],[]);q()||G(4,[],[2,5]),ee=!0}return S(),t.getToken()!==2?G(7,[2],[]):M(),!0}function H(){I(),M();let ee=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),F(","),M(),t.getToken()===4&&j)break}else ee&&G(6,[],[]);Z()||G(4,[],[4,5]),ee=!0}return _(),t.getToken()!==4?G(8,[4],[]):M(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return X();case 10:return K(!0);default:return x()}}return M(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=g;function v(r,c){let i=T(r),t=[],o,s=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==a&&t.push(r.substring(s,a)),c!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,c)),s=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=v;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,C){let f,y,u,p,d;if(P){for(p=P.offset,d=p+P.length,u=p;u>0&&!b(E,u-1);)u--;let a=d;for(;a<E.length&&!b(E,a);)a++;y=E.substring(u,a),f=T(y,C)}else y=E,f=0,u=0,p=0,d=E.length;const m=R(C,E);let w=!1,g=0,v;C.insertSpaces?v=A(" ",C.tabSize||4):v="	";const l=(0,D.createScanner)(y,!1);let r=!1;function c(){return m+A(v,f+g)}function i(){let a=l.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=l.scan();return r=a===16||l.getTokenError()!==0,a}const t=[];function o(a,h,S){!r&&h<d&&S>p&&E.substring(h,S)!==a&&t.push({offset:h,length:S-h,content:a})}let s=i();if(s!==17){const a=l.getTokenOffset()+u,h=A(v,f);o(h,u,a)}for(;s!==17;){let a=l.getTokenOffset()+l.getTokenLength()+u,h=i(),S="";for(;!w&&(h===12||h===13);){const _=l.getTokenOffset()+u;o(" ",a,_),a=l.getTokenOffset()+l.getTokenLength()+u,S=h===12?c():"",h=i()}if(h===2)s!==1&&(g--,S=c());else if(h===4)s!==3&&(g--,S=c());else{switch(s){case 3:case 1:g++,S=c();break;case 5:case 12:S=c();break;case 13:w?S=c():S=" ";break;case 6:S=" ";break;case 10:if(h===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?S=" ":h!==5&&h!==17&&(r=!0);break;case 16:r=!0;break}w&&(h===12||h===13)&&(S=c())}const I=l.getTokenOffset()+u;o(S,a,I),s=h}return t}e.format=n;function L(E,P){const C=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?C.replace(/\r\n|\r|\n/g,P.eol):C}e.toFormattedString=L;function A(E,P){let C="";for(let f=0;f<P;f++)C+=E;return C}function T(E,P){let C=0,f=0;const y=P.tabSize||4;for(;C<E.length;){const u=E.charAt(C);if(u===" ")f++;else if(u==="	")f+=y;else break;C++}return Math.floor(f/y)}function R(E,P){for(let C=0;C<P.length;C++){const f=P.charAt(C);if(f==="\r")return C+1<P.length&&P.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function b(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=b}),define(ne[69],ie([0,1,35,49]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,P,C){return A(E,P,void 0,C)}e.removeProperty=L;function A(E,P,C,f,y){const u=P.slice(),p=[],d=(0,D.parseTree)(E,p);let m,w;for(;u.length>0&&(w=u.pop(),m=(0,D.findNodeAtLocation)(d,u),m===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const g=(0,D.findNodeAtLocation)(m,[w]);if(g!==void 0)if(C===void 0){if(!g.parent)throw new Error("Malformed AST");const v=m.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(v>0){const c=m.children[v-1];l=c.offset+c.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return T(E,{offset:l,length:r-l,content:""},f)}else return T(E,{offset:g.offset,length:g.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const v=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=y?y(m.children.map(c=>c.children[0].value)):m.children.length;let r;if(l>0){const c=m.children[l-1];r={offset:c.offset+c.length,length:0,content:","+v}}else m.children.length===0?r={offset:m.offset+1,length:0,content:v}:r={offset:m.offset+1,length:0,content:v+","};return T(E,r,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(C!==void 0){const g=`${JSON.stringify(C)}`;let v;if(m.children.length===0||w===0)v={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const l=w===-1||w>m.children.length?m.children.length:w,r=m.children[l-1];v={offset:r.offset+r.length,length:0,content:","+g}}return T(E,v,f)}else{const g=w,v=m.children[g];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],c=r.offset+r.length,i=m.offset+m.length;l={offset:c,length:i-2-c,content:""}}else l={offset:v.offset,length:m.children[g+1].offset-v.offset,content:""};return T(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function T(E,P,C){let f=R(E,P),y=P.offset,u=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;y>0&&!(0,n.isEOL)(f,y-1);)y--;for(;u<f.length&&!(0,n.isEOL)(f,u);)u++}const p=(0,n.format)(f,{offset:y,length:u-y},C);for(let m=p.length-1;m>=0;m--){const w=p[m];f=R(f,w),y=Math.min(y,w.offset),u=Math.max(u,w.offset+w.length),u+=w.content.length-w.length}const d=E.length-(f.length-u)-y;return[{offset:y,length:d,content:f.substring(y,u)}]}e.withFormatting=T;function R(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=R;function b(E,P){let C=P.slice(0).sort((y,u)=>{const p=y.offset-u.offset;return p===0?y.length-u.length:p}),f=E.length;for(let y=C.length-1;y>=0;y--){let u=C[y];if(u.offset+u.length<=f)E=R(E,u);else throw new Error("Overlapping edit");f=u.offset}return E}e.applyEdits=b}),define(ne[100],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(ne[2],ie([0,1,68,55]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let A=null;function T(t){A=t}if(e.setDisposableTracker=T,L){const t="__is_disposable_tracked__";T(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function R(t){return A?.trackDisposable(t),t}function b(t){A?.markAsDisposed(t)}function E(t,o){A?.setParent(t,o)}function P(t,o){if(!!A)for(const s of t)A.setParent(s,o)}function C(t){return A?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function y(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=y;function u(t){if(n.Iterable.is(t)){let o=[];for(const s of t)if(s)try{s.dispose()}catch(a){o.push(a)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=u;function p(...t){const o=d(()=>u(t));return P(t,o),o}e.combinedDisposable=p;function d(t){const o=R({dispose:(0,D.once)(()=>{b(o),t()})});return o}e.toDisposable=d;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=g;class v{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=v;class l{constructor(){this.references=new Map}acquire(o,...s){let a=this.references.get(o);a||(a={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,a));const{object:h}=a,S=(0,D.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(o,a.object),this.references.delete(o))});return a.counter++,{object:h,dispose:S}}}e.ReferenceCollection=l;class r{constructor(o){this.referenceCollection=o}async acquire(o,...s){const a=this.referenceCollection.acquire(o,...s);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(h){throw a.dispose(),h}}}e.AsyncReferenceCollection=r;class c{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=c;function i(t){const o=new m;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(ne[101],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const T=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const R=new D(A);if(this._first===D.Undefined)this._first=R,this._last=R;else if(T){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(){function J(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function T(b){A.push(b,Date.now())}function R(){const b=[];for(let E=0;E<A.length;E+=2)b.push({name:A[E],startTime:A[E+1]});return b}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(L+T.startTime)});return A}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ne[4],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,A=!1,T=!1,R=!1,b=!1,E=!1,P=!1,C,f=D,y,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const d=typeof p?.versions?.electron=="string",m=d&&p?.type==="renderer";if(e.isElectronSandboxed=m&&p?.sandboxed,typeof navigator=="object"&&!m)u=navigator.userAgent,n=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=u.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof p=="object"){n=p.platform==="win32",L=p.platform==="darwin",A=p.platform==="linux",T=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,E=d,C=D,f=D;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),a=s.availableLanguages["*"];C=s.locale,f=a||D,y=s._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let v=0;L?v=1:n?v=3:A&&(v=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=E,e.isWeb=b,e.isIOS=P,e.platform=v,e.userAgent=u,e.language=f;var l;(function(o){function s(){return e.language}o.value=s;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function h(){return e.language==="en"}o.isDefault=h})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let h=0,S=o.length;h<S;h++){const I=o[h];if(I.id===a.data.vscodeScheduleAsyncWork){o.splice(h,1),I.callback();return}}});let s=0;return a=>{const h=++s;o.push({id:h,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:n?1:3;let c=!0,i=!1;function t(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,c=new Uint16Array(o.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=t}),define(ne[32],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],ie([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,A=90,T=122,R=46,b=47,E=92,P=58,C=63;class f extends Error{constructor(v,l,r){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const i=v.indexOf(".")!==-1?"property":"argument";let t=`The "${v}" ${i} ${c} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function y(g,v){if(typeof g!="string")throw new f(v,"string",g)}function u(g){return g===b||g===E}function p(g){return g===b}function d(g){return g>=n&&g<=A||g>=L&&g<=T}function m(g,v,l,r){let c="",i=0,t=-1,o=0,s=0;for(let a=0;a<=g.length;++a){if(a<g.length)s=g.charCodeAt(a);else{if(r(s))break;s=b}if(r(s)){if(!(t===a-1||o===1))if(o===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const h=c.lastIndexOf(l);h===-1?(c="",i=0):(c=c.slice(0,h),i=c.length-1-c.lastIndexOf(l)),t=a,o=0;continue}else if(c.length!==0){c="",i=0,t=a,o=0;continue}}v&&(c+=c.length>0?`${l}..`:"..",i=2)}else c.length>0?c+=`${l}${g.slice(t+1,a)}`:c=g.slice(t+1,a),i=a-t-1;t=a,o=0}else s===R&&o!==-1?++o:o=-1}return c}function w(g,v){if(v===null||typeof v!="object")throw new f("pathObject","Object",v);const l=v.dir||v.root,r=v.base||`${v.name||""}${v.ext||""}`;return l?l===v.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let v="",l="",r=!1;for(let c=g.length-1;c>=-1;c--){let i;if(c>=0){if(i=g[c],y(i,"path"),i.length===0)continue}else v.length===0?i=D.cwd():(i=D.env[`=${v}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==v.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${v}\\`));const t=i.length;let o=0,s="",a=!1;const h=i.charCodeAt(0);if(t===1)u(h)&&(o=1,a=!0);else if(u(h))if(a=!0,u(i.charCodeAt(1))){let S=2,I=S;for(;S<t&&!u(i.charCodeAt(S));)S++;if(S<t&&S!==I){const _=i.slice(I,S);for(I=S;S<t&&u(i.charCodeAt(S));)S++;if(S<t&&S!==I){for(I=S;S<t&&!u(i.charCodeAt(S));)S++;(S===t||S!==I)&&(s=`\\\\${_}\\${i.slice(I,S)}`,o=S)}}}else o=1;else d(h)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),o=2,t>2&&u(i.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(v.length>0){if(s.toLowerCase()!==v.toLowerCase())continue}else v=s;if(r){if(v.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=a,a&&v.length>0)break}return l=m(l,!r,"\\",u),r?`${v}\\${l}`:`${v}${l}`||"."},normalize(g){y(g,"path");const v=g.length;if(v===0)return".";let l=0,r,c=!1;const i=g.charCodeAt(0);if(v===1)return p(i)?"\\":g;if(u(i))if(c=!0,u(g.charCodeAt(1))){let o=2,s=o;for(;o<v&&!u(g.charCodeAt(o));)o++;if(o<v&&o!==s){const a=g.slice(s,o);for(s=o;o<v&&u(g.charCodeAt(o));)o++;if(o<v&&o!==s){for(s=o;o<v&&!u(g.charCodeAt(o));)o++;if(o===v)return`\\\\${a}\\${g.slice(s)}\\`;o!==s&&(r=`\\\\${a}\\${g.slice(s,o)}`,l=o)}}}else l=1;else d(i)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),l=2,v>2&&u(g.charCodeAt(2))&&(c=!0,l=3));let t=l<v?m(g.slice(l),!c,"\\",u):"";return t.length===0&&!c&&(t="."),t.length>0&&u(g.charCodeAt(v-1))&&(t+="\\"),r===void 0?c?`\\${t}`:t:c?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){y(g,"path");const v=g.length;if(v===0)return!1;const l=g.charCodeAt(0);return u(l)||v>2&&d(l)&&g.charCodeAt(1)===P&&u(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let v,l;for(let i=0;i<g.length;++i){const t=g[i];y(t,"path"),t.length>0&&(v===void 0?v=l=t:v+=`\\${t}`)}if(v===void 0)return".";let r=!0,c=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++c;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++c,i>2&&(u(l.charCodeAt(2))?++c:r=!1))}if(r){for(;c<v.length&&u(v.charCodeAt(c));)c++;c>=2&&(v=`\\${v.slice(c)}`)}return e.win32.normalize(v)},relative(g,v){if(y(g,"from"),y(v,"to"),g===v)return"";const l=e.win32.resolve(g),r=e.win32.resolve(v);if(l===r||(g=l.toLowerCase(),v=r.toLowerCase(),g===v))return"";let c=0;for(;c<g.length&&g.charCodeAt(c)===E;)c++;let i=g.length;for(;i-1>c&&g.charCodeAt(i-1)===E;)i--;const t=i-c;let o=0;for(;o<v.length&&v.charCodeAt(o)===E;)o++;let s=v.length;for(;s-1>o&&v.charCodeAt(s-1)===E;)s--;const a=s-o,h=t<a?t:a;let S=-1,I=0;for(;I<h;I++){const O=g.charCodeAt(c+I);if(O!==v.charCodeAt(o+I))break;O===E&&(S=I)}if(I!==h){if(S===-1)return r}else{if(a>h){if(v.charCodeAt(o+I)===E)return r.slice(o+I+1);if(I===2)return r.slice(o+I)}t>h&&(g.charCodeAt(c+I)===E?S=I:I===2&&(S=3)),S===-1&&(S=0)}let _="";for(I=c+S+1;I<=i;++I)(I===i||g.charCodeAt(I)===E)&&(_+=_.length===0?"..":"\\..");return o+=S,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===E&&++o,r.slice(o,s))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const v=e.win32.resolve(g);if(v.length<=2)return g;if(v.charCodeAt(0)===E){if(v.charCodeAt(1)===E){const l=v.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${v.slice(2)}`}}else if(d(v.charCodeAt(0))&&v.charCodeAt(1)===P&&v.charCodeAt(2)===E)return`\\\\?\\${v}`;return g},dirname(g){y(g,"path");const v=g.length;if(v===0)return".";let l=-1,r=0;const c=g.charCodeAt(0);if(v===1)return u(c)?g:".";if(u(c)){if(l=r=1,u(g.charCodeAt(1))){let o=2,s=o;for(;o<v&&!u(g.charCodeAt(o));)o++;if(o<v&&o!==s){for(s=o;o<v&&u(g.charCodeAt(o));)o++;if(o<v&&o!==s){for(s=o;o<v&&!u(g.charCodeAt(o));)o++;if(o===v)return g;o!==s&&(l=r=o+1)}}}}else d(c)&&g.charCodeAt(1)===P&&(l=v>2&&u(g.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let o=v-1;o>=r;--o)if(u(g.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return g.slice(0,i)},basename(g,v){v!==void 0&&y(v,"ext"),y(g,"path");let l=0,r=-1,c=!0,i;if(g.length>=2&&d(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(l=2),v!==void 0&&v.length>0&&v.length<=g.length){if(v===g)return"";let t=v.length-1,o=-1;for(i=g.length-1;i>=l;--i){const s=g.charCodeAt(i);if(u(s)){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),t>=0&&(s===v.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=g.length),g.slice(l,r)}for(i=g.length-1;i>=l;--i)if(u(g.charCodeAt(i))){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":g.slice(l,r)},extname(g){y(g,"path");let v=0,l=-1,r=0,c=-1,i=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&d(g.charCodeAt(0))&&(v=r=2);for(let o=g.length-1;o>=v;--o){const s=g.charCodeAt(o);if(u(s)){if(!i){r=o+1;break}continue}c===-1&&(i=!1,c=o+1),s===R?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||c===-1||t===0||t===1&&l===c-1&&l===r+1?"":g.slice(l,c)},format:w.bind(null,"\\"),parse(g){y(g,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return v;const l=g.length;let r=0,c=g.charCodeAt(0);if(l===1)return u(c)?(v.root=v.dir=g,v):(v.base=v.name=g,v);if(u(c)){if(r=1,u(g.charCodeAt(1))){let S=2,I=S;for(;S<l&&!u(g.charCodeAt(S));)S++;if(S<l&&S!==I){for(I=S;S<l&&u(g.charCodeAt(S));)S++;if(S<l&&S!==I){for(I=S;S<l&&!u(g.charCodeAt(S));)S++;S===l?r=S:S!==I&&(r=S+1)}}}}else if(d(c)&&g.charCodeAt(1)===P){if(l<=2)return v.root=v.dir=g,v;if(r=2,u(g.charCodeAt(2))){if(l===3)return v.root=v.dir=g,v;r=3}}r>0&&(v.root=g.slice(0,r));let i=-1,t=r,o=-1,s=!0,a=g.length-1,h=0;for(;a>=r;--a){if(c=g.charCodeAt(a),u(c)){if(!s){t=a+1;break}continue}o===-1&&(s=!1,o=a+1),c===R?i===-1?i=a:h!==1&&(h=1):i!==-1&&(h=-1)}return o!==-1&&(i===-1||h===0||h===1&&i===o-1&&i===t+1?v.base=v.name=g.slice(t,o):(v.name=g.slice(t,i),v.base=g.slice(t,o),v.ext=g.slice(i,o))),t>0&&t!==r?v.dir=g.slice(0,t-1):v.dir=v.root,v},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let v="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const c=r>=0?g[r]:D.cwd();y(c,"path"),c.length!==0&&(v=`${c}/${v}`,l=c.charCodeAt(0)===b)}return v=m(v,!l,"/",p),l?`/${v}`:v.length>0?v:"."},normalize(g){if(y(g,"path"),g.length===0)return".";const v=g.charCodeAt(0)===b,l=g.charCodeAt(g.length-1)===b;return g=m(g,!v,"/",p),g.length===0?v?"/":l?"./":".":(l&&(g+="/"),v?`/${g}`:g)},isAbsolute(g){return y(g,"path"),g.length>0&&g.charCodeAt(0)===b},join(...g){if(g.length===0)return".";let v;for(let l=0;l<g.length;++l){const r=g[l];y(r,"path"),r.length>0&&(v===void 0?v=r:v+=`/${r}`)}return v===void 0?".":e.posix.normalize(v)},relative(g,v){if(y(g,"from"),y(v,"to"),g===v||(g=e.posix.resolve(g),v=e.posix.resolve(v),g===v))return"";const l=1,r=g.length,c=r-l,i=1,t=v.length-i,o=c<t?c:t;let s=-1,a=0;for(;a<o;a++){const S=g.charCodeAt(l+a);if(S!==v.charCodeAt(i+a))break;S===b&&(s=a)}if(a===o)if(t>o){if(v.charCodeAt(i+a)===b)return v.slice(i+a+1);if(a===0)return v.slice(i+a)}else c>o&&(g.charCodeAt(l+a)===b?s=a:a===0&&(s=0));let h="";for(a=l+s+1;a<=r;++a)(a===r||g.charCodeAt(a)===b)&&(h+=h.length===0?"..":"/..");return`${h}${v.slice(i+s)}`},toNamespacedPath(g){return g},dirname(g){if(y(g,"path"),g.length===0)return".";const v=g.charCodeAt(0)===b;let l=-1,r=!0;for(let c=g.length-1;c>=1;--c)if(g.charCodeAt(c)===b){if(!r){l=c;break}}else r=!1;return l===-1?v?"/":".":v&&l===1?"//":g.slice(0,l)},basename(g,v){v!==void 0&&y(v,"ext"),y(g,"path");let l=0,r=-1,c=!0,i;if(v!==void 0&&v.length>0&&v.length<=g.length){if(v===g)return"";let t=v.length-1,o=-1;for(i=g.length-1;i>=0;--i){const s=g.charCodeAt(i);if(s===b){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),t>=0&&(s===v.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=g.length),g.slice(l,r)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===b){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":g.slice(l,r)},extname(g){y(g,"path");let v=-1,l=0,r=-1,c=!0,i=0;for(let t=g.length-1;t>=0;--t){const o=g.charCodeAt(t);if(o===b){if(!c){l=t+1;break}continue}r===-1&&(c=!1,r=t+1),o===R?v===-1?v=t:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===l+1?"":g.slice(v,r)},format:w.bind(null,"/"),parse(g){y(g,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return v;const l=g.charCodeAt(0)===b;let r;l?(v.root="/",r=1):r=0;let c=-1,i=0,t=-1,o=!0,s=g.length-1,a=0;for(;s>=r;--s){const h=g.charCodeAt(s);if(h===b){if(!o){i=s+1;break}continue}t===-1&&(o=!1,t=s+1),h===R?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}if(t!==-1){const h=i===0&&l?1:i;c===-1||a===0||a===1&&c===t-1&&c===i+1?v.base=v.name=g.slice(h,t):(v.name=g.slice(h,c),v.base=g.slice(h,t),v.ext=g.slice(c,t))}return i>0?v.dir=g.slice(0,i-1):l&&(v.dir="/"),v},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(C){const f=(0,D.extname)(C),y=L[f.toLowerCase()];return y!==void 0?y:R(C)}e.getMediaOrTextMime=T;function R(C){const f=(0,D.extname)(C);return A[f.toLowerCase()]}e.getMediaMime=R;function b(C){for(const f in A)if(A[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function P(C,f){const y=E.exec(C);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:f?void 0:C}e.normalizeMimeType=P}),define(ne[103],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(A,...T){const R=T.reduce((P,C)=>(P[C]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(P=>!R[P]).forEach(P=>{for(let C=0;C<b.length;C++)if(P.search(b[C])!==-1){delete A[P];break}})}e.sanitizeProcessEnvironment=L}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:J)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return J[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=J,D.c=e,D.d=function(n,L,A){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:A})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var T in n)D.d(A,T,function(R){return n[R]}.bind(null,T));return A},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(J,e,D){(function(n){var L;e=J.exports=N,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],E=0,P=E++;b[P]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;b[y]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var u=E++;b[u]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var p=E++;b[p]="(?:"+b[P]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var m=E++;b[m]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var g=E++;b[g]="[0-9A-Za-z-]+";var v=E++;b[v]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var l=E++,r="v?"+b[y]+b[m]+"?"+b[v]+"?";b[l]="^"+r+"$";var c="[v=\\s]*"+b[u]+b[w]+"?"+b[v]+"?",i=E++;b[i]="^"+c+"$";var t=E++;b[t]="((?:<|>)?=?)";var o=E++;b[o]=b[C]+"|x|X|\\*";var s=E++;b[s]=b[P]+"|x|X|\\*";var a=E++;b[a]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[m]+")?"+b[v]+"?)?)?";var h=E++;b[h]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[v]+"?)?)?";var S=E++;b[S]="^"+b[t]+"\\s*"+b[a]+"$";var I=E++;b[I]="^"+b[t]+"\\s*"+b[h]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;b[O]="(?:~>?)";var F=E++;b[F]="(\\s*)"+b[O]+"\\s+",R[F]=new RegExp(b[F],"g");var z=E++;b[z]="^"+b[O]+b[a]+"$";var k=E++;b[k]="^"+b[O]+b[h]+"$";var U=E++;b[U]="(?:\\^)";var j=E++;b[j]="(\\s*)"+b[U]+"\\s+",R[j]=new RegExp(b[j],"g");var M=E++;b[M]="^"+b[U]+b[a]+"$";var G=E++;b[G]="^"+b[U]+b[h]+"$";var K=E++;b[K]="^"+b[t]+"\\s*("+c+")$|^$";var x=E++;b[x]="^"+b[t]+"\\s*("+r+")$|^$";var q=E++;b[q]="(\\s*)"+b[t]+"\\s*("+c+"|"+b[a]+")",R[q]=new RegExp(b[q],"g");var X=E++;b[X]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var H=E++;b[H]="^\\s*("+b[h]+")\\s+-\\s+("+b[h]+")\\s*$";var Z=E++;b[Z]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)L(ee,b[ee]),R[ee]||(R[ee]=new RegExp(b[ee]));function W(re,ae){if(re instanceof N)return re;if(typeof re!="string"||re.length>A||!(ae?R[i]:R[l]).test(re))return null;try{return new N(re,ae)}catch{return null}}function N(re,ae){if(re instanceof N){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof N))return new N(re,ae);L("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[i]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Pe=+ye;if(Pe>=0&&Pe<T)return Pe}return ye}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=W,e.valid=function(re,ae){var ue=W(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=W(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof N||(re=new N(re,this.loose)),this.compareMain(re)||this.comparePre(re)},N.prototype.compareMain=function(re){return re instanceof N||(re=new N(re,this.loose)),$(this.major,re.major)||$(this.minor,re.minor)||$(this.patch,re.patch)},N.prototype.comparePre=function(re){if(re instanceof N||(re=new N(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],ye=re.prerelease[ae];if(L("prerelease compare",ae,ue,ye),ue===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ue===void 0)return-1;if(ue!==ye)return $(ue,ye)}while(++ae)},N.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,ye){typeof ue=="string"&&(ye=ue,ue=void 0);try{return new N(re,ue).inc(ae,ye).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=W(re),ye=W(ae);if(ue.prerelease.length||ye.prerelease.length){for(var Pe in ue)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ue[Pe]!==ye[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ue)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ue[Pe]!==ye[Pe])return Pe},e.compareIdentifiers=$;var V=/^[0-9]+$/;function $(re,ae){var ue=V.test(re),ye=V.test(ae);return ue&&ye&&(re=+re,ae=+ae),ue&&!ye?-1:ye&&!ue?1:re<ae?-1:re>ae?1:0}function B(re,ae,ue){return new N(re,ue).compare(new N(ae,ue))}function te(re,ae,ue){return B(re,ae,ue)>0}function se(re,ae,ue){return B(re,ae,ue)<0}function ce(re,ae,ue){return B(re,ae,ue)===0}function he(re,ae,ue){return B(re,ae,ue)!==0}function ve(re,ae,ue){return B(re,ae,ue)>=0}function pe(re,ae,ue){return B(re,ae,ue)<=0}function Ee(re,ae,ue,ye){var Pe;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Pe=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Pe=re!==ue;break;case"":case"=":case"==":Pe=ce(re,ue,ye);break;case"!=":Pe=he(re,ue,ye);break;case">":Pe=te(re,ue,ye);break;case">=":Pe=ve(re,ue,ye);break;case"<":Pe=se(re,ue,ye);break;case"<=":Pe=pe(re,ue,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Pe}function Ce(re,ae){if(re instanceof Ce){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Ce))return new Ce(re,ae);L("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===we?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ae){return $(ae,re)},e.major=function(re,ae){return new N(re,ae).major},e.minor=function(re,ae){return new N(re,ae).minor},e.patch=function(re,ae){return new N(re,ae).patch},e.compare=B,e.compareLoose=function(re,ae){return B(re,ae,!0)},e.rcompare=function(re,ae,ue){return B(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,ye){return e.compare(ue,ye,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,ye){return e.rcompare(ue,ye,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=ve,e.lte=pe,e.cmp=Ee,e.Comparator=Ce;var we={};function be(re,ae){if(re instanceof be)return re.loose===ae?re:new be(re.raw,ae);if(re instanceof Ce)return new be(re.value,ae);if(!(this instanceof be))return new be(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Re(re){return!re||re.toLowerCase()==="x"||re==="*"}function Fe(re,ae,ue,ye,Pe,Ne,Te,Oe,_e,Q,oe,le,fe){return((ae=Re(ue)?"":Re(ye)?">="+ue+".0.0":Re(Pe)?">="+ue+"."+ye+".0":">="+ae)+" "+(Oe=Re(_e)?"":Re(Q)?"<"+(+_e+1)+".0.0":Re(oe)?"<"+_e+"."+(+Q+1)+".0":le?"<="+_e+"."+Q+"."+oe+"-"+le:"<="+Oe)).trim()}function Me(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(L(re[ue].semver),re[ue].semver!==we&&re[ue].semver.prerelease.length>0){var ye=re[ue].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function qe(re,ae,ue){try{ae=new be(ae,ue)}catch{return!1}return ae.test(re)}function Be(re,ae,ue,ye){var Pe,Ne,Te,Oe,_e;switch(re=new N(re,ye),ae=new be(ae,ye),ue){case">":Pe=te,Ne=pe,Te=se,Oe=">",_e=">=";break;case"<":Pe=se,Ne=ve,Te=te,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(re,ae,ye))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(ge){ge.semver===we&&(ge=new Ce(">=0.0.0")),le=le||ge,fe=fe||ge,Pe(ge.semver,le.semver,ye)?le=ge:Te(ge.semver,fe.semver,ye)&&(fe=ge)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Ne(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}Ce.prototype.parse=function(re){var ae=this.loose?R[K]:R[x],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new N(ue[2],this.loose):this.semver=we},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===we||(typeof re=="string"&&(re=new N(re,this.loose)),Ee(re,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(re,ae){if(!(re instanceof Ce))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new be(re.value,ae),qe(this.value,ue,ae);if(re.operator==="")return ue=new be(this.value,ae),qe(re.semver,ue,ae);var ye=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ne=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Ee(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Ee(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return ye||Pe||Ne&&Te||Oe||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),L("range",re,ae);var ue=ae?R[H]:R[X];re=re.replace(ue,Fe),L("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),L("comparator trim",re,R[q]),re=(re=(re=re.replace(R[F],"$1~")).replace(R[j],"$1^")).split(/\s+/).join(" ");var ye=ae?R[K]:R[x],Pe=re.split(" ").map(function(Ne){return function(Te,Oe){return L("comp",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ge=fe?R[G]:R[M];return le.replace(ge,function(Le,Se,De,ke,Ie){var Ae;return L("caret",le,Le,Se,De,ke,Ie),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=Se==="0"?">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+".0 <"+(+Se+1)+".0.0":Ie?(L("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+Ie+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ge=fe?R[k]:R[z];return le.replace(ge,function(Le,Se,De,ke,Ie){var Ae;return L("tilde",le,Le,Se,De,ke,Ie),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":Ie?(L("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+(+De+1)+".0"):Ae=">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0",L("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,Q){return L("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ge=fe?R[I]:R[S];return le.replace(ge,function(Le,Se,De,ke,Ie,Ae){L("xRange",le,Le,Se,De,ke,Ie,Ae);var ze=Re(De),je=ze||Re(ke),xe=je||Re(Ie);return Se==="="&&xe&&(Se=""),ze?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&xe?(je&&(ke=0),xe&&(Ie=0),Se===">"?(Se=">=",je?(De=+De+1,ke=0,Ie=0):xe&&(ke=+ke+1,Ie=0)):Se==="<="&&(Se="<",je?De=+De+1:ke=+ke+1),Le=Se+De+"."+ke+"."+Ie):je?Le=">="+De+".0.0 <"+(+De+1)+".0.0":xe&&(Le=">="+De+"."+ke+".0 <"+De+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,Q)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,Q){return L("replaceStars",_e,Q),_e.trim().replace(R[Z],"")}(Te,Oe),L("stars",Te),Te}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ne){return!!Ne.match(ye)})),Pe=Pe.map(function(Ne){return new Ce(Ne,ae)})},be.prototype.intersects=function(re,ae){if(!(re instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(ye){return re.set.some(function(Pe){return Pe.every(function(Ne){return ye.intersects(Ne,ae)})})})})},e.toComparators=function(re,ae){return new be(re,ae).set.map(function(ue){return ue.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},be.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new N(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Me(this.set[ae],re))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(re,ae,ue){var ye=null,Pe=null;try{var Ne=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(ye&&Pe.compare(Te)!==-1||(Pe=new N(ye=Te,ue)))}),ye},e.minSatisfying=function(re,ae,ue){var ye=null,Pe=null;try{var Ne=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(ye&&Pe.compare(Te)!==1||(Pe=new N(ye=Te,ue)))}),ye},e.validRange=function(re,ae){try{return new be(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return Be(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return Be(re,ae,">",ue)},e.outside=Be,e.prerelease=function(re,ae){var ue=W(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new be(re,ue),ae=new be(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof N)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:W((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,n,L=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(d){if(D===setTimeout)return setTimeout(d,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var b,E=[],P=!1,C=-1;function f(){P&&b&&(P=!1,b.length?E=b.concat(E):C=-1,E.length&&y())}function y(){if(!P){var d=R(f);P=!0;for(var m=E.length;m;){for(b=E,E=[];++C<m;)b&&b[C].run();C=-1,m=E.length}b=null,P=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function u(d,m){this.fun=d,this.array=m}function p(){}L.nextTick=function(d){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];E.push(new u(d,m)),E.length!==1||P||R(y)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(d){return[]},L.binding=function(d){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(d){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,E){this.level=R,this.key=b,this.value=E,this.forward=[]}}const L=void 0;class A{constructor(R,b=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(R){return Boolean(A._search(this,R,this.comparator))}get(R){return A._search(this,R,this.comparator)?.value}set(R,b){return A._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=A._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let E=this._header.forward[0];for(;E;)R.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,E){let P=R._header;for(let C=R._level-1;C>=0;C--)for(;P.forward[C]&&E(P.forward[C].key,b)<0;)P=P.forward[C];if(P=P.forward[0],P&&E(P.key,b)===0)return P}static _insert(R,b,E,P){let C=[],f=R._header;for(let y=R._level-1;y>=0;y--){for(;f.forward[y]&&P(f.forward[y].key,b)<0;)f=f.forward[y];C[y]=f}if(f=f.forward[0],f&&P(f.key,b)===0)return f.value=E,!1;{let y=A._randomLevel(R);if(y>R._level){for(let u=R._level;u<y;u++)C[u]=R._header;R._level=y}f=new n(y,b,E);for(let u=0;u<y;u++)f.forward[u]=C[u].forward[u],C[u].forward[u]=f;return!0}}static _randomLevel(R,b=.5){let E=1;for(;Math.random()<b&&E<R._maxLevel;)E+=1;return E}static _delete(R,b,E){let P=[],C=R._header;for(let f=R._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];P[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===C;f++)P[f].forward[f]=C.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=A}),define(ne[105],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new L(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ne[3],ie([0,1,9,68,2,101,105]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(v){v.None=()=>L.Disposable.None;function l(K){return(x,q=null,X)=>{let H=!1,Z;return Z=K(ee=>{if(!H)return Z?Z.dispose():H=!0,x.call(q,ee)},null,X),H&&Z.dispose(),Z}}v.once=l;function r(K,x){return a((q,X=null,H)=>K(Z=>q.call(X,x(Z)),null,H))}v.map=r;function c(K,x){return a((q,X=null,H)=>K(Z=>{x(Z),q.call(X,Z)},null,H))}v.forEach=c;function i(K,x){return a((q,X=null,H)=>K(Z=>x(Z)&&q.call(X,Z),null,H))}v.filter=i;function t(K){return K}v.signal=t;function o(...K){return(x,q=null,X)=>(0,L.combinedDisposable)(...K.map(H=>H(Z=>x.call(q,Z),null,X)))}v.any=o;function s(K,x,q){let X=q;return r(K,H=>(X=x(X,H),X))}v.reduce=s;function a(K){let x;const q=new f({onFirstListenerAdd(){x=K(q.fire,q)},onLastListenerRemove(){x.dispose()}});return q.event}function h(K,x,q,X=100,H=!1){let Z,ee,W=0;return K(N=>{W++,Z=q(Z,N),H&&!ee&&(x(Z),Z=void 0),clearTimeout(ee),ee=setTimeout(()=>{const V=Z;Z=void 0,ee=void 0,(!H||W>1)&&x(V),W=0},X)})}v.debouncedListener=h;function S(K,x,q=100,X=!1,H){let Z,ee,W,N=0;const V=new f({leakWarningThreshold:H,onFirstListenerAdd(){Z=K($=>{N++,ee=x(ee,$),X&&!W&&(V.fire(ee),ee=void 0),clearTimeout(W),W=setTimeout(()=>{const B=ee;ee=void 0,W=void 0,(!X||N>1)&&V.fire(B),N=0},q)})},onLastListenerRemove(){Z.dispose()}});return V.event}v.debounce=S;function I(K,x=(q,X)=>q===X){let q=!0,X;return i(K,H=>{const Z=q||!x(H,X);return q=!1,X=H,Z})}v.latch=I;function _(K,x){return[v.filter(K,x),v.filter(K,q=>!x(q))]}v.split=_;function O(K,x=!1,q=[]){let X=q.slice(),H=K(W=>{X?X.push(W):ee.fire(W)});const Z=()=>{X&&X.forEach(W=>ee.fire(W)),X=null},ee=new f({onFirstListenerAdd(){H||(H=K(W=>ee.fire(W)))},onFirstListenerDidAdd(){X&&(x?setTimeout(Z):Z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return ee.event}v.buffer=O;class F{constructor(x){this.event=x}map(x){return new F(r(this.event,x))}forEach(x){return new F(c(this.event,x))}filter(x){return new F(i(this.event,x))}reduce(x,q){return new F(s(this.event,x,q))}latch(){return new F(I(this.event))}debounce(x,q=100,X=!1,H){return new F(S(this.event,x,q,X,H))}on(x,q,X){return this.event(x,q,X)}once(x,q,X){return l(this.event)(x,q,X)}}function z(K){return new F(K)}v.chain=z;function k(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.on(x,X),Z=()=>K.removeListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}v.fromNodeEventEmitter=k;function U(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.addEventListener(x,X),Z=()=>K.removeEventListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}v.fromDOMEventEmitter=U;function j(K){return new Promise(x=>l(K)(x))}v.toPromise=j;function M(K,x){return x(void 0),K(q=>x(q))}v.runAndSubscribe=M;function G(K,x){let q=null;function X(Z){q?.dispose(),q=new L.DisposableStore,x(Z,q)}X(void 0);const H=K(Z=>X(Z));return(0,L.toDisposable)(()=>{H.dispose(),q?.dispose()})}v.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function P(v){const l=E;return E=v,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=P;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(c)||0;if(this._stacks.set(c,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,o=0;for(const[s,a]of this._stacks)(!t||o<a)&&(t=s,o=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,c)=>{this._listeners||(this._listeners=new A.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const o=this._leakageMon?.check(this._listeners.size),s=(0,L.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof L.DisposableStore?c.add(s):Array.isArray(c)&&c.push(s),s}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,c]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class y extends f{async fireAsync(l,r,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),o=[],s={...t,token:r,waitUntil:a=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");c&&(a=c(a,typeof i=="function"?i:i[0])),o.push(a)}};try{typeof i=="function"?i.call(void 0,s):i[0].call(i[1],s)}catch(a){(0,D.onUnexpectedError)(a);continue}Object.freeze(o),await Promise.allSettled(o).then(a=>{for(const h of a)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=y;class u extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class p extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=p;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const c=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,L.toDisposable)((0,n.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,c,i)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(c,t)):r.call(c,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const c=l();return this.buffers.pop(),r.forEach(i=>i()),c}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ne[23],ie([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const E=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function b(E){return E===R.None||E===R.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=T}),define(ne[106],ie([0,1,23]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new D.CancellationTokenSource,R=this.task(T.token);return this.result={promise:R,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class L{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const R=JSON.stringify(T);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=L}),define(ne[40],ie([0,1,9,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(g){const v=g;return v?[v.on,v.pause,v.resume,v.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function A(g){const v=g;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(g,v){return new R(g,v)}e.newWriteableStream=T;class R{constructor(v,l){this.reducer=v,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(l=>l(v))}emitError(v){this.listeners.error.length===0?(0,D.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(l=>l(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,l){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(v,l){if(this.state.destroyed)return;let r;switch(v){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const c=r.indexOf(l);c>=0&&r.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(g,v){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return v(l)}e.consumeReadable=b;function E(g,v,l){const r=[];let c;for(;(c=g.read())!==null&&r.length<l;)r.push(c);return c===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof c!="undefined"){const i=c;return c=void 0,i}return g.read()}}}e.peekReadable=E;function P(g,v){return new Promise((l,r)=>{const c=[];C(g,{onData:i=>{v&&c.push(i)},onError:i=>{v?r(i):l(void 0)},onEnd:()=>{l(v?v(c):void 0)}})})}e.consumeStream=P;function C(g,v){let l=!1;return g.on("error",r=>{l||v.onError(r)}),g.on("end",()=>{l||v.onEnd()}),g.on("data",r=>{l||v.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(g,v){return new Promise((l,r)=>{const c=new n.DisposableStore,i=[],t=a=>{if(i.push(a),i.length>v)return c.dispose(),g.pause(),l({stream:g,buffer:i,ended:!1})},o=a=>r(a),s=()=>l({stream:g,buffer:i,ended:!0});c.add((0,n.toDisposable)(()=>g.removeListener("error",o))),g.on("error",o),c.add((0,n.toDisposable)(()=>g.removeListener("end",s))),g.on("end",s),c.add((0,n.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=f;function y(g,v){const l=T(v);return l.end(g),l}e.toStream=y;function u(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=u;function p(g){let v=!1;return{read:()=>v?null:(v=!0,g)}}e.toReadable=p;function d(g,v,l){const r=T(l);return C(g,{onData:c=>r.write(v.data(c)),onError:c=>r.error(v.error?v.error(c):c),onEnd:()=>r.end()}),r}e.transform=d;function m(g,v,l){let r=!1;return{read:()=>{const c=v.read();return r?c:(r=!0,c!==null?l([g,c]):g)}}}e.prefixedReadable=m;function w(g,v,l){let r=!1;const c=T(l);return C(v,{onData:i=>r?c.write(i):(r=!0,c.write(l([g,i]))),onError:i=>c.error(i),onEnd:()=>{r||(r=!0,c.write(g)),c.end()}}),c}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,A;class T{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(h)):(L||(L=new TextEncoder),new T(L.encode(h)))}static fromByteArray(h){const S=T.alloc(h.length);for(let I=0,_=h.length;I<_;I++)S.buffer[I]=h[I];return S}static concat(h,S){if(typeof S=="undefined"){S=0;for(let O=0,F=h.length;O<F;O++)S+=h[O].byteLength}const I=T.alloc(S);let _=0;for(let O=0,F=h.length;O<F;O++){const z=h[O];I.set(z,_),_+=z.byteLength}return I}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(h,S){return new T(this.buffer.subarray(h,S))}set(h,S){if(h instanceof T)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,S){P(this.buffer,h,S)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,S){f(this.buffer,h,S)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,S){u(this.buffer,h,S)}}e.VSBuffer=T;function R(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=R;function b(a,h,S){a[S+0]=h&255,h=h>>>8,a[S+1]=h&255}e.writeUInt16LE=b;function E(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=E;function P(a,h,S){a[S+3]=h,h=h>>>8,a[S+2]=h,h=h>>>8,a[S+1]=h,h=h>>>8,a[S]=h}e.writeUInt32BE=P;function C(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=C;function f(a,h,S){a[S+0]=h&255,h=h>>>8,a[S+1]=h&255,h=h>>>8,a[S+2]=h&255,h=h>>>8,a[S+3]=h&255}e.writeUInt32LE=f;function y(a,h){return a[h]}e.readUInt8=y;function u(a,h,S){a[S]=h}e.writeUInt8=u;function p(a){return D.consumeReadable(a,h=>T.concat(h))}e.readableToBuffer=p;function d(a){return D.toReadable(a)}e.bufferToReadable=d;function m(a){return D.consumeStream(a,h=>T.concat(h))}e.streamToBuffer=m;async function w(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=w;function g(a){return D.toStream(a,h=>T.concat(h))}e.bufferToStream=g;function v(a){return D.transform(a,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=v;function l(a){return D.newWriteableStream(h=>T.concat(h),a)}e.newWriteableBufferStream=l;function r(a,h){return D.prefixedReadable(a,h,S=>T.concat(S))}e.prefixedBufferReadable=r;function c(a,h){return D.prefixedStream(a,h,S=>T.concat(S))}e.prefixedBufferStream=c;function i(a){let h=0,S=0,I=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=z=>{switch(S){case 3:_[I++]=h|z,S=0;break;case 2:_[I++]=h|z>>>2,h=z<<6,S=3;break;case 1:_[I++]=h|z>>>4,h=z<<4,S=2;break;default:h=z<<2,S=1}};for(let z=0;z<a.length;z++){const k=a.charCodeAt(z);if(k>=65&&k<=90)O(k-65);else if(k>=97&&k<=122)O(k-97+26);else if(k>=48&&k<=57)O(k-48+52);else if(k===43||k===45)O(62);else if(k===47||k===95)O(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${a[z]}`)}}const F=I;for(;S>0;)O(0);return T.wrap(_).slice(0,F)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},h=!0,S=!1){const I=S?o:t;let _="";const O=a.byteLength%3;let F=0;for(;F<a.byteLength-O;F+=3){const z=a[F+0],k=a[F+1],U=a[F+2];_+=I[z>>>2],_+=I[(z<<4|k>>>4)&63],_+=I[(k<<2|U>>>6)&63],_+=I[U&63]}if(O===1){const z=a[F+0];_+=I[z>>>2],_+=I[z<<4&63],h&&(_+="==")}else if(O===2){const z=a[F+0],k=a[F+1];_+=I[z>>>2],_+=I[(z<<4|k>>>4)&63],_+=I[k<<2&63],h&&(_+="=")}return _}e.encodeBase64=s}),define(ne[27],ie([0,1,106,100]),function(J,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(T,function(le,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=oe.length?le:oe[ge]})}e.format=R;const b=/{([^}]+)}/g;function E(Q,oe){return Q.replace(b,(le,fe)=>oe[fe]??le)}e.format2=E;function P(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function C(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let ge=Q.length-1;ge>=0;ge--)Q.charCodeAt(ge)===fe&&le++;return le}e.count=f;function y(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=y;function u(Q,oe=" "){const le=p(Q,oe);return d(le,oe)}e.trim=u;function p(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=p;function d(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let ge=fe,Le=-1;for(;Le=Q.lastIndexOf(oe,ge-1),!(Le===-1||Le+le!==ge);){if(Le===0)return"";ge=Le}return Q.substring(0,ge)}e.rtrim=d;function m(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function g(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=C(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=g;function v(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function c(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=c;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const ge=Q.charCodeAt(fe);if(ge!==32&&ge!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function o(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=s;function a(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(ge);if(ke<Ie)return-1;if(ke>Ie)return 1}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstring=a;function h(Q,oe){return S(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=h;function S(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(ge);if(ke===Ie)continue;if(ke>=128||Ie>=128)return a(Q.toLowerCase(),oe.toLowerCase(),le,fe,ge,Le);I(ke)&&(ke-=32),I(Ie)&&(Ie-=32);const Ae=ke-Ie;if(Ae!==0)return Ae}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstringIgnoreCase=S;function I(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=I;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&S(Q,oe)===0}e.equalsIgnoreCase=O;function F(Q,oe){const le=oe.length;return oe.length>Q.length?!1:S(Q,oe,0,le)===0}e.startsWithIgnoreCase=F;function z(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=z;function k(Q,oe){let le,fe=Math.min(Q.length,oe.length);const ge=Q.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(ge-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=k;function U(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=U;function j(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=j;function M(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=M;function G(Q,oe,le){const fe=Q.charCodeAt(le);if(U(fe)&&le+1<oe){const ge=Q.charCodeAt(le+1);if(j(ge))return M(fe,ge)}return fe}e.getNextCodePoint=G;function K(Q,oe){const le=Q.charCodeAt(oe-1);if(j(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(U(fe))return M(fe,le)}return le}class x{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=K(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class q{constructor(oe,le=0){this._iterator=new x(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,Se=oe.getGraphemeBreakType(le.nextCodePoint());if(Be(ge,Se)){le.setOffset(Le);break}ge=Se}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,Se=oe.getGraphemeBreakType(le.prevCodePoint());if(Be(Se,ge)){le.setOffset(Le);break}ge=Se}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function X(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=X;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&j(Q.charCodeAt(oe))&&oe--;const le=oe+X(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(Q){return ee.test(Q)}e.containsRTL=W;const N=/^[\t\n\r\x20-\x7E]*$/;function V(Q){return N.test(Q)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=$;function B(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=B;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(ve,"")),Q}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ce(Q){return Ee(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ce;function we(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let ge=0,Le=-1;for(;ge<le;){const Se=fe.indexOf(oe[ge],Le+1);if(Se<0)return!1;Le=Se,ge++}return!0}e.fuzzyContains=we;function be(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=be;function Re(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=Re;function Fe(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=Fe;function Me(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Me;function qe(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=qe;function Be(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ge=1;for(;ge<=fe;)if(oe<le[3*ge])ge=2*ge;else if(oe>le[3*ge+1])ge=2*ge+1;else return le[3*ge+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(Q,oe){if(Q===0)return 0;const le=Pe(Q,oe);if(le!==void 0)return le;const fe=new x(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ye;function Pe(Q,oe){const le=new x(oe,Q);let fe=le.prevCodePoint();for(;Ne(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let ge=le.offset;return ge>0&&le.prevCodePoint()===8205&&(ge=le.offset),ge}function Ne(Q){return 127995<=Q&&Q<=127999}var Te;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(Q=>{function oe(Ie){const Ae=new Map;for(let ze=0;ze<Ie.length;ze+=2)Ae.set(Ie[ze],Ie[ze+1]);return Ae}function le(Ie,Ae){const ze=new Map(Ie);for(const[je,xe]of Ae)ze.set(je,xe);return ze}function fe(Ie,Ae){if(!Ie)return Ae;const ze=new Map;for(const[je,xe]of Ie)Ae.has(je)&&ze.set(je,xe);return ze}const ge=L.ambiguousCharacterData.getValue();let Le=Q.filter(Ie=>!Ie.startsWith("_")&&Ie in ge);Le.length===0&&(Le=["_default"]);let Se;for(const Ie of Le){const Ae=oe(ge[Ie]);Se=fe(Se,Ae)}const De=oe(ge._common),ke=le(De,Se);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[70],ie([0,1,27]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(m){return L(m,0)}e.hash=n;function L(m,w){switch(typeof m){case"object":return m===null?A(349,w):Array.isArray(m)?b(m,w):E(m,w);case"string":return R(m,w);case"boolean":return T(m,w);case"number":return A(m,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=L;function A(m,w){return(w<<5)-w+m|0}e.numberHash=A;function T(m,w){return A(m?433:863,w)}function R(m,w){w=A(149417,w);for(let g=0,v=m.length;g<v;g++)w=A(m.charCodeAt(g),w);return w}e.stringHash=R;function b(m,w){return w=A(104579,w),m.reduce((g,v)=>L(v,g),w)}function E(m,w){return w=A(181387,w),Object.keys(m).sort().reduce((g,v)=>(g=R(v,g),L(m[v],g)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(m,w,g=32){const v=g-w,l=~((1<<v)-1);return(m<<w|(l&m)>>>v)>>>0}function y(m,w=0,g=m.byteLength,v=0){for(let l=0;l<g;l++)m[w+l]=v}function u(m,w,g="0"){for(;m.length<w;)m=g+m;return m}function p(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):u((m>>>0).toString(16),w/4)}e.toHexString=p;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const v=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,c,i;for(r!==0?(c=r,i=-1,r=0):(c=w.charCodeAt(0),i=0);;){let t=c;if(D.isHighSurrogate(c))if(i+1<g){const o=w.charCodeAt(i+1);D.isLowSurrogate(o)?(i++,t=D.computeCodePoint(c,o)):t=65533}else{r=c;break}else D.isLowSurrogate(c)&&(t=65533);if(l=this._push(v,l,t),i++,i<g)c=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,g,v){return v<128?w[g++]=v:v<2048?(w[g++]=192|(v&1984)>>>6,w[g++]=128|(v&63)>>>0):v<65536?(w[g++]=224|(v&61440)>>>12,w[g++]=128|(v&4032)>>>6,w[g++]=128|(v&63)>>>0):(w[g++]=240|(v&1835008)>>>18,w[g++]=128|(v&258048)>>>12,w[g++]=128|(v&4032)>>>6,w[g++]=128|(v&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,g=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let v=this._h0,l=this._h1,r=this._h2,c=this._h3,i=this._h4,t,o,s;for(let a=0;a<80;a++)a<20?(t=l&r|~l&c,o=1518500249):a<40?(t=l^r^c,o=1859775393):a<60?(t=l&r|l&c|r&c,o=2400959708):(t=l^r^c,o=3395469782),s=f(v,5)+t+i+o+w.getUint32(a*4,!1)&4294967295,i=c,c=r,r=f(l,30),l=v,v=s;this._h0=this._h0+v&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(J,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(J,D):L?L.value=D:e.set(J,D),D},Ke=this&&this.__classPrivateFieldGet||function(J,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(J):n?n.value:e.get(J)};define(ne[39],ie([0,1,16,27]),function(J,e,D,n){"use strict";var L,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,o){let s=i.get(t);return s===void 0&&(s=o,i.set(t,s)),s}e.getOrSet=R;function b(i){const t=[];return i.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function E(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=P;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new u(t))}static forPaths(t=!1){return new m(new f(void 0,!t))}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new C)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,D.shuffle)(s);for(let a of s)this.set(a,t)}else{const s=t.slice(0);(0,D.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(t,o){const s=this._iter.reset(t);let a;this._root||(this._root=new p,this._root.segment=s.value());const h=[];for(a=this._root;;){const I=s.cmp(a.segment);if(I>0)a.left||(a.left=new p,a.left.segment=s.value()),h.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new p,a.right.segment=s.value()),h.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new p,a.mid.segment=s.value()),h.push([0,a]),a=a.mid;else break}const S=a.value;a.value=o,a.key=t;for(let I=h.length-1;I>=0;I--){const _=h[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const F=h[I][0],z=h[I+1][0];if(F===1&&z===1)h[I][1]=_.rotateLeft();else if(F===-1&&z===-1)h[I][1]=_.rotateRight();else if(F===1&&z===-1)_.right=h[I+1][1]=h[I+1][1].rotateRight(),h[I][1]=_.rotateLeft();else if(F===-1&&z===1)_.left=h[I+1][1]=h[I+1][1].rotateLeft(),h[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(h[I-1][0]){case-1:h[I-1][1].left=h[I][1];break;case 1:h[I-1][1].right=h[I][1];break;case 0:h[I-1][1].mid=h[I][1];break}else this._root=h[0][1]}}return S}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),a=[];let h=this._root;for(;h;){const S=s.cmp(h.segment);if(S>0)a.push([-1,h]),h=h.left;else if(S<0)a.push([1,h]),h=h.right;else if(s.hasNext())s.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const S=this._min(h.right),{key:I,value:_,segment:O}=S;this._delete(S.key,!1),h.key=I,h.value=_,h.segment=O}else{const S=h.left??h.right;if(a.length>0){const[I,_]=a[a.length-1];switch(I){case-1:_.left=S;break;case 0:_.mid=S;break;case 1:_.right=S;break}}else this._root=S}for(let S=a.length-1;S>=0;S--){const I=a[S][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[S][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[S][1]=I.rotateRight()),S>0)switch(a[S-1][0]){case-1:a[S-1][1].left=a[S][1];break;case 1:a[S-1][1].right=a[S][1];break;case 0:a[S-1][1].mid=a[S][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,a;for(;s;){const h=o.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,o){this.uri=t,this.value=o}}class g{constructor(t,o){this[L]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=i=>i.toString();var v;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let a=this._map.get(t);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let a=this._head;for(;a;){if(o?t.bind(o)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}values(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}entries(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=l;class r extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class c{constructor(t){T.set(this,void 0),Pt(this,T,t,"f")}get size(){return Ke(this,T,"f").size}forEach(t,o){Ke(this,T,"f").forEach(t,o)}get(t){return Ke(this,T,"f").get(t)}has(t){return Ke(this,T,"f").has(t)}entries(){return Ke(this,T,"f").entries()}keys(){return Ke(this,T,"f").keys()}values(){return Ke(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ke(this,T,"f").entries()}}e.ReadonlyMapView=c}),define(ne[71],ie([0,1,39]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return b(E,"NFC",n)}e.normalizeNFC=L;const A=new D.LRUCache(1e4);function T(E){return b(E,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function b(E,P,C){if(!E)return E;const f=C.get(E);if(f)return f;let y;return R.test(E)?y=E.normalize(P):y=E,C.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return T(P).replace(E,"")}}()}),define(ne[15],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(s){return Array.isArray(s)}e.isArray=D;function n(s){return typeof s=="string"}e.isString=n;function L(s){return Array.isArray(s)&&s.every(a=>n(a))}e.isStringArray=L;function A(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=A;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function b(s){return s===!0||s===!1}e.isBoolean=b;function E(s){return typeof s=="undefined"}e.isUndefined=E;function P(s){return!C(s)}e.isDefined=P;function C(s){return E(s)||s===null}e.isUndefinedOrNull=C;function f(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function y(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=y;function u(...s){const a=[];for(let h=0;h<s.length;h++){const S=s[h];if(C(S))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);a.push(S)}return a}e.assertAllDefined=u;const p=Object.prototype.hasOwnProperty;function d(s){if(!A(s))return!1;for(let a in s)if(p.call(s,a))return!1;return!0}e.isEmptyObject=d;function m(s){return typeof s=="function"}e.isFunction=m;function w(...s){return s.length>0&&s.every(m)}e.areFunctions=w;function g(s,a){const h=Math.min(s.length,a.length);for(let S=0;S<h;S++)v(s[S],a[S])}e.validateConstraints=g;function v(s,a){if(n(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(m(a)){try{if(s instanceof a)return}catch{}if(!C(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function l(s){let a=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)a=a.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return a}e.getAllPropertyNames=l;function r(s){const a=[];for(const h of l(s))typeof s[h]=="function"&&a.push(h);return a}e.getAllMethodNames=r;function c(s,a){const h=I=>function(){const _=Array.prototype.slice.call(arguments,0);return a(I,_)};let S={};for(const I of s)S[I]=h(I);return S}e.createProxyObject=c;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function t(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=t;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(ne[41],ie([0,1,10,4,27,15]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function R(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function E(o,s=D.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(T(h)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let I=3;const _=I;for(;I<a&&!T(o.charCodeAt(I));I++);if(_!==I&&!T(o.charCodeAt(I+1))){for(I+=1;I<a;I++)if(T(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,s)}}return s}else if(m(h)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let S=o.indexOf("://");if(S!==-1){for(S+=3;S<a;S++)if(T(o.charCodeAt(S)))return o.slice(0,S+1)}return""}e.getRoot=E;function P(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const h=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(h===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=P;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,s=n.isWindows){const a=s?C:f;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&y.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function p(o,s,a){const h=o===s;return!a||h?h:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=p;function d(o,s,a,h=D.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let I=s.length;return s.charAt(s.length-1)===h&&I--,o.charAt(I)===h}return s.charAt(s.length-1)!==h&&(s+=h),o.indexOf(s)===0}e.isEqualOrParent=d;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(s,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,L.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,L.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=w;function g(o){const s=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:v(s)&&(o.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=g;function v(o,s){return(s!==void 0?s:n.isWindows)?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function l(o){return v(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function c(o){const s=o.split(":");let a,h,S;for(const I of s){const _=Number(I);(0,A.isNumber)(_)?h===void 0?h=_:S===void 0&&(S=_):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:S!==void 0?S:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,a=8){let h="";for(let I=0;I<a;I++)h+=i.charAt(Math.floor(Math.random()*i.length));let S;return s?S=`${s}-${h}`:S=h,o?(0,D.join)(o,S):S}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.keys(p).forEach(m=>{p[m]&&typeof p[m]=="object"?d[m]=n(p[m]):d[m]=p[m]}),d}e.deepClone=n;function L(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const m=d.shift();Object.freeze(m);for(const w in m)if(A.call(m,w)){const g=m[w];typeof g=="object"&&!Object.isFrozen(g)&&d.push(g)}}return p}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function T(p,d){return R(p,d,new Set)}e.cloneAndChange=T;function R(p,d,m){if((0,D.isUndefinedOrNull)(p))return p;const w=d(p);if(typeof w!="undefined")return w;if((0,D.isArray)(p)){const g=[];for(const v of p)g.push(R(v,d,m));return g}if((0,D.isObject)(p)){if(m.has(p))throw new Error("Cannot clone recursive data-structure");m.add(p);const g={};for(let v in p)A.call(p,v)&&(g[v]=R(p[v],d,m));return m.delete(p),g}return p}function b(p,d,m=!0){return(0,D.isObject)(p)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in p?m&&((0,D.isObject)(p[w])&&(0,D.isObject)(d[w])?b(p[w],d[w],m):p[w]=d[w]):p[w]=d[w]}),p):d}e.mixin=b;function E(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let m,w;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(m=0;m<p.length;m++)if(!E(p[m],d[m]))return!1}else{const g=[];for(w in p)g.push(w);g.sort();const v=[];for(w in d)v.push(w);if(v.sort(),!E(g,v))return!1;for(m=0;m<g.length;m++)if(!E(p[g[m]],d[g[m]]))return!1}return!0}e.equals=E;function P(p){const d=new Set;return JSON.stringify(p,(m,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=P;function C(p,d,m){const w=d(p);return typeof w=="undefined"?m:w}e.getOrDefault=C;function f(p,d){const m=Object.create(null);return!p||!d||Object.keys(d).forEach(g=>{const v=p[g],l=d[g];E(v,l)||(m[g]=l)}),m}e.distinct=f;function y(p,d){const m=d.toLowerCase(),w=Object.keys(p).find(g=>g.toLowerCase()===m);return w?p[w]:p[d]}e.getCaseInsensitive=y;function u(p,d){const m=Object.create(null);for(const[w,g]of Object.entries(p))d(w,g)&&(m[w]=g);return m}e.filter=u}),define(ne[7],ie([0,1,10,4]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const P="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(t,o,s,a,h,S=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=b(t,S),this.authority=o||P,this.path=E(this.scheme,s||P),this.query=a||P,this.fragment=h||P,R(this,S))}static isUri(t){return t instanceof y?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:a,query:h,fragment:S}=t;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),a===void 0?a=this.path:a===null&&(a=P),h===void 0?h=this.query:h===null&&(h=P),S===void 0?S=this.fragment:S===null&&(S=P),o===this.scheme&&s===this.authority&&a===this.path&&h===this.query&&S===this.fragment?this:new p(o,s,a,h,S)}static parse(t,o=!1){const s=f.exec(t);return s?new p(s[2]||P,c(s[4]||P),c(s[5]||P),c(s[7]||P),c(s[9]||P),o):new p(P,P,P,P,P)}static file(t){let o=P;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const s=t.indexOf(C,2);s===-1?(o=t.substring(2),t=C):(o=t.substring(2,s),t=t.substring(s)||C)}return new p("file",o,t,P,P)}static from(t){const o=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return R(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=y.file(D.win32.join(g(t,!0),...o)).path:s=D.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof y)return t;{const o=new p(t);return o._formatted=t.external,o._fsPath=t._sep===u?t.fsPath:null,o}}else return t}}e.URI=y;const u=n.isWindows?1:void 0;class p extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,t){let o,s=-1;for(let a=0;a<i.length;a++){const h=i.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const S=d[h];S!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o+=S):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let t;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(t===void 0&&(t=i.substr(0,o)),t+=d[s]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function g(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function v(i,t){const o=t?w:m;let s="",{scheme:a,authority:h,path:S,query:I,fragment:_}=i;if(a&&(s+=a,s+=":"),(h||a==="file")&&(s+=C,s+=C),h){let O=h.indexOf("@");if(O!==-1){const F=h.substr(0,O);h=h.substr(O+1),O=F.indexOf(":"),O===-1?s+=o(F,!1):(s+=o(F.substr(0,O),!1),s+=":",s+=o(F.substr(O+1),!1)),s+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?s+=o(h,!1):(s+=o(h.substr(0,O),!1),s+=h.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}s+=o(S,!0)}return I&&(s+="?",s+=o(I,!1)),_&&(s+="#",s+=t?_:m(_,!1)),s}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(ne[107],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const P=[];let C;try{const f=JSON.parse(E.arguments),y=f[f.length-1];y&&y.__$stack&&(f.pop(),C=y.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:C}}e.parse=L;function A(E){if(typeof E!="string")return A(L(E).stack);const P=E;if(P){const C=T(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=A;function T(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function R(E,P){const{args:C,stack:f}=L(E),y=typeof C[0]=="string"&&C.length===1;let u=T(f);u&&(u=`(${u.trim()})`);let p=[];if(typeof C[0]=="string"?u&&y?p=[`%c[${P}] %c${C[0]} %c${u}`,b("blue"),b(""),b("grey")]:p=[`%c[${P}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:p=[`%c[${P}]%`,b("blue"),...C],u&&!y&&p.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}e.log=R;function b(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,27,7]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,b)}e.stringify=A;function T(P){let C=JSON.parse(P);return C=E(C),C}e.parse=T;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext",P[P.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function b(P,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(P,C=0){if(!P||C>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof D.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=E(P[f],C+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=E(P[f],C+1))}return P}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,P){this._hosts[b]=E,this._ports[b]=P}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const C=this._ports[E],f=this._connectionTokens[E];let y=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(y+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${C}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new A;class T{asBrowserUri(b,E){const P=this.toUri(b,E);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,E){const P=this.toUri(b,E);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==T.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ne[19],ie([0,1,41,18,10,4,27,7]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(y){return(0,R.uriToFsPath)(y,!0)}e.originalFSPath=b;class E{constructor(u){this._ignorePathCasing=u}compare(u,p,d=!1){return u===p?0:(0,T.compare)(this.getComparisonKey(u,d),this.getComparisonKey(p,d))}isEqual(u,p,d=!1){return u===p?!0:!u||!p?!1:this.getComparisonKey(u,d)===this.getComparisonKey(p,d)}getComparisonKey(u,p=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,p,d=!1){if(u.scheme===p.scheme){if(u.scheme===n.Schemas.file)return D.isEqualOrParent(b(u),b(p),this._ignorePathCasing(u))&&u.query===p.query&&(d||u.fragment===p.fragment);if((0,e.isEqualAuthority)(u.authority,p.authority))return D.isEqualOrParent(u.path,p.path,this._ignorePathCasing(u),"/")&&u.query===p.query&&(d||u.fragment===p.fragment)}return!1}joinPath(u,...p){return R.URI.joinPath(u,...p)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return L.posix.basename(u.path)}extname(u){return L.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let p;return u.scheme===n.Schemas.file?p=R.URI.file(L.dirname(b(u))).path:(p=L.posix.dirname(u.path),u.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),p="/")),u.with({path:p})}normalizePath(u){if(!u.path.length)return u;let p;return u.scheme===n.Schemas.file?p=R.URI.file(L.normalize(b(u))).path:p=L.posix.normalize(u.path),u.with({path:p})}relativePath(u,p){if(u.scheme!==p.scheme||!(0,e.isEqualAuthority)(u.authority,p.authority))return;if(u.scheme===n.Schemas.file){const w=L.relative(b(u),b(p));return A.isWindows?D.toSlashes(w):w}let d=u.path||"/",m=p.path||"/";if(this._ignorePathCasing(u)){let w=0;for(const g=Math.min(d.length,m.length);w<g&&!(d.charCodeAt(w)!==m.charCodeAt(w)&&d.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);d=m.substr(0,w)+d.substr(w)}return L.posix.relative(d,m)}resolvePath(u,p){if(u.scheme===n.Schemas.file){const d=R.URI.file(L.resolve(b(u),p));return u.with({authority:d.authority,path:d.path})}return p=D.toPosixPath(p),u.with({path:L.posix.resolve(u.path,p)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,p){return u===p||u!==void 0&&p!==void 0&&(0,T.equalsIgnoreCase)(u,p)}hasTrailingPathSeparator(u,p=L.sep){if(u.scheme===n.Schemas.file){const d=b(u);return d.length>D.getRoot(d).length&&d[d.length-1]===p}else{const d=u.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,p=L.sep){return(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,p=L.sep){let d=!1;if(u.scheme===n.Schemas.file){const m=b(u);d=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===p}else{p="/";const m=u.path;d=m.length===1&&m.charCodeAt(m.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(y,u){const p=[];for(let d=0;d<y.length;d++){const m=u(y[d]);y.some((w,g)=>g===d?!1:(0,e.isEqualOrParent)(m,u(w)))||p.push(y[d])}return p}e.distinctParents=P;var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function u(p){const d=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,l]=g.split(":");v&&l&&d.set(v,l)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&d.set(y.META_DATA_MIME,w),d}y.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(y,u,p){if(u){let d=y.path;return d&&d[0]!==L.posix.sep&&(d=L.posix.sep+d),y.with({scheme:p,authority:u,path:d})}return y.with({scheme:p})}e.toLocalResource=f}),define(ne[5],ie([0,1,23,9,3,2,19,4]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(W){return!!W&&typeof W.then=="function"}e.isThenable=b;function E(W){const N=new D.CancellationTokenSource,V=W(N.token),$=new Promise((B,te)=>{const se=N.token.onCancellationRequested(()=>{se.dispose(),N.dispose(),te(new n.CancellationError)});Promise.resolve(V).then(ce=>{se.dispose(),N.dispose(),B(ce)},ce=>{se.dispose(),N.dispose(),te(ce)})});return new class{cancel(){N.cancel()}then(B,te){return $.then(B,te)}catch(B){return this.then(void 0,B)}finally(B){return $.finally(B)}}}e.createCancelablePromise=E;function P(W,N,V){return new Promise(($,B)=>{const te=N.onCancellationRequested(()=>{te.dispose(),$(V)});W.then($,B).finally(()=>te.dispose())})}e.raceCancellation=P;function C(W,N){return new Promise((V,$)=>{const B=N.onCancellationRequested(()=>{B.dispose(),$(new n.CancellationError)});W.then(V,$).finally(()=>B.dispose())})}e.raceCancellationError=C;async function f(W){let N=-1;const V=W.map((B,te)=>B.then(se=>(N=te,se))),$=await Promise.race(V);return W.forEach((B,te)=>{te!==N&&B.cancel()}),$}e.raceCancellablePromises=f;function y(W,N,V){let $;const B=setTimeout(()=>{$?.(void 0),V?.()},N);return Promise.race([W.finally(()=>clearTimeout(B)),new Promise(te=>$=te)])}e.raceTimeout=y;function u(W){return new Promise((N,V)=>{const $=W();b($)?$.then(N,V):N($)})}e.asPromise=u;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(V,V).then($)})}return new Promise((V,$)=>{this.queuedPromise.then(V,$)})}return this.activePromise=N(),new Promise((V,$)=>{this.activePromise.then(B=>{this.activePromise=null,V(B)},B=>{this.activePromise=null,$(B)})})}}e.Throttler=p;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue(N,V){const B=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(N)===B&&this.promiseMap.delete(N)});return this.promiseMap.set(N,B),B}}e.SequencerByKey=m;const w=(W,N)=>{let V=!0;const $=setTimeout(()=>{V=!1,N()},W);return{isTriggered:()=>V,dispose:()=>{clearTimeout($),V=!1}}},g=W=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,W())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,V=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,te)=>{this.doResolve=B,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=V===e.MicrotaskDelay?g($):w(V,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class l{constructor(N){this.delayer=new v(N),this.throttler=new p}trigger(N,V){return this.delayer.trigger(()=>this.throttler.queue(N),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((N,V)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(W,N){return N?new Promise((V,$)=>{const B=setTimeout(()=>{te.dispose(),V()},W),te=N.onCancellationRequested(()=>{clearTimeout(B),te.dispose(),$(new n.CancellationError)})}):E(V=>i(W,V))}e.timeout=i;function t(W,N=0){const V=setTimeout(W,N);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=t;function o(W){const N=[];let V=0;const $=W.length;function B(){return V<$?W[V++]():null}function te(se){se!=null&&N.push(se);const ce=B();return ce?ce.then(te):Promise.resolve(N)}return Promise.resolve(null).then(te)}e.sequence=o;function s(W,N=$=>!!$,V=null){let $=0;const B=W.length,te=()=>{if($>=B)return Promise.resolve(V);const se=W[$++];return Promise.resolve(se()).then(he=>N(he)?Promise.resolve(he):te())};return te()}e.first=s;function a(W,N=$=>!!$,V=null){if(W.length===0)return Promise.resolve(V);let $=W.length;const B=()=>{$=-1;for(const te of W)te.cancel?.()};return new Promise((te,se)=>{for(const ce of W)ce.then(he=>{--$>=0&&N(he)?(B(),te(he)):$===0&&te(V)}).catch(he=>{--$>=0&&(B(),se(he))})})}e.firstParallel=a;class h{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((V,$)=>{this.outstandingPromises.push({factory:N,c:V,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const V=N.factory();V.then(N.c,N.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class S extends h{constructor(){super(1)}}e.Queue=S;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new x;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,V=T.extUri){const $=V.getComparisonKey(N);let B=this.queues.get($);return B||(B=new S,L.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete($),this.onDidQueueFinish()}),this.queues.set($,B)),B}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(N,V){this._token=-1,typeof N=="function"&&typeof V=="number"&&this.setIfNotSet(N,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},V)}setIfNotSet(N,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},V))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,V){this.cancel(),this._token=setInterval(()=>{N()},V)}}e.IntervalTimer=O;class F{constructor(N,V){this.timeoutToken=-1,this.runner=N,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class z{constructor(N,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=z;class k extends F{constructor(N,V){super(N,V);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class U extends A.Disposable{constructor(N,V){super();this.options=N,this.handler=V,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(N)return;const V=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(W,N)=>{const V=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(V))}}}}();class j{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function M(W,N,V){let $;for(let B=0;B<V;B++)try{return await W()}catch(te){$=te,await i(N)}throw $}e.retry=M;class G{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,V,$){return this._pending={taskId:N,cancel:()=>$?.(),promise:V},V.then(()=>this.donePending(N),()=>this.donePending(N)),V}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let V,$;const B=new Promise((te,se)=>{V=te,$=se});this._next={run:N,promise:B,promiseResolve:V,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(N,V=()=>Date.now()){this.interval=N,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,V)=>{this.completeCallback=N,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(V=>{this.completeCallback(N),this.resolved=!0,V()})}error(N){return new Promise(V=>{this.errorCallback(N),this.rejected=!0,V()})}cancel(){new Promise(N=>{this.errorCallback(new n.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=x;var q;(function(W){async function N($){let B;const te=await Promise.all($.map(se=>se.then(ce=>ce,ce=>{B||(B=ce)})));if(typeof B!="undefined")throw B;return te}W.settled=N;function V($){return new Promise(async(B,te)=>{try{await $(B,te)}catch(se){te(se)}})}W.withAsyncBody=V})(q=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class H{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const V={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(N(V)),this.resolve()}catch($){this.reject($)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}static fromArray(N){return new H(V=>{V.emitMany(N)})}static fromPromise(N){return new H(async V=>{V.emitMany(await N)})}static fromPromises(N){return new H(async V=>{await Promise.all(N.map(async $=>V.emitOne(await $)))})}static merge(N){return new H(async V=>{await Promise.all(N.map(async $=>{for await(const B of $)V.emitOne(B)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,V){return new H(async $=>{for await(const B of N)$.emitOne(V(B))})}map(N){return H.map(this,N)}static filter(N,V){return new H(async $=>{for await(const B of N)V(B)&&$.emitOne(B)})}filter(N){return H.filter(this,N)}static coalesce(N){return H.filter(N,V=>!!V)}coalesce(){return H.coalesce(this)}static async toPromise(N){const V=[];for await(const $ of N)V.push($);return V}toPromise(){return H.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor(N,V){super(V);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ee(W){const N=new D.CancellationTokenSource,V=W(N.token);return new Z(N,async $=>{const B=N.token.onCancellationRequested(()=>{B.dispose(),N.dispose(),$.reject(new n.CancellationError)});try{for await(const te of V){if(N.token.isCancellationRequested)return;$.emitOne(te)}B.dispose(),N.dispose()}catch(te){B.dispose(),N.dispose(),$.reject(te)}})}e.createCancelableAsyncIterable=ee}),define(ne[109],ie([0,1,5,41,39,10,27]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",E="[^/\\\\]",P=/\//g;function C(K){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${b}|${E}+${b}|${b}${E}+)*?`}}function f(K,x){if(!K)return[];const q=[];let X=!1,H=!1,Z="";for(const ee of K){switch(ee){case x:if(!X&&!H){q.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":H=!0;break;case"]":H=!1;break}Z+=ee}return Z&&q.push(Z),q}e.splitGlobAware=f;function y(K){if(!K)return"";let x="";const q=f(K,e.GLOB_SPLIT);if(q.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;q.forEach((H,Z)=>{if(H===e.GLOBSTAR){X||(x+=C(2),X=!0);return}let ee=!1,W="",N=!1,V="";for(const $ of H){if($!=="}"&&ee){W+=$;continue}if(N&&($!=="]"||!V)){let B;$==="-"?B=$:($==="^"||$==="!")&&!V?B="^":$===e.GLOB_SPLIT?B="":B=T.escapeRegExpCharacters($),V+=B;continue}switch($){case"{":ee=!0;continue;case"[":N=!0;continue;case"}":{x+=`(?:${f(W,",").map(se=>y(se)).join("|")})`,ee=!1,W="";break}case"]":x+="["+V+"]",N=!1,V="";break;case"?":x+=E;continue;case"*":x+=C(1);continue;default:x+=T.escapeRegExpCharacters($)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(x+=b),X=!1})}return x}const u=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,v=new L.LRUCache(1e4),l=function(){return!1},r=function(){return null};function c(K,x){if(!K)return r;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const X=`${q}_${!!x.trimForExclusions}`;let H=v.get(X);if(H)return i(H,K);let Z;if(u.test(q)){const ee=q.substr(4);H=function(W,N){return typeof W=="string"&&W.endsWith(ee)?q:null}}else(Z=p.exec(t(q,x)))?H=o(Z[1],q):(x.trimForExclusions?m:d).test(q)?H=s(q,x):(Z=w.exec(t(q,x)))?H=a(Z[1].substr(1),q,!0):(Z=g.exec(t(q,x)))?H=a(Z[1],q,!1):H=h(q);return v.set(X,H),i(H,K)}function i(K,x){return typeof x=="string"?K:function(q,X){return n.isEqualOrParent(q,x.base)?K(A.relative(x.base,q),X):null}}function t(K,x){return x.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,x){const q=`/${K}`,X=`\\${K}`,H=function(ee,W){return typeof ee!="string"?null:W?W===K?x:null:ee===K||ee.endsWith(q)||ee.endsWith(X)?x:null},Z=[K];return H.basenames=Z,H.patterns=[x],H.allBasenames=Z,H}function s(K,x){const q=G(K.slice(1,-1).split(",").map(W=>c(W,x)).filter(W=>W!==r),K),X=q.length;if(!X)return r;if(X===1)return q[0];const H=function(W,N){for(let V=0,$=q.length;V<$;V++)if(q[V](W,N))return K;return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function a(K,x,q){const X=A.sep===A.posix.sep,H=X?K:K.replace(P,A.sep),Z=A.sep+H,ee=A.posix.sep+K,W=q?function(N,V){return typeof N=="string"&&(N===H||N.endsWith(Z)||!X&&(N===K||N.endsWith(ee)))?x:null}:function(N,V){return typeof N=="string"&&(N===H||!X&&N===K)?x:null};return W.allPaths=[(q?"*/":"./")+K],W}function h(K){try{const x=new RegExp(`^${y(K)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?K:null}}catch{return r}}function S(K,x,q){return!K||typeof x!="string"?!1:I(K)(x,void 0,q)}e.match=S;function I(K,x={}){if(!K)return l;if(typeof K=="string"||z(K)){const q=c(K,x);if(q===r)return l;const X=function(H,Z){return!!q(H,Z)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return j(K,x)}e.parse=I;function _(K){if(!K)return;let x;return q=>(x||(x=(K()||Promise.resolve([])).then(X=>X?F(X):{})),x.then(X=>!!X[q]))}e.hasSiblingPromiseFn=_;function O(K){if(!K)return;let x;return q=>{if(!x){const X=K();x=X?F(X):{}}return!!x[q]}}e.hasSiblingFn=O;function F(K){const x={};for(const q of K)x[q]=!0;return x}function z(K){const x=K;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=z;function k(K){return K.allBasenames||[]}e.getBasenameTerms=k;function U(K){return K.allPaths||[]}e.getPathTerms=U;function j(K,x){const q=G(Object.getOwnPropertyNames(K).map(W=>M(W,K[W],x)).filter(W=>W!==r)),X=q.length;if(!X)return r;if(!q.some(W=>!!W.requiresSiblings)){if(X===1)return q[0];const W=function($,B){for(let te=0,se=q.length;te<se;te++){const ce=q[te]($,B);if(ce)return ce}return null},N=q.find($=>!!$.allBasenames);N&&(W.allBasenames=N.allBasenames);const V=q.reduce(($,B)=>B.allPaths?$.concat(B.allPaths):$,[]);return V.length&&(W.allPaths=V),W}const H=function(W,N,V){let $;for(let B=0,te=q.length;B<te;B++){const se=q[B];se.requiresSiblings&&V&&(N||(N=A.basename(W)),$||($=N.substr(0,N.length-A.extname(W).length)));const ce=se(W,N,$,V);if(ce)return ce}return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function M(K,x,q){if(x===!1)return r;const X=c(K,q);if(X===r)return r;if(typeof x=="boolean")return X;if(x){const H=x.when;if(typeof H=="string"){const Z=(ee,W,N,V)=>{if(!V||!X(ee,W))return null;const $=H.replace("$(basename)",N),B=V($);return(0,D.isThenable)(B)?B.then(te=>te?K:null):B?K:null};return Z.requiresSiblings=!0,Z}}return X}function G(K,x){const q=K.filter(W=>!!W.basenames);if(q.length<2)return K;const X=q.reduce((W,N)=>{const V=N.basenames;return V?W.concat(V):W},[]);let H;if(x){H=[];for(let W=0,N=X.length;W<N;W++)H.push(x)}else H=q.reduce((W,N)=>{const V=N.patterns;return V?W.concat(V):W},[]);const Z=function(W,N){if(typeof W!="string")return null;if(!N){let $;for($=W.length;$>0;$--){const B=W.charCodeAt($-1);if(B===47||B===92)break}N=W.substr($)}const V=X.indexOf(N);return V!==-1?H[V]:null};Z.basenames=X,Z.patterns=H,Z.allBasenames=X;const ee=K.filter(W=>!W.basenames);return ee.push(Z),ee}}),define(ne[110],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,C,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof D.URI)return C.transformOutgoing(P);for(let y in P)if(Object.hasOwnProperty.call(P,y)){const u=A(P[y],C,f+1);u!==null&&(P[y]=u)}}return null}function T(P,C){const f=A(P,C,0);return f===null?P:f}e.transformOutgoingURIs=T;function R(P,C,f,y){if(!P||y>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?D.URI.revive(C.transformIncoming(P)):C.transformIncoming(P);for(let u in P)if(Object.hasOwnProperty.call(P,u)){const p=R(P[u],C,f,y+1);p!==null&&(P[u]=p)}}return null}function b(P,C){const f=R(P,C,!1,0);return f===null?P:f}e.transformIncomingURIs=b;function E(P,C){const f=R(P,C,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const L=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function R(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,250]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(R.length<1)return T;let b=0,E,P=b;for(;P<R.length;)if(E=R.charCodeAt(P),E===13||E===10){if(T.push(R.substring(b,P)),P++,P<R.length){const C=E;E=R.charCodeAt(P),(C===13&&E===10||C===10&&E===13)&&P++}b=P}else P++;return this.remaining=b<R.length?R.substr(b):null,T}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function A(){const T=(0,D.networkInterfaces)();for(let R in T){const b=T[R];if(b){for(const{mac:E}of b)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[113],ie([0,1,33,9,39,29,112]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,C=0;const f=(0,D.networkInterfaces)();for(let y in f){const u=f[y];if(u)for(const{mac:p,internal:d}of u)d||(C+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(P+=1))}this._value=C>0?P/C:0}return this._value}};let R;async function b(){return R||(R=(async()=>await E()||A.generateUuid())()),R}e.getMachineId=b;async function E(){try{const P=await new Promise((f,y)=>{J(["crypto"],f,y)}),C=(0,T.getMac)();return P.createHash("sha256").update(C,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(ne[22],ie([0,1,50,33,251,5,41,71,10,4,19,7]),function(J,e,D,n,L,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function y(U,j=f.UNLINK){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return j===f.UNLINK?p(U):u(U)}async function u(U){try{const j=(0,T.randomPath)((0,n.tmpdir)());try{await D.promises.rename(U,j)}catch{return p(U)}p(j).catch(M=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function p(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function d(U){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=d;async function m(U,j){return v(await(j?w(U):(0,L.promisify)(D.readdir)(U)))}async function w(U){try{return await(0,L.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const j=[],M=await m(U);for(const G of M){let K=!1,x=!1,q=!1;try{const X=await e.Promises.lstat((0,b.join)(U,G));K=X.isFile(),x=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}j.push({name:G,isFile:()=>K,isDirectory:()=>x,isSymbolicLink:()=>q})}return j}function g(U){return v(D.readdirSync(U))}e.readdirSync=g;function v(U){return U.map(j=>typeof j=="string"?E.isMacintosh?(0,R.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,R.normalizeNFC)(j.name):j.name,j))}async function l(U){const j=await m(U),M=[];for(const G of j)await c.existsDirectory((0,b.join)(U,G))&&M.push(G);return M}function r(U,j=1e3){return new Promise(M=>{let G=!1;const K=setInterval(()=>{G||(G=!0,D.access(U,x=>{G=!1,x&&(clearInterval(K),M(void 0))}))},j)})}e.whenDeleted=r;var c;(function(U){async function j(K){let x;try{if(x=await e.Promises.lstat(K),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw q}}U.stat=j;async function M(K){try{const{stat:x,symbolicLink:q}=await U.stat(K);return x.isFile()&&q?.dangling!==!0}catch{}return!1}U.existsFile=M;async function G(K){try{const{stat:x,symbolicLink:q}=await U.stat(K);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}U.existsDirectory=G})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function t(U,j,M){return i.queueFor(C.URI.file(U),P.extUriBiasedIgnorePathCase).queue(()=>{const G=h(M);return new Promise((K,x)=>s(U,j,G,q=>q?x(q):K()))})}let o=!0;function s(U,j,M,G){if(!o)return D.writeFile(U,j,{mode:M.mode,flag:M.flag},G);D.open(U,M.flag,M.mode,(K,x)=>{if(K)return G(K);D.writeFile(x,j,q=>{if(q)return D.close(x,()=>G(q));D.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),o=!1),D.close(x,H=>G(H))))})})}function a(U,j,M){const G=h(M);if(!o)return D.writeFileSync(U,j,{mode:G.mode,flag:G.flag});const K=D.openSync(U,G.flag,G.mode);try{D.writeFileSync(K,j);try{D.fdatasyncSync(K)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),o=!1}}finally{D.closeSync(K)}}e.writeFileSync=a;function h(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function S(U,j){if(U===j)return;async function M(G){try{const K=await e.Promises.lstat(G);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(G,K.atime,new Date)}catch{}}try{await e.Promises.rename(U,j),await M(j)}catch(G){if(U.toLowerCase()!==j.toLowerCase()&&G.code==="EXDEV"||U.endsWith("."))await I(U,j,{preserveSymlinks:!1}),await y(U,f.MOVE),await M(j);else throw G}}async function I(U,j,M){return O(U,j,{root:{source:U,target:j},options:M,handledSourcePaths:new Set})}const _=511;async function O(U,j,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:G,symbolicLink:K}=await c.stat(U);if(K){if(M.options.preserveSymlinks)try{return await k(U,j,M)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(K.dangling)return}return G.isDirectory()?F(U,j,G.mode&_,M):z(U,j,G.mode&_)}async function F(U,j,M,G){await e.Promises.mkdir(j,{recursive:!0,mode:M});const K=await m(U);for(const x of K)await O((0,b.join)(U,x),(0,b.join)(j,x),G)}async function z(U,j,M){await e.Promises.copyFile(U,j),await e.Promises.chmod(j,M)}async function k(U,j,M){let G=await e.Promises.readlink(U);(0,T.isEqualOrParent)(G,M.root.source,!E.isLinux)&&(G=(0,b.join)(M.root.target,G.substr(M.root.source.length+1))),await e.Promises.symlink(G,j)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(U,j,M,G,K)=>new Promise((x,q)=>{D.read(U,j,M,G,K,(X,H,Z)=>X?q(X):x({bytesRead:H,buffer:Z}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(U,j,M,G,K)=>new Promise((x,q)=>{D.write(U,j,M,G,K,(X,H,Z)=>X?q(X):x({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return y}get move(){return S}get copy(){return I}}}),define(ne[114],ie([0,1,50,10,4,27,22]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,T.readdirSync)(y).filter(m=>m.toLowerCase()===u);if(d.length===1){const m=R(y);if(m)return(0,n.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(u);if(m>=0){const w=R(y);if(w)return(0,n.join)(w,d[m])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(await T.Promises.readdir(y)).filter(m=>m.toLowerCase()===u);if(d.length===1){const m=await b(y);if(m)return(0,n.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(u);if(m>=0){const w=await b(y);if(w)return(0,n.join)(w,d[m])}}}catch{}return null}e.realcase=b;async function E(f){try{return await T.Promises.realpath(f)}catch{const u=C(f);return await T.Promises.access(u,D.constants.R_OK),u}}e.realpath=E;function P(f){try{return D.realpathSync(f)}catch{const u=C(f);return D.accessSync(u,D.constants.R_OK),u}}e.realpathSync=P;function C(f){return(0,A.rtrim)((0,n.normalize)(f),n.sep)}}),define(ne[115],ie([0,1,56]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,E,P=1){let C=!1;return new Promise(f=>{const y=setTimeout(()=>{if(!C)return C=!0,f(0)},E);L(R,b,P,u=>{if(!C)return C=!0,clearTimeout(y),f(u)})})}e.findFreePort=n;function L(R,b,E,P){if(b===0)return P(0);const C=new D.Socket;C.once("connect",()=>(T(C),L(R+E,b-1,E,P))),C.once("data",()=>{}),C.once("error",f=>(T(C),f.code!=="ECONNREFUSED"?L(R+E,b-1,E,P):P(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,b,E){let P=!1,C,f=1;const y=D.createServer({pauseOnConnect:!0});function u(p,d){P||(P=!0,y.removeAllListeners(),y.close(),C&&clearTimeout(C),d(p))}return new Promise(p=>{C=setTimeout(()=>{u(0,p)},E),y.on("listening",()=>{u(R,p)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(R++,f++,y.listen(R,"127.0.0.1")):u(0,p)}),y.on("close",()=>{u(0,p)}),y.listen(R,"127.0.0.1")})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ne[72],ie([0,1,33,10,22]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class C{constructor(l,r,c){this.exePath=l,this.displayName=r,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:v=!1}={}){return v?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:v=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:v});if(!r)return null;const c=n.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let i=-1,t=null;for(const a of await L.Promises.readdir(c)){let h=-1;if(l){const I=a.indexOf("-");if(I<0)continue;const _=a.substring(0,I);if(!A.test(_)||a.substring(I+1)!=="preview")continue;h=parseInt(_,10)}else{if(!A.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const S=n.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(S)||(t=S,i=h)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",s=l?" Preview":"";return new C(t,`PowerShell${s}${o}`,!0)}async function u({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:c}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new C(t,c)}return null}function p(){const v=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(v,".NET Core PowerShell Global Tool")}function d(){const v=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(v,"Windows PowerShell",!0)}async function*m(){let v=await y();v&&(yield v),v=await y({useAlternateBitness:!0}),v&&(yield v),v=await u(),v&&(yield v),v=p(),v&&(yield v),v=await y({findPreview:!0}),v&&(yield v),v=await u({findPreview:!0}),v&&(yield v),v=await y({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=d(),v&&(yield v)}async function*w(){for await(const v of m())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=w;async function g(){for await(const v of w())return v;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ne[116],ie([0,1,45,18]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(T){return new Promise((R,b)=>{let E;const P=new Map;function C(y,u,p,d,m){const w=P.get(u);if(y===T||w){const g={name:f(p),cmd:p,pid:y,ppid:u,load:d,mem:m};P.set(y,g),y===T&&(E=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((v,l)=>v.pid-l.pid)))}}function f(y){const u=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,v=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(y))return"electron-crash-reporter";if(g.exec(y))return"winpty-process";if(v.exec(y))return"console-window-host (Windows internal process)";let r=l.exec(y);if(r&&r.length===2)return r[1]==="renderer"?u.exec(y)?"shared-process":p.exec(y)?"issue-reporter":d.exec(y)?"process-explorer":"window":r[1]==="utility"&&m.exec(y)?"utility-network-service":r[1];const c=/[a-zA-Z-]+\.js/g;let i="";do r=c.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,p)=>{J(["windows-process-tree"],u,p)}).then(u=>{u.getProcessList(T,p=>{u.getProcessCpuUsage(p,d=>{const m=new Map;d.forEach(w=>{const g=y(w.commandLine||"");m.set(w.pid,{name:f(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=m.get(T),E?(m.forEach(w=>{const g=m.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((g,v)=>g.pid-v.pid))}),R(E)):b(new Error(`Root process ${T} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let y=function(){let u=[E];const p=[];for(;u.length;){const m=u.shift();m&&(p.push(m.pid),m.children&&(u=u.concat(m.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);d+=" "+p.join(" "),(0,D.exec)(d,{},(m,w,g)=>{if(m||g)b(m||new Error(g.toString()));else{const v=w.toString().split(`
`);for(let l=0;l<p.length;l++){const r=P.get(p[l]);r.load=parseFloat(v[l])}if(!E){b(new Error(`Root process ${T} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(u,p,d)=>{if(u||d)if(process.platform!=="linux")b(u||new Error(d.toString()));else{const m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(m,{},(w,g,v)=>{w||v?b(w||new Error(v.toString())):(A(g,C),y())})}else{const m=p.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,l)=>{g||l&&!l.includes("screen size is bogus")?b(g||new Error(l.toString())):(A(v,C),process.platform==="linux"?y():E?R(E):b(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=L;function A(T,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const P of E){const C=b.exec(P.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var de=this&&this.__decorate||function(J,e,D,n){var L=arguments.length,A=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,D,n);else for(var R=J.length-1;R>=0;R--)(T=J[R])&&(A=(L<3?T(A):L>3?T(e,D,A):T(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(ne[36],ie([0,1,16,5,17,23,54,9,3,2,108,27,15]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function u(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const X=this.buffer.slice(this.pos,this.pos+q);return this.pos+=X.byteLength,X}}class g{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var v;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(v||(v={}));function l(x){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE(x,0),q}function r(x){return x.read(4).readUInt32BE(0)}function c(x){const q=L.VSBuffer.alloc(1);return q.writeUInt8(x,0),q}const i={Undefined:c(v.Undefined),String:c(v.String),Buffer:c(v.Buffer),VSBuffer:c(v.VSBuffer),Array:c(v.Array),Object:c(v.Object)},t=typeof Buffer!="undefined";function o(x,q){if(typeof q=="undefined")x.write(i.Undefined);else if(typeof q=="string"){const X=L.VSBuffer.fromString(q);x.write(i.String),x.write(l(X.byteLength)),x.write(X)}else if(t&&Buffer.isBuffer(q)){const X=L.VSBuffer.wrap(q);x.write(i.Buffer),x.write(l(X.byteLength)),x.write(X)}else if(q instanceof L.VSBuffer)x.write(i.VSBuffer),x.write(l(q.byteLength)),x.write(q);else if(Array.isArray(q)){x.write(i.Array),x.write(l(q.length));for(const X of q)o(x,X)}else{const X=L.VSBuffer.fromString(JSON.stringify(q));x.write(i.Object),x.write(l(X.byteLength)),x.write(X)}}function s(x){switch(x.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return x.read(r(x)).toString();case v.Buffer:return x.read(r(x)).buffer;case v.VSBuffer:return x.read(r(x));case v.Array:{const X=r(x),H=[];for(let Z=0;Z<X;Z++)H.push(s(x));return H}case v.Object:return JSON.parse(x.read(r(x)).toString())}}class a{constructor(q,X,H=null,Z=1e3){this.protocol=q,this.ctx=X,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(q,X){this.channels.set(q,X),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const X=this.send([q.type]);this.logger&&this.logger.logOutgoing(X,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const X=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(X,q.id,1,d(q.type),q.data);return}}}send(q,X=void 0){const H=new g;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=new A.CancellationTokenSource;let Z;try{Z=X.call(this.ctx,q.name,q.arg,H.token)}catch(N){Z=Promise.reject(N)}const ee=q.id;Z.then(N=>{this.sendResponse({id:ee,data:N,type:201}),this.activeRequests.delete(q.id)},N=>{N instanceof Error?this.sendResponse({id:ee,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:ee,data:N,type:203}),this.activeRequests.delete(q.id)});const W=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,W)}onEventListen(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=q.id,ee=X.listen(this.ctx,q.name,q.arg)(W=>this.sendResponse({id:H,data:W,type:204}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const X=this.activeRequests.get(q.id);X&&(X.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let X=this.pendingRequests.get(q.channelName);X||(X=[],this.pendingRequests.set(q.channelName,X));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const X=this.pendingRequests.get(q);if(X){for(const H of X)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(q,X=null){this.protocol=q,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=X}getChannel(q){const X=this;return{call(H,Z,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(q,H,Z,ee)},listen(H,Z){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(q,H,Z)}}}requestPromise(q,X,H,Z=A.CancellationToken.None){const ee=this.lastRequestId++,N={id:ee,type:100,channelName:q,name:X,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let V;return new Promise((B,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const pe=Ee=>{switch(Ee.type){case 201:this.handlers.delete(ee),B(Ee.data);break;case 202:{this.handlers.delete(ee);const Ce=new Error(Ee.data.message);Ce.stack=Ee.data.stack,Ce.name=Ee.data.name,te(Ce);break}case 203:this.handlers.delete(ee),te(Ee.data);break}};this.handlers.set(ee,pe),this.sendRequest(N)};let ce=null;this.state===m.Idle?se():(ce=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ee,type:101}),te(R.canceled())},ve=Z.onCancellationRequested(he);V=(0,E.combinedDisposable)((0,E.toDisposable)(he),ve),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(q,X,H){const Z=this.lastRequestId++,W={id:Z,type:102,channelName:q,name:X,arg:H};let N=null;const V=new b.Emitter({onFirstListenerAdd:()=>{N=(0,n.createCancelablePromise)(B=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(V),this.sendRequest(W)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(V),this.sendRequest({id:Z,type:103}))}}),$=B=>V.fire(B.data);return this.handlers.set(Z,$),V.event}sendRequest(q){switch(q.type){case 100:case 102:{const X=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(X,q.id,0,`${u(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(X,q.id,0,u(q.type));return}}}send(q,X=void 0){const H=new g;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,d(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,d(ee),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(q.id);X&&X(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([T.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:X,onDidClientDisconnect:H})=>{b.Event.once(X.onMessage)(ee=>{const W=new w(ee),N=s(W),V=new a(X,N),$=new S(X);this.channels.forEach((te,se)=>V.registerChannel(se,te));const B={channelServer:V,channelClient:$,ctx:N};this._connections.add(B),this._onDidAddConnection.fire(B),H(()=>{V.dispose(),$.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const q=[];return this._connections.forEach(X=>q.push(X)),q}getChannel(q,X){const H=this;return{call(Z,ee,W){let N;if((0,f.isFunction)(X)){let $=(0,D.getRandomElement)(H.connections.filter(X));N=$?Promise.resolve($):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,X))}else N=X.routeCall(H,Z,ee);const V=N.then($=>$.channelClient.getChannel(q));return O(V).call(Z,ee,W)},listen(Z,ee){if((0,f.isFunction)(X))return H.getMulticastEvent(q,X,Z,ee);const W=X.routeEvent(H,Z,ee).then(N=>N.channelClient.getChannel(q));return O(W).listen(Z,ee)}}}getMulticastEvent(q,X,H,Z){const ee=this;let W=new E.DisposableStore;const N=new b.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const V=new b.EventMultiplexer,$=new Map,B=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),ve=V.add(he);$.set(se,ve)},te=se=>{const ce=$.get(se);!ce||(ce.dispose(),$.delete(se))};ee.connections.filter(X).forEach(B),b.Event.filter(ee.onDidAddConnection,X)(B,void 0,W),ee.onDidRemoveConnection(te,void 0,W),V.event(N.fire,N,W),W.add(V)},onLastListenerRemove:()=>{W.dispose()}});return N.event}registerChannel(q,X){this.channels.set(q,X),this._connections.forEach(H=>{H.channelServer.registerChannel(q,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(q,X,H=null){const Z=new g;o(Z,X),q.send(Z.buffer),this.channelClient=new S(q,H),this.channelServer=new a(q,X,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,X){this.channelServer.registerChannel(q,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call(q,X,H){return x.then(Z=>Z.call(q,X,H))},listen(q,X){const H=new b.Relay;return x.then(Z=>H.input=Z.listen(q,X)),H.event}}}e.getDelayedChannel=O;function F(x){let q=!1;return{call(X,H,Z){return q?x.call(X,H,Z):(0,n.timeout)(0).then(()=>q=!0).then(()=>x.call(X,H,Z))},listen(X,H){if(q)return x.listen(X,H);const Z=new b.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>Z.input=x.listen(X,H)),Z.event}}}e.getNextTickChannel=F;class z{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const X of q.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=z;var k;(function(x){function q(ee,W){const N=ee,V=W&&W.disableMarshalling,$=new Map;for(const B in N)H(B)&&$.set(B,b.Event.buffer(N[B],!0));return new class{listen(B,te,se){const ce=$.get(te);if(ce)return ce;if(Z(te)){const he=N[te];if(typeof he=="function")return he.call(N,se)}throw new Error(`Event not found: ${te}`)}call(B,te,se){const ce=N[te];if(typeof ce=="function"){if(!V&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(N,se)}throw new Error(`Method not found: ${te}`)}}}x.fromService=q;function X(ee,W){const N=W&&W.disableMarshalling;return new Proxy({},{get(V,$){if(typeof $=="string")return W?.properties?.has($)?W.properties.get($):Z($)?function(B){return ee.listen($,B)}:H($)?ee.listen($):async function(...B){let te;W&&!(0,f.isUndefinedOrNull)(W.context)?te=[W.context,...B]:te=B;const se=await ee.call($,te);return N?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String($)}`)}})}x.toService=X;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&C.isUpperAsciiLetter(ee.charCodeAt(2))}function Z(ee){return/^onDynamic/.test(ee)&&C.isUpperAsciiLetter(ee.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let q=x.toString();if(q!=="[object Object]")return q}return x}function M(x){return Array.isArray(x)?x.map(j):j(x)}function G(x,q,X,H,Z,ee,W){W=M(W);const N=U[Z],V=N[H%N.length];let $=[`%c[${x}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(ee)?($=$.concat(W),$.push(")")):$.push(W),console.log.apply(console,$)}e.logWithColors=G;class K{constructor(q,X){this._outgoingPrefix=q,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,X,H,Z,ee){this._totalOutgoing+=q,G(this._outgoingPrefix,this._totalOutgoing,q,X,H,Z,ee)}logIncoming(q,X,H,Z,ee){this._totalIncoming+=q,G(this._incomingPrefix,this._totalIncoming,q,X,H,Z,ee)}}e.IPCLogger=K}),define(ne[117],ie([0,1,17,3,36]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class T extends L.IPCClient{constructor(b,E){const P=new A(b);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[73],ie([0,1,17,3,2,36]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function a(S,I){if(!o.has(S)){const _=String(++s);o.set(S,_)}return o.get(S)}function h(S,I,_,O){if(!t.enableDiagnostics)return;const F=a(S,I);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const z=D.VSBuffer.alloc(O.byteLength);z.set(O),t.records.push({timestamp:Date.now(),id:F,label:I,type:_,buff:z})}else t.records.push({timestamp:Date.now(),id:F,label:I,type:_,data:O})}t.traceSocketEvent=h})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const I=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),I}if(this._chunks[0].byteLength>o){const I=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),I}let a=D.VSBuffer.alloc(o),h=0,S=0;for(;o>0;){const I=this._chunks[S];if(I.byteLength>o){const _=I.slice(0,o);a.set(_,h),h+=o,s&&(this._chunks[S]=I.slice(o),this._totalLength-=o),o-=o}else a.set(I,h),h+=I.byteLength,s?(this._chunks.shift(),this._totalLength-=I.byteLength):S++,o-=I.byteLength}return a}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function y(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,s,a,h){this.type=o,this.id=s,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new p(a,h,S,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=w;class g extends A.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new g(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=v;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<c._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=s&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class i{constructor(o,s=null,a=c.getInstance()){this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onDidDispose=new v,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new p(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new p(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new p(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new p(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const S=Math.max(2e4-s,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,74,3,36,117]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends L.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return n.Event.map(b,E=>{const{port1:P,port2:C}=new MessageChannel,y={protocol:new A.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),y})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[119],ie([0,1,17,9]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,C)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),A(E,R),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{P({res:{statusCode:E.status,headers:T(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=L;function A(R,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,b.headers[E])}}}function T(R){const b=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");b[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return b}}),define(ne[75],ie([0,1,5,3,2,15]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function R(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends L.Disposable{constructor(f,y=Object.create(null)){super();this.database=f,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((y,u)=>this.accept(u,y)),f.deleted?.forEach(y=>this.accept(y,void 0))}accept(f,y){if(this.state===b.Closed)return;let u=!1;(0,A.isUndefinedOrNull)(y)?u=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const u=this.cache.get(f);return(0,A.isUndefinedOrNull)(u)?y:u}getBoolean(f,y){const u=this.get(f);return(0,A.isUndefinedOrNull)(u)?y:u==="true"}getNumber(f,y){const u=this.get(f);return(0,A.isUndefinedOrNull)(u)?y:parseInt(u,10)}async set(f,y){if(this.state===b.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(f);const u=String(y);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((y,u)=>this.items.set(u,y)),f.delete&&f.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[120],ie([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,120]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,A=L*24,T=A*7,R=A*30,b=A*365;function E(C,f,y){typeof C!="number"&&(C=C.getTime());const u=Math.round((new Date().getTime()-C)/1e3);if(u<-30)return(0,D.localize)(0,null,E(new Date().getTime()+u*1e3,!1));if(u<30)return(0,D.localize)(1,null);let p;return u<n?(p=u,f?p===1?y?(0,D.localize)(2,null,p):(0,D.localize)(3,null,p):y?(0,D.localize)(4,null,p):(0,D.localize)(5,null,p):p===1?y?(0,D.localize)(6,null,p):(0,D.localize)(7,null,p):y?(0,D.localize)(8,null,p):(0,D.localize)(9,null,p)):u<L?(p=Math.floor(u/n),f?p===1?y?(0,D.localize)(10,null,p):(0,D.localize)(11,null,p):y?(0,D.localize)(12,null,p):(0,D.localize)(13,null,p):p===1?y?(0,D.localize)(14,null,p):(0,D.localize)(15,null,p):y?(0,D.localize)(16,null,p):(0,D.localize)(17,null,p)):u<A?(p=Math.floor(u/L),f?p===1?y?(0,D.localize)(18,null,p):(0,D.localize)(19,null,p):y?(0,D.localize)(20,null,p):(0,D.localize)(21,null,p):p===1?y?(0,D.localize)(22,null,p):(0,D.localize)(23,null,p):y?(0,D.localize)(24,null,p):(0,D.localize)(25,null,p)):u<T?(p=Math.floor(u/A),f?p===1?(0,D.localize)(26,null,p):(0,D.localize)(27,null,p):p===1?(0,D.localize)(28,null,p):(0,D.localize)(29,null,p)):u<R?(p=Math.floor(u/T),f?p===1?y?(0,D.localize)(30,null,p):(0,D.localize)(31,null,p):y?(0,D.localize)(32,null,p):(0,D.localize)(33,null,p):p===1?y?(0,D.localize)(34,null,p):(0,D.localize)(35,null,p):y?(0,D.localize)(36,null,p):(0,D.localize)(37,null,p)):u<b?(p=Math.floor(u/R),f?p===1?y?(0,D.localize)(38,null,p):(0,D.localize)(39,null,p):y?(0,D.localize)(40,null,p):(0,D.localize)(41,null,p):p===1?y?(0,D.localize)(42,null,p):(0,D.localize)(43,null,p):y?(0,D.localize)(44,null,p):(0,D.localize)(45,null,p)):(p=Math.floor(u/b),f?p===1?y?(0,D.localize)(46,null,p):(0,D.localize)(47,null,p):y?(0,D.localize)(48,null,p):(0,D.localize)(49,null,p):p===1?y?(0,D.localize)(50,null,p):(0,D.localize)(51,null,p):y?(0,D.localize)(52,null,p):(0,D.localize)(53,null,p))}e.fromNow=E;function P(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[121],ie([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,P){return P&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,P=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],P);return C.length>1?L.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return A(C.error,P);if(C.exception)return A(C.exception,P)}return E.stack?A(E,P):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b}),define(ne[122],ie([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ne[76],ie([0,1,45,41,18,28,10,4,32,103,15,111,22,122]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(r,c){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function m(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(c,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=c,this.args=i,this.shell=t,this.options=o;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(a=>{s[a]=b.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(T.sep);return i!==-1&&(c=c.substring(i+1)),w.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let t,o;const s=new Promise((a,h)=>{t=a,o=h});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=D.exec(a,this.options,(h,S,I)=>{this.childProcess=null;const _=h;_&&_.killed?o({killed:this.terminateRequested,stdout:S.toString(),stderr:I.toString()}):this.handleExec(t,c,h,S,I)})}else{let a=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,t,c,o);const I={terminated:this.terminateRequested};P.isNumber(S)&&(I.cmdCode=S),t(I)};if(this.shell&&R.isWindows){const S=A.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let I=!1,_=!1;const O=[];let F=this.ensureQuotes(this.cmd);O.push(F.value),I=F.quoted,this.args&&this.args.forEach(k=>{F=this.ensureQuotes(k),O.push(F.value),_=_&&F.quoted});const z=["/s","/c"];I?_?z.push('"'+O.join(" ")+'"'):O.length>1?z.push('"'+O[0]+'" '+O.slice(1).join(" ")):z.push('"'+O[0]+'"'):z.push(O.join(" ")),a=D.spawn(m(),z,S)}else this.cmd&&(a=D.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",S=>{this.childProcess=null,o({terminated:this.terminateRequested,error:S})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,t,c,o,!0)))}return s})}handleClose(c,i,t,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,p(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const i=D.spawn(m(),["/s","/c"]);i.on("error",t=>c(!0)),i.on("exit",t=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(c,i,t,o){super(c,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,t,o,s){[o,s].forEach((a,h)=>{const S=new C.LineDecoder;S.write(a).forEach(O=>{i({line:O,source:h===0?0:1})});const _=S.end();_&&i({line:_,source:h===0?0:1})}),c({terminated:this.terminateRequested,error:t})}handleSpawn(c,i,t,o,s){const a=new C.LineDecoder,h=new C.LineDecoder;c.stdout.on("data",S=>{a.write(S).forEach(_=>t({line:_,source:0}))}),c.stderr.on("data",S=>{h.write(S).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(c,i,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=g;function v(r){let c=[],i=!1;const t=function(o){if(i){c.push(o);return}(!r.send(o,a=>{if(a&&console.error(a),i=!1,c.length>0){const h=c.slice(0);c=[],h.forEach(S=>t(S))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=v;var l;(function(r){async function c(i,t,o){if(T.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),T.dirname(i)!=="."||(o===void 0&&P.isString(b.env.PATH)&&(o=b.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(t,i);async function a(h){if(await f.Promises.exists(h)){let S;try{S=await f.Promises.stat(h)}catch(I){I.message.startsWith("EACCES")&&(S=await f.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(let h of o){let S;if(T.isAbsolute(h)?S=T.join(h,i):S=T.join(t,h,i),await a(S))return S;let I=S+".com";if(await a(I)||(I=S+".exe",await a(I)))return I}return T.join(t,i)}r.findExecutable=c})(l=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,33,4,72,76]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,u){return y===1?n.isWindows?C():A.getWindowsShell(u):E(y,u)}e.getSystemShell=T;function R(y,u){return y===1?n.isWindows?f(u):A.getWindowsShell(u):E(y,u)}e.getSystemShellSync=R;let b=null;function E(y,u){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!b){let p;if(n.isWindows)p="/bin/bash";else{if(p=u.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}b=p}return b}let P=null;async function C(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(y){if(P)return P;const u=n.isWindows&&parseFloat((0,D.release)())>=10,p=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${y.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?d:A.getWindowsShell(y)}}),define(ne[58],ie([0,1,45,5,17,23,107,9,3,2,28,76,36]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(d){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>L.VSBuffer.wrap(Buffer.from(m,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=y;class u{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const m=this;return{call(w,g,v){return m.requestPromise(d,w,g,v)},listen(w,g){return m.requestEvent(d,w,g)}}}requestPromise(d,m,w,g=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const v=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(i=>v.call(m,w,i)),r=g.onCancellationRequested(()=>l.cancel()),c=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(c),l.finally(()=>{r.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let g;const v=new b.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(d).listen(m,w)(v.fire,v),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return v.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,d,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const v=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&v.send(t.buffer.toString("base64")),r=w.event,c={send:l,onMessage:r};this._client=new f.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(ne[124],ie([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class A{constructor(R,b,E,P){this.version=R,this.appName=b,this.machineId=E,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let E of b)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=A}),define(ne[77],ie([0,1,57,54,18,10,32,19,7]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(p,d,m){this._args=p,this.paths=d,this.productService=m}get appRoot(){return(0,A.dirname)(L.FileAccess.asFileUri("",J).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=T.env.VSCODE_PORTABLE;return p?b.URI.file((0,A.join)(p,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,A.resolve)(p):(0,A.normalize)((0,A.join)(L.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,A.resolve)(p):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,A.resolve)(p);const d=T.env.VSCODE_EXTENSIONS;if(d)return d;const m=T.env.VSCODE_PORTABLE;return m?(0,A.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,A.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,A.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(u,p){return y(u["inspect-extensions"],u["inspect-brk-extensions"],5870,p,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=P;function C(u,p){return y(u["inspect-search"],u["inspect-brk-search"],5876,p,u.extensionEnvironment)}e.parseSearchPort=C;function f(u,p){return y(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,p,u.extensionEnvironment)}e.parsePtyHostPort=f;function y(u,p,d,m,w,g){const l=Number(p||u)||(m?null:d),r=l?Boolean(!!p):!1;let c;if(g)try{c=JSON.parse(g)}catch{}return{port:l,break:r,debugId:w,env:c}}}),define(ne[150],ie([0,1,252,4,126]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(u,p,d=T){const m={},w=[],g=[];for(let c in p){const i=p[c];i.alias&&(m[c]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(c),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(g.push(c),i.deprecates&&g.push(...i.deprecates))}const v=D(u,{string:w,boolean:g,alias:m}),l={},r=v;l._=v._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(let c in p){const i=p[c];i.alias&&delete r[i.alias];let t=r[c];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(t||(t=r[o],t&&d.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null))),delete r[o]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(c,t)),l[c]=t,i.deprecationMessage&&d.onDeprecatedOption(c,i.deprecationMessage)),delete r[c]}for(let c in r)d.onUnknownOption(c);return l}e.parseArgs=R;function b(u,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${u}${d}`:`--${u}${d}`}function E(u,p){let d=0,m=[];for(const l in u){const r=u[l],c=b(l,r);d=Math.max(d,c.length),m.push([c,r.description])}let w=d+2+1;if(p-w<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=p-w-1,v=[];for(const l of m){let r=l[0],c=C(l[1],g),i=P(w-r.length-2);v.push("  "+r+i+c[0]);for(let t=1;t<c.length;t++)v.push(P(w)+c[t])}return v}e.formatOptions=E;function P(u){return" ".repeat(u)}function C(u,p){let d=[];for(;u.length;){let m=u.length<p?u.length:u.lastIndexOf(" ",p),w=u.slice(0,m).trim();u=u.slice(m),d.push(w)}return d}function f(u,p,d,m,w){const g=process.stdout.isTTY&&process.stdout.columns||80,v=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${u} ${d}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${p} [${(0,L.localize)(36,null)}]${v}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,p)):l.push((0,L.localize)(38,null,p)),l.push(""));const r={};for(const c in m){const i=m[c];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[c]=i}}for(let c in r){const i=c;let t=r[i];t&&(l.push(A[i]),l.push(...E(t,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function y(u,p){return`${u||(0,L.localize)(39,null)}
${p||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),function(){"use strict";function J(e,D,n,L){function A(R){const b=T(R),E=[b];return e.isAbsolute(b)||E.unshift(L),e.resolve(...E)}function T(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:A}}if(typeof define=="function")define(ne[151],ie([0,152,33,18,19,32]),function(e,D,n,L,A,T){const R=A.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);return J(D,n,b.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=J(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[153],ie([0,1,33,77,151]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=A}),define(ne[154],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const m=d.match(T);return m?m[1]:null}function P(d){if(d.indexOf("://")===-1){const m=d.match(n);return m?E(m[2]):null}try{const m=D.URI.parse(d);if(m.authority)return E(m.authority)}catch{}return null}function C(d,m){const w=new Set;let g;for(;g=R.exec(d);){const l=P(g[1]);l&&w.add(l)}const v=new Set(m);return Array.from(w).map(l=>v.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const m=d.match(A);return m?m[2]:null}function y(d,m,w){return d&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${d}${m}`:`${d}/${m}`):null}function u(d,m){if(d.indexOf("://")===-1){const w=d.match(L);if(w)return y(w[2],w[3],m)}try{const w=D.URI.parse(d);if(w.authority)return y(f(w.authority),w.path,m)}catch{}return null}function p(d,m=!1){const w=[];let g;for(;g=R.exec(d);){const v=u(g[1],m);v&&w.push(v)}return w}e.getRemotes=p}),define(ne[155],ie([0,1,28]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(A,T){const R=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const P=T[E[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,D.cloneAndChange)(A,R)}e.localizeManifest=L}),define(ne[156],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[A,T,R,b])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(A){this.service=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[78],ie([0,1,135]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=A;function T(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=f.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=T;function R(f){if(!f)return null;let y=f.majorBase,u=f.majorMustEqual,p=f.minorBase,d=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(y===0||(d=!1),w=!1);let g=0;if(f.preRelease){const v=L.exec(f.preRelease);if(v){const[,l,r,c]=v;g=Date.UTC(Number(l),Number(r)-1,Number(c))}}return{majorBase:y,majorMustEqual:u,minorBase:p,minorMustEqual:d,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function b(f,y,u){let p;typeof f=="string"?p=R(T(f)):p=f;let d;y instanceof Date?d=y.getTime():typeof y=="string"&&(d=new Date(y).getTime());let m;if(typeof u=="string"?m=R(T(u)):m=u,!p||!m)return!1;let w=p.majorBase,g=p.minorBase,v=p.patchBase,l=m.majorBase,r=m.minorBase,c=m.patchBase,i=m.notBefore,t=m.majorMustEqual,o=m.minorMustEqual,s=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:g>r?!0:g<r||d&&d<i?!1:v>=c:(w===1&&l===0&&(!t||!o||!s)&&(l=1,r=0,c=0,t=!0,o=!1,s=!1),w<l?!1:w>l?!t:g<r?!1:g>r?!o:v<c?!1:v>c?!s:!(d&&d<i))}e.isValidVersion=b;function E(f,y,u,p){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,y,u.engines.vscode,p)}e.isValidExtensionVersion=E;function P(f,y,u){return f==="*"||C(y,u,f)}e.isEngineValid=P;function C(f,y,u,p=[]){let d=R(T(u));if(!d)return p.push(D.localize(0,null,u)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return p.push(D.localize(1,null,u)),!1}else if(!d.majorMustEqual)return p.push(D.localize(2,null,u)),!1;return b(f,y,d)?!0:(p.push(D.localize(3,null,f,u)),!1)}}),define(ne[51],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,A=[],T=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[79],ie([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(T,R,b){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],b)),n.push([T,R])}e.registerSingleton=L;function A(){return n}e.getSingletonServiceDescriptors=A}),define(ne[157],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),b),b.incoming.set(this._hashFn(A),R)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let R=this._nodes.get(T);return R||(R=new D(A),this._nodes.set(T,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,R]of this._nodes)A.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const R=new Set([A]),b=this._findCycle(T,R);if(b)return b}}_findCycle(A,T){for(let[R,b]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const E=this._findCycle(b,T);if(E)return E;T.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(T,R,b,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:T,index:b,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:T,index:b,optional:E}],R[D.DI_TARGET]=R)}function L(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const R=function(b,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,P,!1)};return R.toString=()=>T,D.serviceIds.set(T,R),R}e.createDecorator=L;function A(T){return T}e.refineServiceDecorator=A}),define(ne[158],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[20],ie([0,1,15,7,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=A;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,m){const w=Object.create(null);for(let g in d)P(w,g,d[g],m);return w}e.toValuesTree=E;function P(d,m,w,g){const v=m.split("."),l=v.pop();let r=d;for(let c=0;c<v.length;c++){let i=v[c],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${m} as ${v.slice(0,c+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{g(`Ignoring ${m} as ${v.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${m} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function C(d,m){const w=m.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,m){const w=m.shift();if(m.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const g=d[w];typeof g=="object"&&!Array.isArray(g)&&(f(g,m),Object.keys(g).length===0&&delete d[w])}}function y(d,m,w){function g(r,c){let i=r;for(const t of c){if(typeof i!="object"||i===null)return;i=i[t]}return i}const v=m.split("."),l=g(d,v);return typeof l=="undefined"?w:l}e.getConfigurationValue=y;function u(d,m,w){Object.keys(m).forEach(g=>{g!=="__proto__"&&(g in d?D.isObject(d[g])&&D.isObject(m[g])?u(d[g],m[g],w):w&&(d[g]=m[g]):d[g]=m[g])})}e.merge=u;function p(d,m,w){const g=d.inspect(m),v=d.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:g.defaultValue}e.getMigratedSettingValue=p}),define(ne[159],ie([0,1,4,27,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var b;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(k){return u.create(k)}static equals(k,U){return p.create(k,U)}static notEquals(k,U){return w.create(k,U)}static regex(k,U){return t.create(k,U)}static in(k,U){return d.create(k,U)}static not(k){return g.create(k)}static and(...k){return a.create(k,null)}static or(...k){return h.create(k,null,!0)}static greater(k,U){return l.create(k,U)}static greaterEquals(k,U){return r.create(k,U)}static smaller(k,U){return c.create(k,U)}static smallerEquals(k,U){return i.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){let j=k.split("||");return h.create(j.map(M=>this._deserializeAndExpression(M,U)),null,!0)}static _deserializeAndExpression(k,U){let j=k.split("&&");return a.create(j.map(M=>this._deserializeOne(M,U)),null)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){let j=k.split("!=");return w.create(j[0].trim(),this._deserializeValue(j[1],U))}if(k.indexOf("==")>=0){let j=k.split("==");return p.create(j[0].trim(),this._deserializeValue(j[1],U))}if(k.indexOf("=~")>=0){let j=k.split("=~");return t.create(j[0].trim(),this._deserializeRegexValue(j[1],U))}if(k.indexOf(" in ")>=0){let j=k.split(" in ");return d.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const j=k.split(">=");return r.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const j=k.split(">");return l.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const j=k.split("<=");return i.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const j=k.split("<");return c.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):u.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let j=/^'([^']*)'$/.exec(k);return j?j[1].trim():k}static _deserializeRegexValue(k,U){if((0,n.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=k.indexOf("/"),M=k.lastIndexOf("/");if(j===M||j<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let G=k.slice(j+1,M),K=k[M+1]==="i"?"i":"";try{return new RegExp(G,K)}catch(x){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${x}`);return console.warn(`bad regexp-value '${k}', parse error: ${x}`),null}}}e.ContextKeyExpr=E;function P(z,k){const U=z?z.substituteConstants():void 0,j=k?k.substituteConstants():void 0;return!U&&!j?!0:!U||!j?!1:U.equals(j)}e.expressionsAreEqualWithConstantSubstitution=P;function C(z,k){return z.cmp(k)}class f{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class y{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class u{constructor(k,U){this.key=k,this.negated=U,this.type=2}static create(k,U=null){const j=T.get(k);return typeof j=="boolean"?j?y.INSTANCE:f.INSTANCE:new u(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:I(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?y.INSTANCE:f.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class p{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=4}static create(k,U,j=null){if(typeof U=="boolean")return U?u.create(k,j):g.create(k,j);const M=T.get(k);return typeof M=="boolean"?U===(M?"true":"false")?y.INSTANCE:f.INSTANCE:new p(k,U,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?y.INSTANCE:f.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class d{constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}static create(k,U){return new d(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),j=k.getValue(this.key);return Array.isArray(U)?U.indexOf(j)>=0:typeof j=="string"&&typeof U=="object"&&U!==null?R.call(U,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=d;class m{constructor(k){this._actual=k,this.type=11}static create(k){return new m(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new m(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=5}static create(k,U,j=null){if(typeof U=="boolean")return U?g.create(k,j):u.create(k,j);const M=T.get(k);return typeof M=="boolean"?U===(M?"true":"false")?f.INSTANCE:y.INSTANCE:new w(k,U,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?f.INSTANCE:y.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(k,U){this.key=k,this.negated=U,this.type=3}static create(k,U=null){const j=T.get(k);return typeof j=="boolean"?j?f.INSTANCE:y.INSTANCE:new g(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:I(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?f.INSTANCE:y.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function v(z,k){if(typeof z=="string"){const U=parseFloat(z);isNaN(U)||(z=U)}return typeof z=="string"||typeof z=="number"?k(z):f.INSTANCE}class l{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=12}static create(k,U,j=null){return v(U,M=>new l(k,M,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=13}static create(k,U,j=null){return v(U,M=>new r(k,M,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class c{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=14}static create(k,U,j=null){return v(U,M=>new c(k,M,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=c;class i{constructor(k,U,j){this.key=k,this.value=U,this.negated=j,this.type=15}static create(k,U,j=null){return v(U,M=>new i(k,M,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}static create(k,U){return new t(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return U<j?-1:U>j?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return this.key===k.key&&U===j}return!1}substituteConstants(){return this}evaluate(k){let U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(k){this._actual=k,this.type=8}static create(k){return new o(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new o(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function s(z){let k=null;for(let U=0,j=z.length;U<j;U++){const M=z[U].substituteConstants();if(z[U]!==M&&k===null){k=[];for(let G=0;G<U;G++)k[G]=z[G]}k!==null&&(k[U]=M)}return k===null?z:k}class a{constructor(k,U){this.expr=k,this.negated=U,this.type=6}static create(k,U){return a._normalizeArr(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const M=C(this.expr[U],k.expr[U]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:a.create(k,this.negated)}evaluate(k){for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U){const j=[];let M=!1;for(const G of k)if(!!G){if(G.type===1){M=!0;continue}if(G.type===0)return f.INSTANCE;if(G.type===6){j.push(...G.expr);continue}j.push(G)}if(j.length===0&&M)return y.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(C);for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];for(;j.length>1;){const G=j[j.length-1];if(G.type!==9)break;j.pop();const K=j.pop(),x=j.length===0,q=h.create(G.expr.map(X=>a.create([X,K],null)),null,x);q&&(j.push(q),j.sort(C))}return j.length===1?j[0]:new a(j,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new a(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(let U of this.expr)k.push(U.negate());this.negated=h.create(k,this,!0)}return this.negated}}class h{constructor(k,U){this.expr=k,this.negated=U,this.type=9}static create(k,U,j){return h._normalizeArr(k,U,j)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const M=C(this.expr[U],k.expr[U]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:h.create(k,this.negated,!1)}evaluate(k){for(let U=0,j=this.expr.length;U<j;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,j){let M=[],G=!1;if(k){for(let K=0,x=k.length;K<x;K++){const q=k[K];if(!!q){if(q.type===0){G=!0;continue}if(q.type===1)return y.INSTANCE;if(q.type===9){M=M.concat(q.expr);continue}M.push(q)}}if(M.length===0&&G)return f.INSTANCE;M.sort(C)}if(M.length!==0){if(M.length===1)return M[0];for(let K=1;K<M.length;K++)M[K-1].equals(M[K])&&(M.splice(K,1),K--);if(M.length===1)return M[0];if(j){for(let K=0;K<M.length;K++)for(let x=K+1;x<M.length;x++)O(M[K],M[x])&&(M.splice(x,1),x--);if(M.length===1)return M[0]}return new h(M,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new h(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){let k=[];for(let U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),j=k.shift(),M=[];for(const K of F(U))for(const x of F(j))M.push(a.create([K,x],null));const G=k.length===0;k.unshift(h.create(M,null,G))}this.negated=k[0]}return this.negated}}class S extends u{constructor(k,U,j){super(k,null);this._defaultValue=U,typeof j=="object"?S._info.push({...j,key:k}):j!==!0&&S._info.push({key:k,description:j,type:U!=null?typeof U:void 0})}static all(){return S._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return p.create(this.key,k)}notEqualsTo(k){return w.create(this.key,k)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(z,k){return z<k?-1:z>k?1:0}function _(z,k,U,j){return z<U?-1:z>U?1:k<j?-1:k>j?1:0}function O(z,k){if(k.type===6&&z.type!==9&&z.type!==6){for(const M of k.expr)if(z.equals(M))return!0}const U=z.negate(),j=F(U).concat(F(k));j.sort(C);for(let M=0;M<j.length;M++){const K=j[M].negate();for(let x=M+1;x<j.length;x++){const q=j[x];if(K.equals(q))return!0}}return!1}e.implies=O;function F(z){return z.type===9?z.expr:[z]}}),define(ne[80],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[81],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[30],ie([0,1,18,130,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var A;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));function T(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function b(g,v){switch(g){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function E(g,v){return v==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function P(g,v,l){return E(v,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:C(l).includes(g)}e.isTargetPlatformCompatible=P;function C(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=f;var y;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var u;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var p;(function(g){g.Install="install",g.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(v,l){super(v);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(ne[160],ie([0,1,3,2,28,7,110,30]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(p,d){return A.URI.revive(d?d.transformIncoming(p):p)}function E(p,d){return d?d.transformOutgoingURI(p):p}function P(p,d){d=d||T.DefaultURITransformer;const m=p.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...p,manifest:void 0},d),manifest:m}}function C(p,d){return d?(0,L.cloneAndChange)(p,m=>m instanceof A.URI?d.transformOutgoingURI(m):void 0):p}class f{constructor(d,m){this.service=d,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,m){const w=this.getUriTransformer(d);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map(v=>({...v,local:v.local?C(v.local,w):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,m,w){const g=this.getUriTransformer(d);switch(m){case"zip":return this.service.zip(P(w[0],g)).then(v=>E(v,g));case"unzip":return this.service.unzip(b(w[0],g));case"install":return this.service.install(b(w[0],g),w[1]);case"getManifest":return this.service.getManifest(b(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(v=>v.map(l=>C(l,g)));case"updateMetadata":return this.service.updateMetadata(P(w[0],g),w[1]).then(v=>C(v,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],g),w[1]).then(v=>C(v,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class y extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?A.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?A.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(m=>A.URI.revive(m)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,m){return Promise.resolve(this.channel.call("install",[d,m])).then(w=>P(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.channel.call("installFromGallery",[d,m])).then(w=>P(w,null))}uninstall(d,m){return Promise.resolve(this.channel.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(m=>m.map(w=>P(w,null)))}updateMetadata(d,m){return Promise.resolve(this.channel.call("updateMetadata",[d,m])).then(w=>P(w,null))}updateExtensionScope(d,m){return Promise.resolve(this.channel.call("updateExtensionScope",[d,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class u{constructor(d){this.service=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(ne[82],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,39,10,27,15,7,137,6]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E(M){return M.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function p(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function d(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=d;function m(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(G,K){super(G);this.code=K}}e.FileSystemProviderError=g;function v(M,G){const K=new g(M.toString(),G);return r(K,G),K}e.createFileSystemProviderError=v;function l(M){return M||v((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(M,G){return M.name=G?`${G} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function c(M){if(!M)return w.Unknown;if(M instanceof g)return M.code;const G=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=c;function i(M){if(M instanceof S)return M.fileOperationResult;switch(c(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(G,K,x){this.resource=G,this.operation=K,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(G,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const q of G){const X=x.get(q.type);switch(X?X.push([q.resource,q]):x.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,X]of x)switch(q){case 1:this.added=D.TernarySearchTree.forUris(()=>K),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>K),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>K),this.deleted.fill(X);break}}contains(G,...K){return this.doContains(G,{includeChildren:!1},...K)}affects(G,...K){return this.doContains(G,{includeChildren:!0},...K)}doContains(G,K,...x){if(!G)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(G)||K.includeChildren&&this.added?.findSuperstr(G))||(!q||x.includes(0))&&(this.updated?.get(G)||K.includeChildren&&this.updated?.findSuperstr(G))||(!q||x.includes(2))&&(this.deleted?.findSubstr(G)||K.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function h(M,G,K){return!M||!G||M===G||G.length>M.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),K?(0,L.startsWithIgnoreCase)(M,G):M.indexOf(G)===0)}e.isParent=h;class S extends Error{constructor(G,K,x){super(G);this.fileOperationResult=K,this.options=x}}e.FileOperationError=S;class I extends S{constructor(G,K,x){super(G,2,x);this.stat=K}}e.NotModifiedSinceFileOperationError=I;var _;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=F;async function z(M,G){if(!G.hasProvider(T.URI.from({scheme:M.scheme})))return new Promise(K=>{const x=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&(x.dispose(),K())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class k{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<k.KB?(0,R.localize)(1,null,G.toFixed(0)):G<k.MB?(0,R.localize)(2,null,(G/k.KB).toFixed(2)):G<k.GB?(0,R.localize)(3,null,(G/k.MB).toFixed(2)):G<k.TB?(0,R.localize)(4,null,(G/k.GB).toFixed(2)):(0,R.localize)(5,null,(G/k.TB).toFixed(2))}}e.ByteSize=k,k.KB=1024,k.MB=k.KB*k.KB,k.GB=k.MB*k.KB,k.TB=k.GB*k.KB;var U;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function j(M){return{maxFileSize:M===0?300*k.MB:16*k.GB,maxHeapSize:M===0?700*k.MB:2*700*k.MB}}e.getPlatformLimits=j});var Y=this&&this.__param||function(J,e){return function(D,n){e(D,n,J)}};define(ne[161],ie([0,1,83,40,14]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((E,P)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>P(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};A=de([Y(0,L.IFileService)],A),e.ChecksumService=A}),define(ne[162],ie([0,1,253,127,150,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(f,y){const u={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,m)=>{console.warn((0,n.localize)(1,null,d,m))},onDeprecatedOption:(d,m)=>{console.warn((0,n.localize)(2,null,d,m))}},p=(0,L.parseArgs)(f,L.OPTIONS,y?u:void 0);return p.goto&&p._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),p["max-memory"]&&D(parseInt(p["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function R(f){const y=f.findIndex(u=>!/^-/.test(u));if(y>-1)return[...f.slice(0,y),...f.slice(y+1)]}function b(f){let[,...y]=f;process.env.VSCODE_DEV&&(y=R(y)||[]);const u=!C(process.env);return T(y,u)}e.parseMainProcessArgv=b;function E(f){const[,,...y]=f;return T(y,!0)}e.parseCLIProcessArgv=E;function P(f,...y){const u=f.indexOf("--");return u===-1?f.push(...y):f.splice(u,0,...y),f}e.addArg=P;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(ne[163],ie([0,1,45,10,128,23,37,9,4,29,123,162,5]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let u;async function p(m,w,g){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(g)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=f.Promises.withAsyncBody(async(v,l)=>{const r=new A.CancellationTokenSource,c=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},y);try{v(await d(m,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,T.toErrorMessage)(i)))):v({})}finally{clearTimeout(c),r.dispose()}})),u)}e.getResolvedShellEnv=p;async function d(m,w){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",v);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",c);const i=await(0,P.getSystemShell)(b.OS,c);return m.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,n.basename)(i);let a,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${S} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${S} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const I=(0,D.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});w.onCancellationRequested(()=>(I.kill(),o((0,R.canceled)()))),I.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(F)),o(F)});const _=[];I.stdout.on("data",F=>_.push(F));const O=[];I.stderr.on("data",F=>O.push(F)),I.on("close",(F,z)=>{const k=Buffer.concat(_).toString("utf8");m.trace("getUnixShellEnvironment#raw",k);const U=Buffer.concat(O).toString("utf8");if(U.trim()&&m.trace("getUnixShellEnvironment#stderr",U),F||z)return o(new Error((0,L.localize)(2,null,F,z)));const j=r.exec(k),M=j?j[1]:"{}";try{const G=JSON.parse(M);g?G.ELECTRON_RUN_AS_NODE=g:delete G.ELECTRON_RUN_AS_NODE,v?G.ELECTRON_NO_ATTACH_CONSOLE=v:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){m.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(G)),o(G)}})})}}),define(ne[164],ie([0,1,17,37,9,3,2,40,7,29,14]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(y,u){super();this.channel=y,this.extraCapabilities=u,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,u){const{buffer:p}=await this.channel.call("readFile",[y,u]);return p}readFileStream(y,u,p){const d=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(g=>D.VSBuffer.wrap(g))).buffer),m=this.channel.listen("readFileStream",[y,u])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let g=w;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),d.error(g),d.end()}m.dispose()}});return p.onCancellationRequested(()=>{d.error((0,L.canceled)()),d.end(),m.dispose()}),d}writeFile(y,u,p){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(u),p])}open(y,u){return this.channel.call("open",[y,u])}close(y){return this.channel.call("close",[y])}async read(y,u,p,d,m){const[w,g]=await this.channel.call("read",[y,u,m]);return p.set(w.buffer.slice(0,g),d),g}write(y,u,p,d,m){return this.channel.call("write",[y,u,D.VSBuffer.wrap(p),d,m])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,u){return this.channel.call("delete",[y,u])}rename(y,u,p){return this.channel.call("rename",[y,u,p])}copy(y,u,p){return this.channel.call("copy",[y,u,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const u=y;this._onDidChange.fire(u.map(p=>({resource:b.URI.revive(p.resource),type:p.type})))}else{const u=y;this._onDidWatchError.fire(u)}}))}watch(y,u){const p=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,p,y,u]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=C}),define(ne[84],ie([0,1,17,9,138,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,C,f,y,u,p){let d;try{await R(P,C,f,y,u,p)}catch(m){d=m}finally{d&&u.errorTransformer&&(d=u.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=T;async function R(P,C,f,y,u,p){b(p);const d=await P.open(C,{create:!1});try{b(p);let m=0,w=0,g=u&&typeof u.length=="number"?u.length:void 0,v=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,r=0;do w=await P.read(d,l,v.buffer,r,v.byteLength-r),l+=w,r+=w,m+=w,typeof g=="number"&&(g-=w),r===v.byteLength&&(await f.write(y(v)),v=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&b(p)&&E(m,u));if(r>0){let c=r;typeof g=="number"&&(c=Math.min(r,g)),f.write(y(v.slice(0,c)))}}catch(m){throw(0,A.ensureFileSystemProviderError)(m)}finally{await P.close(d)}}function b(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,C){if(C?.limits){if(typeof C.limits.memory=="number"&&P>C.limits.memory)throw(0,A.createFileSystemProviderError)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&P>C.limits.size)throw(0,A.createFileSystemProviderError)((0,L.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,7,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function T(y){return y.recursive===!0}e.isRecursiveWatchRequest=T;class R extends D.Disposable{constructor(u,p,d,m){super();this.onFileChanges=u,this.onLogMessage=p,this.verboseLogging=d,this.options=m,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new D.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),u.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),u.add(this.watcher.onDidError(p=>this.onError(p)))}onError(u){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(u,p,d){super(u,p,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends R{constructor(u,p,d){super(u,p,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(y){return y.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.toFileChanges=P;function C(y){const u=new f;for(const p of y)u.processEvent(p);return u.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const p=this.mapPathToChange.get(this.toKey(u));let d=!1;if(p){const m=p.type,w=u.type;p.path!==u.path&&(u.type===2||u.type===1)?d=!0:m===1&&w===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(p)):m===2&&w===1?p.type=0:m===1&&w===0||(p.type=w)}else d=!0;d&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],p=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,m)=>d.path.length-m.path.length).filter(d=>p.some(m=>(0,A.isParent)(d.path,m,!n.isLinux))?!1:(p.push(d.path),!0)).concat(u)}}}),define(ne[165],ie([0,1,50,5,23,41,109,2,71,10,4,114,22,52]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends R.Disposable{constructor(m,w,g,v){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=g,this.verboseLogging=v,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,T.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let w=m.path;try{w=await f.Promises.realpath(m.path),m.path===w&&(w=await(0,C.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(P.isMacintosh&&(0,A.isEqualOrParent)(m,"/Volumes/"))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new L.CancellationTokenSource(this.cts.token);let v=new R.DisposableStore;try{const l=(0,E.basename)(m),r=(0,D.watch)(m);v.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${m}'`);const c=new Set;if(w)try{for(const t of await f.Promises.readdir(m))c.add(t)}catch(t){this.error(t)}const i=new Map;v.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,o)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),r.on("change",(t,o)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),P.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===l&&!await f.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,E.join)(m,s));if(g.token.isCancellationRequested)return;let S;h?c.has(s)?S=0:(S=1,c.add(s)):(c.delete(s),S=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:S})},u.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(s)?a=0:(a=1,c.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:a})}else if(t==="rename"||s!==l){const a=setTimeout(async()=>{const h=await f.Promises.exists(m);g.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(m)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),v.dispose()})}async onFileChange(m,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!w&&this.excludes.some(g=>g(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,y.coalesceEvents)(g);if(v.length>0){if(this.verboseLogging)for(const r of v)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(v)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${v[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${v.length}, most recent change: ${v[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(P.isLinux)return f.Promises.exists(m);try{const w=(0,E.basename)(m);return(await f.Promises.readdir((0,E.dirname)(m))).some(v=>v===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function p(d,m,w,g,v=512){const l=await f.Promises.open(d,"r"),r=Buffer.allocUnsafe(v),c=new L.CancellationTokenSource(g);let i,t=!1;const o={path:d,excludes:[],recursive:!1},s=new u(o,a=>{(async()=>{for(const{type:h}of a)if(h===0){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:S}=await f.Promises.read(l,r,0,v,null);if(!S||c.token.isCancellationRequested)break;m(r.slice(0,S))}}catch(S){i=new Error(S),c.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((a,h)=>{c.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(S){i=new Error(S)}i?h(i):a()})})}e.watchFileContents=p}),define(ne[166],ie([0,1,16,3,2,4,165]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),C=P.filter(y=>{const u=this.watchers.get(y.path);return u?!(0,D.equals)(u.request.excludes,y.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:y})=>!P.find(u=>u.path===y.path&&(0,D.equals)(u.excludes,y.excludes))).map(({request:y})=>y.path);C.length&&this.trace(`Request to start watching: ${C.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const y of f)this.stopWatching(y);for(const y of C)this.startWatching(y)}startWatching(E){const P=new T.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:P};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const C of E){const f=A.isLinux?C.path:C.path.toLowerCase();P.set(f,C)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(ne[167],ie([0,1,52,166]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(T,R,b){super(T,R,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[168],ie([0,1,18,36,58,52]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(b,E,P){super(b,E,P);this.init()}createWatcher(b){const E=b.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:P,signal:C})=>this.onError(`terminated by itself with code ${P}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[85],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[A,T]of L)this.set(A,T)}set(L,A){const T=this._entries.get(L);return this._entries.set(L,A),T}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(ne[169],ie([0,1,5,9,51,157,6,85]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class P{constructor(u=new R.ServiceCollection,p=!1,d){this._activeInstantiations=new Set,this._services=u,this._strict=p,this._parent=d,this._services.set(T.IInstantiationService,this)}createChild(u){return new P(u,this._strict,this)}invokeFunction(u,...p){let d=f.traceInvocation(u),m=!1;try{return u({get:g=>{if(m)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(g,d);if(!v)throw new Error(`[invokeFunction] unknown service '${g}'`);return v}},...p)}finally{m=!0,d.stop()}}createInstance(u,...p){let d,m;return u instanceof L.SyncDescriptor?(d=f.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(p),d)):(d=f.traceCreation(u),m=this._createInstance(u,p,d)),d.stop(),m}_createInstance(u,p=[],d){let m=T._util.getServiceDependencies(u).sort((v,l)=>v.index-l.index),w=[];for(const v of m){let l=this._getOrCreateServiceInstance(v.id,d);if(!l&&this._strict&&!v.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${v.id}.`);w.push(l)}let g=m.length>0?m[0].index:p.length;if(p.length!==g){console.warn(`[createInstance] First service dependency of ${u.name} at position ${g+1} conflicts with ${p.length} static arguments`);let v=g-p.length;v>0?p=p.concat(new Array(v)):p=p.slice(0,g)}return new u(...[...p,...w])}_setServiceInstance(u,p){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,p);else if(this._parent)this._parent._setServiceInstance(u,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let p=this._services.get(u);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):p}_getOrCreateServiceInstance(u,p){let d=this._getServiceInstanceOrDescriptor(u);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,d,p.branch(u,!0)):(p.branch(u,!1),d)}_safeCreateAndCacheServiceInstance(u,p,d){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,p,d)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,p,d){const m=new A.Graph(v=>v.id.toString());let w=0;const g=[{id:u,desc:p,_trace:d}];for(;g.length;){const v=g.pop();if(m.lookupOrInsertNode(v),w++>1e3)throw new E(m);for(let l of T._util.getServiceDependencies(v.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),r instanceof L.SyncDescriptor){const c={id:l.id,desc:r,_trace:v._trace.branch(l.id,!0)};m.insertEdge(v,c),g.push(c)}}}for(;;){const v=m.roots();if(v.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:l}of v){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,c)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,p,d=[],m,w){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(p,d,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,p,d,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(u,p=[],d,m){if(d){const w=new D.IdleValue(()=>this._createInstance(u,p,m));return new Proxy(Object.create(null),{get(g,v){if(v in g)return g[v];let l=w.value,r=l[v];return typeof r!="function"||(r=r.bind(l),g[v]=r),r},set(g,v,l){return w.value[v]=l,!0}})}else return this._createInstance(u,p,m)}}e.InstantiationService=P;var C;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,p){this.type=u,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return b?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return b?new f(0,u.name):f._None}branch(u,p){let d=new f(2,u.toString());return this._dep.push([u,p,d]),d}stop(){let u=Date.now()-this._start;f._totals+=u;let p=!1;function d(w,g){let v=[],l=new Array(w+1).join("	");for(const[r,c,i]of g._dep)if(c&&i){p=!0,v.push(`${l}CREATES -> ${r}`);let t=d(w+1,i);t&&v.push(t)}else v.push(`${l}uses -> ${r}`);return v.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||p)&&console.log(m.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[170],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,A){this.server=L,this.router=A}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,A){this.server.registerChannel(L,A)}}e.MessagePortMainProcessService=D}),define(ne[171],ie([0,1,36,51,79,6]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(y,u,p){const d=p.getChannel(y);return R(u)?new u.channelClientCtor(d):D.ProxyChannel.toService(d,u?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let b=class extends T{constructor(y,u,p){super(y,u,p)}};b=de([Y(2,e.IMainProcessService)],b);function E(f,y,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(b,[y,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let P=class extends T{constructor(y,u,p){super(y,u,p)}};P=de([Y(2,e.ISharedProcessService)],P);function C(f,y,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(P,[y,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(ne[59],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const A of L.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[172],ie([0,1,2,59]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ne[8],ie([0,1,37,3,2,4,6]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(c,i,t){switch(i){case b.Trace:c.trace(t);break;case b.Debug:c.debug(t);break;case b.Info:c.info(t);break;case b.Warning:c.warn(t);break;case b.Error:c.error(t);break;case b.Critical:c.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function P(c){let i="";for(let t=0;t<c.length;t++){let o=c[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(t>0?" ":"")+o}return i}e.format=P;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,P(o))}else this.log(b.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class y extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class u extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class p extends C{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class m extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends L.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=g;function v(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const i=l(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function l(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[173],ie([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.environmentService.logsPath),f=(0,A.dirname)(this.environmentService.logsPath),p=(await T.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==C),d=p.slice(0,Math.max(0,p.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(m=>T.Promises.rm((0,A.join)(f,m)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=de([Y(0,R.IEnvironmentService),Y(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(ne[174],ie([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(C,f,y){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(C).emptyWorkspaceInfos.map(p=>p.backupFolder),u=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async p=>{p.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||p===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(p)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p}.`),await T.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([Y(1,R.INativeEnvironmentService),Y(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(ne[175],ie([0,1,45,5,37,3,2,18,10,22,13,8]),function(J,e,D,n,L,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(u,p){super();this.environmentService=u,this.logService=p,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const p=this.parseScript(u,"uninstall");return p&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(u,p){const d=`vscode:${p}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[d]=="string"){const m=u.manifest.scripts[d].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,p,d,m,w){return new Promise((g,v)=>{const l=this.start(u,p,d,w);let r;const c=i=>{r&&(clearTimeout(r),r=null),i?v(i):g(void 0)};l.on("error",i=>{c((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{c(i?`post-${p} process exited with code ${i}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),v("timed out")},5e3))})}start(u,p,d,m){const w={silent:!0,execArgv:void 0},g=(0,D.fork)(u,[`--type=extension-post-${p}`,...d],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(g.stdout,"data"),l=A.Event.fromNodeEventEmitter(g.stderr,"data");v(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${p}`,i)),l(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${p}`,i));const r=A.Event.any(A.Event.map(v,i=>({data:`%c${i}`,format:[""]})),A.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(u){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=de([Y(0,P.IEnvironmentService),Y(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[176],ie([0,1,16,5,9,3,2,10,52,8]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(f,y){super();this.logService=f,this.options=y,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,y):this.watchNonRecursive(f,y)}watchUniversal(f,y){const u={path:this.toFilePath(f),excludes:y.excludes,recursive:y.recursive},p=(0,D.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,b.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&f.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,y){const u={path:this.toFilePath(f),excludes:y.excludes,recursive:!1},p=(0,D.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[177],ie([0,1,16,5,17,23,3,70,55,2,39,18,178,19,40,136,14,84,8]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const c=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),c.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new d.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&c.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),c.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(c)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(c){r.push(c)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const c=this.provider.get(l.scheme);return!!(c&&c.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,y.isAbsolutePath)(l))throw new d.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const c=new Error;throw c.name="ENOPRO",c.message=(0,p.localize)(1,null,l.toString()),c}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(c){throw(0,d.toFileSystemProviderErrorCode)(c)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(c)}}async doResolveFile(l,r){const c=await this.withProvider(l),i=this.isPathCaseSensitive(c),t=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,a=await c.stat(l);let h;return this.toFileStat(c,l,a,void 0,!!s,(S,I)=>(h||(h=P.TernarySearchTree.forUris(()=>!i),h.set(l,!0),t&&h.fill(!0,t)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?I===1:!1))}async toFileStat(l,r,c,i,t,o){const{providerExtUri:s}=this.getExtUri(l),a={resource:r,name:s.basename(r),isFile:(c.type&d.FileType.File)!=0,isDirectory:(c.type&d.FileType.Directory)!=0,isSymbolicLink:(c.type&d.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:c.mtime,size:c.size})};if(a.isDirectory&&o(a,i)){try{const h=await l.readdir(r),S=await n.Promises.settled(h.map(async([I,_])=>{try{const O=s.joinPath(r,I),F=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,F,h.length,t,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(c){return c}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(l,c);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,i)),i}async writeFile(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,c)||await this.mkdirp(i,t.dirname(l));let s;if((0,d.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,u.isReadableStream)(r)){const a=await(0,u.peekStream)(r,3);a.ended?s=L.VSBuffer.concat(a.buffer):s=a}else s=(0,u.peekReadable)(r,a=>L.VSBuffer.concat(a),3);else s=r;!(0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,c,s):await this.doWriteBuffered(i,l,c,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s)}catch(o){throw new d.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),c)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,c){if(!!c?.unlock&&!(l.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,c);if(this.throwIfFileIsReadonly(r,t),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&c.mtime<t.mtime&&c.etag!==(0,d.etag)({mtime:c.mtime,size:t.size}))throw new d.FileOperationError((0,p.localize)(7,null),3,c);return t}async readFile(l,r,c){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,c):this.doReadFile(i,l,r,c)}async doReadFileAtomic(l,r,c,i){return new Promise((t,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,c,i);t(s)}catch(s){o(s)}})})}async doReadFile(l,r,c,i){const t=await this.doReadFileStream(l,r,{...c,preferUnbuffered:!0},i);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,r,c){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,c)}async doReadFileStream(l,r,c,i){const t=new A.CancellationTokenSource(i),o=this.validateReadFile(r,c).then(a=>a,a=>{throw t.cancel(),a});let s;try{return typeof c?.etag=="string"&&c.etag!==d.ETAG_DISABLED&&await o,c?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&c?.preferUnbuffered?s=this.readFileUnbuffered(l,r,c):(0,d.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,t.token,c):s=this.readFileBuffered(l,r,t.token,c),{...await o,value:s}}catch(a){s&&await(0,u.consumeStream)(s);const h=(0,p.localize)(8,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(a).toString());throw a instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,a.stat,c):new d.FileOperationError(h,(0,d.toFileOperationResult)(a),c)}}readFileStreamed(l,r,c,i=Object.create(null)){const t=l.readFileStream(r,i,c);return(0,u.transform)(t,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new d.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,r,c,i=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,m.readFileIntoStream)(l,r,t,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new d.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},c),t}readFileUnbuffered(l,r,c){const i=(0,u.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;c?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof c?.position=="number"&&(t=t.slice(c.position)),typeof c?.length=="number"&&(t=t.slice(0,c.length)),this.validateReadFileLimits(r,t.byteLength,c),i.end(L.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const c=await this.resolve(l,{resolveMetadata:!0});if(c.isDirectory)throw new d.FileOperationError((0,p.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===c.etag)throw new d.NotModifiedSinceFileOperationError((0,p.localize)(12,null),c,r);return this.validateReadFileLimits(l,c.size,r),c}validateReadFileLimits(l,r,c){if(c?.limits){let i;if(typeof c.limits.memory=="number"&&r>c.limits.memory&&(i=9),typeof c.limits.size=="number"&&r>c.limits.size&&(i=7),typeof i=="number")throw new d.FileOperationError((0,p.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,c){return this.doCanMoveCopy(l,r,"move",c)}async canCopy(l,r,c){return this.doCanMoveCopy(l,r,"copy",c)}async doCanMoveCopy(l,r,c,i){if(l.toString()!==r.toString())try{const t=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,o,r,c,i)}catch(t){return t}return!0}async move(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"move",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,r,c){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"copy",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,r,c,i,t,o){if(r.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,r,c,i,t,o);if(s&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(i)),t==="copy"){if(l===c&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const h=await this.resolve(r);h.isDirectory?await this.doCopyFolder(l,h,c,i):await this.doCopyFile(l,r,c,i)}return t}else return l===c?(await l.rename(r,i,{overwrite:o}),t):(await this.doMoveCopy(l,r,c,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,c,i){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(l,r,c,i);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(l,r,c,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(l,r,c,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(c))return this.doPipeUnbuffered(l,r,c,i)}async doCopyFolder(l,r,c,i){await c.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const o=this.getExtUri(c).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),c,o):this.doCopyFile(l,t.resource,c,o)}))}async doValidateMoveCopy(l,r,c,i,t,o){let s=!1;if(l===c){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(l);if(S||(s=h.isEqual(r,i)),s&&t==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&h.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!o)throw new d.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===c){const{providerExtUri:h}=this.getExtUri(l);if(h.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,c)),c}async mkdirp(l,r){const c=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&d.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;c.push(i.basename(r)),r=i.dirname(r)}for(let t=c.length-1;t>=0;t--){r=i.joinPath(r,c[t]);try{await l.mkdir(r)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(c){return c}return!0}async doValidateDelete(l,r){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(c.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(l)));let t;try{t=await c.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,p.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(l)))}return c}async del(l,r){const c=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await c.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const c=new E.DisposableStore;let i=!1,t=()=>{i=!0};return c.add((0,E.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,E.dispose)(o):t=()=>(0,E.dispose)(o)}catch(o){this.logService.error(o)}})(),c}async doWatch(l,r){const c=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:c.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:c?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,c){let i=0,t;if((0,u.isReadableBufferedStream)(c)){if(c.buffer.length>0){const o=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(c.ended)return;t=c.stream}else t=c;return new Promise((o,s)=>{(0,u.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(l,r,a,a.byteLength,i,0)}catch(h){return s(h)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,c){let i=0,t;for(;(t=c.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,c,i,t,o){let s=0;for(;s<i;)s+=await l.write(r,t+s,c.buffer,o+s,i-s)}async doWriteUnbuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,c,i))}async doWriteUnbufferedQueued(l,r,c,i){let t;i instanceof L.VSBuffer?t=i:(0,u.isReadableStream)(i)?t=await(0,L.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?t=await(0,L.bufferedStreamToBuffer)(i):t=(0,L.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,c,i))}async doPipeBufferedQueued(l,r,c,i){let t,o;try{t=await l.open(r,{create:!1}),o=await c.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,S=0;do S=await l.read(t,a,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(c,o,s,S,a,h),a+=S,h+=S,h===s.byteLength&&(h=0);while(S>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof o=="number"?c.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,c,i))}async doPipeUnbufferedQueued(l,r,c,i){return c.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,c,i))}async doPipeUnbufferedToBufferedQueued(l,r,c,i){const t=await c.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(c,t,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await c.close(t)}}async doPipeBufferedToUnbuffered(l,r,c,i){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,A.CancellationToken.None));await this.doWriteUnbuffered(c,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new d.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,p.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};g=de([Y(0,w.ILogService)],g),e.FileService=g}),define(ne[179],ie([0,1,50,254,5,39,17,3,41,2,10,4,19,40,22,139,14,84,176,37,168,167]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(c){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(c)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(i,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let o;return t?.dangling?o=d.FileType.Unknown:i.isFile()?o=d.FileType.File:i.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),o.open()})}async readFile(i,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,t,o){const s=(0,y.newWriteableStream)(a=>T.VSBuffer.concat(a.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,m.readFileIntoStream)(this,i,s,a=>a.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(i,t,o){let s;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(a)){if(!o.overwrite)throw(0,d.createFileSystemProviderError)((0,p.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.createFileSystemProviderError)((0,p.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){let o;(0,d.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let s;try{const a=this.toFilePath(i);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:S}=await u.SymlinkSupport.stat(a);S.mode&128||await u.Promises.chmod(a,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await u.Promises.truncate(a,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";s=await u.Promises.open(a,h)}catch(a){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}return this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(s,i),o&&this.mapHandleToLock.set(s,o),s}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await u.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,o,s,a){const h=this.normalizePos(i,t);let S=null;try{const{bytesRead:I}=await u.Promises.read(i,o,s,a,h);return I}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,h,S)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,t,o,s,a){return(0,L.retry)(()=>this.doWrite(i,t,o,s,a),100,3)}async doWrite(i,t,o,s,a){const h=this.normalizePos(i,t);let S=null;try{const{bytesWritten:I}=await u.Promises.write(i,o,s,a,h);return I}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,h,S)}}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const o=this.toFilePath(i);t.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"move",o.overwrite),await u.Promises.move(s,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"copy",o.overwrite),await u.Promises.copy(s,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,o,s){const a=this.toFilePath(i),h=this.toFilePath(t);let S=!1;if(!!(this.capabilities&1024)||(S=(0,b.isEqual)(a,h,!0)),S&&o==="copy")throw(0,d.createFileSystemProviderError)((0,p.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!S&&await u.Promises.exists(h)){if(!s)throw(0,d.createFileSystemProviderError)((0,p.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,o){return new v.UniversalWatcherClient(s=>i(s),s=>t(s),o)}createNonRecursiveWatcher(i,t,o){return new l.NodeJSWatcherClient(s=>i(s),s=>t(s),o)}toFileSystemProviderError(i){if(i instanceof d.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let o=this.toFileSystemProviderError(t);if(i&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(ne[86],ie([0,1,3,7,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(f,y,u){switch(y){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class T{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){T.setLevel(this.channel,f)}static setLevel(f,y){return f.call("setLevel",y)}}e.LogLevelChannelClient=T;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,y){throw new Error(`Event not found: ${y}`)}async call(f,y,u){switch(y){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${y}`)}createLogger(f,y){this.loggers.set(f.toString(),this.loggerService.createLogger(f,y))}consoleLog(f,y){let u=console.log;switch(f){case L.LogLevel.Error:u=console.error;break;case L.LogLevel.Warning:u=console.warn;break;case L.LogLevel.Info:u=console.info;break}u.call(console,...y)}log(f,y){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[p,d]of y)(0,L.log)(u,p,d)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,y,u){super(f,y);this.channel=u}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,y)=>{this.channel.call("consoleLog",[f,y])}})}doCreateLogger(f,y,u){return new E(this.channel,f,y,u)}}e.LoggerChannelClient=b;class E extends L.AbstractMessageLogger{constructor(f,y,u,p){super(p?.always);this.channel=f,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[y,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,y){const u=[[f,y]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,y){super(y);this.parent=f,this._register(f.onDidChangeLogLevel(u=>y.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[87],ie([0,1,18,4,32,19]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,A.dirname)(D.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,A.joinPath)(R,"product.json").fsPath);const b=J.__$__nodeRequire((0,A.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:b.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ne[26],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[180],ie([0,1,5,9,2,10,22,8,26]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(C,f,y){super();this.productService=f,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),y=(0,A.dirname)(C),u=(0,A.basename)(C),p=await T.Promises.readdir(y);await Promise.all(p.map(async d=>{if(d===u)return;const m=(0,A.join)(y,d),w=await T.Promises.stat(m);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),T.Promises.rm(m)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([Y(1,b.IProductService),Y(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[181],ie([0,1,5,9,2,10,22,13,8,26]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,y,u){super();this.environmentService=f,this.logService=y,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),y=JSON.parse(await T.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(y)){const g=y[w];f[`${g.hash}.${w}`]=!0}const u=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(u))return;const d=await T.Promises.readdir(u);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,A.join)(u,w))}const m=Date.now();for(const w of Object.keys(f)){const g=(0,A.join)(u,w),v=await T.Promises.readdir(g);for(const l of v){if(l==="tcf.json")continue;const r=(0,A.join)(g,l),c=await T.Promises.stat(r);c.isDirectory()&&m-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(w,l)}`),await T.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};P=de([Y(0,R.INativeEnvironmentService),Y(1,b.ILogService),Y(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[182],ie([0,1,10,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(A){function T(R,b="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return R}A.rewriteAbsolutePaths=T})(L=e.Utils||(e.Utils={}))}),define(ne[183],ie([0,1,29]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((E,P)=>{J(["v8-inspect-profiler"],E,P)})).startProfiling({port:A.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(A){const T=this._sessions.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,99,15]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(T,R){D.ok(n.isString(T)),D.ok(n.isObject(R)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new L}),define(ne[88],ie([0,1,3,38]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[L(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[42],ie([0,1,16,3,15,125,88,38]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const c=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const c=[];c.push(...this.doDeregisterConfigurations(r)),c.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(c)})}registerDefaultConfigurations(l){const r=[],c=[];for(const{overrides:i,source:t}of l)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const a={type:"object",default:s,description:A.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(t)?void 0:t};c.push(...u(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:c,source:i}of l)for(const t in c){const o=this.configurationDefaultsOverrides.get(t),s=L.isString(i)?i:i?.id,a=L.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const c=[];return l.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(l){const r=[],c=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>c(t))};for(const i of l){c(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,c,i,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let o=[],s=l.properties;if(s)for(let h in s){if(r&&w(h)){delete s[h];continue}const S=s[h];if(S.source=c,S.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,S),e.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=L.isUndefinedOrNull(S.scope)?t:S.scope,S.restricted=L.isUndefinedOrNull(S.restricted)?!!i?.includes(h):S.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),o.push(h)}let a=l.allOf;if(a)for(let h of a)o.push(...this.validateAndRegisterProperties(h,r,c,i,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=c=>{let i=c.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let t=c.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,c={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,c),e.allSettings.properties[r]=c,e.applicationSettings.properties[r]=c,e.machineSettings.properties[r]=c,e.machineOverridableSettings.properties[r]=c,e.windowSettings.properties[r]=c,e.resourceSettings.properties[r]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const c=this.configurationDefaultsOverrides.get(l);let i=c?.value,t=c?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),L.isUndefined(i)&&(i=d(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(v){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let r=y.exec(v);for(;r?.length;){const c=r[1].trim();c&&l.push(c),r=y.exec(v)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=u;function p(v){return v.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=p;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new C;R.Registry.add(e.Extensions.Configuration,m);function w(v){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?A.localize(7,null,v):m.getConfigurationProperties()[v]!==void 0?A.localize(8,null,v):null:A.localize(6,null)}e.validateProperty=w;function g(){const v=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))v.push([r,l[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=g}),define(ne[89],ie([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},t=[],o=[]){this._contents=i,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const o=this.getContentsForOverrideIdentifer(t);return o?i?(0,P.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const o of this.overrides)o.identifiers.includes(i)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const h of a.overrides){const[S]=o.filter(I=>D.equals(I.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):o.push(R.deepClone(h))}for(const h of a.keys)s.indexOf(h)===-1&&s.push(h)}return new y(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s],h=t[s];h&&(typeof a=="object"&&typeof h=="object"?(a=R.deepClone(a),this.mergeContents(a,h)):a=h),o[s]=a}return new y(o,this.keys,this.overrides)}mergeContents(i,t){for(const o of Object.keys(t)){if(o in i&&b.isObject(i[o])&&b.isObject(t[o])){this.mergeContents(i[o],t[o]);continue}i[o]=R.deepClone(t[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=R.deepClone(a))};for(const a of this.overrides)D.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let o=0;o<t;o++)i.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class u extends y{constructor(i={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),a=[];for(const h in t){const S=i[h],I=S!==void 0?S:t[h].default;(0,P.addToValueTree)(s,h,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const h of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(h)&&a.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,P.toValuesTree)(s[h],S=>console.error(`Conflict in default settings file: ${S}`))});super(s,o,a)}}e.DefaultConfigurationModel=u;class p{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:o,keys:s,overrides:a,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new y(o,s,a),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},o=null,s=[],a=[],h=[];function S(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let I={onObjectBegin:()=>{let _={};S(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];S(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:S,onError:(_,O,F)=>{h.push({error:_,offset:O,length:F})}};if(i)try{L.visit(i,I),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const o=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,t);i=s.raw;const a=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),h=Object.keys(i),S=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:a,keys:h,overrides:S,restricted:s.restricted}}filter(i,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},h=[];for(let S in i)if(C.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const I=this.filter(i[S],t,!1,s);a[S]=I.raw,h.push(...I.restricted)}else{const I=t[S],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&h.push(S),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&I?.restricted||(a[S]=i[S]))}return{raw:a,restricted:h}}toOverrides(i,t){const o=[];for(const s of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const h in i[s])a[h]=i[s][h];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,t)})}return o}}e.ConfigurationModelParser=p;class d extends A.Disposable{constructor(i,t,o,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class m{constructor(i,t,o=new y,s=new y,a=new T.ResourceMap,h=new y,S=new T.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(i)}updateValue(i,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new y,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,o){const s=this.getConsolidateConfigurationModel(t,o),a=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,S=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),F=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,z=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,k=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),U=s.getValue(i),j=D.distinct(D.flatten(s.overrides.map(M=>M.identifiers))).filter(M=>s.getOverrideValue(i,M)!==void 0);return{defaultValue:S,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:F,workspaceFolderValue:z,memoryValue:k,value:U,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:k!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const o=[];if(!t){const{added:s,updated:a,removed:h}=l(this._defaultConfiguration,i);t=[...s,...a,...h]}for(const s of t)for(const a of(0,C.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),S=i.getKeysForOverrideIdentifier(a),I=[...S.filter(_=>h.indexOf(_)===-1),...h.filter(_=>S.indexOf(_)===-1),...h.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),i.override(a).getValue(_)))];o.push([a,I])}return this.updateDefaultConfiguration(i),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.localUserConfiguration,i),h=[...t,...o,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.remoteUserConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.workspaceConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const o=this.folderConfigurations.get(i),{added:s,updated:a,removed:h,overrides:S}=l(o,t);let I=[...s,...a,...h];return(I.length||!o)&&this.updateFolderConfiguration(i,t),{keys:I,overrides:S}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:a,overrides:h}=l(t,void 0);return{keys:[...o,...s,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let o=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=o}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const o=t.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:o,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((h,S)=>(h.set(E.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new T.ResourceMap);return new m(t,o,new y,s,a,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,t=new Map;for(const s of c)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,h])=>{const S=(0,T.getOrSet)(t,a,new Set);h.forEach(I=>S.add(I))});const o=[];return t.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class g{constructor(i,t,o,s){this.change=i,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(S=>a.add(S)),i.overrides.forEach(([,S])=>S.forEach(I=>a.add(I))),this.affectedKeys=[...a.values()];const h=new y;this.affectedKeys.forEach(S=>h.setValue(S,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let o=(0,P.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=g;class v extends g{constructor(i,t,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=v;function l(c,i){const{added:t,removed:o,updated:s}=r(i,c),a=[],h=c?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const I=S.filter(_=>!h.includes(_));for(const _ of I)a.push([_,i.getKeysForOverrideIdentifier(_)])}if(c){const I=h.filter(_=>!S.includes(_));for(const _ of I)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(i&&c){for(const I of h)if(S.includes(I)){const _=r({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});a.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:a}}function r(c,i){const t=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],o=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const h=(0,P.getConfigurationValue)(i.contents,a),S=(0,P.getConfigurationValue)(c.contents,a);R.equals(h,S)||s.push(a)}}return{added:t,removed:o,updated:s}}}),define(ne[184],ie([0,1,5,3,2,19,20,89,42,38]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,y){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,y)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,y){const u=typeof f=="string"?f:void 0,p=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(u,p,void 0)}updateValue(f,y,u,p){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const y=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,y,1)}onDidDefaultConfigurationChange(f){const y=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(u,y,6)}trigger(f,y,u){const p=new R.ConfigurationChangeEvent(f,{data:y},this.configuration);p.source=u,p.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[185],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(T,R=n.Unknown,b){super(T);this._message=T,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(T){return T instanceof L&&T._code===n.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof L&&T._code===n.NoResolverFound}static isHandled(T){return T instanceof L&&T.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[186],ie([0,1,5,17,23,9,3,2,29,73,185]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function y(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(H){const Z=new L.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function p(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.CancellationTokenSource;return H.onCancellationRequested(()=>ee.cancel()),Z.onCancellationRequested(()=>ee.cancel()),ee.token}class d{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((ee,W)=>{this._resolvePromise=ee,this._rejectPromise=W}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function m(H,Z){const ee=new d(Z);return ee.registerDisposable(H.onControlMessage(W=>{const N=JSON.parse(W.toString()),V=G(N);V?ee.reject(V):ee.resolve(N)})),ee.promise}function w(H,Z,ee,W,N,V,$){const B=new d($);return Z.connect(ee,W,N,V,(te,se)=>{B.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?B.reject(te):B.resolve(se)}),B.promise}function g(H,Z){const ee=new d(Z);return H.then(W=>{ee.didTimeout||ee.resolve(W)},W=>{ee.didTimeout||ee.reject(W)}),ee.promise}async function v(H,Z,ee,W){const N=q(H,Z);H.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${y(Z)}-${H.reconnectionToken}`,W)}catch(ce){throw H.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let $,B;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(V,null),$=H.reconnectionProtocol,B=!1):($=new E.PersistentProtocol(V,null),B=!0),H.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const te=await g(H.signService.createNewMessage((0,b.generateUuid)()),W),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};$.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await m($,p(W,u(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(H.logService.trace(`${N} 4/6. received SignRequest control message.`),!await g(H.signService.validate(te,ce.signedData),W)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const ve=await g(H.signService.sign(ce.data),W),pe={type:"connectionType",commit:H.commit,signedData:ve,desiredConnectionType:Z};return ee&&(pe.args=ee),H.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:$,ownsProtocol:B}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${N} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${N} received error control message when negotiating connection. Error:`),H.logService.error(ce)),B&&M($),ce}}async function l(H,Z,ee,W){const N=Date.now(),V=q(H,Z),{protocol:$,ownsProtocol:B}=await v(H,Z,ee,W),te=new d(W);return te.registerDisposable($.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(H.logService.error(`${V} received error control message when negotiating connection. Error:`),H.logService.error(he),B&&M($),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(N)}!`),te.resolve({protocol:$,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:ee}=await l(H,1,void 0,Z);return{protocol:ee}}async function c(H,Z,ee){const{protocol:W,firstMessage:N}=await l(H,2,Z,ee),V=N&&N.debugPort;return{protocol:W,debugPort:V}}async function i(H,Z,ee){const W=Date.now(),N=q(H,3),{protocol:V}=await v(H,3,Z,ee);return H.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${X(W)}!`),V}async function t(H,Z,ee){const{host:W,port:N,connectionToken:V}=await H.addressProvider.getAddress();return{commit:H.commit,host:W,port:N,connectionToken:V,reconnectionToken:Z,reconnectionProtocol:ee,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function o(H,Z,ee){try{const W=(0,b.generateUuid)(),N=await t(H,W,null),{protocol:V}=await r(N,L.CancellationToken.None);return new U(H,Z,ee,W,V)}catch(W){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(W),k.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=o;async function s(H,Z){try{const ee=(0,b.generateUuid)(),W=await t(H,ee,null),{protocol:N,debugPort:V}=await c(W,Z,L.CancellationToken.None);return new j(H,Z,ee,N,V)}catch(ee){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(ee),k.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(ee)),ee}}e.connectRemoteAgentExtensionHost=s;async function a(H,Z,ee){const W=await t(H,(0,b.generateUuid)(),null);return await i(W,{host:Z,port:ee},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function h(H){return(0,D.createCancelablePromise)(Z=>new Promise((ee,W)=>{const N=setTimeout(ee,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(N),ee()})}))}var S;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(S=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,ee){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(Z,ee,W,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.durationSeconds=W,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=O;class F{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=4}}e.ConnectionGainEvent=F;class z{constructor(Z,ee,W,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=z;class k extends R.Disposable{constructor(Z,ee,W,N){super();this._connectionType=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=ee,this.reconnectionToken=W,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(N.onSocketClose(V=>{const $=x(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),k._instances.push(this),k._permanentFailure&&this._gotoPermanentFailure(k._permanentFailureMillisSinceLastIncomingData,k._permanentFailureAttempt,k._permanentFailureHandled)}static triggerPermanentFailure(Z,ee,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=ee,this._permanentFailureHandled=W,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(k._permanentFailure)return;const Z=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const N=W<ee.length?ee[W]:ee[ee.length-1];try{if(N>0){const $=h(N);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,$)),this._options.logService.info(`${Z} waiting for ${N} seconds before reconnecting...`);try{await $}catch{}}if(k._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${Z} resolving connection...`);const V=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,u(C)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,A.isCancellationError)(V)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,P.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!k._permanentFailure)}_gotoPermanentFailure(Z,ee,W){this._onDidStateChange.fire(new z(this.reconnectionToken,Z,ee,W)),M(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=k,k._permanentFailure=!1,k._permanentFailureMillisSinceLastIncomingData=0,k._permanentFailureAttempt=0,k._permanentFailureHandled=!1,k._instances=[];class U extends k{constructor(Z,ee,W,N,V){super(1,Z,N,V);this.client=this._register(new E.Client(V,{remoteAuthority:ee,clientId:W},Z.ipcLogger))}async _reconnect(Z,ee){await r(Z,ee)}}e.ManagementPersistentConnection=U;class j extends k{constructor(Z,ee,W,N,V){super(2,Z,W,N);this._startArguments=ee,this.debugPort=V}async _reconnect(Z,ee){await c(Z,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=j;function M(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,A.onUnexpectedError)(Z)}}function G(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function K(H,Z){for(;H.length<Z;)H+=" ";return H}function x(H,Z,ee){return`[remote-connection][${K(y(H),13)}][${Z.substr(0,5)}\u2026][${ee?"reconnect":"initial"}]`}function q(H,Z){return`${x(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function X(H){return`${Date.now()-H} ms`}}),define(ne[187],ie([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const P=E.indexOf("+");return P<0?E:E.substr(0,P)}e.getRemoteName=L;function A(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=A;function T(E){if(E.folders.length)return E.folders.every(P=>A(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&A(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=T;function R(E){return T(E)?.scheme}e.getVirtualWorkspaceScheme=R;function b(E){return T(E)!==void 0}e.isVirtualWorkspace=b}),define(ne[90],ie([0,1,27,6,187]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=A;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,u){if(typeof y=="undefined"||y===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof y=="string"||typeof u=="string"){let p=typeof y=="string"?y:y.value,d=typeof u=="string"?u:u.value;return D.equalsIgnoreCase(p,d)}return y._lower===u._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function C(f,y){if(y){const u=`onResolveRemoteAuthority:${(0,L.getRemoteName)(y)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,27,90]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,p){return u.uuid&&p.uuid?u.uuid===p.uuid:u.id===p.id?!0:(0,D.compareIgnoreCase)(u.id,p.id)===0}e.areSameExtensions=L;class A{constructor(p,d){this.version=d,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof A?L(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(u,p){return`${u}.${p}`}e.getExtensionId=T;function R(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(u,p){return R(T(u,p))}e.getGalleryExtensionId=b;function E(u,p){const d=[],m=w=>{for(const g of d)if(g.some(v=>L(p(v),p(w))))return g;return null};for(const w of u){const g=m(w);g?g.push(w):d.push([w])}return d}e.groupByExtension=E;function P(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(u){const p=new Set;if(u.malicious)for(const d of u.malicious)p.add(d.id);return p}e.getMaliciousExtensionsSet=f;function y(u,p){const d=[],m=p.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&d.every(g=>!L(g.identifier,{id:w}))){const g=u.filter(v=>L(v.identifier,{id:w}));g.length===1&&(d.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=y}),define(ne[188],ie([0,1,23,31]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(A,T,R,b,E){try{const P=await A.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const C=await A.getInstalled(1);for(const[f,{id:y,migrateStorage:u}]of Object.entries(P.unsupportedPreReleaseExtensions)){const p=C.find(m=>(0,n.areSameExtensions)(m.identifier,{id:f}));if(!p)continue;const d=(await T.getExtensions([{id:y,preRelease:!0}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${y}' extension is not found`);continue}try{E.info(`Migrating '${p.identifier.id}' extension to '${y}' extension...`);const m=!b.getDisabledExtensions().some(g=>(0,n.areSameExtensions)(g,p.identifier));await A.uninstall(p),E.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let w=C.find(g=>(0,n.areSameExtensions)(g.identifier,{id:y}));(!w||!w.isPreReleaseVersion&&m)&&(w=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),m||(await b.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),u&&(R.addToMigrationList((0,n.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${p.identifier.id}' extension to '${y}' extension.`)}catch(m){E.error(m)}}}catch(P){E.error(P)}}e.migrateUnsupportedExtensions=L}),define(ne[189],ie([0,1,5,9,2,4,19,61,7,29,22,13,30,31,14,8]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends L.Disposable{constructor(g,v,l,r){super();this.fileService=v,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,v){await this.cleanUpPromise;const l=this.getName(g),r=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const c=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(g,c,v);try{await this.rename(c,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(c)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,c.path),i}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,v,l){try{await P.Promises.rename(g.fsPath,v.fsPath)}catch(r){if(A.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${v} with 'EPERM' error. Trying again...`),this.rename(g,v,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const v=[],l=[];for(const i of g.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,y.groupByExtension)(l,([i])=>i),c=[];for(const i of r)i.sort((t,o)=>R.rcompare(t[0].version,o[0].version)),v.push(...i.slice(1).map(t=>t[1].resource)),c.push(i[0][1]);c.sort((i,t)=>i.mtime-t.mtime),v.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(v.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new y.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(g){const v=d.exec(g);return v&&v[1]&&v[2]?new y.ExtensionIdentifierWithVersion({id:v[1]},v[2]):null}};m=de([Y(0,C.INativeEnvironmentService),Y(1,u.IFileService),Y(2,f.IExtensionGalleryService),Y(3,p.ILogService)],m),e.ExtensionsDownloader=m}),define(ne[190],ie([0,1,2,10,22,90]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[191],ie([0,1,83,16,5,2,18,10,22,13,30,31,59,8]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends A.Disposable{constructor(m,w,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new p(w,g)),this.extensionManagementService.registerParticipant({postInstall:async v=>this.postInstallExtension(v),postUninstall:async v=>this.postUninstallExtension(v)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,n.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(v=>(0,C.areSameExtensions)(v.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,n.equals)(Object.keys(m),Object.keys(g))}};u=de([Y(0,P.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,y.ILogService)],u),e.LocalizationsService=u;let p=class extends A.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,w){const g=w.identifier,v=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of v)if(w.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let c=r.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,g))[0];c?c.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(m){if(m){const w=(0,D.createHash)("md5");for(const g of m.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=m(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const v=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",v),b.Promises.writeFile(this.languagePacksFilePath,v)}).then(()=>w,g=>this.logService.error(g))})}};p=de([Y(0,E.INativeEnvironmentService),Y(1,y.ILogService)],p)}),define(ne[192],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,8]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var T;(function(u){u.Http="http",u.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function f(u,p){return p?p!==1&&u<1024:!n.isWindows&&u<1024}e.isPortPrivileged=f;let y=class{constructor(p){this.logService=p,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],d=Array.from(this._tunnels.values());for(let m of d){const w=Array.from(m.values());for(let g of w){const v=await g.value;v&&p.push(v)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(m=>m?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,m,w,g=!1,v=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${w}.`),!p)return;d||(d="localhost");const r=this.retainOrCreateTunnel(p,d,m,w,g,v,l);return r?r.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const m=d.get(p.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,m))}}}}async tryDisposeTunnel(p,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const w=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),w}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${d} `);const m=this._tunnels.get(p);if(m&&m.has(d)){const w=m.get(d);w.refcount=0,await this.tryDisposeTunnel(p,d,w)}}addTunnelToMap(p,d,m){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(p,d){const m=this._tunnels.get(p);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let m=[p];P(p)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(p)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(g=>this._tunnels.get(g));for(const g of w){const v=g?.get(d);if(v)return v}}canTunnel(p){return!!E(p)}createWithProvider(p,d,m,w,g,v,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${w}.`);const c={elevationRequired:g?f(w===void 0?m:w):!1},i={remoteAddress:{host:d,port:m},localAddressPort:w,privacy:v,public:v!==R.Private,protocol:l},t=p.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,m,t),t}};y=de([Y(0,A.ILogService)],y),e.AbstractTunnelService=y}),define(ne[193],ie([0,1,8,62,2,9,5]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class Ct extends L.Disposable{constructor(P,C){super();this._tunnelService=P,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,C,f,y,u,p){const d=new R,m=await Promise.resolve(this._tunnelService.openTunnel(P,d,f,y,u,p));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${y} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await m.dispose(),(0,A.canceled)();return d.setTunnel(m),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${m.localAddress} (local) to ${f}:${y} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,C){const f=this._tunnels.get(P);!f||f.setAddress(C)}async destroyTunnel(P){const C=this._tunnels.get(P);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await C.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(ne[194],ie([0,1,119,20,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,b)}async resolveProxy(R){}};A=de([Y(0,n.IConfigurationService),Y(1,L.ILogService)],A),e.RequestService=A}),define(ne[43],ie([0,1,17,140,42,6,38]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=R;function b(u){return u.res.statusCode===204}async function E(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);return b(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=E;async function P(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);if(b(u))return null;const d=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(d)}catch(m){throw m.message+=`:
`+d,m}}e.asJson=P;function C(u){y(u)}e.updateProxyConfigurationsScope=C;let f;function y(u){const p=T.Registry.as(L.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[f],remove:d?[d]:[]})}y(2)}),define(ne[195],ie([0,1,23,18,14,43]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,P=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,P);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const y=await(0,A.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${y}`)}}};T=de([Y(0,A.IRequestService),Y(1,L.IFileService)],T),e.DownloadService=T}),define(ne[196],ie([0,1,16,23,67,2,19,154,14,8,26,43]),function(J,e,D,n,L,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends A.Disposable{constructor(u,p,d,m){super();this.fileService=u,this.productService=p,this.requestService=d,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const p=[];for(const[d,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==u.scheme))try{const w=await this.fileService.readFile((0,T.joinPath)(u,d)),g=new Map;(0,L.forEach)(m.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const c of r.remotes)g.set(c,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else p.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const v=(0,R.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const l of v){const r=g.get(l);r&&p.push(r)}}catch{}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(u.res.statusCode!==200)return[];const p=await(0,C.asJson)(u);return p?p.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=de([Y(0,b.IFileService),Y(1,P.IProductService),Y(2,C.IRequestService),Y(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,17,29]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,T,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await T.readFile(A.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(ne[91],ie([0,1,70,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[197],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[198],ie([0,1,74,152,5,23,3,2,18,4,29,13,8,26,91,197]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let d=class{constructor(g,v,l){this.logService=g,this.productService=v,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const l=(0,u.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(g));const r=new A.CancellationTokenSource;let c,i,t;this.processeDisposables.set(l,h=>{r.dispose(!0),c?.terminate(g,A.CancellationToken.None),i?.close(),t?.close(),this.processeDisposables.delete(l);const S=this.processResolvers.get(l);S&&(this.processResolvers.delete(l),S({reason:h}))}),c=await this.getOrCreateWebWorker(g);const o=new Promise(h=>{this.processResolvers.set(l,h)});if(r.token.isCancellationRequested)return o;const{port1:s,port2:a}=new MessageChannel;return i=s,t=a,await c.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[i])),o}getOrCreateWebWorker(g){let v=this.workers.get(g.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new m(g.process.type,this.logService,this.productService,this.environmentService);v=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:c})=>{this.doDisposeWorker(r,c)}),this.workers.set(g.process.moduleId,v)}return v}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,v){const l=this.processeDisposables.get((0,u.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(v))}};d=de([Y(0,f.ILogService),Y(1,y.IProductService),Y(2,C.INativeEnvironmentService)],d),e.SharedProcessWorkerService=d;class m extends R.Disposable{constructor(g,v,l,r){super();this.type=g,this.logService=v,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new L.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},v.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},v.onmessage=l=>{const{id:r,message:c,configuration:i,nonce:t}=l.data;switch(r){case p.SharedProcessWorkerMessages.Ready:g.complete(v);break;case p.SharedProcessWorkerMessages.Ack:if(t){const o=this.mapMessageNonceToPendingMessageResolve.get(t);o&&(this.mapMessageNonceToPendingMessageResolve.delete(t),o())}break;case p.SharedProcessWorkerMessages.SelfTerminated:i&&c&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(c)});break;case p.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case p.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case p.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case p.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,v,l){const r=await this.workerReady;if(!v.isCancellationRequested)return new Promise(c=>{const i=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(i,c);const t={...g,nonce:i};l?r.postMessage(t,[l]):r.postMessage(t),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(i)&&c()})})}spawn(g,v,l){const r={id:p.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,v)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(E.isLinux){const v={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,P.isUUID)(l)){const t=r["linux-x64"];v.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),v.uploadToServer=!0}const i=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(i,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(v)}return g}terminate(g,v){const l={id:p.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,v)}}}),define(ne[199],ie([0,1,54,18,153]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(ne[92],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[200],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,A)=>J(["vsda"],L,A))}async createNewMessage(L){try{const A=await this.vsda(),T=new A.validator;if(T){const R=String(D._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const T=this.validators.get(L.id);if(!T)return!1;this.validators.delete(L.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(L){try{const A=await this.vsda(),T=new A.signer;if(T)return T.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(ne[24],ie([0,1,5,3,2,178,15,75,6]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class y extends L.Disposable{constructor(m={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===E?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,g){return this.getStorage(w)?.get(m,g)}getBoolean(m,w,g){return this.getStorage(w)?.getBoolean(m,g)}getNumber(m,w,g){return this.getStorage(w)?.getNumber(m,g)}store(m,w,g,v){if((0,T.isUndefinedOrNull)(w)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,v),this.getStorage(g)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const g=[],v=this.getKeyTargets(m);for(const l of Object.keys(v))v[l]===w&&g.push(l);return g}updateKeyTarget(m,w,g){const v=this.getKeyTargets(w);typeof g=="number"?v[m]!==g&&(v[m]=g,this.getStorage(w)?.set(E,JSON.stringify(v))):typeof v[m]=="number"&&(delete v[m],this.getStorage(w)?.set(E,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(E,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),g=this.getStorage(1);switch(m){case P.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return p(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends y{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=u;async function p(d,m,w,g){const v=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,r=new Map;d.forEach((s,a)=>{l.set(a,s),r.set(a,v(s))});const c=new Map,i=new Map;m.forEach((s,a)=>{c.set(a,s),i.set(a,v(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((s,a)=>{t.push({key:a,value:s})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let o=[];c.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=p}),define(ne[201],ie([0,1,3,2,15,30,31,24]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(f.onDidInstallExtensions(y=>y.forEach(({local:u,operation:p})=>{u&&p===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(y=>!(0,T.areSameExtensions)(y,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let y=0;y<f.length;y++){const u=f[y];if((0,T.areSameExtensions)(u,C))return f.splice(y,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=de([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let y;return f===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),y=this.storage[C]):y=this._get(C,f),JSON.parse(y)}set(C,f,y){let u=JSON.stringify(f.map(({id:d,uuid:m})=>({id:d,uuid:m})));this._get(C,y)!==u&&(y===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,y))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const y=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),p=y.filter(m=>!u.some(w=>(0,T.areSameExtensions)(m,w))),d=u.filter(m=>!y.some(w=>(0,T.areSameExtensions)(w,m)));(p.length||d.length)&&this._onDidChange.fire([...p,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,y){f?this.storageService.store(C,f,y,1):this.storageService.remove(C,y)}}e.StorageManager=E}),define(ne[63],ie([0,1,6,3,2,24,31,26,16,8,15]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(u,p,d){super();this.storageService=u,this.productService=p,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(u){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(u.id)}@${u.version}`}static fromKey(u){const p=C.exec(u);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const u=this.storageService.keys(0,1);for(const p of u){const d=nt.fromKey(p);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(u){if(u.scope!==0)return;if(this.extensionsWithKeysForSync.has(u.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const p=nt.fromKey(u.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(u){if((0,P.isString)(u))return u;const p=u.manifest?u.manifest.publisher:u.publisher,d=u.manifest?u.manifest.name:u.name;return(0,T.getExtensionId)(p,d)}getExtensionState(u,p){const d=this.getExtensionId(u),m=this.storageService.get(d,p?0:1);if(m)try{return JSON.parse(m)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${p}): ${w}`)}}setExtensionState(u,p,d){const m=this.getExtensionId(u);p===void 0?this.storageService.remove(m,d?0:1):this.storageService.store(m,JSON.stringify(p),d?0:1,1)}setKeysForSync(u,p){this.storageService.store(nt.toKey(u),JSON.stringify(p),0,1)}getKeysForSync(u){const p=this.productService.extensionSyncedKeys?.[u.id.toLowerCase()],d=this.storageService.get(nt.toKey(u),0),m=d?JSON.parse(d):void 0;return m&&p?(0,b.distinct)([...m,...p]):m||p}addToMigrationList(u,p){if(u!==p){const d=this.migrationList.filter(m=>!m.includes(u)&&!m.includes(p));d.push([u,p]),this.migrationList=d}}getSourceExtensionToMigrate(u){const p=this.migrationList.find(([,d])=>u===d);return p?p[0]:void 0}get migrationList(){const u=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const p=JSON.parse(u);if((0,P.isArray)(p))return p}catch{}return[]}set migrationList(u){u.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(u),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(ne[202],ie([0,1,2,30,63,188,8]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,P,C,f,y){super();E.removeDeprecatedExtensions(),(0,A.migrateUnsupportedExtensions)(E,P,C,f,y)}};R=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,L.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,T.ILogService)],R),e.ExtensionsCleaner=R}),define(ne[203],ie([0,1,3,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class A extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class T extends L{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[204],ie([0,1,5,2,19,75,24,203]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(P,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new A.Storage(P.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(P){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(C.workspaceStorage){const f=new A.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[y,u]of f)this.workspaceStorage.set(y,u)}}e.NativeStorageService=b}),define(ne[205],ie([0,1,4,32,7,29]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,P,C,f,y,u,p,d,m,w){const g=Object.create(null);g["common.machineId"]=p,g.sessionID=(0,A.generateUuid)()+Date.now(),g.commitHash=y,g.version=u,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=n.platform,g["common.nodeArch"]=f,g["common.product"]=w||"desktop";const v=b(d||[]);v&&(g["common.msftInternal"]=v);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const c=T(C);c&&(g["common.platformDetail"]=c);try{const i=await E.readFile(L.URI.file(m));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function b(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const C=P.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(ne[21],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[206],ie([0,1,33,55,5,35,18,10,4,7,113,22,116,80,14,26,21]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,c){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const o=D.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(o+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"/onedrive")||O.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(o+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(o+"/owncloud/")}];break}const s=new Map,a=new Map,h=2e4;function S(O,F,z,k){for(const j of t){const M=O.toLowerCase();j.matcher(M)&&a.set(j.tag,1)}const U=F.substring(O.length+1);return L.Promises.withAsyncBody(async j=>{let M;try{M=await C.Promises.readdir(F,{withFileTypes:!0})}catch{j();return}if(k.count>=h){k.count+=M.length,k.maxReached=!0,j();return}let G=M.length;if(G===0){j();return}let K=M;k.count+M.length>h&&(k.maxReached=!0,G=h-k.count,K=M.slice(0,G)),k.count+=M.length;for(const x of K)if(x.isDirectory()){if(z.includes(x.name)||await S(O,(0,R.join)(F,x.name),z,k),--G==0){j();return}}else{const q=x.name.lastIndexOf(".");if(q>=0){const X=x.name.substring(q+1);X&&s.set(X,(s.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(U)!==!1&&X.filePattern.test(x.name)&&a.set(X.tag,(a.get(X.tag)??0)+1);if(--G==0){j();return}}})}const I={count:0,maxReached:!1};await S(r,r,c,I);const _=await v(r);return{configFiles:w(a),fileTypes:w(s),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=m;function w(r){return[...n.Iterable.map(r.entries(),([c,i])=>({name:c,count:i}))].sort((c,i)=>i.count-c.count)}function g(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},c=D.cpus();return c&&c.length>0&&(r.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),r}e.getMachineInfo=g;async function v(r){try{const c=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(i),o=[],s=(0,A.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,A.getNodeType)(s)==="object"&&s.configurations)for(const a of s.configurations){const h=a.type;h&&(c.has(h)?c.set(h,c.get(h)+1):c.set(h,1))}return w(c)}catch{return[]}}e.collectLaunchConfigs=v;let l=class{constructor(c,i){this.telemetryService=c,this.productService=i}formatMachineInfo(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}formatEnvironment(c){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,f.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async t=>{let[o,s]=t,a=this.formatProcessList(c,o);return i.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))a+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(a+=`

Remote: ${h.hostName}`,h.processes&&(a+=`
${this.formatProcessList(c,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const S of Object.keys(h.workspaceMetadata)){const I=h.workspaceMetadata[S];let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${S}): ${_}`,s+=this.formatWorkspaceStats(I)}}}),{processInfo:a,workspaceInfo:s}})}async getSystemInfo(c,i){const{memory:t,vmHint:o,os:s,cpus:a}=g(),h={os:s,memory:t,cpus:a,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(h.load=`${D.loadavg().map(S=>Math.round(S)).join(", ")}`),b.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(c,i){const t=[];return(0,f.listProcesses)(c.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(c)),t.push(""),t.push(this.formatProcessList(c,o)),c.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(c))),i.forEach(s=>{if((0,y.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(c,s.processes)),s.workspaceMetadata)for(const a of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[a];let S=`${h.fileCount} files`;h.maxFilesReached&&(S=`more than ${S}`),t.push(`Folder (${a}): ${S}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(c){const i=[],t=60;let o=0;const s=(I,_)=>{const O=` ${I}(${_})`;o+O.length>t?(i.push(a),a="|                 ",o=a.length):o+=O.length,a+=O};let a="|      File types:";const h=10;let S=c.fileTypes.length>h?h:c.fileTypes.length;for(let I=0;I<S;I++){const _=c.fileTypes[I];s(_.name,_.count)}if(i.push(a),c.configFiles.length>=0&&(a="|      Conf files:",o=0,c.configFiles.forEach(I=>{s(I.name,I.count)}),i.push(a)),c.launchConfigFiles.length>0){let I="|      Launch Configs:";c.launchConfigFiles.forEach(_=>{I+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(c){const i=Math.max(...Object.keys(c).map(t=>t.length));return Object.keys(c).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${c[t]}`).join(`
                  `)}formatWorkspaceMetadata(c){const i=[],t=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const a=E.URI.revive(s);if(a.scheme===T.Schemas.file){const h=a.fsPath;t.push(m(h,["node_modules",".git"]).then(S=>{let I=`${S.fileCount} files`;S.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(h)}): ${I}`),i.push(this.formatWorkspaceStats(S))}).catch(S=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${S.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(c,i){const t=new Map;c.windows.forEach(s=>t.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(c.mainPID,t,o,i,0),o.join(`
`)}formatProcessItem(c,i,t,o,s){const a=s===0;let h;a?h=o.pid===c?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(h=`${h} (${i.get(o.pid)})`));const S=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(I=>this.formatProcessItem(c,i,t,I,s+1))}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const t=E.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const o=t.fsPath;try{const s=await m(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),s.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),s.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),s.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};l=de([Y(0,d.ITelemetryService),Y(1,p.IProductService)],l),e.DiagnosticsService=l}),define(ne[207],ie([0,1,16,5,23,9,3,2,4,15,7,129,30,31,8,26,21]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(c,i,t,o){super();this.galleryService=c,this.telemetryService=i,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const i=await this.getTargetPlatform();return c.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,c.allTargetPlatforms,i))}async installFromGallery(c,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(c,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw v(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(c),void 0,t),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(t),g(t)}}async uninstall(c,i={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,i)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const i=await this.findGalleryExtension(c);if(!i)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,i,t){if(!P.URI.isUri(i)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(S)return this.logService.info("Extensions is already requested to install",i.identifier.id),S.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(c,i,t);P.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:i}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:c});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(h=h||!!O.extensionDependencies?.some(F=>(0,y.areSameExtensions)({id:F},a.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const F=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(F.identifier,O.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:_}),this.logService.info("Installing extension:",F.identifier.id),o.push({task:F,manifest:O})}}catch(I){if(P.URI.isUri(a.source))(0,D.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,I.message),(0,D.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),I}const S=o.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;S.size;){let I;const _=[...S.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(F=>S.has(F.toLowerCase())));_.length?I=S.size===1?_:_.filter(({task:O})=>!(O===a&&!h)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...S.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const F=new Date().getTime(),z=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const k=await O.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(k,O.source,t,L.CancellationToken.None))),!P.URI.isUri(O.source)&&(v(this.telemetryService,z===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,void 0),b.isWeb&&z!==3))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch{}s.push({local:k,identifier:O.identifier,operation:z,source:O.source})}catch(k){throw P.URI.isUri(O.source)||v(this.telemetryService,z===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,k),this.logService.error("Error while installing the extension:",O.identifier.id),k}finally{S.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:I})=>(0,y.areSameExtensions)(I,a.identifier))[0].local}catch(S){if(o.forEach(({task:I})=>I.cancel()),s.length)try{const I=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:F}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,A.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(I),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),S}finally{for(const{task:S,manifest:I}of o)if(!P.URI.isUri(S.source)){const _=new y.ExtensionIdentifierWithVersion(S.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const i=[],t=[],o=await Promise.allSettled(c);for(const s of o)s.status==="fulfilled"?i.push(s.value):t.push(s.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(c,i,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[c,...s.map(I=>I.identifier)],h=[],S=async(I,_)=>{const O=_.extensionDependencies||[],F=[...O];if(_.extensionPack){const z=t?s.find(k=>(0,y.areSameExtensions)(k.identifier,I)):void 0;for(const k of _.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(U=>(0,y.areSameExtensions)({id:U},{id:k}))||F.every(U=>!(0,y.areSameExtensions)({id:U},{id:k}))&&F.push(k)}if(F.length){const z=[...a,...h.map(U=>U.gallery.identifier)],k=F.filter(U=>z.every(j=>!(0,y.areSameExtensions)(j,{id:U})));if(k.length){const U=await this.galleryService.query({names:k,pageSize:F.length},L.CancellationToken.None);for(const j of U.firstPage){if(z.find(K=>(0,y.areSameExtensions)(K,j.identifier)))continue;const M=O.some(K=>(0,y.areSameExtensions)({id:K},j.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(j,!0,o)}catch(K){if(K instanceof f.ExtensionManagementError&&K.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!M){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw K}h.push({gallery:G.extension,manifest:G.manifest}),await S(G.extension.identifier,_)}}}};return await S(c,i),s=await this.getInstalled(),h.filter(I=>!s.some(_=>(0,y.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(c,i,t){const o=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(o).has(c.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,c.identifier.id,o.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const h=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(h)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(c,i,t);if(s){if(t&&c.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(C.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(C.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(c,i,t){const o=await this.getTargetPlatform();let s=null;return i&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...c.identifier,preRelease:t}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(c,t,o)&&(s=c),!s&&i&&(s=await this.galleryService.getCompatibleExtension(c,t,o)),s}async unininstallExtension(c,i){const t=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),t.waitUntilTaskIsFinished();const o=(S,I)=>{const _=this.createUninstallExtensionTask(S,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),_},s=(S,I)=>{I?this.logService.error("Failed to uninstall extension:",S.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,I),this._onDidUninstallExtension.fire({identifier:S.identifier,error:I?.code})},a=[],h=[];try{a.push(o(c,{}));const S=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(c,S);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(I=>I.extension),S,c),await this.joinAllSettled(a.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,i,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}s(I.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,A.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(I.extension,O),O}finally{h.push(I)}}))}catch(S){const I=S instanceof f.ExtensionManagementError?S:new f.ExtensionManagementError((0,A.getErrorMessage)(S),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}h.includes(_)||s(_.extension,I)}throw I}finally{for(const S of a)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(c,i,t){for(const o of c){const s=this.getDependents(o,i);if(s.length){const a=s.filter(h=>!c.some(S=>(0,y.areSameExtensions)(S.identifier,h.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,t))}}}getDependentsErrorMessage(c,i,t){return t===c?i.length===1?C.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(11,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?C.localize(12,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(13,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(14,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(c,i,t=[]){if(t.indexOf(c)!==-1)return[];t.push(c);const o=c.manifest.extensionPack?c.manifest.extensionPack:[];if(o.length){const s=i.filter(h=>!h.isBuiltin&&o.some(S=>(0,y.areSameExtensions)({id:S},h.identifier))),a=[];for(const h of s)a.push(...this.getAllPackExtensionsToUninstall(h,i,t));return[...s,...a]}return[]}getDependents(c,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,y.areSameExtensions)({id:o},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const i=await this.findGalleryExtensionById(c.identifier.uuid);return i||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([Y(0,f.IExtensionGalleryService),Y(1,d.ITelemetryService),Y(2,u.ILogService),Y(3,p.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const c=Array.isArray(r)?r:[r];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof f.ExtensionManagementError)return r;const c=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return c.stack=r.stack,c}function v(r,c,i,t,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(c,{...i,success:!o,duration:t,errorcode:s})}e.reportTelemetry=v;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(c=>new Promise((i,t)=>{const o=c.onCancellationRequested(()=>{o.dispose(),t((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[208],ie([0,1,16,5,67,3,10,4,32,7,131,13,30,196,82,14,8,60,26,43,24,21]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(o,s,a,h,S,I,_,O,F,z){super(_,O,F,z);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=S,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:k,value:U})=>{const j=[],M=[],G=[];(0,L.forEach)(U.recommendations,({key:K,value:x})=>{x.important?U.important?j.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):M.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):G.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),j.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:j}),M.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:M}),G.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,a)}groupImportantTipsByExe(o,s){const a=new Map;o.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:S}=this.groupByInstalled([...a.keys()],s);for(const O of h){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of S){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const I=this.getPromptedExecutableTips(),_=new Map;for(const O of S){const F=a.get(O);if(F&&(!I[F.exeName]||!I[F.exeName].includes(F.extensionId))){let z=_.get(F.exeName);z||(z=[],_.set(F.exeName,z)),z.push(F)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,a=7*24*60*60*1e3;if(s<a){const I=this._register((0,n.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},a-s));return}const[h,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(S[0].exeName,S);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(o){const s=o.map(({extensionId:h})=>h.toLowerCase()),a=(0,P.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(s,a,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(c,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(c,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,s){const a=this.getPromptedExecutableTips();a[o]=s.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(a),0,0)}groupByInstalled(o,s){const a=[],h=[],S=s.reduce((I,_)=>(I.add(_.identifier.id.toLowerCase()),I),new Set);return o.forEach(I=>{S.has(I.toLowerCase())?a.push(I):h.push(I)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const s=[],a=new Map;for(const h of o.keys()){const S=o.get(h);if(!S||!(0,D.isNonEmptyArray)(S.recommendations))continue;const I=[];R.isWindows?S.windowsPath&&I.push(S.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(I.push((0,T.join)("/usr/local/bin",h)),I.push((0,T.join)("/usr/bin",h)),I.push((0,T.join)(this.environmentService.userHome.fsPath,h)));for(const _ of I){let O=a.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),a.set(_,O)),O)for(const{extensionId:F,extensionName:z,isExtensionPack:k}of S.recommendations)s.push({extensionId:F,extensionName:z,isExtensionPack:k,exeName:h,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return s}};i=de([Y(0,C.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,f.IExtensionManagementService),Y(3,v.IStorageService),Y(4,m.INativeHostService),Y(5,u.IExtensionRecommendationNotificationService),Y(6,p.IFileService),Y(7,w.IProductService),Y(8,g.IRequestService),Y(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(ne[93],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appenders=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:b}){return this.appenders.forEach(E=>E.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(A){this.channel=A}log(A,T){return this.channel.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,15,20,21]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class R{async publicLog(m,w,g){}async publicLogError(m,w,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:u(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,m){return!(m.disableTelemetry||!d.enableTelemetry||m.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(d){const m=d.getValue(A.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function C(d){const m=Object.create(null),w=Object.create(null),g=Object.create(null);y(d,g);for(let v in g){v=v.length>150?v.substr(v.length-149):v;const l=g[v];typeof l=="number"?w[v]=l:typeof l=="boolean"?w[v]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${l.length}`),m[v]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[v]=l)}return{properties:m,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{d.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=f;function y(d,m,w=0,g){if(!!d)for(let v of Object.getOwnPropertyNames(d)){const l=d[v],r=g?g+v:v;Array.isArray(l)?m[r]=(0,D.safeStringify)(l):l instanceof Date?m[r]=l.toISOString():(0,n.isObject)(l)?w<2?y(l,m,w+1,r+"."):m[r]=(0,D.safeStringify)(l):m[r]=l}}function u(d){if(!d)return[];const m=[];return p(m,"",d),m}function p(d,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>p(d,m?`${m}.${g}`:g,w[g])):d.push(m)}}),define(ne[209],ie([0,1,44,149]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class A{constructor(b,E,P,C,f){this.getMachineId=b,this.configurationService=E,this.productService=P,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const y=this.configurationService.getValue("experiments.overrideDelay"),u=typeof y=="number"?y:0;this.overrideInitDelay=new Promise(p=>setTimeout(p,u))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const C=await this.tasClient;return this.networkInitialized?P=C.getTreatmentVariable("vscode",b):P=await C.getTreatmentVariableAsync("vscode",b,!0),P=C.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((y,u)=>{J(["tas-client-umd"],y,u)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=A;class T extends A{constructor(b,E,P){super(()=>Promise.resolve(b),E,P,new L)}}e.AssignmentService=T}),define(ne[210],ie([0,1,16,23,9,28,4,32,15,7,20,13,30,31,78,14,8,26,43,46,24,21,44]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=T.isWeb?"web":(0,f.getTargetPlatform)(T.platform,R.arch);var i;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function t(...$){return String($.reduce((B,te)=>B|te,0))}var o;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(B=S){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,te=this.state.pageSize){return new I({...this.state,pageNumber:B,pageSize:te})}withFilter(B,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new I({...this.state,criteria:se})}withSortBy(B){return new I({...this.state,sortBy:B})}withSortOrder(B){return new I({...this.state,sortOrder:B})}withFlags(...B){return new I({...this.state,flags:B.reduce((te,se)=>te|se,0)})}withAssetTypes(...B){return new I({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:ve,assetTypes:pe}=this.state;return{filters:[{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:pe,flags:ve}}get searchText(){const B=this.state.criteria.filter(te=>te.filterType===o.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _($,B){const te=($||[]).filter(se=>se.statisticName===B)[0];return te?te.value:0}function O($){const B="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(se=>se.assetType.indexOf(B)===0).reduce((se,ce)=>{const he=U($,ce.assetType);return he&&se.push([ce.assetType.substring(B.length),he]),se},[])}function F($){if($.properties){const B=$.properties.filter(ce=>ce.key===s.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=B.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return U($,s.Repository)}function z($){return{uri:`${$.fallbackAssetUri}/${s.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${s.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function k($){const B=U($,s.Icon);if(B)return B;const te=f.DefaultIconPath;return{uri:te,fallbackUri:te}}function U($,B){return $.files.filter(se=>se.assetType===B)[0]?{uri:`${$.assetUri}/${B}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${B}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function j($,B){const te=$.properties?$.properties.filter(ce=>ce.key===B):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,y.adoptToGalleryExtensionId)(ce)):[]}function M($){const B=$.properties?$.properties.filter(te=>te.key===a.Engine):[];return B.length>0&&B[0].value||""}function G($){const B=$.properties?$.properties.filter(te=>te.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function K($){const B=$.properties?$.properties.filter(se=>se.key===a.LocalizedLanguages):[],te=B.length>0&&B[0].value||"";return te?te.split(","):[]}function x($){return $.indexOf("preview")!==-1}function q($){return $.targetPlatform?(0,f.toTargetPlatform)($.targetPlatform):"undefined"}function X($){const B=(0,D.distinct)($.versions.map(q)),te=!!$.tags?.includes(f.WEB_EXTENSION_TAG),se=B.indexOf("web");return te?se===-1&&B.push("web"):se!==-1&&B.splice(se,1),B}function H($,B){const te=(0,f.getFallbackTargetPlarforms)(B);for(let se=0;se<$.length;se++){const ce=$[se];if(ce.version===$[se-1]?.version){let he=se;const ve=q(ce);if(ve===B)for(;he>0&&$[he-1].version===ce.version;)he--;else if(te.includes(ve))for(;he>0&&$[he-1].version===ce.version&&q($[he-1])!==B;)he--;he!==se&&($.splice(se,1),$.splice(he,0,ce))}}return $}e.sortExtensionVersions=H;function Z($,B,te){const se=$.versions[0],ce={manifest:U(B,s.Manifest),readme:U(B,s.Details),changelog:U(B,s.Changelog),license:U(B,s.License),repository:F(B),download:z(B),icon:k(B),coreTranslations:O(B)};return{identifier:{id:(0,y.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:B.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,description:$.shortDescription||"",installCount:_($.statistics,"install"),rating:_($.statistics,"averagerating"),ratingCount:_($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:te,assets:ce,properties:{dependencies:j(B,a.Dependency),extensionPack:j(B,a.ExtensionPack),engine:M(B),localizedLanguages:K(B),targetPlatform:q(B),isPreReleaseVersion:G(B)},hasPreReleaseVersion:G(se),hasReleaseVersion:!0,preview:x($.flags)}}let ee=class{constructor(B,te,se,ce,he,ve,pe,Ee){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=ve,this.productService=pe,this.configurationService=Ee;const Ce=pe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=V(pe.version,pe,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,te,se){const ce=n.CancellationToken.isCancellationToken(te)?{targetPlatform:c}:te,he=n.CancellationToken.isCancellationToken(te)?te:se,ve=[],pe=[],Ee=[],Ce=[];for(const Re of B)Re.uuid?pe.push(Re.uuid):ve.push(Re.id),Ee.push({...Re,preRelease:!!Re.preRelease}),Re.version&&Ce.push({...Re,version:Re.version});if(!pe.length&&!ve.length)return[];let we=new I().withPage(1,B.length);pe.length&&(we=we.withFilter(o.ExtensionId,...pe)),ve.length&&(we=we.withFilter(o.ExtensionName,...ve));const{extensions:be}=await this.queryGalleryExtensions(we,{targetPlatform:ce.targetPlatform,preRelease:Ee,versions:Ce,compatible:!!ce.compatible},he);return be}async getCompatibleExtension(B,te,se){if((0,f.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(B,te,se))return B;const ce=new I().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,B.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(ce,{targetPlatform:se,compatible:!0,preRelease:te},n.CancellationToken.None);return he[0]||null}async isExtensionCompatible(B,te,se){if(!(0,f.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,se)||!te&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const he=await this.getManifest(B,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,u.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(B,te,se,ce,he){if(!(0,f.isTargetPlatformCompatible)(q(B),ce,he)||!te&&G(B))return!1;if(se){const ve=await this.getEngine(B);if(!(0,u.isEngineValid)(ve,this.productService.version,this.productService.date))return!1}return!0}async query(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=B.text||"";const ce=(0,A.getOrDefault)(B,we=>we.pageSize,50);let he=new I().withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Re)=>(he=he.withFilter(o.Category,Re||be),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Re)=>(he=he.withFilter(o.Tag,Re||be),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(o.SearchText,se)),he=he.withSortBy(0)):B.ids?he=he.withFilter(o.ExtensionId,...B.ids):B.names?he=he.withFilter(o.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder));const ve=async(we,be)=>{const{extensions:Re,total:Fe}=await this.queryGalleryExtensions(we,{targetPlatform:c,compatible:!1,preRelease:!!B.includePreRelease},be);return Re.forEach((Me,qe)=>Me.telemetryData={index:(we.pageNumber-1)*we.pageSize+qe,querySource:B.source}),{extensions:Re,total:Fe}},{extensions:pe,total:Ee}=await ve(he,te),Ce=async(we,be)=>{if(be.isCancellationRequested)throw new L.CancellationError;const{extensions:Re}=await ve(he.withPage(we+1),be);return Re};return{firstPage:pe,total:Ee,pageSize:he.pageSize,getPage:Ce}}async queryGalleryExtensions(B,te,se){const ce=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),te.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:he,total:ve}=await this.queryRawGalleryExtensions(B,se);if(!(B.flags&i.IncludeLatestVersionOnly)){const we=[];for(const be of he){const Re=await this.toGalleryExtensionWithCriteria(be,te,!0);Re&&we.push(Re)}return{extensions:we,total:ve}}const Ee=[],Ce=new Map;for(let we=0;we<he.length;we++){const be=he[we],Re={id:(0,y.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Fe=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(qe=>(0,y.areSameExtensions)(qe,Re))?.preRelease;let Me=await this.toGalleryExtensionWithCriteria(be,te,!1);!Me||Me.properties.isPreReleaseVersion&&(!Fe||!Me.hasReleaseVersion)||!Me.properties.isPreReleaseVersion&&Me.properties.targetPlatform!==te.targetPlatform&&Me.hasPreReleaseVersion?Ce.set(be.extensionId,we):Ee.push([we,Me])}if(Ce.size){const we=new Date().getTime(),be=new I().withFlags(ce&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ce.size).withFilter(o.ExtensionId,...Ce.keys()),{extensions:Re}=await this.queryGalleryExtensions(be,te,se);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-we,count:Ce.size});for(const Fe of Re){const Me=Ce.get(Fe.identifier.uuid);Ee.push([Me,Fe])}}return{extensions:Ee.sort((we,be)=>we[0]-be[0]).map(([,we])=>we),total:ve}}async toGalleryExtensionWithCriteria(B,te,se){const ce={id:(0,y.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},he=te.versions?.find(Ce=>(0,y.areSameExtensions)(Ce,ce))?.version,ve=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(Ce=>(0,y.areSameExtensions)(Ce,ce))?.preRelease,pe=X(B),Ee=H(B.versions,te.targetPlatform);if(te.compatible&&se&&(0,f.isNotWebExtensionInWebTargetPlatform)(pe,te.targetPlatform))return null;for(let Ce=0;Ce<Ee.length;Ce++){const we=Ee[Ce];if(!(he&&we.version!==he)){if(await this.isValidVersion(we,ve,te.compatible,pe,te.targetPlatform))return Z(B,we,pe);if(he&&we.version===he)return null}}return he||te.compatible?null:Z(B,B.versions[0],pe)}async queryRawGalleryExtensions(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,t(i.Unpublished));const se=await this.commonHeadersPromise,ce=JSON.stringify(B.raw),he={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},ve=new Date().getTime();let pe,Ee,Ce=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:he},te),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Ce};const we=await(0,w.asJson)(pe);if(we){const be=we.results[0],Re=be.extensions,Fe=be.resultMetadata&&be.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return Ce=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ce}}return{galleryExtensions:[],total:Ce}}catch(we){throw Ee=we,we}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-ve,success:!!pe&&(0,w.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ee?(0,L.isCancellationError)(Ee)?"canceled":(0,L.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ce)})}}async reportStatistic(B,te,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${B}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${te}/${se}/stats?statType=${ce}`),ve=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:ve};try{await this.requestService.request({type:"POST",url:he,headers:Ee},n.CancellationToken.None)}catch{}}async download(B,te,se){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,y.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),ve=we=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:we}),pe=se===2?"install":se===3?"update":"",Ee=pe?{uri:`${B.assets.download.uri}${E.URI.parse(B.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${B.assets.download.fallbackUri}${E.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:B.assets.download,Ce=await this.getAsset(Ee);await this.fileService.writeFile(te,Ce.stream),ve(new Date().getTime()-he)}async getReadme(B,te){if(B.assets.readme){const se=await this.getAsset(B.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(B,te){if(B.assets.manifest){const se=await this.getAsset(B.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,te){const se=U(B,s.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(B,te){const se=B.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(B,te){if(B.assets.changelog){const se=await this.getAsset(B.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(B,te,se){let ce=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?ce=ce.withFilter(o.ExtensionId,B.identifier.uuid):ce=ce.withFilter(o.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryRawGalleryExtensions(ce,n.CancellationToken.None);if(!he.length)return[];const ve=X(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ve,se))return[];const pe=[];for(const Ee of he[0].versions)try{pe[pe.length-1]?.version!==Ee.version&&await this.isValidVersion(Ee,te,!0,ve,se)&&pe.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:G(Ee)})}catch{}return pe}async getAsset(B,te={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},ve={...ce,...te.headers||{}};te={...te,...he,headers:ve};const pe=B.uri,Ee=B.fallbackUri,Ce={...te,url:pe};try{const we=await this.requestService.request(Ce,se);if(we.res.statusCode===200)return we;const be=await(0,w.asText)(we);throw new Error(`Expected 200, got back ${we.res.statusCode} instead.

${be}`)}catch(we){if((0,L.isCancellationError)(we))throw we;const be=(0,L.getErrorMessage)(we);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:be});const Re={...te,url:Ee};return this.requestService.request(Re,se)}}async getEngine(B){let te=M(B);if(!te){const se=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(B),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const ve=te.unsupported[he];(0,b.isBoolean)(ve)||(ce[he.toLowerCase()]=ve.preReleaseExtension)}if(te.migrateToPreRelease)for(const[he,ve]of Object.entries(te.migrateToPreRelease))(!ve.engine||(0,u.isEngineValid)(ve.engine,this.productService.version,this.productService.date))&&(ce[he.toLowerCase()]=ve)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};ee=de([Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,p.IFileService),Y(6,m.IProductService),Y(7,P.IConfigurationService)],ee);let W=class extends ee{constructor(B,te,se,ce,he,ve,pe,Ee){super(B,te,se,ce,he,ve,pe,Ee)}};W=de([Y(0,v.IStorageService),Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,p.IFileService),Y(6,m.IProductService),Y(7,P.IConfigurationService)],W),e.ExtensionGalleryService=W;let N=class extends ee{constructor(B,te,se,ce,he,ve,pe){super(void 0,B,te,se,ce,he,ve,pe)}};N=de([Y(0,w.IRequestService),Y(1,d.ILogService),Y(2,C.IEnvironmentService),Y(3,l.ITelemetryService),Y(4,p.IFileService),Y(5,m.IProductService),Y(6,P.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N;async function V($,B,te,se,ce,he){const ve={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$} (${B.nameShort})`},pe=await(0,g.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(B,te)&&(0,r.getTelemetryLevel)(se)===3&&(ve["X-Market-User-Id"]=pe),ve}e.resolveMarketplaceHeaders=V}),define(ne[94],ie([0,1,2,13,8,44]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(b,E,P=""){super();this.prefix=P;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,A.validateTelemetryData)(E))}};T=de([Y(0,L.ILoggerService),Y(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[95],ie([0,1,2,28,4,27,141,20,42,87,38,21,44]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(d,m){this._experimentProperties[d]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,w=d["common.machineId"],g=d["common.firstSessionDate"],v=d["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:g,msftInternal:v}}dispose(){this._disposables.dispose()}_log(d,m,w,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(v=>{w=(0,n.mixin)(w,v),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(d,w))},v=>{console.error(v)})}publicLog(d,m,w){return this._log(d,3,m,w)}publicLog2(d,m,w){return this.publicLog(d,m,w)}publicLogError(d,m){return this.sendErrorTelemetry?this._log(d,2,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_anonymizeFilePaths(d){let m=d;const w=[];for(let r of this._cleanupPatterns)for(;;){const c=r.exec(d);if(!c)break;w.push([c.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=v.exec(d);if(!r)break;!g.test(r[0])&&w.every(([c,i])=>r.index<c||r.index>=i)&&(m+=d.substring(l,r.index)+"<REDACTED: user-file-path>",l=v.lastIndex)}return l<d.length&&(m+=d.substr(l)),m}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const m=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,g=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,v=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return g.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":v.test(m)?"<REDACTED: token>":d}_cleanupInfo(d,m){let w=d;m&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([Y(1,R.IConfigurationService)],y),e.TelemetryService=y;function u(){const p=(0,T.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=L.isWeb?"":(0,T.localize)(3,null),w=(0,T.localize)(4,null),g=(0,T.localize)(5,null),v=(0,T.localize)(6,null),l=(0,T.localize)(7,null),r=`
|       | ${w} | ${g} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,T.localize)(8,null);return`
${p} ${d} ${m}

&nbsp;

${l}
${r}

&nbsp;

${c}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[211],ie([0,1,9,28,44]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(R,b){const E=await new Promise((C,f)=>{J(["applicationinsights"],C,f)});let P;return E.defaultClient?(P=new E.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class T{constructor(b,E,P,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){!this._aiClient||(E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ne[212],ie([0,1,18,58,20,13,8,21,93,94,95]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(y,u,p,d){this.configurationService=y,this.telemetryService=u,this.loggerService=p,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(y){if(!this.customTelemetryServices.has(y.id)){const{machineId:u,sessionId:p}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=u,d["common.vscodesessionid"]=p;const m=[y.id,JSON.stringify(d),y.aiKey],g=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),v=[new b.TelemetryAppenderClient(g),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${y.id}] `)];this.customTelemetryServices.set(y.id,new P.TelemetryService({appenders:v,sendErrorTelemetry:y.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(y.id)}async publicLog(y,u,p){await(await this.getCustomTelemetryService(y)).publicLog(u,p)}async publicLogError(y,u,p){await(await this.getCustomTelemetryService(y)).publicLogError(u,p)}};C=de([Y(0,L.IConfigurationService),Y(1,R.ITelemetryService),Y(2,T.ILoggerService),Y(3,A.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(ne[213],ie([0,1,5,23,3,2,8]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...E});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(E,P){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([Y(1,T.ILogService)],R),e.RequestStore=R}),define(ne[96],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var y;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(ne[214],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[215],ie([0,1,33,28,10,4,32,15,22]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function P(C,f,y,u=T.env,p=b.Promises.exists){if(L.isAbsolute(C))return await p(C)?C:void 0;if(f===void 0&&(f=T.cwd()),L.dirname(C)!=="."){const g=L.join(f,C);return await p(g)?g:void 0}const m=(0,n.getCaseInsensitive)(u,"PATH");if(y===void 0&&(0,R.isString)(m)&&(y=m.split(L.delimiter)),y===void 0||y.length===0){const g=L.join(f,C);return await p(g)?g:void 0}for(let g of y){let v;if(L.isAbsolute(g)?v=L.join(g,C):v=L.join(f,g,C),await p(v))return v;if(A.isWindows){let l=v+".com";if(await p(l)||(l=v+".exe",await p(l)))return l}}const w=L.join(f,C);return await p(w)?w:void 0}e.findExecutable=P}),define(ne[216],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(ne[97],ie([0,1,48,3,2,6,38,216]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var b;(function(d){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var P;(function(d){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=m;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}d.fromString=g;function v(t){return{id:t}}d.fromId=v;function l(t,o){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}d.modify=l;function r(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}d.getModifier=r;function c(t,o){return t.id===o.id&&t.color?.id===o.color?.id}d.isEqual=c;function i(t,o){return{id:t.id,color:o?E(o):void 0}}d.asThemeIcon=i,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new f;T.Registry.add(e.Extensions.ThemingContribution,y);function u(d){return y.onColorThemeChange(d)}e.registerThemingParticipant=u;class p extends L.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let g=this.theme.getColor(m);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=p}),define(ne[217],ie([0,1,48,7,97]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(C,f){const y=C.map(u=>({name:u.profileName,description:T(u)}));return f&&y.push(...f.map(u=>({name:u.title,description:R(u)}))),{values:y.map(u=>u.name),markdownDescriptions:y.map(u=>u.description)}}e.createProfileSchemaEnums=A;function T(C){let f=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function R(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let y=0;y<C.length;y++)if(C[y]!==f[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(L.ThemeIcon.isThemeIcon(C)&&L.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const y=C,u=f;if((n.URI.isUri(y.light)||P(y.light))&&(n.URI.isUri(y.dark)||P(y.dark))&&(n.URI.isUri(u.light)||P(u.light))&&(n.URI.isUri(u.dark)||P(u.dark)))return y.light.path===u.light.path&&y.dark.path===u.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||P(C)||P(f)){const y=C,u=f;return y.path===u.path&&y.scheme===u.scheme}return!1}e.terminalIconsEqual=E;function P(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=P}),define(ne[218],ie([0,1,48,142,42,38,217]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),v=>v.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),v=>`$(${v.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){A.Registry.as(L.Extensions.Configuration).registerConfiguration(d),g()}e.registerTerminalPlatformConfiguration=m;let w;function g(v,l){const r=A.Registry.as(L.Extensions.Configuration);let c;v&&(c=(0,T.createProfileSchemaEnums)(v?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?c?.values:void 0,markdownEnumDescriptions:v?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?c?.values:void 0,markdownEnumDescriptions:v?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?c?.values:void 0,markdownEnumDescriptions:v?.os===1?c?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(ne[219],ie([0,1,45,48,10,4,22,72,215,97]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,C=!0;function f(c,i,t,o,s=process.env,a,h,S,I){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?y(t,a,s,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),I,S):v(a,h,t,c&&typeof c=="object"?{...c}:o.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,S,s)}e.detectAvailableProfiles=f;async function y(c,i,t,o,s,a,h,S,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await d(S);const z=new Map;c&&(z.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),z.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),z.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(a,z);const k=await u(z.entries(),h,i,t,o,I);if(c||!c&&s)try{const U=await w(`${O}\\${F?"wsl":"bash"}.exe`,h);for(const j of U)(!a||!(j.profileName in a))&&k.push(j)}catch{C&&(o?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return k}async function u(c,i,t,o=process.env,s,a){const h=[];for(const[S,I]of c){if(I===null)continue;let _,O,F;if("source"in I){const U=P?.get(I.source);if(!U)continue;_=U.paths,O=I.args||U.args,I.icon?F=p(I.icon):U.icon&&(F=U.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=A.isWindows||Array.isArray(I.args)?I.args:void 0,F=p(I.icon);const z=await a?.(_)||_.slice(),k=await r(S,i,z,t,o,O,I.env,I.overrideName,I.isAutoDetected,s);k?(k.isAutoDetected=I.isAutoDetected,k.icon=F,k.color=I.color,h.push(k)):s?.trace("profile not validated",S,_)}return h}function p(c){return typeof c=="string"?{id:c}:c}async function d(c){P&&!c||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:c||await m(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function m(){const c=[];for await(const i of(0,R.enumeratePowerShellInstallations)())c.push(i.exePath);return c}async function w(c,i){const t=[],o=await new Promise((h,S)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return S("Problem occurred when getting wsl distros");h(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const S=`${h} (WSL)`,I={profileName:S,path:c,args:["-d",`${h}`],isDefault:S===i,icon:g(h),isAutoDetected:!1};t.push(I)}return t}function g(c){return c.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):c.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function v(c,i,t,o,s,a,h,S){const I=new Map;if(t){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(z=>z.trim().indexOf("#")!==0&&z.trim().length>0),F=new Map;for(const z of O){let k=(0,L.basename)(z),U=F.get(k)||0;U++,U>1&&(k=`${k} (${U})`),F.set(k,U),I.set(k,{path:z,isAutoDetected:!0})}}return l(o,I),await u(I.entries(),s,c,S,i,h)}function l(c,i){if(!!c)for(const[t,o]of Object.entries(c))o===null||!("path"in o)&&!("source"in o)?i.delete(t):(o.icon=o.icon||i.get(t)?.icon,i.set(t,o))}async function r(c,i,t,o,s,a,h,S,I,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(c,i,t,o,s,a,h,S,I);const F={profileName:c,path:O,args:a,env:h,overrideName:S,isAutoDetected:I,isDefault:c===i};if((0,L.basename)(O)===O){const k=s.PATH?s.PATH.split(L.delimiter):void 0,U=await(0,b.findExecutable)(O,void 0,k,void 0,o.existsFile);return U?(F.path=U,F.isFromPath=!0,F):r(c,i,t,o,s,a)}return await o.existsFile((0,L.normalize)(O))?F:r(c,i,t,o,s,a,h,S,I)}}),define(ne[220],ie([0,1,3,2,18,4,36,58,20,13,77,163,8,86,21,213,96,218,219]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let v=0,l=class extends n.Disposable{constructor(c,i,t,o,s){super();this._reconnectConstants=c,this._configurationService=i,this._environmentService=t,this._logService=o,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:v,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?c.debugBrk=i.port:!i.break&&i.port&&(c.debug=i.port));const t=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,c);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const s=t.getChannel(d.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(h=>this._onProcessData.fire(h))),this._register(a.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(a.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(a.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(a.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(a.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(a.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(c,i,t,o,s,a,h,S,I,_,O){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),z=await this._proxy.createProcess(c,i,t,o,s,a,h,S,I,_,O);return clearTimeout(F),v=Math.max(v,z),z}updateTitle(c,i,t){return this._proxy.updateTitle(c,i,t)}updateIcon(c,i,t){return this._proxy.updateIcon(c,i,t)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c){return this._proxy.detachFromProcess(c)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,i){return this._proxy.shutdown(c,i)}input(c,i){return this._proxy.input(c,i)}processBinary(c,i){return this._proxy.processBinary(c,i)}resize(c,i,t){return this._proxy.resize(c,i,t)}acknowledgeDataEvent(c,i){return this._proxy.acknowledgeDataEvent(c,i)}setUnicodeVersion(c,i){return this._proxy.setUnicodeVersion(c,i)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}getLatency(c){return this._proxy.getLatency(c)}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,i){return this._proxy.installAutoReply(c,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._proxy.getDefaultSystemShell(c)}async getProfiles(c,i,t,o=!1){const s=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,c))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(c){return this._proxy.getWslPath(c)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this._proxy.getTerminalLayoutInfo(c)}async requestDetachInstance(c,i){return this._proxy.requestDetachInstance(c,i)}async acceptDetachInstanceReply(c,i){return this._proxy.acceptDetachInstanceReply(c,i)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,i){return this._proxy.reviveTerminalProcesses(c,i)}async refreshProperty(c,i){return this._proxy.refreshProperty(c,i)}async updateProperty(c,i,t){return this._proxy.updateProperty(c,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:i})}async acceptPtyHostResolvedVariables(c,i){this._resolveVariablesRequestStore.acceptReply(c,i)}};l=de([Y(1,b.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,f.ILogService),Y(4,u.ITelemetryService)],l),e.PtyHostService=l}),define(ne[34],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[221],ie([0,1,3,2,7,13,31,14,8,34]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(f,y,u,p,d){super();this.extensionsManagementService=f,this.logService=p,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=L.URI.file(u.extensionsPath);this._register(y.watch(m)),this._register(D.Event.filter(y.onDidFilesChange,w=>w.rawChanges.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(f,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),y)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const y of f)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),y=f.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,T.areSameExtensions)(d,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),u=this.installedExtensions.filter(p=>this.installingExtensions.some(d=>(0,T.areSameExtensions)(d,p))?!1:f.every(d=>!(0,T.areSameExtensions)(d.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=f.map(p=>p.identifier),(y.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:u})}}};P=de([Y(1,R.IFileService),Y(2,A.INativeEnvironmentService),Y(3,b.ILogService),Y(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[222],ie([0,1,34,79,14,19,104,3,2]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const y=new Map,u=p=>{let d=y.get(p.scheme);return d===void 0&&(d=f.hasProvider(p)&&!this._fileService.hasCapability(p,1024),y.set(p.scheme,d)),d};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(p=>{y.delete(p.scheme)})),this.extUri=new A.ExtUri(u),this._canonicalUris=new T.SkipList((p,d)=>this.extUri.compare(p,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,A.normalizePath)(f));let y=this._canonicalUris.get(f);return y?y.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((u,p)=>u[1].touch<p[1].touch?1:u[1].touch>p[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let u=0;u<y;u++)this._canonicalUris.set(f[u][0],f[u][1].touch())}};P=de([Y(0,L.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(D.IUriIdentityService,P,!0)}),define(ne[223],ie([0,1,3,2,40,39,17]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,P,C,f,y){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=C,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(u=>this.handleFileChanges(u)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,C){const f=(0,L.newWriteableStream)(y=>T.VSBuffer.concat(y.map(u=>T.VSBuffer.wrap(u))).buffer);return(async()=>{try{const y=await this.readFile(E);f.end(y)}catch(y){f.error(y),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,C)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:C.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[53],ie([0,1,69]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,b,E){const P=(0,D.setProperty)(T,R,b,E)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=n;function L(T,R,b){let E=b;for(;E>=0;){if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&T.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function A(T,R,b){let E=b;for(;E>=0;)if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&T.charAt(E)===R.charAt(1)))return E;return T.length-1}e.getLineEndOffset=A}),define(ne[224],ie([0,1,28,61,15]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,y,u,p,d){const m=[],w=[],g=[];if(!y){const O=f.filter(({identifier:F})=>d.every(z=>z.toLowerCase()!==F.id.toLowerCase()));return{local:{added:m,removed:w,updated:g},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),y=y.map(P),u=u?u.map(P):null;const v=new Map,l=O=>{O.uuid&&v.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),y.forEach(({identifier:O})=>l(O)),u&&u.forEach(({identifier:O})=>l(O));const r=O=>{const F=O.identifier.uuid||v.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,F)=>(O.set(r(F),F),O),i=f.reduce(c,new Map),t=y.reduce(c,new Map),o=y.reduce((O,F)=>{const z=r(F);F=(0,D.deepClone)(F);const k=i.get(z);return k&&(k.installed&&(F.installed=!0),F.version||(F.version=k.version)),c(O,F)},new Map),s=u?u.reduce(c,new Map):null,a=p.reduce(c,new Map),h=d.reduce((O,F)=>{const z=v.get(F.toLowerCase());return O.add(z?`uuid:${z}`:`id:${F.toLowerCase()}`)},new Set),S=T(i,t,h);if(S.added.size>0||S.removed.size>0||S.updated.size>0){const O=T(s,i,h),F=T(s,t,h),z=(k,U)=>{const j=i.get(k);if(j){const M=t.get(k),G=U?M:j;return{...G,version:(M.version&&n.gt(M.version,j.version),j.version),state:R(j,M,s?.get(k)),preRelease:(0,L.isUndefined)(G.preRelease)?j.preRelease:G.preRelease}}};for(const k of F.removed.values()){const U=i.get(k);U&&w.push(U.identifier)}for(const k of F.added.values())if(O.added.has(k)){if(S.updated.has(k)){const U=z(k,!0);U&&(g.push(C(U,k)),o.set(k,U))}}else{const U=t.get(k);U.installed&&m.push(C(U,k))}for(const k of F.updated.values()){const U=z(k,!0);U&&(g.push(C(U,k)),o.set(k,U))}for(const k of O.added.values())F.added.has(k)||o.set(k,i.get(k));for(const k of O.updated.values())if(!F.removed.has(k)&&!F.updated.has(k)){const U=z(k,!1);U&&(o.get(k)?.installed&&(U.installed=!0),o.set(k,U))}for(const k of O.removed.values())!a.has(k)&&!F.updated.has(k)&&s?.get(k)?.installed&&o.delete(k)}const I=[],_=T(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,F)=>I.push(C(O,F))),{local:{added:m,removed:w,updated:g},remote:I.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:I}:null}}e.merge=A;function T(f,y,u,{checkInstalledProperty:p,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=f?[...f.keys()].filter(r=>!u.has(r)):[],w=[...y.keys()].filter(r=>!u.has(r)),g=w.filter(r=>m.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),v=m.filter(r=>w.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),l=new Set;for(const r of m){if(v.has(r))continue;const c=f.get(r),i=y.get(r);(!i||c.disabled!==i.disabled||c.preRelease!==i.preRelease||!E(c.state,i.state)||d&&c.version!==i.version||p&&c.installed!==i.installed)&&l.add(r)}return{added:g,removed:v,updated:l}}function R(f,y,u){const p=f.state,d=y.state,m=u?.state;if(!y.version||p&&n.gt(f.version,y.version))return p;if(d&&n.gt(y.version,f.version)||!p)return d;if(!d)return p;const w=(0,D.deepClone)(p),g=m?b(m,d):{added:Object.keys(d).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},v=m?b(m,p):{added:Object.keys(p).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...g.added.values(),...g.updated.values()])w[l]=d[l];for(const l of g.removed.values())v.updated.has(l)||delete w[l];return w}function b(f,y){const u=Object.keys(f),p=Object.keys(y),d=p.filter(g=>u.indexOf(g)===-1).reduce((g,v)=>(g.add(v),g),new Set),m=u.filter(g=>p.indexOf(g)===-1).reduce((g,v)=>(g.add(v),g),new Set),w=new Set;for(const g of u){if(m.has(g))continue;const v=f[g],l=y[g];(0,D.equals)(v,l)||w.add(g)}return{added:d,removed:m,updated:w}}function E(f={},y={}){const{added:u,removed:p,updated:d}=b(f,y);return u.size===0&&p.size===0&&d.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,y){const u={identifier:{id:f.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(u.version=f.version),f.disabled&&(u.disabled=!0),f.installed&&(u.installed=!0),f.state&&(u.state=f.state),u}}),define(ne[98],ie([0,1,16,20,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),b&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),b&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):P.push(f);return(0,D.distinct)([...b,...P].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};A=de([Y(0,n.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(ne[225],ie([0,1,16,35,28,159,53]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(v){return(0,n.parse)(v)||[]}e.parseKeybindings=R;async function b(v,l,r,c,i){const t=R(v),o=R(l),s=r?R(r):null,a=[...t,...o,...s||[]].map(M=>M.key),h=await i.resolveUserBindings(a);let S=P(t,o,s,h);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const I=f(t),_=f(o),O=s?f(s):null,F=u(I,_,h),z=O?u(O,I,h):{added:[...I.keys()].reduce((M,G)=>(M.add(G),M),new Set),removed:new Set,updated:new Set},k=O?u(O,_,h):{added:[..._.keys()].reduce((M,G)=>(M.add(G),M),new Set),removed:new Set,updated:new Set},U=E(F,z,k);let j=v;for(const M of U.removed.values())U.conflicts.has(M)||(j=w(j,M,c));for(const M of U.added.values()){if(U.conflicts.has(M))continue;const G=_.get(M);if(G.some(K=>K.command!==`-${M}`&&S.conflicts.has(h[K.key]))){U.conflicts.add(M);continue}j=m(j,G,c)}for(const M of U.updated.values()){if(U.conflicts.has(M))continue;const G=_.get(M);if(G.some(K=>K.command!==`-${M}`&&S.conflicts.has(h[K.key]))){U.conflicts.add(M);continue}j=g(j,M,G,c)}return{mergeContent:j,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=b;function E(v,l,r){const c=new Set,i=new Set,t=new Set,o=new Set;for(const s of l.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):i.add(s));for(const s of l.added.values())o.has(s)||r.added.has(s)&&v.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(l.added.has(s)?v.updated.has(s)&&o.add(s):c.add(s));for(const s of l.updated.values())o.has(s)||r.updated.has(s)&&v.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(l.updated.has(s)?v.updated.has(s)&&o.add(s):t.add(s));return{added:c,removed:i,updated:t,conflicts:o}}function P(v,l,r,c){const i=new Set,t=C(v,c),o=C(l,c),s=r?C(r,c):null,a=y(t,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const h=s?y(s,t):{added:[...t.keys()].reduce((z,k)=>(z.add(k),z),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=s?y(s,o):{added:[...o.keys()].reduce((z,k)=>(z.add(k),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:_,updated:O,conflicts:F}=E(a,h,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:F}}function C(v,l){const r=new Map;for(const c of v){const i=l[c.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(c)}return r}function f(v){const l=new Map;for(const r of v){const c=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(c);i||(i=[],l.set(c,i)),i.push(r)}return l}function y(v,l){const r=[...v.keys()],c=[...l.keys()],i=c.filter(s=>r.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),t=r.filter(s=>c.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of r){if(t.has(s))continue;const a=v.get(s).map(S=>({...S,key:s})),h=l.get(s).map(S=>({...S,key:s}));(0,D.equals)(a,h,(S,I)=>d(S,I))||o.add(s)}return{added:i,removed:t,updated:o}}function u(v,l,r){const c=[...v.keys()],i=[...l.keys()],t=i.filter(a=>c.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=c.filter(a=>i.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),s=new Set;for(const a of c){if(o.has(a))continue;const h=v.get(a).map(I=>({...I,key:r[I.key]})),S=l.get(a).map(I=>({...I,key:r[I.key]}));p(h,S)||s.add(a)}return{added:t,removed:o,updated:s}}function p(v,l){return!(!(0,D.equals)(v.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,c)=>d(r,c))||!(0,D.equals)(v.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,c)=>d(r,c)))}function d(v,l){if(v.command!==l.command||v.key!==l.key)return!1;const r=A.ContextKeyExpr.deserialize(v.when),c=A.ContextKeyExpr.deserialize(l.when);return!(r&&!c||!r&&c||r&&c&&!r.equals(c)||!L.equals(v.args,l.args))}function m(v,l,r){for(const c of l)v=T.edit(v,[-1],c,r);return v}function w(v,l,r){const c=R(v);for(let i=c.length-1;i>=0;i--)(c[i].command===l||c[i].command===`-${l}`)&&(v=T.edit(v,[i],void 0,r));return v}function g(v,l,r,c){const i=R(v),t=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(v=T.edit(v,[o],void 0,c));for(let o=r.length-1;o>=0;o--)v=T.edit(v,[t],r[o],c);return v}}),define(ne[226],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,T,R){const b={},E={},P=new Set;if(!T)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=n(A,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,A),y=n(R,T),u={},p={},d=new Set,m=new Set;for(const w of f.removed.values())y.updated.has(w)?b[w]=T[w]:d.add(w);for(const w of y.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):P.add(w));for(const w of f.updated.values())m.has(w)||(y.updated.has(w)?C.updated.has(w)&&m.add(w):p[w]=A[w]);for(const w of y.updated.values())m.has(w)||(f.updated.has(w)?C.updated.has(w)&&m.add(w):A[w]!==void 0&&(E[w]=T[w]));for(const w of f.added.values())m.has(w)||(y.added.has(w)?C.updated.has(w)&&m.add(w):u[w]=A[w]);for(const w of y.added.values())m.has(w)||(f.added.has(w)?C.updated.has(w)&&m.add(w):b[w]=T[w]);return{local:{added:b,removed:[...P.values()],updated:E},remote:{added:u,removed:[...d.values()],updated:p},conflicts:[...m.values()]}}e.merge=D;function n(A,T){const R=A?Object.keys(A):[],b=T?Object.keys(T):[],E=b.filter(f=>R.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),P=R.filter(f=>b.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),C=new Set;for(const f of R){if(P.has(f))continue;const y=A[f],u=T[f];y!==u&&C.add(f)}return{added:E,removed:P,updated:C}}function L(A,T){const{added:R,removed:b,updated:E}=n(A,T);return R.size===0&&b.size===0&&E.size===0}e.areSame=L}),define(ne[25],ie([0,1,16,19,15,147,42,30,6,88,38]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(I=>!!s[I].ignoreSync),h=Object.keys(s).filter(I=>s[I].scope===2||s[I].scope===6),S=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...h,...S])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const s="vscode://schemas/ignoredSettings",a=P.Registry.as(T.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=P.Registry.as(E.Extensions.JSONContribution),S=()=>{const I=C(),_=f().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(k=>_.indexOf(k)===-1),F=_.filter(k=>I.indexOf(k)===-1),z={items:{type:"string",enum:[...O,...F.map(k=>`-${k}`)]}};h.registerSchema(s,z)};return a.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=y;function u(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=u;var p;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(s,a,h){return h.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=m;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(a,h,S,I){super(a);this.code=h,this.resource=S,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class v extends g{constructor(a,h,S,I,_){super(a,S,void 0,_);this.url=h,this.serverCode=I}}e.UserDataSyncStoreError=v;class l extends g{constructor(a,h){super(a,h)}}e.UserDataAutoSyncError=l,function(s){function a(h){if(h instanceof s)return h;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(S&&S[1]){const I=S[2]==="unknown"?void 0:S[2],_=S[3]==="unknown"?void 0:S[3];return new s(h.message,S[1],I,_)}return new s(h.message,"Unknown")}s.toUserDataSyncError=a}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var c;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(a.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[47],ie([0,1,16,5,17,23,3,35,2,27,15,7,143,20,13,14,8,46,24,21,34,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let c=class extends b.Disposable{constructor(a,h,S,I,_,O,F,z,k,U,j){super();this.resource=a,this.fileService=h,this.environmentService=S,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=F,this.telemetryService=z,this.logService=k,this.configurationService=U,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(S.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(a,S,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(S,h,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const h=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,h={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),h)}async preview(a,h,S={}){return this._sync(a,!1,h,S)}async apply(a,h={}){try{this.syncHeaders={...h};const S=await this.doApply(a);return this.setStatus(S),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,h,S,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(F,O,h,S),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const h=await this.resolveContent(a);if(!h)return!1;const S=this.parseSyncData(h);if(!S)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),F=await this.generateSyncPreview({ref:_.ref,syncData:S},I,O,this.getUserDataSyncConfiguration(),A.CancellationToken.None),z=[];for(const k of F){const U=await this.getAcceptResult(k,k.remoteResource,void 0,A.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,A.CancellationToken.None);z.push([k,{...U,remoteChange:j!==0?j:2}])}await this.applyResult(_,I,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const h=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===h}async getLatestRemoteUserData(a,h){if(h){const S=a&&a.latest?a.latest[this.resource]:void 0;if(h.ref===S||S===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(a,h,S,I){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,h,S,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,h,S,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(a,h,S,I)}throw _}}async doSync(a,h,S,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,h,S,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":S?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async h=>{const S=await this.getMergeResult(h,A.CancellationToken.None);await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(S?.content||""));const I=S&&!S.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,A.CancellationToken.None):void 0;return h.acceptResult=I,h.mergeState=S.hasConflicts?"conflict":I?"accepted":"preview",h.localChange=I?I.localChange:S.localChange,h.remoteChange=I?I.remoteChange:S.remoteChange,h}),this.syncPreviewPromise}async accept(a,h){return await this.updateSyncResourcePreview(a,async S=>{const I=await this.getAcceptResult(S,a,h,A.CancellationToken.None);return S.acceptResult=I,S.mergeState="accepted",S.localChange=I.localChange,S.remoteChange=I.remoteChange,S}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async h=>{const S=await this.getMergeResult(h,A.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(S.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=S.localChange,h.remoteChange=S.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(a,h){if(!this.syncPreviewPromise)return;let S=await this.syncPreviewPromise;const I=S.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:F})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(F,a));I!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...S.resourcePreviews];return O[I]=await h(O[I]),{...S,resourcePreviews:O}}),S=await this.syncPreviewPromise,this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(S=>[S,S.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const h=a.filter(({mergeState:S})=>S==="conflict");(0,D.equals)(this._conflicts,h,(S,I)=>this.extUri.isEqual(S.previewResource,I.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:S})=>({created:h,uri:this.toRemoteBackupResource(S)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:S})=>({created:h,uri:this.toLocalBackupResource(S)}))}toRemoteBackupResource(a){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const h=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(h))){const{content:S}=await this.getUserData(h);if(S)return this.parseSyncData(S)?.machineId}}async resolveContent(a){const h=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(h))){const{content:S}=await this.getUserData(h);return S}return this.extUri.isEqual(a,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(a){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const S of h.resourcePreviews){if(this.extUri.isEqual(S.acceptedResource,a))return S.acceptResult?S.acceptResult.content:null;if(this.extUri.isEqual(S.remoteResource,a))return S.remoteContent;if(this.extUri.isEqual(S.localResource,a))return S.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,h,S,I,_){const O=await this.isRemoteDataFromCurrentMachine(a),F=await this.generateSyncPreview(a,h,O,I,_),z=[];for(const k of F){const U=k.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(k.localChange===0&&k.remoteChange===0)z.push({...k,acceptedResource:U,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=S?await this.getMergeResult(k,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(k.previewResource,L.VSBuffer.fromString(j?.content||""));const M=j&&!j.hasConflicts?await this.getAcceptResult(k,k.previewResource,void 0,_):void 0;z.push({...k,acceptResult:M,mergeState:j?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:j?j.localChange:k.localChange,remoteChange:M?M.remoteChange:j?j.remoteChange:k.remoteChange})}}return{remoteUserData:a,lastSyncUserData:h,resourcePreviews:z,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(a.value.toString()),S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&S&&h.version!==S,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;const I=h;if(I.content===null)return{ref:h.ref,syncData:null};const _=JSON.parse(I.content);if(r(_))return{...h,syncData:_,content:void 0}}catch(a){a instanceof p.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:S,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(a){const{ref:h,content:S}=await this.getUserData(a);let I=null;return S!==null&&(I=this.parseSyncData(S)),{ref:h,syncData:I}}parseSyncData(a){try{const h=JSON.parse(a);if(r(h))return h}catch(h){this.logService.error(h)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,P.isString)(a)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:h}}else{const h=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(a,h){const S=await this.currentMachineIdPromise,I={version:this.version,machineId:S,content:a};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),h,this.syncHeaders),{ref:h,syncData:I}}async backupLocal(a){const h={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=de([Y(1,p.IFileService),Y(2,u.IEnvironmentService),Y(3,w.IStorageService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncEnablementService),Y(7,g.ITelemetryService),Y(8,l.IUserDataSyncLogService),Y(9,y.IConfigurationService),Y(10,v.IUriIdentityService)],c),e.AbstractSynchroniser=c;let i=class extends c{constructor(a,h,S,I,_,O,F,z,k,U,j,M){super(h,S,I,_,O,F,z,k,U,j,M);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,h,S){try{h?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),S?void 0:h):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:S})}catch(I){throw I instanceof p.FileOperationError&&I.fileOperationResult===1||I instanceof p.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,p.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,g.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,y.IConfigurationService),Y(11,v.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(a,h,S,I,_,O,F,z,k,U,j,M,G){super(a,h,S,I,_,O,F,z,k,U,M,G);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(a){const h=[];return(0,R.parse)(a,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Y(2,p.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,g.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,l.IUserDataSyncUtilService),Y(11,y.IConfigurationService),Y(12,v.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(a,h,S,I,_){this.resource=a,this.environmentService=h,this.logService=S,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:a,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const S=this.parseSyncData(h);if(!!S)try{await this.doInitialize({ref:a,syncData:S})}catch(I){this.logService.error(I)}}parseSyncData(a){try{const h=JSON.parse(a);if(r(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,h={}){const S={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(S)))}};o=de([Y(1,u.IEnvironmentService),Y(2,d.ILogService),Y(3,p.IFileService),Y(4,v.IUriIdentityService)],o),e.AbstractInitializer=o}),define(ne[227],ie([0,1,5,23,9,3,49,27,7,20,13,30,31,63,14,8,24,21,34,47,224,98,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const h=(await s.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of a)o.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),o.version===2&&h.every(I=>!(0,f.areSameExtensions)(I.identifier,S.identifier))&&(S.installed=!0)}return a}let i=class mt extends g.AbstractSynchroniser{constructor(s,a,h,S,I,_,O,F,z,k,U,j,M,G,K){super("extensions",a,s,h,S,I,j,M,z,U,K);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=k,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:q})=>!!q)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const h=s.syncData?await c(s.syncData,this.extensionManagementService):null,S=a?.skippedExtensions||[],I=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);h?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:k}=(0,v.merge)(O,h,I,S,F),U={local:z,remote:k,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:k!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:h?this.stringify(h,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await c(s.syncData,this.extensionManagementService):null,h=await this.extensionManagementService.getInstalled(void 0,!0),S=this.getLocalExtensions(h),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),{remote:_}=(0,v.merge)(S,a,a,s.skippedExtensions||[],I);return _!==null}getPreviewContent(s,a,h,S){const I=[...a,...h],_=new Set,O=F=>{_.add(F.id.toLowerCase()),F.uuid&&_.add(F.uuid)};I.forEach(({identifier:F})=>O(F)),S.forEach(O);for(const F of s)_.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&_.has(F.identifier.uuid)||I.push(F);return this.stringify(I,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,h,S){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),S=(0,v.merge)(s.localExtensions,null,null,s.skippedExtensions,h),{local:I,remote:_}=S;return{content:s.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),S=s.remoteContent?JSON.parse(s.remoteContent):null;if(S!==null){const I=(0,v.merge)(s.localExtensions,S,s.localExtensions,[],h),{local:_,remote:O}=I;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,h,S){let{skippedExtensions:I,localExtensions:_}=h[0][0],{local:O,remote:F,localChange:z,remoteChange:k}=h[0][1];if(z===0&&k===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(F.all);s=await this.updateRemoteUserData(U,S?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const h=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),I=this.getLocalExtensions(h).filter(_=>!S.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const h=await this.resolvePreviewContent(s);return h&&this.stringify(JSON.parse(h),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const h=this.parseSyncData(a);if(h)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(h),!0)}}return null}stringify(s,a){return s.sort((h,S)=>!h.identifier.uuid&&S.identifier.uuid?-1:h.identifier.uuid&&!S.identifier.uuid?1:(0,R.compare)(h.identifier.id,S.identifier.id)),a?(0,T.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(h=>h.installed||h.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,h,S){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const z=O.filter(({identifier:k,isBuiltin:U})=>!U&&a.some(j=>(0,f.areSameExtensions)(k,j)));await D.Promises.settled(z.map(async k=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,k.identifier.id),await this.extensionManagementService.uninstall(k,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,k.identifier.id),I.push(k.identifier)}))}(s.length||h.length)&&await D.Promises.settled([...s,...h].map(async z=>{const k=O.find(j=>(0,f.areSameExtensions)(j.identifier,z.identifier));if(k&&k.isBuiltin){z.state&&k.manifest.version===z.version&&this.updateExtensionState(z.state,k,k.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(M=>(0,f.areSameExtensions)(M,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id))),I.push(z.identifier);return}const U=(await this.extensionGalleryService.getExtensions([{...z.identifier,preRelease:z.preRelease}],n.CancellationToken.None))[0];if(z.state&&(k?k.manifest.version===z.version:!!U)&&this.updateExtensionState(z.state,k||U,k?.manifest.version),U)try{this.extensionEnablementService.getDisabledExtensions().some(M=>(0,f.areSameExtensions)(M,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,U.version))),(!k||k.preRelease!==z.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:z.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,U.version),I.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),_.push(z)))}catch(j){_.push(z),j instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else _.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const F=[];for(const z of S)I.some(k=>(0,f.areSameExtensions)(k,z.identifier))||F.push(z);for(const z of _)F.some(k=>(0,f.areSameExtensions)(k.identifier,z.identifier))||F.push(z);return F}updateExtensionState(s,a,h){const S=this.extensionStorageService.getExtensionState(a,!0)||{},I=h?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:h}):void 0;I?I.forEach(_=>{S[_]=s[_]}):Object.keys(s).forEach(_=>S[_]=s[_]),this.extensionStorageService.setExtensionState(a,S,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(h=>{const{identifier:S,isBuiltin:I,manifest:_,preRelease:O}=h,F={identifier:S,preRelease:O,version:_.version};a.some(z=>(0,f.areSameExtensions)(z,S))&&(F.disabled=!0),I||(F.installed=!0);try{const z=this.extensionStorageService.getKeysForSync({id:S.id,version:_.version});if(z){const k=this.extensionStorageService.getExtensionState(h,!0)||{};F.state=Object.keys(k).reduce((U,j)=>(z.includes(j)&&(U[j]=k[j]),U),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(z))}return F})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,P.IEnvironmentService),Y(1,u.IFileService),Y(2,d.IStorageService),Y(3,r.IUserDataSyncStoreService),Y(4,r.IUserDataSyncBackupStoreService),Y(5,C.IExtensionManagementService),Y(6,C.IGlobalExtensionEnablementService),Y(7,l.IIgnoredExtensionsManagementService),Y(8,r.IUserDataSyncLogService),Y(9,C.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,m.ITelemetryService),Y(13,y.IExtensionStorageService),Y(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends g.AbstractInitializer{constructor(s,a,h,S,I,_){super("extensions",S,I,h,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await c(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const h=[],S=[],I=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(F=>(0,f.areSameExtensions)(F.identifier,_.identifier));O?(h.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(S.push(_.identifier),_.disabled&&I.push(_.identifier))}return{installedExtensions:h,newExtensions:S,disabledExtensions:I,remoteExtensions:s}}};t=de([Y(0,C.IExtensionManagementService),Y(1,l.IIgnoredExtensionsManagementService),Y(2,u.IFileService),Y(3,P.IEnvironmentService),Y(4,p.ILogService),Y(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ne[228],ie([0,1,28,25]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,E,P,C){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=A(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=E?A(E,b):{added:Object.keys(b).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},u=E?A(E,R):{added:Object.keys(R).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},d=D.deepClone(b),m=!E;for(const w of u.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&m&&y.added.has(w)||(d[w]=R[w]);for(const w of u.updated.values())d[w]=R[w];for(const w of u.removed.values())P.unregistered.includes(w)||delete d[w];for(const w of y.added.values()){const g=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&u.added.has(w))continue;const v=R[w];v&&v.value===g.value||w===n.SYNC_SERVICE_URL_TYPE&&m&&u.added.has(w)||(v?p.updated[w]=g:p.added[w]=g)}for(const w of y.updated.values()){const g=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(w)||u.removed.has(w))continue;const v=R[w];v&&v.value===g.value||(p.updated[w]=g)}for(const w of y.removed.values()){if(P.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}u.updated.has(w)||u.removed.has(w)||p.removed.push(w)}return{local:p,remote:T(d,b)?null:d}}e.merge=L;function A(R,b){const E=Object.keys(R),P=Object.keys(b),C=P.filter(u=>E.indexOf(u)===-1).reduce((u,p)=>(u.add(p),u),new Set),f=E.filter(u=>P.indexOf(u)===-1).reduce((u,p)=>(u.add(p),u),new Set),y=new Set;for(const u of E){if(f.has(u))continue;const p=R[u],d=b[u];D.equals(p,d)||y.add(u)}return{added:C,removed:f,updated:y}}function T(R,b){const{added:E,removed:P,updated:C}=A(R,b);return E.size===0&&P.size===0&&C.size===0}}),define(ne[229],ie([0,1,17,9,3,35,49,4,7,29,20,13,14,8,46,24,21,34,47,53,228,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",c=["locale"];function i(h,S){const I=h.storage?Object.keys(h.storage).sort():[],_={};return I.forEach(O=>_[O]=h.storage[O]),h.storage=_,S?(0,T.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let o=class vt extends w.AbstractSynchroniser{constructor(S,I,_,O,F,z,k,U,j,M){super("globalState",S,F,j,I,_,z,k,O,U,M);this.storageService=j,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(S.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:j.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(S,I,_){const O=S.syncData?JSON.parse(S.syncData.content):null;I=I===null&&_?S:I;const F=I&&I.syncData?JSON.parse(I.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const k=this.getStorageKeys(F),{local:U,remote:j}=(0,v.merge)(z.storage,O?O.storage:null,F?F.storage:null,k,this.logService),M={content:null,local:U,remote:j,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i(z,!1),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:k}]}async hasRemoteChanged(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:F}=(0,v.merge)(_.storage,I.storage,I.storage,O,this.logService);return F!==null}async getMergeResult(S,I){return{...S.previewResult,hasConflicts:!1}}async getAcceptResult(S,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(I,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(S){return{content:S.localContent,local:{added:{},removed:[],updated:{}},remote:S.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(S){if(S.remoteContent!==null){const I=JSON.parse(S.remoteContent),{local:_,remote:O}=(0,v.merge)(S.localUserData.storage,I.storage,null,S.storageKeys,this.logService);return{content:S.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:S.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(S,I,_,O){let{localUserData:F}=_[0][0],{local:z,remote:k,localChange:U,remoteChange:j}=_[0][1];if(U===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),U!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:k});S=await this.updateRemoteUserData(M,O?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S)){const _=await this.resolvePreviewContent(S);return _&&i(JSON.parse(_),!0)}let I=await super.resolveContent(S);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(S)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(S)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:S}=await this.getLocalGlobalState();if(Object.keys(S).length>1||S[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const S={},I=await this.getLocalArgvContent(),_=(0,A.parse)(I);for(const O of c)_[O]!==void 0&&(S[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const F=this.storageService.get(O,0);F&&(S[O]={version:1,value:F})}return{storage:S}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const S=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),S.value.toString()}catch(S){this.logService.debug((0,n.getErrorMessage)(S))}return"{}"}async writeLocalGlobalState({added:S,removed:I,updated:_}){const O={},F={},z=(U,j)=>{for(const M of U){if(M.startsWith(r)){O[M.substring(r.length)]=j?j[M].value:void 0;continue}if(j){const G=j[M];G.value!==String(this.storageService.get(M,0))&&(F[M]=G.value)}else this.storageService.get(M,0)!==void 0&&(F[M]=void 0)}};if(z(Object.keys(S),S),z(Object.keys(_),_),z(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const U of Object.keys(F))this.storageService.store(U,F[U],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(S){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(S))_=(0,g.edit)(_,[O],S[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(S){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],F=S?.storage?Object.keys(S.storage).filter(z=>!z.startsWith(r)&&!O.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!R.isWeb){const z=[...l.ALL_SYNC_RESOURCES.map(k=>(0,l.getEnablementKey)(k)),l.SYNC_SERVICE_URL_TYPE];F.push(...z),_.push(...z)}return{user:I,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,f.IFileService),Y(1,l.IUserDataSyncStoreService),Y(2,l.IUserDataSyncBackupStoreService),Y(3,l.IUserDataSyncLogService),Y(4,C.IEnvironmentService),Y(5,l.IUserDataSyncEnablementService),Y(6,d.ITelemetryService),Y(7,P.IConfigurationService),Y(8,p.IStorageService),Y(9,m.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(S,I,_,O,F){super("globalState",_,O,I,F);this.storageService=S}async doInitialize(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const F of Object.keys(I.storage))F.startsWith(r)?_[F.substring(r.length)]=I.storage[F].value:this.storageService.get(F,0)===void 0&&(O[F]=I.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const z of Object.keys(_))F=(0,g.edit)(F,[z],_[z],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(O).length)for(const F of Object.keys(O))this.storageService.store(F,O[F],0,0)}};s=de([Y(0,p.IStorageService),Y(1,f.IFileService),Y(2,C.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,m.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(S,I,_,O,F){this.userDataSyncStoreClient=S,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=F}getSyncStoreType(S){return this.parseGlobalState(S)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(S){const I=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(S,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(S,I)}throw _}}async doSync(S,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:S,version:t};const F=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:t,machineId:F,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),_.ref,I)}parseGlobalState({content:S}){if(!S)return null;const I=JSON.parse(S);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};a=de([Y(1,p.IStorageService),Y(2,C.IEnvironmentService),Y(3,f.IFileService),Y(4,y.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(ne[230],ie([0,1,16,17,3,35,4,15,144,20,13,14,24,21,34,47,225,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,c){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return c.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends p.AbstractJsonFileSynchroniser{constructor(r,c,i,t,o,s,a,h,S,I,_){super(a.keybindingsResource,"keybindings",s,a,h,r,c,o,I,i,S,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,c,i,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&i?r:c;const s=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),h=await this.getFormattingOptions();let S=null,I=!1,_=!1,O=!1;if(o){let z=a?a.value.toString():"[]";if(z=z||"[]",this.hasErrors(z))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==z||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const k=await(0,d.merge)(z,o,s,h,this.userDataSyncUtilService);k.hasChanges&&(S=k.mergeContent,O=k.hasConflicts,I=O||k.mergeContent!==z,_=O||k.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),S=a.value.toString(),_=!0);const F={content:S,localChange:I?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getKeybindingsContentFromLastSyncUserData(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,d.merge)(t||"[]",c,c,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==c}async getMergeResult(r,c){return r.previewResult}async getAcceptResult(r,c,i,t){if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:h}=i[0][1];if(a===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const S=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(S,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=(0,A.parse)(r.value.toString());if((0,D.isNonEmptyArray)(c))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,c){let i={};try{i=JSON.parse(c||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([Y(0,m.IUserDataSyncStoreService),Y(1,m.IUserDataSyncBackupStoreService),Y(2,m.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,m.IUserDataSyncEnablementService),Y(5,C.IFileService),Y(6,P.IEnvironmentService),Y(7,f.IStorageService),Y(8,m.IUserDataSyncUtilService),Y(9,y.ITelemetryService),Y(10,u.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let v=class extends p.AbstractInitializer{constructor(r,c,i,t){super("keybindings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(c)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,A.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(c)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(c){return this.logService.error(c),null}}};v=de([Y(0,C.IFileService),Y(1,P.IEnvironmentService),Y(2,m.IUserDataSyncLogService),Y(3,u.IUriIdentityService)],v),e.KeybindingsInitializer=v}),define(ne[231],ie([0,1,16,35,69,49,28,53,25]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(s,a,h){let S=[];h?S=C(h):S=P(a);const I=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const O of S)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,D.distinct)([...s,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function P(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function C(s){const a=(0,n.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(s,a,h,S){if(h.length){const I=o(a),_=(0,n.parse)(a),O=(0,n.parse)(s),F=[];for(const z of h){const k=_[z],U=O[z];k===void 0?s=R.edit(s,[z],void 0,S):U!==void 0?s=R.edit(s,[z],k,S):F.push(l(z,I))}F.sort((z,k)=>z.startOffset-k.startOffset),F.forEach(z=>s=m(z.setting.key,a,s,S))}return s}e.updateIgnoredSettings=f;function y(s,a,h,S,I,_){const O=f(s,a,S,_),F=h!==O,z=h!==a;if(!F&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!F)return{conflictsSettings:[],localContent:f(a,s,S,_),remoteContent:null,hasConflicts:!1};if(h===null&&p(s)){const $=u(s,a,S)?null:f(a,s,S,_);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let k=s,U=a;const j=(0,n.parse)(s),M=(0,n.parse)(a),G=h?(0,n.parse)(h):null,K=S.reduce(($,B)=>($.add(B),$),new Set),x=d(j,M,K),q=d(G,j,K),X=d(G,M,K),H=new Map,Z=new Set,ee=$=>{Z.add($);const B=I.filter(({key:te})=>te===$)[0];B?(k=R.edit(k,[$],B.value,_),U=R.edit(U,[$],B.value,_)):H.set($,{key:$,localValue:j[$],remoteValue:M[$]})};for(const $ of q.removed.values())X.updated.has($)?ee($):U=R.edit(U,[$],void 0,_);for(const $ of X.removed.values())Z.has($)||(q.updated.has($)?ee($):k=R.edit(k,[$],void 0,_));for(const $ of q.updated.values())Z.has($)||(X.updated.has($)?x.updated.has($)&&ee($):U=R.edit(U,[$],j[$],_));for(const $ of X.updated.values())Z.has($)||(q.updated.has($)?x.updated.has($)&&ee($):k=R.edit(k,[$],M[$],_));for(const $ of q.added.values())Z.has($)||(X.added.has($)?x.updated.has($)&&ee($):U=m($,k,U,_));for(const $ of X.added.values())Z.has($)||(q.added.has($)?x.updated.has($)&&ee($):k=m($,U,k,_));const W=H.size>0||!u(k,U,S),N=W||!u(k,s,[]),V=W||!u(U,a,[]);return{localContent:N?k:null,remoteContent:V?U:null,conflictsSettings:[...H.values()],hasConflicts:W}}e.merge=y;function u(s,a,h){if(s===a)return!0;const S=(0,n.parse)(s),I=(0,n.parse)(a),_=h.reduce((z,k)=>(z.add(k),z),new Set),O=o(s).filter(z=>!(z.setting&&_.has(z.setting.key))),F=o(a).filter(z=>!(z.setting&&_.has(z.setting.key)));if(O.length!==F.length)return!1;for(let z=0;z<O.length;z++){const k=O[z],U=F[z];if(k.setting&&U.setting){if(k.setting.key!==U.setting.key||!T.equals(S[k.setting.key],I[k.setting.key]))return!1}else if(!k.setting&&!U.setting){if(k.value!==U.value)return!1}else return!1}return!0}e.areSame=u;function p(s){return s?o(s).length===0:!0}e.isEmpty=p;function d(s,a,h){const S=s?Object.keys(s).filter(z=>!h.has(z)):[],I=Object.keys(a).filter(z=>!h.has(z)),_=I.filter(z=>S.indexOf(z)===-1).reduce((z,k)=>(z.add(k),z),new Set),O=S.filter(z=>I.indexOf(z)===-1).reduce((z,k)=>(z.add(k),z),new Set),F=new Set;if(s)for(const z of S){if(O.has(z))continue;const k=s[z],U=a[z];T.equals(k,U)||F.add(z)}return{added:_,removed:O,updated:F}}function m(s,a,h,S){const I=(0,n.parse)(a),_=o(a),O=o(h),F=w(s,_,O);return g(h,s,I[s],F,O,S)}e.addSetting=m;function w(s,a,h){const S=a.findIndex(_=>_.setting?.key===s),I=a[S-1];if(I){if(I.setting){const O=l(I.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!0}}else{const O=r(S,a);if(O){const F=l(O.setting.key,h);if(F){const z=c(h.indexOf(F),h),k=i(a,O,a[S]);if(z){const U=i(h,F,z),j=t(k,U);return j?{index:h.indexOf(j),insertAfter:!0}:{index:h.indexOf(z),insertAfter:!1}}else{const U=i(h,F,h[h.length-1]),j=t(k,U);return j?{index:h.indexOf(j),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const _=a[S+1];if(_)if(_.setting){const O=l(_.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!1}}else{const O=c(S,a);if(O){const F=l(O.setting.key,h);if(F){const z=r(h.indexOf(F),h),k=i(a,a[S],O);if(z){const U=i(h,z,F),j=t(k.reverse(),U.reverse());return j?{index:h.indexOf(j),insertAfter:!1}:{index:h.indexOf(z),insertAfter:!0}}else{const U=i(h,h[0],F),j=t(k.reverse(),U.reverse());return j?{index:h.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function g(s,a,h,S,I,_){let O;return S.index===-1?O=(0,L.setProperty)(s,[a],h,_):O=v(s,a,h,S,I,_).map(F=>(0,L.withFormatting)(s,F,_)[0]),(0,L.applyEdits)(s,O)}function v(s,a,h,S,I,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(h)}`,F=(0,A.getEOL)(_,s),z=I[S.index];if(S.insertAfter){const k=[];if(z.setting)k.push({offset:z.endOffset,length:0,content:","+O});else{const U=c(S.index,I),j=r(S.index,I),M=j?.setting?.commaOffset;j&&M===void 0&&k.push({offset:j.endOffset,length:0,content:","});const G=M!==void 0&&M>z.endOffset;k.push({offset:G?M+1:z.endOffset,length:0,content:U?F+O+",":F+O})}return k}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const k=(I[S.index-1]&&!I[S.index-1].setting?F:"")+O+(c(S.index,I)?",":"")+F;return[{offset:z.startOffset,length:0,content:k}]}}function l(s,a){return a.filter(h=>h.setting?.key===s)[0]}function r(s,a){for(let h=s-1;h>=0;h--)if(a[h].setting)return a[h]}function c(s,a){for(let h=s+1;h<a.length;h++)if(a[h].setting)return a[h]}function i(s,a,h){const S=s.indexOf(a),I=s.indexOf(h);return s.filter((_,O)=>S<O&&O<I)}function t(s,a){if(s.length&&a.length){let h=0;for(;h<a.length&&h<s.length;h++)if(s[h].value!==a[h].value)return a[h-1];return a[h-1]}}function o(s){const a=[];let h=-1,S,I;const _={onObjectBegin:O=>{h++},onObjectProperty:(O,F,z)=>{h===0&&(S=F,I=O)},onObjectEnd:(O,F)=>{h--,h===0&&a.push({startOffset:S,endOffset:O+F,value:s.substring(S,O+F),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,F)=>{h++},onArrayEnd:(O,F)=>{h--,h===0&&a.push({startOffset:S,endOffset:O+F,value:s.substring(S,O+F),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,F,z)=>{h===0&&a.push({startOffset:S,endOffset:F+z,value:s.substring(S,F+z),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,F,z)=>{if(h===0&&O===","){let k=a.length-1;for(;k>=0&&!a[k].setting;k--);const U=a[k];U&&a.splice(k,1,{startOffset:U.startOffset,endOffset:U.endOffset,value:U.value,setting:{key:U.setting.key,commaOffset:F}})}},onComment:(O,F)=>{h===0&&a.push({startOffset:O,endOffset:O+F,value:s.substring(O,O+F)})}};return(0,n.visit)(s,_),a}}),define(ne[232],ie([0,1,17,3,145,20,89,13,30,14,24,21,34,47,53,231,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return m(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let g=class extends y.AbstractJsonFileSynchroniser{constructor(r,c,i,t,o,s,a,h,S,I,_,O){super(c.settingsResource,"settings",r,c,i,t,o,S,I,s,a,h,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const c=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,c),t=this.getSettingsSyncContent(i),o=new T.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,c,i){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);c=c===null&&i?r:c;const a=c?this.getSettingsSyncContent(c):null,h=await this.getIgnoredSettings();let S=null,I=!1,_=!1,O=!1;if(s){let z=t?t.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const k=(0,p.merge)(z,s.settings,a?a.settings:null,h,[],o);S=k.localContent||k.remoteContent,I=k.localContent!==null,_=k.remoteContent!==null,O=k.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),S=t.value.toString(),_=!0);const F={content:S,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getSettingsSyncContent(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,p.merge)(t||"{}",c.settings,c.settings,o,[],s).remoteContent!==null}async getMergeResult(r,c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,p.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,c,i,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?(0,p.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent!==null?(0,p.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,p.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:h}=i[0][1];if(a===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const S=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,p.updateIgnoredSettings)(s,I?I.settings:"{}",_,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=await this.getFormattingOptions(),i=(0,u.edit)(r.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,p.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let c=await super.resolvePreviewContent(r);if(c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();c=(0,p.updateIgnoredSettings)(c,"{}",t,i)}return c}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(c,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new d.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};g=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,P.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncBackupStoreService),Y(5,d.IUserDataSyncLogService),Y(6,d.IUserDataSyncUtilService),Y(7,A.IConfigurationService),Y(8,d.IUserDataSyncEnablementService),Y(9,C.ITelemetryService),Y(10,b.IExtensionManagementService),Y(11,f.IUriIdentityService)],g),e.SettingsSynchroniser=g;let v=class extends y.AbstractInitializer{constructor(r,c,i,t){super("settings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}};v=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,d.IUserDataSyncLogService),Y(3,f.IUriIdentityService)],v),e.SettingsInitializer=v}),define(ne[233],ie([0,1,17,3,28,20,13,14,24,21,34,47,226,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let u=class extends C.AbstractSynchroniser{constructor(m,w,g,v,l,r,c,i,t,o){super("snippets",w,m,g,v,l,i,t,r,c,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,g){const v=await this.getSnippetsFileContents(),l=this.toSnippetsContents(v),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&g?m:w;const c=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,c);return this.getResourcePreviews(i,v,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),v=this.toSnippetsContents(g),l=(0,f.merge)(v,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,g,v){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,g,v){const l=g.map(([r,c])=>({...r,acceptResult:c}));l.every(({localChange:r,remoteChange:c})=>r===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,v)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,v)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,w,g){const v=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};v.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:g[l]?2:1};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!v.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const g=this.parseSyncData(w);if(g){const v=this.parseSnippets(g),l=[];for(const r of Object.keys(v)){const c=this.extUri.joinPath(m,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:c,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const g of m)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:g,acceptResult:v,localResource:l,remoteResource:r,localChange:c}of m)if(c!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(v.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(v.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,g){const v=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(v);for(const{acceptResult:r,localResource:c,remoteResource:i,remoteChange:t}of m)if(t!==0){const o=c?this.extUri.basename(c):this.extUri.basename(i);t===3?delete l[o]:l[o]=r.content}return(0,f.areSame)(v,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const g of Object.keys(m))w[g]=m[g].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of w.children||[]){const v=g.resource,l=this.extUri.extname(v);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,v),c=await this.fileService.readFile(v);m[r]=c}}return m}};u=de([Y(0,T.IEnvironmentService),Y(1,R.IFileService),Y(2,b.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,A.IConfigurationService),Y(7,y.IUserDataSyncEnablementService),Y(8,E.ITelemetryService),Y(9,P.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let p=class extends C.AbstractInitializer{constructor(m,w,g,v){super("snippets",w,g,m,v)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(w)){const l=w[v];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};p=de([Y(0,R.IFileService),Y(1,T.IEnvironmentService),Y(2,y.IUserDataSyncLogService),Y(3,P.IUriIdentityService)],p),e.SnippetsInitializer=p}),define(ne[64],ie([0,1,3,2,6,25]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};T=de([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[234],ie([0,1,5,17,57,2,19,20,13,14,25]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends A.Disposable{constructor(y,u,p,d){super();this.environmentService=y,this.fileService=u,this.configurationService=p,this.logService=d,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(y){const u=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),p=await this.fileService.resolve(u);return p.children?p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(y,u){if(!u){const p=await this.getAllRefs(y);p.length&&(u=p[p.length-1].ref)}if(u){const p=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,u);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(y,u){const p=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),d=(0,T.joinPath)(p,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(u))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const u=(0,T.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(u))return}catch{return}const p=await this.fileService.resolve(u);if(p.children){const d=p.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(v=>Date.now()-this.getCreationTime(v)>m);const g=d.length-w.length;g<10&&(w=w.slice(10-g)),await D.Promises.settled(w.map(async v=>{this.logService.info("Deleting from backup",v.resource.path),await this.fileService.del(v.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};C=de([Y(0,b.IEnvironmentService),Y(1,E.IFileService),Y(2,R.IConfigurationService),Y(3,P.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(ne[235],ie([0,1,3,2,4,13,24,21,25]),function(J,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends n.Disposable{constructor(f,y,u,p){super();this.storageService=f,this.telemetryService=y,this.environmentService=u,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,y){if(this.isResourceEnabled(f)!==y){const u=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(u,{enabled:y}),this.storeResourceEnablement(u,y)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,y){this.storageService.store(f,y,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=b.ALL_SYNC_RESOURCES.filter(u=>(0,b.getEnablementKey)(u)===f.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};P=de([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[236],ie([0,1,2,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(f,y,u){switch(y){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class A{constructor(f){this.service=f}listen(f,y){throw new Error(`Event not found: ${y}`)}call(f,y,u){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(f,y,u){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(f,y,u){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(f,y,u){switch(y){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[237],ie([0,1,13,8]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};L=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[65],ie([0,1,3,2,4,27,148,13,14,6,26,46,24,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let p=class Ze extends n.Disposable{constructor(m,w,g,v,l,r){super();this.storageService=g,this.userDataSyncStoreService=v,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(m,w,g)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(v=>({...v,isCurrent:v.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:v})=>v===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m),v=g.machines.filter(({id:l})=>l!==w);v.length!==g.machines.length&&(g.machines=v,await this.writeMachinesData(g))}async renameMachine(m,w,g){const v=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:c})=>c===m);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:c})=>c===v)&&this.storageService.store(u,w,0,1))}async setEnablement(m,w){const g=await this.readMachinesData(),v=g.machines.find(({id:l})=>l===m);v&&(v.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const w=this.storageService.get(u,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,L.PlatformToString)(L.isWeb?0:L.platform)})`,v=new RegExp(`${(0,A.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of m){const c=v.exec(r.name),i=c?parseInt(c[1]):0;l=i>l?i:l}return`${g} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==Ze.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),g=await this.userDataSyncStoreService.write(Ze.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=de([Y(0,R.IEnvironmentService),Y(1,b.IFileService),Y(2,f.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncLogService),Y(5,P.IProductService)],p),e.UserDataSyncMachinesService=p}),define(ne[238],ie([0,1,5,57,37,9,3,2,4,19,7,146,26,24,21,25,64,65]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",v="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,o,s,a,h,S,I,_,O,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=S,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(h.onDidChangeLocal,(z,k)=>z?[...z,k]:[k],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(v,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(v,t.toString(),0,1):this.storageService.remove(v,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=p.UserDataSyncError.toUserDataSyncError(t);o instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"||o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,f.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncEnablementService),Y(4,p.IUserDataSyncService),Y(5,p.IUserDataSyncLogService),Y(6,d.IUserDataSyncAccountService),Y(7,u.ITelemetryService),Y(8,m.IUserDataSyncMachinesService),Y(9,y.IStorageService)],r),e.UserDataAutoSyncService=r;class c extends R.Disposable{constructor(t,o,s,a,h,S,I,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=S,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,A.isCancellationError)(h))return}return this.doSync(t,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,E.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const h=this.storageService.get(g,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const S=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const I=S.find(_=>_.isCurrent);if(I?.disabled)throw new p.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new p.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof p.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(g,this.manifest.session,0,1),s.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(t){return super._register(t)}}c.INTERVAL_SYNCING="Interval"}),define(ne[239],ie([0,1,16,5,37,3,2,19,15,29,20,30,6,24,21,227,229,230,232,233,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends T.Disposable{constructor(s,a,h,S,I,_,O,F){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=a,this.instantiationService=h,this.configurationService=S,this.logService=I,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=F,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,a){this.checkEnablement();const h=(0,E.generateUuid)();try{const F=(0,v.createSyncHeaders)(h);a&&(F["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,F)}catch(F){const z=v.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(z,h),z}let S=!1;const I=this,_=this.getEnabledSynchronizers();let O;return{manifest:s,async run(){if(S)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(F=>I.sync(_,s,h,F)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),I.status!=="idle")return I.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new v.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),a=(0,v.createSyncHeaders)(s);let h;try{h=await this.userDataSyncStoreService.manifest(null,a)}catch(I){const _=v.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(_,s),_}await this.resetLocal();const S=this.getEnabledSynchronizers();return new c(s,h,a,S,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(s,a,h,S){if(S.isCancellationRequested||!s.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,v.createSyncHeaders)(h);for(const O of s){if(S.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(a,_)}catch(F){let z=!1;if(F instanceof v.UserDataSyncError)switch(F.code){case"TooLarge":F=new v.UserDataSyncError(F.message,F.code,O.resource),z=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":z=!0;break}const k=v.UserDataSyncError.toUserDataSyncError(F);if(this.reportUserDataSyncError(k,h),z)throw k;this.logService.error(F),this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(F)}`),this._syncErrors.push([O.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(_){const O=v.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,h),O}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const a of s)try{a.status!=="idle"&&await a.stop()}catch(h){this.logService.error(h)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async a=>{if(await a.replace(s))return!0})}async accept(s,a,h,S){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===s)return await I.accept(a,h),S&&await I.apply(!1,(0,v.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async a=>{const h=await a.resolveContent(s);if(h)return h})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,a){return await this.performSynchronizerAction(async S=>{if(S.resource===s)return S.getAssociatedResources(a)})||[]}async getMachineId(s,a){return await this.performSynchronizerAction(async S=>{if(S.resource===s)return await S.getMachineId(a)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async a=>{if(a.resource!=="globalState"&&await a.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async a=>{if(await a.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(a){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(a)}`),this.logService.error(a)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const a=new T.DisposableStore;try{const h=this.synchronizers.value||a.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),S=[...h.enabled,...h.disabled.map(I=>a.add(h.createSynchronizer(I)))];for(const I of S){const _=await s(I);if(!(0,b.isUndefined)(_))return _}return null}finally{a.dispose()}}setStatus(s){const a=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const a=this.computeStatus(s);this.setStatus(a)}updateConflicts(s){const a=this.computeConflicts(s);(0,D.equals)(this._conflicts,a,([h,S],[I,_])=>h===h&&(0,D.equals)(S,_,(O,F)=>(0,R.isEqual)(O.previewResource,F.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(a))}computeConflicts(s){return s.filter(a=>a.status==="hasConflicts").map(a=>[a.resource,a.conflicts.map(t)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(a=>a.status==="hasConflicts")?"hasConflicts":s.some(a=>a.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,a){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof v.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof v.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,P.IConfigurationService),Y(4,v.IUserDataSyncLogService),Y(5,u.ITelemetryService),Y(6,y.IStorageService),Y(7,v.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class c extends T.Disposable{constructor(s,a,h,S,I,_,O){super();this.id=s,this.manifest=a,this.syncHeaders=h,this.synchronisers=S,this.onStop=I,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,a){try{return await this.performAction(s,h=>h.accept(s,a))}catch(h){throw this.logService.error(h),h}}async merge(s){try{return s?await this.performAction(s,a=>a.merge(s)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(s){try{return await this.performAction(s,a=>a.discard(s))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,a]of this.previews)for(const h of a.resourcePreviews)h.mergeState==="conflict"&&s.push(h.previewResource);for(const a of s)await this.discard(a);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const S=this.synchronisers.find(_=>_.resource===a);for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await S.merge(_.previewResource);const I=await S.apply(!1,this.syncHeaders);I&&s.push(this.toSyncResourcePreview(S.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(S=>S.resource===s);for(const S of a.resourcePreviews)await h.accept(S.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(S=>S.resource===s);for(const S of a.resourcePreviews)await h.accept(S.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:j,previewResource:M,remoteResource:G})=>(0,R.isEqual)(s,j)||(0,R.isEqual)(s,M)||(0,R.isEqual)(s,G)));if(h===-1)return this.previews;const[S,I]=this.previews[h],_=I.resourcePreviews.find(({localResource:U,remoteResource:j,previewResource:M})=>(0,R.isEqual)(U,s)||(0,R.isEqual)(j,s)||(0,R.isEqual)(M,s));if(!_)return this.previews;let O=this.synchronizingResources.find(U=>U[0]===S);O||(O=[S,[]],this.synchronizingResources.push(O)),O[1].some(U=>(0,R.isEqual)(U,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const F=this.synchronisers.find(U=>U.resource===this.previews[h][0]),z=await a(F);z?this.previews.splice(h,1,this.toSyncResourcePreview(F.resource,z)):this.previews.splice(h,1);const k=this.synchronizingResources.findIndex(U=>U[0]===S);return this.synchronizingResources[k][1].splice(O[1].findIndex(U=>(0,R.isEqual)(U,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(k,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const S=this.synchronisers.find(_=>_.resource===a);let I=h;for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(I=await S.merge(_.previewResource));I&&s.push(this.toSyncResourcePreview(S.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const a=[],h=await this.getUserDataSyncConfiguration();for(const S of this.synchronisers){if(s.isCancellationRequested)return[];const I=await S.preview(this.manifest,h,this.syncHeaders);I&&a.push(this.toSyncResourcePreview(S.resource,I))}return a}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(h=>h instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...a}}toSyncResourcePreview(s,a){return[s,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends T.Disposable{constructor(s,a,h,S,I,_,O){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=a,this.onDidChangeLocal=h,this.userDataSyncEnablementService=S,this.instantiationService=I,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(S.onDidChangeResourceEnablement(([F,z])=>this.onDidChangeResourceEnablement(F,z))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,F])=>F.dispose())));for(const F of v.ALL_SYNC_RESOURCES)S.isResourceEnabled(F)&&this.registerSynchronizer(F)}get enabled(){return this._enabled.sort((s,a)=>s[1]-a[1]).map(([s])=>s)}get disabled(){return v.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,a){a?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([I])=>I.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const a=new T.DisposableStore,h=a.add(this.createSynchronizer(s));a.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),a.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),a.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const S=this.getOrder(s);this._enabled.push([h,S,a])}deRegisterSynchronizer(s){const a=this._enabled.findIndex(([h])=>h.resource===s);if(a!==-1){const h=this._enabled.splice(a,1);for(const[S,,I]of h){if(S.status!=="idle"){const _=S.conflicts.length>0;S.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(p.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([Y(3,v.IUserDataSyncEnablementService),Y(4,f.IInstantiationService),Y(5,C.IExtensionGalleryService),Y(6,v.IUserDataSyncLogService)],i);function t(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[240],ie([0,1,3,2,15,7,25]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,y){try{return await this._call(C,f,y)}catch(u){throw this.logService.error(u),u}}async _call(C,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],A.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),p=y[0],d=this.getManualSyncTask(p);switch(y=y.slice(1),u){case"preview":return d.preview();case"accept":return d.accept(A.URI.revive(y[0]),y[1]);case"merge":return d.merge(A.URI.revive(y[0]));case"discard":return d.discard(A.URI.revive(y[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:y}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,y,u){return C.call(f,y,u).then(null,p=>{throw T.UserDataSyncError.toUserDataSyncError(p)})},listen(f,y){return C.listen(f,y)}},this.channel.call("_getInitialData").then(([f,y,u])=>{this.updateStatus(f),this.updateConflicts(y),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([y,u])=>[y,T.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:y}=await this.channel.call("createManualSyncTask"),u=this,p=new E(C,f,y,{async call(d,m,w){return u.channel.call(`manualSync/${d}`,[C,...(0,L.isArray)(m)?m:[m]],w)},listen(d,m){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${d}`,m),w=>!p.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return p}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,y,u){return this.channel.call("accept",[C,f,y,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:y,uri:u})=>({created:y,uri:A.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:y,uri:u})=>({created:y,uri:A.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:p})=>({resource:A.URI.revive(u),comparableResource:A.URI.revive(p)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,y])=>[f,y.map(u=>({...u,localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,y,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=y;const p=this;this.channel={async call(d,m,w){try{const g=await u.call(d,m,w);return p.isDiposed()||(p._status=await u.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(d,m){return u.listen(d,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const y=await this.channel.call("accept",[C,f]);return this.deserializePreviews(y)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,y])=>[f,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(u=>({...u,localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource),acceptedResource:A.URI.revive(u.acceptedResource)}))}])}}}),define(ne[241],ie([0,1,5,23,9,3,2,102,4,19,15,7,29,20,13,14,26,43,46,24,25]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",c="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends T.Disposable{constructor(O,F,z){super();this.productService=O,this.configurationService=F,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(z.onDidChangeValue,k=>k.key===v.SYNC_SERVICE_URL_TYPE&&k.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(v.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(v.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[v.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=b.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...F||{}};if(z&&(0,P.isString)(z.url)&&(0,P.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(k=>(0,P.isArray)(z.authenticationProviders[k].scopes))){const k=z,U=!!k.canSwitch&&!F?.url,j=k.url===k.insidersUrl?"insiders":"stable",M=(U?this.userDataSyncStoreType:void 0)||j,G=F?.url||(M==="insiders"?k.insidersUrl:M==="stable"?k.stableUrl:k.url);return{url:C.URI.parse(G),type:M,defaultType:j,defaultUrl:C.URI.parse(k.url),stableUrl:C.URI.parse(k.stableUrl),insidersUrl:C.URI.parse(k.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(k.authenticationProviders).reduce((K,x)=>(K.push({id:x,scopes:k.authenticationProviders[x].scopes}),K),[])}}}};s=de([Y(0,d.IProductService),Y(1,y.IConfigurationService),Y(2,g.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(O,F,z){super(O,F,z);const k=this.storageService.get(l,0);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const U=this.productService[v.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(l,JSON.stringify(U),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=de([Y(0,d.IProductService),Y(1,y.IConfigurationService),Y(2,g.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends T.Disposable{constructor(O,F,z,k,U,j,M){super();this.requestService=z,this.logService=k,this.storageService=M,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(U,j,M).then(G=>{const K={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(K["X-Client-Commit"]=F.commit),K}),this.session=new I(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},k=await this.request(F.toString(),{type:"GET",headers:z},[],n.CancellationToken.None);return(await(0,m.asJson)(k)||[]).map(({url:j,created:M})=>({ref:(0,E.relativePath)(F,F.with({path:j})),created:M*1e3}))}async resolveContent(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString(),k={};k["Cache-Control"]="no-cache";const U=await this.request(z,{type:"GET",headers:k},[],n.CancellationToken.None);return await(0,m.asText)(U)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(F,{type:"DELETE",headers:z},[],n.CancellationToken.None)}async read(O,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const U=await this.request(k,{type:"GET",headers:z},[304],n.CancellationToken.None);let j=null;if(U.res.statusCode===304&&(j=F),j===null){const M=U.res.headers.etag;if(!M)throw new v.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",U.res.statusCode,U.res.headers[v.HEADER_OPERATION_ID]);const G=await(0,m.asText)(U);if(!G&&U.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",k,"EmptyResponse",U.res.statusCode,U.res.headers[v.HEADER_OPERATION_ID]);j={ref:M,content:G}}return j}async write(O,F,z,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();k={...k},k["Content-Type"]=R.Mimes.text,z&&(k["If-Match"]=z);const j=await this.request(U,{type:"POST",data:F,headers:k},[],n.CancellationToken.None),M=j.res.headers.etag;if(!M)throw new v.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",j.res.statusCode,j.res.headers[v.HEADER_OPERATION_ID]);return M}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const k=await this.request(z,{type:"GET",headers:F},[304],n.CancellationToken.None);let U=null;if(k.res.statusCode===304&&(U=O),!U){const M=k.res.headers.etag;if(!M)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",k.res.statusCode,k.res.headers[v.HEADER_OPERATION_ID]);const G=await(0,m.asText)(k);if(!G&&k.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",z,"EmptyResponse",k.res.statusCode,k.res.headers[v.HEADER_OPERATION_ID]);G&&(U={...JSON.parse(G),ref:M})}const j=this.storageService.get(c,0);return j&&U&&j!==U.session&&this.clearSession(),U===null&&j&&this.clearSession(),U&&this.storageService.store(c,U.session,0,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(i,0)}async request(O,F,z,k){if(!this.authToken)throw new v.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;F.headers={...F.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let j;try{j=await this.session.request(O,F,k)}catch(x){if(!(x instanceof v.UserDataSyncStoreError)){let q="RequestFailed";const X=(0,L.getErrorMessage)(x).toLowerCase();X.includes("xhr timeout")?q="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?q="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":X.includes("headers must be an object")?q="RequestHeadersNotObject":(0,L.isCancellationError)(x)&&(q="RequestCanceled"),x=new v.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),x}const M=j.res.headers[v.HEADER_OPERATION_ID],G={url:O,status:j.res.statusCode,"execution-id":F.headers[v.HEADER_EXECUTION_ID],"operation-id":M},K=(0,m.isSuccess)(j)||j.res.statusCode&&z.indexOf(j.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new v.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",j.res.statusCode,M);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",j.res.statusCode,M);if(j.res.statusCode===410)throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",j.res.statusCode,M);if(j.res.statusCode===412)throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",j.res.statusCode,M);if(j.res.statusCode===413)throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",j.res.statusCode,M);if(j.res.statusCode===426)throw new v.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",j.res.statusCode,M);if(j.res.statusCode===429){const x=j.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",j.res.statusCode,M)):new v.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",j.res.statusCode,M)}if(!K)throw new v.UserDataSyncStoreError("Server returned "+j.res.statusCode,O,"Unknown",j.res.statusCode,M);return j}addSessionHeaders(O){let F=this.storageService.get(i,0);F===void 0&&(F=(0,f.generateUuid)(),this.storageService.store(i,F,0,1)),O["X-Machine-Session-Id"]=F;const z=this.storageService.get(c,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};h=de([Y(1,d.IProductService),Y(2,m.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,p.IFileService),Y(6,g.IStorageService)],h),e.UserDataSyncStoreClient=h;let S=class extends h{constructor(O,F,z,k,U,j,M){super(O.userDataSyncStore?.url,F,z,k,U,j,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};S=de([Y(0,v.IUserDataSyncStoreManagementService),Y(1,d.IProductService),Y(2,m.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,p.IFileService),Y(6,g.IStorageService)],S),e.UserDataSyncStoreService=S;class I{constructor(O,F,z,k){this.limit=O,this.interval=F,this.requestService=z,this.logService=k,this.requests=[],this.startTime=void 0}request(O,F,z){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new v.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[242],ie([0,1,3,60,26,24,21,238,25,64,65]),function(J,e,D,n,L,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(y,u,p,d,m,w,g,v,l,r,c){super(y,u,p,d,m,g,v,l,r,c);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};C=de([Y(0,L.IProductService),Y(1,b.IUserDataSyncStoreManagementService),Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncEnablementService),Y(4,b.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,b.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,A.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[243],ie([0,1,5,3,2]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ne[66],ie([0,1,50,5,10,15,22,124,255,256]),function(J,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,c){let i=c.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=c}}e.ExtractError=P;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(c=>r&c).reduce((c,i)=>c+i,r&61440)}function f(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function y(l,r,c,i,t,o){const s=L.dirname(r),a=L.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const h=L.join(i,r);let S;return o.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!o.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:c}),S.once("close",()=>I()),S.once("error",_),l.once("error",_),l.pipe(S)}catch(O){_(O)}}))}function u(l,r,c,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((s,a)=>{const h=new n.Sequencer,S=I=>{I.isCancellationRequested||(o++,l.readEntry())};l.once("error",a),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===o?s():a(new P("Incomplete",new Error(R.localize(1,null,o,l.entryCount))))},a)),l.readEntry(),l.on("entry",I=>{if(i.isCancellationRequested)return;if(!c.sourcePathRegex.test(I.fileName)){S(i);return}const _=I.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const z=L.join(r,_);t=(0,n.createCancelablePromise)(k=>T.Promises.mkdir(z,{recursive:!0}).then(()=>S(k)).then(void 0,a));return}const O=d(l,I),F=C(I);t=(0,n.createCancelablePromise)(z=>h.queue(()=>O.then(k=>y(k,_,F,r,c,z).then(()=>S(z)))).then(null,a))})})}function p(l,r=!1){return new Promise((c,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(t,o)=>{t?i(f(t)):c((0,A.assertIsDefined)(o))})})}function d(l,r){return new Promise((c,i)=>{l.openReadStream(r,(t,o)=>{t?i(f(t)):c((0,A.assertIsDefined)(o))})})}function m(l,r){return new Promise((c,i)=>{const t=new E.ZipFile;r.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>c(l))})}e.zip=m;function w(l,r,c={},i){const t=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=p(l,!0);return c.overwrite&&(o=o.then(s=>T.Promises.rm(r).then(()=>s))),o.then(s=>u(s,r,{sourcePathRegex:t},i))}e.extract=w;function g(l,r){return p(l).then(c=>new Promise((i,t)=>{c.on("entry",o=>{o.fileName===r&&d(c,o).then(s=>i(s),s=>t(s))}),c.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function v(l,r){return g(l,r).then(c=>new Promise((i,t)=>{const o=[];c.once("error",t),c.on("data",s=>o.push(s)),c.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=v}),define(ne[244],ie([0,1,66,133]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return(0,D.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(ne[245],ie([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,13,30,31,155,14,8,26]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let c=class extends A.Disposable{constructor(t,o,s,a,h){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=s,this.environmentService=a,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=a.builtinExtensionsPath,this.extensionsPath=a.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,s=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(s).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,s=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(s).message,m.ExtensionManagementErrorCode.Internal))));try{const s=await Promise.all(o);return(0,D.flatten)(s)}catch(s){throw this.joinErrors(s)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,s]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return s=s.filter(a=>!o[new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version).key()]),t&&(s=(0,w.groupByExtension)(s,h=>h.identifier).map(h=>h.sort((S,I)=>P.rcompare(S.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",s.length),s}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,s,a){const h=t.key(),S=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),I=R.join(this.extensionsPath,h);try{await y.Promises.rm(I)}catch{try{await y.Promises.rm(I)}catch{}throw new m.ExtensionManagementError((0,p.localize)(0,null,I,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,S,a);let _=await this.scanExtension(C.URI.file(S),1);if(!_)throw new Error((0,p.localize)(1,null,S));await this.storeMetadata(_,{...s,installedTimestamp:Date.now()});try{await this.rename(t,S,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(O){try{await y.Promises.rm(S)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(O)}. Deleted from extracted location`,S),O}try{_=await this.scanExtension(C.URI.file(I),1)}catch{}if(_)return _;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const s=R.join(t.location.fsPath,"package.json"),a=await y.Promises.readFile(s,"utf8"),{manifest:h}=await this.parseManifest(a);return h.__metadata=o,await y.Promises.writeFile(s,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(s=>new w.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version));await this.withUninstalledExtensions(s=>{o.forEach(a=>s[a.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(a=>delete a[t.key()]);const s=(await this.scanExtensions(1)).find(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version).equals(t))||null;return s?(await this.storeMetadata(s,{installedTimestamp:Date.now()}),this.scanExtension(s.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(a){if(a.code!=="ENOENT")throw a}let s={};if(o)try{s=JSON.parse(o)}catch{}return t&&(t(s),Object.keys(s).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(s)):await y.Promises.rm(this.uninstalledPath)),s})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await y.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,s,a){this.logService.trace(`Started extracting the extension from ${o} to ${s}`);try{await y.Promises.rm(s)}catch(h){throw new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,s,{sourcePath:"extension",overwrite:!0},a),this.logService.info(`Extracted extension to ${s}:`,t.id)}catch(h){try{await y.Promises.rm(s)}catch{}let S=m.ExtensionManagementErrorCode.Extract;throw h instanceof u.ExtractError&&(h.type==="CorruptZip"?S=m.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(S=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(h.message,S)}}async rename(t,o,s,a){try{await y.Promises.rename(o,s)}catch(h){if(b.isWindows&&h&&h.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${o} to ${s} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,s,a);throw new m.ExtensionManagementError(h.message||(0,p.localize)(3,null,o,s),h.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[s,a]=await Promise.all([t,o]);return[...s,...a]}async scanExtensionsInDir(t,o){const s=new n.Limiter(10),a=await this.fileService.resolve(C.URI.file(t));return a.children?(await Promise.all(a.children.filter(S=>S.isDirectory).map(S=>s.queue(async()=>o===1&&(0,E.basename)(S.resource).indexOf(".")===0?null:this.scanExtension(S.resource,o))))).filter(S=>S&&S.identifier):[]}async scanExtension(t,o){try{const s=await this.fileService.resolve(t);if(s.children){const{manifest:a,metadata:h}=await this.readManifest(t.fsPath),S=s.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,I=s.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource,_={id:(0,w.getGalleryExtensionId)(a.publisher,a.name)},O={type:o,identifier:_,manifest:a,location:t,readmeUrl:S,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(O,h),O}}catch(s){o!==0&&this.logService.trace(s)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(s=>t.some(a=>(0,w.areSameExtensions)(s.identifier,{id:a})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o?.publisherDisplayName||null,t.publisherId=o?.publisherId||null,t.identifier.uuid=o?.id,t.isMachineScoped=!!o?.isMachineScoped,t.isPreReleaseVersion=!!o?.isPreReleaseVersion,t.preRelease=!!o?.preRelease,t.isBuiltin=t.type===0||!!o?.isBuiltin,t.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),s=new Set;for(const S of o)t[new w.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]||s.add(S.identifier.id.toLowerCase());const a=(0,w.groupByExtension)(o,S=>S.identifier);await n.Promises.settled(a.map(async S=>{const I=S.sort((_,O)=>P.rcompare(_.manifest.version,O.manifest.version))[0];s.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const h=o.filter(S=>t[new w.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]);await n.Promises.settled(h.map(S=>this.removeUninstalledExtension(S)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],s=(0,w.groupByExtension)(t,a=>a.identifier);o.push(...(0,D.flatten)(s.map(a=>a.sort((h,S)=>P.rcompare(h.manifest.version,S.manifest.version)).slice(1)))),await n.Promises.settled(o.map(a=>this.removeExtension(a,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(T.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[y.Promises.readFile(R.join(t,"package.json"),"utf8").then(S=>this.parseManifest(S)),y.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,S=>S.code!=="ENOENT"?Promise.reject(S):"{}").then(S=>JSON.parse(S))],[{manifest:s,metadata:a},h]=await Promise.all(o);return{manifest:(0,g.localizeManifest)(s,h),metadata:a}}parseManifest(t){return new Promise((o,s)=>{try{const a=JSON.parse(t),h=a.__metadata||null;o({manifest:a,metadata:h})}catch{s(new Error((0,p.localize)(4,null)))}})}};c=de([Y(1,v.IFileService),Y(2,l.ILogService),Y(3,d.INativeEnvironmentService),Y(4,r.IProductService)],c),e.ExtensionsScanner=c}),define(ne[246],ie([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,13,207,30,31,189,175,244,190,245,221,78,14,6,8,26,21,34]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l,r,c,i,t,o,s,a,h,S,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends m.AbstractExtensionManagementService{constructor(M,G,K,x,q,X,H,Z,ee){super(M,G,K,Z);this.environmentService=x,this.downloadService=q,this.fileService=H;const W=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,V=>W.postUninstall(V))),this.manifestCache=this._register(new c.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(X.createInstance(v.ExtensionsDownloader));const N=this._register(new t.ExtensionsWatcher(this,H,x,K,ee));this._register(N.onDidChangeExtensionsByAnotherSource(({added:V,removed:$})=>{V.length&&this._onDidInstallExtensions.fire(V.map(B=>({identifier:B.identifier,operation:1,local:B}))),$.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(M?"alpine":T.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let M;try{M=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{M=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(K){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(K))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const G=await this.collectFiles(M),K=await(0,y.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return P.URI.file(K)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const G=await this.downloadVsix(M),K=A.resolve(G.fsPath);return(0,r.getManifest)(K)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,G={}){this.logService.trace("ExtensionManagementService#install",M.toString());const K=await this.downloadVsix(M),x=await(0,r.getManifest)(A.resolve(K.fsPath));if(x.engines&&x.engines.vscode&&!(0,o.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,g.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,K,G)}async updateMetadata(M,G){this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id);const K={...M.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(K.preRelease=!0),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,K),this.manifestCache.invalidate(),M}async updateExtensionScope(M,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===L.Schemas.file)return M;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(M,G),G}createInstallExtensionTask(M,G,K){return P.URI.isUri(G)?new k(M,G,K,this.galleryService,this.extensionsScanner,this.logService):new z(G,K,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,G){return new U(M,G,this.extensionsScanner)}async collectFiles(M){const G=async x=>{let q=await f.Promises.readdir(x);q=q.map(Z=>A.join(x,Z));const X=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return X.forEach((Z,ee)=>{const W=q[ee];Z.isFile()&&(H=H.then(N=>[...N,W])),Z.isDirectory()&&(H=H.then(N=>G(W).then(V=>[...N,...V])))}),H};return(await G(M.location.fsPath)).map(x=>({path:`extension/${A.relative(M.location.fsPath,x)}`,localPath:x}))}};O=de([Y(0,w.IExtensionGalleryService),Y(1,I.ITelemetryService),Y(2,h.ILogService),Y(3,d.INativeEnvironmentService),Y(4,p.IDownloadService),Y(5,a.IInstantiationService),Y(6,s.IFileService),Y(7,S.IProductService),Y(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class F extends m.AbstractExtensionTask{constructor(M,G,K,x){super();this.identifier=M,this.source=G,this.extensionsScanner=K,this.logService=x,this._operation=2}get operation(){return this._operation}async installExtension(M,G){try{const K=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(K)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...M.metadata}):K}catch{throw T.isMacintosh?new w.ExtensionManagementError(u.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(u.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(M,G)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const K=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),K}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:G,metadata:K},x){let q=await this.extensionsScanner.extractUserExtension(G,M,K,x);return this.logService.info("Extracting completed.",G.id),q}}class z extends F{constructor(M,G,K,x,q){super(M.identifier,M,x,q);this.gallery=M,this.options=G,this.extensionsDownloader=K}async doRun(M){const K=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,g.areSameExtensions)(q.identifier,this.gallery.identifier));K&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||K?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||K?.isBuiltin,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:K?.preRelease||this.options.installPreReleaseVersion;try{const q=await this.installExtension(x,M);return K&&E.neq(K.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(K),q}catch(q){throw await this.deleteDownloadedVSIX(x.zipPath),q}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(P.URI.file(M))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(M,G){const K={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",M.identifier.id),x=(await this.extensionsDownloader.downloadExtension(M,G)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,x)}catch(q){throw new w.ExtensionManagementError((0,m.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(x);return{zipPath:x,identifierWithVersion:new g.ExtensionIdentifierWithVersion(M.identifier,q.version),metadata:K}}catch(q){throw await this.deleteDownloadedVSIX(x),new w.ExtensionManagementError((0,m.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class k extends F{constructor(M,G,K,x,q,X){super({id:(0,g.getGalleryExtensionId)(M.publisher,M.name)},G,q,X);this.manifest=M,this.location=G,this.options=K,this.galleryService=x}async doRun(M){const G=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,g.areSameExtensions)(this.identifier,X.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,M);if(q.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,G.equals(new g.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const X=await this.unsetUninstalledAndGetLocal(G);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:A.resolve(this.location.fsPath),identifierWithVersion:G,metadata:q},M)}async getMetadata(M,G,K){try{let[x]=await this.galleryService.getExtensions([{id:M,version:G}],K);if(x||([x]=await this.galleryService.getExtensions([{id:M}],K)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class U extends m.AbstractExtensionTask{constructor(M,G,K){super();this.extension=M,this.options=G,this.extensionsScanner=K}async doRun(M){const G=[],K=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...K.filter(q=>x.equals(new g.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else G.push(...K.filter(x=>(0,g.areSameExtensions)(x.identifier,this.extension.identifier)));if(!G.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const x of G)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(q){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(q)))}}}}),define(ne[247],ie([0,1,83,56,33,17,9,3,2,10,4,29,36,73,257]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(A.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=p;var d;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var m;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(I,_,O,F){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new g(this,_,O,F,this._onData,(z,k)=>this._write(z,k))),this._register(this._flowManager.onError(z=>{console.error(z),(0,T.onUnexpectedError)(z),this._onClose.fire({type:0,hadError:!0,error:z})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(z=>this._onClose.fire(z)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const F=A.VSBuffer.alloc(O);if(_?F.writeUInt8(194,0):F.writeUInt8(130,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let z=1;F.writeUInt8(I.byteLength>>>8&255,++z),F.writeUInt8(I.byteLength>>>0&255,++z)}else{F.writeUInt8(127,1);let z=1;F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(I.byteLength>>>24&255,++z),F.writeUInt8(I.byteLength>>>16&255,++z),F.writeUInt8(I.byteLength>>>8&255,++z),F.writeUInt8(I.byteLength>>>0&255,++z)}this.socket.write(A.VSBuffer.concat([F,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),F=(O&128)>>>7,z=(O&64)>>>6,k=_.readUInt8(1),U=(k&128)>>>7,j=k&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(z)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),F=(O&128)>>>7;let z=O&127,k=1;z===126?z=_.readUInt8(++k)*2**8+_.readUInt8(++k):z===127&&(z=_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k));let U=0;F&&(U=_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k)),this._state.state=3,this._state.readLen=z,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends b.Disposable{constructor(I,_,O,F,z,k){super();this._tracer=I,this._onData=z,this._writeFn=k,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new v(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,F)=>{I.write(_),I.flush(z=>O(z))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((F,z)=>{I.write(_),O&&I.write(A.VSBuffer.fromByteArray([0,0,255,255])),I.flush(k=>F(k))})}}class v extends b.Disposable{constructor(I,_,O,F){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(F),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent("zlibInflateData",z),this._pendingInflateData.push(A.VSBuffer.wrap(z))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class l extends b.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function r(S,I){if(I===0)return;let _=S.byteLength>>>2;for(let j=0;j<_;j++){const M=S.readUInt32BE(j*4);S.writeUInt32BE(M^I,j*4)}let O=_*4,F=S.byteLength-O;const z=I>>>24&255,k=I>>>16&255,U=I>>>8&255;F>=1&&S.writeUInt8(S.readUInt8(O)^z,O),F>=2&&S.writeUInt8(S.readUInt8(O+1)^k,O+1),F>=3&&S.writeUInt8(S.readUInt8(O+2)^U,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function i(){const S=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):I=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${S}.sock`),o(I),I}e.createRandomIPCHandle=i;function t(S,I,_){const O=(0,D.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):F=(0,E.join)(S,`${_}-${I}.sock`),o(F),F}e.createStaticIPCHandle=t;function o(S){const I=c[P.platform];typeof I=="number"&&S.length>=I&&console.warn(`WARNING: IPC handle "${S}" is longer than ${I} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(I){super(s.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new y.Protocol(new p(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(S){return new Promise((I,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(S,()=>{O.removeListener("error",_),I(new s(O))})})}e.serve=a;function h(S,I){return new Promise((_,O)=>{const F=(0,n.createConnection)(S,()=>{F.removeListener("error",O),_(y.Client.fromSocket(new p(F,`ipc-client${I}`),I))});F.once("error",O)})}e.connect=h}),define(ne[248],ie([0,1,56,247]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,A,T,R,b){const E=C=>b(C,void 0),P=D.createConnection({host:L,port:A},()=>{P.removeListener("error",E);const C=Buffer.alloc(16);for(let p=0;p<16;p++)C[p]=Math.round(Math.random()*256);const f=C.toString("base64"),y=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${A}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(y.join(`\r
`)+`\r
\r
`);const u=p=>{p.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",u),b(void 0,new n.NodeSocket(P,R)))};P.on("data",u)});P.setNoDelay(!0),P.once("error",E)}}}),define(ne[249],ie([0,1,56,115,248,5,2,20,8,26,186,62,92]),function(J,e,D,n,L,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(w,g,v,l,r){let c;for(let i=3;i&&(c&&c.dispose(),c=await new u(w,g,v,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class u extends T.Disposable{constructor(g,v,l,r,c){super();this.defaultTunnelHost=v,this.suggestedLocalPort=c,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=D.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(v=>{v()})}async waitForReady(){let g=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),v=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address(),v||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address()),this.tunnelLocalPort=v.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${v.port}`,this}async _onConnection(g){g.pause();const v=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,v,this.tunnelRemotePort),r=l.getSocket().socket,c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&g.write(c.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let p=class extends C.AbstractTunnelService{constructor(g,v,l,r,c){super(v);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=c}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,v,l,r,c,i,t){const o=this.getTunnelFromMap(v,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,v,l,r,c,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${v}:${l} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},a=y(s,this.defaultTunnelHost,v,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(v,l,a),a}}};p=de([Y(1,b.ILogService),Y(2,f.ISignService),Y(3,E.IProductService),Y(4,R.IConfigurationService)],p),e.BaseTunnelService=p;let d=class extends p{constructor(g,v,l,r){super(L.nodeSocketFactory,g,v,l,r)}};d=de([Y(0,b.ILogService),Y(1,f.ISignService),Y(2,E.IProductService),Y(3,R.IConfigurationService)],d),e.TunnelService=d;let m=class extends T.Disposable{constructor(g,v,l,r){super();this.logService=g,this.productService=v,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,v,l,r,c,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${c}.`),!this._tunnelServices.has(g)){const s=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(g,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(v,l,r,c,i,t,o)}};m=de([Y(0,b.ILogService),Y(1,E.IProductService),Y(2,f.ISignService),Y(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ne[258],ie([0,1,74,33,37,9,2,18,19,7,36,118,180,202,181,172,173,174,158,161,20,184,80,206,81,195,13,199,201,210,30,160,208,246,82,156,14,177,179,51,6,169,85,170,171,59,191,8,86,60,87,26,194,43,24,204,205,21,93,94,95,44,211,212,96,214,220,63,98,25,64,234,236,237,65,235,239,240,241,242,243,92,200,62,249,192,193,91,198,209,34,222,4,223,164,183,182]),function(J,e,D,n,L,A,T,R,b,E,P,C,f,y,u,p,d,m,w,g,v,l,r,c,i,t,o,s,a,h,S,I,_,O,F,z,k,U,j,M,G,K,x,q,X,H,Z,ee,W,N,V,$,B,te,se,ce,he,ve,pe,Ee,Ce,we,be,Re,Fe,Me,qe,Be,re,ae,ue,ye,Pe,Ne,Te,Oe,_e,Q,oe,le,fe,ge,Le,Se,De,ke,Ie,Ae,ze,je,xe,It,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends T.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Ye,$e)=>this.onDisposeWorker($e);D.ipcRenderer.on(Ue,We),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,We)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Ue=>{const We=Ue.get(ee.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(We)}),this._register((0,T.combinedDisposable)(me.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(u.LanguagePackCachedDataCleaner),me.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(d.LogsDataCleaner),me.createInstance(p.LocalizationsUpdater),me.createInstance(y.ExtensionsCleaner)))}async initServices(){const me=new x.ServiceCollection,Ue={_serviceBrand:void 0,...V.default};me.set($.IProductService,Ue);const We=new P.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,We);me.set(X.IMainProcessService,Ye);const $e=new s.SharedProcessEnvironmentService(this.configuration.args,Ue);me.set(o.INativeEnvironmentService,$e);const it=new W.LogLevelChannelClient(this.server.getChannel("logLevel",We)),Xe=new W.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));me.set(ee.ILoggerService,Xe);const ot=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file($e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new W.FollowerLogService(it,ot));me.set(ee.ILogService,Je),this.sharedProcessWorkerService=new ze.SharedProcessWorkerService(Je,Ue,$e),me.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new U.FileService(Je));me.set(k.IFileService,Ve);const at=this._register(new j.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService($e.settingsResource,Ve));me.set(v.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,$e);me.set(se.IStorageService,et),this._register((0,T.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),me.set(xe.IUriIdentityService,new It.UriIdentityService(Ve)),me.set(te.IRequestService,new M.SyncDescriptor(B.RequestService)),me.set(w.IChecksumService,new M.SyncDescriptor(g.ChecksumService)),me.set(St.IV8InspectProfilingService,new M.SyncDescriptor(kt.InspectProfilingService));const rt=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(N.INativeHostService,rt),me.set(i.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new P.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));me.set(F.IExtensionRecommendationNotificationService,new z.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new je.AssignmentService(this.configuration.machineId,He,Ue);let tt;const Qe=[];if((0,we.supportsTelemetry)(Ue,$e)){const Ge=new Ee.TelemetryLogAppender(Xe,$e);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=$e;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&st){const bt=new be.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,st,!0);this._register((0,T.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new be.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,T.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Ce.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=we.NullTelemetryService;const Ge=we.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),me.set(ve.ITelemetryService,tt);const At=new Re.CustomEndpointTelemetryService(He,tt,Xe,$e);me.set(ve.ICustomEndpointTelemetryService,At),me.set(S.IExtensionManagementService,new M.SyncDescriptor(O.ExtensionManagementService)),me.set(S.IExtensionGalleryService,new M.SyncDescriptor(h.ExtensionGalleryService)),me.set(S.IExtensionTipsService,new M.SyncDescriptor(_.ExtensionTipsService)),me.set(H.ILocalizationsService,new M.SyncDescriptor(Z.LocalizationsService)),me.set(r.IDiagnosticsService,new M.SyncDescriptor(c.DiagnosticsService)),me.set(ue.IUserDataSyncAccountService,new M.SyncDescriptor(ue.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new M.SyncDescriptor(Ne.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new Pe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),me.set(S.IGlobalExtensionEnablementService,new M.SyncDescriptor(a.GlobalExtensionEnablementService)),me.set(re.IIgnoredExtensionsManagementService,new M.SyncDescriptor(re.IgnoredExtensionsManagementService)),me.set(Be.IExtensionStorageService,new M.SyncDescriptor(Be.ExtensionStorageService)),me.set(ae.IUserDataSyncStoreManagementService,new M.SyncDescriptor(oe.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new M.SyncDescriptor(oe.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new M.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new M.SyncDescriptor(ye.UserDataSyncBackupStoreService)),me.set(ae.IUserDataSyncEnablementService,new M.SyncDescriptor(Oe.UserDataSyncEnablementService)),me.set(ae.IUserDataSyncService,new M.SyncDescriptor(_e.UserDataSyncService));const wt=new qe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,$e,Je,tt);return await wt.initialize(),me.set(Me.ILocalPtyService,this._register(wt)),me.set(ge.ISignService,new M.SyncDescriptor(Le.SignService)),me.set(Se.ISharedTunnelsService,new M.SyncDescriptor(De.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new M.SyncDescriptor(Ie.SharedProcessTunnelService)),new K.InstantiationService(me)}initChannels(me){const Ue=new I.ExtensionManagementChannel(me.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const We=P.ProxyChannel.fromService(me.get(H.ILocalizationsService));this.server.registerChannel("localizations",We);const Ye=P.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const $e=new I.ExtensionTipsChannel(me.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",$e);const it=P.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=P.ProxyChannel.fromService(me.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Pe.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=P.ProxyChannel.fromService(me.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Pe.UserDataSyncAccountServiceChannel(me.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Pe.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new Q.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(ee.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(me.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Pe.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=me.get(Me.ILocalPtyService),lt=P.ProxyChannel.fromService(rt);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(me.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Ue=>{(0,A.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Ue=>{const We=(0,L.toErrorMessage)(Ue,!0);!We||me.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Tt(yt){const me=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23aa7ad51c95d90d48b1d352a316d7f0c2c4310d/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
