/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Z){for(var e=[],m=0,t=Z.length;m<t;m++)e[m]=pe[Z[m]];return e};define(pe[55],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=m}),define(pe[74],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(T){return T?T.replace(/\$\((.*?)\)/g,(k,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=m;class t{constructor(k,_,P){this.id=k,this.definition=_,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(T,k){const _=["codicon","codicon-"+T];return k&&_.push("codicon-modifier-"+k),_}e.getClassNamesArray=I;var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function _(C){if(C instanceof t)return["codicon","codicon-"+C.id];const l=k.exec(C.id);if(!l)return _(t.error);let[,w,p]=l;const g=["codicon","codicon-"+w];return p&&g.push("codicon-modifier-"+p.substr(1)),g}T.asClassNameArray=_;function P(C){return _(C).join(" ")}T.asClassName=P;function R(C){return"."+_(C).join(".")}T.asCSSSelector=R})(D=e.CSSIcon||(e.CSSIcon={}))}),define(pe[75],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function t(R){const C=[];for(let l in R)m.call(R,l)&&C.push(R[l]);return C}e.values=t;function I(R,C){for(let l in R)if(m.call(R,l)&&C({key:l,value:R[l]},function(){delete R[l]})===!1)return}e.forEach=I;function D(R,C){const l=Object.create(null);for(const w of R){const p=C(w);let g=l[p];g||(g=l[p]=[]),g.push(w)}return l}e.groupBy=D;function T(R){const C=Object.create(null);return R&&R.forEach((l,w)=>{C[w]=l}),C}e.fromMap=T;function k(R,C){const l=[],w=[];for(let p of R)C.has(p)||l.push(p);for(let p of C)R.has(p)||w.push(p);return{removed:l,added:w}}e.diffSets=k;function _(R,C){const l=[],w=[];for(let[p,g]of R)C.has(p)||l.push(g);for(let[p,g]of C)R.has(p)||w.push(g);return{removed:l,added:w}}e.diffMaps=_;class P{constructor(){this.map=new Map}add(C,l){let w=this.map.get(C);w||(w=new Set,this.map.set(C,w)),w.add(l)}delete(C,l){const w=this.map.get(C);!w||(w.delete(l),w.size===0&&this.map.delete(C))}forEach(C,l){const w=this.map.get(C);!w||w.forEach(l)}}e.SetMap=P}),define(pe[56],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(T){return(k,_,P)=>{let R=null,C=null;if(typeof P.value=="function"?(R="value",C=P.value):typeof P.get=="function"&&(R="get",C=P.get),!C)throw new Error("not supported");P[R]=T(C,_)}}e.createDecorator=m;function t(T,k,_){let P=null,R=null;if(typeof _.value=="function"?(P="value",R=_.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(P="get",R=_.get),!R)throw new Error("not supported");const C=`$memoize$${k}`;_[P]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[C]}}e.memoize=t;function I(T,k,_){return m((P,R)=>{const C=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...w){this[l]||(this[l]=_?_():void 0),clearTimeout(this[C]),k&&(this[l]=k(this[l],...w),w=[this[l]]),this[C]=setTimeout(()=>{P.apply(this,w),this[l]=_?_():void 0},T)}})}e.debounce=I;function D(T,k,_){return m((P,R)=>{const C=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,w=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...g){if(this[l]||(this[l]=_?_():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...g)),this[p])return;const E=this[w]+T;E<=Date.now()?(this[w]=Date.now(),P.apply(this,[this[l]]),this[l]=_?_():void 0):(this[p]=!0,this[C]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),P.apply(this,[this[l]]),this[l]=_?_():void 0},E-Date.now()))}})}e.throttle=D}),define(pe[16],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(S=>{S(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=m,e.errorHandler=new m;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function I(f){_(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=I;function D(f){_(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=D;function T(f){if(f instanceof Error){let{name:o,message:S}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:o,message:S,stack:s}}return f}e.transformErrorForSerialization=T;const k="Canceled";function _(f){return f instanceof P?!0:f instanceof Error&&f.name===k&&f.message===k}e.isCancellationError=_;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function R(){const f=new Error(k);return f.name=f.message,f}e.canceled=R;function C(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=C;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=l;function w(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function p(f){const o=new Error(`${f} has been disposed`);return o.name="DISPOSED",o}e.disposed=p;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class E extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=E;class F extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=F;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function u(f){const o=f;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=u;function r(f,o=Object.create(null)){const S=new Error(f);return o.actions&&(S.actions=o.actions),S}e.createErrorWithActions=r}),define(pe[17],ve([0,1,16]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(K,Q=0){return K[K.length-(1+Q)]}e.tail=t;function I(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=I;function D(K,Q,ae=(fe,be)=>fe===be){if(K===Q)return!0;if(!K||!Q||K.length!==Q.length)return!1;for(let fe=0,be=K.length;fe<be;fe++)if(!ae(K[fe],Q[fe]))return!1;return!0}e.equals=D;function T(K,Q,ae){let fe=0,be=K.length-1;for(;fe<=be;){const Me=(fe+be)/2|0,xe=ae(K[Me],Q);if(xe<0)fe=Me+1;else if(xe>0)be=Me-1;else return Me}return-(fe+1)}e.binarySearch=T;function k(K,Q){let ae=0,fe=K.length;if(fe===0)return 0;for(;ae<fe;){const be=Math.floor((ae+fe)/2);Q(K[be])?fe=be:ae=be+1}return ae}e.findFirstInSorted=k;function _(K,Q,ae){if(K=K|0,K>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],be=[],Me=[],xe=[];for(let Ge of Q){const Je=ae(Ge,fe);Je<0?be.push(Ge):Je>0?Me.push(Ge):xe.push(Ge)}return K<be.length?_(K,be,ae):K<be.length+xe.length?xe[0]:_(K-(be.length+xe.length),Me,ae)}e.quickSelect=_;function P(K,Q){const ae=[];let fe;for(const be of K.slice(0).sort(Q))!fe||Q(fe[0],be)!==0?(fe=[be],ae.push(fe)):fe.push(be);return ae}e.groupBy=P;function R(K,Q,ae){const fe=[];function be(Ge,Je,q){if(Je===0&&q.length===0)return;const te=fe[fe.length-1];te&&te.start+te.deleteCount===Ge?(te.deleteCount+=Je,te.toInsert.push(...q)):fe.push({start:Ge,deleteCount:Je,toInsert:q})}let Me=0,xe=0;for(;;){if(Me===K.length){be(Me,0,Q.slice(xe));break}if(xe===Q.length){be(Me,K.length-Me,[]);break}const Ge=K[Me],Je=Q[xe],q=ae(Ge,Je);q===0?(Me+=1,xe+=1):q<0?(be(Me,1,[]),Me+=1):q>0&&(be(Me,0,[Je]),xe+=1)}return fe}e.sortedDiff=R;function C(K,Q,ae){const fe=R(K,Q,ae),be=[],Me=[];for(const xe of fe)be.push(...K.slice(xe.start,xe.start+xe.deleteCount)),Me.push(...xe.toInsert);return{removed:be,added:Me}}e.delta=C;function l(K,Q,ae){if(ae===0)return[];const fe=K.slice(0,ae).sort(Q);return p(K,Q,fe,ae,K.length),fe}e.top=l;function w(K,Q,ae,fe,be){return ae===0?Promise.resolve([]):new Promise((Me,xe)=>{(async()=>{const Ge=K.length,Je=K.slice(0,ae).sort(Q);for(let q=ae,te=Math.min(ae+fe,Ge);q<Ge;q=te,te=Math.min(te+fe,Ge)){if(q>ae&&await new Promise(G=>setTimeout(G)),be&&be.isCancellationRequested)throw(0,m.canceled)();p(K,Q,Je,q,te)}return Je})().then(Me,xe)})}e.topAsync=w;function p(K,Q,ae,fe,be){for(const Me=ae.length;fe<be;fe++){const xe=K[fe];if(Q(xe,ae[Me-1])<0){ae.pop();const Ge=k(ae,Je=>Q(xe,Je)<0);ae.splice(Ge,0,xe)}}}function g(K){return K.filter(Q=>!!Q)}e.coalesce=g;function E(K){let Q=0;for(let ae=0;ae<K.length;ae++)K[ae]&&(K[Q]=K[ae],Q+=1);K.length=Q}e.coalesceInPlace=E;function F(K,Q,ae){K.splice(ae,0,K.splice(Q,1)[0])}e.move=F;function y(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=y;function u(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=u;function r(K,Q=ae=>ae){const ae=new Set;return K.filter(fe=>{const be=Q(fe);return ae.has(be)?!1:(ae.add(be),!0)})}e.distinct=r;function f(K){const Q=new Set;return ae=>{const fe=K(ae);return Q.has(fe)?!1:(Q.add(fe),!0)}}e.uniqueFilter=f;function o(K,Q){const ae=S(K,Q);if(ae!==-1)return K[ae]}e.findLast=o;function S(K,Q){for(let ae=K.length-1;ae>=0;ae--){const fe=K[ae];if(Q(fe))return ae}return-1}e.lastIndex=S;function s(K,Q){return K.length>0?K[0]:Q}e.firstOrDefault=s;function i(K,Q,ae=(fe,be)=>fe===be){let fe=0;for(let be=0,Me=Math.min(K.length,Q.length);be<Me&&ae(K[be],Q[be]);be++)fe++;return fe}e.commonPrefixLength=i;function n(K){return[].concat(...K)}e.flatten=n;function c(K,Q){let ae=typeof Q=="number"?K:0;typeof Q=="number"?ae=K:(ae=0,Q=K);const fe=[];if(ae<=Q)for(let be=ae;be<Q;be++)fe.push(be);else for(let be=ae;be>Q;be--)fe.push(be);return fe}e.range=c;function a(K,Q,ae){return K.reduce((fe,be)=>(fe[Q(be)]=ae?ae(be):be,fe),Object.create(null))}e.index=a;function h(K,Q){return K.push(Q),()=>d(K,Q)}e.insert=h;function d(K,Q){const ae=K.indexOf(Q);if(ae>-1)return K.splice(ae,1),Q}e.remove=d;function v(K,Q,ae){const fe=K.slice(0,Q),be=K.slice(Q);return fe.concat(ae,be)}e.arrayInsert=v;function b(K,Q){let ae;if(typeof Q=="number"){let fe=Q;ae=()=>{const be=Math.sin(fe++)*179426549;return be-Math.floor(be)}}else ae=Math.random;for(let fe=K.length-1;fe>0;fe-=1){const be=Math.floor(ae()*(fe+1)),Me=K[fe];K[fe]=K[be],K[be]=Me}}e.shuffle=b;function A(K,Q){const ae=K.indexOf(Q);ae>-1&&(K.splice(ae,1),K.unshift(Q))}e.pushToStart=A;function O(K,Q){const ae=K.indexOf(Q);ae>-1&&(K.splice(ae,1),K.push(Q))}e.pushToEnd=O;function N(K,Q){return Array.isArray(K)?K.map(Q):Q(K)}e.mapArrayOrNot=N;function L(K){return Array.isArray(K)?K:[K]}e.asArray=L;function M(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=M;function V(K,Q){for(const ae of K){const fe=Q(ae);if(fe!==void 0)return fe}}e.mapFind=V;function H(K,Q,ae){const fe=B(K,Q),be=K.length,Me=ae.length;K.length=be+Me;for(let xe=be-1;xe>=fe;xe--)K[xe+Me]=K[xe];for(let xe=0;xe<Me;xe++)K[xe+fe]=ae[xe]}e.insertInto=H;function U(K,Q,ae,fe){const be=B(K,Q),Me=K.splice(be,ae);return H(K,be,fe),Me}e.splice=U;function B(K,Q){return Q<0?Math.max(Q+K.length,0):Math.min(Q,K.length)}function $(K,Q){return(ae,fe)=>Q(K(ae),K(fe))}e.compareBy=$;const z=(K,Q)=>K-Q;e.numberComparator=z;function W(K,Q){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];Q(be,ae)>0&&(ae=be)}return ae}e.findMaxBy=W;function J(K,Q){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];Q(be,ae)>=0&&(ae=be)}return ae}e.findLastMaxBy=J;function ne(K,Q){return W(K,(ae,fe)=>-Q(ae,fe))}e.findMinBy=ne;class se{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let ae=this.firstIdx;for(;ae<this.items.length&&Q(this.items[ae]);)ae++;const fe=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,fe}takeFromEndWhile(Q){let ae=this.lastIdx;for(;ae>=0&&Q(this.items[ae]);)ae--;const fe=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,fe}peek(){return this.items[this.firstIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}takeCount(Q){const ae=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,ae}}e.ArrayQueue=se}),define(pe[76],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(t){const I=this;let D=!1,T;return function(){return D||(D=!0,T=t.apply(I,arguments)),T}}e.once=m}),define(pe[77],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(pe[78],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(t){function I(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=I;const D=Object.freeze([]);function T(){return D}t.empty=T;function*k(f){yield f}t.single=k;function _(f){return f||D}t.from=_;function P(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=P;function R(f){return f[Symbol.iterator]().next().value}t.first=R;function C(f,o){for(const S of f)if(o(S))return!0;return!1}t.some=C;function l(f,o){for(const S of f)if(o(S))return S}t.find=l;function*w(f,o){for(const S of f)o(S)&&(yield S)}t.filter=w;function*p(f,o){let S=0;for(const s of f)yield o(s,S++)}t.map=p;function*g(...f){for(const o of f)for(const S of o)yield S}t.concat=g;function*E(f){for(const o of f)for(const S of o)yield S}t.concatNested=E;function F(f,o,S){let s=S;for(const i of f)s=o(s,i);return s}t.reduce=F;function*y(f,o,S=f.length){for(o<0&&(o+=f.length),S<0?S+=f.length:S>f.length&&(S=f.length);o<S;o++)yield f[o]}t.slice=y;function u(f,o=Number.POSITIVE_INFINITY){const S=[];if(o===0)return[S,f];const s=f[Symbol.iterator]();for(let i=0;i<o;i++){const n=s.next();if(n.done)return[S,t.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return s}}]}t.consume=u;function r(f,o,S=(s,i)=>s===i){const s=f[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const n=s.next(),c=i.next();if(n.done!==c.done)return!1;if(n.done)return!0;if(!S(n.value,c.value))return!1}}t.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(pe[57],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(o){o.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function T(o,S=!1){let s=0,i=o.length,n="",c=0,a=16,h=0;function d(M){let V=0,H=0;for(;V<M;){const U=o.charCodeAt(s);if(U>=48&&U<=57)H=H*16+U-48;else if(U>=65&&U<=70)H=H*16+U-65+10;else if(U>=97&&U<=102)H=H*16+U-97+10;else break;s++,V++}return V<M&&(H=-1),H}function v(M){s=M,n="",c=0,a=16,h=0}function b(){const M=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&P(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&P(o.charCodeAt(s)))for(s++;s<o.length&&P(o.charCodeAt(s));)s++;else return h=3,o.substring(M,s);let V=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&P(o.charCodeAt(s))){for(s++;s<o.length&&P(o.charCodeAt(s));)s++;V=s}else h=3;return o.substring(M,V)}function A(){let M="",V=s;for(;;){if(s>=i){M+=o.substring(V,s),h=2;break}const H=o.charCodeAt(s);if(H===34){M+=o.substring(V,s),s++;break}if(H===92){if(M+=o.substring(V,s),s++,s>=i){h=2;break}switch(o.charCodeAt(s++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=d(4);B>=0?M+=String.fromCharCode(B):h=4;break}default:h=5}V=s;continue}if(H>=0&&H<=31)if(_(H)){M+=o.substring(V,s),h=2;break}else h=6;s++}return M}function O(){if(n="",h=0,c=s,s>=i)return c=i,a=17;let M=o.charCodeAt(s);if(k(M)){do s++,n+=String.fromCharCode(M),M=o.charCodeAt(s);while(k(M));return a=15}if(_(M))return s++,n+=String.fromCharCode(M),M===13&&o.charCodeAt(s)===10&&(s++,n+=`
`),a=14;switch(M){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,n=A(),a=10;case 47:{const V=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!_(o.charCodeAt(s));)s++;return n=o.substring(V,s),a=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let U=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,h=1),n=o.substring(V,s),a=13}return n+=String.fromCharCode(M),s++,a=16}case 45:if(n+=String.fromCharCode(M),s++,s===i||!P(o.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=b(),a=11;default:for(;s<i&&N(M);)s++,M=o.charCodeAt(s);if(c!==s){switch(n=o.substring(c,s),n){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return n+=String.fromCharCode(M),s++,a=16}}function N(M){if(k(M)||_(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:v,getPosition:()=>s,scan:S?L:O,getToken:()=>a,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>h}}e.createScanner=T;function k(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function _(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function C(o,S){const s=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(d,v,b,A){c.value=d,c.offset=v,c.length=b,c.type=A,c.colonOffset=void 0,n=c}try{u(o,{onObjectBegin:(d,v)=>{if(S<=d)throw i;n=void 0,a=S>d,s.push("")},onObjectProperty:(d,v,b)=>{if(S<v||(h(d,v,b,"property"),s[s.length-1]=d,S<=v+b))throw i},onObjectEnd:(d,v)=>{if(S<=d)throw i;n=void 0,s.pop()},onArrayBegin:(d,v)=>{if(S<=d)throw i;n=void 0,s.push(0)},onArrayEnd:(d,v)=>{if(S<=d)throw i;n=void 0,s.pop()},onLiteralValue:(d,v,b)=>{if(S<v||(h(d,v,b,f(d)),S<=v+b))throw i},onSeparator:(d,v,b)=>{if(S<=v)throw i;if(d===":"&&n&&n.type==="property")n.colonOffset=v,a=!1,n=void 0;else if(d===","){const A=s[s.length-1];typeof A=="number"?s[s.length-1]=A+1:(a=!0,s[s.length-1]=""),n=void 0}}})}catch(d){if(d!==i)throw d}return{path:s,previousNode:n,isAtPropertyKey:a,matches:d=>{let v=0;for(let b=0;v<d.length&&b<s.length;b++)if(d[v]===s[b]||d[v]==="*")v++;else if(d[v]!=="**")return!1;return v===d.length}}}e.getLocation=C;function l(o,S=[],s=D.DEFAULT){let i=null,n=[];const c=[];function a(d){Array.isArray(n)?n.push(d):i!==null&&(n[i]=d)}return u(o,{onObjectBegin:()=>{const d={};a(d),c.push(n),n=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const d=[];a(d),c.push(n),n=d,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:a,onError:(d,v,b)=>{S.push({error:d,offset:v,length:b})}},s),n[0]}e.parse=l;function w(o,S=[],s=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(d){i.type==="property"&&(i.length=d-i.offset,i=i.parent)}function c(d){return i.children.push(d),d}u(o,{onObjectBegin:d=>{i=c({type:"object",offset:d,length:-1,parent:i,children:[]})},onObjectProperty:(d,v,b)=>{i=c({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:d,offset:v,length:b,parent:i})},onObjectEnd:(d,v)=>{i.length=d+v-i.offset,i=i.parent,n(d+v)},onArrayBegin:(d,v)=>{i=c({type:"array",offset:d,length:-1,parent:i,children:[]})},onArrayEnd:(d,v)=>{i.length=d+v-i.offset,i=i.parent,n(d+v)},onLiteralValue:(d,v,b)=>{c({type:f(d),offset:v,length:b,parent:i,value:d}),n(v+b)},onSeparator:(d,v,b)=>{i.type==="property"&&(d===":"?i.colonOffset=v:d===","&&n(v))},onError:(d,v,b)=>{S.push({error:d,offset:v,length:b})}},s);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=w;function p(o,S){if(!o)return;let s=o;for(let i of S)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===i){s=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=p;function g(o){if(!o.parent||!o.parent.children)return[];const S=g(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;S.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&S.push(s)}return S}e.getNodePath=g;function E(o){switch(o.type){case"array":return o.children.map(E);case"object":{const S=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(S[s.children[0].value]=E(i))}return S}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=E;function F(o,S,s=!1){return S>=o.offset&&S<o.offset+o.length||s&&S===o.offset+o.length}e.contains=F;function y(o,S,s=!1){if(F(o,S,s)){const i=o.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=S;n++){const c=y(i[n],S,s);if(c)return c}return o}}e.findNodeAtOffset=y;function u(o,S,s=D.DEFAULT){const i=T(o,!1);function n(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(se){return se?K=>se(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=n(S.onObjectBegin),h=c(S.onObjectProperty),d=n(S.onObjectEnd),v=n(S.onArrayBegin),b=n(S.onArrayEnd),A=c(S.onLiteralValue),O=c(S.onSeparator),N=n(S.onComment),L=c(S.onError),M=s&&s.disallowComments,V=s&&s.allowTrailingComma;function H(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(se){case 12:case 13:M?U(10):N();break;case 16:U(1);break;case 15:case 14:break;default:return se}}}function U(se,K=[],Q=[]){if(L(se),K.length+Q.length>0){let ae=i.getToken();for(;ae!==17;){if(K.indexOf(ae)!==-1){H();break}else if(Q.indexOf(ae)!==-1)break;ae=H()}}}function B(se){const K=i.getTokenValue();return se?A(K):h(K),H(),!0}function $(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(U(2),se=0)}catch{U(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return H(),!0}function z(){return i.getToken()!==10?(U(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(O(":"),H(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function W(){a(),H();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||U(4,[],[]),O(","),H(),i.getToken()===2&&V)break}else se&&U(6,[],[]);z()||U(4,[],[2,5]),se=!0}return d(),i.getToken()!==2?U(7,[2],[]):H(),!0}function J(){v(),H();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||U(4,[],[]),O(","),H(),i.getToken()===4&&V)break}else se&&U(6,[],[]);ne()||U(4,[],[4,5]),se=!0}return b(),i.getToken()!==4?U(8,[4],[]):H(),!0}function ne(){switch(i.getToken()){case 3:return J();case 1:return W();case 10:return B(!0);default:return $()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(i.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=u;function r(o,S){let s=T(o),i=[],n,c=0,a;do switch(a=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==a&&i.push(o.substring(c,a)),S!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,S)),c=s.getPosition();break}while(n!==17);return i.join("")}e.stripComments=r;function f(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(pe[139],ve([0,1,57]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,R,C){let l,w,p,g,E;if(R){for(g=R.offset,E=g+R.length,p=g;p>0&&!_(P,p-1);)p--;let a=E;for(;a<P.length&&!_(P,a);)a++;w=P.substring(p,a),l=T(w,C)}else w=P,l=0,p=0,g=0,E=P.length;const F=k(C,P);let y=!1,u=0,r;C.insertSpaces?r=D(" ",C.tabSize||4):r="	";const f=(0,m.createScanner)(w,!1);let o=!1;function S(){return F+D(r,l+u)}function s(){let a=f.scan();for(y=!1;a===15||a===14;)y=y||a===14,a=f.scan();return o=a===16||f.getTokenError()!==0,a}const i=[];function n(a,h,d){!o&&h<E&&d>g&&P.substring(h,d)!==a&&i.push({offset:h,length:d-h,content:a})}let c=s();if(c!==17){const a=f.getTokenOffset()+p,h=D(r,l);n(h,p,a)}for(;c!==17;){let a=f.getTokenOffset()+f.getTokenLength()+p,h=s(),d="";for(;!y&&(h===12||h===13);){const b=f.getTokenOffset()+p;n(" ",a,b),a=f.getTokenOffset()+f.getTokenLength()+p,d=h===12?S():"",h=s()}if(h===2)c!==1&&(u--,d=S());else if(h===4)c!==3&&(u--,d=S());else{switch(c){case 3:case 1:u++,d=S();break;case 5:case 12:d=S();break;case 13:y?d=S():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(o=!0);break;case 16:o=!0;break}y&&(h===12||h===13)&&(d=S())}const v=f.getTokenOffset()+p;n(d,a,v),c=h}return i}e.format=t;function I(P,R){const C=JSON.stringify(P,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?C.replace(/\r\n|\r|\n/g,R.eol):C}e.toFormattedString=I;function D(P,R){let C="";for(let l=0;l<R;l++)C+=P;return C}function T(P,R){let C=0,l=0;const w=R.tabSize||4;for(;C<P.length;){const p=P.charAt(C);if(p===" ")l++;else if(p==="	")l+=w;else break;C++}return Math.floor(l/w)}function k(P,R){for(let C=0;C<R.length;C++){const l=R.charAt(C);if(l==="\r")return C+1<R.length&&R.charAt(C+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=k;function _(P,R){return`\r
`.indexOf(P.charAt(R))!==-1}e.isEOL=_}),define(pe[140],ve([0,1,57,139]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,R,C){return D(P,R,void 0,C)}e.removeProperty=I;function D(P,R,C,l,w){const p=R.slice(),g=[],E=(0,m.parseTree)(P,g);let F,y;for(;p.length>0&&(y=p.pop(),F=(0,m.findNodeAtLocation)(E,p),F===void 0&&C!==void 0);)typeof y=="string"?C={[y]:C}:C=[C];if(F)if(F.type==="object"&&typeof y=="string"&&Array.isArray(F.children)){const u=(0,m.findNodeAtLocation)(F,[y]);if(u!==void 0)if(C===void 0){if(!u.parent)throw new Error("Malformed AST");const r=F.children.indexOf(u.parent);let f,o=u.parent.offset+u.parent.length;if(r>0){const S=F.children[r-1];f=S.offset+S.length}else f=F.offset+1,F.children.length>1&&(o=F.children[1].offset);return T(P,{offset:f,length:o-f,content:""},l)}else return T(P,{offset:u.offset,length:u.length,content:JSON.stringify(C)},l);else{if(C===void 0)return[];const r=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,f=w?w(F.children.map(S=>S.children[0].value)):F.children.length;let o;if(f>0){const S=F.children[f-1];o={offset:S.offset+S.length,length:0,content:","+r}}else F.children.length===0?o={offset:F.offset+1,length:0,content:r}:o={offset:F.offset+1,length:0,content:r+","};return T(P,o,l)}}else if(F.type==="array"&&typeof y=="number"&&Array.isArray(F.children))if(C!==void 0){const u=`${JSON.stringify(C)}`;let r;if(F.children.length===0||y===0)r={offset:F.offset+1,length:0,content:F.children.length===0?u:u+","};else{const f=y===-1||y>F.children.length?F.children.length:y,o=F.children[f-1];r={offset:o.offset+o.length,length:0,content:","+u}}return T(P,r,l)}else{const u=y,r=F.children[u];let f;if(F.children.length===1)f={offset:F.offset+1,length:F.length-2,content:""};else if(F.children.length-1===u){const o=F.children[u-1],S=o.offset+o.length,s=F.offset+F.length;f={offset:S,length:s-2-S,content:""}}else f={offset:r.offset,length:F.children[u+1].offset-r.offset,content:""};return T(P,f,l)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${F.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},l)}}e.setProperty=D;function T(P,R,C){let l=k(P,R),w=R.offset,p=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;w>0&&!(0,t.isEOL)(l,w-1);)w--;for(;p<l.length&&!(0,t.isEOL)(l,p);)p++}const g=(0,t.format)(l,{offset:w,length:p-w},C);for(let F=g.length-1;F>=0;F--){const y=g[F];l=k(l,y),w=Math.min(w,y.offset),p=Math.max(p,y.offset+y.length),p+=y.content.length-y.length}const E=P.length-(l.length-p)-w;return[{offset:w,length:E,content:l.substring(w,p)}]}e.withFormatting=T;function k(P,R){return P.substring(0,R.offset)+R.content+P.substring(R.offset+R.length)}e.applyEdit=k;function _(P,R){let C=R.slice(0).sort((w,p)=>{const g=w.offset-p.offset;return g===0?w.length-p.length:g}),l=P.length;for(let w=C.length-1;w>=0;w--){let p=C[w];if(p.offset+p.length<=l)P=k(P,p);else throw new Error("Overlapping edit");l=p.offset}return P}e.applyEdits=_}),define(pe[92],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new m(()=>I(this.getValue()))}}e.Lazy=m}),define(pe[6],ve([0,1,76,78]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let D=null;function T(i){D=i}if(e.setDisposableTracker=T,I){const i="__is_disposable_tracked__";T(new class{trackDisposable(n){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(c)},3e3)}setParent(n,c){if(n&&n!==y.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==y.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function k(i){return D?.trackDisposable(i),i}function _(i){D?.markAsDisposed(i)}function P(i,n){D?.setParent(i,n)}function R(i,n){if(!!D)for(const c of i)D.setParent(c,n)}function C(i){return D?.markAsSingleton(i),i}e.markAsSingleton=C;class l extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=l;function w(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=w;function p(i){if(t.Iterable.is(i)){let n=[];for(const c of i)if(c)try{c.dispose()}catch(a){n.push(a)}if(n.length===1)throw n[0];if(n.length>1)throw new l(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function g(...i){const n=E(()=>p(i));return R(i,n),n}e.combinedDisposable=g;function E(i){const n=k({dispose:(0,m.once)(()=>{_(n),i()})});return n}e.toDisposable=E;class F{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return P(n,this),this._isDisposed?F.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=F,F.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new F,k(this),P(this._store,this)}dispose(){_(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&P(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&P(n,null),n}}e.MutableDisposable=u;class r{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class f{constructor(){this.references=new Map}acquire(n,...c){let a=this.references.get(n);a||(a={counter:0,object:this.createReferencedObject(n,...c)},this.references.set(n,a));const{object:h}=a,d=(0,m.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(n,a.object),this.references.delete(n))});return a.counter++,{object:h,dispose:d}}}e.ReferenceCollection=f;class o{constructor(n){this.referenceCollection=n}async acquire(n,...c){const a=this.referenceCollection.acquire(n,...c);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(h){throw a.dispose(),h}}}e.AsyncReferenceCollection=o;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function s(i){const n=new F;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=s}),define(pe[93],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(D){this.element=D,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class t{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let D=this._first;for(;D!==m.Undefined;){const T=D.next;D.prev=m.Undefined,D.next=m.Undefined,D=T}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,T){const k=new m(D);if(this._first===m.Undefined)this._first=k,this._last=k;else if(T){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==m.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==m.Undefined&&D.next!==m.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===m.Undefined&&D.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):D.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):D.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==m.Undefined;)yield D.element,D=D.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Re,Ae){for(var De=0;De<Ae.length;De++){var ce=Ae[De];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Re,ce.key,ce)}}function e(Re,Ae,De){return Ae&&Z(Re.prototype,Ae),De&&Z(Re,De),Re}function m(Re,Ae){if(!!Re){if(typeof Re=="string")return t(Re,Ae);var De=Object.prototype.toString.call(Re).slice(8,-1);if(De==="Object"&&Re.constructor&&(De=Re.constructor.name),De==="Map"||De==="Set")return Array.from(Re);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return t(Re,Ae)}}function t(Re,Ae){(Ae==null||Ae>Re.length)&&(Ae=Re.length);for(var De=0,ce=new Array(Ae);De<Ae;De++)ce[De]=Re[De];return ce}function I(Re,Ae){var De=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(De)return(De=De.call(Re)).next.bind(De);if(Array.isArray(Re)||(De=m(Re))||Ae&&Re&&typeof Re.length=="number"){De&&(Re=De);var ce=0;return function(){return ce>=Re.length?{done:!0}:{done:!1,value:Re[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var D={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){D.exports.defaults=Re}D.exports={defaults:T(),getDefaults:T,changeDefaults:k};var _=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Ae){return l[Ae]};function p(Re,Ae){if(Ae){if(_.test(Re))return Re.replace(P,w)}else if(R.test(Re))return Re.replace(C,w);return Re}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Re){return Re.replace(g,function(Ae,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var F=/(^|[^\[])\^/g;function y(Re,Ae){Re=Re.source||Re,Ae=Ae||"";var De={replace:function(de,we){return we=we.source||we,we=we.replace(F,"$1"),Re=Re.replace(de,we),De},getRegex:function(){return new RegExp(Re,Ae)}};return De}var u=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(Re,Ae,De){if(Re){var ce;try{ce=decodeURIComponent(E(De)).replace(u,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Ae&&!r.test(De)&&(De=n(Ae,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var o={},S=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Re,Ae){o[" "+Re]||(S.test(Re)?o[" "+Re]=Re+"/":o[" "+Re]=d(Re,"/",!0)),Re=o[" "+Re];var De=Re.indexOf(":")===-1;return Ae.substring(0,2)==="//"?De?Ae:Re.replace(s,"$1")+Ae:Ae.charAt(0)==="/"?De?Ae:Re.replace(i,"$1")+Ae:Re+Ae}var c={exec:function(){}};function a(Re){for(var Ae=1,De,ce;Ae<arguments.length;Ae++){De=arguments[Ae];for(ce in De)Object.prototype.hasOwnProperty.call(De,ce)&&(Re[ce]=De[ce])}return Re}function h(Re,Ae){var De=Re.replace(/\|/g,function(we,Ce,Oe){for(var Ke=!1,$e=Ce;--$e>=0&&Oe[$e]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=De.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Ae)ce.splice(Ae);else for(;ce.length<Ae;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function d(Re,Ae,De){var ce=Re.length;if(ce===0)return"";for(var de=0;de<ce;){var we=Re.charAt(ce-de-1);if(we===Ae&&!De)de++;else if(we!==Ae&&De)de++;else break}return Re.substr(0,ce-de)}function v(Re,Ae){if(Re.indexOf(Ae[1])===-1)return-1;for(var De=Re.length,ce=0,de=0;de<De;de++)if(Re[de]==="\\")de++;else if(Re[de]===Ae[0])ce++;else if(Re[de]===Ae[1]&&(ce--,ce<0))return de;return-1}function b(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Re,Ae){if(Ae<1)return"";for(var De="";Ae>1;)Ae&1&&(De+=Re),Ae>>=1,Re+=Re;return De+Re}var O={escape:p,unescape:E,edit:y,cleanUrl:f,resolveUrl:n,noopTest:c,merge:a,splitCells:h,rtrim:d,findClosingBracket:v,checkSanitizeDeprecation:b,repeatString:A},N=D.exports.defaults,L=O.rtrim,M=O.splitCells,V=O.escape,H=O.findClosingBracket;function U(Re,Ae,De,ce){var de=Ae.href,we=Ae.title?V(Ae.title):null,Ce=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ce.state.inLink=!0;var Oe={type:"link",raw:De,href:de,title:we,text:Ce,tokens:ce.inlineTokens(Ce,[])};return ce.state.inLink=!1,Oe}else return{type:"image",raw:De,href:de,title:we,text:V(Ce)}}function B(Re,Ae){var De=Re.match(/^(\s+)(?:```)/);if(De===null)return Ae;var ce=De[1];return Ae.split(`
`).map(function(de){var we=de.match(/^\s+/);if(we===null)return de;var Ce=we[0];return Ce.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var $=function(){function Re(De){this.options=De||N}var Ae=Re.prototype;return Ae.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var we=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?we:L(we,`
`)}}},Ae.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var we=de[0],Ce=B(we,de[3]||"");return{type:"code",raw:we,lang:de[2]?de[2].trim():de[2],text:Ce}}},Ae.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var we=de[2].trim();if(/#$/.test(we)){var Ce=L(we,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(we=Ce.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:we,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var we=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},Ae.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var we,Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e=de[1].trim(),he=_e.length>1,Y={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var ke=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=ke.exec(ce)));){He=de[2].split(`
`),this.options.pedantic?(Ke=2,Ee=He[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),Ee=He[0].slice(Ke-de[1].length)),Ze=!1,we=de[0],!He[0]&&/^ *$/.test(He[1])&&(we=de[1]+He.slice(0,2).join(`
`)+`
`,Y.loose=!0,He=[]);var Ne=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<He.length;$e++){if(ct=He[$e],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ne.test(ct)){we=de[1]+He.slice(0,$e).join(`
`)+`
`;break}if(!Ze){ct.trim()||(Ze=!0),ct.search(/[^ ]/)>=Ke?Ee+=`
`+ct.slice(Ke):Ee+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ke||!ct.trim()){Ee+=`
`+ct.slice(Ke);continue}else{we=de[1]+He.slice(0,$e).join(`
`)+`
`;break}}Y.loose||(lt?Y.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(Ee),Ce&&(Oe=Ce[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Y.items.push({type:"list_item",raw:we,task:!!Ce,checked:Oe,loose:!1,text:Ee}),Y.raw+=we,ce=ce.slice(we.length)}Y.items[Y.items.length-1].raw=we.trimRight(),Y.items[Y.items.length-1].text=Ee.trimRight(),Y.raw=Y.raw.trimRight();var Xe=Y.items.length;for($e=0;$e<Xe;$e++)this.lexer.state.top=!1,Y.items[$e].tokens=this.lexer.blockTokens(Y.items[$e].text,[]),Y.items[$e].tokens.some(function(Qe){return Qe.type==="space"})&&(Y.loose=!0,Y.items[$e].loose=!0);return Y}},Ae.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var we={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},Ae.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var we=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var we={type:"table",header:M(de[1]).map(function(lt){return{text:lt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=de[0];var Ce=we.align.length,Oe,Ke,$e,Ze;for(Oe=0;Oe<Ce;Oe++)/^ *-+: *$/.test(we.align[Oe])?we.align[Oe]="right":/^ *:-+: *$/.test(we.align[Oe])?we.align[Oe]="center":/^ *:-+ *$/.test(we.align[Oe])?we.align[Oe]="left":we.align[Oe]=null;for(Ce=we.rows.length,Oe=0;Oe<Ce;Oe++)we.rows[Oe]=M(we.rows[Oe],we.header.length).map(function(lt){return{text:lt}});for(Ce=we.header.length,Ke=0;Ke<Ce;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(Ce=we.rows.length,Ke=0;Ke<Ce;Ke++)for(Ze=we.rows[Ke],$e=0;$e<Ze.length;$e++)Ze[$e].tokens=[],this.lexer.inlineTokens(Ze[$e].text,Ze[$e].tokens);return we}}},Ae.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var we={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var we={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var we={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var we=de[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var Ce=L(we.slice(0,-1),"\\");if((we.length-Ce.length)%2==0)return}else{var Oe=H(de[2],"()");if(Oe>-1){var Ke=de[0].indexOf("!")===0?5:4,$e=Ke+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Ze=de[2],lt="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);ct&&(Ze=ct[1],lt=ct[3])}else lt=de[3]?de[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(we)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),U(de,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ce,de){var we;if((we=this.rules.inline.reflink.exec(ce))||(we=this.rules.inline.nolink.exec(ce))){var Ce=(we[2]||we[1]).replace(/\s+/g," ");if(Ce=de[Ce.toLowerCase()],!Ce||!Ce.href){var Oe=we[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return U(we,Ce,we[0],this.lexer)}},Ae.emStrong=function(ce,de,we){we===void 0&&(we="");var Ce=this.rules.inline.emStrong.lDelim.exec(ce);if(!!Ce&&!(Ce[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=Ce[1]||Ce[2]||"";if(!Oe||Oe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=Ce[0].length-1,$e,Ze,lt=Ke,ct=0,He=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(He.lastIndex=0,de=de.slice(-1*ce.length+Ke);(Ce=He.exec(de))!=null;)if($e=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!$e){if(Ze=$e.length,Ce[3]||Ce[4]){lt+=Ze;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Ze)%3)){ct+=Ze;continue}if(lt-=Ze,!(lt>0)){if(Ze=Math.min(Ze,Ze+lt+ct),Math.min(Ke,Ze)%2){var Ee=ce.slice(1,Ke+Ce.index+Ze);return{type:"em",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var _e=ce.slice(2,Ke+Ce.index+Ze-1);return{type:"strong",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var we=de[2].replace(/\n/g," "),Ce=/[^ ]/.test(we),Oe=/^ /.test(we)&&/ $/.test(we);return Ce&&Oe&&(we=we.substring(1,we.length-1)),we=V(we,!0),{type:"codespan",raw:de[0],text:we}}},Ae.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ce,de){var we=this.rules.inline.autolink.exec(ce);if(we){var Ce,Oe;return we[2]==="@"?(Ce=V(this.options.mangle?de(we[1]):we[1]),Oe="mailto:"+Ce):(Ce=V(we[1]),Oe=Ce),{type:"link",raw:we[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.url=function(ce,de){var we;if(we=this.rules.inline.url.exec(ce)){var Ce,Oe;if(we[2]==="@")Ce=V(this.options.mangle?de(we[0]):we[0]),Oe="mailto:"+Ce;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);Ce=V(we[0]),we[1]==="www."?Oe="http://"+Ce:Oe=Ce}return{type:"link",raw:we[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.inlineText=function(ce,de){var we=this.rules.inline.text.exec(ce);if(we){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):V(we[0]):we[0]:Ce=V(this.options.smartypants?de(we[0]):we[0]),{type:"text",raw:we[0],text:Ce}}},Re}(),z=O.noopTest,W=O.edit,J=O.merge,ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=W(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=W(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=W(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=W(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=W(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=W(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=J({},ne),ne.gfm=J({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=W(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=J({},ne.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:W(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=W(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=W(ne._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=W(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=W(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=W(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=W(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=W(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=W(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=W(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=W(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=J({},se),se.pedantic=J({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=J({},se.normal,{escape:W(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=W(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=J({},se.gfm,{br:W(se.br).replace("{2,}","*").getRegex(),text:W(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var K={block:ne,inline:se},Q=$,ae=D.exports.defaults,fe=K.block,be=K.inline,Me=O.repeatString;function xe(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Re){var Ae="",De,ce,de=Re.length;for(De=0;De<de;De++)ce=Re.charCodeAt(De),Math.random()>.5&&(ce="x"+ce.toString(16)),Ae+="&#"+ce+";";return Ae}var Je=function(){function Re(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ae,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:fe.normal,inline:be.normal};this.options.pedantic?(ce.block=fe.pedantic,ce.inline=be.pedantic):this.options.gfm&&(ce.block=fe.gfm,this.options.breaks?ce.inline=be.breaks:ce.inline=be.gfm),this.tokenizer.rules=ce}Re.lex=function(ce,de){var we=new Re(de);return we.lex(ce)},Re.lexInline=function(ce,de){var we=new Re(de);return we.inlineTokens(ce)};var Ae=Re.prototype;return Ae.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ce,de){var we=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var Ce,Oe,Ke,$e;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(Ce=lt.call({lexer:we},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(ce)){ce=ce.substring(Ce.raw.length),Ce.type&&de.push(Ce);continue}if(Ce=this.tokenizer.code(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(Ce=this.tokenizer.fences(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.heading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.hr(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.blockquote(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.list(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.html(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.def(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.lheading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=1/0,ct=ce.slice(1),He=void 0;we.options.extensions.startBlock.forEach(function(Ee){He=Ee.call({lexer:this},ct),typeof He=="number"&&He>=0&&(lt=Math.min(lt,He))}),lt<1/0&&lt>=0&&(Ke=ce.substring(0,lt+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Oe=de[de.length-1],$e&&Oe.type==="paragraph"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce),$e=Ke.length!==ce.length,ce=ce.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(ce){var Ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,de},Ae.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Ae.inlineTokens=function(ce,de){var we=this;de===void 0&&(de=[]);var Ce,Oe,Ke,$e=ce,Ze,lt,ct;if(this.tokens.links){var He=Object.keys(this.tokens.links);if(He.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)He.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(lt||(ct=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(Ce=_e.call({lexer:we},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.tag(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.link(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.emStrong(ce,$e,ct)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.codespan(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.br(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.del(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.autolink(ce,Ge)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(ce,Ge))){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ce.slice(1),Y=void 0;we.options.extensions.startInline.forEach(function(ke){Y=ke.call({lexer:this},he),typeof Y=="number"&&Y>=0&&(_e=Math.min(_e,Y))}),_e<1/0&&_e>=0&&(Ke=ce.substring(0,_e+1))}(),Ce=this.tokenizer.inlineText(Ke,xe)){ce=ce.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(ct=Ce.raw.slice(-1)),lt=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(ce){var Ee="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:fe,inline:be}}}]),Re}(),q=D.exports.defaults,te=O.cleanUrl,G=O.escape,X=function(){function Re(De){this.options=De||q}var Ae=Re.prototype;return Ae.code=function(ce,de,we){var Ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ce,Ce);Oe!=null&&Oe!==ce&&(we=!0,ce=Oe)}return ce=ce.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+G(Ce,!0)+'">'+(we?ce:G(ce,!0))+`</code></pre>
`:"<pre><code>"+(we?ce:G(ce,!0))+`</code></pre>
`},Ae.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Ae.html=function(ce){return ce},Ae.heading=function(ce,de,we,Ce){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ce.slug(we)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ce,de,we){var Ce=de?"ol":"ul",Oe=de&&we!==1?' start="'+we+'"':"";return"<"+Ce+Oe+`>
`+ce+"</"+Ce+`>
`},Ae.listitem=function(ce){return"<li>"+ce+`</li>
`},Ae.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ce){return"<p>"+ce+`</p>
`},Ae.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Ae.tablecell=function(ce,de){var we=de.header?"th":"td",Ce=de.align?"<"+we+' align="'+de.align+'">':"<"+we+">";return Ce+ce+"</"+we+`>
`},Ae.strong=function(ce){return"<strong>"+ce+"</strong>"},Ae.em=function(ce){return"<em>"+ce+"</em>"},Ae.codespan=function(ce){return"<code>"+ce+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ce){return"<del>"+ce+"</del>"},Ae.link=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var Ce='<a href="'+G(ce)+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=">"+we+"</a>",Ce},Ae.image=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var Ce='<img src="'+ce+'" alt="'+we+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Ae.text=function(ce){return ce},Re}(),oe=function(){function Re(){}var Ae=Re.prototype;return Ae.strong=function(ce){return ce},Ae.em=function(ce){return ce},Ae.codespan=function(ce){return ce},Ae.del=function(ce){return ce},Ae.html=function(ce){return ce},Ae.text=function(ce){return ce},Ae.link=function(ce,de,we){return""+we},Ae.image=function(ce,de,we){return""+we},Ae.br=function(){return""},Re}(),me=function(){function Re(){this.seen={}}var Ae=Re.prototype;return Ae.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ce,de){var we=ce,Ce=0;if(this.seen.hasOwnProperty(we)){Ce=this.seen[ce];do Ce++,we=ce+"-"+Ce;while(this.seen.hasOwnProperty(we))}return de||(this.seen[ce]=Ce,this.seen[we]=0),we},Ae.slug=function(ce,de){de===void 0&&(de={});var we=this.serialize(ce);return this.getNextSafeSlug(we,de.dryrun)},Re}(),Ie=X,We=oe,Ye=me,it=D.exports.defaults,st=O.unescape,ot=function(){function Re(De){this.options=De||it,this.options.renderer=this.options.renderer||new Ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new Ye}Re.parse=function(ce,de){var we=new Re(de);return we.parse(ce)},Re.parseInline=function(ce,de){var we=new Re(de);return we.parseInline(ce)};var Ae=Re.prototype;return Ae.parse=function(ce,de){de===void 0&&(de=!0);var we="",Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e,he,Y,ke,Ne,Xe,Qe,pt,St,yt,ft=ce.length;for(Ce=0;Ce<ft;Ce++){if(_e=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(yt=this.options.extensions.renderers[_e.type].call({parser:this},_e),yt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){we+=yt||"";continue}switch(_e.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,st(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(He="",ct="",$e=_e.header.length,Oe=0;Oe<$e;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for(He+=this.renderer.tablerow(ct),Ee="",$e=_e.rows.length,Oe=0;Oe<$e;Oe++){for(lt=_e.rows[Oe],ct="",Ze=lt.length,Ke=0;Ke<Ze;Ke++)ct+=this.renderer.tablecell(this.parseInline(lt[Ke].tokens),{header:!1,align:_e.align[Ke]});Ee+=this.renderer.tablerow(ct)}we+=this.renderer.table(He,Ee);continue}case"blockquote":{Ee=this.parse(_e.tokens),we+=this.renderer.blockquote(Ee);continue}case"list":{for(he=_e.ordered,Y=_e.start,ke=_e.loose,$e=_e.items.length,Ee="",Oe=0;Oe<$e;Oe++)Xe=_e.items[Oe],Qe=Xe.checked,pt=Xe.task,Ne="",Xe.task&&(St=this.renderer.checkbox(Qe),ke?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=St+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=St+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:St}):Ne+=St),Ne+=this.parse(Xe.tokens,ke),Ee+=this.renderer.listitem(Ne,pt,Qe);we+=this.renderer.list(Ee,he,Y);continue}case"html":{we+=this.renderer.html(_e.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Ee=_e.tokens?this.parseInline(_e.tokens):_e.text;Ce+1<ft&&ce[Ce+1].type==="text";)_e=ce[++Ce],Ee+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);we+=de?this.renderer.paragraph(Ee):Ee;continue}default:{var wt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return we},Ae.parseInline=function(ce,de){de=de||this.renderer;var we="",Ce,Oe,Ke,$e=ce.length;for(Ce=0;Ce<$e;Ce++){if(Oe=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ke=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){we+=Ke||"";continue}switch(Oe.type){case"escape":{we+=de.text(Oe.text);break}case"html":{we+=de.html(Oe.text);break}case"link":{we+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{we+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{we+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{we+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{we+=de.codespan(Oe.text);break}case"br":{we+=de.br();break}case"del":{we+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{we+=de.text(Oe.text);break}default:{var Ze='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return we},Re}(),tt=Je,rt=ot,gt=$,Ue=X,It=oe,ee=me,ie=O.merge,Se=O.checkSanitizeDeprecation,re=O.escape,ye=D.exports.getDefaults,Fe=D.exports.changeDefaults,qe=D.exports.defaults;function Ve(Re,Ae,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ae=="function"&&(De=Ae,Ae=null),Ae=ie({},Ve.defaults,Ae||{}),Se(Ae),De){var ce=Ae.highlight,de;try{de=tt.lex(Re,Ae)}catch(Ke){return De(Ke)}var we=function($e){var Ze;if(!$e)try{Ae.walkTokens&&Ve.walkTokens(de,Ae.walkTokens),Ze=rt.parse(de,Ae)}catch(lt){$e=lt}return Ae.highlight=ce,$e?De($e):De(null,Ze)};if(!ce||ce.length<3||(delete Ae.highlight,!de.length))return we();var Ce=0;Ve.walkTokens(de,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){ce(Ke.text,Ke.lang,function($e,Ze){if($e)return we($e);Ze!=null&&Ze!==Ke.text&&(Ke.text=Ze,Ke.escaped=!0),Ce--,Ce===0&&we()})},0))}),Ce===0&&we();return}try{var Oe=tt.lex(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(Oe,Ae.walkTokens),rt.parse(Oe,Ae)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(Ke.message+"",!0)+"</pre>";throw Ke}}Ve.options=Ve.setOptions=function(Re){return ie(Ve.defaults,Re),Fe(Ve.defaults),Ve},Ve.getDefaults=ye,Ve.defaults=qe,Ve.use=function(){for(var Re=this,Ae=arguments.length,De=new Array(Ae),ce=0;ce<Ae;ce++)De[ce]=arguments[ce];var de=ie.apply(void 0,[{}].concat(De)),we=Ve.defaults.extensions||{renderers:{},childTokens:{}},Ce;De.forEach(function(Oe){if(Oe.extensions&&(Ce=!0,Oe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ze=we.renderers?we.renderers[$e.name]:null;Ze?we.renderers[$e.name]=function(){for(var lt=arguments.length,ct=new Array(lt),He=0;He<lt;He++)ct[He]=arguments[He];var Ee=$e.renderer.apply(this,ct);return Ee===!1&&(Ee=Ze.apply(this,ct)),Ee}:we.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[$e.level]?we[$e.level].unshift($e.tokenizer):we[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?we.startBlock?we.startBlock.push($e.start):we.startBlock=[$e.start]:$e.level==="inline"&&(we.startInline?we.startInline.push($e.start):we.startInline=[$e.start]))}$e.childTokens&&(we.childTokens[$e.name]=$e.childTokens)})),Oe.renderer&&function(){var $e=Ve.defaults.renderer||new Ue,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.renderer[He].apply($e,he);return ke===!1&&(ke=Ee.apply($e,he)),ke}};for(var lt in Oe.renderer)Ze(lt);de.renderer=$e}(),Oe.tokenizer&&function(){var $e=Ve.defaults.tokenizer||new gt,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.tokenizer[He].apply($e,he);return ke===!1&&(ke=Ee.apply($e,he)),ke}};for(var lt in Oe.tokenizer)Ze(lt);de.tokenizer=$e}(),Oe.walkTokens){var Ke=Ve.defaults.walkTokens;de.walkTokens=function($e){Oe.walkTokens.call(Re,$e),Ke&&Ke($e)}}Ce&&(de.extensions=we),Ve.setOptions(de)})},Ve.walkTokens=function(Re,Ae){for(var De=function(){var Ce=de.value;switch(Ae(Ce),Ce.type){case"table":{for(var Oe=I(Ce.header),Ke;!(Ke=Oe()).done;){var $e=Ke.value;Ve.walkTokens($e.tokens,Ae)}for(var Ze=I(Ce.rows),lt;!(lt=Ze()).done;)for(var ct=lt.value,He=I(ct),Ee;!(Ee=He()).done;){var _e=Ee.value;Ve.walkTokens(_e.tokens,Ae)}break}case"list":{Ve.walkTokens(Ce.items,Ae);break}default:Ve.defaults.extensions&&Ve.defaults.extensions.childTokens&&Ve.defaults.extensions.childTokens[Ce.type]?Ve.defaults.extensions.childTokens[Ce.type].forEach(function(he){Ve.walkTokens(Ce[he],Ae)}):Ce.tokens&&Ve.walkTokens(Ce.tokens,Ae)}},ce=I(Re),de;!(de=ce()).done;)De()},Ve.parseInline=function(Re,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ae=ie({},Ve.defaults,Ae||{}),Se(Ae);try{var De=tt.lexInline(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(De,Ae.walkTokens),rt.parseInline(De,Ae)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(ce.message+"",!0)+"</pre>";throw ce}},Ve.Parser=rt,Ve.parser=rt.parse,Ve.Renderer=Ue,Ve.TextRenderer=It,Ve.Lexer=tt,Ve.lexer=tt.lex,Ve.Tokenizer=gt,Ve.Slugger=ee,Ve.parse=Ve;var ut=Ve;return ut}),define(pe[94],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(k,_,P){return Math.min(Math.max(k,_),P)}e.clamp=m;function t(k,_){return(_+k%_)%_}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class D{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=D;class T{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const P=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function Z(I){const D=[];typeof I=="number"&&D.push("code/timeOrigin",I);function T(_){D.push(_,Date.now())}function k(){const _=[];for(let P=0;P<D.length;P+=2)_.push({name:D[P],startTime:D[P+1]});return _}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(I+T.startTime)});return D}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=m(t))}(),define(pe[12],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let t=!1,I=!1,D=!1,T=!1,k=!1,_=!1,P=!1,R=!1,C,l=m,w,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",F=E&&g?.type==="renderer";if(e.isElectronSandboxed=F&&g?.sandboxed,typeof navigator=="object"&&!F)p=navigator.userAgent,t=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,R=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=p.indexOf("Linux")>=0,_=!0,C=navigator.language,l=C;else if(typeof g=="object"){t=g.platform==="win32",I=g.platform==="darwin",D=g.platform==="linux",T=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,P=E,C=m,l=m;const n=g.env.VSCODE_NLS_CONFIG;if(n)try{const c=JSON.parse(n),a=c.availableLanguages["*"];C=c.locale,l=a||m,w=c._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function u(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let r=0;I?r=1:t?r=3:D&&(r=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=T,e.isNative=k,e.isElectron=P,e.isWeb=_,e.isIOS=R,e.platform=r,e.userAgent=p,e.language=l;var f;(function(n){function c(){return e.language}n.value=c;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=a;function h(){return e.language==="en"}n.isDefault=h})(f=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=w,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let h=0,d=n.length;h<d;h++){const v=n[h];if(v.id===a.data.vscodeScheduleAsyncWork){n.splice(h,1),v.callback();return}}});let c=0;return a=>{const h=++c;n.push({id:h,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:t?1:3;let S=!0,s=!1;function i(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i}),define(pe[40],ve([0,1,12]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const I=m.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[9],ve([0,1,40]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,D=90,T=122,k=46,_=47,P=92,R=58,C=63;class l extends Error{constructor(r,f,o){let S;typeof f=="string"&&f.indexOf("not ")===0?(S="must not be",f=f.replace(/^not /,"")):S="must be";const s=r.indexOf(".")!==-1?"property":"argument";let i=`The "${r}" ${s} ${S} of type ${f}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function w(u,r){if(typeof u!="string")throw new l(r,"string",u)}function p(u){return u===_||u===P}function g(u){return u===_}function E(u){return u>=t&&u<=D||u>=I&&u<=T}function F(u,r,f,o){let S="",s=0,i=-1,n=0,c=0;for(let a=0;a<=u.length;++a){if(a<u.length)c=u.charCodeAt(a);else{if(o(c))break;c=_}if(o(c)){if(!(i===a-1||n===1))if(n===2){if(S.length<2||s!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const h=S.lastIndexOf(f);h===-1?(S="",s=0):(S=S.slice(0,h),s=S.length-1-S.lastIndexOf(f)),i=a,n=0;continue}else if(S.length!==0){S="",s=0,i=a,n=0;continue}}r&&(S+=S.length>0?`${f}..`:"..",s=2)}else S.length>0?S+=`${f}${u.slice(i+1,a)}`:S=u.slice(i+1,a),s=a-i-1;i=a,n=0}else c===k&&n!==-1?++n:n=-1}return S}function y(u,r){if(r===null||typeof r!="object")throw new l("pathObject","Object",r);const f=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return f?f===r.root?`${f}${o}`:`${f}${u}${o}`:o}e.win32={resolve(...u){let r="",f="",o=!1;for(let S=u.length-1;S>=-1;S--){let s;if(S>=0){if(s=u[S],w(s,"path"),s.length===0)continue}else r.length===0?s=m.cwd():(s=m.env[`=${r}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==r.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${r}\\`));const i=s.length;let n=0,c="",a=!1;const h=s.charCodeAt(0);if(i===1)p(h)&&(n=1,a=!0);else if(p(h))if(a=!0,p(s.charCodeAt(1))){let d=2,v=d;for(;d<i&&!p(s.charCodeAt(d));)d++;if(d<i&&d!==v){const b=s.slice(v,d);for(v=d;d<i&&p(s.charCodeAt(d));)d++;if(d<i&&d!==v){for(v=d;d<i&&!p(s.charCodeAt(d));)d++;(d===i||d!==v)&&(c=`\\\\${b}\\${s.slice(v,d)}`,n=d)}}}else n=1;else E(h)&&s.charCodeAt(1)===R&&(c=s.slice(0,2),n=2,i>2&&p(s.charCodeAt(2))&&(a=!0,n=3));if(c.length>0)if(r.length>0){if(c.toLowerCase()!==r.toLowerCase())continue}else r=c;if(o){if(r.length>0)break}else if(f=`${s.slice(n)}\\${f}`,o=a,a&&r.length>0)break}return f=F(f,!o,"\\",p),o?`${r}\\${f}`:`${r}${f}`||"."},normalize(u){w(u,"path");const r=u.length;if(r===0)return".";let f=0,o,S=!1;const s=u.charCodeAt(0);if(r===1)return g(s)?"\\":u;if(p(s))if(S=!0,p(u.charCodeAt(1))){let n=2,c=n;for(;n<r&&!p(u.charCodeAt(n));)n++;if(n<r&&n!==c){const a=u.slice(c,n);for(c=n;n<r&&p(u.charCodeAt(n));)n++;if(n<r&&n!==c){for(c=n;n<r&&!p(u.charCodeAt(n));)n++;if(n===r)return`\\\\${a}\\${u.slice(c)}\\`;n!==c&&(o=`\\\\${a}\\${u.slice(c,n)}`,f=n)}}}else f=1;else E(s)&&u.charCodeAt(1)===R&&(o=u.slice(0,2),f=2,r>2&&p(u.charCodeAt(2))&&(S=!0,f=3));let i=f<r?F(u.slice(f),!S,"\\",p):"";return i.length===0&&!S&&(i="."),i.length>0&&p(u.charCodeAt(r-1))&&(i+="\\"),o===void 0?S?`\\${i}`:i:S?`${o}\\${i}`:`${o}${i}`},isAbsolute(u){w(u,"path");const r=u.length;if(r===0)return!1;const f=u.charCodeAt(0);return p(f)||r>2&&E(f)&&u.charCodeAt(1)===R&&p(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let r,f;for(let s=0;s<u.length;++s){const i=u[s];w(i,"path"),i.length>0&&(r===void 0?r=f=i:r+=`\\${i}`)}if(r===void 0)return".";let o=!0,S=0;if(typeof f=="string"&&p(f.charCodeAt(0))){++S;const s=f.length;s>1&&p(f.charCodeAt(1))&&(++S,s>2&&(p(f.charCodeAt(2))?++S:o=!1))}if(o){for(;S<r.length&&p(r.charCodeAt(S));)S++;S>=2&&(r=`\\${r.slice(S)}`)}return e.win32.normalize(r)},relative(u,r){if(w(u,"from"),w(r,"to"),u===r)return"";const f=e.win32.resolve(u),o=e.win32.resolve(r);if(f===o||(u=f.toLowerCase(),r=o.toLowerCase(),u===r))return"";let S=0;for(;S<u.length&&u.charCodeAt(S)===P;)S++;let s=u.length;for(;s-1>S&&u.charCodeAt(s-1)===P;)s--;const i=s-S;let n=0;for(;n<r.length&&r.charCodeAt(n)===P;)n++;let c=r.length;for(;c-1>n&&r.charCodeAt(c-1)===P;)c--;const a=c-n,h=i<a?i:a;let d=-1,v=0;for(;v<h;v++){const A=u.charCodeAt(S+v);if(A!==r.charCodeAt(n+v))break;A===P&&(d=v)}if(v!==h){if(d===-1)return o}else{if(a>h){if(r.charCodeAt(n+v)===P)return o.slice(n+v+1);if(v===2)return o.slice(n+v)}i>h&&(u.charCodeAt(S+v)===P?d=v:v===2&&(d=3)),d===-1&&(d=0)}let b="";for(v=S+d+1;v<=s;++v)(v===s||u.charCodeAt(v)===P)&&(b+=b.length===0?"..":"\\..");return n+=d,b.length>0?`${b}${o.slice(n,c)}`:(o.charCodeAt(n)===P&&++n,o.slice(n,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const r=e.win32.resolve(u);if(r.length<=2)return u;if(r.charCodeAt(0)===P){if(r.charCodeAt(1)===P){const f=r.charCodeAt(2);if(f!==C&&f!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(E(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===P)return`\\\\?\\${r}`;return u},dirname(u){w(u,"path");const r=u.length;if(r===0)return".";let f=-1,o=0;const S=u.charCodeAt(0);if(r===1)return p(S)?u:".";if(p(S)){if(f=o=1,p(u.charCodeAt(1))){let n=2,c=n;for(;n<r&&!p(u.charCodeAt(n));)n++;if(n<r&&n!==c){for(c=n;n<r&&p(u.charCodeAt(n));)n++;if(n<r&&n!==c){for(c=n;n<r&&!p(u.charCodeAt(n));)n++;if(n===r)return u;n!==c&&(f=o=n+1)}}}}else E(S)&&u.charCodeAt(1)===R&&(f=r>2&&p(u.charCodeAt(2))?3:2,o=f);let s=-1,i=!0;for(let n=r-1;n>=o;--n)if(p(u.charCodeAt(n))){if(!i){s=n;break}}else i=!1;if(s===-1){if(f===-1)return".";s=f}return u.slice(0,s)},basename(u,r){r!==void 0&&w(r,"ext"),w(u,"path");let f=0,o=-1,S=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===R&&(f=2),r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let i=r.length-1,n=-1;for(s=u.length-1;s>=f;--s){const c=u.charCodeAt(s);if(p(c)){if(!S){f=s+1;break}}else n===-1&&(S=!1,n=s+1),i>=0&&(c===r.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=n))}return f===o?o=n:o===-1&&(o=u.length),u.slice(f,o)}for(s=u.length-1;s>=f;--s)if(p(u.charCodeAt(s))){if(!S){f=s+1;break}}else o===-1&&(S=!1,o=s+1);return o===-1?"":u.slice(f,o)},extname(u){w(u,"path");let r=0,f=-1,o=0,S=-1,s=!0,i=0;u.length>=2&&u.charCodeAt(1)===R&&E(u.charCodeAt(0))&&(r=o=2);for(let n=u.length-1;n>=r;--n){const c=u.charCodeAt(n);if(p(c)){if(!s){o=n+1;break}continue}S===-1&&(s=!1,S=n+1),c===k?f===-1?f=n:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||S===-1||i===0||i===1&&f===S-1&&f===o+1?"":u.slice(f,S)},format:y.bind(null,"\\"),parse(u){w(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const f=u.length;let o=0,S=u.charCodeAt(0);if(f===1)return p(S)?(r.root=r.dir=u,r):(r.base=r.name=u,r);if(p(S)){if(o=1,p(u.charCodeAt(1))){let d=2,v=d;for(;d<f&&!p(u.charCodeAt(d));)d++;if(d<f&&d!==v){for(v=d;d<f&&p(u.charCodeAt(d));)d++;if(d<f&&d!==v){for(v=d;d<f&&!p(u.charCodeAt(d));)d++;d===f?o=d:d!==v&&(o=d+1)}}}}else if(E(S)&&u.charCodeAt(1)===R){if(f<=2)return r.root=r.dir=u,r;if(o=2,p(u.charCodeAt(2))){if(f===3)return r.root=r.dir=u,r;o=3}}o>0&&(r.root=u.slice(0,o));let s=-1,i=o,n=-1,c=!0,a=u.length-1,h=0;for(;a>=o;--a){if(S=u.charCodeAt(a),p(S)){if(!c){i=a+1;break}continue}n===-1&&(c=!1,n=a+1),S===k?s===-1?s=a:h!==1&&(h=1):s!==-1&&(h=-1)}return n!==-1&&(s===-1||h===0||h===1&&s===n-1&&s===i+1?r.base=r.name=u.slice(i,n):(r.name=u.slice(i,s),r.base=u.slice(i,n),r.ext=u.slice(s,n))),i>0&&i!==o?r.dir=u.slice(0,i-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let r="",f=!1;for(let o=u.length-1;o>=-1&&!f;o--){const S=o>=0?u[o]:m.cwd();w(S,"path"),S.length!==0&&(r=`${S}/${r}`,f=S.charCodeAt(0)===_)}return r=F(r,!f,"/",g),f?`/${r}`:r.length>0?r:"."},normalize(u){if(w(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===_,f=u.charCodeAt(u.length-1)===_;return u=F(u,!r,"/",g),u.length===0?r?"/":f?"./":".":(f&&(u+="/"),r?`/${u}`:u)},isAbsolute(u){return w(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let r;for(let f=0;f<u.length;++f){const o=u[f];w(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(u,r){if(w(u,"from"),w(r,"to"),u===r||(u=e.posix.resolve(u),r=e.posix.resolve(r),u===r))return"";const f=1,o=u.length,S=o-f,s=1,i=r.length-s,n=S<i?S:i;let c=-1,a=0;for(;a<n;a++){const d=u.charCodeAt(f+a);if(d!==r.charCodeAt(s+a))break;d===_&&(c=a)}if(a===n)if(i>n){if(r.charCodeAt(s+a)===_)return r.slice(s+a+1);if(a===0)return r.slice(s+a)}else S>n&&(u.charCodeAt(f+a)===_?c=a:a===0&&(c=0));let h="";for(a=f+c+1;a<=o;++a)(a===o||u.charCodeAt(a)===_)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(s+c)}`},toNamespacedPath(u){return u},dirname(u){if(w(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===_;let f=-1,o=!0;for(let S=u.length-1;S>=1;--S)if(u.charCodeAt(S)===_){if(!o){f=S;break}}else o=!1;return f===-1?r?"/":".":r&&f===1?"//":u.slice(0,f)},basename(u,r){r!==void 0&&w(r,"ext"),w(u,"path");let f=0,o=-1,S=!0,s;if(r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let i=r.length-1,n=-1;for(s=u.length-1;s>=0;--s){const c=u.charCodeAt(s);if(c===_){if(!S){f=s+1;break}}else n===-1&&(S=!1,n=s+1),i>=0&&(c===r.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=n))}return f===o?o=n:o===-1&&(o=u.length),u.slice(f,o)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===_){if(!S){f=s+1;break}}else o===-1&&(S=!1,o=s+1);return o===-1?"":u.slice(f,o)},extname(u){w(u,"path");let r=-1,f=0,o=-1,S=!0,s=0;for(let i=u.length-1;i>=0;--i){const n=u.charCodeAt(i);if(n===_){if(!S){f=i+1;break}continue}o===-1&&(S=!1,o=i+1),n===k?r===-1?r=i:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||o===-1||s===0||s===1&&r===o-1&&r===f+1?"":u.slice(r,o)},format:y.bind(null,"/"),parse(u){w(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const f=u.charCodeAt(0)===_;let o;f?(r.root="/",o=1):o=0;let S=-1,s=0,i=-1,n=!0,c=u.length-1,a=0;for(;c>=o;--c){const h=u.charCodeAt(c);if(h===_){if(!n){s=c+1;break}continue}i===-1&&(n=!1,i=c+1),h===k?S===-1?S=c:a!==1&&(a=1):S!==-1&&(a=-1)}if(i!==-1){const h=s===0&&f?1:s;S===-1||a===0||a===1&&S===i-1&&S===s+1?r.base=r.name=u.slice(h,i):(r.name=u.slice(h,S),r.base=u.slice(h,i),r.ext=u.slice(S,i))}return s>0?r.dir=u.slice(0,s-1):f&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[95],ve([0,1,9]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(C){const l=(0,m.extname)(C),w=I[l.toLowerCase()];return w!==void 0?w:k(C)}e.getMediaOrTextMime=T;function k(C){const l=(0,m.extname)(C);return D[l.toLowerCase()]}e.getMediaMime=k;function _(C){for(const l in D)if(D[l]===C)return l}e.getExtensionForMimeType=_;const P=/^(.+)\/(.+?)(;.+)?$/;function R(C,l){const w=P.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:l?void 0:C}e.normalizeMimeType=R}),define(pe[96],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var t;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(D,...T){const k=T.reduce((R,C)=>(R[C]=!0,R),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(R=>!k[R]).forEach(R=>{for(let C=0;C<_.length;C++)if(R.search(_[C])!==-1){delete D[R];break}})}e.sanitizeProcessEnvironment=I}),define(pe[46],ve([0,1,12]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=m.globals.performance&&typeof m.globals.performance.now=="function";class I{constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new I(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=I}),define(pe[3],ve([0,1,16,76,6,93,46]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>I.Disposable.None;function f(B){return($,z=null,W)=>{let J=!1,ne;return ne=B(se=>{if(!J)return ne?ne.dispose():J=!0,$.call(z,se)},null,W),J&&ne.dispose(),ne}}r.once=f;function o(B,$){return a((z,W=null,J)=>B(ne=>z.call(W,$(ne)),null,J))}r.map=o;function S(B,$){return a((z,W=null,J)=>B(ne=>{$(ne),z.call(W,ne)},null,J))}r.forEach=S;function s(B,$){return a((z,W=null,J)=>B(ne=>$(ne)&&z.call(W,ne),null,J))}r.filter=s;function i(B){return B}r.signal=i;function n(...B){return($,z=null,W)=>(0,I.combinedDisposable)(...B.map(J=>J(ne=>$.call(z,ne),null,W)))}r.any=n;function c(B,$,z){let W=z;return o(B,J=>(W=$(W,J),W))}r.reduce=c;function a(B){let $;const z=new l({onFirstListenerAdd(){$=B(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}function h(B,$,z,W=100,J=!1){let ne,se,K=0;return B(Q=>{K++,ne=z(ne,Q),J&&!se&&($(ne),ne=void 0),clearTimeout(se),se=setTimeout(()=>{const ae=ne;ne=void 0,se=void 0,(!J||K>1)&&$(ae),K=0},W)})}r.debouncedListener=h;function d(B,$,z=100,W=!1,J){let ne,se,K,Q=0;const ae=new l({leakWarningThreshold:J,onFirstListenerAdd(){ne=B(fe=>{Q++,se=$(se,fe),W&&!K&&(ae.fire(se),se=void 0),clearTimeout(K),K=setTimeout(()=>{const be=se;se=void 0,K=void 0,(!W||Q>1)&&ae.fire(be),Q=0},z)})},onLastListenerRemove(){ne.dispose()}});return ae.event}r.debounce=d;function v(B,$=(z,W)=>z===W){let z=!0,W;return s(B,J=>{const ne=z||!$(J,W);return z=!1,W=J,ne})}r.latch=v;function b(B,$){return[r.filter(B,$),r.filter(B,z=>!$(z))]}r.split=b;function A(B,$=!1,z=[]){let W=z.slice(),J=B(K=>{W?W.push(K):se.fire(K)});const ne=()=>{W&&W.forEach(K=>se.fire(K)),W=null},se=new l({onFirstListenerAdd(){J||(J=B(K=>se.fire(K)))},onFirstListenerDidAdd(){W&&($?setTimeout(ne):ne())},onLastListenerRemove(){J&&J.dispose(),J=null}});return se.event}r.buffer=A;class O{constructor($){this.event=$}map($){return new O(o(this.event,$))}forEach($){return new O(S(this.event,$))}filter($){return new O(s(this.event,$))}reduce($,z){return new O(c(this.event,$,z))}latch(){return new O(v(this.event))}debounce($,z=100,W=!1,J){return new O(d(this.event,$,z,W,J))}on($,z,W){return this.event($,z,W)}once($,z,W){return f(this.event)($,z,W)}}function N(B){return new O(B)}r.chain=N;function L(B,$,z=W=>W){const W=(...K)=>se.fire(z(...K)),J=()=>B.on($,W),ne=()=>B.removeListener($,W),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return se.event}r.fromNodeEventEmitter=L;function M(B,$,z=W=>W){const W=(...K)=>se.fire(z(...K)),J=()=>B.addEventListener($,W),ne=()=>B.removeEventListener($,W),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return se.event}r.fromDOMEventEmitter=M;function V(B){return new Promise($=>f(B)($))}r.toPromise=V;function H(B,$){return $(void 0),B(z=>$(z))}r.runAndSubscribe=H;function U(B,$){let z=null;function W(ne){z?.dispose(),z=new I.DisposableStore,$(ne,z)}W(void 0);const J=B(ne=>W(ne));return(0,I.toDisposable)(()=>{J.dispose(),z?.dispose()})}r.runAndSubscribeWithStore=U})(k=e.Event||(e.Event={}));class _{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${_._idPool++}`}start(f){this._stopWatch=new T.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let P=-1;function R(r){const f=P;return P=r,{dispose(){P=f}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(f,o=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let o=P;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||f<o)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(S)||0;if(this._stacks.set(S,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,n=0;for(const[c,a]of this._stacks)(!i||n<a)&&(i=c,n=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(f,o,S)=>{this._listeners||(this._listeners=new D.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[f,o]:f);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,o);const n=this._leakageMon?.check(this._listeners.size),c=(0,I.toDisposable)(()=>{n&&n(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(c):Array.isArray(S)&&S.push(c),c}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,S]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,S):o[0].call(o[1],S)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class w extends l{async fireAsync(f,o,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,f]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),n=[],c={...i,token:o,waitUntil:a=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(a=S(a,typeof s=="function"?s:s[0])),n.push(a)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(a){(0,m.onUnexpectedError)(a);continue}Object.freeze(n),await Promise.allSettled(n).then(a=>{for(const h of a)h.status==="rejected"&&(0,m.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=w;class p extends l{constructor(f){super(f);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=p;class g extends p{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=g;class E extends l{constructor(f){super(f);this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class F{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const o={event:f,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const S=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(o=>this.emitter.fire(o))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=F;class y{constructor(){this.buffers=[]}wrapEvent(f){return(o,S,s)=>f(i=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>o.call(S,i)):o.call(S,i)},void 0,s)}bufferEvents(f){const o=[];this.buffers.push(o);const S=f();return this.buffers.pop(),o.forEach(s=>s()),S}}e.EventBufferer=y;class u{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(pe[21],ve([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,_){const P=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(P)}}});var I;(function(k){function _(P){return P===k.None||P===k.Cancelled||P instanceof D?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=I.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=T}),define(pe[141],ve([0,1,21]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new m.CancellationTokenSource,k=this.task(T.token);return this.result={promise:k,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class I{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const k=JSON.stringify(T);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=I}),define(pe[97],ve([0,1,16,6]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(u){const r=u;return r?[r.on,r.pause,r.resume,r.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=I;function D(u){const r=u;return r?I(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(u,r){return new k(u,r)}e.newWriteableStream=T;class k{constructor(r,f){this.reducer=r,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(f=>f(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(f=>f(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,f){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(r,f){if(this.state.destroyed)return;let o;switch(r){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const S=o.indexOf(f);S>=0&&o.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,r){const f=[];let o;for(;(o=u.read())!==null;)f.push(o);return r(f)}e.consumeReadable=_;function P(u,r,f){const o=[];let S;for(;(S=u.read())!==null&&o.length<f;)o.push(S);return S===null&&o.length>0?r(o):{read:()=>{if(o.length>0)return o.shift();if(typeof S!="undefined"){const s=S;return S=void 0,s}return u.read()}}}e.peekReadable=P;function R(u,r){return new Promise((f,o)=>{const S=[];C(u,{onData:s=>{r&&S.push(s)},onError:s=>{r?o(s):f(void 0)},onEnd:()=>{f(r?r(S):void 0)}})})}e.consumeStream=R;function C(u,r){let f=!1;return u.on("error",o=>{f||r.onError(o)}),u.on("end",()=>{f||r.onEnd()}),u.on("data",o=>{f||r.onData(o)}),(0,t.toDisposable)(()=>f=!0)}e.listenStream=C;function l(u,r){return new Promise((f,o)=>{const S=new t.DisposableStore,s=[],i=a=>{if(s.push(a),s.length>r)return S.dispose(),u.pause(),f({stream:u,buffer:s,ended:!1})},n=a=>o(a),c=()=>f({stream:u,buffer:s,ended:!0});S.add((0,t.toDisposable)(()=>u.removeListener("error",n))),u.on("error",n),S.add((0,t.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),S.add((0,t.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=l;function w(u,r){const f=T(r);return f.end(u),f}e.toStream=w;function p(){const u=T(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=p;function g(u){let r=!1;return{read:()=>r?null:(r=!0,u)}}e.toReadable=g;function E(u,r,f){const o=T(f);return C(u,{onData:S=>o.write(r.data(S)),onError:S=>o.error(r.error?r.error(S):S),onEnd:()=>o.end()}),o}e.transform=E;function F(u,r,f){let o=!1;return{read:()=>{const S=r.read();return o?S:(o=!0,S!==null?f([u,S]):u)}}}e.prefixedReadable=F;function y(u,r,f){let o=!1;const S=T(f);return C(r,{onData:s=>o?S.write(s):(o=!0,S.write(f([u,s]))),onError:s=>S.error(s),onEnd:()=>{o||(o=!0,S.write(u)),S.end()}}),S}e.prefixedStream=y}),define(pe[22],ve([0,1,97]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,D;class T{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,d){return!(d?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(h)):(I||(I=new TextEncoder),new T(I.encode(h)))}static fromByteArray(h){const d=T.alloc(h.length);for(let v=0,b=h.length;v<b;v++)d.buffer[v]=h[v];return d}static concat(h,d){if(typeof d=="undefined"){d=0;for(let A=0,O=h.length;A<O;A++)d+=h[A].byteLength}const v=T.alloc(d);let b=0;for(let A=0,O=h.length;A<O;A++){const N=h[A];v.set(N,b),b+=N.byteLength}return v}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(h,d){return new T(this.buffer.subarray(h,d))}set(h,d){if(h instanceof T)this.buffer.set(h.buffer,d);else if(h instanceof Uint8Array)this.buffer.set(h,d);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),d);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),d);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return P(this.buffer,h)}writeUInt32BE(h,d){R(this.buffer,h,d)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,d){l(this.buffer,h,d)}readUInt8(h){return w(this.buffer,h)}writeUInt8(h,d){p(this.buffer,h,d)}}e.VSBuffer=T;function k(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=k;function _(a,h,d){a[d+0]=h&255,h=h>>>8,a[d+1]=h&255}e.writeUInt16LE=_;function P(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=P;function R(a,h,d){a[d+3]=h,h=h>>>8,a[d+2]=h,h=h>>>8,a[d+1]=h,h=h>>>8,a[d]=h}e.writeUInt32BE=R;function C(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=C;function l(a,h,d){a[d+0]=h&255,h=h>>>8,a[d+1]=h&255,h=h>>>8,a[d+2]=h&255,h=h>>>8,a[d+3]=h&255}e.writeUInt32LE=l;function w(a,h){return a[h]}e.readUInt8=w;function p(a,h,d){a[d]=h}e.writeUInt8=p;function g(a){return m.consumeReadable(a,h=>T.concat(h))}e.readableToBuffer=g;function E(a){return m.toReadable(a)}e.bufferToReadable=E;function F(a){return m.consumeStream(a,h=>T.concat(h))}e.streamToBuffer=F;async function y(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await F(a.stream)])}e.bufferedStreamToBuffer=y;function u(a){return m.toStream(a,h=>T.concat(h))}e.bufferToStream=u;function r(a){return m.transform(a,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=r;function f(a){return m.newWriteableStream(h=>T.concat(h),a)}e.newWriteableBufferStream=f;function o(a,h){return m.prefixedReadable(a,h,d=>T.concat(d))}e.prefixedBufferReadable=o;function S(a,h){return m.prefixedStream(a,h,d=>T.concat(d))}e.prefixedBufferStream=S;function s(a){let h=0,d=0,v=0;const b=new Uint8Array(Math.floor(a.length/4*3)),A=N=>{switch(d){case 3:b[v++]=h|N,d=0;break;case 2:b[v++]=h|N>>>2,h=N<<6,d=3;break;case 1:b[v++]=h|N>>>4,h=N<<4,d=2;break;default:h=N<<2,d=1}};for(let N=0;N<a.length;N++){const L=a.charCodeAt(N);if(L>=65&&L<=90)A(L-65);else if(L>=97&&L<=122)A(L-97+26);else if(L>=48&&L<=57)A(L-48+52);else if(L===43||L===45)A(62);else if(L===47||L===95)A(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[N]}`)}}const O=v;for(;d>0;)A(0);return T.wrap(b).slice(0,O)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,d=!1){const v=d?n:i;let b="";const A=a.byteLength%3;let O=0;for(;O<a.byteLength-A;O+=3){const N=a[O+0],L=a[O+1],M=a[O+2];b+=v[N>>>2],b+=v[(N<<4|L>>>4)&63],b+=v[(L<<2|M>>>6)&63],b+=v[M&63]}if(A===1){const N=a[O+0];b+=v[N>>>2],b+=v[N<<4&63],h&&(b+="==")}else if(A===2){const N=a[O+0],L=a[O+1];b+=v[N>>>2],b+=v[(N<<4|L>>>4)&63],b+=v[L<<2&63],h&&(b+="=")}return b}e.encodeBase64=c}),define(pe[8],ve([0,1,141,92]),function(Z,e,m,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function k(re,...ye){return ye.length===0?re:re.replace(T,function(Fe,qe){const Ve=parseInt(qe,10);return isNaN(Ve)||Ve<0||Ve>=ye.length?Fe:ye[Ve]})}e.format=k;const _=/{([^}]+)}/g;function P(re,ye){return re.replace(_,(Fe,qe)=>ye[qe]??Fe)}e.format2=P;function R(re){return re.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=R;function C(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function l(re,ye){let Fe=0;const qe=ye.charCodeAt(0);for(let Ve=re.length-1;Ve>=0;Ve--)re.charCodeAt(Ve)===qe&&Fe++;return Fe}e.count=l;function w(re,ye,Fe="\u2026"){return re.length<=ye?re:`${re.substr(0,ye)}${Fe}`}e.truncate=w;function p(re,ye=" "){const Fe=g(re,ye);return E(Fe,ye)}e.trim=p;function g(re,ye){if(!re||!ye)return re;const Fe=ye.length;if(Fe===0||re.length===0)return re;let qe=0;for(;re.indexOf(ye,qe)===qe;)qe=qe+Fe;return re.substring(qe)}e.ltrim=g;function E(re,ye){if(!re||!ye)return re;const Fe=ye.length,qe=re.length;if(Fe===0||qe===0)return re;let Ve=qe,ut=-1;for(;ut=re.lastIndexOf(ye,Ve-1),!(ut===-1||ut+Fe!==Ve);){if(ut===0)return"";Ve=ut}return re.substring(0,Ve)}e.rtrim=E;function F(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=F;function y(re){return re.replace(/\*/g,"")}e.stripWildcards=y;function u(re,ye,Fe={}){if(!re)throw new Error("Cannot create regex from empty string");ye||(re=C(re)),Fe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let qe="";return Fe.global&&(qe+="g"),Fe.matchCase||(qe+="i"),Fe.multiline&&(qe+="m"),Fe.unicode&&(qe+="u"),new RegExp(re,qe)}e.createRegExp=u;function r(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=r;function f(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function o(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=o;function S(re){return re.split(/\r\n|\r|\n/)}e.splitLines=S;function s(re){for(let ye=0,Fe=re.length;ye<Fe;ye++){const qe=re.charCodeAt(ye);if(qe!==32&&qe!==9)return ye}return-1}e.firstNonWhitespaceIndex=s;function i(re,ye=0,Fe=re.length){for(let qe=ye;qe<Fe;qe++){const Ve=re.charCodeAt(qe);if(Ve!==32&&Ve!==9)return re.substring(ye,qe)}return re.substring(ye,Fe)}e.getLeadingWhitespace=i;function n(re,ye=re.length-1){for(let Fe=ye;Fe>=0;Fe--){const qe=re.charCodeAt(Fe);if(qe!==32&&qe!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function c(re,ye){return re<ye?-1:re>ye?1:0}e.compare=c;function a(re,ye,Fe=0,qe=re.length,Ve=0,ut=ye.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=ye.charCodeAt(Ve);if(De<ce)return-1;if(De>ce)return 1}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=a;function h(re,ye){return d(re,ye,0,re.length,0,ye.length)}e.compareIgnoreCase=h;function d(re,ye,Fe=0,qe=re.length,Ve=0,ut=ye.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=ye.charCodeAt(Ve);if(De===ce)continue;if(De>=128||ce>=128)return a(re.toLowerCase(),ye.toLowerCase(),Fe,qe,Ve,ut);v(De)&&(De-=32),v(ce)&&(ce-=32);const de=De-ce;if(de!==0)return de}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=d;function v(re){return re>=97&&re<=122}e.isLowerAsciiLetter=v;function b(re){return re>=65&&re<=90}e.isUpperAsciiLetter=b;function A(re,ye){return re.length===ye.length&&d(re,ye)===0}e.equalsIgnoreCase=A;function O(re,ye){const Fe=ye.length;return ye.length>re.length?!1:d(re,ye,0,Fe)===0}e.startsWithIgnoreCase=O;function N(re,ye){let Fe,qe=Math.min(re.length,ye.length);for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Fe)!==ye.charCodeAt(Fe))return Fe;return qe}e.commonPrefixLength=N;function L(re,ye){let Fe,qe=Math.min(re.length,ye.length);const Ve=re.length-1,ut=ye.length-1;for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Ve-Fe)!==ye.charCodeAt(ut-Fe))return Fe;return qe}e.commonSuffixLength=L;function M(re){return 55296<=re&&re<=56319}e.isHighSurrogate=M;function V(re){return 56320<=re&&re<=57343}e.isLowSurrogate=V;function H(re,ye){return(re-55296<<10)+(ye-56320)+65536}e.computeCodePoint=H;function U(re,ye,Fe){const qe=re.charCodeAt(Fe);if(M(qe)&&Fe+1<ye){const Ve=re.charCodeAt(Fe+1);if(V(Ve))return H(qe,Ve)}return qe}e.getNextCodePoint=U;function B(re,ye){const Fe=re.charCodeAt(ye-1);if(V(Fe)&&ye>1){const qe=re.charCodeAt(ye-2);if(M(qe))return H(qe,Fe)}return Fe}class ${constructor(ye,Fe=0){this._str=ye,this._len=ye.length,this._offset=Fe}get offset(){return this._offset}setOffset(ye){this._offset=ye}prevCodePoint(){const ye=B(this._str,this._offset);return this._offset-=ye>=65536?2:1,ye}nextCodePoint(){const ye=U(this._str,this._len,this._offset);return this._offset+=ye>=65536?2:1,ye}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class z{constructor(ye,Fe=0){this._iterator=new $(ye,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ye=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=ye.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Re=ye.getGraphemeBreakType(Fe.nextCodePoint());if(st(Ve,Re)){Fe.setOffset(ut);break}Ve=Re}return Fe.offset-qe}prevGraphemeLength(){const ye=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=ye.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Re=ye.getGraphemeBreakType(Fe.prevCodePoint());if(st(Re,Ve)){Fe.setOffset(ut);break}Ve=Re}return qe-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function W(re,ye){return new z(re,ye).nextGraphemeLength()}e.nextCharLength=W;function J(re,ye){return new z(re,ye).prevGraphemeLength()}e.prevCharLength=J;function ne(re,ye){ye>0&&V(re.charCodeAt(ye))&&ye--;const Fe=ye+W(re,ye);return[Fe-J(re,Fe),Fe]}e.getCharContainingOffset=ne;const se=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(re){return se.test(re)}e.containsRTL=K;const Q=/^[\t\n\r\x20-\x7E]*$/;function ae(re){return Q.test(re)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=fe;function be(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=be;function Me(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=Me;function xe(re,ye){if(re.length<ye)return re;const Fe=/\b/g;let qe=0;for(;Fe.test(re)&&!(re.length-Fe.lastIndex<ye);)qe=Fe.lastIndex,Fe.lastIndex+=1;return re.substring(qe).replace(/^\s/,"")}e.lcut=xe;const Ge=/\x1B\x5B[12]?K/g,Je=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function te(re){return re&&(re=re.replace(Ge,""),re=re.replace(Je,""),re=re.replace(q,"")),re}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function X(re){return G(re)?re.substr(1):re}e.stripUTF8BOM=X;function oe(re,ye){if(!re||!ye||re.length<ye.length)return!1;const Fe=ye.length,qe=re.toLowerCase();let Ve=0,ut=-1;for(;Ve<Fe;){const Re=qe.indexOf(ye[Ve],ut+1);if(Re<0)return!1;ut=Re,Ve++}return!0}e.fuzzyContains=oe;function me(re,ye=!1){return re?(ye&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=me;function Ie(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=Ie;function We(re,ye=1){if(ye===0)return"";let Fe=-1;do Fe=re.indexOf(`
`,Fe+1),ye--;while(ye>0&&Fe>=0);return Fe===-1?re:(re[Fe-1]==="\r"&&Fe--,re.substr(0,Fe))}e.getNLines=We;function Ye(re){const ye=90-65+1;return re=re%(2*ye),re<ye?String.fromCharCode(97+re):String.fromCharCode(65+re-ye)}e.singleLetterHash=Ye;function it(re){return tt.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=it;function st(re,ye){return re===0?ye!==5&&ye!==7:re===2&&ye===3?!1:re===4||re===2||re===3||ye===4||ye===2||ye===3?!0:!(re===8&&(ye===8||ye===9||ye===11||ye===12)||(re===11||re===9)&&(ye===9||ye===10)||(re===12||re===10)&&ye===10||ye===5||ye===13||ye===7||re===1||re===13&&ye===14||re===6&&ye===6)}var ot;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class tt{constructor(){this._data=rt()}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Fe=this._data,qe=Fe.length/3;let Ve=1;for(;Ve<=qe;)if(ye<Fe[3*Ve])Ve=2*Ve;else if(ye>Fe[3*Ve+1])Ve=2*Ve+1;else return Fe[3*Ve+2];return 0}}tt._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(re,ye){if(re===0)return 0;const Fe=Ue(re,ye);if(Fe!==void 0)return Fe;const qe=new $(ye,re);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=gt;function Ue(re,ye){const Fe=new $(ye,re);let qe=Fe.prevCodePoint();for(;It(qe)||qe===65039||qe===8419;){if(Fe.offset===0)return;qe=Fe.prevCodePoint()}if(!Me(qe))return;let Ve=Fe.offset;return Ve>0&&Fe.prevCodePoint()===8205&&(Ve=Fe.offset),Ve}function It(re){return 127995<=re&&re<=127999}var ee;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ie{constructor(ye){this.confusableDictionary=ye}static getInstance(ye){return ie.cache.get(Array.from(ye))}static getLocales(){return ie._locales.getValue()}isAmbiguous(ye){return this.confusableDictionary.has(ye)}getPrimaryConfusable(ye){return this.confusableDictionary.get(ye)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ie,I=ie,ie.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ie.cache=new m.LRUCachedComputed(re=>{function ye(ce){const de=new Map;for(let we=0;we<ce.length;we+=2)de.set(ce[we],ce[we+1]);return de}function Fe(ce,de){const we=new Map(ce);for(const[Ce,Oe]of de)we.set(Ce,Oe);return we}function qe(ce,de){if(!ce)return de;const we=new Map;for(const[Ce,Oe]of ce)de.has(Ce)&&we.set(Ce,Oe);return we}const Ve=I.ambiguousCharacterData.getValue();let ut=re.filter(ce=>!ce.startsWith("_")&&ce in Ve);ut.length===0&&(ut=["_default"]);let Re;for(const ce of ut){const de=ye(Ve[ce]);Re=qe(Re,de)}const Ae=ye(Ve._common),De=Fe(Ae,Re);return new ie(De)}),ie._locales=new t.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(ye){return Se.getData().has(ye)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(pe[58],ve([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(F){return I(F,0)}e.hash=t;function I(F,y){switch(typeof F){case"object":return F===null?D(349,y):Array.isArray(F)?_(F,y):P(F,y);case"string":return k(F,y);case"boolean":return T(F,y);case"number":return D(F,y);case"undefined":return D(937,y);default:return D(617,y)}}e.doHash=I;function D(F,y){return(y<<5)-y+F|0}e.numberHash=D;function T(F,y){return D(F?433:863,y)}function k(F,y){y=D(149417,y);for(let u=0,r=F.length;u<r;u++)y=D(F.charCodeAt(u),y);return y}e.stringHash=k;function _(F,y){return y=D(104579,y),F.reduce((u,r)=>I(r,u),y)}function P(F,y){return y=D(181387,y),Object.keys(F).sort().reduce((u,r)=>(u=k(r,u),I(F[r],u)),y)}class R{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=I(y,this._value),this._value}}e.Hasher=R;var C;(function(F){F[F.BLOCK_SIZE=64]="BLOCK_SIZE",F[F.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(F,y,u=32){const r=u-y,f=~((1<<r)-1);return(F<<y|(f&F)>>>r)>>>0}function w(F,y=0,u=F.byteLength,r=0){for(let f=0;f<u;f++)F[y+f]=r}function p(F,y,u="0"){for(;F.length<y;)F=u+F;return F}function g(F,y=32){return F instanceof ArrayBuffer?Array.from(new Uint8Array(F)).map(u=>u.toString(16).padStart(2,"0")).join(""):p((F>>>0).toString(16),y/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const u=y.length;if(u===0)return;const r=this._buff;let f=this._buffLen,o=this._leftoverHighSurrogate,S,s;for(o!==0?(S=o,s=-1,o=0):(S=y.charCodeAt(0),s=0);;){let i=S;if(m.isHighSurrogate(S))if(s+1<u){const n=y.charCodeAt(s+1);m.isLowSurrogate(n)?(s++,i=m.computeCodePoint(S,n)):i=65533}else{o=S;break}else m.isLowSurrogate(S)&&(i=65533);if(f=this._push(r,f,i),s++,s<u)S=y.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=o}_push(y,u,r){return r<128?y[u++]=r:r<2048?(y[u++]=192|(r&1984)>>>6,y[u++]=128|(r&63)>>>0):r<65536?(y[u++]=224|(r&61440)>>>12,y[u++]=128|(r&4032)>>>6,y[u++]=128|(r&63)>>>0):(y[u++]=240|(r&1835008)>>>18,y[u++]=128|(r&258048)>>>12,y[u++]=128|(r&4032)>>>6,y[u++]=128|(r&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=E._bigBlock32,u=this._buffDV;for(let a=0;a<64;a+=4)y.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,l(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let r=this._h0,f=this._h1,o=this._h2,S=this._h3,s=this._h4,i,n,c;for(let a=0;a<80;a++)a<20?(i=f&o|~f&S,n=1518500249):a<40?(i=f^o^S,n=1859775393):a<60?(i=f&o|f&S|o&S,n=2400959708):(i=f^o^S,n=3395469782),c=l(r,5)+i+s+n+y.getUint32(a*4,!1)&4294967295,s=S,S=o,o=l(f,30),f=r,r=c;this._h0=this._h0+r&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[24],ve([0,1,17,8]),function(Z,e,m,t){"use strict";var I,D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,i,n){let c=s.get(i);return c===void 0&&(c=n,s.set(i,c)),c}e.getOrSet=k;function _(s){const i=[];return s.forEach((n,c)=>{i.push(`${c} => ${n}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=_;function P(s){const i=[];return s.forEach(n=>{i.push(n)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return n-c}value(){return this._value[this._pos]}}e.StringIterator=R;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let n=i.length-1;n>=0;n--,this._valueLen--){const c=this._value.charCodeAt(n);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var w;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(w||(w={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(E||(E={}));class F{constructor(i){this._iter=i}static forUris(i=()=>!1){return new F(new p(i))}static forPaths(i=!1){return new F(new l(void 0,!i))}static forStrings(){return new F(new R)}static forConfigKeys(){return new F(new C)}clear(){this._root=void 0}fill(i,n){if(n){const c=n.slice(0);(0,m.shuffle)(c);for(let a of c)this.set(a,i)}else{const c=i.slice(0);(0,m.shuffle)(c);for(let a of c)this.set(a[0],a[1])}}set(i,n){const c=this._iter.reset(i);let a;this._root||(this._root=new g,this._root.segment=c.value());const h=[];for(a=this._root;;){const v=c.cmp(a.segment);if(v>0)a.left||(a.left=new g,a.left.segment=c.value()),h.push([-1,a]),a=a.left;else if(v<0)a.right||(a.right=new g,a.right.segment=c.value()),h.push([1,a]),a=a.right;else if(c.hasNext())c.next(),a.mid||(a.mid=new g,a.mid.segment=c.value()),h.push([0,a]),a=a.mid;else break}const d=a.value;a.value=n,a.key=i;for(let v=h.length-1;v>=0;v--){const b=h[v][1];b.updateHeight();const A=b.balanceFactor();if(A<-1||A>1){const O=h[v][0],N=h[v+1][0];if(O===1&&N===1)h[v][1]=b.rotateLeft();else if(O===-1&&N===-1)h[v][1]=b.rotateRight();else if(O===1&&N===-1)b.right=h[v+1][1]=h[v+1][1].rotateRight(),h[v][1]=b.rotateLeft();else if(O===-1&&N===1)b.left=h[v+1][1]=h[v+1][1].rotateLeft(),h[v][1]=b.rotateRight();else throw new Error;if(v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this._root=h[0][1]}}return d}get(i){return this._getNode(i)?.value}_getNode(i){const n=this._iter.reset(i);let c=this._root;for(;c;){const a=n.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(n.hasNext())n.next(),c=c.mid;else break}return c}has(i){const n=this._getNode(i);return!(n?.value===void 0&&n?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const c=this._iter.reset(i),a=[];let h=this._root;for(;h;){const d=c.cmp(h.segment);if(d>0)a.push([-1,h]),h=h.left;else if(d<0)a.push([1,h]),h=h.right;else if(c.hasNext())c.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const d=this._min(h.right),{key:v,value:b,segment:A}=d;this._delete(d.key,!1),h.key=v,h.value=b,h.segment=A}else{const d=h.left??h.right;if(a.length>0){const[v,b]=a[a.length-1];switch(v){case-1:b.left=d;break;case 0:b.mid=d;break;case 1:b.right=d;break}}else this._root=d}for(let d=a.length-1;d>=0;d--){const v=a[d][1];v.updateHeight();const b=v.balanceFactor();if(b>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),a[d][1]=v.rotateLeft()):b<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),a[d][1]=v.rotateRight()),d>0)switch(a[d-1][0]){case-1:a[d-1][1].left=a[d][1];break;case 1:a[d-1][1].right=a[d][1];break;case 0:a[d-1][1].mid=a[d][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const n=this._iter.reset(i);let c=this._root,a;for(;c;){const h=n.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(n.hasNext())n.next(),a=c.value||a,c=c.mid;else break}return c&&c.value||a}findSuperstr(i){const n=this._iter.reset(i);let c=this._root;for(;c;){const a=n.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(n.hasNext())n.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[n,c]of this)i(c,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=n=>{if(!n)return!0;const c=n.balanceFactor();return c<-1||c>1?!1:i(n.left)&&i(n.right)};return i(this._root)}}e.TernarySearchTree=F;class y{constructor(i,n){this.uri=i,this.value=n}}class u{constructor(i,n){this[I]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=n??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),new y(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[c,a]of this.map)i(a.value,a.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var r;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class f{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=0){const c=this._map.get(i);if(!!c)return n!==0&&this.touch(c,n),c.value}set(i,n,c=0){let a=this._map.get(i);if(a)a.value=n,c!==0&&this.touch(a,c);else{switch(a={key:i,value:n,next:void 0,previous:void 0},c){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const c=this._state;let a=this._head;for(;a;){if(n?i.bind(n)(a.value,a.key,this):i(a.value,a.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,n=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}values(){const i=this,n=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}entries(){const i=this,n=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,c=this.size;for(;n&&c>i;)this._map.delete(n.key),n=n.next,c--;this._head=n,this._size=c,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,c=i.previous;if(!n||!c)throw new Error("Invalid list");n.previous=c,c.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const c=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(c.previous=a,a.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const c=i.next,a=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=a,a.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,c)=>{i.push([c,n])}),i}fromJSON(i){this.clear();for(const[n,c]of i)this.set(n,c)}}e.LinkedMap=f;class o extends f{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class S{constructor(i){T.set(this,void 0),nt(this,T,i,"f")}get size(){return Le(this,T,"f").size}forEach(i,n){Le(this,T,"f").forEach(i,n)}get(i){return Le(this,T,"f").get(i)}has(i){return Le(this,T,"f").has(i)}entries(){return Le(this,T,"f").entries()}keys(){return Le(this,T,"f").keys()}values(){return Le(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Le(this,T,"f").entries()}}e.ReadonlyMapView=S}),define(pe[98],ve([0,1,24,8]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...G){return function(X,oe){for(let me=0,Ie=G.length;me<Ie;me++){const We=G[me](X,oe);if(We)return We}return null}}e.or=I,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(G,X,oe){if(!oe||oe.length<X.length)return null;let me;return G?me=t.startsWithIgnoreCase(oe,X):me=oe.indexOf(X)===0,me?X.length>0?[{start:0,end:X.length}]:[]:null}function T(G,X){const oe=X.toLowerCase().indexOf(G.toLowerCase());return oe===-1?null:[{start:oe,end:oe+G.length}]}e.matchesContiguousSubString=T;function k(G,X){return _(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=k;function _(G,X,oe,me){if(oe===G.length)return[];if(me===X.length)return null;if(G[oe]===X[me]){let Ie=null;return(Ie=_(G,X,oe+1,me+1))?F({start:me,end:me+1},Ie):null}return _(G,X,oe,me+1)}function P(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function C(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>w.add(G.charCodeAt(0)));function p(G){return l(G)||w.has(G)}function g(G,X){return G===X||p(G)&&p(X)}function E(G){return P(G)||R(G)||C(G)}function F(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function y(G,X){for(let oe=X;oe<G.length;oe++){const me=G.charCodeAt(oe);if(R(me)||C(me)||oe>0&&!E(G.charCodeAt(oe-1)))return oe}return G.length}function u(G,X,oe,me){if(oe===G.length)return[];if(me===X.length)return null;if(G[oe]!==X[me].toLowerCase())return null;{let Ie=null,We=me+1;for(Ie=u(G,X,oe+1,me+1);!Ie&&(We=y(X,We))<X.length;)Ie=u(G,X,oe+1,We),We++;return Ie===null?null:F({start:me,end:me+1},Ie)}}function r(G){let X=0,oe=0,me=0,Ie=0,We=0;for(let tt=0;tt<G.length;tt++)We=G.charCodeAt(tt),R(We)&&X++,P(We)&&oe++,E(We)&&me++,C(We)&&Ie++;const Ye=X/G.length,it=oe/G.length,st=me/G.length,ot=Ie/G.length;return{upperPercent:Ye,lowerPercent:it,alphaPercent:st,numericPercent:ot}}function f(G){const{upperPercent:X,lowerPercent:oe}=G;return oe===0&&X>.6}function o(G){const{upperPercent:X,lowerPercent:oe,alphaPercent:me,numericPercent:Ie}=G;return oe>.2&&X<.8&&me>.6&&Ie<.2}function S(G){let X=0,oe=0,me=0,Ie=0;for(let We=0;We<G.length;We++)me=G.charCodeAt(We),R(me)&&X++,P(me)&&oe++,l(me)&&Ie++;return(X===0||oe===0)&&Ie===0?G.length<=30:X<=5}function s(G,X){if(!X||(X=X.trim(),X.length===0)||!S(G)||X.length>60)return null;const oe=r(X);if(!o(oe)){if(!f(oe))return null;X=X.toLowerCase()}let me=null,Ie=0;for(G=G.toLowerCase();Ie<X.length&&(me=u(G,X,0,Ie))===null;)Ie=y(X,Ie+1);return me}e.matchesCamelCase=s;function i(G,X,oe=!1){if(!X||X.length===0)return null;let me=null,Ie=0;for(G=G.toLowerCase(),X=X.toLowerCase();Ie<X.length&&(me=n(G,X,0,Ie,oe))===null;)Ie=c(X,Ie+1);return me}e.matchesWords=i;function n(G,X,oe,me,Ie){if(oe===G.length)return[];if(me===X.length)return null;if(g(G.charCodeAt(oe),X.charCodeAt(me))){let We=null,Ye=me+1;if(We=n(G,X,oe+1,me+1,Ie),!Ie)for(;!We&&(Ye=c(X,Ye))<X.length;)We=n(G,X,oe+1,Ye,Ie),Ye++;return We===null?null:F({start:me,end:me+1},We)}else return null}function c(G,X){for(let oe=X;oe<G.length;oe++)if(p(G.charCodeAt(oe))||oe>0&&p(G.charCodeAt(oe-1)))return oe;return G.length}const a=I(e.matchesPrefix,s,T),h=I(e.matchesPrefix,s,k),d=new m.LRUCache(1e4);function v(G,X,oe=!1){if(typeof G!="string"||typeof X!="string")return null;let me=d.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),d.set(G,me));const Ie=me.exec(X);return Ie?[{start:Ie.index,end:Ie.index+Ie[0].length}]:oe?h(G,X):a(G,X)}e.matchesFuzzy=v;function b(G,X){const oe=be(G,G.toLowerCase(),0,X,X.toLowerCase(),0,!0);return oe?O(oe):null}e.matchesFuzzy2=b;function A(G,X,oe,me,Ie,We){const Ye=Math.min(13,G.length);for(;oe<Ye;oe++){const it=be(G,X,oe,me,Ie,We,!1);if(it)return it}return[0,We]}e.anyScore=A;function O(G){if(typeof G=="undefined")return[];const X=[],oe=G[1];for(let me=G.length-1;me>1;me--){const Ie=G[me]+oe,We=X[X.length-1];We&&We.end===Ie?We.end=Ie+1:X.push({start:Ie,end:Ie+1})}return X}e.createMatches=O;const N=128;function L(){const G=[],X=[];for(let oe=0;oe<=N;oe++)X[oe]=0;for(let oe=0;oe<=N;oe++)G.push(X.slice(0));return G}function M(G){const X=[];for(let oe=0;oe<=G;oe++)X[oe]=0;return X}const V=M(2*N),H=M(2*N),U=L(),B=L(),$=L(),z=!1;function W(G,X,oe,me,Ie){function We(it,st,ot=" "){for(;it.length<st;)it=ot+it;return it}let Ye=` |   |${me.split("").map(it=>We(it,3)).join("|")}
`;for(let it=0;it<=oe;it++)it===0?Ye+=" |":Ye+=`${X[it-1]}|`,Ye+=G[it].slice(0,Ie+1).map(st=>We(st.toString(),3)).join("|")+`
`;return Ye}function J(G,X,oe,me){G=G.substr(X),oe=oe.substr(me),console.log(W(B,G,G.length,oe,oe.length)),console.log(W($,G,G.length,oe,oe.length)),console.log(W(U,G,G.length,oe,oe.length))}function ne(G,X){if(X<0||X>=G.length)return!1;const oe=G.codePointAt(X);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(oe)}}function se(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function K(G,X,oe){return X[G]!==oe[G]}function Q(G,X,oe,me,Ie,We,Ye=!1){for(;X<oe&&Ie<We;)G[X]===me[Ie]&&(Ye&&(V[X]=Ie),X+=1),Ie+=1;return X===oe}e.isPatternInWord=Q;var ae;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var fe;(function(G){G.Default=[-100,0];function X(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}G.isDefault=X})(fe=e.FuzzyScore||(e.FuzzyScore={}));function be(G,X,oe,me,Ie,We,Ye){const it=G.length>N?N:G.length,st=me.length>N?N:me.length;if(oe>=it||We>=st||it-oe>st-We||!Q(X,oe,it,Ie,We,st,!0))return;Me(it,st,oe,We,X,Ie);let ot=1,tt=1,rt=oe,gt=We;const Ue=[!1];for(ot=1,rt=oe;rt<it;ot++,rt++){const re=V[rt],ye=H[rt],Fe=rt+1<it?H[rt+1]:st;for(tt=re-We+1,gt=re;gt<Fe;tt++,gt++){let qe=Number.MIN_SAFE_INTEGER,Ve=!1;gt<=ye&&(qe=xe(G,X,rt,oe,me,Ie,gt,st,We,U[ot-1][tt-1]===0,Ue));let ut=0;qe!==Number.MAX_SAFE_INTEGER&&(Ve=!0,ut=qe+B[ot-1][tt-1]);const Re=gt>re,Ae=Re?B[ot][tt-1]+(U[ot][tt-1]>0?-5:0):0,De=gt>re+1&&U[ot][tt-1]>0,ce=De?B[ot][tt-2]+(U[ot][tt-2]>0?-5:0):0;if(De&&(!Re||ce>=Ae)&&(!Ve||ce>=ut))B[ot][tt]=ce,$[ot][tt]=3,U[ot][tt]=0;else if(Re&&(!Ve||Ae>=ut))B[ot][tt]=Ae,$[ot][tt]=2,U[ot][tt]=0;else if(Ve)B[ot][tt]=ut,$[ot][tt]=1,U[ot][tt]=U[ot-1][tt-1]+1;else throw new Error("not possible")}}if(z&&J(G,oe,me,We),!Ue[0]&&!Ye)return;ot--,tt--;const It=[B[ot][tt],We];let ee=0,ie=0;for(;ot>=1;){let re=tt;do{const ye=$[ot][re];if(ye===3)re=re-2;else if(ye===2)re=re-1;else break}while(re>=1);ee>1&&X[oe+ot-1]===Ie[We+tt-1]&&!K(re+We-1,me,Ie)&&ee+1>U[ot][re]&&(re=tt),re===tt?ee++:ee=1,ie||(ie=re),ot--,tt=re-1,It.push(tt)}st===it&&(It[0]+=2);const Se=ie-it;return It[0]-=Se,It}e.fuzzyScore=be;function Me(G,X,oe,me,Ie,We){let Ye=G-1,it=X-1;for(;Ye>=oe&&it>=me;)Ie[Ye]===We[it]&&(H[Ye]=it,Ye--),it--}function xe(G,X,oe,me,Ie,We,Ye,it,st,ot,tt){if(X[oe]!==We[Ye])return Number.MIN_SAFE_INTEGER;let rt=1,gt=!1;return Ye===oe-me?rt=G[oe]===Ie[Ye]?7:5:K(Ye,Ie,We)&&(Ye===0||!K(Ye-1,Ie,We))?(rt=G[oe]===Ie[Ye]?7:5,gt=!0):ne(We,Ye)&&(Ye===0||!ne(We,Ye-1))?rt=5:(ne(We,Ye-1)||se(We,Ye-1))&&(rt=5,gt=!0),rt>1&&oe===me&&(tt[0]=!0),gt||(gt=K(Ye,Ie,We)||ne(We,Ye-1)||se(We,Ye-1)),oe===me?Ye>st&&(rt-=gt?3:5):ot?rt+=gt?2:0:rt+=gt?0:1,Ye+1===it&&(rt-=gt?3:5),rt}function Ge(G,X,oe,me,Ie,We,Ye){return q(G,X,oe,me,Ie,We,!0,Ye)}e.fuzzyScoreGracefulAggressive=Ge;function Je(G,X,oe,me,Ie,We,Ye){return q(G,X,oe,me,Ie,We,!1,Ye)}e.fuzzyScoreGraceful=Je;function q(G,X,oe,me,Ie,We,Ye,it){let st=be(G,X,oe,me,Ie,We,it);if(st&&!Ye)return st;if(G.length>=3){const ot=Math.min(7,G.length-1);for(let tt=oe+1;tt<ot;tt++){const rt=te(G,tt);if(rt){const gt=be(rt,rt.toLowerCase(),oe,me,Ie,We,it);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function te(G,X){if(X+1>=G.length)return;const oe=G[X],me=G[X+1];if(oe!==me)return G.slice(0,X)+me+oe+G.slice(X+2)}}),define(pe[142],ve([0,1,74,98,8]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${D.source}`,"g");function _(E){return E.replace(k,(F,y)=>y?F:`\\${F}`)}e.escapeIcons=_;const P=new RegExp(`\\\\${D.source}`,"g");function R(E){return E.replace(P,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=R;const C=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function l(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(C,(F,y,u,r)=>u?F:y||r||"")}e.stripIcons=l;function w(E){const F=E.indexOf(e.iconStartMarker);return F===-1?{text:E}:p(E,F)}e.parseLabelWithIcons=w;function p(E,F){const y=[];let u="";function r(a){if(a){u+=a;for(const h of a)y.push(S)}}let f=-1,o="",S=0,s,i,n=F;const c=E.length;for(r(E.substr(0,F));n<c;)s=E[n],i=E[n+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=n,r(o),o=e.iconStartMarker,n++):s===")"&&f!==-1?(S+=n-f+1,f=-1,o=""):f!==-1?T.test(s)?o+=s:(r(o),f=-1,o=""):r(s),n++;return r(o),{text:u,iconOffsets:y}}function g(E,F,y=!1){const{text:u,iconOffsets:r}=F;if(!r||r.length===0)return(0,t.matchesFuzzy)(E,u,y);const f=(0,I.ltrim)(u," "),o=u.length-f.length,S=(0,t.matchesFuzzy)(E,f,y);if(S)for(const s of S){const i=r[s.start+o]+o;s.start+=i,s.end+=i}return S}e.matchesFuzzyIconAware=g}),define(pe[99],ve([0,1,16,142]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(w="",p=!1){if(this.value=w,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(w,p=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(w):w).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,p){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=D;function T(l){return k(l)?!l.value:Array.isArray(l)?l.every(T):!0}e.isEmptyMarkdownString=T;function k(l){return l instanceof D?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(l,w){return l===w?!0:!l||!w?!1:l.value===w.value&&l.isTrusted===w.isTrusted&&l.supportThemeIcons===w.supportThemeIcons}e.markdownStringEqual=_;function P(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function R(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function C(l){const w=[],p=l.split("|").map(E=>E.trim());l=p[0];const g=p[1];if(g){const E=/height=(\d+)/.exec(g),F=/width=(\d+)/.exec(g),y=E?E[1]:"",u=F?F[1]:"",r=isFinite(parseInt(u)),f=isFinite(parseInt(y));r&&w.push(`width="${u}"`),f&&w.push(`height="${y}"`)}return{href:l,dimensions:w}}e.parseHrefAndDimensions=C}),define(pe[79],ve([0,1,24]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new m.LRUCache(1e4);function I(P){return _(P,"NFC",t)}e.normalizeNFC=I;const D=new m.LRUCache(1e4);function T(P){return _(P,"NFD",D)}e.normalizeNFD=T;const k=/[^\u0000-\u0080]/;function _(P,R,C){if(!P)return P;const l=C.get(P);if(l)return l;let w;return k.test(P)?w=P.normalize(R):w=P,C.set(P,w),w}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(R){return T(R).replace(P,"")}}()}),define(pe[47],ve([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const D="error",T="warning",k="warn",_="info",P="ignore";function R(l){return l?m.equalsIgnoreCase(D,l)?I.Error:m.equalsIgnoreCase(T,l)||m.equalsIgnoreCase(k,l)?I.Warning:m.equalsIgnoreCase(_,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function C(l){switch(l){case I.Error:return D;case I.Warning:return T;case I.Info:return _;default:return P}}I.toString=C}(t||(t={})),e.default=t}),define(pe[18],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(c){return Array.isArray(c)}e.isArray=m;function t(c){return typeof c=="string"}e.isString=t;function I(c){return Array.isArray(c)&&c.every(a=>t(a))}e.isStringArray=I;function D(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=D;function T(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=T;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function _(c){return c===!0||c===!1}e.isBoolean=_;function P(c){return typeof c=="undefined"}e.isUndefined=P;function R(c){return!C(c)}e.isDefined=R;function C(c){return P(c)||c===null}e.isUndefinedOrNull=C;function l(c,a){if(!c)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=l;function w(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=w;function p(...c){const a=[];for(let h=0;h<c.length;h++){const d=c[h];if(C(d))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);a.push(d)}return a}e.assertAllDefined=p;const g=Object.prototype.hasOwnProperty;function E(c){if(!D(c))return!1;for(let a in c)if(g.call(c,a))return!1;return!0}e.isEmptyObject=E;function F(c){return typeof c=="function"}e.isFunction=F;function y(...c){return c.length>0&&c.every(F)}e.areFunctions=y;function u(c,a){const h=Math.min(c.length,a.length);for(let d=0;d<h;d++)r(c[d],a[d])}e.validateConstraints=u;function r(c,a){if(t(a)){if(typeof c!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(F(a)){try{if(c instanceof a)return}catch{}if(!C(c)&&c.constructor===a||a.length===1&&a.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function f(c){let a=[],h=Object.getPrototypeOf(c);for(;Object.prototype!==h;)a=a.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return a}e.getAllPropertyNames=f;function o(c){const a=[];for(const h of f(c))typeof c[h]=="function"&&a.push(h);return a}e.getAllMethodNames=o;function S(c,a){const h=v=>function(){const b=Array.prototype.slice.call(arguments,0);return a(v,b)};let d={};for(const v of c)d[v]=h(v);return d}e.createProxyObject=S;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function i(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=i;function n(c,a="Unreachable"){throw new Error(a)}e.assertNever=n}),define(pe[29],ve([0,1,9,12,8,18]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function _(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function P(n,c=m.posix.sep){if(!n)return"";const a=n.length,h=n.charCodeAt(0);if(T(h)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let v=3;const b=v;for(;v<a&&!T(n.charCodeAt(v));v++);if(b!==v&&!T(n.charCodeAt(v+1))){for(v+=1;v<a;v++)if(T(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,c)}}return c}else if(F(h)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+c:n.slice(0,2);let d=n.indexOf("://");if(d!==-1){for(d+=3;d<a;d++)if(T(n.charCodeAt(d)))return n.slice(0,d+1)}return""}e.getRoot=P;function R(n){if(!t.isWindows||!n||n.length<5)return!1;let c=n.charCodeAt(0);if(c!==92||(c=n.charCodeAt(1),c!==92))return!1;let a=2;const h=a;for(;a<n.length&&(c=n.charCodeAt(a),c!==92);a++);return!(h===a||(c=n.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=R;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(n,c=t.isWindows){const a=c?C:l;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||c&&w.test(n)||n==="."||n===".."||c&&n[n.length-1]==="."||c&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=p;function g(n,c,a){const h=n===c;return!a||h?h:!n||!c?!1:(0,I.equalsIgnoreCase)(n,c)}e.isEqual=g;function E(n,c,a,h=m.sep){if(n===c)return!0;if(!n||!c||c.length>n.length)return!1;if(a){if(!(0,I.startsWithIgnoreCase)(n,c))return!1;if(c.length===n.length)return!0;let v=c.length;return c.charAt(c.length-1)===h&&v--,n.charAt(v)===h}return c.charAt(c.length-1)!==h&&(c+=h),n.indexOf(c)===0}e.isEqualOrParent=E;function F(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=F;function y(n,c){return t.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(c,n)),n=(0,m.normalize)(n),t.isWindows?(n=(0,I.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,I.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=y;function u(n){const c=(0,m.normalize)(n);return t.isWindows?n.length>3?!1:r(c)&&(n.length===2||c.charCodeAt(2)===92):c===m.posix.sep}e.isRootOrDriveLetter=u;function r(n,c){return(c!==void 0?c:t.isWindows)?F(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function f(n){return r(n)?n[0]:void 0}e.getDriveLetter=f;function o(n,c,a){return c.length>n.length?-1:n===c?0:(a&&(n=n.toLowerCase(),c=c.toLowerCase()),n.indexOf(c))}e.indexOfPath=o;function S(n){const c=n.split(":");let a,h,d;for(const v of c){const b=Number(v);(0,D.isNumber)(b)?h===void 0?h=b:d===void 0&&(d=b):a=a?[a,v].join(":"):v}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:d!==void 0?d:h!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(n,c,a=8){let h="";for(let v=0;v<a;v++)h+=s.charAt(Math.floor(Math.random()*s.length));let d;return c?d=`${c}-${h}`:d=h,n?(0,m.join)(n,d):d}e.randomPath=i}),define(pe[25],ve([0,1,18]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(F=>{g[F]&&typeof g[F]=="object"?E[F]=t(g[F]):E[F]=g[F]}),E}e.deepClone=t;function I(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const F=E.shift();Object.freeze(F);for(const y in F)if(D.call(F,y)){const u=F[y];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return g}e.deepFreeze=I;const D=Object.prototype.hasOwnProperty;function T(g,E){return k(g,E,new Set)}e.cloneAndChange=T;function k(g,E,F){if((0,m.isUndefinedOrNull)(g))return g;const y=E(g);if(typeof y!="undefined")return y;if((0,m.isArray)(g)){const u=[];for(const r of g)u.push(k(r,E,F));return u}if((0,m.isObject)(g)){if(F.has(g))throw new Error("Cannot clone recursive data-structure");F.add(g);const u={};for(let r in g)D.call(g,r)&&(u[r]=k(g[r],E,F));return F.delete(g),u}return g}function _(g,E,F=!0){return(0,m.isObject)(g)?((0,m.isObject)(E)&&Object.keys(E).forEach(y=>{y in g?F&&((0,m.isObject)(g[y])&&(0,m.isObject)(E[y])?_(g[y],E[y],F):g[y]=E[y]):g[y]=E[y]}),g):E}e.mixin=_;function P(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let F,y;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(F=0;F<g.length;F++)if(!P(g[F],E[F]))return!1}else{const u=[];for(y in g)u.push(y);u.sort();const r=[];for(y in E)r.push(y);if(r.sort(),!P(u,r))return!1;for(F=0;F<u.length;F++)if(!P(g[u[F]],E[u[F]]))return!1}return!0}e.equals=P;function R(g){const E=new Set;return JSON.stringify(g,(F,y)=>{if((0,m.isObject)(y)||Array.isArray(y)){if(E.has(y))return"[Circular]";E.add(y)}return y})}e.safeStringify=R;function C(g,E,F){const y=E(g);return typeof y=="undefined"?F:y}e.getOrDefault=C;function l(g,E){const F=Object.create(null);return!g||!E||Object.keys(E).forEach(u=>{const r=g[u],f=E[u];P(r,f)||(F[u]=f)}),F}e.distinct=l;function w(g,E){const F=E.toLowerCase(),y=Object.keys(g).find(u=>u.toLowerCase()===F);return y?g[y]:g[E]}e.getCaseInsensitive=w;function p(g,E){const F=Object.create(null);for(const[y,u]of Object.entries(g))E(y,u)&&(F[y]=u);return F}e.filter=p}),define(pe[100],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function t(D){return D<0?0:D>255?255:D|0}e.toUint8=t;function I(D){return D<0?0:D>4294967295?4294967295:D|0}e.toUint32=I}),define(pe[2],ve([0,1,9,12]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,D=/^\//,T=/^\/\//;function k(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,i){return!s&&!i?"file":s}function P(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const R="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(i,n,c,a,h,d=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=_(i,d),this.authority=n||R,this.path=P(this.scheme,c||R),this.query=a||R,this.fragment=h||R,k(this,d))}static isUri(i){return i instanceof w?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:n,authority:c,path:a,query:h,fragment:d}=i;return n===void 0?n=this.scheme:n===null&&(n=R),c===void 0?c=this.authority:c===null&&(c=R),a===void 0?a=this.path:a===null&&(a=R),h===void 0?h=this.query:h===null&&(h=R),d===void 0?d=this.fragment:d===null&&(d=R),n===this.scheme&&c===this.authority&&a===this.path&&h===this.query&&d===this.fragment?this:new g(n,c,a,h,d)}static parse(i,n=!1){const c=l.exec(i);return c?new g(c[2]||R,S(c[4]||R),S(c[5]||R),S(c[7]||R),S(c[9]||R),n):new g(R,R,R,R,R)}static file(i){let n=R;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(n=i.substring(2),i=C):(n=i.substring(2,c),i=i.substring(c)||C)}return new g("file",n,i,R,R)}static from(i){const n=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return k(n,!0),n}static joinPath(i,...n){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=w.file(m.win32.join(u(i,!0),...n)).path:c=m.posix.join(i.path,...n),i.with({path:c})}toString(i=!1){return r(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof w)return i;{const n=new g(i);return n._formatted=i.external,n._fsPath=i._sep===p?i.fsPath:null,n}}else return i}}e.URI=w;const p=t.isWindows?1:void 0;class g extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function F(s,i){let n,c=-1;for(let a=0;a<s.length;a++){const h=s.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)c!==-1&&(n+=encodeURIComponent(s.substring(c,a)),c=-1),n!==void 0&&(n+=s.charAt(a));else{n===void 0&&(n=s.substr(0,a));const d=E[h];d!==void 0?(c!==-1&&(n+=encodeURIComponent(s.substring(c,a)),c=-1),n+=d):c===-1&&(c=a)}}return c!==-1&&(n+=encodeURIComponent(s.substring(c))),n!==void 0?n:s}function y(s){let i;for(let n=0;n<s.length;n++){const c=s.charCodeAt(n);c===35||c===63?(i===void 0&&(i=s.substr(0,n)),i+=E[c]):i!==void 0&&(i+=s[n])}return i!==void 0?i:s}function u(s,i){let n;return s.authority&&s.path.length>1&&s.scheme==="file"?n=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?n=s.path.substr(1):n=s.path[1].toLowerCase()+s.path.substr(2):n=s.path,t.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=u;function r(s,i){const n=i?y:F;let c="",{scheme:a,authority:h,path:d,query:v,fragment:b}=s;if(a&&(c+=a,c+=":"),(h||a==="file")&&(c+=C,c+=C),h){let A=h.indexOf("@");if(A!==-1){const O=h.substr(0,A);h=h.substr(A+1),A=O.indexOf(":"),A===-1?c+=n(O,!1):(c+=n(O.substr(0,A),!1),c+=":",c+=n(O.substr(A+1),!1)),c+="@"}h=h.toLowerCase(),A=h.indexOf(":"),A===-1?c+=n(h,!1):(c+=n(h.substr(0,A),!1),c+=h.substr(A))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const A=d.charCodeAt(1);A>=65&&A<=90&&(d=`/${String.fromCharCode(A+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const A=d.charCodeAt(0);A>=65&&A<=90&&(d=`${String.fromCharCode(A+32)}:${d.substr(2)}`)}c+=n(d,!0)}return v&&(c+="?",c+=n(v,!1)),b&&(c+="#",c+=i?b:F(b,!1)),c}function f(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(s){return s.match(o)?s.replace(o,i=>f(i)):s}}),define(pe[59],ve([0,1,22,8,2]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(R){return JSON.stringify(R,_)}e.stringify=D;function T(R){let C=JSON.parse(R);return C=P(C),C}e.parse=T;var k;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function _(R,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function P(R,C=0){if(!R||C>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return I.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof m.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let l=0;l<R.length;++l)R[l]=P(R[l],C+1);else for(const l in R)Object.hasOwnProperty.call(R,l)&&(R[l]=P(R[l],C+1))}return R}e.revive=P}),define(pe[10],ve([0,1,12,2]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,P,R){this._hosts[_]=P,this._ports[_]=R}setConnectionToken(_,P){this._connectionTokens[_]=P}rewrite(_){if(this._delegate)return this._delegate(_);const P=_.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[P],l=this._connectionTokens[P];let w=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(w+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:m.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new D;class T{asBrowserUri(_,P){const R=this.toUri(_,P);return R.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===I.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${I.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:I.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(_,P){const R=this.toUri(_,P);return R.scheme===I.vscodeFileResource?R.with({scheme:I.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(_,P){return t.URI.isUri(_)?_:t.URI.parse(P.toUrl(_))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(pe[23],ve([0,1,29,10,9,12,8,2]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(w){return(0,k.uriToFsPath)(w,!0)}e.originalFSPath=_;class P{constructor(p){this._ignorePathCasing=p}compare(p,g,E=!1){return p===g?0:(0,T.compare)(this.getComparisonKey(p,E),this.getComparisonKey(g,E))}isEqual(p,g,E=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,E)===this.getComparisonKey(g,E)}getComparisonKey(p,g=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,g,E=!1){if(p.scheme===g.scheme){if(p.scheme===t.Schemas.file)return m.isEqualOrParent(_(p),_(g),this._ignorePathCasing(p))&&p.query===g.query&&(E||p.fragment===g.fragment);if((0,e.isEqualAuthority)(p.authority,g.authority))return m.isEqualOrParent(p.path,g.path,this._ignorePathCasing(p),"/")&&p.query===g.query&&(E||p.fragment===g.fragment)}return!1}joinPath(p,...g){return k.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return I.posix.basename(p.path)}extname(p){return I.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===t.Schemas.file?g=k.URI.file(I.dirname(_(p))).path:(g=I.posix.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===t.Schemas.file?g=k.URI.file(I.normalize(_(p))).path:g=I.posix.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.isEqualAuthority)(p.authority,g.authority))return;if(p.scheme===t.Schemas.file){const y=I.relative(_(p),_(g));return D.isWindows?m.toSlashes(y):y}let E=p.path||"/",F=g.path||"/";if(this._ignorePathCasing(p)){let y=0;for(const u=Math.min(E.length,F.length);y<u&&!(E.charCodeAt(y)!==F.charCodeAt(y)&&E.charAt(y).toLowerCase()!==F.charAt(y).toLowerCase());y++);E=F.substr(0,y)+E.substr(y)}return I.posix.relative(E,F)}resolvePath(p,g){if(p.scheme===t.Schemas.file){const E=k.URI.file(I.resolve(_(p),g));return p.with({authority:E.authority,path:E.path})}return g=m.toPosixPath(g),p.with({path:I.posix.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,T.equalsIgnoreCase)(p,g)}hasTrailingPathSeparator(p,g=I.sep){if(p.scheme===t.Schemas.file){const E=_(p);return E.length>m.getRoot(E).length&&E[E.length-1]===g}else{const E=p.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=I.sep){return(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=I.sep){let E=!1;if(p.scheme===t.Schemas.file){const F=_(p);E=F!==void 0&&F.length===m.getRoot(F).length&&F[F.length-1]===g}else{g="/";const F=p.path;E=F.length===1&&F.charCodeAt(F.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(w=>w.scheme===t.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new P(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(w,p){const g=[];for(let E=0;E<w.length;E++){const F=p(w[E]);w.some((y,u)=>u===E?!1:(0,e.isEqualOrParent)(F,p(y)))||g.push(w[E])}return g}e.distinctParents=R;var C;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function p(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[r,f]=u.split(":");r&&f&&E.set(r,f)});const y=g.path.substring(0,g.path.indexOf(";"));return y&&E.set(w.META_DATA_MIME,y),E}w.parseMetaData=p})(C=e.DataUri||(e.DataUri={}));function l(w,p,g){if(p){let E=w.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),w.with({scheme:g,authority:p,path:E})}return w.with({scheme:g})}e.toLocalResource=l}),define(pe[13],ve([0,1,21,16,3,6,23,12]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(K){return!!K&&typeof K.then=="function"}e.isThenable=_;function P(K){const Q=new m.CancellationTokenSource,ae=K(Q.token),fe=new Promise((be,Me)=>{const xe=Q.token.onCancellationRequested(()=>{xe.dispose(),Q.dispose(),Me(new t.CancellationError)});Promise.resolve(ae).then(Ge=>{xe.dispose(),Q.dispose(),be(Ge)},Ge=>{xe.dispose(),Q.dispose(),Me(Ge)})});return new class{cancel(){Q.cancel()}then(be,Me){return fe.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return fe.finally(be)}}}e.createCancelablePromise=P;function R(K,Q,ae){return new Promise((fe,be)=>{const Me=Q.onCancellationRequested(()=>{Me.dispose(),fe(ae)});K.then(fe,be).finally(()=>Me.dispose())})}e.raceCancellation=R;function C(K,Q){return new Promise((ae,fe)=>{const be=Q.onCancellationRequested(()=>{be.dispose(),fe(new t.CancellationError)});K.then(ae,fe).finally(()=>be.dispose())})}e.raceCancellationError=C;async function l(K){let Q=-1;const ae=K.map((be,Me)=>be.then(xe=>(Q=Me,xe))),fe=await Promise.race(ae);return K.forEach((be,Me)=>{Me!==Q&&be.cancel()}),fe}e.raceCancellablePromises=l;function w(K,Q,ae){let fe;const be=setTimeout(()=>{fe?.(void 0),ae?.()},Q);return Promise.race([K.finally(()=>clearTimeout(be)),new Promise(Me=>fe=Me)])}e.raceTimeout=w;function p(K){return new Promise((Q,ae)=>{const fe=K();_(fe)?fe.then(Q,ae):Q(fe)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ae=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ae,ae).then(fe)})}return new Promise((ae,fe)=>{this.queuedPromise.then(ae,fe)})}return this.activePromise=Q(),new Promise((ae,fe)=>{this.activePromise.then(be=>{this.activePromise=null,ae(be)},be=>{this.activePromise=null,fe(be)})})}}e.Throttler=g;class E{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=E;class F{constructor(){this.promiseMap=new Map}queue(Q,ae){const be=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(Q)===be&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,be),be}}e.SequencerByKey=F;const y=(K,Q)=>{let ae=!0;const fe=setTimeout(()=>{ae=!1,Q()},K);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(fe),ae=!1}}},u=K=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,K())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class r{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ae=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Me)=>{this.doResolve=be,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===e.MicrotaskDelay?u(fe):y(ae,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class f{constructor(Q){this.delayer=new r(Q),this.throttler=new g}trigger(Q,ae){return this.delayer.trigger(()=>this.throttler.queue(Q),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class o{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ae)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class S extends o{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function s(K,Q){return Q?new Promise((ae,fe)=>{const be=setTimeout(()=>{Me.dispose(),ae()},K),Me=Q.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),fe(new t.CancellationError)})}):P(ae=>s(K,ae))}e.timeout=s;function i(K,Q=0){const ae=setTimeout(K,Q);return(0,D.toDisposable)(()=>clearTimeout(ae))}e.disposableTimeout=i;function n(K){const Q=[];let ae=0;const fe=K.length;function be(){return ae<fe?K[ae++]():null}function Me(xe){xe!=null&&Q.push(xe);const Ge=be();return Ge?Ge.then(Me):Promise.resolve(Q)}return Promise.resolve(null).then(Me)}e.sequence=n;function c(K,Q=fe=>!!fe,ae=null){let fe=0;const be=K.length,Me=()=>{if(fe>=be)return Promise.resolve(ae);const xe=K[fe++];return Promise.resolve(xe()).then(Je=>Q(Je)?Promise.resolve(Je):Me())};return Me()}e.first=c;function a(K,Q=fe=>!!fe,ae=null){if(K.length===0)return Promise.resolve(ae);let fe=K.length;const be=()=>{fe=-1;for(const Me of K)Me.cancel?.()};return new Promise((Me,xe)=>{for(const Ge of K)Ge.then(Je=>{--fe>=0&&Q(Je)?(be(),Me(Je)):fe===0&&Me(ae)}).catch(Je=>{--fe>=0&&(be(),xe(Je))})})}e.firstParallel=a;class h{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ae,fe)=>{this.outstandingPromises.push({factory:Q,c:ae,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ae=Q.factory();ae.then(Q.c,Q.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class d extends h{constructor(){super(1)}}e.Queue=d;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new $;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,ae=T.extUri){const fe=ae.getComparisonKey(Q);let be=this.queues.get(fe);return be||(be=new d,I.Event.once(be.onFinished)(()=>{be?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,be)),be}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class b{constructor(Q,ae){this._token=-1,typeof Q=="function"&&typeof ae=="number"&&this.setIfNotSet(Q,ae)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ae){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ae)}setIfNotSet(Q,ae){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ae))}}e.TimeoutTimer=b;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ae){this.cancel(),this._token=setInterval(()=>{Q()},ae)}}e.IntervalTimer=A;class O{constructor(Q,ae){this.timeoutToken=-1,this.runner=Q,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class N{constructor(Q,ae){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class L extends O{constructor(Q,ae){super(Q,ae);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class M extends D.Disposable{constructor(Q,ae){super();this.options=Q,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,k.setTimeout0)(()=>{if(Q)return;const ae=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(K,Q)=>{const ae=requestIdleCallback(K,typeof Q=="number"?{timeout:Q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(ae))}}}}();class V{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function H(K,Q,ae){let fe;for(let be=0;be<ae;be++)try{return await K()}catch(Me){fe=Me,await s(Q)}throw fe}e.retry=H;class U{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,ae,fe){return this._pending={taskId:Q,cancel:()=>fe?.(),promise:ae},ae.then(()=>this.donePending(Q),()=>this.donePending(Q)),ae}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ae,fe;const be=new Promise((Me,xe)=>{ae=Me,fe=xe});this._next={run:Q,promise:be,promiseResolve:ae,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=U;class B{constructor(Q,ae=()=>Date.now()){this.interval=Q,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ae)=>{this.completeCallback=Q,this.errorCallback=ae})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(ae=>{this.completeCallback(Q),this.resolved=!0,ae()})}error(Q){return new Promise(ae=>{this.errorCallback(Q),this.rejected=!0,ae()})}cancel(){new Promise(Q=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=$;var z;(function(K){async function Q(fe){let be;const Me=await Promise.all(fe.map(xe=>xe.then(Ge=>Ge,Ge=>{be||(be=Ge)})));if(typeof be!="undefined")throw be;return Me}K.settled=Q;function ae(fe){return new Promise(async(be,Me)=>{try{await fe(be,Me)}catch(xe){Me(xe)}})}K.withAsyncBody=ae})(z=e.Promises||(e.Promises={}));var W;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(W||(W={}));class J{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const ae={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(Q(ae)),this.resolve()}catch(fe){this.reject(fe)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}static fromArray(Q){return new J(ae=>{ae.emitMany(Q)})}static fromPromise(Q){return new J(async ae=>{ae.emitMany(await Q)})}static fromPromises(Q){return new J(async ae=>{await Promise.all(Q.map(async fe=>ae.emitOne(await fe)))})}static merge(Q){return new J(async ae=>{await Promise.all(Q.map(async fe=>{for await(const be of fe)ae.emitOne(be)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ae){return new J(async fe=>{for await(const be of Q)fe.emitOne(ae(be))})}map(Q){return J.map(this,Q)}static filter(Q,ae){return new J(async fe=>{for await(const be of Q)ae(be)&&fe.emitOne(be)})}filter(Q){return J.filter(this,Q)}static coalesce(Q){return J.filter(Q,ae=>!!ae)}coalesce(){return J.coalesce(this)}static async toPromise(Q){const ae=[];for await(const fe of Q)ae.push(fe);return ae}toPromise(){return J.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ne extends J{constructor(Q,ae){super(ae);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function se(K){const Q=new m.CancellationTokenSource,ae=K(Q.token);return new ne(Q,async fe=>{const be=Q.token.onCancellationRequested(()=>{be.dispose(),Q.dispose(),fe.reject(new t.CancellationError)});try{for await(const Me of ae){if(Q.token.isCancellationRequested)return;fe.emitOne(Me)}be.dispose(),Q.dispose()}catch(Me){be.dispose(),Q.dispose(),fe.reject(Me)}})}e.createCancelableAsyncIterable=se}),define(pe[101],ve([0,1,13,9]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new m.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),D=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(d,v,b=!1){const A=d||"",O=v||"",N=I.value.collator.compare(A,O);return I.value.collatorIsNumeric&&N===0&&A!==O?A<O?-1:1:N}e.compareFileNames=k;function _(d,v){const b=D.value.collator;return d=d||"",v=v||"",f(b,d,v)}e.compareFileNamesDefault=_;function P(d,v){const b=D.value.collator;return d=d||"",v=v||"",i(d,v)||f(b,d,v)}e.compareFileNamesUpper=P;function R(d,v){const b=D.value.collator;return d=d||"",v=v||"",s(d,v)||f(b,d,v)}e.compareFileNamesLower=R;function C(d,v){return d=d||"",v=v||"",d===v?0:d<v?-1:1}e.compareFileNamesUnicode=C;function l(d,v,b=!1){b||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase());const[A,O]=u(d),[N,L]=u(v);return A!==N?A<N?-1:1:O===L?0:O<L?-1:1}e.noIntlCompareFileNames=l;function w(d,v){const[b,A]=u(d),[O,N]=u(v);let L=I.value.collator.compare(A,N);if(L===0){if(I.value.collatorIsNumeric&&A!==N)return A<N?-1:1;if(L=I.value.collator.compare(b,O),I.value.collatorIsNumeric&&L===0&&b!==O)return b<O?-1:1}return L}e.compareFileExtensions=w;function p(d,v){d=d||"",v=v||"";const b=r(d),A=r(v),O=D.value.collator,N=T.value.collator;return f(N,b,A)||f(O,d,v)}e.compareFileExtensionsDefault=p;function g(d,v){d=d||"",v=v||"";const b=r(d),A=r(v),O=D.value.collator,N=T.value.collator;return f(N,b,A)||i(d,v)||f(O,d,v)}e.compareFileExtensionsUpper=g;function E(d,v){d=d||"",v=v||"";const b=r(d),A=r(v),O=D.value.collator,N=T.value.collator;return f(N,b,A)||s(d,v)||f(O,d,v)}e.compareFileExtensionsLower=E;function F(d,v){d=d||"",v=v||"";const b=r(d).toLowerCase(),A=r(v).toLowerCase();return b!==A?b<A?-1:1:d!==v?d<v?-1:1:0}e.compareFileExtensionsUnicode=F;const y=/^(.*?)(\.([^.]*))?$/;function u(d,v=!1){const b=d?y.exec(d):[];let A=[b&&b[1]||"",b&&b[3]||""];return v&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function r(d){const v=d?y.exec(d):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function f(d,v,b){let A=d.compare(v,b);return A!==0?A:v.length!==b.length?v.length<b.length?-1:1:0}function o(d){const v=d.charAt(0);return v.toLocaleUpperCase()!==v}function S(d){const v=d.charAt(0);return v.toLocaleLowerCase()!==v}function s(d,v){return o(d)&&S(v)?-1:S(d)&&o(v)?1:0}function i(d,v){return S(d)&&o(v)?-1:o(d)&&S(v)?1:0}function n(d,v,b=!1){return b||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase()),d===v?0:d<v?-1:1}function c(d,v,b=!1){const A=d.split(t.sep),O=v.split(t.sep),N=A.length-1,L=O.length-1;let M,V;for(let H=0;;H++){if(M=N===H,V=L===H,M&&V)return k(A[H],O[H],b);if(M)return-1;if(V)return 1;const U=n(A[H],O[H],b);if(U!==0)return U}}e.comparePaths=c;function a(d,v,b){const A=d.toLowerCase(),O=v.toLowerCase(),N=h(d,v,b);if(N)return N;const L=A.endsWith(b),M=O.endsWith(b);if(L!==M)return L?-1:1;const V=k(A,O);return V!==0?V:A.localeCompare(O)}e.compareAnything=a;function h(d,v,b){const A=d.toLowerCase(),O=v.toLowerCase(),N=A.startsWith(b),L=O.startsWith(b);if(N!==L)return N?-1:1;if(N&&L){if(A.length<O.length)return-1;if(A.length>O.length)return 1}return 0}e.compareByPrefix=h}),define(pe[102],ve([0,1,101,98,58,9,12,8]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,P=[_,[]];function R(U,B,$,z){if(!U||!B)return P;const W=U.length,J=B.length;if(W<J)return P;const ne=U.toLowerCase();return C(B,$,J,U,ne,W,z)}e.scoreFuzzy=R;function C(U,B,$,z,W,J,ne){const se=[],K=[];for(let be=0;be<$;be++){const Me=be*J,xe=Me-J,Ge=be>0,Je=U[be],q=B[be];for(let te=0;te<J;te++){const G=te>0,X=Me+te,oe=X-1,me=xe+te-1,Ie=G?se[oe]:0,We=Ge&&G?se[me]:0,Ye=Ge&&G?K[me]:0;let it;!We&&Ge?it=0:it=l(Je,q,z,W,te,Ye),it&&We+it>=Ie&&(ne||Ge||W.startsWith(B,te))?(K[X]=Ye+1,se[X]=We+it):(K[X]=_,se[X]=Ie)}}const Q=[];let ae=$-1,fe=J-1;for(;ae>=0&&fe>=0;){const be=ae*J+fe;K[be]===_||(Q.push(fe),ae--),fe--}return[se[$*J-1],Q.reverse()]}function l(U,B,$,z,W,J){let ne=0;if(!w(B,z[W]))return ne;if(ne+=1,J>0&&(ne+=J*5),U===$[W]&&(ne+=1),W===0)ne+=8;else{const se=p($.charCodeAt(W-1));se?ne+=se:(0,t.isUpper)($.charCodeAt(W))&&J===0&&(ne+=2)}return ne}function w(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function p(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function E(U,B,$=0,z=0){const W=B;return W.values&&W.values.length>1?F(U,W.values,$,z):y(U,B,$,z)}e.scoreFuzzy2=E;function F(U,B,$,z){let W=0;const J=[];for(const ne of B){const[se,K]=y(U,ne,$,z);if(typeof se!="number")return g;W+=se,J.push(...K)}return[W,h(J)]}function y(U,B,$,z){const W=(0,t.fuzzyScore)(B.original,B.originalLowercase,$,U,U.toLowerCase(),z,!0);return W?[W[0],(0,t.createMatches)(W)]:g}const u=Object.freeze({score:0}),r=1<<18,f=1<<17,o=1<<16;function S(U,B,$,z){const W=z.values?z.values:[z];return(0,I.hash)({[z.normalized]:{values:W.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:B,allowNonContiguousMatches:$}})}function s(U,B,$,z,W){if(!U||!B.normalized)return u;const J=z.getItemLabel(U);if(!J)return u;const ne=z.getItemDescription(U),se=S(J,ne,$,B),K=W[se];if(K)return K;const Q=i(J,ne,z.getItemPath(U),B,$);return W[se]=Q,Q}e.scoreItemFuzzy=s;function i(U,B,$,z,W){const J=!$||!z.containsPathSeparator;return $&&(T.isLinux?z.pathNormalized===$:(0,k.equalsIgnoreCase)(z.pathNormalized,$))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:z.values&&z.values.length>1?n(U,B,$,z.values,J,W):c(U,B,$,z,J,W)}function n(U,B,$,z,W,J){let ne=0;const se=[],K=[];for(const Q of z){const{score:ae,labelMatch:fe,descriptionMatch:be}=c(U,B,$,Q,W,J);if(ae===_)return u;ne+=ae,fe&&se.push(...fe),be&&K.push(...be)}return{score:ne,labelMatch:h(se),descriptionMatch:h(K)}}function c(U,B,$,z,W,J){if(W||!B){const[ne,se]=R(U,z.normalized,z.normalizedLowercase,J&&!z.expectContiguousMatch);if(ne){const K=(0,t.matchesPrefix)(z.normalized,U);let Q;return K?(Q=f,Q+=Math.round(z.normalized.length/U.length*100)):Q=o,{score:Q+ne,labelMatch:K||a(se)}}}if(B){let ne=B;$&&(ne=`${B}${D.sep}`);const se=ne.length,K=`${ne}${U}`,[Q,ae]=R(K,z.normalized,z.normalizedLowercase,J&&!z.expectContiguousMatch);if(Q){const fe=a(ae),be=[],Me=[];return fe.forEach(xe=>{xe.start<se&&xe.end>se?(be.push({start:0,end:xe.end-se}),Me.push({start:xe.start,end:se})):xe.start>=se?be.push({start:xe.start-se,end:xe.end-se}):Me.push(xe)}),{score:Q,labelMatch:be,descriptionMatch:Me}}}return u}function a(U){const B=[];if(!U)return B;let $;for(const z of U)$&&$.end===z?$.end+=1:($={start:z,end:z+1},B.push($));return B}function h(U){const B=U.sort((W,J)=>W.start-J.start),$=[];let z;for(const W of B)!z||!d(z,W)?(z=W,$.push(W)):(z.start=Math.min(z.start,W.start),z.end=Math.max(z.end,W.end));return $}function d(U,B){return!(U.end<B.start||B.end<U.start)}function v(U,B,$,z,W,J){const ne=s(U,$,z,W,J),se=s(B,$,z,W,J),K=ne.score,Q=se.score;if((K===r||Q===r)&&K!==Q)return K===r?-1:1;if(K>o||Q>o){if(K!==Q)return K>Q?-1:1;if(K<f&&Q<f){const Je=A(ne.labelMatch,se.labelMatch);if(Je!==0)return Je}const xe=W.getItemLabel(U)||"",Ge=W.getItemLabel(B)||"";if(xe.length!==Ge.length)return xe.length-Ge.length}if(K!==Q)return K>Q?-1:1;const ae=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,fe=Array.isArray(se.labelMatch)&&se.labelMatch.length>0;if(ae&&!fe)return-1;if(fe&&!ae)return 1;const be=b(U,ne,W),Me=b(B,se,W);return be&&Me&&be!==Me?Me>be?-1:1:O(U,B,$,W)}e.compareItemsByFuzzyScore=v;function b(U,B,$){let z=-1,W=-1;if(B.descriptionMatch&&B.descriptionMatch.length?z=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(z=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(W=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const J=$.getItemDescription(U);J&&(W+=J.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(W=B.descriptionMatch[B.descriptionMatch.length-1].end);return W-z}function A(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const $=U[0].start,W=U[U.length-1].end-$,J=B[0].start,se=B[B.length-1].end-J;return W===se?0:se<W?1:-1}function O(U,B,$,z){const W=z.getItemLabel(U)||"",J=z.getItemLabel(B)||"",ne=z.getItemDescription(U),se=z.getItemDescription(B),K=W.length+(ne?ne.length:0),Q=J.length+(se?se.length:0);if(K!==Q)return K-Q;const ae=z.getItemPath(U),fe=z.getItemPath(B);return ae&&fe&&ae.length!==fe.length?ae.length-fe.length:W!==J?(0,m.compareAnything)(W,J,$.normalized):ne&&se&&ne!==se?(0,m.compareAnything)(ne,se,$.normalized):ae&&fe&&ae!==fe?(0,m.compareAnything)(ae,fe,$.normalized):0}function N(U){return U.startsWith('"')&&U.endsWith('"')}const L=" ";function M(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:$,normalized:z,normalizedLowercase:W}=V(U),J=$.indexOf(D.sep)>=0,ne=N(U);let se;const K=U.split(L);if(K.length>1)for(const Q of K){const ae=N(Q),{pathNormalized:fe,normalized:be,normalizedLowercase:Me}=V(Q);be&&(se||(se=[]),se.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:fe,normalized:be,normalizedLowercase:Me,expectContiguousMatch:ae}))}return{original:U,originalLowercase:B,pathNormalized:$,normalized:z,normalizedLowercase:W,values:se,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=M;function V(U){let B;T.isWindows?B=U.replace(/\//g,D.sep):B=U.replace(/\\/g,D.sep);const $=(0,k.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:$,normalizedLowercase:$.toLowerCase()}}function H(U){return Array.isArray(U)?M(U.map(B=>B.original).join(L)):M(U.original)}e.pieceToQuery=H}),define(pe[32],ve([0,1,13,29,24,9,8]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const _="[/\\\\]",P="[^/\\\\]",R=/\//g;function C(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${_}|${P}+${_}|${_}${P}+)*?`}}function l(B,$){if(!B)return[];const z=[];let W=!1,J=!1,ne="";for(const se of B){switch(se){case $:if(!W&&!J){z.push(ne),ne="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":J=!0;break;case"]":J=!1;break}ne+=se}return ne&&z.push(ne),z}e.splitGlobAware=l;function w(B){if(!B)return"";let $="";const z=l(B,e.GLOB_SPLIT);if(z.every(W=>W===e.GLOBSTAR))$=".*";else{let W=!1;z.forEach((J,ne)=>{if(J===e.GLOBSTAR){W||($+=C(2),W=!0);return}let se=!1,K="",Q=!1,ae="";for(const fe of J){if(fe!=="}"&&se){K+=fe;continue}if(Q&&(fe!=="]"||!ae)){let be;fe==="-"?be=fe:(fe==="^"||fe==="!")&&!ae?be="^":fe===e.GLOB_SPLIT?be="":be=T.escapeRegExpCharacters(fe),ae+=be;continue}switch(fe){case"{":se=!0;continue;case"[":Q=!0;continue;case"}":{$+=`(?:${l(K,",").map(xe=>w(xe)).join("|")})`,se=!1,K="";break}case"]":$+="["+ae+"]",Q=!1,ae="";break;case"?":$+=P;continue;case"*":$+=C(1);continue;default:$+=T.escapeRegExpCharacters(fe)}}ne<z.length-1&&(z[ne+1]!==e.GLOBSTAR||ne+2<z.length)&&($+=_),W=!1})}return $}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,F=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new I.LRUCache(1e4),f=function(){return!1},o=function(){return null};function S(B,$){if(!B)return o;let z;typeof B!="string"?z=B.pattern:z=B,z=z.trim();const W=`${z}_${!!$.trimForExclusions}`;let J=r.get(W);if(J)return s(J,B);let ne;if(p.test(z)){const se=z.substr(4);J=function(K,Q){return typeof K=="string"&&K.endsWith(se)?z:null}}else(ne=g.exec(i(z,$)))?J=n(ne[1],z):($.trimForExclusions?F:E).test(z)?J=c(z,$):(ne=y.exec(i(z,$)))?J=a(ne[1].substr(1),z,!0):(ne=u.exec(i(z,$)))?J=a(ne[1],z,!1):J=h(z);return r.set(W,J),s(J,B)}function s(B,$){return typeof $=="string"?B:function(z,W){return t.isEqualOrParent(z,$.base)?B(D.relative($.base,z),W):null}}function i(B,$){return $.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function n(B,$){const z=`/${B}`,W=`\\${B}`,J=function(se,K){return typeof se!="string"?null:K?K===B?$:null:se===B||se.endsWith(z)||se.endsWith(W)?$:null},ne=[B];return J.basenames=ne,J.patterns=[$],J.allBasenames=ne,J}function c(B,$){const z=U(B.slice(1,-1).split(",").map(K=>S(K,$)).filter(K=>K!==o),B),W=z.length;if(!W)return o;if(W===1)return z[0];const J=function(K,Q){for(let ae=0,fe=z.length;ae<fe;ae++)if(z[ae](K,Q))return B;return null},ne=z.find(K=>!!K.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=z.reduce((K,Q)=>Q.allPaths?K.concat(Q.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function a(B,$,z){const W=D.sep===D.posix.sep,J=W?B:B.replace(R,D.sep),ne=D.sep+J,se=D.posix.sep+B,K=z?function(Q,ae){return typeof Q=="string"&&(Q===J||Q.endsWith(ne)||!W&&(Q===B||Q.endsWith(se)))?$:null}:function(Q,ae){return typeof Q=="string"&&(Q===J||!W&&Q===B)?$:null};return K.allPaths=[(z?"*/":"./")+B],K}function h(B){try{const $=new RegExp(`^${w(B)}$`);return function(z){return $.lastIndex=0,typeof z=="string"&&$.test(z)?B:null}}catch{return o}}function d(B,$,z){return!B||typeof $!="string"?!1:v(B)($,void 0,z)}e.match=d;function v(B,$={}){if(!B)return f;if(typeof B=="string"||N(B)){const z=S(B,$);if(z===o)return f;const W=function(J,ne){return!!z(J,ne)};return z.allBasenames&&(W.allBasenames=z.allBasenames),z.allPaths&&(W.allPaths=z.allPaths),W}return V(B,$)}e.parse=v;function b(B){if(!B)return;let $;return z=>($||($=(B()||Promise.resolve([])).then(W=>W?O(W):{})),$.then(W=>!!W[z]))}e.hasSiblingPromiseFn=b;function A(B){if(!B)return;let $;return z=>{if(!$){const W=B();$=W?O(W):{}}return!!$[z]}}e.hasSiblingFn=A;function O(B){const $={};for(const z of B)$[z]=!0;return $}function N(B){const $=B;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=N;function L(B){return B.allBasenames||[]}e.getBasenameTerms=L;function M(B){return B.allPaths||[]}e.getPathTerms=M;function V(B,$){const z=U(Object.getOwnPropertyNames(B).map(K=>H(K,B[K],$)).filter(K=>K!==o)),W=z.length;if(!W)return o;if(!z.some(K=>!!K.requiresSiblings)){if(W===1)return z[0];const K=function(fe,be){for(let Me=0,xe=z.length;Me<xe;Me++){const Ge=z[Me](fe,be);if(Ge)return Ge}return null},Q=z.find(fe=>!!fe.allBasenames);Q&&(K.allBasenames=Q.allBasenames);const ae=z.reduce((fe,be)=>be.allPaths?fe.concat(be.allPaths):fe,[]);return ae.length&&(K.allPaths=ae),K}const J=function(K,Q,ae){let fe;for(let be=0,Me=z.length;be<Me;be++){const xe=z[be];xe.requiresSiblings&&ae&&(Q||(Q=D.basename(K)),fe||(fe=Q.substr(0,Q.length-D.extname(K).length)));const Ge=xe(K,Q,fe,ae);if(Ge)return Ge}return null},ne=z.find(K=>!!K.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=z.reduce((K,Q)=>Q.allPaths?K.concat(Q.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function H(B,$,z){if($===!1)return o;const W=S(B,z);if(W===o)return o;if(typeof $=="boolean")return W;if($){const J=$.when;if(typeof J=="string"){const ne=(se,K,Q,ae)=>{if(!ae||!W(se,K))return null;const fe=J.replace("$(basename)",Q),be=ae(fe);return(0,m.isThenable)(be)?be.then(Me=>Me?B:null):be?B:null};return ne.requiresSiblings=!0,ne}}return W}function U(B,$){const z=B.filter(K=>!!K.basenames);if(z.length<2)return B;const W=z.reduce((K,Q)=>{const ae=Q.basenames;return ae?K.concat(ae):K},[]);let J;if($){J=[];for(let K=0,Q=W.length;K<Q;K++)J.push($)}else J=z.reduce((K,Q)=>{const ae=Q.patterns;return ae?K.concat(ae):K},[]);const ne=function(K,Q){if(typeof K!="string")return null;if(!Q){let fe;for(fe=K.length;fe>0;fe--){const be=K.charCodeAt(fe-1);if(be===47||be===92)break}Q=K.substr(fe)}const ae=W.indexOf(Q);return ae!==-1?J[ae]:null};ne.basenames=W,ne.patterns=J,ne.allBasenames=W;const se=B.filter(K=>!K.basenames);return se.push(ne),se}}),define(pe[80],ve([0,1,29,10,9,12,23,8,2]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,n,c){if(typeof i=="string"&&(i=_.URI.file(i)),c){const h=c.getWorkspaceFolder(i);if(h){const d=c.getWorkspace().folders.length>1;let v;if((0,T.isEqual)(h.uri,i)?v="":v=(0,T.relativePath)(h.uri,i),d){const b=h.name?h.name:(0,T.basename)(h.uri);v=v?b+" \u2022 "+v:b}return v}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let a=(0,I.normalize)(i.fsPath);return!D.isWindows&&n?.userHome&&(a=w(a,n.userHome.fsPath)),a}e.getPathLabel=P;function R(i){if(!i)return;typeof i=="string"&&(i=_.URI.file(i));const n=(0,T.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,m.isRootOrDriveLetter)(n)?C(n):n}e.getBaseLabel=R;function C(i,n){return(0,m.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function w(i,n){if(D.isWindows||!i||!n)return i;let c=l.original===n?l.normalized:void 0;return c||(c=`${(0,k.rtrim)(n,I.posix.sep)}${I.posix.sep}`,l={original:n,normalized:c}),(D.isLinux?i.startsWith(c):(0,k.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=w;function p(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=p;const g="\u2026",E="\\\\",F="~";function y(i,n=I.sep){const c=new Array(i.length);let a=!1;for(let h=0;h<i.length;h++){let d=i[h];if(d===""){c[h]=`.${n}`;continue}if(!d){c[h]=d;continue}a=!0;let v="";d.indexOf(E)===0?(v=d.substr(0,d.indexOf(E)+E.length),d=d.substr(d.indexOf(E)+E.length)):d.indexOf(n)===0?(v=d.substr(0,d.indexOf(n)+n.length),d=d.substr(d.indexOf(n)+n.length)):d.indexOf(F)===0&&(v=d.substr(0,d.indexOf(F)+F.length),d=d.substr(d.indexOf(F)+F.length));const b=d.split(n);for(let A=1;a&&A<=b.length;A++)for(let O=b.length-A;a&&O>=0;O--){a=!1;let N=b.slice(O,O+A).join(n);for(let L=0;!a&&L<i.length;L++)if(L!==h&&i[L]&&i[L].indexOf(N)>-1){const M=O+A===b.length,V=O>0&&i[L].indexOf(n)>-1?n+N:N,H=i[L].endsWith(V);a=!M||H}if(!a){let L="";(b[0].endsWith(":")||v!=="")&&(O===1&&(O=0,A++,N=b[0]+n+N),O>0&&(L=b[0]+n),L=v+L),O>0&&(L=L+g+n),L=L+N,O+A<b.length&&(L=L+n+g),c[h]=L}}a&&(c[h]=d)}return c}e.shorten=y;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function r(i,n=Object.create(null)){const c=[];let a=!1,h="";for(const d of i)if(d==="$"||a&&d==="{")h&&c.push({value:h,type:u.TEXT}),h="",a=!0;else if(d==="}"&&a){const v=n[h];if(typeof v=="string")v.length&&c.push({value:v,type:u.VARIABLE});else if(v){const b=c[c.length-1];(!b||b.type!==u.SEPARATOR)&&c.push({value:v.label,type:u.SEPARATOR})}h="",a=!1}else h+=d;return h&&!a&&c.push({value:h,type:u.TEXT}),c.filter((d,v)=>{if(d.type===u.SEPARATOR){const b=c[v-1],A=c[v+1];return[b,A].every(O=>O&&(O.type===u.VARIABLE||O.type===u.TEXT)&&O.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=r;function f(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function o(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function s(i){const n=i.indexOf("/")!==-1?I.posix:I.win32,c=n.basename(i),a=n.dirname(i);return c.length?{name:c,parentPath:a}:{name:a,parentPath:""}}e.splitName=s}),define(pe[103],ve([0,1,2]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class I{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:t(m.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:t(m.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:m.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function D(R,C,l){if(!R||l>200)return null;if(typeof R=="object"){if(R instanceof m.URI)return C.transformOutgoing(R);for(let w in R)if(Object.hasOwnProperty.call(R,w)){const p=D(R[w],C,l+1);p!==null&&(R[w]=p)}}return null}function T(R,C){const l=D(R,C,0);return l===null?R:l}e.transformOutgoingURIs=T;function k(R,C,l,w){if(!R||w>200)return null;if(typeof R=="object"){if(R.$mid===1)return l?m.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let p in R)if(Object.hasOwnProperty.call(R,p)){const g=k(R[p],C,l,w+1);g!==null&&(R[p]=g)}}return null}function _(R,C){const l=k(R,C,!1,0);return l===null?R:l}e.transformIncomingURIs=_;function P(R,C){const l=k(R,C,!0,0);return l===null?R:l}e.transformAndReviveIncomingURIs=P}),define(pe[33],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(_){return m.test(_)}e.isUUID=t;const I=new Uint8Array(16),D=[];for(let _=0;_<256;_++)D.push(_.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(_){for(let P=0;P<_.length;P++)_[P]=Math.floor(Math.random()*256);return _};function k(){T(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let _=0,P="";return P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P+="-",P+=D[I[_++]],P+=D[I[_++]],P+="-",P+=D[I[_++]],P+=D[I[_++]],P+="-",P+=D[I[_++]],P+=D[I[_++]],P+="-",P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P+=D[I[_++]],P}e.generateUuid=k}),define(pe[143],ve([0,1,104]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(D="utf8"){this.stringDecoder=new m.StringDecoder(D),this.remaining=null}write(D){const T=[],k=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(k.length<1)return T;let _=0,P,R=_;for(;R<k.length;)if(P=k.charCodeAt(R),P===13||P===10){if(T.push(k.substring(_,R)),R++,R<k.length){const C=P;P=k.charCodeAt(R),(C===13&&P===10||C===10&&P===13)&&R++}_=R}else R++;return this.remaining=_<k.length?k.substr(_):null,T}end(){return this.remaining}}e.LineDecoder=t}),define(pe[30],ve([0,1,60,81,291,13,29,79,9,12,23,2]),function(Z,e,m,t,I,D,T,k,_,P,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function w(M,V=l.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?g(M):p(M)}async function p(M){try{const V=(0,T.randomPath)((0,t.tmpdir)());try{await m.promises.rename(M,V)}catch{return g(M)}g(V).catch(H=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function E(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=E;async function F(M,V){return r(await(V?y(M):(0,I.promisify)(m.readdir)(M)))}async function y(M){try{return await(0,I.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const V=[],H=await F(M);for(const U of H){let B=!1,$=!1,z=!1;try{const W=await e.Promises.lstat((0,_.join)(M,U));B=W.isFile(),$=W.isDirectory(),z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:U,isFile:()=>B,isDirectory:()=>$,isSymbolicLink:()=>z})}return V}function u(M){return r(m.readdirSync(M))}e.readdirSync=u;function r(M){return M.map(V=>typeof V=="string"?P.isMacintosh?(0,k.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,k.normalizeNFC)(V.name):V.name,V))}async function f(M){const V=await F(M),H=[];for(const U of V)await S.existsDirectory((0,_.join)(M,U))&&H.push(U);return H}function o(M,V=1e3){return new Promise(H=>{let U=!1;const B=setInterval(()=>{U||(U=!0,m.access(M,$=>{U=!1,$&&(clearInterval(B),H(void 0))}))},V)})}e.whenDeleted=o;var S;(function(M){async function V(B){let $;try{if($=await e.Promises.lstat(B),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(P.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw W}throw z}}M.stat=V;async function H(B){try{const{stat:$,symbolicLink:z}=await M.stat(B);return $.isFile()&&z?.dangling!==!0}catch{}return!1}M.existsFile=H;async function U(B){try{const{stat:$,symbolicLink:z}=await M.stat(B);return $.isDirectory()&&z?.dangling!==!0}catch{}return!1}M.existsDirectory=U})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new D.ResourceQueue;function i(M,V,H){return s.queueFor(C.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const U=h(H);return new Promise((B,$)=>c(M,V,U,z=>z?$(z):B()))})}let n=!0;function c(M,V,H,U){if(!n)return m.writeFile(M,V,{mode:H.mode,flag:H.flag},U);m.open(M,H.flag,H.mode,(B,$)=>{if(B)return U(B);m.writeFile($,V,z=>{if(z)return m.close($,()=>U(z));m.fdatasync($,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),n=!1),m.close($,J=>U(J))))})})}function a(M,V,H){const U=h(H);if(!n)return m.writeFileSync(M,V,{mode:U.mode,flag:U.flag});const B=m.openSync(M,U.flag,U.mode);try{m.writeFileSync(B,V);try{m.fdatasyncSync(B)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),n=!1}}finally{m.closeSync(B)}}e.writeFileSync=a;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,V){if(M===V)return;async function H(U){try{const B=await e.Promises.lstat(U);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(U,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,V),await H(V)}catch(U){if(M.toLowerCase()!==V.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await v(M,V,{preserveSymlinks:!1}),await w(M,l.MOVE),await H(V);else throw U}}async function v(M,V,H){return A(M,V,{root:{source:M,target:V},options:H,handledSourcePaths:new Set})}const b=511;async function A(M,V,H){if(H.handledSourcePaths.has(M))return;H.handledSourcePaths.add(M);const{stat:U,symbolicLink:B}=await S.stat(M);if(B){if(H.options.preserveSymlinks)try{return await L(M,V,H)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(B.dangling)return}return U.isDirectory()?O(M,V,U.mode&b,H):N(M,V,U.mode&b)}async function O(M,V,H,U){await e.Promises.mkdir(V,{recursive:!0,mode:H});const B=await F(M);for(const $ of B)await A((0,_.join)(M,$),(0,_.join)(V,$),U)}async function N(M,V,H){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,H)}async function L(M,V,H){let U=await e.Promises.readlink(M);(0,T.isEqualOrParent)(U,H.root.source,!P.isLinux)&&(U=(0,_.join)(H.root.target,U.substr(H.root.source.length+1))),await e.Promises.symlink(U,V)}e.Promises=new class{get access(){return(0,I.promisify)(m.access)}get stat(){return(0,I.promisify)(m.stat)}get lstat(){return(0,I.promisify)(m.lstat)}get utimes(){return(0,I.promisify)(m.utimes)}get read(){return(M,V,H,U,B)=>new Promise(($,z)=>{m.read(M,V,H,U,B,(W,J,ne)=>W?z(W):$({bytesRead:J,buffer:ne}))})}get readFile(){return(0,I.promisify)(m.readFile)}get write(){return(M,V,H,U,B)=>new Promise(($,z)=>{m.write(M,V,H,U,B,(W,J,ne)=>W?z(W):$({bytesWritten:J,buffer:ne}))})}get appendFile(){return(0,I.promisify)(m.appendFile)}get fdatasync(){return(0,I.promisify)(m.fdatasync)}get truncate(){return(0,I.promisify)(m.truncate)}get rename(){return(0,I.promisify)(m.rename)}get copyFile(){return(0,I.promisify)(m.copyFile)}get open(){return(0,I.promisify)(m.open)}get close(){return(0,I.promisify)(m.close)}get symlink(){return(0,I.promisify)(m.symlink)}get readlink(){return(0,I.promisify)(m.readlink)}get chmod(){return(0,I.promisify)(m.chmod)}get mkdir(){return(0,I.promisify)(m.mkdir)}get unlink(){return(0,I.promisify)(m.unlink)}get rmdir(){return(0,I.promisify)(m.rmdir)}get realpath(){return(0,I.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return F}get readDirsInDir(){return f}get writeFile(){return i}get rm(){return w}get move(){return d}get copy(){return v}}}),define(pe[105],ve([0,1,60,9,12,8,30]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(l){if(I.isLinux)return l;const w=(0,t.dirname)(l);if(l===w)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(0,T.readdirSync)(w).filter(F=>F.toLowerCase()===p);if(E.length===1){const F=k(w);if(F)return(0,t.join)(F,E[0])}else if(E.length>1){const F=E.indexOf(p);if(F>=0){const y=k(w);if(y)return(0,t.join)(y,E[F])}}}catch{}return null}e.realcaseSync=k;async function _(l){if(I.isLinux)return l;const w=(0,t.dirname)(l);if(l===w)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(await T.Promises.readdir(w)).filter(F=>F.toLowerCase()===p);if(E.length===1){const F=await _(w);if(F)return(0,t.join)(F,E[0])}else if(E.length>1){const F=E.indexOf(p);if(F>=0){const y=await _(w);if(y)return(0,t.join)(y,E[F])}}}catch{}return null}e.realcase=_;async function P(l){try{return await T.Promises.realpath(l)}catch{const p=C(l);return await T.Promises.access(p,m.constants.R_OK),p}}e.realpath=P;function R(l){try{return m.realpathSync(l)}catch{const p=C(l);return m.accessSync(p,m.constants.R_OK),p}}e.realpathSync=R;function C(l){return(0,D.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(Z,e,m,t){var I=arguments.length,D=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,m):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Z,e,m,t);else for(var k=Z.length-1;k>=0;k--)(T=Z[k])&&(D=(I<3?T(D):I>3?T(e,m,D):T(e,m))||D);return I>3&&D&&Object.defineProperty(e,m,D),D};define(pe[106],ve([0,1,17,13,22,21,56,16,3,6,59,8,18]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function p($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var F;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(F||(F={}));class y{constructor(z){this.buffer=z,this.pos=0}read(z){const W=this.buffer.slice(this.pos,this.pos+z);return this.pos+=W.byteLength,W}}class u{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var r;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(r||(r={}));function f($){const z=I.VSBuffer.alloc(4);return z.writeUInt32BE($,0),z}function o($){return $.read(4).readUInt32BE(0)}function S($){const z=I.VSBuffer.alloc(1);return z.writeUInt8($,0),z}const s={Undefined:S(r.Undefined),String:S(r.String),Buffer:S(r.Buffer),VSBuffer:S(r.VSBuffer),Array:S(r.Array),Object:S(r.Object)},i=typeof Buffer!="undefined";function n($,z){if(typeof z=="undefined")$.write(s.Undefined);else if(typeof z=="string"){const W=I.VSBuffer.fromString(z);$.write(s.String),$.write(f(W.byteLength)),$.write(W)}else if(i&&Buffer.isBuffer(z)){const W=I.VSBuffer.wrap(z);$.write(s.Buffer),$.write(f(W.byteLength)),$.write(W)}else if(z instanceof I.VSBuffer)$.write(s.VSBuffer),$.write(f(z.byteLength)),$.write(z);else if(Array.isArray(z)){$.write(s.Array),$.write(f(z.length));for(const W of z)n($,W)}else{const W=I.VSBuffer.fromString(JSON.stringify(z));$.write(s.Object),$.write(f(W.byteLength)),$.write(W)}}function c($){switch($.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return $.read(o($)).toString();case r.Buffer:return $.read(o($)).buffer;case r.VSBuffer:return $.read(o($));case r.Array:{const W=o($),J=[];for(let ne=0;ne<W;ne++)J.push(c($));return J}case r.Object:return JSON.parse($.read(o($)).toString())}}class a{constructor(z,W,J=null,ne=1e3){this.protocol=z,this.ctx=W,this.logger=J,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(z,W){this.channels.set(z,W),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const W=this.send([z.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(z.type));return}case 201:case 202:case 204:case 203:{const W=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(W,z.id,1,E(z.type),z.data);return}}}send(z,W=void 0){const J=new u;return n(J,z),n(J,W),this.sendBuffer(J.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const W=new y(z),J=c(W),ne=c(W),se=J[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ne),this.onPromise({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ne),this.onEventListen({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]})}}onPromise(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const J=new D.CancellationTokenSource;let ne;try{ne=W.call(this.ctx,z.name,z.arg,J.token)}catch(Q){ne=Promise.reject(Q)}const se=z.id;ne.then(Q=>{this.sendResponse({id:se,data:Q,type:201}),this.activeRequests.delete(z.id)},Q=>{Q instanceof Error?this.sendResponse({id:se,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:se,data:Q,type:203}),this.activeRequests.delete(z.id)});const K=(0,P.toDisposable)(()=>J.cancel());this.activeRequests.set(z.id,K)}onEventListen(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const J=z.id,se=W.listen(this.ctx,z.name,z.arg)(K=>this.sendResponse({id:J,data:K,type:204}));this.activeRequests.set(z.id,se)}disposeActiveRequest(z){const W=this.activeRequests.get(z.id);W&&(W.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let W=this.pendingRequests.get(z.channelName);W||(W=[],this.pendingRequests.set(z.channelName,W));const J=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:z,timeoutTimer:J})}flushPendingRequests(z){const W=this.pendingRequests.get(z);if(W){for(const J of W)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(z,W=null){this.protocol=z,this.isDisposed=!1,this.state=F.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=W}getChannel(z){const W=this;return{call(J,ne,se){return W.isDisposed?Promise.reject(k.canceled()):W.requestPromise(z,J,ne,se)},listen(J,ne){return W.isDisposed?Promise.reject(k.canceled()):W.requestEvent(z,J,ne)}}}requestPromise(z,W,J,ne=D.CancellationToken.None){const se=this.lastRequestId++,Q={id:se,type:100,channelName:z,name:W,arg:J};if(ne.isCancellationRequested)return Promise.reject(k.canceled());let ae;return new Promise((be,Me)=>{if(ne.isCancellationRequested)return Me(k.canceled());const xe=()=>{const te=G=>{switch(G.type){case 201:this.handlers.delete(se),be(G.data);break;case 202:{this.handlers.delete(se);const X=new Error(G.data.message);X.stack=G.data.stack,X.name=G.data.name,Me(X);break}case 203:this.handlers.delete(se),Me(G.data);break}};this.handlers.set(se,te),this.sendRequest(Q)};let Ge=null;this.state===F.Idle?xe():(Ge=(0,t.createCancelablePromise)(te=>this.whenInitialized()),Ge.then(()=>{Ge=null,xe()}));const Je=()=>{Ge?(Ge.cancel(),Ge=null):this.sendRequest({id:se,type:101}),Me(k.canceled())},q=ne.onCancellationRequested(Je);ae=(0,P.combinedDisposable)((0,P.toDisposable)(Je),q),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(z,W,J){const ne=this.lastRequestId++,K={id:ne,type:102,channelName:z,name:W,arg:J};let Q=null;const ae=new _.Emitter({onFirstListenerAdd:()=>{Q=(0,t.createCancelablePromise)(be=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ae),this.sendRequest(K)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ae),this.sendRequest({id:ne,type:103}))}}),fe=be=>ae.fire(be.data);return this.handlers.set(ne,fe),ae.event}sendRequest(z){switch(z.type){case 100:case 102:{const W=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(W,z.id,0,`${p(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const W=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(W,z.id,0,p(z.type));return}}}send(z,W=void 0){const J=new u;return n(J,z),n(J,W),this.sendBuffer(J.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const W=new y(z),J=c(W),ne=c(W),se=J[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,E(se)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],0,E(se),ne),this.onResponse({type:J[0],id:J[1],data:ne})}}onResponse(z){if(z.type===200){this.state=F.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(z.id);W&&W(z)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===F.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}je([T.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class v{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:W,onDidClientDisconnect:J})=>{_.Event.once(W.onMessage)(se=>{const K=new y(se),Q=c(K),ae=new a(W,Q),fe=new d(W);this.channels.forEach((Me,xe)=>ae.registerChannel(xe,Me));const be={channelServer:ae,channelClient:fe,ctx:Q};this._connections.add(be),this._onDidAddConnection.fire(be),J(()=>{ae.dispose(),fe.dispose(),this._connections.delete(be),this._onDidRemoveConnection.fire(be)})})})}get connections(){const z=[];return this._connections.forEach(W=>z.push(W)),z}getChannel(z,W){const J=this;return{call(ne,se,K){let Q;if((0,l.isFunction)(W)){let fe=(0,m.getRandomElement)(J.connections.filter(W));Q=fe?Promise.resolve(fe):_.Event.toPromise(_.Event.filter(J.onDidAddConnection,W))}else Q=W.routeCall(J,ne,se);const ae=Q.then(fe=>fe.channelClient.getChannel(z));return A(ae).call(ne,se,K)},listen(ne,se){if((0,l.isFunction)(W))return J.getMulticastEvent(z,W,ne,se);const K=W.routeEvent(J,ne,se).then(Q=>Q.channelClient.getChannel(z));return A(K).listen(ne,se)}}}getMulticastEvent(z,W,J,ne){const se=this;let K=new P.DisposableStore;const Q=new _.Emitter({onFirstListenerAdd:()=>{K=new P.DisposableStore;const ae=new _.EventMultiplexer,fe=new Map,be=xe=>{const Je=xe.channelClient.getChannel(z).listen(J,ne),q=ae.add(Je);fe.set(xe,q)},Me=xe=>{const Ge=fe.get(xe);!Ge||(Ge.dispose(),fe.delete(xe))};se.connections.filter(W).forEach(be),_.Event.filter(se.onDidAddConnection,W)(be,void 0,K),se.onDidRemoveConnection(Me,void 0,K),ae.event(Q.fire,Q,K),K.add(ae)},onLastListenerRemove:()=>{K.dispose()}});return Q.event}registerChannel(z,W){this.channels.set(z,W),this._connections.forEach(J=>{J.channelServer.registerChannel(z,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class b{constructor(z,W,J=null){const ne=new u;n(ne,W),z.send(ne.buffer),this.channelClient=new d(z,J),this.channelServer=new a(z,W,J)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,W){this.channelServer.registerChannel(z,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=b;function A($){return{call(z,W,J){return $.then(ne=>ne.call(z,W,J))},listen(z,W){const J=new _.Relay;return $.then(ne=>J.input=ne.listen(z,W)),J.event}}}e.getDelayedChannel=A;function O($){let z=!1;return{call(W,J,ne){return z?$.call(W,J,ne):(0,t.timeout)(0).then(()=>z=!0).then(()=>$.call(W,J,ne))},listen(W,J){if(z)return $.listen(W,J);const ne=new _.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>ne.input=$.listen(W,J)),ne.event}}}e.getNextTickChannel=O;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const W of z.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await _.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;var L;(function($){function z(se,K){const Q=se,ae=K&&K.disableMarshalling,fe=new Map;for(const be in Q)J(be)&&fe.set(be,_.Event.buffer(Q[be],!0));return new class{listen(be,Me,xe){const Ge=fe.get(Me);if(Ge)return Ge;if(ne(Me)){const Je=Q[Me];if(typeof Je=="function")return Je.call(Q,xe)}throw new Error(`Event not found: ${Me}`)}call(be,Me,xe){const Ge=Q[Me];if(typeof Ge=="function"){if(!ae&&Array.isArray(xe))for(let Je=0;Je<xe.length;Je++)xe[Je]=(0,R.revive)(xe[Je]);return Ge.apply(Q,xe)}throw new Error(`Method not found: ${Me}`)}}}$.fromService=z;function W(se,K){const Q=K&&K.disableMarshalling;return new Proxy({},{get(ae,fe){if(typeof fe=="string")return K?.properties?.has(fe)?K.properties.get(fe):ne(fe)?function(be){return se.listen(fe,be)}:J(fe)?se.listen(fe):async function(...be){let Me;K&&!(0,l.isUndefinedOrNull)(K.context)?Me=[K.context,...be]:Me=be;const xe=await se.call(fe,Me);return Q?xe:(0,R.revive)(xe)};throw new Error(`Property not found: ${String(fe)}`)}})}$.toService=W;function J(se){return se[0]==="o"&&se[1]==="n"&&C.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&C.isUpperAsciiLetter(se.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let z=$.toString();if(z!=="[object Object]")return z}return $}function H($){return Array.isArray($)?$.map(V):V($)}function U($,z,W,J,ne,se,K){K=H(K);const Q=M[ne],ae=Q[J%Q.length];let fe=[`%c[${$}]%c[${String(z).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(se)?(fe=fe.concat(K),fe.push(")")):fe.push(K),console.log.apply(console,fe)}e.logWithColors=U;class B{constructor(z,W){this._outgoingPrefix=z,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,W,J,ne,se){this._totalOutgoing+=z,U(this._outgoingPrefix,this._totalOutgoing,z,W,J,ne,se)}logIncoming(z,W,J,ne,se){this._totalIncoming+=z,U(this._incomingPrefix,this._totalIncoming,z,W,J,ne,se)}}e.IPCLogger=B}),define(pe[107],ve([0,1,22,3,6,106]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function a(d,v){if(!n.has(d)){const b=String(++c);n.set(d,b)}return n.get(d)}function h(d,v,b,A){if(!i.enableDiagnostics)return;const O=a(d,v);if(A instanceof m.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const N=m.VSBuffer.alloc(A.byteLength);N.set(A),i.records.push({timestamp:Date.now(),id:O,label:v,type:b,buff:N})}else i.records.push({timestamp:Date.now(),id:O,label:v,type:b,data:A})}i.traceSocketEvent=h})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function R(){return P||(P=m.VSBuffer.alloc(0)),P}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,c){if(n===0)return R();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const v=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=n),v}if(this._chunks[0].byteLength>n){const v=this._chunks[0].slice(0,n);return c&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),v}let a=m.VSBuffer.alloc(n),h=0,d=0;for(;n>0;){const v=this._chunks[d];if(v.byteLength>n){const b=v.slice(0,n);a.set(b,h),h+=n,c&&(this._chunks[d]=v.slice(n),this._totalLength-=n),n-=n}else a.set(v,h),h+=v.byteLength,c?(this._chunks.shift(),this._totalLength-=v.byteLength):d++,n-=v.byteLength}return a}}e.ChunkStream=C;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function w(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(n,c,a,h){this.type=n,this.id=c,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends I.Disposable{constructor(n){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new g(a,h,d,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class F{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=m.VSBuffer.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(c,n.data)}_bufferAdd(n,c){const a=this._totalLength===0;return this._data.push(n,c),this._totalLength+=n.byteLength+c.byteLength,a}_bufferTake(){const n=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,c){this._bufferAdd(n,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class y extends I.Disposable{constructor(n){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new F(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(1,0,0,n))}}e.Protocol=y;class u extends D.IPCClient{constructor(n,c,a=null){super(n,c,a);this.protocol=n}static fromSocket(n,c){return new u(new y(n),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=u;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class f{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],c=0,a=this._first;for(;a;)n[c++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const c=new f(n);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let c=0;c<S._HISTORY_LENGTH;c++)this.lastRuns[c]=n-1e3*c;setInterval(()=>{for(let c=S._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),c=(1+S._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<S._HISTORY_LENGTH;h++)n-this.lastRuns[h]<=c&&a++;return 1-a/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class s{constructor(n,c=null,a=S.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),c&&this._socketReader.acceptChunk(c)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(5,0,0,R());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new g(7,0,0,R());this._socketWriter.write(n)}sendResume(){const n=new g(8,0,0,R());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,c){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n);const c=this._outgoingUnackMsg.toArray();for(let a=0,h=c.length;a<h;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new g(6,0,0,R())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,h=c.length;a<h;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new g(1,c,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const c=new g(2,0,0,n);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),c=Date.now()-n.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const d=Math.max(2e4-c,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},d)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(pe[108],ve([0,1,100]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const _=(0,m.toUint8)(k);this._defaultValue=_,this._asciiMap=t._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){const _=new Uint8Array(256);for(let P=0;P<256;P++)_[P]=k;return _}set(k,_){const P=(0,m.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(I||(I={}));class D{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=D}),define(pe[144],ve([0,1,108]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends m.CharacterClassifier{constructor(k){super(0);for(let _=0,P=k.length;_<P;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function D(T){const k={};return _=>(k.hasOwnProperty(_)||(k[_]=T(_)),k[_])}e.getMapForWordSeparators=D(T=>new I(T))}),define(pe[48],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(I,D){this.lineNumber=I,this.column=D}with(I=this.lineNumber,D=this.column){return I===this.lineNumber&&D===this.column?this:new m(I,D)}delta(I=0,D=0){return this.with(this.lineNumber+I,this.column+D)}equals(I){return m.equals(this,I)}static equals(I,D){return!I&&!D?!0:!!I&&!!D&&I.lineNumber===D.lineNumber&&I.column===D.column}isBefore(I){return m.isBefore(this,I)}static isBefore(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<D.column}isBeforeOrEqual(I){return m.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<=D.column}static compare(I,D){const T=I.lineNumber|0,k=D.lineNumber|0;if(T===k){const _=I.column|0,P=D.column|0;return _-P}return T-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new m(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=m}),define(pe[41],ve([0,1,48]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(D,T,k,_){D>k||D===k&&T>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=D,this.endColumn=T):(this.startLineNumber=D,this.startColumn=T,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return t.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return t.containsPosition(this,D)}static containsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<D.startColumn||T.lineNumber===D.endLineNumber&&T.column>D.endColumn)}static strictContainsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<=D.startColumn||T.lineNumber===D.endLineNumber&&T.column>=D.endColumn)}containsRange(D){return t.containsRange(this,D)}static containsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>D.endColumn)}strictContainsRange(D){return t.strictContainsRange(this,D)}static strictContainsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<=D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>=D.endColumn)}plusRange(D){return t.plusRange(this,D)}static plusRange(D,T){let k,_,P,R;return T.startLineNumber<D.startLineNumber?(k=T.startLineNumber,_=T.startColumn):T.startLineNumber===D.startLineNumber?(k=T.startLineNumber,_=Math.min(T.startColumn,D.startColumn)):(k=D.startLineNumber,_=D.startColumn),T.endLineNumber>D.endLineNumber?(P=T.endLineNumber,R=T.endColumn):T.endLineNumber===D.endLineNumber?(P=T.endLineNumber,R=Math.max(T.endColumn,D.endColumn)):(P=D.endLineNumber,R=D.endColumn),new t(k,_,P,R)}intersectRanges(D){return t.intersectRanges(this,D)}static intersectRanges(D,T){let k=D.startLineNumber,_=D.startColumn,P=D.endLineNumber,R=D.endColumn,C=T.startLineNumber,l=T.startColumn,w=T.endLineNumber,p=T.endColumn;return k<C?(k=C,_=l):k===C&&(_=Math.max(_,l)),P>w?(P=w,R=p):P===w&&(R=Math.min(R,p)),k>P||k===P&&_>R?null:new t(k,_,P,R)}equalsRange(D){return t.equalsRange(this,D)}static equalsRange(D,T){return!!D&&!!T&&D.startLineNumber===T.startLineNumber&&D.startColumn===T.startColumn&&D.endLineNumber===T.endLineNumber&&D.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(D){return new m.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(D){return new m.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,T){return new t(this.startLineNumber,this.startColumn,D,T)}setStartPosition(D,T){return new t(D,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(D){return new t(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,T=D){return new t(D.lineNumber,D.column,T.lineNumber,T.column)}static lift(D){return D?new t(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<D.startColumn)}static areIntersecting(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<=T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,T){if(D&&T){const P=D.startLineNumber|0,R=T.startLineNumber|0;if(P===R){const C=D.startColumn|0,l=T.startColumn|0;if(C===l){const w=D.endLineNumber|0,p=T.endLineNumber|0;if(w===p){const g=D.endColumn|0,E=T.endColumn|0;return g-E}return w-p}return C-l}return P-R}return(D?1:0)-(T?1:0)}static compareRangesUsingEnds(D,T){return D.endLineNumber===T.endLineNumber?D.endColumn===T.endColumn?D.startLineNumber===T.startLineNumber?D.startColumn-T.startColumn:D.startLineNumber-T.startLineNumber:D.endColumn-T.endColumn:D.endLineNumber-T.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=t}),define(pe[145],ve([0,1,48,41]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class D extends t.Range{constructor(k,_,P,R){super(k,_,P,R);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=P,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return D.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new D(this.startLineNumber,this.startColumn,k,_):new D(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new D(k,_,this.endLineNumber,this.endColumn):new D(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new D(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new D(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new D(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new D(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let P=0,R=k.length;P<R;P++)if(!this.selectionsEqual(k[P],_[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,P,R,C){return C===0?new D(k,_,P,R):new D(P,R,k,_)}}e.Selection=D}),define(pe[146],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let _=0,P=k.notIn.length;_<P;_++)switch(k.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,_){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(_-2),R=k.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(k,_){for(let P=k;P<=_;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)D(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),D(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),D(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),D(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&D(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=I;function D(T,k,_){T.has(k)?T.get(k).push(_):T.set(k,[_])}}),define(pe[82],ve([0,1,32,9]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(D,T,k,_){if(Array.isArray(D)){let P=0;for(const R of D){const C=I(R,T,k,_);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof D=="string")return _?D==="*"?5:D===k?10:0:0;if(D){const{language:P,pattern:R,scheme:C,hasAccessToAllModels:l}=D;if(!_&&!l)return 0;let w=0;if(C)if(C===T.scheme)w=10;else if(C==="*")w=5;else return 0;if(P)if(P===k)w=10;else if(P==="*")w=Math.max(w,5);else return 0;if(R){let p;if(typeof R=="string"?p=R:p={...R,base:(0,t.normalize)(R.base)},p===T.fsPath||(0,m.match)(p,T.fsPath))w=10;else return 0}return w}else return 0}}e.score=I}),define(pe[147],ve([0,1,108]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(p,g,E){const F=new Uint8Array(p*g);for(let y=0,u=p*g;y<u;y++)F[y]=E;this._data=F,this.rows=p,this.cols=g}get(p,g){return this._data[p*this.cols+g]}set(p,g,E){this._data[p*this.cols+g]=E}}e.Uint8Matrix=I;class D{constructor(p){let g=0,E=0;for(let y=0,u=p.length;y<u;y++){const[r,f,o]=p[y];f>g&&(g=f),r>E&&(E=r),o>E&&(E=o)}g++,E++;const F=new I(E,g,0);for(let y=0,u=p.length;y<u;y++){const[r,f,o]=p[y];F.set(r,f,o)}this._states=F,this._maxCharCode=g}nextState(p,g){return g<0||g>=this._maxCharCode?0:this._states.get(p,g)}}e.StateMachine=D;let T=null;function k(){return T===null&&(T=new D([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var _;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let P=null;function R(){if(P===null){P=new m.CharacterClassifier(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<w.length;g++)P.set(w.charCodeAt(g),1);const p=".,;";for(let g=0;g<p.length;g++)P.set(p.charCodeAt(g),2)}return P}class C{static _createLink(p,g,E,F,y){let u=y-1;do{const r=g.charCodeAt(u);if(p.get(r)!==2)break;u--}while(u>F);if(F>0){const r=g.charCodeAt(F-1),f=g.charCodeAt(u);(r===40&&f===41||r===91&&f===93||r===123&&f===125)&&u--}return{range:{startLineNumber:E,startColumn:F+1,endLineNumber:E,endColumn:u+2},url:g.substring(F,u+1)}}static computeLinks(p,g=k()){const E=R(),F=[];for(let y=1,u=p.getLineCount();y<=u;y++){const r=p.getLineContent(y),f=r.length;let o=0,S=0,s=0,i=1,n=!1,c=!1,a=!1,h=!1;for(;o<f;){let d=!1;const v=r.charCodeAt(o);if(i===13){let b;switch(v){case 40:n=!0,b=0;break;case 41:b=n?0:1;break;case 91:a=!0,c=!0,b=0;break;case 93:a=!1,b=c?0:1;break;case 123:h=!0,b=0;break;case 125:b=h?0:1;break;case 39:b=s===34||s===96?0:1;break;case 34:b=s===39||s===96?0:1;break;case 96:b=s===39||s===34?0:1;break;case 42:b=s===42?1:0;break;case 124:b=s===124?1:0;break;case 32:b=a?0:1;break;default:b=E.get(v)}b===1&&(F.push(C._createLink(E,r,y,S,o)),d=!0)}else if(i===12){let b;v===91?(c=!0,b=0):b=E.get(v),b===1?d=!0:i=13}else i=g.nextState(i,v),i===0&&(d=!0);d&&(i=1,n=!1,c=!1,h=!1,S=o+1,s=v),o++}i===13&&F.push(C._createLink(E,r,y,S,f))}return F}}e.LinkComputer=C;function l(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:C.computeLinks(w)}e.computeLinks=l}),define(pe[148],ve([0,1,3,6]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,_){return this._map.set(k,_),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===_&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,_){this._factories.get(k)?.dispose();const P=new D(this,k,_);return this._factories.set(k,P),(0,t.toDisposable)(()=>{const R=this._factories.get(k);!R||R!==P||(this._factories.delete(k),R.dispose())})}async getOrCreate(k){const _=this.get(k);if(_)return _;const P=this._factories.get(k);return!P||P.isResolved?null:(await P.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const P=this._factories.get(k);return!!(!P||P.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class D extends t.Disposable{constructor(k,_,P){super();this._registry=k,this._languageId=_,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(pe[109],ve([0,1,25]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(D=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var T;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(F){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,F.tabSize|0),this.indentSize=F.tabSize|0,this.insertSpaces=Boolean(F.insertSpaces),this.defaultEOL=F.defaultEOL|0,this.trimAutoWhitespace=Boolean(F.trimAutoWhitespace),this.bracketPairColorizationOptions=F.bracketPairColorizationOptions}equals(F){return this.tabSize===F.tabSize&&this.indentSize===F.indentSize&&this.insertSpaces===F.insertSpaces&&this.defaultEOL===F.defaultEOL&&this.trimAutoWhitespace===F.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,F.bracketPairColorizationOptions)}createChangeEvent(F){return{tabSize:this.tabSize!==F.tabSize,indentSize:this.indentSize!==F.indentSize,insertSpaces:this.insertSpaces!==F.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==F.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class R{constructor(F,y){this._findMatchBrand=void 0,this.range=F,this.matches=y}}e.FindMatch=R;var C;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class p{constructor(F,y,u,r,f,o){this.identifier=F,this.range=y,this.text=u,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=f,this._isTracked=o}}e.ValidAnnotatedEditOperation=p;class g{constructor(F,y,u){this.reverseEdits=F,this.changes=y,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=g}),define(pe[149],ve([0,1,8,144,48,41,109]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(u,r,f,o){this.searchString=u,this.isRegex=r,this.matchCase=f,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!r)return null;let f=!this.isRegex&&!u;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new R(r,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=_;function P(y){if(!y||y.length===0)return!1;for(let u=0,r=y.length;u<r;u++)if(y.charCodeAt(u)===92){if(u++,u>=r)break;const o=y.charCodeAt(u);if(o===110||o===114||o===87)return!0}return!1}e.isMultilineRegexSource=P;class R{constructor(u,r,f){this.regex=u,this.wordSeparators=r,this.simpleSearch=f}}e.SearchData=R;function C(y,u,r){if(!r)return new T.FindMatch(y,null);const f=[];for(let o=0,S=u.length;o<S;o++)f[o]=u[o];return new T.FindMatch(y,f)}e.createFindMatch=C;class l{constructor(u){const r=[];let f=0;for(let o=0,S=u.length;o<S;o++)u.charCodeAt(o)===10&&(r[f++]=o);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(u){const r=this._lineFeedsOffsets;let f=0,o=r.length-1;if(o===-1||u<=r[0])return 0;for(;f<o;){const S=f+((o-f)/2>>0);r[S]>=u?o=S-1:r[S+1]>=u?(f=S,o=S):f=S+1}return f+1}}class w{static findMatches(u,r,f,o,S){const s=r.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,f,new F(s.wordSeparators,s.regex),o,S):this._doFindMatchesLineByLine(u,f,s,o,S):[]}static _getMultilineMatchRange(u,r,f,o,S,s){let i,n=0;o?(n=o.findLineFeedCountBeforeOffset(S),i=r+S+n):i=r+S;let c;if(o){const v=o.findLineFeedCountBeforeOffset(S+s.length)-n;c=i+s.length+v}else c=i+s.length;const a=u.getPositionAt(i),h=u.getPositionAt(c);return new D.Range(a.lineNumber,a.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(u,r,f,o,S){const s=u.getOffsetAt(r.getStartPosition()),i=u.getValueInRange(r,1),n=u.getEOL()===`\r
`?new l(i):null,c=[];let a=0,h;for(f.reset(0);h=f.next(i);)if(c[a++]=C(this._getMultilineMatchRange(u,s,i,n,h.index,h[0]),h,o),a>=S)return c;return c}static _doFindMatchesLineByLine(u,r,f,o,S){const s=[];let i=0;if(r.startLineNumber===r.endLineNumber){const c=u.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return i=this._findMatchesInLine(f,c,r.startLineNumber,r.startColumn-1,i,s,o,S),s}const n=u.getLineContent(r.startLineNumber).substring(r.startColumn-1);i=this._findMatchesInLine(f,n,r.startLineNumber,r.startColumn-1,i,s,o,S);for(let c=r.startLineNumber+1;c<r.endLineNumber&&i<S;c++)i=this._findMatchesInLine(f,u.getLineContent(c),c,0,i,s,o,S);if(i<S){const c=u.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);i=this._findMatchesInLine(f,c,r.endLineNumber,0,i,s,o,S)}return s}static _findMatchesInLine(u,r,f,o,S,s,i,n){const c=u.wordSeparators;if(!i&&u.simpleSearch){const d=u.simpleSearch,v=d.length,b=r.length;let A=-v;for(;(A=r.indexOf(d,A+v))!==-1;)if((!c||E(c,r,b,A,v))&&(s[S++]=new T.FindMatch(new D.Range(f,A+1+o,f,A+1+v+o),null),S>=n))return S;return S}const a=new F(u.wordSeparators,u.regex);let h;a.reset(0);do if(h=a.next(r),h&&(s[S++]=C(new D.Range(f,h.index+1+o,f,h.index+1+h[0].length+o),h,i),S>=n))return S;while(h);return S}static findNextMatch(u,r,f,o){const S=r.parseSearchRequest();if(!S)return null;const s=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(u,f,s,o):this._doFindNextMatchLineByLine(u,f,s,o)}static _doFindNextMatchMultiline(u,r,f,o){const S=new I.Position(r.lineNumber,1),s=u.getOffsetAt(S),i=u.getLineCount(),n=u.getValueInRange(new D.Range(S.lineNumber,S.column,i,u.getLineMaxColumn(i)),1),c=u.getEOL()===`\r
`?new l(n):null;f.reset(r.column-1);let a=f.next(n);return a?C(this._getMultilineMatchRange(u,s,n,c,a.index,a[0]),a,o):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(u,new I.Position(1,1),f,o):null}static _doFindNextMatchLineByLine(u,r,f,o){const S=u.getLineCount(),s=r.lineNumber,i=u.getLineContent(s),n=this._findFirstMatchInLine(f,i,s,r.column,o);if(n)return n;for(let c=1;c<=S;c++){const a=(s+c-1)%S,h=u.getLineContent(a+1),d=this._findFirstMatchInLine(f,h,a+1,1,o);if(d)return d}return null}static _findFirstMatchInLine(u,r,f,o,S){u.reset(o-1);const s=u.next(r);return s?C(new D.Range(f,s.index+1,f,s.index+1+s[0].length),s,S):null}static findPreviousMatch(u,r,f,o){const S=r.parseSearchRequest();if(!S)return null;const s=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(u,f,s,o):this._doFindPreviousMatchLineByLine(u,f,s,o)}static _doFindPreviousMatchMultiline(u,r,f,o){const S=this._doFindMatchesMultiline(u,new D.Range(1,1,r.lineNumber,r.column),f,o,10*k);if(S.length>0)return S[S.length-1];const s=u.getLineCount();return r.lineNumber!==s||r.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new I.Position(s,u.getLineMaxColumn(s)),f,o):null}static _doFindPreviousMatchLineByLine(u,r,f,o){const S=u.getLineCount(),s=r.lineNumber,i=u.getLineContent(s).substring(0,r.column-1),n=this._findLastMatchInLine(f,i,s,o);if(n)return n;for(let c=1;c<=S;c++){const a=(S+s-c-1)%S,h=u.getLineContent(a+1),d=this._findLastMatchInLine(f,h,a+1,o);if(d)return d}return null}static _findLastMatchInLine(u,r,f,o){let S=null,s;for(u.reset(0);s=u.next(r);)S=C(new D.Range(f,s.index+1,f,s.index+1+s[0].length),s,o);return S}}e.TextModelSearch=w;function p(y,u,r,f,o){if(f===0)return!0;const S=u.charCodeAt(f-1);if(y.get(S)!==0||S===13||S===10)return!0;if(o>0){const s=u.charCodeAt(f);if(y.get(s)!==0)return!0}return!1}function g(y,u,r,f,o){if(f+o===r)return!0;const S=u.charCodeAt(f+o);if(y.get(S)!==0||S===13||S===10)return!0;if(o>0){const s=u.charCodeAt(f+o-1);if(y.get(s)!==0)return!0}return!1}function E(y,u,r,f,o){return p(y,u,r,f,o)&&g(y,u,r,f,o)}e.isValidMatch=E;class F{constructor(u,r){this._wordSeparators=u,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const r=u.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(f=this._searchRegex.exec(u),!f))return null;const o=f.index,S=f[0].length;if(o===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){m.getNextCodePoint(u,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=S,!this._wordSeparators||E(this._wordSeparators,u,r,o,S))return f}while(f);return null}}e.Searcher=F}),define(pe[110],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(_+="\\"+P);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function t(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),_=new RegExp(k.source,P)}return _.lastIndex=0,_}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function D(k,_,P,R,C=I){if(P.length>C.maxLen){let E=k-C.maxLen/2;return E<0?E=0:R+=E,P=P.substring(E,k+C.maxLen/2),D(k,_,P,R,C)}const l=Date.now(),w=k-1-R;let p=-1,g=null;for(let E=1;!(Date.now()-l>=C.timeBudget);E++){const F=w-C.windowSize*E;_.lastIndex=Math.max(0,F);const y=T(_,P,w,p);if(!y&&g||(g=y,F<=0))break;p=F}if(g){const E={word:g[0],startColumn:R+1+g.index,endColumn:R+1+g.index+g[0].length};return _.lastIndex=0,E}return null}e.getWordAtText=D;function T(k,_,P,R){let C;for(;C=k.exec(_);){const l=C.index||0;if(l<=P&&k.lastIndex>=P)return C;if(R>0&&l>R)return null}return null}}),define(pe[111],ve([0,1,22,12]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(I||(I={}));function D(C){for(let l=0,w=C.length;l<w;l+=4){const p=C[l+0],g=C[l+1],E=C[l+2],F=C[l+3];C[l+0]=F,C[l+1]=E,C[l+2]=g,C[l+3]=p}}function T(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||D(l),m.VSBuffer.wrap(l)}function k(C){const l=C.buffer;if(t.isLittleEndian()||D(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function _(C){const l=new Uint32Array(P(C));let w=0;if(l[w++]=C.id,C.type==="full")l[w++]=1,l[w++]=C.data.length,l.set(C.data,w),w+=C.data.length;else{l[w++]=2,l[w++]=C.deltas.length;for(const p of C.deltas)l[w++]=p.start,l[w++]=p.deleteCount,p.data?(l[w++]=p.data.length,l.set(p.data,w),w+=p.data.length):l[w++]=0}return T(l)}e.encodeSemanticTokensDto=_;function P(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const w of C.deltas)w.data&&(l+=w.data.length)}return l}function R(C){const l=k(C);let w=0;const p=l[w++];if(l[w++]===1){const y=l[w++],u=l.subarray(w,w+y);return w+=y,{id:p,type:"full",data:u}}const E=l[w++],F=[];for(let y=0;y<E;y++){const u=l[w++],r=l[w++],f=l[w++];let o;f>0&&(o=l.subarray(w,w+f),w+=f),F[y]={start:u,deleteCount:r,data:o}}return{id:p,type:"delta",deltas:F}}e.decodeSemanticTokensDto=R}),define(pe[112],ve([0,1,17,100]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,P){_=(0,t.toUint32)(_);const R=this.values,C=this.prefixSum,l=P.length;return l===0?!1:(this.values=new Uint32Array(R.length+l),this.values.set(R.subarray(0,_),0),this.values.set(R.subarray(_),_+l),this.values.set(P,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,P){return _=(0,t.toUint32)(_),P=(0,t.toUint32)(P),this.values[_]===P?!1:(this.values[_]=P,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,P){_=(0,t.toUint32)(_),P=(0,t.toUint32)(P);const R=this.values,C=this.prefixSum;if(_>=R.length)return!1;const l=R.length-_;return P>=l&&(P=l),P===0?!1:(this.values=new Uint32Array(R.length-P),this.values.set(R.subarray(0,_),0),this.values.set(R.subarray(_+P),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,t.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),_>=this.values.length&&(_=this.values.length-1);for(let R=P;R<=_;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let P=0,R=this.values.length-1,C=0,l=0,w=0;for(;P<=R;)if(C=P+(R-P)/2|0,l=this.prefixSum[C],w=l-this.values[C],_<w)R=C-1;else if(_>=l)P=C+1;else break;return new T(C,_-w)}}e.PrefixSumComputer=I;class D{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const P=this._indexBySum[_],R=P>0?this._prefixSum[P-1]:0;return new T(P,_-R)}removeValues(_,P){this._values.splice(_,P),this._invalidate(_)}insertValues(_,P){this._values=(0,m.arrayInsert)(this._values,_,P),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,P=this._values.length;_<P;_++){const R=this._values[_],C=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=C+R;for(let l=0;l<R;l++)this._indexBySum[C+l]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,P){this._values[_]!==P&&(this._values[_]=P,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=D;class T{constructor(_,P){this.index=_,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=P}}e.PrefixSumIndexOfResult=T}),define(pe[150],ve([0,1,8,48,112]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class D{constructor(k,_,P,R){this._uri=k,this._lines=_,this._eol=P,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const P of _)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,P=new Uint32Array(_);for(let R=0;R<_;R++)P[R]=this._lines[R].length+k;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;const P=(0,m.splitLines)(_);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);const R=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),R[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}e.MirrorTextModel=D}),define(pe[151],ve([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(pe[152],ve([0,1,151]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,D=I*24,T=D*7,k=D*30,_=D*365;function P(C,l,w){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,m.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,m.localize)(1,null);let g;return p<t?(g=p,l?g===1?w?(0,m.localize)(2,null,g):(0,m.localize)(3,null,g):w?(0,m.localize)(4,null,g):(0,m.localize)(5,null,g):g===1?w?(0,m.localize)(6,null,g):(0,m.localize)(7,null,g):w?(0,m.localize)(8,null,g):(0,m.localize)(9,null,g)):p<I?(g=Math.floor(p/t),l?g===1?w?(0,m.localize)(10,null,g):(0,m.localize)(11,null,g):w?(0,m.localize)(12,null,g):(0,m.localize)(13,null,g):g===1?w?(0,m.localize)(14,null,g):(0,m.localize)(15,null,g):w?(0,m.localize)(16,null,g):(0,m.localize)(17,null,g)):p<D?(g=Math.floor(p/I),l?g===1?w?(0,m.localize)(18,null,g):(0,m.localize)(19,null,g):w?(0,m.localize)(20,null,g):(0,m.localize)(21,null,g):g===1?w?(0,m.localize)(22,null,g):(0,m.localize)(23,null,g):w?(0,m.localize)(24,null,g):(0,m.localize)(25,null,g)):p<T?(g=Math.floor(p/D),l?g===1?(0,m.localize)(26,null,g):(0,m.localize)(27,null,g):g===1?(0,m.localize)(28,null,g):(0,m.localize)(29,null,g)):p<k?(g=Math.floor(p/T),l?g===1?w?(0,m.localize)(30,null,g):(0,m.localize)(31,null,g):w?(0,m.localize)(32,null,g):(0,m.localize)(33,null,g):g===1?w?(0,m.localize)(34,null,g):(0,m.localize)(35,null,g):w?(0,m.localize)(36,null,g):(0,m.localize)(37,null,g)):p<_?(g=Math.floor(p/k),l?g===1?w?(0,m.localize)(38,null,g):(0,m.localize)(39,null,g):w?(0,m.localize)(40,null,g):(0,m.localize)(41,null,g):g===1?w?(0,m.localize)(42,null,g):(0,m.localize)(43,null,g):w?(0,m.localize)(44,null,g):(0,m.localize)(45,null,g)):(g=Math.floor(p/_),l?g===1?w?(0,m.localize)(46,null,g):(0,m.localize)(47,null,g):w?(0,m.localize)(48,null,g):(0,m.localize)(49,null,g):g===1?w?(0,m.localize)(50,null,g):(0,m.localize)(51,null,g):w?(0,m.localize)(52,null,g):(0,m.localize)(53,null,g))}e.fromNow=P;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[153],ve([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([0,1,17,18,153]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(P,R){return R&&(P.stack||P.stacktrace)?I.localize(0,null,k(P),T(P.stack)||T(P.stacktrace)):k(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function _(P=null,R=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const C=m.coalesce(P),l=_(C[0],R);return C.length>1?I.localize(4,null,l,C.length):l}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return D(C.error,R);if(C.exception)return D(C.exception,R)}return P.stack?D(P,R):P.message?P.message:I.localize(5,null)}e.toErrorMessage=_}),define(pe[154],ve([19,20]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(pe[113],ve([0,1,37,29,10,25,9,12,40,96,18,143,30,154]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,S){if(k.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};S&&(s.cwd=S);const i=m.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(n=>{i.once("error",c=>{n({success:!1,error:c})}),i.once("exit",(c,a)=>{n(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?p(s.status):1})}else if(k.isLinux||k.isMacintosh)try{const s=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{m.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,c,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function E(o){!o||(delete o.DEBUG,k.isMacintosh&&delete o.DYLD_LIBRARY_PATH,k.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function F(o=_.env){return o.comspec||"cmd.exe"}e.getWindowsShell=F;class y{constructor(S,s,i,n){if(s!==void 0&&i!==void 0&&n!==void 0)this.cmd=S,this.args=s,this.shell=i,this.options=n;else{const c=S;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(_.env).forEach(a=>{c[a]=_.env[a]}),Object.keys(this.options.env).forEach(a=>{c[a]=this.options.env[a]}),this.options.env=c}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const s=S.lastIndexOf(T.sep);return s!==-1&&(S=S.substring(s+1)),y.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(_.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(s=>{let i,n;const c=new Promise((a,h)=>{i=a,n=h});if(s){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=m.exec(a,this.options,(h,d,v)=>{this.childProcess=null;const b=h;b&&b.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:v.toString()}):this.handleExec(i,S,h,d,v)})}else{let a=null;const h=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,i,S,n);const v={terminated:this.terminateRequested};R.isNumber(d)&&(v.cmdCode=d),i(v)};if(this.shell&&k.isWindows){const d=D.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let v=!1,b=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),v=O.quoted,this.args&&this.args.forEach(L=>{O=this.ensureQuotes(L),A.push(O.value),b=b&&O.quoted});const N=["/s","/c"];v?b?N.push('"'+A.join(" ")+'"'):A.length>1?N.push('"'+A[0]+'" '+A.slice(1).join(" ")):N.push('"'+A[0]+'"'):N.push(A.join(" ")),a=m.spawn(F(),N,d)}else this.cmd&&(a=m.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(R.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,i,S,n,!0)))}return c})}handleClose(S,s,i,n){}ensureQuotes(S){return y.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,g(S,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const s=m.spawn(F(),["/s","/c"]);s.on("error",i=>S(!0)),s.on("exit",i=>S(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class u extends y{constructor(S,s,i,n){super(S,s,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,s,i,n,c){[n,c].forEach((a,h)=>{const d=new C.LineDecoder;d.write(a).forEach(A=>{s({line:A,source:h===0?0:1})});const b=d.end();b&&s({line:b,source:h===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,s,i,n,c){const a=new C.LineDecoder,h=new C.LineDecoder;S.stdout.on("data",d=>{a.write(d).forEach(b=>i({line:b,source:0}))}),S.stderr.on("data",d=>{h.write(d).forEach(b=>i({line:b,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(S,s,i,n){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=u;function r(o){let S=[],s=!1;const i=function(n){if(s){S.push(n);return}(!o.send(n,a=>{if(a&&console.error(a),s=!1,S.length>0){const h=S.slice(0);S=[],h.forEach(d=>i(d))}})||k.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=r;var f;(function(o){async function S(s,i,n){if(T.isAbsolute(s))return s;if(i===void 0&&(i=_.cwd()),T.dirname(s)!=="."||(n===void 0&&R.isString(_.env.PATH)&&(n=_.env.PATH.split(T.delimiter)),n===void 0||n.length===0))return T.join(i,s);async function a(h){if(await l.Promises.exists(h)){let d;try{d=await l.Promises.stat(h)}catch(v){v.message.startsWith("EACCES")&&(d=await l.Promises.lstat(h))}return d?!d.isDirectory():!1}return!1}for(let h of n){let d;if(T.isAbsolute(h)?d=T.join(h,s):d=T.join(i,h,s),await a(d))return d;let v=d+".com";if(await a(v)||(v=d+".exe",await a(v)))return v}return T.join(i,s)}o.findExecutable=S})(f=e.win32||(e.win32={}))}),define(pe[155],ve([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(pe[114],ve([0,1,155,12,110,17,25]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=_;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class R{constructor(ie,Se,re,ye){this.id=ie,this.name=Se,this.defaultValue=re,this.schema=ye}applyUpdate(ie,Se){return l(ie,Se)}compute(ie,Se,re){return re}}class C{constructor(ie,Se){this.newValue=ie,this.didChange=Se}}e.ApplyUpdateResult=C;function l(ee,ie){if(typeof ee!="object"||typeof ie!="object"||!ee||!ie)return new C(ie,ee!==ie);if(Array.isArray(ee)||Array.isArray(ie)){const re=Array.isArray(ee)&&Array.isArray(ie)&&D.equals(ee,ie);return new C(ie,re)}let Se=!1;for(const re in ie)if(ie.hasOwnProperty(re)){const ye=l(ee[re],ie[re]);ye.didChange&&(ee[re]=ye.newValue,Se=!0)}return new C(ee,Se)}class w{constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,Se){return l(ie,Se)}validate(ie){return this.defaultValue}}class p{constructor(ie,Se,re,ye){this.id=ie,this.name=Se,this.defaultValue=re,this.schema=ye}applyUpdate(ie,Se){return l(ie,Se)}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Se,re){return re}}function g(ee,ie){return typeof ee=="undefined"?ie:ee==="false"?!1:Boolean(ee)}e.boolean=g;class E extends p{constructor(ie,Se,re,ye=void 0){typeof ye!="undefined"&&(ye.type="boolean",ye.default=re);super(ie,Se,re,ye)}validate(ie){return g(ie,this.defaultValue)}}function F(ee,ie,Se,re){if(typeof ee=="undefined")return ie;let ye=parseInt(ee,10);return isNaN(ye)?ie:(ye=Math.max(Se,ye),ye=Math.min(re,ye),ye|0)}e.clampedInt=F;class y extends p{constructor(ie,Se,re,ye,Fe,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=re,qe.minimum=ye,qe.maximum=Fe);super(ie,Se,re,qe);this.minimum=ye,this.maximum=Fe}static clampedInt(ie,Se,re,ye){return F(ie,Se,re,ye)}validate(ie){return y.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends p{constructor(ie,Se,re,ye,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=re);super(ie,Se,re,Fe);this.validationFn=ye}static clamp(ie,Se,re){return ie<Se?Se:ie>re?re:ie}static float(ie,Se){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Se;const re=parseFloat(ie);return isNaN(re)?Se:re}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class r extends p{static string(ie,Se){return typeof ie!="string"?Se:ie}constructor(ie,Se,re,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.default=re);super(ie,Se,re,ye)}validate(ie){return r.string(ie,this.defaultValue)}}function f(ee,ie,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?ie:ee}e.stringSet=f;class o extends p{constructor(ie,Se,re,ye,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=ye,Fe.default=re);super(ie,Se,re,Fe);this._allowedValues=ye}validate(ie){return f(ie,this.defaultValue,this._allowedValues)}}class S extends R{constructor(ie,Se,re,ye,Fe,qe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=Fe,Ve.default=ye);super(ie,Se,re,Ve);this._allowedValues=Fe,this._convert=qe}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function s(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Se,re){return re===0?ie.accessibilitySupport:re}}class n extends R{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function v(ee){switch(ee){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class b extends w{constructor(){super(128)}compute(ie,Se,re){const ye=["monaco-editor"];return Se.get(33)&&ye.push(Se.get(33)),ie.extraEditorClassName&&ye.push(ie.extraEditorClassName),Se.get(66)==="default"?ye.push("mouse-default"):Se.get(66)==="copy"&&ye.push("mouse-copy"),Se.get(100)&&ye.push("showUnused"),Se.get(126)&&ye.push("showDeprecated"),ye.join(" ")}}class A extends E{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ie,Se,re){return re&&ie.emptySelectionClipboard}}class O extends R{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:m.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:m.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":f(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":f(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class N extends R{constructor(){super(45,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?N.OFF:ie==="true"?N.ON:ie:Boolean(ie)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class L extends w{constructor(){super(44)}compute(ie,Se,re){return ie.fontInfo}}class M extends p{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ie){const Se=u.float(ie,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(Se,6,100)}compute(ie,Se,re){return ie.fontInfo.fontSize}}class V extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(y.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class H extends R{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:re,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:re,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:re,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:re,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:re,description:m.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{multiple:f(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??f(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??f(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??f(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??f(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??f(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends R{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,minimum:0,maximum:1e4,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:m.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:y.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),above:g(Se.above,this.defaultValue.above)}}}var B;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class $ extends w{constructor(){super(131)}compute(ie,Se,re){return $.computeLayout(Se,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Se=ie.height/ie.lineHeight,re=ie.scrollBeyondLastLine?Se-1:0,ye=(ie.viewLineCount+re)/(ie.pixelRatio*ie.height),Fe=Math.floor(ie.viewLineCount/ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:re,desiredRatio:ye,minimapLineCount:Fe}}static _computeMinimapLayout(ie,Se){const re=ie.outerWidth,ye=ie.outerHeight,Fe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const qe=Se.stableMinimapLayoutInput,Ve=qe&&ie.outerHeight===qe.outerHeight&&ie.lineHeight===qe.lineHeight&&ie.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&ie.pixelRatio===qe.pixelRatio&&ie.scrollBeyondLastLine===qe.scrollBeyondLastLine&&ie.minimap.enabled===qe.minimap.enabled&&ie.minimap.side===qe.minimap.side&&ie.minimap.size===qe.minimap.size&&ie.minimap.showSlider===qe.minimap.showSlider&&ie.minimap.renderCharacters===qe.minimap.renderCharacters&&ie.minimap.maxColumn===qe.minimap.maxColumn&&ie.minimap.scale===qe.minimap.scale&&ie.verticalScrollbarWidth===qe.verticalScrollbarWidth&&ie.isViewportWrapping===qe.isViewportWrapping,ut=ie.lineHeight,Re=ie.typicalHalfwidthCharacterWidth,Ae=ie.scrollBeyondLastLine,De=ie.minimap.renderCharacters;let ce=Fe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const de=ie.minimap.maxColumn,we=ie.minimap.size,Ce=ie.minimap.side,Oe=ie.verticalScrollbarWidth,Ke=ie.viewLineCount,$e=ie.remainingWidth,Ze=ie.isViewportWrapping,lt=De?2:3;let ct=Math.floor(Fe*ye);const He=ct/Fe;let Ee=!1,_e=!1,he=lt*ce,Y=ce/Fe,ke=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:wt,desiredRatio:bt,minimapLineCount:Ut}=$.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Ae,height:ye,lineHeight:ut,pixelRatio:Fe});if(Ke/Ut>1)Ee=!0,_e=!0,ce=1,he=1,Y=ce/Fe;else{let Ft=!1,kt=ce+1;if(we==="fit"){const Ct=Math.ceil((Ke+wt)*he);Ze&&Ve&&$e<=Se.stableFitRemainingWidth?(Ft=!0,kt=Se.stableFitMaxMinimapScale):Ft=Ct>ct}if(we==="fill"||Ft){Ee=!0;const Ct=ce;he=Math.min(ut*Fe,Math.max(1,Math.floor(1/bt))),Ze&&Ve&&$e<=Se.stableFitRemainingWidth&&(kt=Se.stableFitMaxMinimapScale),ce=Math.min(kt,Math.max(1,Math.floor(he/lt))),ce>Ct&&(ke=Math.min(2,ce/Ct)),Y=ce/Fe/ke,ct=Math.ceil(Math.max(ft,Ke+wt)*he),Ze?(Se.stableMinimapLayoutInput=ie,Se.stableFitRemainingWidth=$e,Se.stableFitMaxMinimapScale=ce):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ne=Math.floor(de*Y),Xe=Math.min(Ne,Math.max(0,Math.floor(($e-Oe-2)*Y/(Re+Y)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(Fe*Xe);const pt=Qe/Fe;Qe=Math.floor(Qe*ke);const St=De?1:2,yt=Ce==="left"?0:re-Xe-Oe;return{renderMinimap:St,minimapLeft:yt,minimapWidth:Xe,minimapHeightIsEditorHeight:Ee,minimapIsSampling:_e,minimapScale:ce,minimapLineHeight:he,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ct,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:He}}static computeLayout(ie,Se){const re=Se.outerWidth|0,ye=Se.outerHeight|0,Fe=Se.lineHeight|0,qe=Se.lineNumbersDigitCount|0,Ve=Se.typicalHalfwidthCharacterWidth,ut=Se.maxDigitWidth,Re=Se.pixelRatio,Ae=Se.viewLineCount,De=ie.get(123),ce=De==="inherit"?ie.get(122):De,de=ce==="inherit"?ie.get(118):ce,we=ie.get(121),Ce=ie.get(2),Oe=Se.isDominatedByLongLines,Ke=ie.get(50),$e=ie.get(60).renderType!==0,Ze=ie.get(61),lt=ie.get(94),ct=ie.get(65),He=ie.get(92),Ee=He.verticalScrollbarSize,_e=He.verticalHasArrows,he=He.arrowSize,Y=He.horizontalScrollbarSize,ke=ie.get(58),Ne=ie.get(37);let Xe;if(typeof ke=="string"&&/^\d+(\.\d+)?ch$/.test(ke)){const Et=parseFloat(ke.substr(0,ke.length-2));Xe=y.clampedInt(Et*Ve,0,0,1e3)}else Xe=y.clampedInt(ke,0,0,1e3);Ne&&(Xe+=16);let Qe=0;if($e){const Et=Math.max(qe,Ze);Qe=Math.round(Et*ut)}let pt=0;Ke&&(pt=Fe);let St=0,yt=St+pt,ft=yt+Qe,wt=ft+Xe;const bt=re-pt-Qe-Xe;let Ut=!1,Pt=!1,Ft=-1;Ce!==2&&(ce==="inherit"&&Oe?(Ut=!0,Pt=!0):de==="on"||de==="bounded"?Pt=!0:de==="wordWrapColumn"&&(Ft=we));const kt=$._computeMinimapLayout({outerWidth:re,outerHeight:ye,lineHeight:Fe,typicalHalfwidthCharacterWidth:Ve,pixelRatio:Re,scrollBeyondLastLine:lt,minimap:ct,verticalScrollbarWidth:Ee,viewLineCount:Ae,remainingWidth:bt,isViewportWrapping:Pt},Se.memory||new P);kt.renderMinimap!==0&&kt.minimapLeft===0&&(St+=kt.minimapWidth,yt+=kt.minimapWidth,ft+=kt.minimapWidth,wt+=kt.minimapWidth);const Ct=bt-kt.minimapWidth,Qt=Math.max(1,Math.floor((Ct-Ee-2)/Ve)),Vt=_e?he:0;return Pt&&(Ft=Math.max(1,Qt),de==="bounded"&&(Ft=Math.min(Ft,we))),{width:re,height:ye,glyphMarginLeft:St,glyphMarginWidth:pt,lineNumbersLeft:yt,lineNumbersWidth:Qe,decorationsLeft:ft,decorationsWidth:Xe,contentLeft:wt,contentWidth:Ct,minimap:kt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:Pt,wrappingColumn:Ft,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:Y,overviewRuler:{top:Vt,width:Ee,height:ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=$;class z extends R{constructor(){const ie={enabled:!0};super(57,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:m.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:g(ie.enabled,this.defaultValue.enabled)}}}class W extends R{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),fontSize:y.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class J extends u{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>u.clamp(ie,0,150),{markdownDescription:m.localize(47,null)})}compute(ie,Se,re){return ie.fontInfo.lineHeight}}class ne extends R{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ie.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:m.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),size:f(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Se.side,this.defaultValue.side,["right","left"]),showSlider:f(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(Se.scale,1,1,3),maxColumn:y.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function se(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{top:y.clampedInt(Se.top,0,0,1e3),bottom:y.clampedInt(Se.bottom,0,0,1e3)}}}class Q extends R{constructor(){const ie={enabled:!0,cycle:!1};super(76,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:m.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class ae extends w{constructor(){super(129)}compute(ie,Se,re){return ie.pixelRatio}}class fe extends R{constructor(){const ie={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:m.localize(63,null)},other:{type:"boolean",default:ie.other,description:m.localize(64,null)}}}],default:ie,description:m.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Se=ie,re={other:g(Se.other,this.defaultValue.other),comments:g(Se.comments,this.defaultValue.comments),strings:g(Se.strings,this.defaultValue.strings)};return re.other&&re.comments&&re.strings?!0:!re.other&&!re.comments&&!re.strings?!1:re}return this.defaultValue}}var be;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ie){let Se=this.defaultValue.renderType,re=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Se=4,re=ie):ie==="interval"?Se=3:ie==="relative"?Se=2:ie==="on"?Se=1:Se=0),{renderType:Se,renderFn:re}}}function xe(ee){const ie=ee.get(87);return ie==="editable"?ee.get(81):ie!=="on"}e.filterValidationDecorations=xe;class Ge extends R{constructor(){const ie=[],Se={type:"number",description:m.localize(71,null)};super(91,"rulers",ie,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ie,description:m.localize(73,null)})}validate(ie){if(Array.isArray(ie)){const Se=[];for(let re of ie)if(typeof re=="number")Se.push({column:y.clampedInt(re,0,0,1e4),color:null});else if(re&&typeof re=="object"){const ye=re;Se.push({column:y.clampedInt(ye.column,0,0,1e4),color:ye.color})}return Se.sort((re,ye)=>re.column-ye.column),Se}return this.defaultValue}}function Je(ee,ie){if(typeof ee!="string")return ie;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends R{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:m.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie,re=y.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=y.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(Se.vertical,this.defaultValue.vertical),horizontal:Je(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:re,horizontalSliderSize:y.clampedInt(Se.horizontalSliderSize,re,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:y.clampedInt(Se.verticalSliderSize,ye,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class te extends R{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:m.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:m.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:m.localize(91,null)}})}applyUpdate(ie,Se){let re=!1;Se.allowedCharacters&&(T.equals(ie.allowedCharacters,Se.allowedCharacters)||(ie={...ie,allowedCharacters:Se.allowedCharacters},re=!0)),Se.allowedLocales&&(T.equals(ie.allowedLocales,Se.allowedLocales)||(ie={...ie,allowedLocales:Se.allowedLocales},re=!0));const ye=super.applyUpdate(ie,Se);return re?new C(ye.newValue,!0):ye}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{nonBasicASCII:me(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ie.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ie,Se){if(typeof ie!="object"||!ie)return Se;const re={};for(const[ye,Fe]of Object.entries(ie))Fe===!0&&(re[ye]=!0);return re}}class G extends R{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:m.localize(92,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:f(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class X extends R{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:m.localize(93,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:g(ie.enabled,this.defaultValue.enabled)}}}class oe extends R{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:ie.bracketPairs,description:m.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:ie.bracketPairsHorizontal,description:m.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:m.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:m.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:m.localize(104,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{bracketPairs:me(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:g(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(ee,ie,Se){const re=Se.indexOf(ee);return re===-1?ie:Se[re]}class Ie extends R{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(105,null),m.localize(106,null)],default:ie.insertMode,description:m.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:m.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:m.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:m.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:m.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:m.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:m.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:m.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:m.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(146,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertMode:f(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:f(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class We extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(147,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ye extends w{constructor(){super(130)}compute(ie,Se,re){return Se.get(81)?!0:ie.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function st(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends w{constructor(){super(132)}compute(ie,Se,re){const ye=Se.get(131);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?rt:t.isLinux?gt:tt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var It;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(It=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new E(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(148,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(149,null),""],markdownDescription:m.localize(150,null)})),accessibilitySupport:Ue(new i),accessibilityPageSize:Ue(new y(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(151,null)})),ariaLabel:Ue(new r(4,"ariaLabel",m.localize(152,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(153,null),m.localize(154,null),""],description:m.localize(155,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(158,null),""],description:m.localize(159,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(160,null),m.localize(161,null),""],description:m.localize(162,null)})),autoIndent:Ue(new S(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[m.localize(163,null),m.localize(164,null),m.localize(165,null),m.localize(166,null),m.localize(167,null)],description:m.localize(168,null)})),automaticLayout:Ue(new E(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(169,null),m.localize(170,null),m.localize(171,null),""],description:m.localize(172,null)})),bracketPairColorization:Ue(new X),bracketPairGuides:Ue(new oe),stickyTabStops:Ue(new E(104,"stickyTabStops",!1,{description:m.localize(173,null)})),codeLens:Ue(new E(14,"codeLens",!0,{description:m.localize(174,null)})),codeLensFontFamily:Ue(new r(15,"codeLensFontFamily","",{description:m.localize(175,null)})),codeLensFontSize:Ue(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(176,null)})),colorDecorators:Ue(new E(17,"colorDecorators",!0,{description:m.localize(177,null)})),columnSelection:Ue(new E(18,"columnSelection",!1,{description:m.localize(178,null)})),comments:Ue(new n),contextmenu:Ue(new E(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new E(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(179,null)})),cursorBlinking:Ue(new S(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:m.localize(180,null)})),cursorSmoothCaretAnimation:Ue(new E(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(181,null)})),cursorStyle:Ue(new S(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:m.localize(182,null)})),cursorSurroundingLines:Ue(new y(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(183,null)})),cursorSurroundingLinesStyle:Ue(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(184,null),m.localize(185,null)],description:m.localize(186,null)})),cursorWidth:Ue(new y(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(187,null)})),disableLayerHinting:Ue(new E(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new E(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new E(30,"domReadOnly",!1)),dragAndDrop:Ue(new E(31,"dragAndDrop",!0,{description:m.localize(188,null)})),emptySelectionClipboard:Ue(new A),extraEditorClassName:Ue(new r(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(189,null)})),find:Ue(new O),fixedOverflowWidgets:Ue(new E(36,"fixedOverflowWidgets",!1)),folding:Ue(new E(37,"folding",!0,{description:m.localize(190,null)})),foldingStrategy:Ue(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(191,null),m.localize(192,null)],description:m.localize(193,null)})),foldingHighlight:Ue(new E(39,"foldingHighlight",!0,{description:m.localize(194,null)})),foldingImportsByDefault:Ue(new E(40,"foldingImportsByDefault",!1,{description:m.localize(195,null)})),foldingMaximumRegions:Ue(new y(41,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ue(new E(42,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(197,null)})),fontFamily:Ue(new r(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(198,null)})),fontInfo:Ue(new L),fontLigatures2:Ue(new N),fontSize:Ue(new M),fontWeight:Ue(new V),formatOnPaste:Ue(new E(48,"formatOnPaste",!1,{description:m.localize(199,null)})),formatOnType:Ue(new E(49,"formatOnType",!1,{description:m.localize(200,null)})),glyphMargin:Ue(new E(50,"glyphMargin",!0,{description:m.localize(201,null)})),gotoLocation:Ue(new H),hideCursorInOverviewRuler:Ue(new E(52,"hideCursorInOverviewRuler",!1,{description:m.localize(202,null)})),hover:Ue(new U),inDiffEditor:Ue(new E(54,"inDiffEditor",!1)),letterSpacing:Ue(new u(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>u.clamp(ee,-5,20),{description:m.localize(203,null)})),lightbulb:Ue(new z),lineDecorationsWidth:Ue(new p(58,"lineDecorationsWidth",10)),lineHeight:Ue(new J),lineNumbers:Ue(new Me),lineNumbersMinChars:Ue(new y(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new E(62,"linkedEditing",!1,{description:m.localize(204,null)})),links:Ue(new E(63,"links",!0,{description:m.localize(205,null)})),matchBrackets:Ue(new o(64,"matchBrackets","always",["always","near","never"],{description:m.localize(206,null)})),minimap:Ue(new ne),mouseStyle:Ue(new o(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(207,null)})),mouseWheelZoom:Ue(new E(68,"mouseWheelZoom",!1,{markdownDescription:m.localize(208,null)})),multiCursorMergeOverlapping:Ue(new E(69,"multiCursorMergeOverlapping",!0,{description:m.localize(209,null)})),multiCursorModifier:Ue(new S(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),multiCursorPaste:Ue(new o(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(213,null),m.localize(214,null)],markdownDescription:m.localize(215,null)})),occurrencesHighlight:Ue(new E(72,"occurrencesHighlight",!0,{description:m.localize(216,null)})),overviewRulerBorder:Ue(new E(73,"overviewRulerBorder",!0,{description:m.localize(217,null)})),overviewRulerLanes:Ue(new y(74,"overviewRulerLanes",3,0,3)),padding:Ue(new K),parameterHints:Ue(new Q),peekWidgetDefaultFocus:Ue(new o(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(218,null),m.localize(219,null)],description:m.localize(220,null)})),definitionLinkOpensInPeek:Ue(new E(78,"definitionLinkOpensInPeek",!1,{description:m.localize(221,null)})),quickSuggestions:Ue(new fe),quickSuggestionsDelay:Ue(new y(80,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(222,null)})),readOnly:Ue(new E(81,"readOnly",!1)),renameOnType:Ue(new E(82,"renameOnType",!1,{description:m.localize(223,null),markdownDeprecationMessage:m.localize(224,null)})),renderControlCharacters:Ue(new E(83,"renderControlCharacters",!0,{description:m.localize(225,null),restricted:!0})),renderFinalNewline:Ue(new E(84,"renderFinalNewline",!0,{description:m.localize(226,null)})),renderLineHighlight:Ue(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(227,null)],description:m.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ue(new E(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(229,null)})),renderValidationDecorations:Ue(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),m.localize(232,null),""],description:m.localize(233,null)})),revealHorizontalRightPadding:Ue(new y(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new E(90,"roundedSelection",!0,{description:m.localize(234,null)})),rulers:Ue(new Ge),scrollbar:Ue(new q),scrollBeyondLastColumn:Ue(new y(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(235,null)})),scrollBeyondLastLine:Ue(new E(94,"scrollBeyondLastLine",!0,{description:m.localize(236,null)})),scrollPredominantAxis:Ue(new E(95,"scrollPredominantAxis",!0,{description:m.localize(237,null)})),selectionClipboard:Ue(new E(96,"selectionClipboard",!0,{description:m.localize(238,null),included:t.isLinux})),selectionHighlight:Ue(new E(97,"selectionHighlight",!0,{description:m.localize(239,null)})),selectOnLineNumbers:Ue(new E(98,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(240,null),m.localize(241,null)],description:m.localize(242,null)})),showUnused:Ue(new E(100,"showUnused",!0,{description:m.localize(243,null)})),showDeprecated:Ue(new E(126,"showDeprecated",!0,{description:m.localize(244,null)})),inlayHints:Ue(new W),snippetSuggestions:Ue(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(245,null),m.localize(246,null),m.localize(247,null),m.localize(248,null)],description:m.localize(249,null)})),smartSelect:Ue(new We),smoothScrolling:Ue(new E(103,"smoothScrolling",!1,{description:m.localize(250,null)})),stopRenderingLineAfter:Ue(new y(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ie),inlineSuggest:Ue(new G),suggestFontSize:Ue(new y(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(251,null)})),suggestLineHeight:Ue(new y(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(252,null)})),suggestOnTriggerCharacters:Ue(new E(109,"suggestOnTriggerCharacters",!0,{description:m.localize(253,null)})),suggestSelection:Ue(new o(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),tabCompletion:Ue(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(258,null),m.localize(259,null),m.localize(260,null)],description:m.localize(261,null)})),tabIndex:Ue(new y(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new te),unusualLineTerminators:Ue(new o(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),useShadowDOM:Ue(new E(115,"useShadowDOM",!0)),useTabStops:Ue(new E(116,"useTabStops",!0,{description:m.localize(266,null)})),wordSeparators:Ue(new r(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:m.localize(267,null)})),wordWrap:Ue(new o(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(268,null),m.localize(269,null),m.localize(270,null),m.localize(271,null)],description:m.localize(272,null)})),wordWrapBreakAfterCharacters:Ue(new r(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new r(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new y(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(273,null)})),wordWrapOverride1:Ue(new o(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new S(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[m.localize(274,null),m.localize(275,null),m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),wrappingStrategy:Ue(new o(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(279,null),m.localize(280,null)],description:m.localize(281,null)})),editorClassName:Ue(new b),pixelRatio:Ue(new ae),tabFocusMode:Ue(new Ye),layoutInfo:Ue(new $),wrappingInfo:Ue(new ot)}}),define(pe[156],ve([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[157],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[158],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[159],ve([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[160],ve([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(pe[161],ve([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(pe[162],ve([19,20]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[163],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[164],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[165],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[166],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[167],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[168],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[169],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[170],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[171],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[172],ve([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(pe[173],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[174],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[175],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[176],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[177],ve([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[178],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var t;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[179],ve([0,1,158]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function D(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=D;function T(l){if(!D(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=l.match(t);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=T;function k(l){if(!l)return null;let w=l.majorBase,p=l.majorMustEqual,g=l.minorBase,E=l.minorMustEqual,F=l.patchBase,y=l.patchMustEqual;l.hasCaret&&(w===0||(E=!1),y=!1);let u=0;if(l.preRelease){const r=I.exec(l.preRelease);if(r){const[,f,o,S]=r;u=Date.UTC(Number(f),Number(o)-1,Number(S))}}return{majorBase:w,majorMustEqual:p,minorBase:g,minorMustEqual:E,patchBase:F,patchMustEqual:y,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=k;function _(l,w,p){let g;typeof l=="string"?g=k(T(l)):g=l;let E;w instanceof Date?E=w.getTime():typeof w=="string"&&(E=new Date(w).getTime());let F;if(typeof p=="string"?F=k(T(p)):F=p,!g||!F)return!1;let y=g.majorBase,u=g.minorBase,r=g.patchBase,f=F.majorBase,o=F.minorBase,S=F.patchBase,s=F.notBefore,i=F.majorMustEqual,n=F.minorMustEqual,c=F.patchMustEqual;return F.isMinimum?y>f?!0:y<f?!1:u>o?!0:u<o||E&&E<s?!1:r>=S:(y===1&&f===0&&(!i||!n||!c)&&(f=1,o=0,S=0,i=!0,n=!1,c=!1),y<f?!1:y>f?!i:u<o?!1:u>o?!n:r<S?!1:r>S?!c:!(E&&E<s))}e.isValidVersion=_;function P(l,w,p,g){return p.isBuiltin||typeof p.main=="undefined"?!0:C(l,w,p.engines.vscode,g)}e.isValidExtensionVersion=P;function R(l,w,p){return l==="*"||C(w,p,l)}e.isEngineValid=R;function C(l,w,p,g=[]){let E=k(T(p));if(!E)return g.push(m.localize(0,null,p)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(m.localize(1,null,p)),!1}else if(!E.majorMustEqual)return g.push(m.localize(2,null,p)),!1;return _(l,w,E)?!0:(g.push(m.localize(3,null,l,p)),!1)}}),define(pe[115],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(I,D=[],T=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=m}),define(pe[61],ve([0,1,115]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(T,k,_){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],_)),t.push([T,k])}e.registerSingleton=I;function D(){return t}e.getSingletonServiceDescriptors=D}),define(pe[180],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=m;class t{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const k=this.lookupOrInsertNode(D),_=this.lookupOrInsertNode(T);k.outgoing.set(this._hashFn(T),_),_.incoming.set(this._hashFn(D),k)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let k of this._nodes.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let k=this._nodes.get(T);return k||(k=new m(D),this._nodes.set(T,k)),k}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,k]of this._nodes)D.push(`${T}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const k=new Set([D]),_=this._findCycle(T,k);if(_)return _}}_findCycle(D,T){for(let[k,_]of D.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const P=this._findCycle(_,T);if(P)return P;T.delete(k)}}}e.Graph=t}),define(pe[4],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(T,k,_,P){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:T,index:_,optional:P}):(k[m.DI_DEPENDENCIES]=[{id:T,index:_,optional:P}],k[m.DI_TARGET]=k)}function I(T){if(m.serviceIds.has(T))return m.serviceIds.get(T);const k=function(_,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,_,R,!1)};return k.toString=()=>T,m.serviceIds.set(T,k),k}e.createDecorator=I;function D(T){return T}e.refineServiceDecorator=D}),define(pe[181],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function t(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(pe[182],ve([0,1,3,6,82,181]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function T(_){return typeof _=="string"?!1:Array.isArray(_)?_.every(T):!!_.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(P,R){let C={selector:P,provider:R,_score:-1,_time:this._clock++};return this._entries.push(C),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(C){const l=this._entries.indexOf(C);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const R=[];for(let C of this._entries)C._score>0&&R.push(C.provider);return R}ordered(P){const R=[];return this._orderedForEach(P,C=>R.push(C.provider)),R}orderedGroups(P){const R=[];let C,l;return this._orderedForEach(P,w=>{C&&l===w._score?C.push(w.provider):(l=w._score,C=[w.provider],R.push(C))}),R}_orderedForEach(P,R){if(!!P){this._updateScores(P);for(const C of this._entries)C._score>0&&R(C)}}_updateScores(P){const R={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let C of this._entries)if(C._score=(0,I.score)(C.selector,P.uri,P.getLanguageId(),(0,D.shouldSynchronizeModel)(P)),T(C.selector)&&C._score>0){for(let l of this._entries)l._score=0;C._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(P,R){return P._score<R._score?1:P._score>R._score?-1:P._time<R._time?1:P._time>R._time?-1:0}}e.LanguageFeatureRegistry=k}),define(pe[83],ve([0,1,2,41,182,148,74]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(_=e.FontStyle||(e.FontStyle={}));var P;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var R;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var C;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",b[b.ITALIC_MASK=1024]="ITALIC_MASK",b[b.BOLD_MASK=2048]="BOLD_MASK",b[b.UNDERLINE_MASK=4096]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(C=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&768)>>>8}static getFontStyle(A){return(A&15360)>>>10}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){const O=this.getForeground(A);let N="mtk"+O;const L=this.getFontStyle(A);return L&1&&(N+=" mtki"),L&2&&(N+=" mtkb"),L&4&&(N+=" mtku"),L&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(A,O){const N=this.getForeground(A),L=this.getFontStyle(A);let M=`color: ${O[N]};`;L&1&&(M+="font-style: italic;"),L&2&&(M+="font-weight: bold;");let V="";return L&4&&(V+=" underline"),L&8&&(V+=" line-through"),V&&(M+=`text-decoration:${V};`),M}static getPresentationFromMetadata(A){const O=this.getForeground(A),N=this.getFontStyle(A);return{foreground:O,italic:Boolean(N&1),bold:Boolean(N&2),underline:Boolean(N&4),strikethrough:Boolean(N&8)}}}e.TokenMetadata=l;var w;(function(b){b[b.Method=0]="Method",b[b.Function=1]="Function",b[b.Constructor=2]="Constructor",b[b.Field=3]="Field",b[b.Variable=4]="Variable",b[b.Class=5]="Class",b[b.Struct=6]="Struct",b[b.Interface=7]="Interface",b[b.Module=8]="Module",b[b.Property=9]="Property",b[b.Event=10]="Event",b[b.Operator=11]="Operator",b[b.Unit=12]="Unit",b[b.Value=13]="Value",b[b.Constant=14]="Constant",b[b.Enum=15]="Enum",b[b.EnumMember=16]="EnumMember",b[b.Keyword=17]="Keyword",b[b.Text=18]="Text",b[b.Color=19]="Color",b[b.File=20]="File",b[b.Reference=21]="Reference",b[b.Customcolor=22]="Customcolor",b[b.Folder=23]="Folder",b[b.TypeParameter=24]="TypeParameter",b[b.User=25]="User",b[b.Issue=26]="Issue",b[b.Snippet=27]="Snippet"})(w=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(b){const A=new Map;A.set(0,T.Codicon.symbolMethod),A.set(1,T.Codicon.symbolFunction),A.set(2,T.Codicon.symbolConstructor),A.set(3,T.Codicon.symbolField),A.set(4,T.Codicon.symbolVariable),A.set(5,T.Codicon.symbolClass),A.set(6,T.Codicon.symbolStruct),A.set(7,T.Codicon.symbolInterface),A.set(8,T.Codicon.symbolModule),A.set(9,T.Codicon.symbolProperty),A.set(10,T.Codicon.symbolEvent),A.set(11,T.Codicon.symbolOperator),A.set(12,T.Codicon.symbolUnit),A.set(13,T.Codicon.symbolValue),A.set(15,T.Codicon.symbolEnum),A.set(14,T.Codicon.symbolConstant),A.set(15,T.Codicon.symbolEnum),A.set(16,T.Codicon.symbolEnumMember),A.set(17,T.Codicon.symbolKeyword),A.set(27,T.Codicon.symbolSnippet),A.set(18,T.Codicon.symbolText),A.set(19,T.Codicon.symbolColor),A.set(20,T.Codicon.symbolFile),A.set(21,T.Codicon.symbolReference),A.set(22,T.Codicon.symbolCustomColor),A.set(23,T.Codicon.symbolFolder),A.set(24,T.Codicon.symbolTypeParameter),A.set(25,T.Codicon.account),A.set(26,T.Codicon.issues);function O(M){let V=A.get(M);return V||(console.info("No codicon found for CompletionItemKind "+M),V=T.Codicon.symbolProperty),V}b.toIcon=O;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function L(M,V){let H=N.get(M);return typeof H=="undefined"&&!V&&(H=9),H}b.fromString=L})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(b){b[b.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(b){b[b.KeepWhitespace=1]="KeepWhitespace",b[b.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(b){b[b.Invoke=0]="Invoke",b[b.TriggerCharacter=1]="TriggerCharacter",b[b.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(b){b[b.Invoke=1]="Invoke",b[b.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var r;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(r=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(b){return b&&m.URI.isUri(b.uri)&&t.Range.isIRange(b.range)&&(t.Range.isIRange(b.originSelectionRange)||t.Range.isIRange(b.targetSelectionRange))}e.isLocationLink=o;var S;(function(b){b[b.File=0]="File",b[b.Module=1]="Module",b[b.Namespace=2]="Namespace",b[b.Package=3]="Package",b[b.Class=4]="Class",b[b.Method=5]="Method",b[b.Property=6]="Property",b[b.Field=7]="Field",b[b.Constructor=8]="Constructor",b[b.Enum=9]="Enum",b[b.Interface=10]="Interface",b[b.Function=11]="Function",b[b.Variable=12]="Variable",b[b.Constant=13]="Constant",b[b.String=14]="String",b[b.Number=15]="Number",b[b.Boolean=16]="Boolean",b[b.Array=17]="Array",b[b.Object=18]="Object",b[b.Key=19]="Key",b[b.Null=20]="Null",b[b.EnumMember=21]="EnumMember",b[b.Struct=22]="Struct",b[b.Event=23]="Event",b[b.Operator=24]="Operator",b[b.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var s;(function(b){b[b.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(b){const A=new Map;A.set(0,T.Codicon.symbolFile),A.set(1,T.Codicon.symbolModule),A.set(2,T.Codicon.symbolNamespace),A.set(3,T.Codicon.symbolPackage),A.set(4,T.Codicon.symbolClass),A.set(5,T.Codicon.symbolMethod),A.set(6,T.Codicon.symbolProperty),A.set(7,T.Codicon.symbolField),A.set(8,T.Codicon.symbolConstructor),A.set(9,T.Codicon.symbolEnum),A.set(10,T.Codicon.symbolInterface),A.set(11,T.Codicon.symbolFunction),A.set(12,T.Codicon.symbolVariable),A.set(13,T.Codicon.symbolConstant),A.set(14,T.Codicon.symbolString),A.set(15,T.Codicon.symbolNumber),A.set(16,T.Codicon.symbolBoolean),A.set(17,T.Codicon.symbolArray),A.set(18,T.Codicon.symbolObject),A.set(19,T.Codicon.symbolKey),A.set(20,T.Codicon.symbolNull),A.set(21,T.Codicon.symbolEnumMember),A.set(22,T.Codicon.symbolStruct),A.set(23,T.Codicon.symbolEvent),A.set(24,T.Codicon.symbolOperator),A.set(25,T.Codicon.symbolTypeParameter);function O(N){let L=A.get(N);return L||(console.info("No codicon found for SymbolKind "+N),L=T.Codicon.symbolProperty),L}b.toIcon=O})(i=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(A){this.value=A}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var c;(function(b){function A(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}b.is=A})(c=e.Command||(e.Command={}));var a;(function(b){b[b.Collapsed=0]="Collapsed",b[b.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(b){b[b.Editing=0]="Editing",b[b.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var d;(function(b){b[b.Other=0]="Other",b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistry;var v;(function(b){b[b.None=0]="None",b[b.Option=1]="Option",b[b.Default=2]="Default",b[b.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[116],ve([0,1,18,2,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function D(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=D;function T(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||m.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var k;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function P(E,F){const y=Object.create(null);for(let u in E)R(y,u,E[u],F);return y}e.toValuesTree=P;function R(E,F,y,u){const r=F.split("."),f=r.pop();let o=E;for(let S=0;S<r.length;S++){let s=r[S],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${F} as ${r.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[f]=y}catch{u(`Ignoring ${F} as ${r.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${F} as ${r.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function C(E,F){const y=F.split(".");l(E,y)}e.removeFromValueTree=C;function l(E,F){const y=F.shift();if(F.length===0){delete E[y];return}if(Object.keys(E).indexOf(y)!==-1){const u=E[y];typeof u=="object"&&!Array.isArray(u)&&(l(u,F),Object.keys(u).length===0&&delete E[y])}}function w(E,F,y){function u(o,S){let s=o;for(const i of S){if(typeof s!="object"||s===null)return;s=s[i]}return s}const r=F.split("."),f=u(E,r);return typeof f=="undefined"?y:f}e.getConfigurationValue=w;function p(E,F,y){Object.keys(F).forEach(u=>{u!=="__proto__"&&(u in E?m.isObject(E[u])&&m.isObject(F[u])?p(E[u],F[u],y):y&&(E[u]=F[u]):E[u]=F[u])})}e.merge=p;function g(E,F,y){const u=E.inspect(F),r=E.inspect(y);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:u.defaultValue}e.getMigratedSettingValue=g}),define(pe[62],ve([0,1,12,8,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=m.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",m.isMacintosh),T.set("isLinux",m.isLinux),T.set("isWindows",m.isWindows),T.set("isWeb",m.isWeb),T.set("isMacNative",m.isMacintosh&&!m.isWeb),T.set("isEdge",D.indexOf("Edg/")>=0),T.set("isFirefox",D.indexOf("Firefox")>=0),T.set("isChrome",D.indexOf("Chrome")>=0),T.set("isSafari",D.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return l.INSTANCE}static true(){return w.INSTANCE}static has(L){return p.create(L)}static equals(L,M){return g.create(L,M)}static notEquals(L,M){return y.create(L,M)}static regex(L,M){return i.create(L,M)}static in(L,M){return E.create(L,M)}static not(L){return u.create(L)}static and(...L){return a.create(L,null)}static or(...L){return h.create(L,null,!0)}static greater(L,M){return f.create(L,M)}static greaterEquals(L,M){return o.create(L,M)}static smaller(L,M){return S.create(L,M)}static smallerEquals(L,M){return s.create(L,M)}static deserialize(L,M=!1){if(!!L)return this._deserializeOrExpression(L,M)}static _deserializeOrExpression(L,M){let V=L.split("||");return h.create(V.map(H=>this._deserializeAndExpression(H,M)),null,!0)}static _deserializeAndExpression(L,M){let V=L.split("&&");return a.create(V.map(H=>this._deserializeOne(H,M)),null)}static _deserializeOne(L,M){if(L=L.trim(),L.indexOf("!=")>=0){let V=L.split("!=");return y.create(V[0].trim(),this._deserializeValue(V[1],M))}if(L.indexOf("==")>=0){let V=L.split("==");return g.create(V[0].trim(),this._deserializeValue(V[1],M))}if(L.indexOf("=~")>=0){let V=L.split("=~");return i.create(V[0].trim(),this._deserializeRegexValue(V[1],M))}if(L.indexOf(" in ")>=0){let V=L.split(" in ");return E.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const V=L.split(">=");return o.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const V=L.split(">");return f.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const V=L.split("<=");return s.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const V=L.split("<");return S.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(L)?u.create(L.substr(1).trim()):p.create(L)}static _deserializeValue(L,M){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let V=/^'([^']*)'$/.exec(L);return V?V[1].trim():L}static _deserializeRegexValue(L,M){if((0,t.isFalsyOrWhitespace)(L)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=L.indexOf("/"),H=L.lastIndexOf("/");if(V===H||V<0){if(M)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let U=L.slice(V+1,H),B=L[H+1]==="i"?"i":"";try{return new RegExp(U,B)}catch($){if(M)throw new Error(`bad regexp-value '${L}', parse error: ${$}`);return console.warn(`bad regexp-value '${L}', parse error: ${$}`),null}}}e.ContextKeyExpr=P;function R(N,L){const M=N?N.substituteConstants():void 0,V=L?L.substituteConstants():void 0;return!M&&!V?!0:!M||!V?!1:M.equals(V)}e.expressionsAreEqualWithConstantSubstitution=R;function C(N,L){return N.cmp(L)}class l{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class w{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class p{constructor(L,M){this.key=L,this.negated=M,this.type=2}static create(L,M=null){const V=T.get(L);return typeof V=="boolean"?V?w.INSTANCE:l.INSTANCE:new p(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:l.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class g{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=4}static create(L,M,V=null){if(typeof M=="boolean")return M?p.create(L,V):u.create(L,V);const H=T.get(L);return typeof H=="boolean"?M===(H?"true":"false")?w.INSTANCE:l.INSTANCE:new g(L,M,V)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const M=L?"true":"false";return this.value===M?w.INSTANCE:l.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class E{constructor(L,M){this.key=L,this.valueKey=M,this.type=10,this.negated=null}static create(L,M){return new E(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.valueKey),V=L.getValue(this.key);return Array.isArray(M)?M.indexOf(V)>=0:typeof V=="string"&&typeof M=="object"&&M!==null?k.call(M,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyInExpr=E;class F{constructor(L){this._actual=L,this.type=11}static create(L){return new F(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new F(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=F;class y{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=5}static create(L,M,V=null){if(typeof M=="boolean")return M?u.create(L,V):p.create(L,V);const H=T.get(L);return typeof H=="boolean"?M===(H?"true":"false")?l.INSTANCE:w.INSTANCE:new y(L,M,V)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const M=L?"true":"false";return this.value===M?l.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class u{constructor(L,M){this.key=L,this.negated=M,this.type=3}static create(L,M=null){const V=T.get(L);return typeof V=="boolean"?V?l.INSTANCE:w.INSTANCE:new u(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?l.INSTANCE:w.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=u;function r(N,L){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?L(N):l.INSTANCE}class f{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=12}static create(L,M,V=null){return r(M,H=>new f(L,H,V))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class o{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=13}static create(L,M,V=null){return r(M,H=>new o(L,H,V))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class S{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=14}static create(L,M,V=null){return r(M,H=>new S(L,H,V))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class s{constructor(L,M,V){this.key=L,this.value=M,this.negated=V,this.type=15}static create(L,M,V=null){return r(M,H=>new s(L,H,V))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class i{constructor(L,M){this.key=L,this.regexp=M,this.type=7,this.negated=null}static create(L,M){return new i(L,M)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const M=this.regexp?this.regexp.source:"",V=L.regexp?L.regexp.source:"";return M<V?-1:M>V?1:0}equals(L){if(L.type===this.type){const M=this.regexp?this.regexp.source:"",V=L.regexp?L.regexp.source:"";return this.key===L.key&&M===V}return!1}substituteConstants(){return this}evaluate(L){let M=L.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(L){this._actual=L,this.type=8}static create(L){return new n(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new n(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function c(N){let L=null;for(let M=0,V=N.length;M<V;M++){const H=N[M].substituteConstants();if(N[M]!==H&&L===null){L=[];for(let U=0;U<M;U++)L[U]=N[U]}L!==null&&(L[M]=H)}return L===null?N:L}class a{constructor(L,M){this.expr=L,this.negated=M,this.type=6}static create(L,M){return a._normalizeArr(L,M)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const H=C(this.expr[M],L.expr[M]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=c(this.expr);return L===this.expr?this:a.create(L,this.negated)}evaluate(L){for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].evaluate(L))return!1;return!0}static _normalizeArr(L,M){const V=[];let H=!1;for(const U of L)if(!!U){if(U.type===1){H=!0;continue}if(U.type===0)return l.INSTANCE;if(U.type===6){V.push(...U.expr);continue}V.push(U)}if(V.length===0&&H)return w.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(C);for(let U=1;U<V.length;U++)V[U-1].equals(V[U])&&(V.splice(U,1),U--);if(V.length===1)return V[0];for(;V.length>1;){const U=V[V.length-1];if(U.type!==9)break;V.pop();const B=V.pop(),$=V.length===0,z=h.create(U.expr.map(W=>a.create([W,B],null)),null,$);z&&(V.push(z),V.sort(C))}return V.length===1?V[0]:new a(V,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let M of this.expr)L.push(...M.keys());return L}map(L){return new a(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.negated){const L=[];for(let M of this.expr)L.push(M.negate());this.negated=h.create(L,this,!0)}return this.negated}}class h{constructor(L,M){this.expr=L,this.negated=M,this.type=9}static create(L,M,V){return h._normalizeArr(L,M,V)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const H=C(this.expr[M],L.expr[M]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=c(this.expr);return L===this.expr?this:h.create(L,this.negated,!1)}evaluate(L){for(let M=0,V=this.expr.length;M<V;M++)if(this.expr[M].evaluate(L))return!0;return!1}static _normalizeArr(L,M,V){let H=[],U=!1;if(L){for(let B=0,$=L.length;B<$;B++){const z=L[B];if(!!z){if(z.type===0){U=!0;continue}if(z.type===1)return w.INSTANCE;if(z.type===9){H=H.concat(z.expr);continue}H.push(z)}}if(H.length===0&&U)return l.INSTANCE;H.sort(C)}if(H.length!==0){if(H.length===1)return H[0];for(let B=1;B<H.length;B++)H[B-1].equals(H[B])&&(H.splice(B,1),B--);if(H.length===1)return H[0];if(V){for(let B=0;B<H.length;B++)for(let $=B+1;$<H.length;$++)A(H[B],H[$])&&(H.splice($,1),$--);if(H.length===1)return H[0]}return new h(H,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let M of this.expr)L.push(...M.keys());return L}map(L){return new h(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.negated){let L=[];for(let M of this.expr)L.push(M.negate());for(;L.length>1;){const M=L.shift(),V=L.shift(),H=[];for(const B of O(M))for(const $ of O(V))H.push(a.create([B,$],null));const U=L.length===0;L.unshift(h.create(H,null,U))}this.negated=L[0]}return this.negated}}class d extends p{constructor(L,M,V){super(L,null);this._defaultValue=M,typeof V=="object"?d._info.push({...V,key:L}):V!==!0&&d._info.push({key:L,description:V,type:M!=null?typeof M:void 0})}static all(){return d._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return g.create(this.key,L)}notEqualsTo(L){return y.create(this.key,L)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(N,L){return N<L?-1:N>L?1:0}function b(N,L,M,V){return N<M?-1:N>M?1:L<V?-1:L>V?1:0}function A(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const H of L.expr)if(N.equals(H))return!0}const M=N.negate(),V=O(M).concat(O(L));V.sort(C);for(let H=0;H<V.length;H++){const B=V[H].negate();for(let $=H+1;$<V.length;$++){const z=V[$];if(B.equals(z))return!0}}return!1}e.implies=A;function O(N){return N.type===9?N.expr:[N]}}),define(pe[183],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[184],ve([0,1,10,157,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function T(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(u,r){switch(u){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function P(u,r){return r==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function R(u,r,f){return P(r,f)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===f?!0:C(f).includes(u)}e.isTargetPlatformCompatible=R;function C(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function l(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=l;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var F;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(F=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(r,f){super(r);this.code=f,this.name=f}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(pe[185],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(pe[186],ve([0,1,37,10,9,12,96,30,113,159,185]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends l{openTerminal(r,f){return this.spawnTerminal(m,r,_.getWindowsShell(),f)}spawnTerminal(r,f,o,S){const s=f.windowsExec||w.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return r.spawn(s,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),(i==="wt"||i==="wt.exe")&&n.push("-d ."),new Promise((c,a)=>{const h=E(process),d=r.spawn(o,n,{cwd:S,env:h});d.on("error",a),d.on("exit",()=>c())})}runInTerminal(r,f,o,S,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows();return new Promise((n,c)=>{const a=`"${f} - ${C}"`,h=`""${o.join('" "')}" & pause"`,d=["/c","start",a,"/wait",i,"/c",h],v=Object.assign({},E(process),S);Object.keys(v).filter(O=>v[O]===null).forEach(O=>delete v[O]);const b={cwd:f,env:v,windowsVerbatimArguments:!0};m.spawn(w.CMD,d,b).on("error",O=>{c(F(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class p extends l{openTerminal(r,f){return this.spawnTerminal(m,r,f)}runInTerminal(r,f,o,S,s){const i=s.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,c)=>{if(i===R.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const a=i===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Z).fsPath,"-t",r||C,"-w",f];for(let A of o)d.push("-a"),d.push(A);if(S){const A=Object.assign({},E(process),S);for(let O in A){const N=A[O];N===null?(d.push("-u"),d.push(O)):(d.push("-e"),d.push(`${O}=${N}`))}}let v="";const b=m.spawn(p.OSASCRIPT,d);b.on("error",A=>{c(F(A))}),b.stderr.on("data",A=>{v+=A.toString()}),b.on("exit",A=>{if(A===0)n(void 0);else if(v){const O=v.split(`
`,1);c(new Error(O[0]))}else c(new Error(P.localize(1,null,a,A)))})}else c(new Error(P.localize(2,null,i)))})}spawnTerminal(r,f,o){const S=f.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const n=["-a",S];o&&n.push(o);const c=E(process),a=r.spawn("/usr/bin/open",n,{cwd:o,env:c});a.on("error",i),a.on("exit",()=>s())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class g extends l{openTerminal(r,f){return this.spawnTerminal(m,r,f)}runInTerminal(r,f,o,S,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{let a=[];i.then(h=>{h.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const d=`${y(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;a.push(`''${d}''`);const v=Object.assign({},E(process),S);Object.keys(v).filter(N=>v[N]===null).forEach(N=>delete v[N]);const b={cwd:f,env:v};let A="";const O=m.spawn(h,a,b);O.on("error",N=>{c(F(N))}),O.stderr.on("data",N=>{A+=N.toString()}),O.on("exit",N=>{if(N===0)n(void 0);else if(A){const L=A.split(`
`,1);c(new Error(L[0]))}else c(new Error(P.localize(4,null,h,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(f=>{r?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,f,o){const S=f.linuxExec?Promise.resolve(f.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{S.then(n=>{const c=E(process),a=r.spawn(n,[],{cwd:o,env:c});a.on("error",i),a.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=P.localize(3,null);function E(u){const r={...u.env};return(0,T.sanitizeProcessEnvironment)(r),r}function F(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(P.localize(5,null,u.path)):u}function y(u){let r="";for(let f of u)f.indexOf(" ")>=0?r+='"'+f+'"':r+=f,r+=" ";return r}}),define(pe[42],ve([0,1,24,9,8,18,2,160,4]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function P(H){return H.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(H){H[H.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=w;function p(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=p;function g(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=E;function F(H){return w(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var y;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(U,B){super(U);this.code=B}}e.FileSystemProviderError=u;function r(H,U){const B=new u(H.toString(),U);return o(B,U),B}e.createFileSystemProviderError=r;function f(H){return H||r((0,k.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=f;function o(H,U){return H.name=U?`${U} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function S(H){if(!H)return y.Unknown;if(H instanceof u)return H.code;const U=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!U)return y.Unknown;switch(U[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=S;function s(H){if(H instanceof d)return H.fileOperationResult;switch(S(H)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(U,B,$){this.resource=U,this.operation=B,this.target=$}isOperation(U){return this.operation===U}}e.FileOperationEvent=n;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class a{constructor(U,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const $=new Map;for(const z of U){const W=$.get(z.type);switch(W?W.push([z.resource,z]):$.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,W]of $)switch(z){case 1:this.added=m.TernarySearchTree.forUris(()=>B),this.added.fill(W);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>B),this.updated.fill(W);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>B),this.deleted.fill(W);break}}contains(U,...B){return this.doContains(U,{includeChildren:!1},...B)}affects(U,...B){return this.doContains(U,{includeChildren:!0},...B)}doContains(U,B,...$){if(!U)return!1;const z=$.length>0;return!!((!z||$.includes(1))&&(this.added?.get(U)||B.includeChildren&&this.added?.findSuperstr(U))||(!z||$.includes(0))&&(this.updated?.get(U)||B.includeChildren&&this.updated?.findSuperstr(U))||(!z||$.includes(2))&&(this.deleted?.findSubstr(U)||B.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function h(H,U,B){return!H||!U||H===U||U.length>H.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),B?(0,I.startsWithIgnoreCase)(H,U):H.indexOf(U)===0)}e.isParent=h;class d extends Error{constructor(U,B,$){super(U);this.fileOperationResult=B,this.options=$}}e.FileOperationError=d;class v extends d{constructor(U,B,$){super(U,2,$);this.stat=B}}e.NotModifiedSinceFileOperationError=v;var b;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=O;async function N(H,U){if(!U.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(B=>{const $=U.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===H.scheme&&z.added&&($.dispose(),B())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(U){return(0,D.isNumber)(U)||(U=0),U<L.KB?(0,k.localize)(1,null,U.toFixed(0)):U<L.MB?(0,k.localize)(2,null,(U/L.KB).toFixed(2)):U<L.GB?(0,k.localize)(3,null,(U/L.MB).toFixed(2)):U<L.TB?(0,k.localize)(4,null,(U/L.GB).toFixed(2)):(0,k.localize)(5,null,(U/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var M;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function V(H){return{maxFileSize:H===0?300*L.MB:16*L.GB,maxHeapSize:H===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=V}),define(pe[84],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[D,T]of I)this.set(D,T)}set(I,D){const T=this._entries.get(I);return this._entries.set(I,D),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=m}),define(pe[187],ve([0,1,13,16,115,180,4,84]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const _=!1;class P extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class R{constructor(p=new k.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=p,this._strict=g,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(p){return new R(p,this._strict,this)}invokeFunction(p,...g){let E=l.traceInvocation(p),F=!1;try{return p({get:u=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(u,E);if(!r)throw new Error(`[invokeFunction] unknown service '${u}'`);return r}},...g)}finally{F=!0,E.stop()}}createInstance(p,...g){let E,F;return p instanceof I.SyncDescriptor?(E=l.traceCreation(p.ctor),F=this._createInstance(p.ctor,p.staticArguments.concat(g),E)):(E=l.traceCreation(p),F=this._createInstance(p,g,E)),E.stop(),F}_createInstance(p,g=[],E){let F=T._util.getServiceDependencies(p).sort((r,f)=>r.index-f.index),y=[];for(const r of F){let f=this._getOrCreateServiceInstance(r.id,E);if(!f&&this._strict&&!r.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${r.id}.`);y.push(f)}let u=F.length>0?F[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${p.name} at position ${u+1} conflicts with ${g.length} static arguments`);let r=u-g.length;r>0?g=g.concat(new Array(r)):g=g.slice(0,u)}return new p(...[...g,...y])}_setServiceInstance(p,g){if(this._services.get(p)instanceof I.SyncDescriptor)this._services.set(p,g);else if(this._parent)this._parent._setServiceInstance(p,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let g=this._services.get(p);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):g}_getOrCreateServiceInstance(p,g){let E=this._getServiceInstanceOrDescriptor(p);return E instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,g.branch(p,!0)):(g.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,g,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,g,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,g,E){const F=new D.Graph(r=>r.id.toString());let y=0;const u=[{id:p,desc:g,_trace:E}];for(;u.length;){const r=u.pop();if(F.lookupOrInsertNode(r),y++>1e3)throw new P(F);for(let f of T._util.getServiceDependencies(r.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(f.id);if(!o&&!f.optional&&console.warn(`[createInstance] ${p} depends on ${f.id} which is NOT registered.`),o instanceof I.SyncDescriptor){const S={id:f.id,desc:o,_trace:r._trace.branch(f.id,!0)};F.insertEdge(r,S),u.push(S)}}}for(;;){const r=F.roots();if(r.length===0){if(!F.isEmpty())throw new P(F);break}for(const{data:f}of r){if(this._getServiceInstanceOrDescriptor(f.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,S)}F.removeNode(f)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,g,E=[],F,y){if(this._services.get(p)instanceof I.SyncDescriptor)return this._createServiceInstance(g,E,F,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,g,E,F,y);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(p,g=[],E,F){if(E){const y=new m.IdleValue(()=>this._createInstance(p,g,F));return new Proxy(Object.create(null),{get(u,r){if(r in u)return u[r];let f=y.value,o=f[r];return typeof o!="function"||(o=o.bind(f),u[r]=o),o},set(u,r,f){return y.value[r]=f,!0}})}else return this._createInstance(p,g,F)}}e.InstantiationService=R;var C;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(C||(C={}));class l{constructor(p,g){this.type=p,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return _?new l(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(p){return _?new l(0,p.name):l._None}branch(p,g){let E=new l(2,p.toString());return this._dep.push([p,g,E]),E}stop(){let p=Date.now()-this._start;l._totals+=p;let g=!1;function E(y,u){let r=[],f=new Array(y+1).join("	");for(const[o,S,s]of u._dep)if(S&&s){g=!0,r.push(`${f}CREATES -> ${o}`);let i=E(y+1,s);i&&r.push(i)}else r.push(`${f}uses -> ${o}`);return r.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(p>2||g)&&console.log(F.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(pe[11],ve([0,1,49,3,6,12,4]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function P(S,s,i){switch(s){case _.Trace:S.trace(i);break;case _.Debug:S.debug(i);break;case _.Info:S.info(i);break;case _.Warning:S.warn(i);break;case _.Error:S.error(i);break;case _.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function R(S){let s="";for(let i=0;i<S.length;i++){let n=S[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}s+=(i>0?" ":"")+n}return s}e.format=R;class C extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class l extends C{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,R([s,...i]))}debug(s,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,R([s,...i]))}info(s,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,R([s,...i]))}warn(s,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,R([s,...i]))}error(s,...i){if(this.checkLogLevel(_.Error))if(s instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=s.stack,this.log(_.Error,R(n))}else this.log(_.Error,R([s,...i]))}critical(s,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,R([s,...i]))}flush(){}}e.AbstractMessageLogger=l;class w extends C{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!D.isWindows}trace(s,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}debug(s,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}info(s,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}warn(s,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,s,...i):console.warn(`[main ${k()}]`,s,...i))}error(s,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,s,...i):console.error(`[main ${k()}]`,s,...i))}critical(s,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,s,...i):console.error(`[main ${k()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class p extends C{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class g extends C{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,m.toErrorMessage)(s,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends C{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const n of this.logServices)n.trace(s,...i)}debug(s,...i){for(const n of this.logServices)n.debug(s,...i)}info(s,...i){for(const n of this.logServices)n.info(s,...i)}warn(s,...i){for(const n of this.logServices)n.warn(s,...i)}error(s,...i){for(const n of this.logServices)n.error(s,...i)}critical(s,...i){for(const n of this.logServices)n.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=E;class F extends I.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=F;class y extends I.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(n))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let n=this.loggers.get(s.toString());return n||(n=this.doCreateLogger(s,i?.always?_.Trace:this.logLevel,i),this.loggers.set(s.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return _.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=u;function r(S){if(S.verbose)return _.Trace;if(typeof S.logLevel=="string"){const s=f(S.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function f(S){switch(S){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=f;function o(S){switch(S){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=o}),define(pe[188],ve([0,1,42,11]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,_,P,R,C){try{const l=await new Promise((p,g)=>{Z(["spdlog"],p,g)});l.setFlushOn(t.LogLevel.Trace);const w=await l.createAsyncRotatingLogger(k,_,P,R);return C&&w.clearFormatters(),w}catch(l){console.error(l)}return null}function D(k,_,P){switch(_){case t.LogLevel.Trace:k.trace(P);break;case t.LogLevel.Debug:k.debug(P);break;case t.LogLevel.Info:k.info(P);break;case t.LogLevel.Warning:k.warn(P);break;case t.LogLevel.Error:k.error(P);break;case t.LogLevel.Critical:k.critical(P);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(_,P,R,C,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(_,P,R,C),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(_,P,R,C){const l=R?6:1,w=30/l*m.ByteSize.MB,p=await I(_,P,w,l,C);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)D(this._logger,g,E);this.buffer=[]}}log(_,P){this._logger?D(this._logger,_,P):this.getLevel()<=_&&this.buffer.push({level:_,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(pe[117],ve([0,1,47,161,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var T;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function P(p,g){return g-p}_.compare=P;const R=Object.create(null);R[_.Error]=(0,t.localize)(0,null),R[_.Warning]=(0,t.localize)(1,null),R[_.Info]=(0,t.localize)(2,null);function C(p){return R[p]||""}_.toString=C;function l(p){switch(p){case m.default.Error:return _.Error;case m.default.Warning:return _.Warning;case m.default.Info:return _.Info;case m.default.Ignore:return _.Hint}}_.fromSeverity=l;function w(p){switch(p){case _.Error:return m.default.Error;case _.Warning:return m.default.Warning;case _.Info:return m.default.Info;case _.Hint:return m.default.Ignore}}_.toSeverity=w}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const P="";function R(l){return C(l,!0)}_.makeKey=R;function C(l,w){let p=[P];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(P),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(P),l.severity!==void 0&&l.severity!==null?p.push(T.toString(l.severity)):p.push(P),l.message&&w?p.push(l.message.replace("\xA6","\\\xA6")):p.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(P),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(P),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}_.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(pe[189],ve([0,1,3,47,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var D;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=_}),define(pe[190],ve([0,1,6,8,2,4]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function T(_,P){return I.URI.isUri(_)?(0,t.equalsIgnoreCase)(_.scheme,P):(0,t.startsWithIgnoreCase)(_,P+":")}e.matchesScheme=T;function k(_,...P){return P.some(R=>T(_,R))}e.matchesSomeScheme=k}),define(pe[191],ve([0,1,10,12,40,23]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)T=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const k=(0,D.dirname)(m.FileAccess.asFileUri("",Z));T=Z.__$__nodeRequire((0,D.joinPath)(k,"product.json").fsPath);const _=Z.__$__nodeRequire((0,D.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:_.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var ze=this&&this.__param||function(Z,e){return function(m,t){e(m,t,Z)}};define(pe[118],ve([0,1,13,21,6,4]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,D.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends I.Disposable{constructor(C,l){super();this.deferred=new m.DeferredPromise,l.withProgress(C,w=>(this.reporter=w,this.lastStep&&w.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};_=je([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class P extends I.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,w=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>w.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:w.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,D.createDecorator)("editorProgressService")}),define(pe[50],ve([0,1,55,18]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,k){m.ok(t.isString(T)),m.ok(t.isObject(k)),m.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,k)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(pe[192],ve([0,1,3,50]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class D{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,P){this.schemasById[I(_)]=P,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;t.Registry.add(e.Extensions.JSONContribution,T)}),define(pe[119],ve([0,1,17,3,18,156,192,50]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=k.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(f,o=!0){this.registerConfigurations([f],o)}registerConfigurations(f,o=!0){const S=this.doRegisterConfigurations(f,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(f){const o=this.doDeregisterConfigurations(f);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:f,remove:o}){const S=[];S.push(...this.doDeregisterConfigurations(o)),S.push(...this.doRegisterConfigurations(f,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(S)})}registerDefaultConfigurations(f){const o=[],S=[];for(const{overrides:s,source:i}of f)for(const n in s)if(o.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const c={...this.configurationDefaultsOverrides.get(n)?.value||{},...s[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:c});const a={type:"object",default:c,description:D.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:I.isString(i)?void 0:i};S.push(...p(n)),this.configurationProperties[n]=a,this.defaultLanguageConfigurationOverridesNode.properties[n]=a}else{this.configurationDefaultsOverrides.set(n,{value:s[n],source:i});const c=this.configurationProperties[n];c&&(this.updatePropertyDefaultValue(n,c),this.updateSchema(n,c))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(f){const o=[];for(const{overrides:S,source:s}of f)for(const i in S){const n=this.configurationDefaultsOverrides.get(i),c=I.isString(s)?s:s?.id,a=I.isString(n?.source)?n?.source:n?.source?.id;if(c===a)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const h=this.configurationProperties[i];h&&(this.updatePropertyDefaultValue(i,h),this.updateSchema(i,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const o of f)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,o){const S=[];return f.forEach(s=>{S.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),S}doDeregisterConfigurations(f){const o=[],S=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>S(i))};for(const s of f){S(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(f,o=!0,S,s,i=3){i=I.isUndefinedOrNull(f.scope)?i:f.scope;let n=[],c=f.properties;if(c)for(let h in c){if(o&&y(h)){delete c[h];continue}const d=c[h];if(d.source=S,d.defaultDefaultValue=c[h].default,this.updatePropertyDefaultValue(h,d),e.OVERRIDE_PROPERTY_REGEX.test(h)?d.scope=void 0:(d.scope=I.isUndefinedOrNull(d.scope)?i:d.scope,d.restricted=I.isUndefinedOrNull(d.restricted)?!!s?.includes(h):d.restricted),c[h].hasOwnProperty("included")&&!c[h].included){this.excludedConfigurationProperties[h]=c[h],delete c[h];continue}else this.configurationProperties[h]=c[h];!c[h].deprecationMessage&&c[h].markdownDeprecationMessage&&(c[h].deprecationMessage=c[h].markdownDeprecationMessage),n.push(h)}let a=f.allOf;if(a)for(let h of a)n.push(...this.validateAndRegisterProperties(h,o,S,s,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(f){const o=S=>{let s=S.properties;if(s)for(const n in s)this.updateSchema(n,s[n]);let i=S.allOf;i&&i.forEach(o)};o(f)}updateSchema(f,o){switch(e.allSettings.properties[f]=o,o.scope){case 1:e.applicationSettings.properties[f]=o;break;case 2:e.machineSettings.properties[f]=o;break;case 6:e.machineOverridableSettings.properties[f]=o;break;case 3:e.windowSettings.properties[f]=o;break;case 4:e.resourceSettings.properties[f]=o;break;case 5:e.resourceSettings.properties[f]=o,this.resourceLanguageSettingsSchema.properties[f]=o;break}}removeFromSchema(f,o){switch(delete e.allSettings.properties[f],o.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f],delete this.resourceLanguageSettingsSchema.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const o=`[${f}]`,S={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,S),e.allSettings.properties[o]=S,e.applicationSettings.properties[o]=S,e.machineSettings.properties[o]=S,e.machineOverridableSettings.properties[o]=S,e.windowSettings.properties[o]=S,e.resourceSettings.properties[o]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const f={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,o){const S=this.configurationDefaultsOverrides.get(f);let s=S?.value,i=S?.source;I.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),I.isUndefined(s)&&(s=E(o.type)),o.default=s,o.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",w=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(r){const f=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let o=w.exec(r);for(;o?.length;){const S=o[1].trim();S&&f.push(S),o=w.exec(r)}}return(0,m.distinct)(f)}e.overrideIdentifiersFromKey=p;function g(r){return r.reduce((f,o)=>`${f}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function E(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const F=new C;k.Registry.add(e.Extensions.Configuration,F);function y(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?D.localize(7,null,r):F.getConfigurationProperties()[r]!==void 0?D.localize(8,null,r):null:D.localize(6,null)}e.validateProperty=y;function u(){const r=[],f=F.getConfigurationProperties();for(const o of Object.keys(f))r.push([o,f[o].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=u}),define(pe[193],ve([0,1,17,3,57,6,24,25,18,2,116,119,50]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(s={},i=[],n=[]){this._contents=s,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,R.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return m.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return m.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=k.deepClone(this.contents),n=k.deepClone(this.overrides),c=[...this.keys];for(const a of s){this.mergeContents(i,a.contents);for(const h of a.overrides){const[d]=n.filter(v=>m.equals(v.identifiers,h.identifiers));d?(this.mergeContents(d.contents,h.contents),d.keys.push(...h.keys),d.keys=m.distinct(d.keys)):n.push(k.deepClone(h))}for(const h of a.keys)c.indexOf(h)===-1&&c.push(h)}return new w(i,c,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const c of m.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[c],h=i[c];h&&(typeof a=="object"&&typeof h=="object"?(a=k.deepClone(a),this.mergeContents(a,h)):a=h),n[c]=a}return new w(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&_.isObject(s[n])&&_.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=k.deepClone(i[n])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?k.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,n=null;const c=a=>{a&&(n?this.mergeContents(n,a):n=k.deepClone(a))};for(const a of this.overrides)m.equals(a.identifiers,[s])?i=a.contents:a.identifiers.includes(s)&&c(a.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,R.addToValueTree)(this.contents,s,i,n=>{throw new Error(n)})}removeValue(s){this.removeKey(s)&&(0,R.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let n=0;n<i;n++)s.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class p extends w{constructor(s={}){const i=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(i),c=Object.create(null),a=[];for(const h in i){const d=s[h],v=d!==void 0?d:i[h].default;(0,R.addToValueTree)(c,h,v,b=>console.error(`Conflict in default settings: ${b}`))}for(const h of Object.keys(c))C.OVERRIDE_PROPERTY_REGEX.test(h)&&a.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(c[h]),contents:(0,R.toValuesTree)(c[h],d=>console.error(`Conflict in default settings file: ${d}`))});super(c,n,a)}}e.DefaultConfigurationModel=p;class g{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!_.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:c,overrides:a,restricted:h}=this.doParseRaw(s,i);this._configurationModel=new w(n,c,a),this._restrictedConfigurations=h||[]}doParseContent(s){let i={},n=null,c=[],a=[],h=[];function d(b){Array.isArray(c)?c.push(b):n!==null&&(c[n]=b)}let v={onObjectBegin:()=>{let b={};d(b),a.push(c),c=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{c=a.pop()},onArrayBegin:()=>{let b=[];d(b),a.push(c),c=b,n=null},onArrayEnd:()=>{c=a.pop()},onLiteralValue:d,onError:(b,A,O)=>{h.push({error:b,offset:A,length:O})}};if(s)try{I.visit(s,v),i=c[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return i}doParseRaw(s,i){const n=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),c=this.filter(s,n,!0,i);s=c.raw;const a=(0,R.toValuesTree)(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),h=Object.keys(s),d=this.toOverrides(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:a,keys:h,overrides:d,restricted:c.restricted}}filter(s,i,n,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:s,restricted:[]};const a={},h=[];for(let d in s)if(C.OVERRIDE_PROPERTY_REGEX.test(d)&&n){const v=this.filter(s[d],i,!1,c);a[d]=v.raw,h.push(...v.restricted)}else{const v=i[d],b=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&h.push(d),(b===void 0||c.scopes===void 0||c.scopes.includes(b))&&(c.skipRestricted&&v?.restricted||(a[d]=s[d]))}return{raw:a,restricted:h}}toOverrides(s,i){const n=[];for(const c of Object.keys(s))if(C.OVERRIDE_PROPERTY_REGEX.test(c)){const a={};for(const h in s[c])a[h]=s[c][h];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(c),keys:Object.keys(a),contents:(0,R.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=g;class E extends D.Disposable{constructor(s,i,n,c){super();this.userSettingsResource=s,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class F{constructor(s,i,n=new w,c=new w,a=new T.ResourceMap,h=new w,d=new T.ResourceMap,v=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=c,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=d,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(s)}updateValue(s,i,n={}){let c;n.resource?(c=this._memoryConfigurationByResource.get(n.resource),c||(c=new w,this._memoryConfigurationByResource.set(n.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(s):c.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const c=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,d=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),v=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),b=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),O=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,N=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(s):a.freeze().getValue(s):void 0,L=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(s):h.getValue(s),M=c.getValue(s),V=m.distinct(m.flatten(c.overrides.map(H=>H.identifiers))).filter(H=>c.getOverrideValue(s,H)!==void 0);return{defaultValue:d,userValue:v,userLocalValue:b,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:N,memoryValue:L,value:M,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:a?.freeze().getValue(s),override:i.overrideIdentifier?a?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:h.getValue(s),override:i.overrideIdentifier?h.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:c,updated:a,removed:h}=f(this._defaultConfiguration,s);i=[...c,...a,...h]}for(const c of i)for(const a of(0,C.overrideIdentifiersFromKey)(c)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=s.getKeysForOverrideIdentifier(a),v=[...d.filter(b=>h.indexOf(b)===-1),...h.filter(b=>d.indexOf(b)===-1),...h.filter(b=>!k.equals(this._defaultConfiguration.override(a).getValue(b),s.override(a).getValue(b)))];n.push([a,v])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:a}=f(this.localUserConfiguration,s),h=[...i,...n,...c];return h.length&&this.updateLocalUserConfiguration(s),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:c,overrides:a}=f(this.remoteUserConfiguration,s);let h=[...i,...n,...c];return h.length&&this.updateRemoteUserConfiguration(s),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:c,overrides:a}=f(this.workspaceConfiguration,s);let h=[...i,...n,...c];return h.length&&this.updateWorkspaceConfiguration(s),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:c,updated:a,removed:h,overrides:d}=f(n,i);let v=[...c,...a,...h];return(v.length||!n)&&this.updateFolderConfiguration(s,i),{keys:v,overrides:d}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:c,removed:a,overrides:h}=f(i,void 0);return{keys:[...n,...c,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let n=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?n.override(s.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const c=i.getFolder(s);c&&(n=this.getFolderConsolidatedConfiguration(c.uri)||n);const a=this._memoryConfigurationByResource.get(s);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(s);c?(i=n.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:c,keys:a}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:c,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.user),c=this.parseConfigurationModel(s.workspace),a=s.folders.reduce((h,d)=>(h.set(P.URI.revive(d[0]),this.parseConfigurationModel(d[1])),h),new T.ResourceMap);return new F(i,n,new w,c,a,new w,new T.ResourceMap,!1)}static parseConfigurationModel(s){return new w(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=F;function y(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const s=new Set,i=new Map;for(const c of S)c.keys.forEach(a=>s.add(a)),c.overrides.forEach(([a,h])=>{const d=(0,T.getOrSet)(i,a,new Set);h.forEach(v=>d.add(v))});const n=[];return i.forEach((c,a)=>n.push([a,[...c.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=y;class u{constructor(s,i,n,c){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=c,this._previousConfiguration=void 0;const a=new Set;s.keys.forEach(d=>a.add(d)),s.overrides.forEach(([,d])=>d.forEach(v=>a.add(v))),this.affectedKeys=[...a.values()];const h=new w;this.affectedKeys.forEach(d=>h.setValue(d,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!k.equals(n,c)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let n=(0,R.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof n=="object"&&(c=Object.keys(n)[0]);){if(s=s[c],!s)return!1;n=n[c]}return!0}}e.ConfigurationChangeEvent=u;class r extends u{constructor(s,i,n,c){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=n,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=r;function f(S,s){const{added:i,removed:n,updated:c}=o(s,S),a=[],h=S?.getAllOverrideIdentifiers()||[],d=s?.getAllOverrideIdentifiers()||[];if(s){const v=d.filter(b=>!h.includes(b));for(const b of v)a.push([b,s.getKeysForOverrideIdentifier(b)])}if(S){const v=h.filter(b=>!d.includes(b));for(const b of v)a.push([b,S.getKeysForOverrideIdentifier(b)])}if(s&&S){for(const v of h)if(d.includes(v)){const b=o({contents:S.getOverrideValue(void 0,v)||{},keys:S.getKeysForOverrideIdentifier(v)},{contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)});a.push([v,[...b.added,...b.removed,...b.updated]])}}return{added:i,removed:n,updated:c,overrides:a}}function o(S,s){const i=S?s?S.keys.filter(a=>s.keys.indexOf(a)===-1):[...S.keys]:[],n=s?S?s.keys.filter(a=>S.keys.indexOf(a)===-1):[...s.keys]:[],c=[];if(S&&s){for(const a of s.keys)if(S.keys.indexOf(a)!==-1){const h=(0,R.getConfigurationValue)(s.contents,a),d=(0,R.getConfigurationValue)(S.contents,a);k.equals(h,d)||c.push(a)}}return{added:i,removed:n,updated:c}}}),define(pe[120],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var t;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(T,k=t.Unknown,_){super(T);this._message=T,this._code=k,this._detail=_,this.isHandled=k===t.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(T){return T instanceof I&&T._code===t.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof I&&T._code===t.NoResolverFound}static isHandled(T){return T instanceof I&&T.isHandled}}e.RemoteAuthorityResolverError=I}),define(pe[63],ve([0,1,10]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===m.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function I(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=I;function D(P){return P.scheme!==m.Schemas.file&&P.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=D;function T(P){if(P.folders.length)return P.folders.every(R=>D(R.uri))?P.folders[0].uri:void 0;if(P.configuration&&D(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function k(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=k;function _(P){return T(P)!==void 0}e.isVirtualWorkspace=_}),define(pe[27],ve([0,1,8,4,63]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=D;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,p){if(typeof w=="undefined"||w===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof w=="string"||typeof p=="string"){let g=typeof w=="string"?w:w.value,E=typeof p=="string"?p:p.value;return m.equalsIgnoreCase(g,E)}return w._lower===p._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=_;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function R(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function C(l,w){if(w){const p=`onResolveRemoteAuthority:${(0,I.getRemoteName)(w)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[194],ve([0,1,8,27]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:(0,m.compareIgnoreCase)(p.id,g.id)===0}e.areSameExtensions=I;class D{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof D?I(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=D;function T(p,g){return`${p}.${g}`}e.getExtensionId=T;function k(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(p,g){return k(T(p,g))}e.getGalleryExtensionId=_;function P(p,g){const E=[],F=y=>{for(const u of E)if(u.some(r=>I(g(r),g(y))))return u;return null};for(const y of p){const u=F(y);u?u.push(y):E.push([y])}return E}e.groupByExtension=P;function R(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(p){const g=new Set;if(p.malicious)for(const E of p.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=l;function w(p,g){const E=[],F=g.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const y=F.shift();if(y&&E.every(u=>!I(u.identifier,{id:y}))){const u=p.filter(r=>I(r.identifier,{id:y}));u.length===1&&(E.push(u[0]),F.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=w}),define(pe[121],ve([0,1,3,12,4,11]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var T;(function(p){p.Http="http",p.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=C;function l(p,g){return g?g!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=l;let w=class{constructor(g){this.logService=g,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let F of E){const y=Array.from(F.values());for(let u of y){const r=await u.value;r&&g.push(r)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(F=>F?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,F,y,u=!1,r=k.Private,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${F} on local port ${y}.`),!g)return;E||(E="localhost");const o=this.retainOrCreateTunnel(g,E,F,y,u,r,f);return o?o.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(S);return(S.tunnelRemoteHost!==E||S.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const F=E.get(g.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,F))}}}}async tryDisposeTunnel(g,E,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const y=F.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),y}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const F=this._tunnels.get(g);if(F&&F.has(E)){const y=F.get(E);y.refcount=0,await this.tryDisposeTunnel(g,E,y)}}addTunnelToMap(g,E,F){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:F})}async removeEmptyTunnelFromMap(g,E){const F=this._tunnels.get(g);F&&(await F.get(E)||F.delete(E),F.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let F=[g];R(g)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):C(g)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const y=F.map(u=>this._tunnels.get(u));for(const u of y){const r=u?.get(E);if(r)return r}}canTunnel(g){return!!P(g)}createWithProvider(g,E,F,y,u,r,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${F} on local port ${y}.`);const S={elevationRequired:u?l(y===void 0?F:y):!1},s={remoteAddress:{host:E,port:F},localAddressPort:y,privacy:r,public:r!==k.Private,protocol:f},i=g.forwardPort(s,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,F,i),i}};w=je([ze(0,D.ILogService)],w),e.AbstractTunnelService=w}),define(pe[195],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((I,D)=>Z(["vsda"],I,D))}async createNewMessage(I){try{const D=await this.vsda(),T=new D.validator;if(T){const k=String(m._nextId++);return this.validators.set(k,T),{id:k,data:T.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,D){if(!I.id)return!0;const T=this.validators.get(I.id);if(!T)return!1;this.validators.delete(I.id);try{return T.validate(D)==="ok"}catch{return!1}}async sign(I){try{const D=await this.vsda(),T=new D.signer;if(T)return T.sign(I)}catch{}return I}}e.SignService=m,m._nextId=1}),define(pe[196],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,D,T=5){let k;return k=D(_=>{const P=typeof _=="string"?_:_.data;let R=this._terminalBufferMap.get(I);if(R){R.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(I),T);R={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,R)}),k}stopBuffering(I){const D=this._terminalBufferMap.get(I);D&&D.dispose()}flushBuffer(I){const D=this._terminalBufferMap.get(I);D&&(this._terminalBufferMap.delete(I),this._callback(I,D.data.join("")))}}e.TerminalDataBufferer=m}),define(pe[197],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(pe[85],ve([0,1,74,3,6,4,50,197]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var _;(function(E){function F(y){return y&&typeof y=="object"&&typeof y.id=="string"}E.isThemeColor=F})(_=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var R;(function(E){function F(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||_.isThemeColor(i.color))}E.isThemeIcon=F;const y=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const n=y.exec(i);if(!n)return;let[,c]=n;return{id:c}}E.fromString=u;function r(i){return{id:i}}E.fromId=r;function f(i,n){let c=i.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),n&&(c=`${c}~${n}`),{id:c}}E.modify=f;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}E.getModifier=o;function S(i,n){return i.id===n.id&&i.color?.id===n.color?.id}E.isEqual=S;function s(i,n){return{id:i.id,color:n?P(n):void 0}}E.asThemeIcon=s,E.asClassNameArray=m.CSSIcon.asClassNameArray,E.asClassName=m.CSSIcon.asClassName,E.asCSSSelector=m.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function C(E){switch(E){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,I.toDisposable)(()=>{const y=this.themingParticipants.indexOf(F);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new l;T.Registry.add(e.Extensions.ThemingContribution,w);function p(E){return w.onColorThemeChange(E)}e.registerThemingParticipant=p;class g extends I.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,y){let u=this.theme.getColor(F);return u&&y&&(u=y(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(pe[43],ve([0,1,24,23,2,4]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var T;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const w=l;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=k;function _(l){const w=l;return!!(w&&typeof w=="object"&&I.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=_;class P{constructor(w,p,g,E,F){this._id=w,this._transient=g,this._configuration=E,this._ignorePathCasing=F,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class R{constructor(w,p){this.raw=p,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,t.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(l){return new R({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(pe[198],ve([0,1,29,57,140,80,10,9,12,23,2,162,4,63,43]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(U){return(typeof U=="string"?(0,k.extname)(U):(0,P.extname)(U))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function F(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=F;function y(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=y;function u(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=u;function r(U){return U&&U.hasOwnProperty("folderUri")}e.isFolderBackupInfo=r;function f(U){return U&&U.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=f;function o(U){const B=U;return typeof B?.id=="string"&&R.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=o;function S(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=S;function s(U){const B=U;return typeof B?.id=="string"&&R.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=s;function i(U){const B=U;if(B?.uri)return{id:B.id,uri:R.URI.revive(B.uri)};const $=U;if($?.configPath)return{id:$.id,configPath:R.URI.revive($.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=i;function n(U,B){return P.extUriBiasedIgnorePathCase.isEqualOrParent(U,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function c(U){return a(U)||h(U)}e.isStoredWorkspaceFolder=c;function a(U){const B=U;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=a;function h(U){const B=U;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=h;function d(U,B,$,z,W=!_.isWindows,J){if(U.scheme!==z.scheme)return{name:$,uri:U.toString(!0)};let ne=B?void 0:J.relativePath(z,U);if(ne!==void 0)ne.length===0?ne=".":_.isWindows&&U.scheme===T.Schemas.file&&!W&&(ne=ne.replace(/\//g,"\\"));else if(U.scheme===T.Schemas.file)ne=U.fsPath,_.isWindows&&(ne=(0,D.normalizeDriveLetter)(ne),W&&(ne=(0,m.toSlashes)(ne)));else{if(!J.isEqualAuthority(U.authority,z.authority))return{name:$,uri:U.toString(!0)};ne=U.path}return{name:$,path:ne}}e.getStoredWorkspaceFolder=d;function v(U,B,$){let z=[],W=new Set;const J=$.dirname(B);for(let ne of U){let se;if(a(ne))ne.path&&(se=$.resolvePath(J,ne.path));else if(h(ne))try{se=R.URI.parse(ne.uri),se.path[0]!=="/"&&(se=se.with({path:"/"+se.path}))}catch(K){console.warn(K)}if(se){let K=$.getComparisonKey(se);if(!W.has(K)){W.add(K);const Q=ne.name||$.basenameOrAuthority(se);z.push(new p.WorkspaceFolder({uri:se,name:Q,index:z.length},ne))}}}return z}e.toWorkspaceFolders=v;function b(U,B,$,z,W){let J=A(B,U);const ne=W.dirname(B),se=W.dirname(z),K=[],Q=O(J.folders);for(const Me of J.folders){const xe=a(Me)?W.resolvePath(ne,Me.path):R.URI.parse(Me.uri);let Ge;$?Ge=!1:Ge=!a(Me)||(0,k.isAbsolute)(Me.path),K.push(d(xe,Ge,Me.name,se,Q,W))}const ae={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},fe=I.setProperty(U,["folders"],K,ae);let be=I.applyEdits(U,fe);return(0,P.isEqualAuthority)(J.remoteAuthority,(0,w.getRemoteAuthority)(z))&&(be=I.applyEdits(be,I.removeProperty(be,["remoteAuthority"],ae))),be}e.rewriteWorkspaceFileForNewLocation=b;function A(U,B){let $=t.parse(B);if($&&Array.isArray($.folders))$.folders=$.folders.filter(z=>c(z));else throw new Error(`${U} looks like an invalid workspace file.`);return $}function O(U){return _.isWindows?U.some(B=>a(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function N(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function L(U){return typeof U.folderUri=="string"}function M(U){return typeof U.fileUri=="string"}function V(U,B){const $={workspaces:[],files:[]};if(U){const z=function(J,ne){for(let se=0;se<J.length;se++)try{ne(J[se],se)}catch(K){B.warn(`Error restoring recent entry ${JSON.stringify(J[se])}: ${K.toString()}. Skip entry.`)}},W=U;if(Array.isArray(W.entries))z(W.entries,J=>{const ne=J.label,se=J.remoteAuthority;N(J)?$.workspaces.push({label:ne,remoteAuthority:se,workspace:{id:J.workspace.id,configPath:R.URI.parse(J.workspace.configPath)}}):L(J)?$.workspaces.push({label:ne,remoteAuthority:se,folderUri:R.URI.parse(J.folderUri)}):M(J)&&$.files.push({label:ne,remoteAuthority:se,fileUri:R.URI.parse(J.fileUri)})});else{const J=U;Array.isArray(J.workspaces3)&&z(J.workspaces3,(ne,se)=>{const K=Array.isArray(J.workspaceLabels)&&J.workspaceLabels[se]||void 0;typeof ne=="object"&&typeof ne.id=="string"&&typeof ne.configURIPath=="string"?$.workspaces.push({label:K,workspace:{id:ne.id,configPath:R.URI.parse(ne.configURIPath)}}):typeof ne=="string"&&$.workspaces.push({label:K,folderUri:R.URI.parse(ne)})}),Array.isArray(J.files2)&&z(J.files2,(ne,se)=>{const K=Array.isArray(J.fileLabels)&&J.fileLabels[se]||void 0;typeof ne=="string"&&$.files.push({label:K,fileUri:R.URI.parse(ne)})})}}return $}e.restoreRecentlyOpened=V;function H(U){const B={entries:[]};for(const $ of U.workspaces)y($)?B.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):B.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of U.files)B.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return B}e.toStoreData=H}),define(pe[86],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const D=this._idPool++;return this._data.set(D,I),this.logDebugInfo(),D}get(I,D){return this._data.has(I)?this._data.get(I)[D]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(pe[199],ve([0,1,13]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(T,k,_){this._deferredPromises=new Map,this._id=T,this._shared=k,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const C of P.values())C.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,k){let _=this._value[T];return typeof _=="undefined"&&(_=k),_}update(T,k){this._value[T]=k;let _=this._deferredPromises.get(T);if(_!==void 0)return _.p;const P=new m.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(T,k){super(T.identifier.value,!0,k);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=I}),define(pe[200],ve([0,1,3,2,11]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(_.value,P)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));P.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};D=je([ze(0,I.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(pe[14],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class t{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[201],ve([0,1,27,3]),function(Z,e,m,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(k,_){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),nt(this,I,_,"f"),Le(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Le(this,I,"f").get(this._id,k)}store(k,_){return Le(this,I,"f").store(this._id,k,_)}delete(k){return Le(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=D,I=new WeakMap}),define(pe[122],ve([0,1,4,3]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(pe[64],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(y,u)=>{const r={controllerId:u};return t.set(y,r),r};e.createPrivateApiFor=I;const D=y=>t.get(y);e.getPrivateApiFor=D;const T=(y,u,r,f)=>{let o=r;return{enumerable:!0,configurable:!1,get(){return o},set(S){if(!f(o,S)){const s=o;o=S,y.listener?.({op:3,key:u,value:S,previous:s})}}}},k=(y,u)=>y===u,_={range:(y,u)=>y===u?!0:!y||!u?!1:y.isEqual(u),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(y,u)=>!(y.length!==u.length||y.some(r=>!u.find(f=>r.id===f.id)))},P=Object.keys(_),R=(y,u)=>({range:T(y,"range",void 0,_.range),label:T(y,"label",u,_.label),description:T(y,"description",void 0,_.description),canResolveChildren:T(y,"canResolveChildren",!1,_.canResolveChildren),busy:T(y,"busy",!1,_.busy),error:T(y,"error",void 0,_.error),tags:T(y,"tags",[],_.tags)}),C=(y,u)=>{const r=new Map;for(const f of P)_[f](y[f],u[f])||r.set(f,u[f]);return r};e.diffTestItems=C;class l extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=l;class w extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class p extends Error{constructor(u,r,f){super(`TestItem with ID "${u}" is from controller "${r}" and cannot be added as a child of an item from controller "${f}".`)}}e.MixedTestItemController=p;const g=y=>{const u=(0,e.getPrivateApiFor)(y);let r=new Map;return{get size(){return r.size},forEach(f,o){for(const S of r.values())f.call(o,S,this)},replace(f){const o=new Map,S=new Set(r.keys()),s={op:4,ops:[]};for(const i of f){if(!(i instanceof E))throw new w(i.id);const n=(0,e.getPrivateApiFor)(i).controllerId;if(n!==u.controllerId)throw new p(i.id,n,u.controllerId);if(o.has(i.id))throw new l(i.id);o.set(i.id,i),S.delete(i.id),s.ops.push({op:0,item:i})}for(const i of S.keys())s.ops.push({op:1,id:i});u.listener?.(s),r=o},add(f){if(!(f instanceof E))throw new w(f.id);r.set(f.id,f),u.listener?.({op:0,item:f})},delete(f){r.delete(f)&&u.listener?.({op:1,id:f})},get(f){return r.get(f)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class E{constructor(u,r,f,o){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const S=(0,e.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof F?void 0:S.parent}},children:{value:g(this),enumerable:!0,writable:!1},...R(S,f)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class F extends E{constructor(u,r){super(u,u,r,void 0)}}e.TestItemRootImpl=F}),define(pe[51],ve([0,1,4,121,3,14]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(_){function P(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}_.fromApiTunnel=P;function R(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}_.fromServiceTunnel=R})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,C,l,w){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([ze(0,D.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[7],ve([0,1,17,16,99,24,95,8,18,2,33,42,120]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";var w,p,g,E,F,y,u,r,f,o,S,s,i,n,c,a,h,d,v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function x(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(x,j),Object.setPrototypeOf(x.prototype,j.prototype),x}let O=F=class{constructor(x){w.set(this,void 0),nt(this,w,x,"f")}static from(...x){let ue=x;return new F(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Le(this,w,"f")=="function"&&(Le(this,w,"f").call(this),nt(this,w,void 0,"f"))}};w=new WeakMap,O=F=je([A],O),e.Disposable=O;let N=y=class{constructor(x,ue){if(x<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=x,this._character=ue}static Min(...x){if(x.length===0)throw new TypeError;let ue=x[0];for(let Pe=1;Pe<x.length;Pe++){const et=x[Pe];et.isBefore(ue)&&(ue=et)}return ue}static Max(...x){if(x.length===0)throw new TypeError;let ue=x[0];for(let Pe=1;Pe<x.length;Pe++){const et=x[Pe];et.isAfter(ue)&&(ue=et)}return ue}static isPosition(x){if(!x)return!1;if(x instanceof y)return!0;let{line:ue,character:Pe}=x;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,ue=0){if(x===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof x=="undefined"?Pe=0:typeof x=="number"?Pe=x:(Pe=typeof x.lineDelta=="number"?x.lineDelta:0,ue=typeof x.characterDelta=="number"?x.characterDelta:0),Pe===0&&ue===0?this:new y(this.line+Pe,this.character+ue)}with(x,ue=this.character){if(x===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof x=="undefined"?Pe=this.line:typeof x=="number"?Pe=x:(Pe=typeof x.line=="number"?x.line:this.line,ue=typeof x.character=="number"?x.character:this.character),Pe===this.line&&ue===this.character?this:new y(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};N=y=je([A],N),e.Position=N;let L=u=class{constructor(x,ue,Pe,et){let at,dt;if(typeof x=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new N(x,ue),dt=new N(Pe,et)):x instanceof N&&ue instanceof N&&(at=x,dt=ue),!at||!dt)throw new Error("Invalid arguments");at.isBefore(dt)?(this._start=at,this._end=dt):(this._start=dt,this._end=at)}static isRange(x){return x instanceof u?!0:x?N.isPosition(x.start)&&N.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof u?this.contains(x._start)&&this.contains(x._end):x instanceof N?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const ue=N.Max(x.start,this._start),Pe=N.Min(x.end,this._end);if(!ue.isAfter(Pe))return new u(ue,Pe)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const ue=N.Min(x.start,this._start),Pe=N.Max(x.end,this.end);return new u(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,ue=this.end){if(x===null||ue===null)throw(0,t.illegalArgument)();let Pe;return x?N.isPosition(x)?Pe=x:(Pe=x.start||this.start,ue=x.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new u(Pe,ue)}toJSON(){return[this.start,this.end]}};L=u=je([A],L),e.Range=L;let M=r=class extends L{constructor(x,ue,Pe,et){let at,dt;if(typeof x=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new N(x,ue),dt=new N(Pe,et)):x instanceof N&&ue instanceof N&&(at=x,dt=ue),!at||!dt)throw new Error("Invalid arguments");super(at,dt);this._anchor=at,this._active=dt}static isSelection(x){return x instanceof r?!0:x?L.isRange(x)&&N.isPosition(x.anchor)&&N.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=r=je([A],M),e.Selection=M;class V{constructor(x,ue,Pe){if(typeof x!="string"||x.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=V;class H extends Error{constructor(x,ue=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(x);this._message=x,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(x,ue){return new H(x,l.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(x){return new H(x,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var U;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var B;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=f=class{constructor(x,ue){this._range=x,this._newText=ue}static isTextEdit(x){return x instanceof f?!0:x?L.isRange(x)&&typeof x.newText=="string":!1}static replace(x,ue){return new f(x,ue)}static insert(x,ue){return f.replace(new L(x,x),ue)}static delete(x){return f.replace(x,"")}static setEndOfLine(x){const ue=new f(new L(new N(0,0),new N(0,0)),"");return ue.newEol=x,ue}get range(){return this._range}set range(x){if(x&&!L.isRange(x))throw(0,t.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,t.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,t.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=f=je([A],$),e.TextEdit=$;var z;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,ue,Pe,et){this._edits.push({_type:1,from:x,to:ue,options:Pe,metadata:et})}createFile(x,ue,Pe){this._edits.push({_type:1,from:void 0,to:x,options:ue,metadata:Pe})}deleteFile(x,ue,Pe){this._edits.push({_type:1,from:x,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata(x,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:x,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(x,ue,Pe,et,at){let dt,mt,At=[],Lt;if(Ht.isNotebookRange(ue)&&Bt.isNotebookCellDataArray(Pe)&&!Bt.isNotebookCellDataArray(et)?(dt=ue.start,mt=ue.end,At=Pe,Lt=et):typeof ue=="number"&&typeof Pe=="number"&&Bt.isNotebookCellDataArray(et)&&(dt=ue,mt=Pe,At=et,Lt=at),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||At.length>0)&&this._edits.push({_type:5,uri:x,index:dt,count:mt-dt,cells:At,metadata:Lt})}replaceNotebookCellMetadata(x,ue,Pe,et){this._edits.push({_type:3,metadata:et,uri:x,edit:{editType:8,index:ue,metadata:Pe}})}replace(x,ue,Pe,et){this._edits.push({_type:2,uri:x,edit:new $(ue,Pe),metadata:et})}insert(x,ue,Pe,et){this.replace(x,new L(ue,ue),Pe,et)}delete(x,ue,Pe){this.replace(x,ue,"",Pe)}has(x){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===x.toString())}set(x,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:x,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const et=this._edits[Pe];et._type===2&&et.uri.toString()===x.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(x){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===x.toString()&&ue.push(Pe.edit);return ue}entries(){const x=new D.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=x.get(ue.uri);Pe||(Pe=[ue.uri,[]],x.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=je([A],W),e.WorkspaceEdit=W;let J=o=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof o?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=o._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,ue=this._tabstop++){if(typeof x=="function"){const Pe=new o;Pe._tabstop=this._tabstop,x(Pe),this._tabstop=Pe._tabstop,x=Pe.value}else x=o._escape(x);return this.value+="${",this.value+=ue,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,ue=this._tabstop++){const Pe=x.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(x,ue){if(typeof ue=="function"){const Pe=new o;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};J=o=je([A],J),e.SnippetString=J;var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=S=class{constructor(x,ue){if(this.uri=x,ue)if(ue instanceof L)this.range=ue;else if(ue instanceof N)this.range=new L(ue,ue);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof S?!0:x?L.isRange(x.range)&&P.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=S=je([A],K),e.Location=K;let Q=class{constructor(x,ue){this.location=x,this.message=ue}static is(x){return x?typeof x.message=="string"&&x.location&&L.isRange(x.location.range)&&P.URI.isUri(x.location.uri):!1}static isEqual(x,ue){return x===ue?!0:!x||!ue?!1:x.message===ue.message&&x.location.range.isEqual(ue.location.range)&&x.location.uri.toString()===ue.location.uri.toString()}};Q=je([A],Q),e.DiagnosticRelatedInformation=Q;let ae=class{constructor(x,ue,Pe=se.Error){if(!L.isRange(x))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=x,this.message=ue,this.severity=Pe}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,ue){return x===ue?!0:!x||!ue?!1:x.message===ue.message&&x.severity===ue.severity&&x.code===ue.code&&x.severity===ue.severity&&x.source===ue.source&&x.range.isEqual(ue.range)&&(0,m.equals)(x.tags,ue.tags)&&(0,m.equals)(x.relatedInformation,ue.relatedInformation,Q.isEqual)}};ae=je([A],ae),e.Diagnostic=ae;let fe=class{constructor(x,ue){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=ue}};fe=je([A],fe),e.Hover=fe;var be;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(x,ue=be.Text){this.range=x,this.kind=ue}toJSON(){return{range:this.range,kind:be[this.kind]}}};Me=je([A],Me),e.DocumentHighlight=Me;var xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(j){j[j.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Je=s=class{constructor(x,ue,Pe,et,at){this.name=x,this.kind=ue,this.containerName=at,typeof Pe=="string"&&(this.containerName=Pe),et instanceof K?this.location=et:Pe instanceof L&&(this.location=new K(et,Pe)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};Je=s=je([A],Je),e.SymbolInformation=Je;let q=i=class{constructor(x,ue,Pe,et,at){this.name=x,this.detail=ue,this.kind=Pe,this.range=et,this.selectionRange=at,this.children=[],i.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(i.validate)}};q=i=je([A],q),e.DocumentSymbol=q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(x,ue){this.title=x,this.kind=ue}};G=je([A],G),e.CodeAction=G;let X=n=class{constructor(x){this.value=x}append(x){return new n(this.value?this.value+n.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+n.sep)}};X.sep=".",X=n=je([A],X),e.CodeActionKind=X,X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll");let oe=class{constructor(x,ue){if(this.range=x,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=je([A],oe),e.SelectionRange=oe;class me{constructor(x,ue,Pe,et,at,dt){this.kind=x,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.CallHierarchyItem=me;class Ie{constructor(x,ue){this.fromRanges=ue,this.from=x}}e.CallHierarchyIncomingCall=Ie;class We{constructor(x,ue){this.fromRanges=ue,this.to=x}}e.CallHierarchyOutgoingCall=We;var Ye;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(x,ue){this.range=x,this.command=ue}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let st=c=class{constructor(x,ue=!1){p.set(this,void 0),nt(this,p,new I.MarkdownString(x,{supportThemeIcons:ue}),"f")}static isMarkdownString(x){return x instanceof c?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Le(this,p,"f").value}set value(x){Le(this,p,"f").value=x}get isTrusted(){return Le(this,p,"f").isTrusted}set isTrusted(x){Le(this,p,"f").isTrusted=x}get supportThemeIcons(){return Le(this,p,"f").supportThemeIcons}set supportThemeIcons(x){Le(this,p,"f").supportThemeIcons=x}get supportHtml(){return Le(this,p,"f").supportHtml}set supportHtml(x){Le(this,p,"f").supportHtml=x}appendText(x){return Le(this,p,"f").appendText(x),this}appendMarkdown(x){return Le(this,p,"f").appendMarkdown(x),this}appendCodeblock(x,ue){return Le(this,p,"f").appendCodeblock(ue??"",x),this}};p=new WeakMap,st=c=je([A],st),e.MarkdownString=st;let ot=class{constructor(x,ue){this.label=x,this.documentation=ue}};ot=je([A],ot),e.ParameterInformation=ot;let tt=class{constructor(x,ue){this.label=x,this.documentation=ue,this.parameters=[]}};tt=je([A],tt),e.SignatureInformation=tt;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=je([A],rt),e.SignatureHelp=rt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let It=class{constructor(x){this.label=x}toString(){return this.label}};It=je([A],It),e.InlayHintLabelPart=It;let ee=class{constructor(x,ue,Pe){this.label=x,this.position=ue,this.kind=Pe}};ee=je([A],ee),e.InlayHint=ee;var ie;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(j){j[j.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(x,ue){this.label=x,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([A],ye),e.CompletionItem=ye;let Fe=class{constructor(x=[],ue=!1){this.items=x,this.isIncomplete=ue}};Fe=je([A],Fe),e.CompletionList=Fe;let qe=class{constructor(x,ue,Pe){this.text=x,this.range=ue,this.command=Pe}};qe=je([A],qe),e.InlineSuggestion=qe;let Ve=class{constructor(x){this.items=x}};Ve=je([A],Ve),e.InlineSuggestions=Ve;var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var Re;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var we;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(we=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ce;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function x(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=x}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(x,ue){if(ue&&!P.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!L.isRange(x)||x.isEmpty)throw(0,t.illegalArgument)("range");this.range=x,this.target=ue}};Oe=je([A],Oe),e.DocumentLink=Oe;let Ke=class{constructor(x,ue,Pe,et){this.red=x,this.green=ue,this.blue=Pe,this.alpha=et}};Ke=je([A],Ke),e.Color=Ke;let $e=class{constructor(x,ue){if(ue&&!(ue instanceof Ke))throw(0,t.illegalArgument)("color");if(!L.isRange(x)||x.isEmpty)throw(0,t.illegalArgument)("range");this.range=x,this.color=ue}};$e=je([A],$e),e.ColorInformation=$e;let Ze=class{constructor(x){if(!x||typeof x!="string")throw(0,t.illegalArgument)("label");this.label=x}};Ze=je([A],Ze),e.ColorPresentation=Ze;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class He{constructor(x,ue,Pe){if(this.startIndex=x,this.length=ue,this.tooltip=Pe,typeof x!="number"||x<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=He;var Ee;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(x){this.options=x,typeof x!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=a=class{constructor(x,ue){if(this.label=ue,typeof x!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};ke.Clean=new a("clean","Clean"),ke.Build=new a("build","Build"),ke.Rebuild=new a("rebuild","Rebuild"),ke.Test=new a("test","Test"),ke=a=je([A],ke),e.TaskGroup=ke;function Ne(j){let x="";for(let ue=0;ue<j.length;ue++)x+=j[ue].replace(/,/g,",,")+",";return x}let Xe=class{constructor(x,ue,Pe){if(typeof x!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=x,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,t.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)x.push(ue);return Ne(x)}};Xe=je([A],Xe),e.ProcessExecution=Xe;let Qe=class{constructor(x,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!x)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,t.illegalArgument)("command");this._command=x,this._args=ue,this._options=Pe}else{if(typeof x!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=x,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,t.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)x.push(typeof ue=="string"?ue:ue.value);return Ne(x)}};Qe=je([A],Qe),e.ShellExecution=Qe;var pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class yt{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=yt;let ft=h=class{constructor(x,ue,Pe,et,at,dt){this.__deprecated=!1,this._definition=this.definition=x;let mt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=et,mt=at,this.__deprecated=!0):ue===St.Global||ue===St.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const ue=this._definition.type;(h.EmptyType===ue||h.ProcessType===ue||h.ShellType===ue||h.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=h=je([A],ft),e.Task=ft;var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(x,ue=Ut.None){this.collapsibleState=ue,P.URI.isUri(x)?this.resourceUri=x:this.label=x}};bt=je([A],bt),e.TreeItem=bt;var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(x){this._value=x}async asString(){return JSON.stringify(this._value)}};Pt=je([A],Pt),e.TreeDataTransferItem=Pt;let Ft=class{constructor(){this._items=new Map}get(x){return this._items.get(x)}set(x,ue){this._items.set(x,ue)}forEach(x){this._items.forEach(x)}};Ft=je([A],Ft),e.TreeDataTransfer=Ft;let kt=class{constructor(x,ue){this.id=x,this.color=ue}};kt=je([A],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Ct=class{constructor(x){this.id=x}};Ct=je([A],Ct),e.ThemeColor=Ct;var Qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(x,ue){if(typeof x!="string"&&(!x||!P.URI.isUri(x)&&!P.URI.isUri(x.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof x=="string"?this.baseUri=P.URI.file(x):P.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=ue}get base(){return this._base}set base(x){this._base=x,this._baseUri=P.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=je([A],Vt),e.RelativePattern=Vt;let Et=class{constructor(x,ue,Pe,et){this.enabled=typeof x=="boolean"?x:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Et=je([A],Et),e.Breakpoint=Et;let Xt=class extends Et{constructor(x,ue,Pe,et,at){super(ue,Pe,et,at);if(x===null)throw(0,t.illegalArgument)("location");this.location=x}};Xt=je([A],Xt),e.SourceBreakpoint=Xt;let qt=class extends Et{constructor(x,ue,Pe,et,at){super(ue,Pe,et,at);this.functionName=x}};qt=je([A],qt),e.FunctionBreakpoint=qt;let Yt=class extends Et{constructor(x,ue,Pe,et,at,dt,mt){super(et,at,dt,mt);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=x,this.dataId=ue,this.canPersist=Pe}};Yt=je([A],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(x,ue,Pe){this.command=x,this.args=ue||[],this.options=Pe}};ai=je([A],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(x,ue){this.port=x,this.host=ue}};Rt=je([A],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(x){this.path=x}};Jt=je([A],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(x){this.implementation=x}};li=je([A],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(x,ue){this.range=x,this.expression=ue}};jt=je([A],jt),e.EvaluatableExpression=jt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vt=class{constructor(x,ue){this.range=x,this.text=ue}};vt=je([A],vt),e.InlineValueText=vt;let ci=class{constructor(x,ue,Pe=!0){this.range=x,this.variableName=ue,this.caseSensitiveLookup=Pe}};ci=je([A],ci),e.InlineValueVariableLookup=ci;let Ot=class{constructor(x,ue){this.range=x,this.expression=ue}};Ot=je([A],Ot),e.InlineValueEvaluatableExpression=Ot;let $t=class{constructor(x,ue){this.frameId=x,this.stoppedLocation=ue}};$t=je([A],$t),e.InlineValueContext=$t;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=d=class extends Error{constructor(x,ue=C.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri(x)?x.toString(!0):x);this.code=Pe?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(x){return new d(x,C.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(x){return new d(x,C.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(x){return new d(x,C.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(x){return new d(x,C.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(x){return new d(x,C.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(x){return new d(x,C.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};ui=d=je([A],ui),e.FileSystemError=ui;let ei=class{constructor(x,ue,Pe){this.start=x,this.end=ue,this.kind=Pe}};ei=je([A],ei),e.FoldingRange=ei;var Ci;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(x,ue=[]){this.tokenTypes=x,this.tokenModifiers=ue}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,_.isStringArray)(j)}class Gt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let ue=0,Pe=x.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set(x.tokenTypes[ue],ue);for(let ue=0,Pe=x.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set(x.tokenModifiers[ue],ue)}}push(x,ue,Pe,et,at){if(typeof x=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded(x,ue,Pe,et,at);if(L.isRange(x)&&typeof ue=="string"&&di(Pe))return this._push(x,ue,Pe);throw(0,t.illegalArgument)()}_push(x,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const et=x.start.line,at=x.start.character,dt=x.end.character-x.start.character,mt=this._tokenTypeStrToInt.get(ue);let At=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Lt);At|=1<<Nt>>>0}this._pushEncoded(et,at,dt,mt,At)}_pushEncoded(x,ue,Pe,et,at){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,Nt=0;for(let Wt=0;Wt<At;Wt++){let zt=this._data[5*Wt],gi=this._data[5*Wt+1];zt===0?(zt=Lt,gi+=Nt):zt+=Lt,this._data[5*Wt]=zt,this._data[5*Wt+1]=gi,Lt=zt,Nt=gi}}let dt=x,mt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=at,this._prevLine=x,this._prevChar=ue}static _sortAndDeltaEncode(x){let ue=[];const Pe=x.length/5|0;for(let mt=0;mt<Pe;mt++)ue[mt]=mt;ue.sort((mt,At)=>{const Lt=x[5*mt],Nt=x[5*At];if(Lt===Nt){const Wt=x[5*mt+1],zt=x[5*At+1];return Wt-zt}return Lt-Nt});const et=new Uint32Array(x.length);let at=0,dt=0;for(let mt=0;mt<Pe;mt++){const At=5*ue[mt],Lt=x[At+0],Nt=x[At+1],Wt=x[At+2],zt=x[At+3],gi=x[At+4],xi=Lt-at,Ji=xi===0?Nt-dt:Nt,pi=5*mt;et[pi+0]=xi,et[pi+1]=Ji,et[pi+2]=Wt,et[pi+3]=zt,et[pi+4]=gi,at=Lt,dt=Nt}return et}build(x){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),x):new hi(Gt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Gt;class hi{constructor(x,ue){this.resultId=ue,this.data=x}}e.SemanticTokens=hi;class ki{constructor(x,ue,Pe){this.start=x,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=ki;class Kt{constructor(x,ue){this.resultId=ue,this.edits=x}}e.SemanticTokensEdits=Kt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([A],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=1]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(x,ue,Pe){this.badge=x,this.tooltip=ue,this.color=Pe}static validate(x){if(x.badge){let ue=(0,k.nextCharLength)(x.badge,0);if(ue<x.badge.length&&(ue+=(0,k.nextCharLength)(x.badge,ue)),x.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(x){this.kind=x}};ni=je([A],ni),e.ColorTheme=ni;var Be;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Be=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(x,ue){if(x<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");x<=ue?(this._start=x,this._end=ue):(this._start=ue,this._end=x)}static isNotebookRange(x){return x instanceof Ht?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let ue=this._start,Pe=this._end;return x.start!==void 0&&(ue=x.start),x.end!==void 0&&(Pe=x.end),ue===this._start&&Pe===this._end?this:new Ht(ue,Pe)}}e.NotebookRange=Ht;class Bt{constructor(x,ue,Pe,et,at,dt,mt){this.kind=x,this.value=ue,this.languageId=Pe,this.mime=et,this.outputs=at??[],this.metadata=dt,this.executionSummary=mt,Bt.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(ue=>Bt.isNotebookCellData(ue))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Bt;class _t{constructor(x){this.cells=x}}e.NotebookData=_t;class Mt{constructor(x,ue){this.data=x,this.mime=ue;const Pe=(0,T.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(x){return x instanceof Mt?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const ue={name:x.name,message:x.message,stack:x.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout(x){return Mt.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Mt.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,ue="application/octet-stream"){return new Mt(x,ue)}static text(x,ue=T.Mimes.text){const Pe=Le(Mt,g,"f",E).encode(String(x));return new Mt(Pe,ue)}static json(x,ue="application/json"){const Pe=JSON.stringify(x,void 0,"	");return Mt.text(Pe,ue)}}e.NotebookCellOutputItem=Mt,g=Mt,E={value:new TextEncoder};class ri{constructor(x,ue,Pe){this.items=ri.ensureUniqueMimeTypes(x,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput(x){return x instanceof ri?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&(0,_.isArray)(x.items)}static ensureUniqueMimeTypes(x,ue=!1){const Pe=new Set,et=new Set;for(let at=0;at<x.length;at++){const dt=x[at],mt=(0,T.normalizeMimeType)(dt.mime);if(!Pe.has(mt)){Pe.add(mt);continue}et.add(at),ue&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?x:x.filter((at,dt)=>!et.has(dt))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(x,ue){this.text=x,this.alignment=ue}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(x,ue=[]){this.uri=x,this.provides=(0,m.asArray)(ue)}}e.NotebookRendererScript=_i;let mi=class{constructor(x,ue){this.label=x,this.timestamp=ue}};mi=je([A],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(x,ue){this.ranges=x,this.wordPattern=ue}}e.LinkedEditingRanges=Ui;class le{constructor(x,ue){this._port=x,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Te;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor(x=void 0,ue=void 0,Pe=void 0){this.include=x,this.exclude=ue,this.profile=Pe}};ht=je([A],ht),e.TestRunRequest=ht;let Dt=v=class{constructor(x){this.message=x}static diff(x,ue,Pe){const et=new v(x);return et.expectedOutput=ue,et.actualOutput=Pe,et}};Dt=v=je([A],Dt),e.TestMessage=Dt;let Tt=class{constructor(x){this.id=x}};Tt=je([A],Tt),e.TestTag=Tt;let si=class{constructor(x,ue){this.covered=x,this.total=ue}};si=je([A],si),e.CoveredCount=si;let Bi=b=class{constructor(x,ue,Pe,et){this.uri=x,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=et}static fromDetails(x,ue){const Pe=new si(0,0),et=new si(0,0),at=new si(0,0);for(const mt of ue)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const At of mt.branches)et.total+=1,et.covered+=At.executionCount>0?1:0}else at.total+=1,at.covered+=mt.executionCount>0?1:0;const dt=new b(x,Pe,et.total>0?et:void 0,at.total>0?at:void 0);return dt.detailedCoverage=ue,dt}};Bi=b=je([A],Bi),e.FileCoverage=Bi;let Wi=class{constructor(x,ue,Pe=[]){this.executionCount=x,this.location=ue,this.branches=Pe}};Wi=je([A],Wi),e.StatementCoverage=Wi;let $i=class{constructor(x,ue){this.executionCount=x,this.location=ue}};$i=je([A],$i),e.BranchCoverage=$i;let Hi=class{constructor(x,ue){this.executionCount=x,this.location=ue}};Hi=je([A],Hi),e.FunctionCoverage=Hi;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(x,ue,Pe,et,at,dt){this.kind=x,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.TypeHierarchyItem=Yi}),define(pe[123],ve([0,1,55,10,8,150,110,7,17]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(p,g){g?P.set(p,g):P.delete(p)}e.setWordDefinitionFor=R;function C(p){return P.get(p)}e.getWordDefinitionFor=C;class l extends D.MirrorTextModel{constructor(g,E,F,y,u,r,f,o){super(E,F,y,u);this._proxy=g,this._languageId=r,this._isDirty=f,this._notebook=o,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,_.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(E){return E?g._getTextInRange(E):g.getText()},get eol(){return g._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(E){return g._lineAt(E)},offsetAt(E){return g._offsetAt(E)},positionAt(E){return g._positionAt(E)},validateRange(E){return g._validateRange(E)},validatePosition(E){return g._validatePosition(E)},getWordRangeAtPosition(E,F){return g._getWordRangeAtPosition(E,F)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,m.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,m.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const E=this._validateRange(g);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const F=this._eol,y=E.start.line,u=E.end.line,r=[];r.push(this._lines[y].substring(E.start.character));for(let f=y+1;f<u;f++)r.push(this._lines[f]);return r.push(this._lines[u].substring(0,E.end.character)),r.join(F)}_lineAt(g){let E;if(g instanceof k.Position?E=g.line:typeof g=="number"&&(E=g),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new w(E,this._lines[E],E===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(g),F=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,F))}_validateRange(g){if(!(g instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(g.start),F=this._validatePosition(g.end);return E===g.start&&F===g.end?g:new k.Range(E.line,E.character,F.line,F.character)}_validatePosition(g){if(!(g instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:E,character:F}=g,y=!1;if(E<0)E=0,F=0,y=!0;else if(E>=this._lines.length)E=this._lines.length-1,F=this._lines[E].length,y=!0;else{const u=this._lines[E].length;F<0?(F=0,y=!0):F>u&&(F=u,y=!0)}return y?new k.Position(E,F):g}_getWordRangeAtPosition(g,E){const F=this._validatePosition(g);if(!E)E=C(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const y=(0,T.getWordAtText)(F.character+1,(0,T.ensureValidWordDefinition)(E),this._lines[F.line],0);if(y)return new k.Range(F.line,y.startColumn-1,F.line,y.endColumn-1)}}e.ExtHostDocumentData=l;class w{constructor(g,E,F){this._line=g,this._text=E,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(pe[202],ve([0,1,7,3,112,6,82,24,2,33]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(l,w,p,g){this._notebook=p,this._selector=g,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(w.onDidChangeDocument(F=>{const y=this._cellUris.get(F.document.uri);y!==void 0&&(this._cellLengths.setValue(y,this._cells[y].document.getText().length+1),this._cellLines.setValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(F=>E(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],w=[];for(const p of this._notebook.getCells())p.kind===m.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),l.push(p.document.getText().length+1),w.push(p.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(w))}get version(){return this._versionId}getText(l){if(!l){let y="";for(const u of this._cells)y+=u.document.getText()+`
`;return y=y.slice(0,-1),y}if(l.isEmpty)return"";const w=this.locationAt(l.start),p=this.locationAt(l.end),g=this._cellUris.get(w.uri),E=this._cellUris.get(p.uri);if(g===void 0||E===void 0)return"";if(g===E)return this._cells[g].document.getText(new m.Range(w.range.start,p.range.end));const F=[this._cells[g].document.getText(new m.Range(w.range.start,new m.Position(this._cells[g].document.lineCount,0)))];for(let y=g+1;y<E;y++)F.push(this._cells[y].document.getText());return F.push(this._cells[E].document.getText(new m.Range(new m.Position(0,0),p.range.end))),F.join(`
`)}offsetAt(l){const w=this._cellLines.getIndexOf(l.line),p=this._cellLengths.getPrefixSum(w.index-1),g=this._cells[w.index].document.offsetAt(l.with(w.remainder));return p+g}positionAt(l){if(typeof l=="number"){const p=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(g)}const w=this._cellUris.get(l.uri);if(w!==void 0){const p=this._cellLines.getPrefixSum(w-1);return new m.Position(p+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const w=this._cellLines.getIndexOf(l.start.line);let p=w;l.isEmpty||(p=this._cellLines.getIndexOf(l.end.line));const g=new m.Position(w.remainder,l.start.character),E=new m.Position(p.remainder,l.end.character),F=new m.Range(g,E),y=this._cells[w.index];return new m.Location(y.document.uri,y.document.validateRange(F))}contains(l){return this._cellUris.has(l)}validateRange(l){const w=this.validatePosition(l.start),p=this.validatePosition(l.end);return l.with(w,p)}validatePosition(l){const w=this._cellLines.getIndexOf(l.line),p=new m.Position(w.remainder,l.character),g=this._cells[w.index].document.validatePosition(p),E=this._cellLines.getPrefixSum(w.index-1);return new m.Position(E+g.line,g.character)}}e.ExtHostNotebookConcatDocument=R}),define(pe[203],ve([0,1,7,14,3]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=je([ze(0,t.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(pe[65],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class t{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=t}),define(pe[204],ve([0,1,22]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(_){let P=this.buffers.indexOf(_);return P<0&&(P=this.buffers.length,this.buffers.push(_)),P}}function I(k,_){if(_.serializeBuffersForPostMessage){const P=new t,R=(w,p)=>{if(p instanceof ArrayBuffer){const g=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(p)){const g=D(p);if(g){const E=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},C=JSON.stringify(k,R),l=P.buffers.map(w=>{const p=new Uint8Array(w);return m.VSBuffer.wrap(p)});return{message:C,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function D(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(k,_){const P=_.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),R=_.length?(l,w)=>{if(typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const p=w,{index:g}=p,E=P[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(E,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return w}:void 0;return{message:JSON.parse(k,R),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(pe[205],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(t){function I(T){const k=new Map;return T.types.forEach((_,P)=>{k.set(_,{asString:async()=>T.items[P].asString})}),k}t.toITreeDataTransfer=I;async function D(T){const k={types:[],items:[]},_=Array.from(T.entries());for(const P of _)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}t.toTreeDataTransferDTO=D})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[87],ve([0,1,10,2]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,_){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===m.Schemas.file&&(k=t.URI.from({scheme:m.Schemas.vscodeRemote,authority:_.authority,path:k.path})),t.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${D(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function D(k){return k.replace(/./g,_=>{const P=_.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?_:"-"+P.toString(16).padStart(4,"0")})}function T(k){return k.replace(/-([0-9a-f]{4})/g,(_,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(pe[206],ve([0,1,3,6,87]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(k,_,P){this._proxy=k,this._editors=_,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const R=_.getVisibleTextEditors();for(const C of this._insets.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,P,R,C){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===k){l=u;break}if(!l)throw new Error("not a visible editor");const w=this,p=this._handlePool++,g=new m.Emitter,E=new m.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,I.asWebviewUri)(u,w._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(u){this._options=u,w._proxy.$setOptions(p,u)}get options(){return this._options}set html(u){this._html=u,w._proxy.$setHtml(p,u)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(u){return w._proxy.$postMessage(p,u)}},y=new class{constructor(){this.editor=k,this.line=_,this.height=P,this.webview=F,this.onDidDispose=E.event}dispose(){w._insets.has(p)&&(w._insets.delete(p),w._proxy.$disposeEditorInset(p),E.fire(),E.dispose(),g.dispose())}};return this._proxy.$createEditorInset(p,l.id,l.value.document.uri,_+1,P,R||{},C.identifier,C.extensionLocation),this._insets.set(p,{editor:k,inset:y,onDidReceiveMessage:g}),y}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=D}),define(pe[207],ve([0,1,172,18,2,6,4,62,50,42,17,10]),function(Z,e,m,t,I,D,T,k,_,P,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.EditorTabsVisibleContext=new k.RawContextKey("editorTabsVisible",!0,(0,m.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(L,M,V){for(const H of V.visibleEditorPanes)if(H.group.id===M&&L.matches(H.input))return H.getViewState()}e.findViewStateForEditor=l;function w(L){if(f(L))return!1;const M=L;return I.URI.isUri(M?.resource)}e.isResourceEditorInput=w;function p(L){if(f(L))return!1;const M=L;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=p;function g(L){if(f(L)||p(L))return!1;const M=L;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function E(L){if(f(L))return!1;const M=L;return M?M.resource===void 0||M.resource.scheme===C.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var F;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var y;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));var u;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends D.Disposable{}e.AbstractEditorInput=r;function f(L){return L instanceof r}e.isEditorInput=f;function o(L){const M=L;return I.URI.isUri(M?.preferredResource)}function S(L){const M=L;return f(M?.primary)&&f(M?.secondary)}e.isSideBySideEditorInput=S;function s(L){const M=L;return f(M?.modified)&&f(M?.original)}e.isDiffEditorInput=s;function i(L){return f(L?.editor)}e.isEditorInputWithOptions=i;function n(L){const M=L;return i(L)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function c(L){const M=L;return typeof M?.groupId=="number"&&f(M.editor)}e.isEditorIdentifier=c;var a;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(a=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(h=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var d;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(d=e.SideBySideEditor||(e.SideBySideEditor={}));class v{getOriginalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:U,secondary:B}=this.getSideEditors(M);if(U&&B){if(V?.supportSideBySide===d.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===d.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===d.PRIMARY?U:B}}if(p(M)||g(M))return;const H=o(M)?M.preferredResource:M.resource;return!H||!V||!V.filterByScheme?H:this.filterUri(H,V.filterByScheme)}getSideEditors(M){return S(M)||g(M)?{primary:M.primary,secondary:M.secondary}:s(M)||p(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:U,secondary:B}=this.getSideEditors(M);if(U&&B){if(V?.supportSideBySide===d.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===d.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===d.PRIMARY?U:B}}if(p(M)||g(M))return;const H=M.resource;return!H||!V||!V.filterByScheme?H:this.filterUri(H,V.filterByScheme)}filterUri(M,V){if(Array.isArray(V)){if(V.some(H=>M.scheme===H))return M}else if(V===M.scheme)return M}}e.EditorResourceAccessor=new v;var b;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const V=this.instantiationService=M.get(T.IInstantiationService);for(const[H,U]of this.editorSerializerConstructors)this.createEditorSerializer(H,U,V);this.editorSerializerConstructors.clear()}createEditorSerializer(M,V,H){const U=H.createInstance(V);this.editorSerializerInstances.set(M,U)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,V){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,V,this.instantiationService):this.editorSerializerConstructors.set(M,V),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new A);async function O(L,M){if(!L||!L.length)return[];const V=await Promise.all(L.map(async H=>{const U=I.URI.revive(H.fileUri);if(!U||!await M.canHandleResource(U))return;let $=H.exists,z=H.type;if(typeof $!="boolean"||typeof z!="number")try{z=(await M.resolve(U)).isDirectory?P.FileType.Directory:P.FileType.Unknown,$=!0}catch{$=!1}if(!$&&H.openOnlyIfExists||z===P.FileType.Directory)return;const W={selection:$?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let J;return $?J={resource:U,options:W}:J={resource:U,options:W,forceUntitled:!0},J}));return(0,R.coalesce)(V)}e.pathsToEditors=O;var N;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[124],ve([0,1,3,13,173]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,P,R){const C={command:k};if(_&&Object.keys(_).length>0&&(C.arguments=_),this.internalSend("request",C),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.pendingRequests.get(C.seq);if(w){this.pendingRequests.delete(C.seq);const p={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,I.localize)(0,null,R,k)};w(p)}},R)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const _=k,P=this.pendingRequests.get(_.request_seq);P&&(this.pendingRequests.delete(_.request_seq),P(_));break}}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,P)=>k.set(P,_)),await(0,t.timeout)(500),k.forEach((_,P)=>{_({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(pe[208],ve([0,1,8,2,9,25,10]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(s,i,n){return s.replace(k,function(c,a){return i&&a.length>0&&a[0]!=="_"?c:n&&n.hasOwnProperty(a)?n[a]:c})}e.formatPII=_;function P(s){const i={};for(const n of Object.keys(s))n.startsWith("!")||(i[n]=s[n]);return i}e.filterExceptionsFromTelemetry=P;function R(s){return s.configuration.request==="attach"&&!C(s)&&(!s.parentSession||R(s.parentSession))}e.isSessionAttach=R;function C(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?C(s.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=l;function w(s,i,n){let c,a=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=h.exec(s);){const v=d.index+1,b=v+d[0].length;if(v<=i&&b>=n){c=d[0],a=v;break}}if(c){const v=/\w+/g;let b=null;for(;(b=v.exec(c))&&!(b.index+1+a+b[0].length>=n););b&&(c=c.substring(0,v.lastIndex))}return c?{start:a,end:a+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=w;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(s){return!!(s&&s.match(p))}e.isUri=g;function E(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(g(s.path))return t.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function F(s){if(typeof s.path=="object"){const i=t.URI.revive(s.path);if(i)return i.scheme===T.Schemas.file?i.fsPath:i.toString()}return s.path}function y(s,i){const n=i?E:F,c=(0,D.deepClone)(s);return r(c,(a,h)=>{a&&h&&(h.path=n(h))}),c}e.convertToDAPaths=y;function u(s,i){const n=i?E:F,c=(0,D.deepClone)(s);return r(c,(a,h)=>{!a&&h&&(h.path=n(h))}),c}e.convertToVSCPaths=u;function r(s,i){switch(s.type){case"event":{const n=s;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=s;switch(n.command){case"setBreakpoints":i(!0,n.arguments.source);break;case"breakpointLocations":i(!0,n.arguments.source);break;case"source":i(!0,n.arguments.source);break;case"gotoTargets":i(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(c=>i(!1,c));break;default:break}break}case"response":{const n=s;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(c=>i(!1,c.source));break;case"loadedSources":n.body.sources.forEach(c=>i(!1,c));break;case"scopes":n.body.scopes.forEach(c=>i(!1,c.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(c=>i(!1,c.source));break;case"setBreakpoints":n.body.breakpoints.forEach(c=>i(!1,c.source));break;default:break}break}}}function f(s){return s.filter(i=>!i.presentation?.hidden).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):o(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=f;function o(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function S(s,i){const n=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(n!=="none"&&(await i.saveAll(),n==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&c.input.resource?.scheme===T.Schemas.untitled&&await i.save({editor:c.input,groupId:c.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(pe[209],ve([0,1,30,37,174,125,9,8,25,12,184,124]),function(Z,e,m,t,I,D,T,k,_,P,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(y,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,y.on("data",r=>this.handleData(r))}sendMessage(y){if(this.outputStream){const u=JSON.stringify(y);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(y){for(this.rawData=Buffer.concat([this.rawData,y]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const f=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const o of f){const S=o.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class w extends l{startSession(){return new Promise((y,u)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),y(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",f=>{r?this._onError.fire(f):u(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class p extends w{constructor(y){super();this.adapterServer=y}createConnection(y){return D.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",y)}}e.SocketDebugAdapter=p;class g extends w{constructor(y){super();this.adapterServer=y}createConnection(y){return D.createConnection(this.adapterServer.path,y)}}e.NamedPipeDebugAdapter=g;class E extends l{constructor(y,u,r){super();this.adapterExecutable=y,this.debugType=u,this.outputService=r}async startSession(){const y=this.adapterExecutable.command,u=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(y)if(T.isAbsolute(y)){if(!await m.Promises.exists(y))throw new Error(I.localize(0,null,y))}else y.indexOf("/")<0&&y.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let f=process.env;if(r.env&&Object.keys(r.env).length>0&&(f=_.mixin(_.deepClone(process.env),r.env)),y==="node")if(Array.isArray(u)&&u.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:f,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(s.cwd=r.cwd);const i=t.fork(u[0],u.slice(1),s);if(!i.pid)throw new Error(I.localize(2,null,u[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:f};r.cwd&&(S.cwd=r.cwd),this.serverProcess=t.spawn(y,u,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,s)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const o=this.outputService;if(o){const S=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=o.getChannel(R.ExtensionsChannelId);i&&i.append(S(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((y,u)=>{const r=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,o,S){if(f)return u(f)});r.on("exit",y),r.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(y,u){if(!y)return;const r=Object.create(null);y.runtime&&(y.runtime.indexOf("./")===0?r.runtime=T.join(u,y.runtime):r.runtime=y.runtime),y.runtimeArgs&&(r.runtimeArgs=y.runtimeArgs),y.program&&(T.isAbsolute(y.program)?r.program=y.program:r.program=T.join(u,y.program)),y.args&&(r.args=y.args);const f=y;return f.win&&(r.win=E.extract(f.win,u)),f.winx86&&(r.winx86=E.extract(f.winx86,u)),f.windows&&(r.windows=E.extract(f.windows,u)),f.osx&&(r.osx=E.extract(f.osx,u)),f.linux&&(r.linux=E.extract(f.linux,u)),r}static platformAdapterExecutable(y,u){let r=Object.create(null);u=u.toLowerCase();for(const n of y)if(n.contributes){const c=n.contributes.debuggers;c&&c.length>0&&c.filter(a=>typeof a.type=="string"&&k.equalsIgnoreCase(a.type,u)).forEach(a=>{const h=E.extract(a,n.extensionLocation.fsPath);r=_.mixin(r,h,n.isBuiltin)})}let f;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=r.winx86||r.win||r.windows:P.isWindows?f=r.win||r.windows:P.isMacintosh?f=r.osx:P.isLinux&&(f=r.linux),f=f||r;const o=f.program||r.program,S=f.args||r.args,s=f.runtime||r.runtime,i=f.runtimeArgs||r.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof o=="string"?[o]:[]).concat(S||[])};if(o)return{type:"executable",command:o,args:S||[]}}}e.ExecutableDebugAdapter=E}),define(pe[210],ve([0,1,37,12,29,186]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(l,w){return new Promise((p,g)=>{let E="";const F=m.spawn(l,w);F.pid&&F.stdout.on("data",y=>{E+=y.toString()}),F.on("error",y=>{g(y)}),F.on("close",y=>{p(E)})})}let k;function _(l,w){if(!k)if(t.isWindows)k=new D.WindowsExternalTerminalService;else if(t.isMacintosh)k=new D.MacExternalTerminalService;else if(t.isLinux)k=new D.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=w.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},p.external||{})}e.runInExternalTerminal=_;async function P(l){if(l)if(t.isWindows){const w=await new Promise((p,g)=>{Z(["windows-process-tree"],p,g)});return new Promise(p=>{w.getProcessTree(l,g=>{p(g.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(l)]).then(w=>{const p=w.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},w=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function C(l,w,p,g){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=1:l.indexOf("cmd.exe")>=0?E=0:l.indexOf("bash")>=0?E=2:t.isWindows?E=0:E=2;let F,y=" ";switch(E){case 1:if(F=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),p){const u=(0,I.getDriveLetter)(p);u&&(y+=`${u}:; `),y+=`cd ${F(p)}; `}if(g)for(const u in g){const r=g[u];r===null?y+=`Remove-Item env:${u}; `:y+=`\${env:${u}}='${r}'; `}if(w.length>0){const u=F(w.shift());y+=u[0]==="'"?`& ${u} `:`${u} `;for(const r of w)y+=`${F(r)} `}break;case 0:if(F=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),p){const u=(0,I.getDriveLetter)(p);u&&(y+=`${u}: && `),y+=`cd ${F(p)} && `}if(g){y+='cmd /C "';for(const u in g){let r=g[u];r===null?y+=`set "${u}=" && `:(r=r.replace(/[\^\&\|\<\>]/g,f=>`^${f}`),y+=`set "${u}=${r}" && `)}}for(const u of w)y+=`${F(u)} `;g&&(y+='"');break;case 2:{F=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const u=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(p&&(y+=`cd ${F(p)} ; `),g){y+="/usr/bin/env";for(const r in g){const f=g[r];f===null?y+=` -u ${u(r)}`:y+=` ${u(`${r}=${f}`)}`}y+=" "}for(const r of w)y+=`${F(r)} `;break}}return y}e.prepareCommand=C}),define(pe[126],ve([0,1,32,78,95,10,9,12,62]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var F;(function(v){v.scheme=D.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function A(H,U){return H.with({scheme:v.scheme,fragment:`ch${U.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}v.generate=A;function O(H){if(H.scheme!==v.scheme)return;const U=b.exec(H.fragment);return U?{handle:Number(U[1]),notebook:H.with({scheme:H.fragment.substring(U[0].length)||D.Schemas.file,fragment:null})}:void 0}v.parse=O;function N(H,U,B){return H.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${B??""},${H.scheme!==D.Schemas.file?H.scheme:""}`})}v.generateCellOutputUri=N;function L(H){if(H.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!U)return;const B=Number(U[1]),$=U[2]&&U[2]!==""?U[2]:void 0,z=U[3];return{handle:B,outputId:$,notebook:H.with({scheme:z||D.Schemas.file,fragment:null})}}v.parseCellOutputUri=L;function M(H,U,B){return H.with({scheme:B,fragment:`ch${U.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}v.generateCellUri=M;function V(H,U){if(H.scheme!==U)return;const B=b.exec(H.fragment);return B?{handle:Number(B[1]),notebook:H.with({scheme:H.fragment.substring(B[0].length)||D.Schemas.file,fragment:null})}:void 0}v.parseCellUri=V})(F=e.CellUri||(e.CellUri={}));const y=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function u(v){return y.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=u;function r(v){return y.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function f(v){return y.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=f;const o=v=>k.isWindows?v.replace(/\//g,"\\"):v;class S{constructor(b=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(b)].map(O=>({pattern:O,matches:m.parse(o(O))}))}sort(b){const A=new Map(t.Iterable.map(b,N=>[N,o(N)]));let O=[];for(const{matches:N}of this.order)for(const[L,M]of A)if(N(M)){O.push(L),A.delete(L);break}return A.size&&(O=O.concat([...A.keys()].sort((N,L)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(L)))),O}prioritize(b,A){const O=this.findIndex(b);if(O===-1){this.order.unshift({pattern:b,matches:m.parse(o(b))});return}const N=new Set(A.map(M=>this.findIndex(M,O)));N.delete(-1);const L=Array.from(N).sort();this.order.splice(O+1,0,...L.map(M=>this.order[M]));for(let M=L.length-1;M>=0;M--)this.order.splice(L[M],1)}toArray(){return this.order.map(b=>b.pattern)}findIndex(b,A=this.order.length){const O=o(b);for(let N=0;N<A;N++)if(this.order[N].matches(O))return N;return-1}}e.MimeTypeDisplayOrder=S;function s(v,b,A,O=(N,L)=>N===L){const N=[];function L(H,U,B){if(U===0&&B.length===0)return;const $=N[N.length-1];$&&$.start+$.deleteCount===H?($.deleteCount+=U,$.toInsert.push(...B)):N.push({start:H,deleteCount:U,toInsert:B})}let M=0,V=0;for(;;){if(M===v.length){L(M,0,b.slice(V));break}if(V===b.length){L(M,v.length-M,[]);break}const H=v[M],U=b[V];if(O(H,U)){M+=1,V+=1;continue}A(U)?(L(M,1,[]),M+=1):(L(M,0,[U]),V+=1)}return N}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(v){const b=v;return!!((typeof b.include=="string"||m.isRelativePattern(b.include))&&(typeof b.exclude=="string"||m.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=n;function c(v,b,A){if(Array.isArray(v.viewType)&&v.viewType.indexOf(b)>=0||v.viewType===b)return!0;if(v.filenamePattern){const O=n(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,N=n(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(m.match(O,(0,T.basename)(A.fsPath).toLowerCase()))return!(N&&m.match(N,(0,T.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class a{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)b[A]=this.textModel.cells[A].getHashValue();return b}}e.CellSequence=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var h;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class d{static create(b){return`${d._prefix}${b}`}static parse(b){if(b.startsWith(d._prefix))return b.substring(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d,d._prefix="notebook/"}),define(pe[211],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(pe[212],ve([0,1,4,62]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[213],ve([0,1,176,4,62]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[214],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=m;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(pe[127],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var t;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var D;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(D=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=T;var k;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire",C[C.AddTag=5]="AddTag",C[C.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,w){}complete(){}}e.IncrementalChangeCollector=P;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const w=this.createChangeCollector();for(const p of l)switch(p[0]){case 0:{const g=p[1];if(g.parent){if(this.items.has(g.parent)){const E=this.items.get(g.parent);E.children.add(g.item.extId);const F=this.createItem(g,E);this.items.set(g.item.extId,F),w.add(F)}}else{const E=this.createItem(g);this.roots.add(E),this.items.set(g.item.extId,E),w.add(E)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=p[1],E=this.items.get(g.extId);if(!E)break;g.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,g),w.update(E);break}case 2:{const g=this.items.get(p[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const E=[[p[1]]];for(;E.length;)for(const F of E.pop()){const y=this.items.get(F);y&&(E.push(y.children),this.items.delete(F),w.remove(y,y!==g),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}w.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=R}),define(pe[88],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(D){D.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(T,k=T.length){if(this.path=T,this.viewEnd=k,T.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,k,_=T.parent){if(T.id===k)return new I([k]);let P=[T.id];for(let R=_;R&&R.id!==k;R=R.parent)P.push(R.id);return P.push(k),new I(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const k=T.indexOf("\0");return k===-1?T:T.slice(0,k)}static fromString(T){return new I(T.split("\0"))}static join(T,k){return new I([...T.path,k])}static joinToString(T,k){return T.toString()+"\0"+k}static compare(T,k){return T===k?0:k.startsWith(T+"\0")?2:T.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let k=0;k<T.viewEnd&&k<this.viewEnd;k++)if(T.path[k]!==this.path[k])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(pe[215],ve([0,1,9,40,18,25,12,80,177]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,l,w){this._contributedVariables=new Map,this._context=C,this._labelService=l,w&&(this._envVariablesPromise=w.then(p=>this.prepareEnv(p)))}prepareEnv(C){if(T.isWindows){const l=Object.create(null);return Object.keys(C).forEach(w=>{l[w.toLowerCase()]=C[w]}),l}return C}resolveWithEnvironment(C,l,w){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,w)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,w,p){const g=D.deepClone(l);return T.isWindows&&g.windows?Object.keys(g.windows).forEach(E=>g[E]=g.windows[E]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(E=>g[E]=g.osx[E]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(E=>g[E]=g.linux[E]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,w,p)}async resolveAnyAsync(C,l,w){return this.resolveAnyBase(C,l,w)}async resolveAnyMap(C,l,w){const p=new Map;return{newConfig:await this.resolveAnyBase(C,l,w,p),resolvedVariables:p}}resolveWithInteractionReplace(C,l,w,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,w,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,w,p,g){if(I.isString(w))return this.resolveString(C,l,w,p,g);if(I.isArray(w))return w.map(E=>this.recursiveResolve(C,l,E,p,g));if(I.isObject(w)){let E=Object.create(null);return Object.keys(w).forEach(F=>{const y=this.resolveString(C,l,F,p,g);E[y]=this.recursiveResolve(C,l,w[F],p,g)}),E}return w}resolveString(C,l,w,p,g){return w.replace(P.VARIABLE_REGEXP,(F,y)=>{if(y.includes(P.VARIABLE_LHS))return F;let u=this.evaluateSingleVariable(C,F,y,l,p);return g&&g.set(y,u),u!==F&&I.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(C,l,u,p,g)),u})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,w,p,g){let E;const F=w.split(":");F.length>1&&(w=F[0],E=F[1]);const y=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,_.localize)(0,null,l))},u=()=>{const f=y();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,_.localize)(1,null,l,m.basename(f)))},r=()=>{if(E){const f=this._context.getFolderUri(E);if(f)return f;throw new Error((0,_.localize)(2,null,l,E))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(w){case"env":if(E){if(C){const f=C[T.isWindows?E.toLowerCase():E];if(I.isString(f))return f}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(E){const f=this._context.getConfigurationValue(p,E);if(I.isUndefinedOrNull(f))throw new Error((0,_.localize)(6,null,l,E));if(I.isObject(f))throw new Error((0,_.localize)(7,null,l,E));return f}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,E,g,"command");case"input":return this.resolveFromMap(l,E,g,"input");default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return p||E?(0,k.normalizeDriveLetter)(this.fsPath(r())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":{const f=this._context.getLineNumber();if(f)return f;throw new Error((0,_.localize)(9,null,l))}case"selectedText":{const f=this._context.getSelectedText();if(f)return f;throw new Error((0,_.localize)(10,null,l))}case"file":return y();case"fileWorkspaceFolder":return u();case"relativeFile":return p||E?m.relative(this.fsPath(r()),y()):y();case"relativeFileDirname":{const f=m.dirname(y());if(p||E){const o=m.relative(this.fsPath(r()),f);return o.length===0?".":o}return f}case"fileDirname":return m.dirname(y());case"fileExtname":return m.extname(y());case"fileBasename":return m.basename(y());case"fileBasenameNoExtension":{const f=m.basename(y());return f.slice(0,f.length-m.extname(f).length)}case"fileDirnameBasename":return m.basename(m.dirname(y()));case"execPath":{const f=this._context.getExecPath();return f||l}case"execInstallFolder":{const f=this._context.getAppRoot();return f||l}case"pathSeparator":return m.sep;default:try{const f=E?`${w}:${E}`:w;return this.resolveFromMap(l,f,g,void 0)}catch{return l}}}}resolveFromMap(C,l,w,p){if(l&&w){const g=p===void 0?w[l]:w[p+":"+l];if(typeof g=="string")return g;throw new Error((0,_.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[128],ve([0,1,4,207]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var k;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const g=p;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function l(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=l;function w(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(pe[216],ve([0,1,4,128]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(D){const T=D;return typeof D=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=I}),define(pe[15],ve([0,1,17,22,99,292,59,25,18,2,41,83,178,117,64,126,88,216,7]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Ee){function _e(Y){const{selectionStartLineNumber:ke,selectionStartColumn:Ne,positionLineNumber:Xe,positionColumn:Qe}=Y,pt=new y.Position(ke-1,Ne-1),St=new y.Position(Xe-1,Qe-1);return new y.Selection(pt,St)}Ee.to=_e;function he(Y){const{anchor:ke,active:Ne}=Y;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}Ee.from=he})(u=e.Selection||(e.Selection={}));var r;(function(Ee){function _e(Y){if(!Y)return;const{start:ke,end:Ne}=Y;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}Ee.from=_e;function he(Y){if(!Y)return;const{startLineNumber:ke,startColumn:Ne,endLineNumber:Xe,endColumn:Qe}=Y;return new y.Range(ke-1,Ne-1,Xe-1,Qe-1)}Ee.to=he})(r=e.Range||(e.Range={}));var f;(function(Ee){function _e(he){switch(he){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 3:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}Ee.to=_e})(f=e.TokenType||(e.TokenType={}));var o;(function(Ee){function _e(Y){return new y.Position(Y.lineNumber-1,Y.column-1)}Ee.to=_e;function he(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=he})(o=e.Position||(e.Position={}));var S;(function(Ee){function _e(ke,Ne){return(0,m.coalesce)((0,m.asArray)(ke).map(Xe=>he(Xe,Ne)))}Ee.from=_e;function he(ke,Ne){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:Y(ke.scheme,Ne),pattern:Se.from(ke.pattern)??void 0,exclusive:ke.exclusive}}function Y(ke,Ne){return Ne&&typeof ke=="string"?Ne.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ee){function _e(Y){switch(Y){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}Ee.from=_e;function he(Y){switch(Y){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Ee){function _e(Y){let ke;return Y.code&&((0,_.isString)(Y.code)||(0,_.isNumber)(Y.code)?ke=String(Y.code):ke={value:String(Y.code.value),target:Y.code.target}),{...r.from(Y.range),message:Y.message,source:Y.source,code:ke,severity:c.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(n.from),tags:Array.isArray(Y.tags)?(0,m.coalesce)(Y.tags.map(s.from)):void 0}}Ee.from=_e;function he(Y){const ke=new y.Diagnostic(r.to(Y),Y.message,c.to(Y.severity));return ke.source=Y.source,ke.code=(0,_.isString)(Y.code)?Y.code:Y.code?.value,ke.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(n.to),ke.tags=Y.tags&&(0,m.coalesce)(Y.tags.map(s.to)),ke}Ee.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var n;(function(Ee){function _e(Y){return{...r.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ee.from=_e;function he(Y){return new y.DiagnosticRelatedInformation(new y.Location(Y.resource,r.to(Y)),Y.message)}Ee.to=he})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(Ee){function _e(Y){switch(Y){case y.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Ee.from=_e;function he(Y){switch(Y){case w.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}Ee.to=he})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(Ee){function _e(Y){return typeof Y=="number"&&Y>=y.ViewColumn.One?Y-1:Y===y.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}Ee.from=_e;function he(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(a=e.ViewColumn||(e.ViewColumn={}));function h(Ee){return typeof Ee.range!="undefined"}function d(Ee){return Ee.length===0?!0:!!h(Ee[0])}e.isDecorationOptionsArr=d;var v;(function(Ee){function _e(Qe){return Qe.map(Ee.from)}Ee.fromMany=_e;function he(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Y(Qe){let pt;if(he(Qe)){const{language:wt,value:bt}=Qe;pt={value:"```"+wt+`
`+bt+"\n```\n"}}else y.MarkdownString.isMarkdownString(Qe)?pt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml}:typeof Qe=="string"?pt={value:Qe}:pt={value:""};const St=Object.create(null);pt.uris=St;const yt=wt=>{try{let bt=P.URI.parse(wt,!0);bt=bt.with({query:ke(bt.query,St)}),St[wt]=bt}catch{}return""},ft=new D.Renderer;return ft.link=yt,ft.image=wt=>yt(I.parseHrefAndDimensions(wt).href),D(pt.value,{renderer:ft}),pt}Ee.from=Y;function ke(Qe,pt){if(!Qe)return Qe;let St;try{St=(0,T.parse)(Qe)}catch{}if(!St)return Qe;let yt=!1;return St=(0,k.cloneAndChange)(St,ft=>{if(P.URI.isUri(ft)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[wt]=ft,yt=!0,wt}else return}),yt?JSON.stringify(St):Qe}function Ne(Qe){const pt=new y.MarkdownString(Qe.value,Qe.supportThemeIcons);return pt.isTrusted=Qe.isTrusted,pt.supportHtml=Qe.supportHtml,pt}Ee.to=Ne;function Xe(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Ee.from(Qe)}Ee.fromStrict=Xe})(v=e.MarkdownString||(e.MarkdownString={}));function b(Ee){return d(Ee)?Ee.map(_e=>({range:r.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?v.fromMany(_e.hoverMessage):_e.hoverMessage?v.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):Ee.map(_e=>({range:r.from(_e)}))}e.fromRangeOrRangeWithMessage=b;function A(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?P.URI.file(Ee):Ee}e.pathOrURIToURI=A;var O;(function(Ee){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?A(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=_e})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Ee){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Ee.from=_e})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function _e(he){if(typeof he=="undefined")return he;switch(he){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=_e})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(Ee){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?L.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?N.from(he.light):void 0,dark:he.dark?N.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Ee.from=_e})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ee){function _e(Y){return{text:Y.newText,eol:Y.newEol&&gt.from(Y.newEol),range:r.from(Y.range)}}Ee.from=_e;function he(Y){const ke=new y.TextEdit(r.to(Y.range),Y.text);return ke.newEol=typeof Y.eol=="undefined"?void 0:gt.to(Y.eol),ke}Ee.to=he})(V=e.TextEdit||(e.TextEdit={}));var H;(function(Ee){function _e(Y,ke,Ne){const Xe={edits:[]};if(Y instanceof y.WorkspaceEdit)for(let Qe of Y._allEntries())if(Qe._type===1)Xe.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const pt=ke?.getDocument(Qe.uri);Xe.edits.push({_type:2,resource:Qe.uri,edit:V.from(Qe.edit),modelVersionId:pt?.version,metadata:Qe.metadata})}else Qe._type===3?Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ut.from)}});return Xe}Ee.from=_e;function he(Y){const ke=new y.WorkspaceEdit;for(const Ne of Y.edits)Ne.edit?ke.replace(P.URI.revive(Ne.resource),r.to(Ne.edit.range),Ne.edit.text):ke.renameFile(P.URI.revive(Ne.oldUri),P.URI.revive(Ne.newUri),Ne.options);return ke}Ee.to=he})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(Ee){const _e=Object.create(null);_e[y.SymbolKind.File]=0,_e[y.SymbolKind.Module]=1,_e[y.SymbolKind.Namespace]=2,_e[y.SymbolKind.Package]=3,_e[y.SymbolKind.Class]=4,_e[y.SymbolKind.Method]=5,_e[y.SymbolKind.Property]=6,_e[y.SymbolKind.Field]=7,_e[y.SymbolKind.Constructor]=8,_e[y.SymbolKind.Enum]=9,_e[y.SymbolKind.Interface]=10,_e[y.SymbolKind.Function]=11,_e[y.SymbolKind.Variable]=12,_e[y.SymbolKind.Constant]=13,_e[y.SymbolKind.String]=14,_e[y.SymbolKind.Number]=15,_e[y.SymbolKind.Boolean]=16,_e[y.SymbolKind.Array]=17,_e[y.SymbolKind.Object]=18,_e[y.SymbolKind.Key]=19,_e[y.SymbolKind.Null]=20,_e[y.SymbolKind.EnumMember]=21,_e[y.SymbolKind.Struct]=22,_e[y.SymbolKind.Event]=23,_e[y.SymbolKind.Operator]=24,_e[y.SymbolKind.TypeParameter]=25;function he(ke){return typeof _e[ke]=="number"?_e[ke]:6}Ee.from=he;function Y(ke){for(const Ne in _e)if(_e[Ne]===ke)return Number(Ne);return y.SymbolKind.Property}Ee.to=Y})(U=e.SymbolKind||(e.SymbolKind={}));var B;(function(Ee){function _e(Y){switch(Y){case y.SymbolTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return y.SymbolTag.Deprecated}}Ee.to=he})(B=e.SymbolTag||(e.SymbolTag={}));var $;(function(Ee){function _e(Y){return{name:Y.name,kind:U.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:se.from(Y.location)}}Ee.from=_e;function he(Y){const ke=new y.SymbolInformation(Y.name,U.to(Y.kind),Y.containerName,se.to(Y.location));return ke.tags=Y.tags&&Y.tags.map(B.to),ke}Ee.to=he})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(Ee){function _e(Y){const ke={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:r.from(Y.range),selectionRange:r.from(Y.selectionRange),kind:U.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(ke.children=Y.children.map(_e)),ke}Ee.from=_e;function he(Y){const ke=new y.DocumentSymbol(Y.name,Y.detail,U.to(Y.kind),r.to(Y.range),r.to(Y.selectionRange));return(0,m.isNonEmptyArray)(Y.tags)&&(ke.tags=Y.tags.map(B.to)),Y.children&&(ke.children=Y.children.map(he)),ke}Ee.to=he})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(Ee){function _e(Y){const ke=new y.CallHierarchyItem(U.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),r.to(Y.range),r.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,name:Y.name,detail:Y.detail,kind:U.from(Y.kind),uri:Y.uri,range:r.from(Y.range),selectionRange:r.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Ee){function _e(he){return new y.CallHierarchyIncomingCall(W.to(he.from),he.fromRanges.map(Y=>r.to(Y)))}Ee.to=_e})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Ee){function _e(he){return new y.CallHierarchyOutgoingCall(W.to(he.to),he.fromRanges.map(Y=>r.to(Y)))}Ee.to=_e})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var se;(function(Ee){function _e(Y){return{range:Y.range&&r.from(Y.range),uri:Y.uri}}Ee.from=_e;function he(Y){return new y.Location(P.URI.revive(Y.uri),r.to(Y.range))}Ee.to=he})(se=e.location||(e.location={}));var K;(function(Ee){function _e(Y){const ke=Y,Ne=Y;return{originSelectionRange:ke.originSelectionRange?r.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ne.uri,range:r.from(ke.targetRange?ke.targetRange:Ne.range),targetSelectionRange:ke.targetSelectionRange?r.from(ke.targetSelectionRange):void 0}}Ee.from=_e;function he(Y){return{targetUri:P.URI.revive(Y.uri),targetRange:r.to(Y.range),targetSelectionRange:Y.targetSelectionRange?r.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?r.to(Y.originSelectionRange):void 0}}Ee.to=he})(K=e.DefinitionLink||(e.DefinitionLink={}));var Q;(function(Ee){function _e(Y){return{range:r.from(Y.range),contents:v.fromMany(Y.contents)}}Ee.from=_e;function he(Y){return new y.Hover(Y.contents.map(v.to),r.to(Y.range))}Ee.to=he})(Q=e.Hover||(e.Hover={}));var ae;(function(Ee){function _e(Y){return{range:r.from(Y.range),expression:Y.expression}}Ee.from=_e;function he(Y){return new y.EvaluatableExpression(r.to(Y.range),Y.expression)}Ee.to=he})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Ee){function _e(Y){if(Y instanceof y.InlineValueText)return{type:"text",range:r.from(Y.range),text:Y.text};if(Y instanceof y.InlineValueVariableLookup)return{type:"variable",range:r.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=_e;function he(Y){switch(Y.type){case"text":return{range:r.to(Y.range),text:Y.text};case"variable":return{range:r.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:r.to(Y.range),expression:Y.expression}}}Ee.to=he})(fe=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function _e(Y){return{frameId:Y.frameId,stoppedLocation:r.from(Y.stoppedLocation)}}Ee.from=_e;function he(Y){return new y.InlineValueContext(Y.frameId,r.to(Y.stoppedLocation))}Ee.to=he})(be=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(Ee){function _e(Y){return{range:r.from(Y.range),kind:Y.kind}}Ee.from=_e;function he(Y){return new y.DocumentHighlight(r.to(Y.range),Y.kind)}Ee.to=he})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(Ee){function _e(he){switch(he){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}Ee.to=_e})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(Ee){function _e(he){return{triggerKind:xe.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=_e})(Ge=e.CompletionContext||(e.CompletionContext={}));var Je;(function(Ee){function _e(Y){switch(Y){case y.CompletionItemTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return y.CompletionItemTag.Deprecated}}Ee.to=he})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Ee){const _e=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function he(Ne){return _e.get(Ne)??9}Ee.from=he;const Y=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function ke(Ne){return Y.get(Ne)??y.CompletionItemKind.Property}Ee.to=ke})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function _e(he,Y){const ke=new y.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=q.to(he.kind),ke.tags=he.tags?.map(Je.to),ke.detail=he.detail,ke.documentation=I.isMarkdownString(he.documentation)?v.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,R.Range.isIRange(he.range)?ke.range=r.to(he.range):typeof he.range=="object"&&(ke.range={inserting:r.to(he.range.insert),replacing:r.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?ke.insertText=new y.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof y.Range?new y.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Ne=>V.to(Ne))),ke.command=Y&&he.command?Y.fromInternal(he.command):void 0,ke}Ee.to=_e})(te=e.CompletionItem||(e.CompletionItem={}));var G;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation}}Ee.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var X;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.from):[],activeParameter:Y.activeParameter}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.to):[],activeParameter:Y.activeParameter}}Ee.to=he})(X=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(Ee){function _e(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.from):[]}}Ee.from=_e;function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.to):[]}}Ee.to=he})(oe=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(Ee){function _e(he,Y){const ke=new y.InlayHint(typeof Y.label=="string"?Y.label:Y.label.map(Ie.to.bind(void 0,he)),o.to(Y.position),We.to(Y.kind));return ke.tooltip=I.isMarkdownString(Y.tooltip)?v.to(Y.tooltip):Y.tooltip,ke.whitespaceAfter=Y.whitespaceAfter,ke.whitespaceBefore=Y.whitespaceBefore,ke}Ee.to=_e})(me=e.InlayHint||(e.InlayHint={}));var Ie;(function(Ee){function _e(he,Y){const ke=new y.InlayHintLabelPart(Y.label);return ke.collapsible=Y.collapsible,C.Command.is(Y.action)?ke.action=he.fromInternal(Y.action):Y.action&&(ke.action=se.to(Y.action)),ke}Ee.to=_e})(Ie=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var We;(function(Ee){function _e(Y){return Y}Ee.from=_e;function he(Y){return Y}Ee.to=he})(We=e.InlayHintKind||(e.InlayHintKind={}));var Ye;(function(Ee){function _e(Y){return{range:r.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=_e;function he(Y){let ke;if(Y.url)try{ke=typeof Y.url=="string"?P.URI.parse(Y.url,!0):P.URI.revive(Y.url)}catch{}return new y.DocumentLink(r.to(Y.range),ke)}Ee.to=he})(Ye=e.DocumentLink||(e.DocumentLink={}));var it;(function(Ee){function _e(Y){const ke=new y.ColorPresentation(Y.label);return Y.textEdit&&(ke.textEdit=V.to(Y.textEdit)),Y.additionalTextEdits&&(ke.additionalTextEdits=Y.additionalTextEdits.map(Ne=>V.to(Ne))),ke}Ee.to=_e;function he(Y){return{label:Y.label,textEdit:Y.textEdit?V.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(ke=>V.from(ke)):void 0}}Ee.from=he})(it=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(Ee){function _e(Y){return new y.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=_e;function he(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=he})(st=e.Color||(e.Color={}));var ot;(function(Ee){function _e(Y){return{range:r.from(Y.range)}}Ee.from=_e;function he(Y){return new y.SelectionRange(r.to(Y.range))}Ee.to=he})(ot=e.SelectionRange||(e.SelectionRange={}));var tt;(function(Ee){function _e(he){switch(he){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}Ee.to=_e})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(Ee){function _e(Y){switch(Y){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=_e;function he(Y){switch(Y){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}Ee.to=he})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(Ee){function _e(Y){if(Y===y.EndOfLine.CRLF)return 1;if(Y===y.EndOfLine.LF)return 0}Ee.from=_e;function he(Y){if(Y===1)return y.EndOfLine.CRLF;if(Y===0)return y.EndOfLine.LF}Ee.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Ee){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=_e})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var It;(function(Ee){function _e(he){const Y={start:he.start+1,end:he.end+1};return he.kind&&(Y.kind=ee.from(he.kind)),Y}Ee.from=_e})(It=e.FoldingRange||(e.FoldingRange={}));var ee;(function(Ee){function _e(he){if(he)switch(he){case y.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Ee.from=_e})(ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ie;(function(Ee){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?r.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}Ee.from=_e})(ie=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(Ee){function _e(Ne){return Ne instanceof y.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:he(Ne)||Y(Ne)?new y.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}Ee.from=_e;function he(Ne){const Xe=Ne;return Xe?P.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Y(Ne){const Xe=Ne;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(Ne){return typeof Ne=="string"?Ne:new y.RelativePattern(P.URI.revive(Ne.baseUri),Ne.pattern)}Ee.to=ke})(Se=e.GlobPattern||(e.GlobPattern={}));var re;(function(Ee){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const Y=he;return{language:Y.language,scheme:Y.scheme,pattern:Se.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=_e})(re=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(Ee){function _e(Y){return{start:Y.start,end:Y.end}}Ee.from=_e;function he(Y){return new y.NotebookRange(Y.start,Y.end)}Ee.to=he})(ye=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Ee){function _e(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=_e;function he(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ee.from=he})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Ee){function _e(Y){switch(Y){case y.NotebookCellKind.Markup:return g.CellKind.Markup;case y.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=_e;function he(Y){switch(Y){case g.CellKind.Markup:return y.NotebookCellKind.Markup;case g.CellKind.Code:default:return y.NotebookCellKind.Code}}Ee.to=he})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Ee){function _e(Y){const ke={metadata:Y.metadata??Object.create(null),cells:[]};for(let Ne of Y.cells)y.NotebookCellData.validate(Ne),ke.cells.push(ut.from(Ne));return ke}Ee.from=_e;function he(Y){const ke=new y.NotebookData(Y.cells.map(ut.to));return(0,_.isEmptyObject)(Y.metadata)||(ke.metadata=Y.metadata),ke}Ee.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var ut;(function(Ee){function _e(Y){return{cellKind:qe.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Fe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Ae.from):[]}}Ee.from=_e;function he(Y){return new y.NotebookCellData(qe.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Ae.to):void 0,Y.metadata,Y.internalMetadata?Fe.to(Y.internalMetadata):void 0)}Ee.to=he})(ut=e.NotebookCellData||(e.NotebookCellData={}));var Re;(function(Ee){function _e(Y){return{mime:Y.mime,valueBytes:t.VSBuffer.wrap(Y.data)}}Ee.from=_e;function he(Y){return new y.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Ee.to=he})(Re=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Ee){function _e(Y){return{outputId:Y.id,items:Y.items.map(Re.from),metadata:Y.metadata}}Ee.from=_e;function he(Y){const ke=Y.items.map(Re.to);return new y.NotebookCellOutput(ke,Y.outputId,Y.metadata)}Ee.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(Ee){function _e(ke){return Y(ke)?{include:(0,_.withNullAsUndefined)(Se.from(ke.include)),exclude:(0,_.withNullAsUndefined)(Se.from(ke.exclude))}:(0,_.withNullAsUndefined)(Se.from(ke))}Ee.from=_e;function he(ke){return Y(ke)?{include:Se.to(ke.include),exclude:Se.to(ke.exclude)}:Se.to(ke)}Ee.to=he;function Y(ke){const Ne=ke;return Ne?!!Ne.include&&!!Ne.exclude:!1}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ce;(function(Ee){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?O.from(he.top):void 0}}Ee.from=_e})(ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(Ee){function _e(he,Y,ke){const Ne=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Ne,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var we;(function(Ee){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Ee.from=_e})(we=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ce;(function(Ee){function _e(Y){return{uri:Y.uri,provides:Y.provides}}Ee.from=_e;function he(Y){return new y.NotebookRendererScript(P.URI.revive(Y.uri),Y.provides)}Ee.to=he})(Ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(Ee){function _e(Y){return{message:v.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location?se.from(Y.location):void 0}}Ee.from=_e;function he(Y){const ke=new y.TestMessage(typeof Y.message=="string"?Y.message:v.to(Y.message));return ke.actualOutput=Y.actual,ke.expectedOutput=Y.expected,ke.location=Y.location?se.to(Y.location):void 0,ke}Ee.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ke;(function(Ee){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),Ee.namespace=(he,Y)=>he+"\0"+Y,Ee.denamespace=he=>{const Y=he.indexOf("\0");return{ctrlId:he.slice(0,Y),tagId:he.slice(Y+1)}}})(Ke=e.TestTag||(e.TestTag={}));var $e;(function(Ee){function _e(Ne){const Xe=(0,p.getPrivateApiFor)(Ne).controllerId;return{extId:E.TestId.fromExtHostTestItem(Ne,Xe).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(Qe=>Ke.namespace(Xe,Qe.id)),range:r.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&v.fromStrict(Ne.error)||null}}Ee.from=_e;function he(Ne){return{parent:void 0,error:void 0,id:E.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:P.URI.revive(Ne.uri),tags:(Ne.tags||[]).map(Xe=>{const{tagId:Qe}=Ke.denamespace(Xe);return new y.TestTag(Qe)}),range:r.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}Ee.toPlain=he;function Y(Ne){const Xe=E.TestId.fromString(Ne.extId),Qe=new p.TestItemImpl(Xe.controllerId,Xe.localId,Ne.label,P.URI.revive(Ne.uri));return Qe.range=r.to(Ne.range||void 0),Qe.description=Ne.description||void 0,Qe}function ke(Ne){let Xe;for(const Qe of Ne.tests){const pt=Y(Qe.item);(0,p.getPrivateApiFor)(pt).parent=Xe,Xe=pt}return Xe}Ee.toItemFromContext=ke})($e=e.TestItem||(e.TestItem={})),function(Ee){function _e(Y){return{id:Y.id}}Ee.from=_e;function he(Y){return new y.TestTag(Y.id)}Ee.to=he}(Ke=e.TestTag||(e.TestTag={}));var Ze;(function(Ee){const _e=(Y,ke)=>{const Ne={...$e.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(Qe=>Qe.type===0).map(Oe.to)})),children:Y.children.map(Xe=>ke.get(Xe)).filter(_.isDefined).map(Xe=>_e(Xe,ke))};for(const Xe of Ne.children)Xe.parent=Ne;return Ne};function he(Y){const ke=[],Ne=new Map;for(const Xe of Y.items)Ne.set(Xe.item.extId,Xe),Y.request.targets.some(Qe=>Qe.controllerId===Xe.controllerId&&Qe.testIds.includes(Xe.item.extId))&&ke.push(Xe);return{completedAt:Y.completedAt,results:ke.map(Xe=>_e(Xe,Ne))}}Ee.to=he})(Ze=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function _e(Ne){return{covered:Ne.covered,total:Ne.covered}}function he(Ne){return"line"in Ne?o.from(Ne):r.from(Ne)}function Y(Ne){return"branches"in Ne?{count:Ne.executionCount,location:he(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&he(Xe.location)})):void 0}:{type:0,count:Ne.executionCount,location:he(Ne.location)}}Ee.fromDetailed=Y;function ke(Ne){return{uri:Ne.uri,statement:_e(Ne.statementCoverage),branch:Ne.branchCoverage&&_e(Ne.branchCoverage),function:Ne.functionCoverage&&_e(Ne.functionCoverage),details:Ne.detailedCoverage?.map(Y)}}Ee.fromFile=ke})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(Ee){function _e(he){switch(he){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}Ee.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var He;(function(Ee){function _e(Y){const ke=new y.TypeHierarchyItem(U.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),r.to(Y.range),r.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,kind:U.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:r.from(Y.range),selectionRange:r.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})(He=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[217],ve([0,1,2,16,7,15,93]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,R,C,l={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,C,l)=>{const p={dispose:this._callbacks.push([R,C,P])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(P,R){const C=m.URI.revive(P);let l=!1;const w=setTimeout(()=>l=!0,this._thresholds.timeout),p=[];try{for(let g of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(C),F=await this._deliverEventAsyncAndBlameBadListeners(g,{document:E,reason:D.TextDocumentSaveReason.to(R)});p.push(F)}}finally{clearTimeout(w)}return p}_deliverEventAsyncAndBlameBadListeners([P,R,C],l){const w=this._badListeners.get(P);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,R,l).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this._badListeners.get(P);this._badListeners.set(P,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,C,l){const w=[],p=Date.now(),{document:g,reason:E}=l,{version:F}=g,y=Object.freeze({document:g,reason:E,waitUntil(u){if(Object.isFrozen(w))throw(0,t.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(u))}});try{R.apply(C,[y])}catch(u){return Promise.reject(u)}return Object.freeze(w),new Promise((u,r)=>{const f=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(f),u(o)}).catch(o=>{clearTimeout(f),r(o)})}).then(u=>{const r={edits:[]};for(const f of u)if(Array.isArray(f)&&f.every(o=>o instanceof I.TextEdit))for(const{newText:o,newEol:S,range:s}of f)r.edits.push({_type:2,resource:g.uri,edit:{range:s&&D.Range.from(s),text:o,eol:S&&D.EndOfLine.from(S)}});if(r.edits.length!==0)return F===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[218],ve([0,1,10,25,2,15,126]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(C,l,w,p){this.start=C,this.deletedCount=l,this.deletedItems=w,this.items=p}static asApiEvents(C){return C.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(w=>w.apiCell)}))}}class _{constructor(C,l,w){this.notebook=C,this._extHostDocument=l,this._cellData=w,this.handle=w.handle,this.uri=I.URI.revive(w.uri),this.cellKind=w.cellKind,this._outputs=w.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=w.internalMetadata??{},this._metadata=Object.freeze(w.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}static asModelAddData(C,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:C}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return C._mime},set mime(w){C._mime=w},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}})}return this._apiCell}setOutputs(C){this._outputs=C.map(D.NotebookCellOutput.to)}setOutputItems(C,l,w){const p=w.map(D.NotebookCellOutputItem.to),g=this._outputs.find(E=>E.id===C);g&&(l||(g.items.length=0),g.items.push(...p))}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=_;class P{constructor(C,l,w,p,g,E){this._proxy=C,this._textDocumentsAndEditors=l,this._textDocuments=w,this._emitter=p,this.uri=g,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const C=this;this._notebook={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===m.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(l){return l=C._validateIndex(l),C._cells[l].apiCell},getCells(l){return(l?C._getCells(l):C._cells).map(p=>p.apiCell)},save(){return C._save()}}}return this._notebook}updateBackup(C){this._backup?.delete(),this._backup=C}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,l){this._versionId=C.versionId,this._isDirty=l;for(const w of C.rawEvents)w.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(w.changes,!1):w.kind===T.NotebookCellsChangeType.Move?this._moveCell(w.index,w.newIdx):w.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(w.index,w.outputs):w.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(w.index,w.outputId,w.append,w.outputItems):w.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(w.index,w.language):w.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(w.index,w.mime):w.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(w.index,w.metadata):w.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(w.index,w.internalMetadata)}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let l=C.start|0,w=C.end|0;return l<0&&(l=0),w>this._cells.length&&(w=this._cells.length),C.with({start:l,end:w})}_getCells(C){C=this._validateRange(C);const l=[];for(let w=C.start;w<C.end;w++)l.push(this._cells[w]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,l){if(this._disposed)return;const w=[],p=[],g=[];C.reverse().forEach(E=>{const y=E[2].map(f=>{const o=new _(this,this._textDocumentsAndEditors,f);return l||p.push(_.asModelAddData(this.apiNotebook,f)),o}),u=new k(E[0],E[1],[],y),r=this._cells.splice(E[0],E[1],...y);for(const f of r)g.push(f.uri),u.deletedItems.push(f.apiCell);w.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:g}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(w)}))}_moveCell(C,l){const w=this._cells.splice(C,1);this._cells.splice(l,0,...w);const p=[new k(C,1,w.map(g=>g.apiCell),[]),new k(l,0,[],w)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(p)}))}_setCellOutputs(C,l){const w=this._cells[C];w.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_setCellOutputItems(C,l,w,p){const g=this._cells[C];g.setOutputItems(l,w,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(C,l){const w=this._cells[C];w.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(w.uri,l)}_changeCellMime(C,l){const w=this._cells[C];w.apiCell.mime=l}_changeCellMetadata(C,l){const w=this._cells[C],p=w.apiCell.metadata;w.setMetadata(l);const g=w.apiCell.metadata;(0,t.equals)(p,g)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:w.apiCell}))}_changeCellInternalMetadata(C,l){this._cells[C].setInternalMetadata(l)}getCellFromApiCell(C){return this._cells.find(l=>l.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(l=>l.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(pe[129],ve([0,1,7,15,16]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:P})}replaceCells(_,P,R){this._throwIfFinalized(),!(_===P&&R.length===0)&&this._collectedEdits.push({editType:1,index:_,count:P-_,cells:R.map(t.NotebookCellData.from)})}}class T{constructor(_,P,R,C,l,w){this.id=_,this._proxy=P,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=w}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(P){if(!Array.isArray(P)||!P.every(m.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");_._selections=P,_._trySetSelections(P)},get visibleRanges(){return _._visibleRanges},revealRange(P,R){_._proxy.$tryRevealRange(_.id,t.NotebookRange.from(P),R??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(P){const R=new D(this.document.version);return P(R),_._applyEdit(R.finalize())},setDecorations(P,R){return _.setDecorations(P,R)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(t.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const P=[];let R=-1;for(let C=0;C<_.cellEdits.length;C++){if(R<0){P.push(_.cellEdits[C]),R++;continue}const w=P[R],p=_.cellEdits[C];if(w.editType===1&&p.editType===1&&w.index===p.index){w.cells.push(..._.cellEdits[C].cells),w.count+=_.cellEdits[C].count;continue}P.push(_.cellEdits[C]),R++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,P)}setDecorations(_,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return P.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),_.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,15,118,165,21,56,16]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,w,p){const g=this._handles++,{title:E,location:F,cancellable:y}=w,u={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(g,{location:m.ProgressLocation.from(F),title:E,source:u,cancellable:y},l.isUnderDevelopment?void 0:l.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(g,p,!!y)}_withProgress(l,w,p){let g;p&&(g=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,g));const E=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),g&&g.dispose()};let F;try{F=w(new R(this._proxy,l),p&&g?g.token:D.CancellationToken.None)}catch(y){throw E(l),y}return F.then(y=>E(l),y=>E(l)),F}$acceptProgressCanceled(l){const w=this._mapHandleToCancellationSource.get(l);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=_;function P(C,l){return C.message=l.message,typeof l.increment=="number"&&(typeof C.increment=="number"?C.increment+=l.increment:C.increment=l.increment),C}class R extends t.Progress{constructor(l,w){super(p=>this.throttledReport(p));this._proxy=l,this._handle=w}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,T.throttle)(100,(C,l)=>P(C,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(pe[130],ve([0,1,55,16,77,15,7]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,w,p){const g=k._Keys.nextId();l.$registerTextEditorDecorationType(w.identifier,g,D.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class _{constructor(l,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,w){this._throwIfFinalized();let p=null;if(l instanceof T.Position)p=new T.Range(l,l);else if(l instanceof T.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,w,!1)}insert(l,w){this._throwIfFinalized(),this._pushEdit(new T.Range(l,l),w,!0)}delete(l){this._throwIfFinalized();let w=null;if(l instanceof T.Range)w=l;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(l,w,p){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:w,forceMoveMarkers:p})}setEndOfLine(l){if(this._throwIfFinalized(),l!==T.EndOfLine.LF&&l!==T.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class P{constructor(l,w,p,g){this._proxy=l,this._id=w,this._accept(p),this._logService=g;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(F){E._setTabSize(F)},get insertSpaces(){return E._insertSpaces},set insertSpaces(F){E._setInsertSpaces(F)},get cursorStyle(){return E._cursorStyle},set cursorStyle(F){E._setCursorStyle(F)},get lineNumbers(){return E._lineNumbers},set lineNumbers(F){E._setLineNumbers(F)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(l){const w=this._validateTabSize(l);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const w=this._validateInsertSpaces(l);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let p=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(p=!0,w.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,p=!0,w.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(p=!0,w.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,p=!0,w.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,p=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,p=!0,w.lineNumbers=D.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(l,w){w.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class R{constructor(l,w,p,g,E,F,y,u){this.id=l,this._proxy=w,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,F,p),this._visibleRanges=y,this._viewColumn=u;const r=this;this.value=Object.freeze({get document(){return g.getValue()},set document(f){throw(0,t.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(f){if(!(f instanceof T.Selection))throw(0,t.illegalArgument)("selection");r._selections=[f],r._trySetSelection()},get selections(){return r._selections},set selections(f){if(!Array.isArray(f)||f.some(o=>!(o instanceof T.Selection)))throw(0,t.illegalArgument)("selections");r._selections=f,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(f){throw(0,t.readonly)("visibleRanges")},get options(){return r._options.value},set options(f){r._disposed||r._options.assign(f)},get viewColumn(){return r._viewColumn},set viewColumn(f){throw(0,t.readonly)("viewColumn")},edit(f,o={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new _(g.getValue(),o);return f(S),r._applyEdit(S)},insertSnippet(f,o,S={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!o||Array.isArray(o)&&o.length===0)s=r._selections.map(i=>D.Range.from(i));else if(o instanceof T.Position){const{lineNumber:i,column:n}=D.Position.from(o);s=[{startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n}]}else if(o instanceof T.Range)s=[D.Range.from(o)];else{s=[];for(const i of o)if(i instanceof T.Range)s.push(D.Range.from(i));else{const{lineNumber:n,column:c}=D.Position.from(i);s.push({startLineNumber:n,startColumn:c,endLineNumber:n,endColumn:c})}}return w.$tryInsertSnippet(l,f.value,s,S)},setDecorations(f,o){const S=o.length===0;S&&!r._hasDecorationsForKey.has(f.key)||(S?r._hasDecorationsForKey.delete(f.key):r._hasDecorationsForKey.add(f.key),r._runOnProxy(()=>{if(D.isDecorationOptionsArr(o))return w.$trySetDecorations(l,f.key,D.fromRangeOrRangeWithMessage(o));{const s=new Array(4*o.length);for(let i=0,n=o.length;i<n;i++){const c=o[i];s[4*i]=c.start.line+1,s[4*i+1]=c.start.character+1,s[4*i+2]=c.end.line+1,s[4*i+3]=c.end.character+1}return w.$trySetDecorationsFast(l,f.key,s)}}))},revealRange(f,o){r._runOnProxy(()=>w.$tryRevealRange(l,D.Range.from(f),o||T.TextEditorRevealType.Default))},show(f){w.$tryShowEditor(l,D.ViewColumn.from(f))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const p=w.edits.map(E=>E.range);p.sort((E,F)=>E.end.line===F.end.line?E.end.character===F.end.character?E.start.line===F.start.line?E.start.character-F.start.character:E.start.line-F.start.line:E.end.character-F.end.character:E.end.line-F.end.line);for(let E=0,F=p.length-1;E<F;E++){const y=p[E].end;if(p[E+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=w.edits.map(E=>({range:D.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,g,{setEndOfLine:typeof w.setEndOfLine=="number"?D.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=R}),define(pe[220],ve([0,1,13,3,6,18,64,15,127,88]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends I.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const w=this.diff[this.diff.length-1];if(w&&l[0]===1){if(w[0]===1&&w[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(w[1],l[1]);return}if(w[0]===0&&w[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(w[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,w){const p=this.tree.get(l);if(!!p){if((p.expandLevels===void 0||w>p.expandLevels)&&(p.expandLevels=w),p.expand===1){const g=this.resolveChildren(p);return g.isOpen()?this.expandChildren(p,w-1):g.wait().then(()=>this.expandChildren(p,w-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,w-1)):this.expandChildren(p,w-1)}}dispose(){for(const l of this.tree.values())(0,T.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,w){switch(w.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,w.id));break;case 0:this.upsertItem(w.item,l);break;case 4:for(const p of w.ops)this.onTestItemEvent(l,p);break;case 3:{const{key:p,value:g,previous:E}=w,F=l.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(g,E,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:k.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:k.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[p]:g??null}}]);break}break}default:(0,D.assertNever)(w)}}upsertItem(l,w){if(!(l instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const p=P.TestId.fromExtHostTestItem(l,this.root.id,w?.actual),g=(0,T.getPrivateApiFor)(l);g.parent&&g.parent!==w?.actual&&g.parent.children.delete(l.id);let E=this.tree.get(p.toString());if(!E){E={fullId:p,actual:l,parent:w?p.parentId:null,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(l,w),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,E,w);return}if(E.actual===l){this.connectItem(l,E,w);return}const F=E.actual.children,y=E.actual,u=(0,T.diffTestItems)(y,l);(0,T.getPrivateApiFor)(y).listener=void 0,E.actual=l,E.expand=0;for(const[r,f]of u)this.onTestItemEvent(E,{op:3,key:r,value:f,previous:y[r]});this.connectItemAndChildren(l,E,w);for(const r of F)l.children.get(r.id)||this.removeItem(P.TestId.joinToString(p,r.id))}diffTagRefs(l,w,p){const g=new Set(w.map(E=>E.id));for(const E of l)g.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:p,item:{tags:l.map(E=>k.TestTag.namespace(this.controllerId,E.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const w=this.tags.get(l.id);w?w.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const w=this.tags.get(l);w&&!--w.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,w){(0,T.getPrivateApiFor)(l).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(l,w,p){this.setItemParent(l,p);const g=(0,T.getPrivateApiFor)(l);g.parent=p?.actual,g.listener=E=>this.onTestItemEvent(w,E),this.updateExpandability(w)}connectItemAndChildren(l,w,p){this.connectItem(l,w,p);for(const g of l.children)this.upsertItem(g,w)}updateExpandability(l){let w;this._resolveHandler?l.resolveBarrier?w=l.resolveBarrier.isOpen()?3:2:w=l.actual.canResolveChildren?1:0:w=0,w!==l.expand&&(l.expand=w,this.pushDiff([1,{extId:l.fullId.toString(),expand:w}]),w===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,w){if(w<0)return;const p=[];for(const g of l.actual.children){const E=this.expand(P.TestId.joinToString(l.fullId,g.id),w);(0,m.isThenable)(E)&&p.push(E)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const E=new m.Barrier;return E.open(),E}l.expand=2,this.pushExpandStateUpdate(l);const w=l.resolveBarrier=new m.Barrier,p=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=E.stack||E.message||String(E))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(E){p(E)}return(0,m.isThenable)(g)?g.catch(p).then(()=>{w.open(),this.updateExpandability(l)}):(w.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const w=this.tree.get(l);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const p=[w];for(;p.length;){const g=p.pop();if(!!g){(0,T.getPrivateApiFor)(g.actual).listener=void 0;for(const E of g.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(g.fullId.toString());for(const E of g.actual.children)p.push(this.tree.get(P.TestId.joinToString(g.fullId,E.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=R}),define(pe[221],ve([0,1,4,183]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(pe[222],ve([0,1,27,3,9]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=D;class T{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${m.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(l=>C.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const l=T._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(w=>w.identifier)),C.length>0){const w=new Set;C.forEach(p=>w.add(m.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!w.has(m.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(l)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,F){this.addNode(E),this.addNode(F),this._arcs.has(E)?this._arcs.get(E).push(F):this._arcs.set(E,[F])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,F){const y=C.getArcs(E);for(let u=0;u<y.length;u++)if(!F.has(y[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of R){const F=m.ExtensionIdentifier.toKey(E.identifier);if(l.set(F,E),E.extensionDependencies)for(let y of E.extensionDependencies){const u=m.ExtensionIdentifier.toKey(y);C.addArc(F,u)}}let w=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>w.add(E));let p=C.getNodes().filter(E=>!w.has(E)),g;do{g=!1;for(let E=0;E<p.length;E++){const F=p[E];C.hasOnlyGoodArcs(F,w)&&(p.splice(E,1),E--,w.add(F),g=!0)}}while(g);return p.map(E=>l.get(E))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(m.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=T;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function _(P,R){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==l)return C-l;const w=I.posix.basename(P.extensionLocation.path),p=I.posix.basename(R.extensionLocation.path);return w<p?-1:w>p?1:0}}),define(pe[223],ve([0,1,22]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function D(k){const _=m.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=D;function T(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=T}),define(pe[28],ve([0,1,3,2,4,27,194]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class P{constructor(f){this.dependency=f}}e.MissingExtensionDependency=P;var R;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=C;function l(r,f){return r.enabledApiProposals?r.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=l;function w(r,f){if(!l(r,f))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=w;class p{constructor(f,o,S,s){this.codeLoadingTime=f,this.activateCallTime=o,this.activateResolvedTime=S,this.activationReason=s}}e.ActivationTimes=p;class g{constructor(f,o){this.description=f,this.value=o}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var E;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function F(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=F;function y(r,f){return{identifier:new D.ExtensionIdentifier((0,T.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!f,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=y;class u{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(f){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,o){return Promise.resolve()}_onWillActivateExtension(f){}_onDidActivateExtension(f,o,S,s,i){}_onDidActivateExtensionError(f,o){}_onExtensionRuntimeError(f,o){}_onExtensionHostExit(f){}}e.NullExtensionService=u}),define(pe[224],ve([0,1,16,27,28,11]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class k{constructor(g,E,F,y){this.startup=g,this.codeLoadingTime=E,this.activateCallTime=F,this.activateResolvedTime=y}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class _{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,E){return g===-1||E===-1?-1:E-g}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class P{constructor(g,E,F,y,u,r){this.activationFailed=g,this.activationFailedError=E,this.activationTimes=F,this.module=y,this.exports=u,this.subscriptions=r}}e.ActivatedExtension=P;class R extends P{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class l extends P{constructor(g){super(!0,g,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let w=class{constructor(g,E,F,y,u){this._logService=u,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,E.forEach(r=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,F.forEach(r=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(r),r)),this._host=y,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const E=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(E)}getActivatedExtension(g){const E=t.ExtensionIdentifier.toKey(g),F=this._activatedExtensions.get(E);if(!F)throw new Error("Extension `"+g.value+"` is not known or not activated");return F}activateByEvent(g,E){if(this._alreadyActivatedEvents[g])return T;const F=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(F.map(y=>({id:y.identifier,reason:{startup:E,extensionId:y.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,E){const F=this._registry.getExtensionDescription(g);if(!F)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:F.identifier,reason:E}])}_handleActivateRequest(g,E,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){E[t.ExtensionIdentifier.toKey(g.id)]=g;return}const y=this._registry.getExtensionDescription(g.id);if(!y){const f=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,f,new I.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new l(f));return}const u=typeof y.extensionDependencies=="undefined"?[]:y.extensionDependencies;let r=!0;for(let f=0,o=u.length;f<o;f++){const S=u[f];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const s=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const a=y.displayName||y.identifier.value,h=this._registry.getExtensionDescription(S),d=h&&h.displayName||S,v=new Error(`Cannot activate the '${a}' extension because its dependency '${d}' failed to activate`);v.detail=s.activationFailedError,this._host.onExtensionActivationError(y.identifier,v,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new l(v));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){r=!1,E[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;r=!1,E[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:g.reason};continue}const n=y.displayName||y.identifier.value,c=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(y.identifier,c,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new l(c));return}r?E[t.ExtensionIdentifier.toKey(y.identifier)]=g:F.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(u=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(u.id))),g.length===0))return Promise.resolve(void 0);const E=Object.create(null),F=[];for(let u=0,r=g.length;u<r;u++)this._handleActivateRequest(g[u],E,F);for(let u=0,r=F.length;u<r;u++){const f=t.ExtensionIdentifier.toKey(F[u].id);E[f]&&delete E[f]}const y=Object.keys(E).map(u=>E[u]);return F.length===0?Promise.all(y.map(u=>this._activateExtension(u.id,u.reason))).then(u=>{}):this._activateExtensions(y).then(u=>this._activateExtensions(F))}_activateExtension(g,E){const F=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const y=this._activatingExtensions.get(F);if(y)return y;const u=this._host.actualActivateExtension(g,E).then(void 0,r=>{const f=new Error;return r&&r.name&&(f.name=r.name),r&&r.message?f.message=`Activating extension '${g.value}' failed: ${r.message}.`:f.message=`Activating extension '${g.value}' failed: ${r}.`,r&&r.stack&&(f.stack=r.stack),this._isDisposed&&m.isCancellationError(r)?new l(r):(this._host.onExtensionActivationError(g,f,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(r),new l(r))}).then(r=>{this._activatedExtensions.set(F,r),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,u),u}};w=je([ze(4,D.ILogService)],w),e.ExtensionsActivator=w}),define(pe[225],ve([0,1,11,26,28]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends m.LogService{constructor(k,_){super(k.createLogger(_.logFile,{name:I.ExtensionHostLogFileName}))}};D=je([ze(0,m.ILoggerService),ze(1,t.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(pe[226],ve([0,1,16]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,T)=>{this._actualOk=D,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,m.onUnexpectedError)(D))}then(D,T){return this._ensureActual().then(D,T)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=t}),define(pe[52],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const t=[];function I(k){const _=new m(k);return t[_.nid]=_,_}e.createProxyIdentifier=I;function D(k){return t[k].sid}e.getStringIdentifierForProxy=D;class T{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=T}),define(pe[5],ve([0,1,59,2,52]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var T;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function r(o,S){return Object.defineProperty(o,u.name,{value:S,enumerable:!0}),o}u.mixin=r;function f(o){return o[u.name]}u.of=f})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class w{static mixin(r){return r._id=w._n++,r}}e.IdObject=w,w._n=0;var p;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(u){if(u&&u.edits)for(const r of u.edits)typeof r.resource=="object"?r.resource=t.URI.revive(r.resource):(r.newUri=t.URI.revive(r.newUri),r.oldUri=t.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return u}e.reviveWorkspaceEditDto=F;var y;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(pe[89],ve([0,1,5,3,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,P){return this._proxy.$setPassword(k,_,P)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=D,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(pe[66],ve([0,1,4,11,5,14]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(_,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(I.MainContext.MainThreadTelemetry)}report(_,P,R){const C=this.getUsageKey(_,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:_}))}getUsageKey(_,P){return`${_}-${P.identifier.value}`}};T=je([ze(0,D.IExtHostRpcService),ze(1,t.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,P){}})}),define(pe[227],ve([0,1,3,5,7,27]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,P,R,C={}){const l=D.ExtensionIdentifier.toKey(_.identifier),w=this._inFlightRequests.get(l)||[],p=[...R].sort().join(" ");let g=w.find(E=>E.scopes===p);if(g)return g.result;{const E=this._getSession(_,l,P,R,C);g={scopes:p,result:E},w.push(g),this._inFlightRequests.set(l,w);try{await E}finally{const F=w.findIndex(y=>y.scopes===p);F>-1&&(w.splice(F),this._inFlightRequests.set(l,w))}return E}}async _getSession(_,P,R,C,l={}){await this._proxy.$ensureProvider(R);const w=_.displayName||_.name;return this._proxy.$getSession(R,C,P,w,l)}async removeSession(_,P){const R=this._authenticationProviders.get(_);return R?R.provider.removeSession(P):this._proxy.$removeSession(_,P)}registerAuthenticationProvider(_,P,R,C){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:P,provider:R,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(w=>w.id===_)||this._providers.push({id:_,label:P});const l=R.onDidChangeSessions(w=>{this._proxy.$sendDidChangeSessions(_,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,P,C?.supportsMultipleAccounts??!1),new I.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const w=this._providers.findIndex(p=>p.id===_);w>-1&&this._providers.splice(w),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,P){return this._onDidChangeSessions.fire({provider:{id:_,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(pe[228],ve([0,1,5,14,15]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};D=je([ze(0,t.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(pe[229],ve([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(D){const T=D.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(k){return T.$writeText(k)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[38],ve([0,1,18,7,15,25,5,17,11,59,41,48,2,6,4,14,64,22,52,49]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(c,a){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,nt(this,r,c.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new o(this,h=>{const d=this._apiCommands.get(h);return d?.result===s.Void?d:void 0},a),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,D.cloneAndChange)(h,function(d){if(R.Range.isIRange(d))return I.Range.to(d);if(C.Position.isIPosition(d))return I.Position.to(d);if(R.Range.isIRange(d.range)&&l.URI.isUri(d.uri))return I.location.to(d);if(d instanceof F.VSBuffer)return d.buffer.buffer;if(!Array.isArray(d))return d})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const a=this.registerCommand(!1,c.id,async(...h)=>{const d=c.args.map((b,A)=>{if(!b.validate(h[A]))throw new Error(`Invalid argument '${b.name}' when running '${c.id}', received: ${h[A]}`);return b.convert(h[A])}),v=await this.executeCommand(c.internalId,...d);return c.result.convert(v,h,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,a,h,d,v,b){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:h,thisArg:d,description:v,extension:b}),c&&Le(this,r,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&c&&Le(this,r,"f").$unregisterCommand(a)})}executeCommand(c,...a){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,a,!0)}async _doExecuteCommand(c,a,h){if(this._commands.has(c))return this._executeContributedCommand(c,a,!1);{let d=!1;const v=(0,D.cloneAndChange)(a,function(b){if(b instanceof t.Position)return I.Position.from(b);if(b instanceof t.Range)return I.Range.from(b);if(b instanceof t.Location)return I.location.from(b);if(t.NotebookRange.isNotebookRange(b))return I.NotebookRange.from(b);if(b instanceof ArrayBuffer)return d=!0,F.VSBuffer.wrap(new Uint8Array(b));if(b instanceof Uint8Array)return d=!0,F.VSBuffer.wrap(b);if(!Array.isArray(b))return b});try{const b=await Le(this,r,"f").$executeCommand(c,d?new y.SerializableObjectWithBuffers(v):v,h);return(0,P.revive)(b)}catch(b){if(b instanceof Error&&b.message==="$executeCommand:retry")return this._doExecuteCommand(c,a,!1);throw b}}}async _executeContributedCommand(c,a,h){const d=this._commands.get(c);if(!d)throw new Error("Unknown command");let{callback:v,thisArg:b,description:A}=d;if(A)for(let O=0;O<A.args.length;O++)try{(0,m.validateConstraint)(a[O],A.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${A.args[O].name}' - ${A.args[O].description}`)}try{return await v.apply(b,a)}catch(O){if(c===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...a);N&&(c=N.command)}throw this._logService.error(O,c,d.extension?.identifier),h?new class extends Error{constructor(){super((0,u.toErrorMessage)(O));this.id=c,this.source=d.extension?.displayName??d.extension?.name}}:O}}$executeContributedCommand(c,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(a=a.map(h=>this._argumentProcessors.reduce((d,v)=>v.processArgument(d),h)),this._executeContributedCommand(c,a,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Le(this,r,"f").$getCommands().then(a=>(c&&(a=a.filter(h=>h[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[a,h]of this._commands){let{description:d}=h;d&&(c[a]=d)}return Promise.resolve(c)}};r=new WeakMap,f=je([ze(0,g.IExtHostRpcService),ze(1,_.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class o{constructor(c,a,h){this._commands=c,this._lookupApiCommand=a,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,a){if(!c)return;const h={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return h;const d=this._lookupApiCommand(c.command);if(d)h.id=d.internalId,h.arguments=d.args.map((v,b)=>v.convert(c.arguments&&c.arguments[b]));else if((0,k.isNonEmptyArray)(c.arguments)){const v=++this._cachIdPool;this._cache.set(v,c),a.add((0,w.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),h.$ident=v,h.id=this.delegatingCommandId,h.arguments=[v],this._logService.trace("CommandsConverter#CREATE",c.command,v)}return h}fromInternal(c){const a=T.ObjectIdentifier.of(c);return typeof a=="number"?this._cache.get(a):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const a=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class S{constructor(c,a,h,d){this.name=c,this.description=a,this.validate=h,this.convert=d}optional(){return new S(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,a){return new S(c??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),S.Position=new S("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),S.Range=new S("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),S.Selection=new S("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),S.Number=new S("number","",n=>typeof n=="number",n=>n),S.String=new S("string","",n=>typeof n=="string",n=>n),S.CallHierarchyItem=new S("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",n=>n instanceof E.TestItemImpl,I.TestItem.from);class s{constructor(c,a){this.description=c,this.convert=a}}e.ApiCommandResult=s,s.Void=new s("no result",n=>n);class i{constructor(c,a,h,d,v){this.id=c,this.internalId=a,this.description=h,this.args=d,this.result=v}}e.ApiCommand=i}),define(pe[230],ve([0,1,15,7,83,38,17,111]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(m.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,w)=>{if((0,T.isFalsyOrEmpty)(l))return;class p extends t.SymbolInformation{static to(E){const F=new p(E.name,m.SymbolKind.to(E.kind),E.containerName||"",new t.Location(w[0],m.Range.to(E.range)));return F.detail=E.detail,F.range=F.location.range,F.selectionRange=m.Range.to(E.selectionRange),F.children=E.children?E.children.map(p.to):[],F}}return l.map(p.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(m.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(m.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(w=>t.Position.isPosition(w)),l=>l.map(m.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(w=>{let p;for(const g of w.reverse())p=new t.SelectionRange(m.Range.to(g),p);return p}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(m.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:m.Range.to(l.range),placeholder:l.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const w=(0,k.decodeSemanticTokensDto)(l);if(w.type==="full")return new t.SemanticTokens(w.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const w=(0,k.decodeSemanticTokensDto)(l);if(w.type==="full")return new t.SemanticTokens(w.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,w,p)=>{if(!l)return new t.CompletionList([]);const g=l.suggestions.map(E=>m.CompletionItem.to(E,p));return new t.CompletionList(g,l.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,w,p)=>R(g=>new t.CodeLens(m.Range.to(g.range),g.command&&p.fromInternal(g.command)))(l))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,w,p)=>R(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(g.command)}else{const E=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=m.WorkspaceEdit.to(g.edit)),g.command&&(E.command=p.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(l))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(w=>new t.ColorInformation(m.Range.to(w.range),m.Color.to(w.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,m.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,w,p)=>l.map(m.InlayHint.to.bind(void 0,p)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(w=>m.NotebookExclusiveDocumentPattern.to(w))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[m.ViewColumn.from(l),void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[m.ViewColumn.from(l),void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class P{static register(w){_.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=P;function R(l){return w=>{if(Array.isArray(w))return w.map(l)}}function C(l){if(!Array.isArray(l))return;const w=[];for(const p of l)I.isLocationLink(p)?w.push(m.DefinitionLink.to(p)):w.push(m.location.to(p));return w}}),define(pe[231],ve([0,1,13,56,3,6,2,83,27,15,7,28,5]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function w(p,g,E){const F=p.getProxy(l.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const c=this._commentControllers.get(n.handle);return c||n}else if(n&&n.$mid===7){const c=this._commentControllers.get(n.commentControlHandle);if(!c)return n;const a=c.getCommentThread(n.commentThreadHandle);return a||n}else if(n&&n.$mid===8){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const a=c.getCommentThread(n.thread.commentThreadHandle);return a?{thread:a,text:n.text}:n}else if(n&&n.$mid===9){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const a=c.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let h=n.commentUniqueId,d=a.getCommentByUniqueId(h);return d||n}else if(n&&n.$mid===10){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const a=c.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let h=n.text,d=n.commentUniqueId,v=a.getCommentByUniqueId(d);return v?(v.body=h,v):n}return n}})}createCommentController(n,c,a){const h=y.handlePool++,d=new r(n,h,c,a);this._commentControllers.set(d.handle,d);const v=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(n.identifier))||[];return v.push(d),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(n.identifier),v),d.value}$createCommentThreadTemplate(n,c,a){const h=this._commentControllers.get(n);!h||h.$createCommentThreadTemplate(c,a)}async $updateCommentThreadTemplate(n,c,a){const h=this._commentControllers.get(n);!h||h.$updateCommentThreadTemplate(c,a)}$deleteCommentThread(n,c){const a=this._commentControllers.get(n);a&&a.$deleteCommentThread(c)}$provideCommentingRanges(n,c,a){const h=this._commentControllers.get(n);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const d=E.getDocument(T.URI.revive(c));return(0,m.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(d,a)).then(v=>v?v.map(b=>P.Range.from(b)):void 0)}$toggleReaction(n,c,a,h,d){const v=this._commentControllers.get(n);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const b=v.getCommentThread(c);if(b){const A=b.getCommentByUniqueId(h.uniqueIdInThread);if(v!==void 0&&A&&v.reactionHandler)return v.reactionHandler(A,S(d))}return Promise.resolve(void 0)})}dispose(){}}y.handlePool=0;class u{constructor(n,c,a,h,d,v,b){this._commentControllerHandle=c,this._id=a,this._uri=h,this._range=d,this._comments=v,this.extensionDescription=b,this.handle=u._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),F.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),b.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{F.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(O){A.range=O},get comments(){return A.comments},set comments(O){A.comments=O},get collapsibleState(){return A.collapsibleState},set collapsibleState(O){A.collapsibleState=O},get canReply(){return A.canReply},set canReply(O){A.canReply=O},get contextValue(){return A.contextValue},set contextValue(O){A.contextValue=O},get label(){return A.label},set label(O){A.label=O},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const n=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),c={};n("range")&&(c.range=P.Range.from(this._range)),n("label")&&(c.label=this.label),n("contextValue")&&(c.contextValue=this.contextValue??null),n("comments")&&(c.comments=this._comments.map(a=>f(this,a,this._commentsMap))),n("collapsibleState")&&(c.collapseState=s(this._collapseState)),n("canReply")&&(c.canReply=this.canReply),this.modifications={},F.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(n){for(let c of this._commentsMap){let a=c[0],h=c[1];if(n===h)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}u._handlePool=0,je([(0,t.debounce)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class r{constructor(n,c,a,h){this._extension=n,this._handle=c,this._id=a,this._label=h,this._threads=new Map,F.$registerCommentController(this.handle,a,h);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(v){d.options=v},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(v){d.commentingRangeProvider=v},get reactionHandler(){return d.reactionHandler},set reactionHandler(v){d.reactionHandler=v},createCommentThread(v,b,A){return d.createCommentThread(v,b,A).value},dispose:()=>{d.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{F.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,F.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,F.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,F.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,c,a,h){if(typeof n=="string"){const d=new u(this.id,this.handle,n,c,a,h,this._extension);return this._threads.set(d.handle,d),d}else{const d=new u(this.id,this.handle,void 0,n,c,a,this._extension);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(n,c){const a=new u(this.id,this.handle,void 0,T.URI.revive(n),P.Range.to(c),[],this._extension);return a.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(n,c){let a=this._threads.get(n);a&&(a.range=P.Range.to(c))}$deleteCommentThread(n){let c=this._threads.get(n);c&&c.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function f(i,n,c){let a=c.get(n);a||(a=++i.commentHandle,c.set(n,a));const h=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;n.detail&&(0,C.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let d;return n.detail&&typeof n.detail!="string"?d={source:n.detail,$mid:14}:d=n.detail,{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:a,body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:h,label:n.label,commentReactions:n.reactions?n.reactions.map(v=>o(v)):void 0,detail:d}}function o(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?T.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function s(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new y}e.createExtHostComments=w}),define(pe[131],ve([0,1,2,5,7,4,14,11,17,8,9]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yi{constructor(w,p){this._logService=p,this._provider=new Map,this._proxy=w.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,p){const g=yi._handlePool++;this._provider.set(g,{provider:w,extensionId:p}),this._proxy.$registerDecorationProvider(g,p.value);const E=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(g,null);return}let y=(0,_.asArray)(F);if(y.length<=yi._maxEventSize){this._proxy.$onDidChange(g,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,y.length);const u=y.map(o=>({uri:o,rank:(0,P.count)(o.path,"/")})),r=(0,_.groupBy)(u,(o,S)=>o.rank-S.rank||(0,P.compare)(o.uri.path,S.uri.path));let f=[];e:for(let o of r){let S;for(let s of o){let i=(0,R.dirname)(s.uri.path);if(S!==i&&(S=i,f.push(s.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(g,f)});return new I.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(w,p,g){if(!this._provider.has(w))return Object.create(null);const E=Object.create(null),{provider:F,extensionId:y}=this._provider.get(w);return await Promise.all(p.map(async u=>{try{const{uri:r,id:f}=u,o=await Promise.resolve(F.provideFileDecoration(m.URI.revive(r),g));if(!o)return;try{I.FileDecoration.validate(o),E[f]=[o.propagate,o.tooltip,o.badge,o.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${y.value}': ${S}`)}}catch(r){this._logService.error(r)}})),E}};C._handlePool=0,C._maxEventSize=250,C=je([ze(0,T.IExtHostRpcService),ze(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,D.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[232],ve([0,1,163,117,2,5,7,15,3,11,24,44]),function(Z,e,m,t,I,D,T,k,_,P,R,C){"use strict";var l,w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(y,u,r,f,o,S){this._name=y,this._owner=u,this._maxDiagnosticsPerFile=r,l.set(this,void 0),w.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new R.ResourceMap(s=>f.getComparisonKey(s)),"f"),nt(this,l,o,"f"),nt(this,w,S,"f")}dispose(){this._isDisposed||(Le(this,w,"f").fire([...Le(this,p,"f").keys()]),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,u){if(!y){this.clear();return}this._checkDisposed();let r=[];if(I.URI.isUri(y)){if(!u){this.delete(y);return}Le(this,p,"f").set(y,u.slice()),r=[y]}else if(Array.isArray(y)){r=[];let o;y=[...y].sort(g._compareIndexedTuplesByUri);for(const S of y){const[s,i]=S;if((!o||s.toString()!==o.toString())&&(o&&Le(this,p,"f").get(o).length===0&&Le(this,p,"f").delete(o),o=s,r.push(s),Le(this,p,"f").set(s,[])),i){const n=Le(this,p,"f").get(s);n&&n.push(...i)}else{const n=Le(this,p,"f").get(s);n&&(n.length=0)}}}if(Le(this,w,"f").fire(r),!Le(this,l,"f"))return;const f=[];for(let o of r){let S=[];const s=Le(this,p,"f").get(o);if(s)if(s.length>this._maxDiagnosticsPerFile){S=[];const i=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let c of s)if(c.severity===i[n]&&S.push(k.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,m.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=s.map(i=>k.Diagnostic.from(i));f.push([o,S])}Le(this,l,"f").$changeMany(this._owner,f)}delete(y){this._checkDisposed(),Le(this,w,"f").fire([y]),Le(this,p,"f").delete(y),Le(this,l,"f")&&Le(this,l,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Le(this,w,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner)}forEach(y,u){this._checkDisposed();for(let r of Le(this,p,"f").keys())y.apply(u,[r,this.get(r),this])}get(y){this._checkDisposed();const u=Le(this,p,"f").get(y);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,u){return y[0].toString()<u[0].toString()?-1:y[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=g,l=new WeakMap,w=new WeakMap,p=new WeakMap;let E=class oi{constructor(y,u,r){this._logService=u,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=y.getProxy(D.MainContext.MainThreadDiagnostics)}static _mapper(y){const u=new R.ResourceMap;for(const r of y)u.set(r,r);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(y,u){const{_collections:r,_proxy:f,_onDidChangeDiagnostics:o,_logService:S,_fileSystemInfoService:s}=this,i=new class{$changeMany(a,h){f.$changeMany(a,h),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,a,h.length===0?"CLEARING":h)}$clear(a){f.$clear(a),S.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,a)}dispose(){f.dispose()}};let n;if(!u)u="_generated_diagnostic_collection_name_#"+oi._idPool++,n=u;else if(!r.has(u))n=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do n=u+oi._idPool++;while(r.has(n))}return new class extends g{constructor(){super(u,n,oi._maxDiagnosticsPerFile,s.extUri,i,o);r.set(n,this)}dispose(){super.dispose(),r.delete(n)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const u=new Map,r=[];for(const f of this._collections.values())f.forEach((o,S)=>{let s=u.get(o.toString());typeof s=="undefined"&&(s=r.length,u.set(o.toString(),s),r.push([o,[]])),r[s][1]=r[s][1].concat(...S)});return r}}_getDiagnostics(y){let u=[];for(let r of this._collections.values())r.has(y)&&(u=u.concat(r.get(y)));return u}$acceptMarkersChange(y){if(!this._mirrorCollection){const u="_generated_mirror",r=new g(u,u,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(u,r),this._mirrorCollection=r}for(const[u,r]of y)this._mirrorCollection.set(I.URI.revive(u),r.map(k.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=je([ze(1,P.ILogService),ze(2,C.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(pe[233],ve([0,1,2,5]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(T){this._proxy=T.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(k=>k?k.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(pe[234],ve([0,1,16,2,7,5,10,21,8]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,l,w){this._documentsAndEditors=l,this._logService=w,this._documentContentProviders=new Map,this._proxy=C.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(T.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const w=P._handlePool++;this._documentContentProviders.set(w,l),this._proxy.$registerTextContentProvider(w,C);let p;return typeof l.onDidChange=="function"&&(p=l.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(w,g).then(E=>{if(!E&&typeof E!="string")return;const F=this._documentsAndEditors.getDocument(g);if(!F)return;const y=(0,_.splitLines)(E);if(!F.equalLines(y))return this._proxy.$onVirtualDocumentChange(g,E)},m.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(C,l){const w=this._documentContentProviders.get(C);return w?Promise.resolve(w.provideTextDocumentContent(t.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(pe[235],ve([0,1,3,6,2,5,123,15,18,25,7]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(w,p){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const E of g)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const E of g)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const p=this._documentsAndEditors.getDocument(w);if(p)return p}getDocument(w){const p=this.getDocumentData(w);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return p.document}ensureDocumentData(w){const p=this._documentsAndEditors.getDocument(w);if(p)return Promise.resolve(p);let g=this._documentLoader.get(w.toString());return g||(g=this._proxy.$tryOpenDocument(w).then(E=>{this._documentLoader.delete(w.toString());const F=I.URI.revive(E);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(F))},E=>(this._documentLoader.delete(w.toString()),Promise.reject(E))),this._documentLoader.set(w.toString(),g)),g}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged(w,p){const g=I.URI.revive(w),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(p),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(w){const p=I.URI.revive(w),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(w,p){const g=I.URI.revive(w),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");E._acceptIsDirty(p),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,p,g){const E=I.URI.revive(w),F=this._documentsAndEditors.getDocument(E);if(!F)throw new Error("unknown document");F._acceptIsDirty(g),F.onEvents(p);let y;p.isUndoing?y=R.TextDocumentChangeReason.Undo:p.isRedoing&&(y=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:F.document,contentChanges:p.changes.map(u=>({range:k.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:y}))}setWordDefinitionFor(w,p){(0,T.setWordDefinitionFor)(w,p)}}e.ExtHostDocuments=C}),define(pe[45],ve([0,1,55,3,6,2,4,5,123,14,130,15,11,24,10,78,92]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(r,f){this._extHostRpc=r,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const f=[],o=[],S=[];if(r.removedDocuments)for(const s of r.removedDocuments){const i=D.URI.revive(s),n=this._documents.get(i);n?.unref()&&(this._documents.delete(i),f.push(n.value))}if(r.addedDocuments)for(const s of r.addedDocuments){const i=D.URI.revive(s.uri);let n=this._documents.get(i);if(n&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);n||(n=new F(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,n),o.push(n.value)),n.ref()}if(r.removedEditors)for(const s of r.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&S.push(i)}if(r.addedEditors)for(const s of r.addedEditors){const i=D.URI.revive(s.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const n=this._documents.get(i).value,c=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>n.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(a=>C.Range.to(a)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,c)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,I.dispose)(f),(0,I.dispose)(S),r.removedDocuments&&this._onDidRemoveDocuments.fire(f),r.addedDocuments&&this._onDidAddDocuments.fire(o),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return r?f:f?.value}allEditors(){return[...this._editors.values()]}};y=je([ze(0,P.IExtHostRpcService),ze(1,l.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([0,1,15,5,2,3,4,14,13]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let P=class{constructor(C){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new D.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=C.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(C){let l=-1;this._tabs=C.map((p,g)=>(p.isActive&&(l=g),Object.freeze({label:p.label,viewColumn:m.ViewColumn.to(p.viewColumn),index:g,resource:I.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:E,viewId:F})=>({resource:I.URI.revive(E),viewId:F})),viewId:p.editorId,isActive:p.isActive,move:async(E,F)=>{this._proxy.$moveTab(p,E,m.ViewColumn.from(F)),await(0,_.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,_.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,g)=>p.viewColumn===g.viewColumn?p.index-g.index:p.viewColumn-g.viewColumn);const w=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==w&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([ze(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(pe[236],ve([0,1,2,5,6,7,15,147,8,22,28]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const g=this._schemes.indexOf(p);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),g=[];let E,F,y=14,u=14;for(const r of p){let f=E?(0,_.commonPrefixLength)(E,r):0;for(f===0?F=1:F=u;f<r.length;f++)f+1===r.length?(y=u,u=9):u+=1,g.push([F,r.toUpperCase().charCodeAt(f),u]),g.push([F,r.toLowerCase().charCodeAt(f),u]),F=u;E=r,u=y}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new k.StateMachine(g)}}provideDocumentLinks(p){this._initStateMachine();const g=[],E=k.LinkComputer.computeLinks({getLineContent(F){return p.lineAt(F-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const F of E){const y=T.DocumentLink.to(F);y.target&&g.push(y)}return g}}class l{constructor(p,g){this._extHostLanguageFeatures=g,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,g,E,F={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const y=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(y,E);let u=2;F.isCaseSensitive&&(u+=1024),F.isReadonly&&(u+=2048),typeof E.copy=="function"&&(u+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),u+=4),this._proxy.$registerFileSystemProvider(y,g,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${g}`),console.error(f)});const r=E.onDidChangeFile(f=>{const o=[];for(const S of f){let{uri:s,type:i}=S;if(s.scheme!==g)continue;let n;switch(i){case D.FileChangeType.Changed:n=0;break;case D.FileChangeType.Created:n=1;break;case D.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:s,type:n})}this._proxy.$onFileSystemChange(y,o)});return(0,I.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(p){const{type:g,ctime:E,mtime:F,size:y,permissions:u}=p;return{type:g,ctime:E,mtime:F,size:y,permissions:u}}$stat(p,g){return Promise.resolve(this._getFsProvider(p).stat(m.URI.revive(g))).then(E=>l._asIStat(E))}$readdir(p,g){return Promise.resolve(this._getFsProvider(p).readDirectory(m.URI.revive(g)))}$readFile(p,g){return Promise.resolve(this._getFsProvider(p).readFile(m.URI.revive(g))).then(E=>P.VSBuffer.wrap(E))}$writeFile(p,g,E,F){return Promise.resolve(this._getFsProvider(p).writeFile(m.URI.revive(g),E.buffer,F))}$delete(p,g,E){return Promise.resolve(this._getFsProvider(p).delete(m.URI.revive(g),E))}$rename(p,g,E,F){return Promise.resolve(this._getFsProvider(p).rename(m.URI.revive(g),m.URI.revive(E),F))}$copy(p,g,E,F){const y=this._getFsProvider(p);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(m.URI.revive(g),m.URI.revive(E),F))}$mkdir(p,g){return Promise.resolve(this._getFsProvider(p).createDirectory(m.URI.revive(g)))}$watch(p,g,E,F){const y=this._getFsProvider(p).watch(m.URI.revive(E),F);this._watches.set(g,y)}$unwatch(p,g){const E=this._watches.get(g);E&&(E.dispose(),this._watches.delete(g))}$open(p,g,E){const F=this._getFsProvider(p);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(m.URI.revive(g),E))}$close(p,g){const E=this._getFsProvider(p);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(g))}$read(p,g,E,F){const y=this._getFsProvider(p);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const u=P.VSBuffer.alloc(F);return Promise.resolve(y.read(g,E,u.buffer,0,F)).then(r=>u.slice(0,r))}$write(p,g,E,F){const y=this._getFsProvider(p);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(g,E,F.buffer,0,F.byteLength))}_getFsProvider(p){const g=this._fsProvider.get(p);if(!g){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return g}}e.ExtHostFileSystem=l}),define(pe[67],ve([0,1,5,42,7,22,4,14,44,6]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class xt{constructor(l,w){this._fileSystemProvider=new Map,this._proxy=l.getProxy(m.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(g){try{const E=p._fileSystemProvider.get(g.scheme);if(!E)return await p._proxy.$stat(g);await p._proxy.$ensureActivation(g.scheme);const F=await E.stat(g);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(E){xt._handleError(E)}},async readDirectory(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readDirectory(g)).slice()):await p._proxy.$readdir(g)}catch(E){return xt._handleError(E)}},async createDirectory(g){try{return await p._proxy.$mkdir(g)}catch(E){return xt._handleError(E)}},async readFile(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readFile(g)).slice()):(await p._proxy.$readFile(g)).buffer}catch(E){return xt._handleError(E)}},async writeFile(g,E){try{return await p._proxy.$writeFile(g,D.VSBuffer.wrap(E))}catch(F){return xt._handleError(F)}},async delete(g,E){try{const F=p._fileSystemProvider.get(g.scheme);return F?(await p._proxy.$ensureActivation(g.scheme),await F.delete(g,{recursive:!1,...E})):await p._proxy.$delete(g,{recursive:!1,useTrash:!1,...E})}catch(F){return xt._handleError(F)}},async rename(g,E,F){try{return await p._proxy.$rename(g,E,{overwrite:!1,...F})}catch(y){return xt._handleError(y)}},async copy(g,E,F){try{return await p._proxy.$copy(g,E,{overwrite:!1,...F})}catch(y){return xt._handleError(y)}},isWritableFileSystem(g){const E=w.getCapabilities(g);if(typeof E=="number")return!(E&2048)}})}static _handleError(l){if(l instanceof I.FileSystemError)throw l;if(!(l instanceof Error))throw new I.FileSystemError(String(l));if(l.name==="ENOPRO")throw I.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(l.message);default:throw new I.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,w){return this._fileSystemProvider.set(l,w),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(l))}};R=je([ze(0,k.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[237],ve([0,1,3,32,2,5,15,7]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(C,l,w,p,g,E,F,y){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter;const u=this.ensureWatching(C,w,g);this._config=0,E&&(this._config+=1),F&&(this._config+=2),y&&(this._config+=4);const r=(0,t.parse)(g),f=typeof g=="string",o=p(S=>{if(!E)for(let s of S.created){const i=I.URI.revive(s);r(i.fsPath)&&(!f||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!F)for(let s of S.changed){const i=I.URI.revive(s);r(i.fsPath)&&(!f||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!y)for(let s of S.deleted){const i=I.URI.revive(s);r(i.fsPath)&&(!f||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(u,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(C,l,w){let p=k.Disposable.from();if(typeof w=="string")return p;const g=C.getProxy(D.MainContext.MainThreadFileSystem);let E=!1;(w.pattern.includes(t.GLOBSTAR)||w.pattern.includes(t.GLOB_SPLIT))&&(E=!0);const F=Math.random();return g.$watch(l.identifier.value,F,w.baseUri,{recursive:E,excludes:[]}),k.Disposable.from({dispose:()=>g.$unwatch(F)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,l,w){this._mainContext=C,this._logService=l,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,l,w,p,g,E){return new _(this._mainContext,C,l,this._onFileSystemEvent.event,T.GlobPattern.from(w),p,g,E)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,l){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(w=>({oldUri:I.URI.revive(w.source),newUri:I.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(w=>I.URI.revive(w.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(w=>I.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,l){return(w,p,g)=>{const E=function(y){w.call(p,y)};return E.extension=C,l.event(E,void 0,g)}}async $onWillRunFileOperation(C,l,w,p){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))},w,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(g=>I.URI.revive(g.target))},w,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(g=>I.URI.revive(g.target))},w,p)}}async _fireWillEvent(C,l,w,p){const g=new Set,E=[];if(await C.fireAsync(l,p,async(y,u)=>{const r=Date.now(),f=await Promise.resolve(y);f instanceof k.WorkspaceEdit&&(E.push(f),g.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-r>w&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),p.isCancellationRequested||E.length===0)return;const F={edits:[]};for(let y of E){let{edits:u}=T.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);F.edits=F.edits.concat(u)}return{edit:F,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=P}),define(pe[238],ve([0,1,2,38]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,k,_,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=P;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new t.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new t.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new t.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new t.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:m.URI.revive(C.notebookUri),inputUri:m.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(C.notebookUri),inputUri:m.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(T,k,_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(pe[239],ve([0,1,6,5]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,T),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(pe[240],ve([0,1,2,25,15,7,5,8,41,17,18,145,21,6,111,77,86,46,16,3,13]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentSymbols(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentSymbols(G,te);if(!(0,P.isFalsyOrEmpty)(X))return X[0]instanceof D.DocumentSymbol?X.map(I.DocumentSymbol.from):f._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((X,oe)=>{let me=X.location.range.start.compareTo(oe.location.range.start);return me===0&&(me=oe.location.range.end.compareTo(X.location.range.end)),me});const te=[],G=[];for(const X of q){const oe={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(oe),te.push(oe);break}const me=G[G.length-1];if(_.Range.containsRange(me.range,oe.range)&&!_.Range.equalsRange(me.range,oe.range)){me.children&&me.children.push(oe),G.push(oe);break}G.pop()}}return te}}class o{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideCodeLenses(G,te);if(!X||te.isCancellationRequested)return;const oe=this._cache.add(X),me=new w.DisposableStore;this._disposables.set(oe,me);const Ie={cacheId:oe,lenses:[]};for(let We=0;We<X.length;We++)Ie.lenses.push({cacheId:[oe,We],range:I.Range.from(X[We].range),command:this._commands.toInternal(X[We].command,me)});return Ie}async resolveCodeLens(q,te){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,te),X||(X=G),te.isCancellationRequested)return;const oe=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!oe)return q.command=this._commands.toInternal(X.command??o._badCmd,oe),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Je){return Array.isArray(Je)?Je.map(I.DefinitionLink.from):Je?[I.DefinitionLink.from(Je)]:[]}class s{constructor(q,te){this._documents=q,this._provider=te}async provideDefinition(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDefinition(X,oe,G);return S(me)}}class i{constructor(q,te){this._documents=q,this._provider=te}async provideDeclaration(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDeclaration(X,oe,G);return S(me)}}class n{constructor(q,te){this._documents=q,this._provider=te}async provideImplementation(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideImplementation(X,oe,G);return S(me)}}class c{constructor(q,te){this._documents=q,this._provider=te}async provideTypeDefinition(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideTypeDefinition(X,oe,G);return S(me)}}class a{constructor(q,te){this._documents=q,this._provider=te}async provideHover(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideHover(X,oe,G);if(!(!me||(0,P.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=X.getWordRangeAtPosition(oe)),me.range||(me.range=new D.Range(oe,oe)),I.Hover.from(me)}}class h{constructor(q,te){this._documents=q,this._provider=te}async provideEvaluatableExpression(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideEvaluatableExpression(X,oe,G);if(me)return I.EvaluatableExpression.from(me)}}class d{constructor(q,te){this._documents=q,this._provider=te}async provideInlineValues(q,te,G,X){const oe=this._documents.getDocument(q),me=await this._provider.provideInlineValues(oe,I.Range.to(te),I.InlineValueContext.to(G),X);if(Array.isArray(me))return me.map(Ie=>I.InlineValue.from(Ie))}}class v{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentHighlights(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDocumentHighlights(X,oe,G);if(Array.isArray(me))return me.map(I.DocumentHighlight.from)}}class b{constructor(q,te){this._documents=q,this._provider=te}async provideLinkedEditingRanges(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideLinkedEditingRanges(X,oe,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,P.coalesce)(me.ranges.map(I.Range.from)),wordPattern:me.wordPattern}}}class A{constructor(q,te){this._documents=q,this._provider=te}async provideReferences(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideReferences(oe,me,G,X);if(Array.isArray(Ie))return Ie.map(I.location.from)}}class O{constructor(q,te,G,X,oe,me,Ie){this._documents=q,this._commands=te,this._diagnostics=G,this._provider=X,this._logService=oe,this._extension=me,this._apiDeprecation=Ie,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,te,G,X){const oe=this._documents.getDocument(q),me=C.Selection.isISelection(te)?I.Selection.to(te):I.Range.to(te),Ie=[];for(const tt of this._diagnostics.getDiagnostics(q))if(me.intersection(tt.range)&&Ie.push(tt)>O._maxCodeActionsPerFile)break;const We={diagnostics:Ie,only:G.only?new D.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Ye=await this._provider.provideCodeActions(oe,me,We,X);if(!(0,P.isNonEmptyArray)(Ye)||X.isCancellationRequested)return;const it=this._cache.add(Ye),st=new w.DisposableStore;this._disposables.set(it,st);const ot=[];for(let tt=0;tt<Ye.length;tt++){const rt=Ye[tt];!rt||(O._isCommand(rt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,st)})):(We.only&&(rt.kind?We.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[it,tt],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,st),diagnostics:rt.diagnostics&&rt.diagnostics.map(I.Diagnostic.from),edit:rt.edit&&I.WorkspaceEdit.from(rt.edit),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,disabled:rt.disabled?.reason})))}return{cacheId:it,actions:ot}}async resolveCodeAction(q,te){const[G,X]=q,oe=this._cache.get(G,X);if(!oe||O._isCommand(oe)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(oe,te)??oe;return me?.edit?I.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class N{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentFormattingEdits(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideDocumentFormattingEdits(X,te,G);if(Array.isArray(oe))return oe.map(I.TextEdit.from)}}class L{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeFormattingEdits(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Range.to(te),Ie=await this._provider.provideDocumentRangeFormattingEdits(oe,me,G,X);if(Array.isArray(Ie))return Ie.map(I.TextEdit.from)}}class M{constructor(q,te){this._documents=q,this._provider=te,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,te,G,X,oe){const me=this._documents.getDocument(q),Ie=I.Position.to(te),We=await this._provider.provideOnTypeFormattingEdits(me,Ie,G,X,oe);if(Array.isArray(We))return We.map(I.TextEdit.from)}}class V{constructor(q,te){this._provider=q,this._logService=te,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,te){const G=T.IdObject.mixin({symbols:[]}),X=await this._provider.provideWorkspaceSymbols(q,te);if((0,P.isNonEmptyArray)(X))for(const oe of X){if(!oe)continue;if(!oe.name){this._logService.warn("INVALID SymbolInformation, lacks name",oe);continue}const me=T.IdObject.mixin(I.WorkspaceSymbol.from(oe));this._symbolCache.set(me._id,oe),G.symbols.push(me)}return G.symbols.length>0&&this._resultCache.set(G._id,[G.symbols[0]._id,G.symbols[G.symbols.length-1]._id]),G}async resolveWorkspaceSymbol(q,te){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const G=this._symbolCache.get(q._id);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,te);return X&&(0,t.mixin)(q,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(q){const te=this._resultCache.get(q);if(te){for(let[G,X]=te;G<=X;G++)this._symbolCache.delete(G);this._resultCache.delete(q)}}}class H{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Position.to(te);try{const Ie=await this._provider.provideRenameEdits(oe,me,G,X);return Ie?I.WorkspaceEdit.from(Ie):void 0}catch(Ie){const We=H._asMessage(Ie);return We?{rejectReason:We,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(q,te,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(q),oe=I.Position.to(te);try{const me=await this._provider.prepareRename(X,oe,G);let Ie,We;if(D.Range.isRange(me)?(Ie=me,We=X.getText(me)):(0,R.isObject)(me)&&(Ie=me.range,We=me.placeholder),!Ie||!We)return;if(Ie.start.line>oe.line||Ie.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ie),text:We}}catch(me){const Ie=H._asMessage(me);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class U{constructor(q,te){this.resultId=q,this.tokens=te}}class B{constructor(q,te){this._documents=q,this._provider=te,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,te,G){const X=this._documents.getDocument(q),oe=te!==0?this._previousResults.get(te):null;let me=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,oe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return oe&&this._previousResults.delete(te),me?(me=B._fixProvidedSemanticTokens(me),this._send(B._convertToEdits(oe,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return B._isSemanticTokens(q)?B._isCorrectSemanticTokens(q)?q:new D.SemanticTokens(new Uint32Array(q.data),q.resultId):B._isSemanticTokensEdits(q)?B._isCorrectSemanticTokensEdits(q)?q:new D.SemanticTokensEdits(q.edits.map(te=>new D.SemanticTokensEdit(te.start,te.deleteCount,te.data?new Uint32Array(te.data):te.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const te of q.edits)if(!(te.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,te){if(!B._isSemanticTokens(te)||!q||!q.tokens)return te;const G=q.tokens,X=G.length,oe=te.data,me=oe.length;let Ie=0;const We=Math.min(X,me);for(;Ie<We&&G[Ie]===oe[Ie];)Ie++;if(Ie===X&&Ie===me)return new D.SemanticTokensEdits([],te.resultId);let Ye=0;const it=We-Ie;for(;Ye<it&&G[X-Ye-1]===oe[me-Ye-1];)Ye++;return new D.SemanticTokensEdits([{start:Ie,deleteCount:X-Ie-Ye,data:oe.subarray(Ie,me-Ye)}],te.resultId)}_send(q,te){if(B._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new U(q.resultId,q.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if(B._isSemanticTokensEdits(q)){const G=this._nextResultId++;return B._isSemanticTokens(te)?this._previousResults.set(G,new U(te.resultId,te.data)):this._previousResults.set(G,new U(q.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class ${constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeSemanticTokens(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(te),G);return oe?this._send(oe):null}_send(q){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=$;class z{constructor(q,te,G,X,oe){this._documents=q,this._commands=te,this._provider=G,this._apiDeprecation=X,this._extension=oe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=oe.getWordRangeAtPosition(me)||new D.Range(me,me),We=Ie.with({end:me}),Ye=new F.StopWatch(!0),it=await this._provider.provideCompletionItems(oe,me,X,I.CompletionContext.to(G));if(!it||X.isCancellationRequested)return;const st=Array.isArray(it)?new D.CompletionList(it):it,ot=z.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),tt=new w.DisposableStore;this._disposables.set(ot,tt);const rt=[],gt={x:ot,b:rt,a:{replace:I.Range.from(Ie),insert:I.Range.from(We)},c:st.isIncomplete||void 0,d:Ye.elapsed()};for(let Ue=0;Ue<st.items.length;Ue++){const It=st.items[Ue],ee=this._convertCompletionItem(It,[ot,Ue],We,Ie);rt.push(ee)}return gt}async resolveCompletionItem(q,te){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveCompletionItem(G,te);if(!!X)return this._convertCompletionItem(X,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,te,G,X){const oe=this._disposables.get(te[0]);if(!oe)throw Error("DisposableStore is missing...");const me={x:te,a:q.label,b:q.kind!==void 0?I.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(I.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(q.command,oe)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof D.SnippetString&&(me.h=q.insertText.value,me.i|=4);let Ie;return q.textEdit?Ie=q.textEdit.range:q.range&&(Ie=q.range),D.Range.isRange(Ie)?me.j=I.Range.from(Ie):Ie&&(!G?.isEqual(Ie.inserting)||!X?.isEqual(Ie.replacing))&&(me.j={insert:I.Range.from(Ie.inserting),replace:I.Range.from(Ie.replacing)}),me}}class W{constructor(q,te,G){this._documents=q,this._provider=te,this._commands=G,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideInlineCompletionItems(oe,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},X);if(!Ie||X.isCancellationRequested)return;const We=(0,R.isArray)(Ie)?{items:Ie}:Ie,Ye=this._cache.add(We.items);let it;return{pid:Ye,items:We.items.map((st,ot)=>{let tt;return st.command&&(it||(it=new w.DisposableStore,this._disposables.set(Ye,it)),tt=this._commands.toInternal(st.command,it)),{text:st.text,range:st.range?I.Range.from(st.range):void 0,command:tt,idx:ot}})}}disposeCompletions(q){this._cache.delete(q);const te=this._disposables.get(q);te&&te.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,te){const G=this._cache.get(q,te);G&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let te=J.map.get(q);return te||(te=new J,J.map.set(q,te)),te}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=J,J.map=new WeakMap;class ne{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("SignatureHelp")}async provideSignatureHelp(q,te,G,X){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=this.reviveContext(G),We=await this._provider.provideSignatureHelp(oe,me,X,Ie);if(We){const Ye=this._cache.add([We]);return{...I.SignatureHelp.from(We),id:Ye}}}reviveContext(q){let te;if(q.activeSignatureHelp){const G=I.SignatureHelp.to(q.activeSignatureHelp),X=this._cache.get(q.activeSignatureHelp.id,0);X?(te=X,te.activeSignature=G.activeSignature,te.activeParameter=G.activeParameter):te=G}return{...q,activeSignatureHelp:te}}releaseSignatureHelp(q){this._cache.delete(q)}}class se{constructor(q,te,G,X,oe){this._documents=q,this._commands=te,this._provider=G,this._logService=X,this._extension=oe,this._cache=new E.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,te,G){const X=this._documents.getDocument(q),oe=I.Range.to(te),me=await this._provider.provideInlayHints(X,oe,G);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${te}`);return}if(G.isCancellationRequested)return;const Ie=this._cache.add(me);this._disposables.set(Ie,new w.DisposableStore);const We={hints:[],cacheId:Ie};for(let Ye=0;Ye<me.length;Ye++)this._isValidInlayHint(me[Ye],oe)&&We.hints.push(this._convertInlayHint(me[Ye],[Ie,Ye]));return this._logService.trace(`[InlayHints] ${We.hints.length} inlay hints from '${this._extension.identifier.value}' for ${te}`),We}async resolveInlayHint(q,te){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveInlayHint(G,te);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,te){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(te&&!te.contains(q.position))}_convertInlayHint(q,te){const G=this._disposables.get(te[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:te,tooltip:q.tooltip&&I.MarkdownString.from(q.tooltip),position:I.Position.from(q.position),kind:I.InlayHintKind.from(q.kind??D.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter};return typeof q.label=="string"?X.label=q.label:X.label=q.label.map(oe=>{let me={label:oe.label};return me.collapsible=oe.collapsible,D.Location.isLocation(oe.action)?me.action=I.location.from(oe.action):oe.action&&(me.action=this._commands.toInternal(oe.action,G)),me}),X}}class K{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("DocumentLink")}async provideLinks(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentLinks(G,te);if(!(!Array.isArray(X)||X.length===0)&&!te.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(K._validateLink).map(I.DocumentLink.from)};{const oe=this._cache.add(X),me={links:[],id:oe};for(let Ie=0;Ie<X.length;Ie++){if(!K._validateLink(X[Ie]))continue;const We=I.DocumentLink.from(X[Ie]);We.cacheId=[oe,Ie],me.links.push(We)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,te){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveDocumentLink(G,te);if(!(!X||!K._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,te){this._documents=q,this._provider=te}async provideColors(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentColors(G,te);return Array.isArray(X)?X.map(me=>({color:I.Color.from(me.color),range:I.Range.from(me.range)})):[]}async provideColorPresentations(q,te,G){const X=this._documents.getDocument(q),oe=I.Range.to(te.range),me=I.Color.to(te.color),Ie=await this._provider.provideColorPresentations(me,{document:X,range:oe},G);if(!!Array.isArray(Ie))return Ie.map(I.ColorPresentation.from)}}class ae{constructor(q,te){this._documents=q,this._provider=te}async provideFoldingRanges(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideFoldingRanges(X,te,G);if(!!Array.isArray(oe))return oe.map(I.FoldingRange.from)}}class fe{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}async provideSelectionRanges(q,te,G){const X=this._documents.getDocument(q),oe=te.map(I.Position.to),me=await this._provider.provideSelectionRanges(X,oe,G);if(!(0,P.isNonEmptyArray)(me))return[];if(me.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let We=0;We<oe.length;We++){const Ye=[];Ie.push(Ye);let it=oe[We],st=me[We];for(;;){if(!st.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(I.SelectionRange.from(st)),!st.parent)break;it=st.range,st=st.parent}}return Ie}}class be{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareCallHierarchy(X,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(Ie,We)):[this._cacheAndConvertItem(Ie,me)]}async provideCallsTo(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!oe)return oe.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}async provideCallsFrom(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!oe)return oe.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),X=I.CallHierarchyItem.from(te,q,G.size.toString(36));return G.set(X._itemId,te),X}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Me{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const X=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareTypeHierarchy(X,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(Ie,We)):[this._cacheAndConvertItem(Ie,me)]}async provideSupertypes(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),X=I.TypeHierarchyItem.from(te,q,G.size.toString(36));return G.set(X._itemId,te),X}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class xe{constructor(q,te){this.adapter=q,this.extension=te}}class Ge{constructor(q,te,G,X,oe,me,Ie){this._adapter=new Map,this._uriTransformer=te,this._proxy=q.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=oe,this._logService=me,this._apiDeprecation=Ie}_transformDocumentSelector(q){return I.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new D.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ge._handlePool++}async _withAdapter(q,te,G,X,oe){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof te))return X;const Ie=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${te.name}'`);const We=G(me.adapter,me.extension);return Promise.resolve(We).catch(Ye=>{(0,y.isCancellationError)(Ye)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Ye))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),l.CancellationToken.isCancellationToken(oe)?(0,r.raceCancellationError)(We,oe):We}_addNewAdapter(q,te){const G=this._nextHandle();return this._adapter.set(G,new xe(q,te)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,te,G,X){const oe=this._addNewAdapter(new f(this._documents,G),q),me=X&&X.label||Ge._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(te),me),this._createDisposable(oe)}$provideDocumentSymbols(q,te,G){return this._withAdapter(q,f,X=>X.provideDocumentSymbols(m.URI.revive(te),G),void 0)}registerCodeLensProvider(q,te,G){const X=this._nextHandle(),oe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new xe(new o(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(te),oe);let me=this._createDisposable(X);if(oe!==void 0){const Ie=G.onDidChangeCodeLenses(We=>this._proxy.$emitCodeLensEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideCodeLenses(q,te,G){return this._withAdapter(q,o,X=>X.provideCodeLenses(m.URI.revive(te),G),void 0)}$resolveCodeLens(q,te,G){return this._withAdapter(q,o,X=>X.resolveCodeLens(te,G),void 0)}$releaseCodeLenses(q,te){this._withAdapter(q,o,G=>Promise.resolve(G.releaseCodeLenses(te)),void 0)}registerDefinitionProvider(q,te,G){const X=this._addNewAdapter(new s(this._documents,G),q);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDefinition(q,te,G,X){return this._withAdapter(q,s,oe=>oe.provideDefinition(m.URI.revive(te),G,X),[])}registerDeclarationProvider(q,te,G){const X=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDeclaration(q,te,G,X){return this._withAdapter(q,i,oe=>oe.provideDeclaration(m.URI.revive(te),G,X),[])}registerImplementationProvider(q,te,G){const X=this._addNewAdapter(new n(this._documents,G),q);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideImplementation(q,te,G,X){return this._withAdapter(q,n,oe=>oe.provideImplementation(m.URI.revive(te),G,X),[])}registerTypeDefinitionProvider(q,te,G){const X=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideTypeDefinition(q,te,G,X){return this._withAdapter(q,c,oe=>oe.provideTypeDefinition(m.URI.revive(te),G,X),[])}registerHoverProvider(q,te,G,X){const oe=this._addNewAdapter(new a(this._documents,G),q);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideHover(q,te,G,X){return this._withAdapter(q,a,oe=>oe.provideHover(m.URI.revive(te),G,X),void 0)}registerEvaluatableExpressionProvider(q,te,G,X){const oe=this._addNewAdapter(new h(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideEvaluatableExpression(q,te,G,X){return this._withAdapter(q,h,oe=>oe.provideEvaluatableExpression(m.URI.revive(te),G,X),void 0)}registerInlineValuesProvider(q,te,G,X){const oe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new d(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(te),oe);let Ie=this._createDisposable(me);if(oe!==void 0){const We=G.onDidChangeInlineValues(Ye=>this._proxy.$emitInlineValuesEvent(oe));Ie=D.Disposable.from(Ie,We)}return Ie}$provideInlineValues(q,te,G,X,oe){return this._withAdapter(q,d,me=>me.provideInlineValues(m.URI.revive(te),G,X,oe),void 0)}registerDocumentHighlightProvider(q,te,G){const X=this._addNewAdapter(new v(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDocumentHighlights(q,te,G,X){return this._withAdapter(q,v,oe=>oe.provideDocumentHighlights(m.URI.revive(te),G,X),void 0)}registerLinkedEditingRangeProvider(q,te,G){const X=this._addNewAdapter(new b(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideLinkedEditingRanges(q,te,G,X){return this._withAdapter(q,b,async oe=>{const me=await oe.provideLinkedEditingRanges(m.URI.revive(te),G,X);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?Ge._serializeRegExp(me.wordPattern):void 0}},void 0)}registerReferenceProvider(q,te,G){const X=this._addNewAdapter(new A(this._documents,G),q);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideReferences(q,te,G,X,oe){return this._withAdapter(q,A,me=>me.provideReferences(m.URI.revive(te),G,X,oe),void 0)}registerCodeActionProvider(q,te,G,X){const oe=new w.DisposableStore,me=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(te),{providedKinds:X?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:X?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this._commands.converter.toInternal(Ie.command,oe)}))},Ge._extLabel(q),Boolean(G.resolveCodeAction)),oe.add(this._createDisposable(me)),oe}$provideCodeActions(q,te,G,X,oe){return this._withAdapter(q,O,me=>me.provideCodeActions(m.URI.revive(te),G,X,oe),void 0)}$resolveCodeAction(q,te,G){return this._withAdapter(q,O,X=>X.resolveCodeAction(te,G),void 0)}$releaseCodeActions(q,te){this._withAdapter(q,O,G=>Promise.resolve(G.releaseCodeActions(te)),void 0)}registerDocumentFormattingEditProvider(q,te,G){const X=this._addNewAdapter(new N(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentFormattingEdits(q,te,G,X){return this._withAdapter(q,N,oe=>oe.provideDocumentFormattingEdits(m.URI.revive(te),G,X),void 0)}registerDocumentRangeFormattingEditProvider(q,te,G){const X=this._addNewAdapter(new L(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(q,te,G,X,oe){return this._withAdapter(q,L,me=>me.provideDocumentRangeFormattingEdits(m.URI.revive(te),G,X,oe),void 0)}registerOnTypeFormattingEditProvider(q,te,G,X){const oe=this._addNewAdapter(new M(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(te),X,q.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(q,te,G,X,oe,me){return this._withAdapter(q,M,Ie=>Ie.provideOnTypeFormattingEdits(m.URI.revive(te),G,X,oe,me),void 0)}registerWorkspaceSymbolProvider(q,te){const G=this._addNewAdapter(new V(te,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof te.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,te,G){return this._withAdapter(q,V,X=>X.provideWorkspaceSymbols(te,G),{symbols:[]})}$resolveWorkspaceSymbol(q,te,G){return this._withAdapter(q,V,X=>X.resolveWorkspaceSymbol(te,G),void 0)}$releaseWorkspaceSymbols(q,te){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(te),void 0)}registerRenameProvider(q,te,G){const X=this._addNewAdapter(new H(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(te),H.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(q,te,G,X,oe){return this._withAdapter(q,H,me=>me.provideRenameEdits(m.URI.revive(te),G,X,oe),void 0)}$resolveRenameLocation(q,te,G,X){return this._withAdapter(q,H,oe=>oe.resolveRenameLocation(m.URI.revive(te),G,X),void 0)}registerDocumentSemanticTokensProvider(q,te,G,X){const oe=this._addNewAdapter(new B(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(te),X,me);let Ie=this._createDisposable(oe);if(me){const We=G.onDidChangeSemanticTokens(Ye=>this._proxy.$emitDocumentSemanticTokensEvent(me));Ie=D.Disposable.from(Ie,We)}return Ie}$provideDocumentSemanticTokens(q,te,G,X){return this._withAdapter(q,B,oe=>oe.provideDocumentSemanticTokens(m.URI.revive(te),G,X),null)}$releaseDocumentSemanticTokens(q,te){this._withAdapter(q,B,G=>G.releaseDocumentSemanticColoring(te),void 0)}registerDocumentRangeSemanticTokensProvider(q,te,G,X){const oe=this._addNewAdapter(new $(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(te),X),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(q,te,G,X){return this._withAdapter(q,$,oe=>oe.provideDocumentRangeSemanticTokens(m.URI.revive(te),G,X),null)}registerCompletionItemProvider(q,te,G,X){const oe=this._addNewAdapter(new z(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(oe,this._transformDocumentSelector(te),X,z.supportsResolving(G),`${q.identifier.value}(${X.join("")})`),this._createDisposable(oe)}$provideCompletionItems(q,te,G,X,oe){return this._withAdapter(q,z,me=>me.provideCompletionItems(m.URI.revive(te),G,X,oe),void 0,oe)}$resolveCompletionItem(q,te,G){return this._withAdapter(q,z,X=>X.resolveCompletionItem(te,G),void 0,G)}$releaseCompletionItems(q,te){this._withAdapter(q,z,G=>G.releaseCompletionItems(te),void 0)}registerInlineCompletionsProvider(q,te,G){const X=this._addNewAdapter(new W(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideInlineCompletions(q,te,G,X,oe){return this._withAdapter(q,W,me=>me.provideInlineCompletions(m.URI.revive(te),G,X,oe),void 0)}$handleInlineCompletionDidShow(q,te,G){this._withAdapter(q,W,async X=>{X.handleDidShowCompletionItem(te,G)},void 0)}$freeInlineCompletionsList(q,te){this._withAdapter(q,W,async G=>{G.disposeCompletions(te)},void 0)}registerSignatureHelpProvider(q,te,G,X){const oe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,me=this._addNewAdapter(new ne(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(te),oe),this._createDisposable(me)}$provideSignatureHelp(q,te,G,X,oe){return this._withAdapter(q,ne,me=>me.provideSignatureHelp(m.URI.revive(te),G,X,oe),void 0)}$releaseSignatureHelp(q,te){this._withAdapter(q,ne,G=>G.releaseSignatureHelp(te),void 0)}registerInlayHintsProvider(q,te,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new se(this._documents,this._commands.converter,G,this._logService,q),q);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(te),typeof G.resolveInlayHint=="function",X);let me=this._createDisposable(oe);if(X!==void 0){const Ie=G.onDidChangeInlayHints(We=>this._proxy.$emitInlayHintsEvent(X));me=D.Disposable.from(me,Ie)}return me}$provideInlayHints(q,te,G,X){return this._withAdapter(q,se,oe=>oe.provideInlayHints(m.URI.revive(te),G,X),void 0,X)}$resolveInlayHint(q,te,G){return this._withAdapter(q,se,X=>X.resolveInlayHint(te,G),void 0,G)}$releaseInlayHints(q,te){this._withAdapter(q,se,G=>G.releaseHints(te),void 0)}registerDocumentLinkProvider(q,te,G){const X=this._addNewAdapter(new K(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(te),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(q,te,G){return this._withAdapter(q,K,X=>X.provideLinks(m.URI.revive(te),G),void 0)}$resolveDocumentLink(q,te,G){return this._withAdapter(q,K,X=>X.resolveLink(te,G),void 0)}$releaseDocumentLinks(q,te){this._withAdapter(q,K,G=>G.releaseLinks(te),void 0)}registerColorProvider(q,te,G){const X=this._addNewAdapter(new Q(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDocumentColors(q,te,G){return this._withAdapter(q,Q,X=>X.provideColors(m.URI.revive(te),G),[])}$provideColorPresentations(q,te,G,X){return this._withAdapter(q,Q,oe=>oe.provideColorPresentations(m.URI.revive(te),G,X),void 0)}registerFoldingRangeProvider(q,te,G){const X=this._nextHandle(),oe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new xe(new ae(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(te),oe);let me=this._createDisposable(X);if(oe!==void 0){const Ie=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideFoldingRanges(q,te,G,X){return this._withAdapter(q,ae,oe=>oe.provideFoldingRanges(m.URI.revive(te),G,X),void 0)}registerSelectionRangeProvider(q,te,G){const X=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideSelectionRanges(q,te,G,X){return this._withAdapter(q,fe,oe=>oe.provideSelectionRanges(m.URI.revive(te),G,X),[])}registerCallHierarchyProvider(q,te,G){const X=this._addNewAdapter(new be(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$prepareCallHierarchy(q,te,G,X){return this._withAdapter(q,be,oe=>Promise.resolve(oe.prepareSession(m.URI.revive(te),G,X)),void 0)}$provideCallHierarchyIncomingCalls(q,te,G,X){return this._withAdapter(q,be,oe=>oe.provideCallsTo(te,G,X),void 0)}$provideCallHierarchyOutgoingCalls(q,te,G,X){return this._withAdapter(q,be,oe=>oe.provideCallsFrom(te,G,X),void 0)}$releaseCallHierarchy(q,te){this._withAdapter(q,be,G=>Promise.resolve(G.releaseSession(te)),void 0)}registerTypeHierarchyProvider(q,te,G){const X=this._addNewAdapter(new Me(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$prepareTypeHierarchy(q,te,G,X){return this._withAdapter(q,Me,oe=>Promise.resolve(oe.prepareSession(m.URI.revive(te),G,X)),void 0)}$provideTypeHierarchySupertypes(q,te,G,X){return this._withAdapter(q,Me,oe=>oe.provideSupertypes(te,G,X),void 0)}$provideTypeHierarchySubtypes(q,te,G,X){return this._withAdapter(q,Me,oe=>oe.provideSubtypes(te,G,X),void 0)}$releaseTypeHierarchy(q,te){this._withAdapter(q,Me,G=>Promise.resolve(G.releaseSession(te)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ge._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ge._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ge._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ge._serializeRegExp(q.beforeText),afterText:q.afterText?Ge._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ge._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ge._serializeOnEnterRule)}setLanguageConfiguration(q,te,G){let{wordPattern:X}=G;if(X&&(0,k.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(te,X):this._documents.setWordDefinitionFor(te,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const oe=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ge._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?Ge._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ge._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,te,me),this._createDisposable(oe)}$setWordDefinitions(q){for(const te of q)this._documents.setWordDefinitionFor(te.languageId,new RegExp(te.regexSource,te.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(pe[241],ve([0,1,5,15,7,47,13,6]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(R,C,l,w){this._documents=C,this._commands=l,this._uriTransformer=w,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,C){await this._proxy.$changeLanguage(R,C);const l=this._documents.getDocumentData(R);if(!l)throw new Error(`document '${R.toString}' NOT found`);return l.document}async tokenAtPosition(R,C){const l=R.version,w=t.Position.from(C),p=await this._proxy.$tokensAtPosition(R.uri,w),g={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(C)??new I.Range(C.line,C.character,C.line,C.character)};if(!p)return g;const E={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!E.range.contains(C)||l!==R.version?g:E}createLanguageStatusItem(R,C,l){const w=this._handlePool++,p=this._proxy,g=this._ids,E=`${R.identifier.value}/${C}`;if(g.has(E))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);g.add(E);const F={selector:l,id:C,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,u=new k.DisposableStore;const r=()=>{y?.dispose(),y=(0,T.disposableTimeout)(()=>{u.clear(),this._proxy.$setLanguageStatus(w,{id:E,name:F.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===I.LanguageStatusSeverity.Error?D.default.Error:F.severity===I.LanguageStatusSeverity.Warning?D.default.Warning:D.default.Info,command:F.command&&this._commands.toInternal(F.command,u),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},f={dispose(){u.dispose(),y?.dispose(),p.$removeLanguageStatus(w),g.delete(E)},get id(){return F.id},get name(){return F.name},set name(o){F.name=o,r()},get selector(){return F.selector},set selector(o){F.selector=o,r()},get text(){return F.text},set text(o){F.text=o,r()},get detail(){return F.detail},set detail(o){F.detail=o,r()},get severity(){return F.severity},set severity(o){F.severity=o,r()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(o){F.accessibilityInformation=o,r()},get command(){return F.command},set command(o){F.command=o,r()},get busy(){return F.busy},set busy(o){F.busy=o,r()}};return r(),f}}e.ExtHostLanguages=_}),define(pe[132],ve([0,1,11,5,26,14,3]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(R,C){const l=new T.Emitter;super(C.logLevel,l.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,C,l){return new _(this._proxy,R,C,l)}};k=je([ze(0,D.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class _ extends m.AbstractMessageLogger{constructor(R,C,l,w){super(w?.always);this.proxy=R,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(C,w).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,C){const l=[[R,C]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(R){this.proxy.$log(this.file,R)}}}),define(pe[242],ve([0,1,5,11,28]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(k){return k&&k.title}let T=class{constructor(_,P){this._logService=P,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,P,R,C,l){const w={source:{identifier:_.identifier,label:_.displayName||_.name}};let p;typeof C=="string"||D(C)?p=[C,...l]:(w.modal=C?.modal,w.useCustom=C?.useCustom,w.detail=C?.detail,p=l),w.useCustom&&(0,I.checkProposedApiEnabled)(_,"resolvers");const g=[];for(let E=0;E<p.length;E++){const F=p[E];if(typeof F=="string")g.push({title:F,handle:E,isCloseAffordance:!1});else if(typeof F=="object"){let{title:y,isCloseAffordance:u}=F;g.push({title:y,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(P,R,w,g).then(E=>{if(typeof E=="number")return p[E]})}};T=je([ze(1,t.ILogService)],T),e.ExtHostMessageService=T}),define(pe[243],ve([0,1,22,3,58,6,24,8,18,2,86,5,15,7,52,218,129]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(u,r,f,o,S){this._textDocumentsAndEditors=f,this._textDocuments=o,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,n=s.cell.handle,a=this._documents.get(i)?.getCell(n);if(a)return a.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){const r=this._editors.get(u);if(!r)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(u){for(const[r,f]of this._editors)if(f.apiEditor===u)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,r){const f=this._documents.get(u);if(!f&&!r)throw new Error(`NO notebook document for '${u}'`);return f}_getProviderData(u){const r=this._notebookContentProviders.get(u);if(!r)throw new Error(`NO provider for '${u}'`);return r}registerNotebookContentProvider(u,r,f,o,S){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:u,provider:f});let s;return f.onDidChangeNotebookContentOptions&&(s=f.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(r,i)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},r,l.NotebookDocumentContentOptions.from(o),F._convertNotebookRegistrationData(u,S)),new w.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(u,r){if(!r)return;const f=r.filenamePattern.map(o=>l.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(r.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:r.displayName,filenamePattern:f,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,r,f){const o=F._notebookStatusBarItemProviderHandlePool++,S=typeof f.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,S,r);let s;return S!==void 0&&(s=f.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,S),s&&s.dispose()})}async createNotebookDocument(u){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&l.NotebookData.from(u.content)});return P.URI.revive(r)}async openNotebookDocument(u){const r=this._documents.get(u);if(r)return r.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(u),o=this._documents.get(P.URI.revive(f));return(0,_.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(u,r){P.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let f;typeof r=="object"?f={position:l.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(l.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:f={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,f),S=o&&this._editors.get(o)?.apiEditor;if(S)return S;throw o?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,r,f,o){const S=this._notebookStatusBarItemProviders.get(u),s=P.URI.revive(r),i=this._documents.get(s);if(!i||!S)return;const n=i.getCellFromIndex(f);if(!n)return;const c=await S.provideCellStatusBarItems(n.apiCell,o);if(!c)return;const a=new D.DisposableStore,h=this._statusBarCache.add([a]),v=(Array.isArray(c)?c:[c]).map(b=>l.NotebookStatusBarItem.from(b,this._commandsConverter,a));return{cacheId:h,items:v}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,r,f,o,S){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,f),this._notebookProxy.$registerNotebookSerializer(s,{id:u.identifier,location:u.extensionLocation},r,l.NotebookDocumentContentOptions.from(o),F._convertNotebookRegistrationData(u,S)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(u,r,f){const o=this._notebookSerializer.get(u);if(!o)throw new Error("NO serializer found");const S=await o.deserializeNotebook(r.buffer,f);return new p.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(u,r,f){const o=this._notebookSerializer.get(u);if(!o)throw new Error("NO serializer found");const S=await o.serializeNotebook(l.NotebookData.to(r.value),f);return m.VSBuffer.wrap(S)}async $openNotebook(u,r,f,o,S){const{provider:s}=this._getProviderData(u),i=await s.openNotebook(P.URI.revive(r),{backupId:f,untitledDocumentData:o?.buffer},S);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(u,r,f){const o=this.getNotebookDocument(P.URI.revive(r)),{provider:S}=this._getProviderData(u);return await S.saveNotebook(o.apiNotebook,f),!0}async $saveNotebookAs(u,r,f,o){const S=this.getNotebookDocument(P.URI.revive(r)),{provider:s}=this._getProviderData(u);return await s.saveNotebookAs(P.URI.revive(f),S.apiNotebook,o),!0}async $backupNotebook(u,r,f){const o=this.getNotebookDocument(P.URI.revive(r)),S=this._getProviderData(u),s=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([o.uri.toString(),this._backupIdPool++])),n=P.URI.joinPath(s,i),c=await S.provider.backupNotebook(o.apiNotebook,{destination:n},f);return o.updateBackup(c),c.id}_createExtHostEditor(u,r,f){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const o=new E.ExtHostNotebookEditor(r,this._notebookEditorsProxy,u,f.visibleRanges.map(l.NotebookRange.to),f.selections.map(l.NotebookRange.to),typeof f.viewColumn=="number"?l.ViewColumn.to(f.viewColumn):void 0);this._editors.set(r,o)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const f of u.value.removedDocuments){const o=P.URI.revive(f),S=this._documents.get(o);S&&(S.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===o.toString()&&this._editors.delete(s.id)}if(u.value.addedDocuments){const f=[];for(const o of u.value.addedDocuments){const S=P.URI.revive(o.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const s=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)}},S,o);f.push(...o.cells.map(n=>g.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(u.value.addedEditors)for(const f of u.value.addedEditors){if(this._editors.has(f.id))return;const o=P.URI.revive(f.documentUri),S=this._documents.get(o);S&&this._createExtHostEditor(S,f.id,f)}const r=[];if(u.value.removedEditors)for(const f of u.value.removedEditors){const o=this._editors.get(f);o&&(this._editors.delete(f),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),r.push(o))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const f=new Set;this._visibleNotebookEditors.forEach(o=>f.add(o.id));for(const o of this._editors.values()){const S=f.has(o.id);o._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,77,11,5,14,15]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(C,l){const w=_._Keys.nextId();C.$registerNotebookEditorDecorationType(w,k.NotebookDecorationRenderOptions.from(l)),this.value={key:w,dispose(){C.$removeNotebookEditorDecorationType(w)}}}}_._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(C,l,w){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new _(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const w=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&w._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&w._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(C[l]))}};P=je([ze(0,I.ILogService),ze(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(pe[245],ve([0,1,17,13,21,3,6,24,2,27,11,5,38,15,7,87,211,28,52]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let u=class{constructor(s,i,n,c,a){this._initData=i,this._extHostNotebook=n,this._commands=c,this._logService=a,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new D.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(C.MainContext.MainThreadNotebookKernels);const h=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",d=>!0,d=>{if(d&&"notebookEditor"in d&&"id"in d){const v=this._extHostNotebook.getIdByEditor(d.notebookEditor);return{id:d.id,extension:d.extension,notebookEditorId:v}}else if(d&&"notebookEditor"in d){const v=this._extHostNotebook.getIdByEditor(d.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${d.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return d})],l.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(s,i,n,c,a,h){for(const W of this._kernelData.values())if(W.controller.id===i&&P.ExtensionIdentifier.equals(s.identifier,W.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const d=this._handlePool++,v=this;this._logService.trace(`NotebookController[${d}], CREATED by ${s.identifier.value}, ${i}`);const b=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${s.identifier}'`);let A=!1;const O=new T.DisposableStore,N=new D.Emitter,L=new D.Emitter,M={id:`${s.identifier.value}/${i}`,notebookType:n,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:h?h.map(w.NotebookRendererScript.from):[]};let V=a??b,H;this._proxy.$addKernel(d,M).catch(W=>{console.log(W),A=!0});let U=0;const B=()=>{if(A)return;const W=++U;Promise.resolve().then(()=>{W===U&&this._proxy.$updateKernel(d,M)})},$=new k.ResourceMap,z={get id(){return i},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return M.label},set label(W){M.label=W??s.displayName??s.name,B()},get detail(){return M.detail??""},set detail(W){M.detail=W,B()},get description(){return M.description??""},set description(W){M.description=W,B()},get kind(){return(0,F.checkProposedApiEnabled)(s,"notebookControllerKind"),M.kind??""},set kind(W){(0,F.checkProposedApiEnabled)(s,"notebookControllerKind"),M.kind=W,B()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(W){M.supportedLanguages=W,B()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(W){M.supportsExecutionOrder=W,B()},get rendererScripts(){return M.preloads?M.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(W){V=W??b},get interruptHandler(){return H},set interruptHandler(W){H=W,M.supportsInterrupt=Boolean(W),B()},createNotebookCellExecution(W){if(A)throw new Error("notebook controller is DISPOSED");if(!$.has(W.notebook.uri))throw v._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(J=>J.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return v._createNotebookCellExecution(W)},dispose:()=>{A||(this._logService.trace(`NotebookController[${d}], DISPOSED`),A=!0,this._kernelData.delete(d),O.dispose(),N.dispose(),L.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(W,J){v._proxy.$updateNotebookPriority(d,W.uri,J)},onDidReceiveMessage:L.event,postMessage(W,J){return(0,F.checkProposedApiEnabled)(s,"notebookMessaging"),v._proxy.$postMessage(d,J&&v._extHostNotebook.getIdByEditor(J),W)},asWebviewUri(W){return(0,F.checkProposedApiEnabled)(s,"notebookMessaging"),(0,g.asWebviewUri)(W,v._initData.remote)}};return this._kernelData.set(d,{extensionId:s.identifier,controller:z,onDidReceiveMessage:L,onDidChangeSelection:N,associatedNotebooks:$}),z}$acceptNotebookAssociation(s,i,n){const c=this._kernelData.get(s);if(c){const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(i));n?c.associatedNotebooks.set(a.uri,!0):c.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,a.uri.toString(),n),c.onDidChangeSelection.fire({selected:n,notebook:a.apiNotebook})}}async $executeCells(s,i,n){const c=this._kernelData.get(s);if(!c)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(i)),h=[];for(const d of n){const v=a.getCell(d);v&&h.push(v.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,a.uri.toString(),h.length),await c.controller.executeHandler.call(c.controller,h,a.apiNotebook,c.controller)}catch(d){this._logService.error(`NotebookController[${s}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(s,i,n){const c=this._kernelData.get(s);if(!c)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(i));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,a.apiNotebook);else for(const h of n){const d=a.getCell(h);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,i,n){const c=this._kernelData.get(s);if(!c)return;const a=this._extHostNotebook.getEditorById(i);c.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:n}))}$cellExecutionChanged(s,i,n){const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(s)).getCell(i);a&&this._onDidChangeCellExecutionState.fire({cell:a.apiCell,state:n??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const c=new f(n.notebook,n,this._proxy);this._activeExecutions.set(n.uri,c);const a=c.onDidChangeState(()=>{c.state===r.Resolved&&(c.dispose(),a.dispose(),this._activeExecutions.delete(n.uri))});return c.asApiObject()}};u=je([ze(4,R.ILogService)],u),e.ExtHostNotebookKernels=u;var r;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(r||(r={}));class f extends T.Disposable{constructor(s,i,n){super();this._document=s,this._cell=i,this._proxy=n,this._onDidChangeState=new D.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new o(10,c=>this.update(c)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const i=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new y.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let i=this._cell;if(s&&(i=this._document.getCellFromApiCell(s)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(s){return s.map(i=>{const n=p.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return n===i.items?w.NotebookCellOutput.from(i):w.NotebookCellOutput.from({items:n,id:i.id,metadata:i.metadata})})}async updateOutputs(s,i,n){const c=this.cellIndexToHandle(i),a=this.validateAndConvertOutputs((0,m.asArray)(s));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:c,append:n,outputs:a})}async updateOutputItems(s,i,n){return s=p.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(s),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:s.map(w.NotebookCellOutputItem.from),outputId:i.id,append:n})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(n){s._executionOrder=n,s.update([{editType:E.CellExecutionUpdateType.ExecutionState,uri:s._document.uri,cellHandle:s._cell.handle,executionOrder:s._executionOrder}])},start(n){if(s._state===r.Resolved||s._state===r.Started)throw new Error("Cannot call start again");s._state=r.Started,s._onDidChangeState.fire(),s.update({editType:E.CellExecutionUpdateType.ExecutionState,uri:s._document.uri,cellHandle:s._cell.handle,runStartTime:n})},end(n,c){if(s._state===r.Resolved)throw new Error("Cannot call resolve twice");s._state=r.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._document.uri,s._cell.handle,new y.SerializableObjectWithBuffers({uri:s._document.uri,cellHandle:s._cell.handle,runEndTime:c,lastRunSuccess:n}))},clearOutput(n){return s.verifyStateForOutput(),s.updateOutputs([],n,!1)},appendOutput(n,c){return s.verifyStateForOutput(),s.updateOutputs(n,c,!0)},replaceOutput(n,c){return s.verifyStateForOutput(),s.updateOutputs(n,c,!1)},appendOutputItems(n,c){return s.verifyStateForOutput(),s.updateOutputItems(n,c,!0)},replaceOutputItems(n,c){return s.verifyStateForOutput(),s.updateOutputItems(n,c,!1)}})}}class o{constructor(s,i){this.delay=s,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>s.complete())}}}),define(pe[246],ve([0,1,3,5,129,28]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(_,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,P,R){const C=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(P)?.fire({editor:C.apiEditor,message:R})}createRendererMessaging(_,P){if(!_.contributes?.notebookRenderer?.some(w=>w.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const R=(0,D.isProposedApiEnabled)(_,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(w,p,g)=>{const E=R?w:F=>{const y={};C.set(y,F.editor),w({editor:y,message:F.message})};return this.getOrCreateEmitterFor(P).event(E,p,g)},postMessage:(w,p)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(w)&&([w,p]=[p,w]);const g=R?p:C.get(p),E=g&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(E?.id,P,w)}}}getOrCreateEmitterFor(_){let P=this._rendererMessageEmitters.get(_);return P||(P=new m.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,P),P)}}e.ExtHostNotebookRenderers=T}),define(pe[133],ve([0,1,5,6,4,14,11,212,67,26,44,152,22]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends t.Disposable{constructor(E,F,y,u){super();this.id=E,this.name=F,this.logger=y,this.proxy=u,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,E)}replace(E){const F=this.offset;this.write(E),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(E,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:F))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=l.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let p=class{constructor(E,F,y,u,r){this.extHostFileSystem=y,this.extHostFileSystemInfo=u,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[F,y]of this.channels)y.visible=F===this.visibleChannelId}createOutputChannel(E,F){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const y=this.doCreateOutputChannel(E,F);return y.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,y)}async doCreateOutputChannel(E,F){const y=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(y,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),f=await this.proxy.$register(E,!1,u,F.identifier.value);return new w(f,E,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,F){let y=!1;const u=()=>{if(y)throw new Error("Channel has been closed")};return{get name(){return E},append(r){u(),F.then(f=>f.append(r))},appendLine(r){u(),F.then(f=>f.appendLine(r))},clear(){u(),F.then(r=>r.clear())},replace(r){u(),F.then(f=>f.replace(r))},show(r,f){u(),F.then(o=>o.show(r,f))},hide(){u(),F.then(r=>r.hide())},dispose(){y=!0,F.then(r=>r.dispose())}}}};p=je([ze(0,D.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,_.IExtHostConsumerFileSystem),ze(3,R.IExtHostFileSystemInfo),ze(4,T.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,13,21,3,6,5,2,7,16,17,47,85,28]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(g,E,F){const y=g.getProxy(T.MainContext.MainThreadQuickOpen);class u{constructor(a,h){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=h}showQuickPick(a,h,d=t.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(a),b=++this._instances,A=y.$show(b,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},d),O={},N=A.then(()=>O);return Promise.race([N,v]).then(L=>{if(L!==O)return v.then(M=>{const V=[];for(let H=0;H<M.length;H++){const U=M[H];typeof U=="string"?V.push({label:U,handle:H}):U.kind===_.QuickPickItemKind.Separator?V.push({type:"separator",label:U.label}):V.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:H})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{h.onDidSelectItem(M[H])}),y.$setItems(b,V),A.then(H=>{if(typeof H=="number")return M[H];if(Array.isArray(H))return H.map(U=>M[U])})})}).then(void 0,L=>{if(!(0,P.isCancellationError)(L))return y.$setError(b,L),Promise.reject(L)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,h=t.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,y.$input(a,typeof this._validateInput=="function",h).then(void 0,d=>{if(!(0,P.isCancellationError)(d))return Promise.reject(d)})}$validateInput(a){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,h=t.CancellationToken.None){const d=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!d)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(b=>b.uri.toString()===d.uri.toString())}createQuickPick(a){const h=new i(a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(a){const h=new n(a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(a,h){const d=this._sessions.get(a);d&&d._fireDidChangeValue(h)}$onDidAccept(a){const h=this._sessions.get(a);h&&h._fireDidAccept()}$onDidChangeActive(a,h){const d=this._sessions.get(a);d instanceof i&&d._fireDidChangeActive(h)}$onDidChangeSelection(a,h){const d=this._sessions.get(a);d instanceof i&&d._fireDidChangeSelection(h)}$onDidTriggerButton(a,h){const d=this._sessions.get(a);d&&d._fireDidTriggerButton(h)}$onDidTriggerItemButton(a,h,d){const v=this._sessions.get(a);v instanceof i&&v._fireDidTriggerItemButton(h,d)}$onDidHide(a){const h=this._sessions.get(a);h&&h._fireDidHide()}}class r{constructor(a,h){this._extensionId=a,this._onDidDispose=h,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((h,d)=>{const v=h===_.QuickInputButtons.Back?-1:d;this._handlesToButtons.set(v,h)}),this.update({buttons:a.map((h,d)=>({...s(h),tooltip:h.tooltip,handle:h===_.QuickInputButtons.Back?-1:d}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const h=this._handlesToButtons.get(a);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(a){if(!this._disposed){for(const h of Object.keys(a)){const d=a[h];this._pendingUpdate[h]=d===void 0?null:d}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function f(c){if(c instanceof _.ThemeIcon)return{id:c.id};const a=S(c),h=o(c);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof h=="string"?k.URI.file(h):h}}function o(c){return typeof c=="object"&&"light"in c?c.light:c}function S(c){return typeof c=="object"&&"dark"in c?c.dark:c}function s(c){const a=f(c.iconPath);let h,d;return"id"in a?d=l.ThemeIcon.asClassName(a):h=a,{iconPath:h,iconClass:d}}class i extends r{constructor(a,h){super(a.identifier,h);this.extension=a,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){a.some(d=>d.kind!==void 0)&&(0,w.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((d,v)=>{this._handlesToItems.set(v,d),this._itemsToHandles.set(d,v)});const h=[];for(let d=0;d<a.length;d++){const v=a[d];v.kind===_.QuickPickItemKind.Separator?h.push({type:"separator",label:v.label}):h.push({handle:d,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((b,A)=>({...s(b),tooltip:b.tooltip,handle:A}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(a){const h=(0,R.coalesce)(a.map(d=>this._handlesToItems.get(d)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(a){const h=(0,R.coalesce)(a.map(d=>this._handlesToItems.get(d)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(a,h){const d=this._handlesToItems.get(a);if(!d||!d.buttons||!d.buttons.length)return;const v=d.buttons[h];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:d})}}class n extends r{constructor(a,h){super(a,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?C.default.Error:C.default.Ignore})}}return new u(E,F)}e.createExtHostQuickOpen=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[248],ve([0,1,2,3,56,6,13,5,17,101,11,27,85,15,28]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";var g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(h){if(h)return typeof h.iconPath=="string"?m.URI.file(h.iconPath):m.URI.isUri(h.iconPath)||l.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function y(h,d){if(!h.iconPath&&!d.iconPath)return 0;if(h.iconPath){if(!d.iconPath)return 1}else return-1;const v=typeof h.iconPath=="string"?h.iconPath:m.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,b=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,P.comparePaths)(v,b)}function u(h,d){let v=0;if(h.strikeThrough!==d.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==d.faded)return h.faded?1:-1;if(h.tooltip!==d.tooltip)return(h.tooltip||"").localeCompare(d.tooltip||"");if(v=y(h,d),v!==0)return v;if(h.light&&d.light)v=y(h.light,d.light);else{if(h.light)return 1;if(d.light)return-1}if(v!==0)return v;if(h.dark&&d.dark)v=y(h.dark,d.dark);else{if(h.dark)return 1;if(d.dark)return-1}return v}function r(h,d){if(h.command!==d.command)return h.command<d.command?-1:1;if(h.title!==d.title)return h.title<d.title?-1:1;if(h.tooltip!==d.tooltip){if(h.tooltip!==void 0&&d.tooltip!==void 0)return h.tooltip<d.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(h.arguments===d.arguments)return 0;if(h.arguments)if(d.arguments){if(h.arguments.length!==d.arguments.length)return h.arguments.length-d.arguments.length}else return 1;else return-1;for(let v=0;v<h.arguments.length;v++){const b=h.arguments[v],A=d.arguments[v];if(b!==A)return b<A?-1:1}return 0}function f(h,d){let v=(0,P.comparePaths)(h.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(v!==0)return v;if(h.command&&d.command)v=r(h.command,d.command);else{if(h.command)return 1;if(d.command)return-1}if(v!==0)return v;if(h.decorations&&d.decorations)v=u(h.decorations,d.decorations);else{if(h.decorations)return 1;if(d.decorations)return-1}return v}function o(h,d){for(let v=0;v<h.length;v++)if(h[v]!==d[v])return!1;return!0}function S(h,d){return h.command===d.command&&h.title===d.title&&h.tooltip===d.tooltip&&(h.arguments&&d.arguments?o(h.arguments,d.arguments):h.arguments===d.arguments)}function s(h,d){return(0,_.equals)(h,d,S)}class i{constructor(d,v,b){this._extension=d,this._sourceControlHandle=b,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,nt(this,g,v,"f")}get value(){return this._value}set value(d){d=d??"",Le(this,g,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Le(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Le(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Le(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,v){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,g,"f").$showValidationMessage(this._sourceControlHandle,d,v)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class n{constructor(d,v,b,A,O){this._proxy=d,this._commands=v,this._sourceControlHandle=b,this._id=A,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,v){const b=this._resourceStatesCommandsMap.get(d);return b?(0,T.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(f),b=(0,_.sortedDiff)(this._resourceSnapshot,d,f).map(N=>{const L=N.toInsert.map(M=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,M);const H=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ae=new D.DisposableStore;U=this._commands.converter.toInternal(M.command,ae),this._resourceStatesDisposablesMap.set(V,ae)}else this._resourceStatesCommandsMap.set(V,M.command);const B=F(M.decorations),$=M.decorations&&F(M.decorations.light)||B,z=M.decorations&&F(M.decorations.dark)||B,W=[$,z],J=M.decorations&&M.decorations.tooltip||"",ne=M.decorations&&!!M.decorations.strikeThrough,se=M.decorations&&!!M.decorations.faded,K=M.contextValue||"";return{rawResource:[V,H,W,J,ne,se,K,U],handle:V}});return{start:N.start,deleteCount:N.deleteCount,toInsert:L}}),A=b.map(({start:N,deleteCount:L,toInsert:M})=>[N,L,M.map(V=>V.rawResource)]),O=b.reverse();for(const{start:N,deleteCount:L,toInsert:M}of O){const V=M.map(U=>U.handle),H=this._handlesSnapshot.splice(N,L,...V);for(const U of H)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=d,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class c{constructor(d,v,b,A,O,N){this._extension=d,this._commands=b,this._id=A,this._label=O,this._rootUri=N,E.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new D.MutableDisposable,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,E,v,"f"),this._inputBox=new i(d,Le(this,E,"f"),this.handle),Le(this,E,"f").$registerSourceControl(this.handle,A,O,N)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Le(this,E,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Le(this,E,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Le(this,E,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=d;const v=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Le(this,E,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new D.DisposableStore,this._actionButton=d;const v=d!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,E,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&s(this._statusBarCommands,d))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=d;const v=(d||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));Le(this,E,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(d,v){const b=new n(Le(this,E,"f"),this._commands,this.handle,d,v),A=t.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,A),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const d=[],v=[];for(const[b,A]of this.createdResourceGroups){A.dispose();const O=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});t.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),O.dispose(),this._groups.delete(b.handle),Le(this,E,"f").$unregisterGroup(this.handle,b.handle)}),d.push([b.handle,b.id,b.label,b.features]);const N=b._takeResourceStateSnapshot();N.length>0&&v.push([b.handle,N]),this._groups.set(b.handle,b)}Le(this,E,"f").$registerGroups(this.handle,d,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(v=>{const b=v._takeResourceStateSnapshot();b.length!==0&&d.push([v.handle,b])}),d.length>0&&Le(this,E,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Le(this,E,"f").$unregisterSourceControl(this.handle)}}E=new WeakMap,c._handlePool=0,je([(0,I.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let a=class Vi{constructor(d,v,b){this._commands=v,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=d.getProxy(k.MainContext.MainThreadSCM),this._telemetry=d.getProxy(k.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const O=this._sourceControls.get(A.sourceControlHandle);if(!O)return A;const N=O.getResourceGroup(A.groupHandle);return N?N.getResourceState(A.handle):A}else if(A&&A.$mid===4){const O=this._sourceControls.get(A.sourceControlHandle);return O?O.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const O=this._sourceControls.get(A.handle);return O||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,v,b,A){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,v,b,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const O=Vi._handlePool++,N=new c(d,this._proxy,this._commands,v,b,A);this._sourceControls.set(O,N);const L=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(N),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(d.identifier),L),N}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const v=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier)),b=v&&v[v.length-1];return b&&b.inputBox}$provideOriginalResource(d,v,b){const A=m.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,A.toString());const O=this._sourceControls.get(d);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(A,b)).then(N=>N||null)}$onInputBoxValueChange(d,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const b=this._sourceControls.get(d);return b&&b.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(d,v,b,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,v,b);const O=this._sourceControls.get(d);if(!O)return Promise.resolve(void 0);const N=O.getResourceGroup(v);return N?N.$executeResourceCommand(b,A):Promise.resolve(void 0)}$validateInput(d,v,b){this.logService.trace("ExtHostSCM#$validateInput",d);const A=this._sourceControls.get(d);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>A.inputBox.validateInput(v,b)).then(O=>{if(!O)return Promise.resolve(void 0);const N=w.MarkdownString.fromStrict(O.message);return N?Promise.resolve([N,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};a._handlePool=0,a=je([ze(2,R.ILogService)],a),e.ExtHostSCM=a});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[249],ve([0,1,7,5,166,6,15,18]),function(Z,e,m,t,I,D,T,k){"use strict";var _,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,g,E,F,y=m.StatusBarAlignment.Left,u){_.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,nt(this,_,p,"f"),nt(this,P,g,"f"),this._entryId=R.ID_GEN++,this._extension=E,this._id=F,this._alignment=y,this._priority=this.validatePriority(u)}validatePriority(p){if(!!(0,k.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Le(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let g;this._name?g=this._name:g=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,_,"f").$setEntry(this._entryId,p,g,this._text,F,this._command?.internal,E,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,_=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const g={message:p};return this._messages.unshift(g),this._update(),new m.Disposable(()=>{const E=this._messages.indexOf(g);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(p,g){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new C(this)}createStatusBarEntry(p,g,E,F){return new R(this._proxy,this._commands,p,g,E,F)}setStatusBarMessage(p,g){const E=this._statusMessage.setMessage(p);let F;return typeof g=="number"?F=setTimeout(()=>E.dispose(),g):typeof g!="undefined"&&g.then(()=>E.dispose(),()=>E.dispose()),new m.Disposable(()=>{E.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=l}),define(pe[90],ve([0,1,5,3,4]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}initializeExtensionStorage(k,_,P){return this._proxy.$initializeExtensionStorage(k,_).then(R=>R||P)}setValue(k,_,P){return this._proxy.$setValue(k,_,P)}$acceptValue(k,_,P){this._onDidChangeStorage.fire({shared:k,key:_,value:P})}}e.ExtHostStorage=D,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(pe[68],ve([0,1,4,26,11,67,2]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,R,C){this._logService=R,this._extHostFileSystem=C,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,D.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,167,16,214,21,33,196,85,18,13]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class y{constructor(c,a,h,d){this._proxy=c,this._id=a,this._creationOptions=h,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(b,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,b,A)},show(b){v._checkDisposed(),v._proxy.$show(v._id,b)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(c,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,E.withNullAsUndefined)(c.shellPath),shellArgs:(0,E.withNullAsUndefined)(c.shellArgs),cwd:(0,E.withNullAsUndefined)(c.cwd),env:(0,E.withNullAsUndefined)(c.env),icon:(0,E.withNullAsUndefined)(s(c.iconPath)),color:g.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,E.withNullAsUndefined)(c.message),strictEnv:(0,E.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(c.location,a?.resolvedExtHostIdentifier),disablePersistence:(0,E.withNullAsUndefined)(c.disablePersistence)})}async createExtensionTerminal(c,a,h,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:g.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(c,a),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,a){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,a){return c===this._cols&&a===this._rows||c===0||a===0?!1:(this._cols=c,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=y;class u{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,a){this._pty.setDimensions?.({columns:c,rows:a})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let r=1,f=class extends k.Disposable{constructor(c,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[h,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,a){const h=new y(this._proxy,(0,w.generateUuid)(),c,c.name),d=new u(c.pty);return h.createExtensionTerminal(c.location,this._serializeParentTerminal(c,a).resolvedExtHostIdentifier,s(c.iconPath),i(c.color)).then(v=>{const b=this._setupExtHostProcessListeners(v,d);this._terminalProcessDisposables[v]=b}),this._terminals.push(h),h.value}_serializeParentTerminal(c,a){if(a=a||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const h=c.location.parentTerminal;if(h){const d=this._terminals.find(v=>v.value===h);d&&(a.resolvedExtHostIdentifier=d._id)}}else c.location&&typeof c.location!="object"?a.location=c.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(c,a){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const d=new u(a),v=this._setupExtHostProcessListeners(c,d);this._terminalProcessDisposables[c]=v}async $acceptActiveTerminalChanged(c){const a=this._activeTerminal;if(c===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(c);h&&(this._activeTerminal=h,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,a){const h=this._getTerminalById(c);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:a})}async $acceptTerminalDimensions(c,a,h){const d=this._getTerminalById(c);d&&d.setDimensions(a,h)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(c,a,h){this._terminalProcesses.get(c)?.resize(a,h)}async $acceptTerminalTitleChange(c,a){const h=this._getTerminalById(c);h&&(h.name=a)}async $acceptTerminalClosed(c,a){const h=this._getTerminalObjectIndexById(this._terminals,c);if(h!==null){const d=this._terminals.splice(h,1)[0];d.setExitCode(a),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(c,a,h,d){if(a){const A=this._getTerminalObjectIndexById(this._terminals,a);if(A!==null){this._terminals[A]._id=c,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:D.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},b=new y(this._proxy,c,v,h);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(c,a){const h=this._getTerminalById(c);h&&h._setProcessId(a)}async $startExtensionTerminal(c,a){const h=this._getTerminalById(c);if(!h)return{message:(0,P.localize)(0,null,c)};h.isOpen||await new Promise(v=>{const b=this.onDidOpenTerminal(async A=>{A===h.value&&(b.dispose(),v())})});const d=this._terminalProcesses.get(c);d?d.startSendingEvents(a):this._extensionTerminalAwaitingStart[c]={initialDimensions:a}}_setupExtHostProcessListeners(c,a){const h=new k.DisposableStore;h.add(a.onProcessReady(v=>this._proxy.$sendProcessReady(c,v.pid,v.cwd))),h.add(a.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(c,v))),this._bufferer.startBuffering(c,a.onProcessData),h.add(a.onProcessExit(v=>this._onProcessExit(c,v))),this._terminalProcesses.set(c,a);const d=this._extensionTerminalAwaitingStart[c];return d&&a instanceof u&&(a.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),h}$acceptProcessAckDataEvent(c,a){this._terminalProcesses.get(c)?.acknowledgeDataEvent(a)}$acceptProcessInput(c,a){this._terminalProcesses.get(c)?.input(a)}$acceptTerminalInteraction(c){const a=this._getTerminalById(c);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(c,a,h){try{this._terminalProcesses.get(c)?.resize(a,h)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(c,a){this._terminalProcesses.get(c)?.shutdown(a)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(a=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:a}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,a,h){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,h),this._proxy.$registerProfileProvider(a,c.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(c,a){const h=new l.CancellationTokenSource().token;let d=await this._profileProviders.get(c)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,a);return}this.createTerminalFromOptions(d.options,a)}}async $provideLinks(c,a){const h=this._getTerminalById(c);if(!h)return[];this._terminalLinkCache.delete(c);const d=this._terminalLinkCancellationSource.get(c);d&&d.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,v);const b=[],A={terminal:h.value,line:a},O=[];for(const M of this._linkProviders)O.push(F.Promises.withAsyncBody(async V=>{v.token.onCancellationRequested(()=>V({provider:M,links:[]}));const H=await M.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||V({provider:M,links:H})}));const N=await Promise.all(O);if(v.token.isCancellationRequested)return[];const L=new Map;for(const M of N)M&&M.links.length>0&&b.push(...M.links.map(V=>{const H={id:r++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return L.set(H.id,{provider:M.provider,link:V}),H}));return this._terminalLinkCache.set(c,L),b}$activateLink(c,a){const h=this._terminalLinkCache.get(c)?.get(a);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(c,a){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const h=this._terminalProcessDisposables[c];h&&(h.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,a)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,a){const h=this._getTerminalObjectIndexById(c,a);return h!==null?c[h]:null}_getTerminalObjectIndexById(c,a){let h=null;return c.some((d,v)=>d._id===a?(h=v,!0):!1),h}getEnvironmentVariableCollection(c){let a=this._environmentVariableCollections.get(c.identifier.value);return a||(a=new o,this._setEnvironmentVariableCollection(c.identifier.value,a)),a}_syncEnvironmentVariableCollection(c,a){const h=(0,C.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(c,a.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(c){c.forEach(a=>{const h=a[0],d=new o(a[1]);this._setEnvironmentVariableCollection(h,d)})}$acceptDefaultProfile(c,a){this._defaultProfile=c,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(c,a){this._environmentVariableCollections.set(c,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,a)})}};f=je([ze(1,T.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class o{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,a){this._setIfDiffers(c,{value:a,type:_.EnvironmentVariableMutatorType.Replace})}append(c,a){this._setIfDiffers(c,{value:a,type:_.EnvironmentVariableMutatorType.Append})}prepend(c,a){this._setIfDiffers(c,{value:a,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,a){const h=this.map.get(c);(!h||h.value!==a.value||h.type!==a.type)&&(this.map.set(c,a),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,a){this.map.forEach((h,d)=>c.call(a,d,h,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let S=class extends f{constructor(c){super(!1,c)}createTerminal(c,a,h){throw new R.NotSupportedError}createTerminalFromOptions(c,a){throw new R.NotSupportedError}};S=je([ze(0,T.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function s(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function i(n){return g.ThemeColor.isThemeColor(n)?n:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[250],ve([0,1,17,22,21,3,76,58,6,25,18,33,5,14,64,15,7,220,127,88]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let f=class{constructor(A,O){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(l.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new S(this.proxy),O.registerArgumentProcessor({processArgument:N=>N?.$mid===13?g.TestItem.toItemFromContext(N):N})}createTestController(A,O,N){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const L=new _.DisposableStore,M=L.add(new F.SingleUseTestCollection(A));M.root.label=O;const V=new Map,H=this.proxy,U={items:M.root.children,get label(){return O},set label($){O=$,M.root.label=$,H.$updateController(A,{label:O})},get refreshHandler(){return N},set refreshHandler($){N=$,H.$updateController(A,{canRefresh:!!$})},get id(){return A},createRunProfile:($,z,W,J,ne)=>{let se=(0,k.hash)($);for(;V.has(se);)se++;const K=new d(this.proxy,A,se,$,z,W,J,ne);return V.set(se,K),K},createTestItem($,z,W){return new p.TestItemImpl(A,$,z,W)},createTestRun:($,z,W=!0)=>this.runTracker.createTestRun(A,M,$,z,W),set resolveHandler($){M.resolveHandler=$},get resolveHandler(){return M.resolveHandler},dispose:()=>{L.dispose()}};H.$registerTestController(A,O,!!N),L.add((0,_.toDisposable)(()=>H.$unregisterTestController(A)));const B={controller:U,collection:M,profiles:V};return this.controllers.set(A,B),L.add((0,_.toDisposable)(()=>this.controllers.delete(A))),L.add(M.onDidGenerateDiff($=>H.$publishDiff(A,$))),U}createTestObserver(){return this.observer.checkout()}async runTests(A,O=I.CancellationToken.None){const N=s(A);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(N.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(M=>M.id)??[L.collection.root.id],profileGroup:v[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:A.exclude?.map(M=>M.id)},O)}$provideFileCoverage(A,O,N){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===A?M.getCoverage(O):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(A,O,N,L){return(0,m.mapFind)(this.runTracker.trackers,V=>V.id===A?V.getCoverage(O):void 0)?.resolveFileCoverage(N,L)??Promise.resolve([])}$configureRunProfile(A,O){this.controllers.get(A)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(A,O){await this.controllers.get(A)?.controller.refreshHandler?.(O)}$publishTestResults(A){this.results=Object.freeze(A.map(O=>(0,P.deepFreeze)(g.TestResults.to(O))).concat(this.results).sort((O,N)=>N.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,O){const N=this.controllers.get(u.TestId.fromString(A).controllerId)?.collection;N&&(await N.expand(A,O<0?1/0:O),N.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,O){const N=this.controllers.get(A.controllerId);if(!N)return;const{collection:L,profiles:M}=N,V=M.get(A.profileId);if(!V)return;const H=A.testIds.map(z=>L.tree.get(z)).filter(R.isDefined),U=A.excludeExtIds.map(z=>N.collection.tree.get(z)).filter(R.isDefined).filter(z=>H.some(W=>W.fullId.compare(z.fullId)===2));if(!H.length)return;const B=new E.TestRunRequest(H.some(z=>z.actual instanceof p.TestItemRootImpl)?void 0:H.map(z=>z.actual),U.map(z=>z.actual),V),$=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(A,N.collection),O);try{await V.runHandler(B,O)}finally{$.isRunning&&!O.isCancellationRequested&&await D.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};f=je([ze(0,w.IExtHostRpcService)],f),e.ExtHostTesting=f;class o extends _.Disposable{constructor(A,O,N){super();this.dto=A,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const O=this.dto.id,N=this.dto.controllerId,L=(0,C.generateUuid)(),M=new n(this.proxy,O,L),V=$=>(z,...W)=>{if(U){console.warn(`Setting the state of test "${z.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(z)||(this.ensureTestIsKnown(z),$(z,...W))},H=($,z)=>{const W=z instanceof Array?z.map(g.TestMessage.from):[g.TestMessage.from(z)];if($.uri&&$.range){const J={range:g.Range.from($.range),uri:$.uri};for(const ne of W)ne.location=ne.location||J}this.proxy.$appendTestMessagesInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),W)};let U=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return M.coverageProvider},set coverageProvider($){M.coverageProvider=$},enqueued:V($=>{this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),1)}),skipped:V($=>{this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),5)}),started:V($=>{this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),2)}),errored:V(($,z,W)=>{H($,z),this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),6,W)}),failed:V(($,z,W)=>{H($,z),this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,N).toString(),4,W)}),passed:V(($,z)=>{this.proxy.$updateTestStateInRun(O,L,u.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,z)}),appendOutput:($,z,W)=>{U||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(O,L,t.VSBuffer.fromString($),z&&g.location.from(z),W&&u.TestId.fromExtHostTestItem(W,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(O,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:B,coverage:M}),this.proxy.$startedTestRunTask(O,{id:L,name:A,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof p.TestItemImpl))throw new p.InvalidTestItemError(A.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const O=[],N=this.dto.colllection.root;for(;;){const L=g.TestItem.from(A);if(O.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),A===N))break;A=A.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class S{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,O,N){return this.getTracker(A,O,N)}cancelRunById(A){for(const O of this.tracked.values())if(O.id===A){O.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,O,N,L,M){const V=this.tracked.get(N);if(V)return V.createRun(L);const H=i.fromPublic(A,O,N,M),U=s(N);this.proxy.$startedExtensionTestRun({controllerId:A,profile:U&&{group:v[U.kind],id:U.profileId},exclude:N.exclude?.map($=>$.id)??[],id:H.id,include:N.include?.map($=>$.id)??[O.root.id],persist:M});const B=this.getTracker(N,H);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),B.createRun(L)}getTracker(A,O,N){const L=new o(O,this.proxy,N);return this.tracked.set(A,L),L.onEnd(()=>this.tracked.delete(A)),L}}e.TestRunCoordinator=S;const s=b=>{if(!!b.profile){if(!(b.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return b.profile}};class i{constructor(A,O,N,L,M,V){this.controllerId=A,this.id=O,this.isPersisted=M,this.colllection=V,this.includePrefix=N.map(H=>H+"\0"),this.excludePrefix=L.map(H=>H+"\0")}static fromPublic(A,O,N,L){return new i(A,(0,C.generateUuid)(),N.include?.map(M=>u.TestId.fromExtHostTestItem(M,A).toString())??[A],N.exclude?.map(M=>u.TestId.fromExtHostTestItem(M,A).toString())??[],L,O)}static fromInternal(A,O){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,O)}isIncluded(A){const O=u.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(O===N||O.startsWith(N))return!1;for(const N of this.includePrefix)if(O===N||O.startsWith(N))return!0;return!1}}e.TestRunDto=i;class n{constructor(A,O,N){this.proxy=A,this.runId=O,this.taskId=N}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(A,O){const N=await this.fileCoverage;let L=N?.[A];return!this._coverageProvider||!N||!L?[]:(L.detailedCoverage||(L=N[A]=await this._coverageProvider.resolveFileCoverage?.(L,O)??L),L.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class c extends y.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,g.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:O,removed:N}=this;return{get added(){return[...A].map(L=>L.revived)},get updated(){return[...O].map(L=>L.revived)},get removed(){return[...N].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,O){return{...A,revived:g.TestItem.toPlain(A.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=a;class h{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(O=>O.revived)},dispose:(0,T.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class d{constructor(A,O,N,L,M,V,H=!1,U=void 0){this.controllerId=O,this.profileId=N,this._label=L,this.kind=M,this.runHandler=V,this._isDefault=H,this._tag=U,r.set(this,void 0),nt(this,r,A,"f");const B=v[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Le(this,r,"f").$publishTestRunProfile({profileId:N,controllerId:O,tag:U?g.TestTag.namespace(this.controllerId,U.id):null,label:L,group:B,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?g.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Le(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,r=new WeakMap;const v={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,17,5,130,15,7]),function(Z,e,m,t,I,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(l=>l.value)}async showTextDocument(R,C,l){let w;typeof C=="number"?w={position:T.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?w={position:T.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?T.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:w={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,w),g=p&&this._extHostDocumentsAndEditors.getEditor(p);if(g)return g.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new D.TextEditorDecorationType(this._proxy,R,C).value}$acceptEditorPropertiesChanged(R,C){const l=this._extHostDocumentsAndEditors.getEditor(R);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const w=C.selections.selections.map(T.Selection.to);l._acceptSelections(w)}if(C.visibleRanges){const w=t.coalesce(C.visibleRanges.map(T.Range.to));l._acceptVisibleRanges(w)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:T.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const w=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),p=C.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:p,kind:w})}if(C.visibleRanges){const w=t.coalesce(C.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(R){for(const C in R){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const w=T.ViewColumn.to(R[C]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=_}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(I.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const w=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(w))?.get(l.handle)}return l}})}async $getTimeline(R,C,l,w,p){return this._providers.get(R)?.provideTimeline(m.URI.revive(C),l,w,p)}registerTimelineProvider(R,C,l,w){const p=new D.DisposableStore,g=this.convertTimelineItem(C.id,w,p).bind(this);let E;C.onDidChange&&(E=C.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:C.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:R,onDidChange:void 0,async provideTimeline(y,u,r,f){f?.resetCache&&(p.clear(),F.get(C.id)?.clear());const o=await C.provideTimeline(y,u,r);if(o==null)return;const S=g(y,f);return{...o,source:C.id,items:o.items.map(S)}},dispose(){for(const y of F.values())y.get(C.id)?.clear();E?.dispose(),p.dispose()}})}convertTimelineItem(R,C,l){return(w,p)=>{let g;if(p?.cacheResults){let E=this._itemsBySourceAndUriMap.get(R);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(R,E));const F=_(w);g=E.get(F),g===void 0&&(g=new Map,E.set(F,g))}return E=>{const{iconPath:F,...y}=E,u=`${R}|${E.id??E.timestamp}`;g?.set(u,E);let r,f,o;return E.iconPath&&(F instanceof T.ThemeIcon?o={id:F.id,color:F.color}:m.URI.isUri(F)?(r=F,f=F):{light:r,dark:f}=F),{...y,id:y.id??void 0,handle:u,source:R,command:E.command?C.toInternal(E.command,l):void 0,icon:r,iconDark:f,themeIcon:o,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,D.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function _(P){return P?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(_){this._openers=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,P,R,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=C.schemes.find(w=>!T.supportedSchemes.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,C.schemes,_,C.label),(0,m.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(_,P,R){const C=this._openers.get(_);if(!C)throw new Error(`Unknown opener with id: ${_}`);const l=I.URI.revive(P);return C.canOpenExternalUri(l,R)}async $openUri(_,P,R){const C=this._openers.get(_);if(!C)throw new Error(`Unknown opener id: '${_}'`);return C.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,16,27]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,P),(0,I.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,R){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(R))}catch(l){(0,D.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[69],ve([0,1,3,10,2,179,204,87,5]),function(Z,e,m,t,I,D,T,k,_){"use strict";var P,R,C,l,w,p,g,E,F,y,u,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(h,d,v,b,A,O,N){P.set(this,void 0),R.set(this,void 0),C.set(this,void 0),l.set(this,void 0),w.set(this,void 0),p.set(this,void 0),g.set(this,""),E.set(this,void 0),F.set(this,!1),y.set(this,!1),u.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Le(this,r,"f").event,nt(this,P,h,"f"),nt(this,R,d,"f"),nt(this,E,v,"f"),nt(this,l,b,"f"),nt(this,w,A,"f"),nt(this,p,O,"f"),nt(this,u,o(O),"f"),nt(this,C,N,"f")}dispose(){nt(this,F,!0,"f"),Le(this,r,"f").fire(),Le(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return nt(this,y,!0,"f"),(0,k.asWebviewUri)(h,Le(this,l,"f").remote)}get cspSource(){const h=Le(this,p,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let d=h.toString();return d.endsWith("/")||(d+="/"),d+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,g,"f")}set html(h){this.assertNotDisposed(),Le(this,g,"f")!==h&&(nt(this,g,h,"f"),!Le(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(nt(this,y,!0,"f"),Le(this,C,"f").report("Webview vscode-resource: uris",Le(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,R,"f").$setHtml(Le(this,P,"f"),h))}get options(){return this.assertNotDisposed(),Le(this,E,"f")}set options(h){this.assertNotDisposed(),Le(this,R,"f").$setOptions(Le(this,P,"f"),i(Le(this,p,"f"),Le(this,w,"f"),h)),nt(this,E,h,"f")}async postMessage(h){if(Le(this,F,"f"))return!1;const d=(0,T.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Le(this,u,"f")});return Le(this,R,"f").$postMessage(Le(this,P,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Le(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,P=new WeakMap,R=new WeakMap,C=new WeakMap,l=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,F=new WeakMap,y=new WeakMap,u=new WeakMap,r=new WeakMap;function o(a){try{const h=(0,D.normalizeVersion)((0,D.parseVersion)(a.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class S{constructor(h,d,v,b,A){this.initData=d,this.workspace=v,this._logService=b,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=h.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(h,d,v){const b=this.getWebview(h);if(b){const{message:A}=(0,T.deserializeWebviewMessage)(d,v.value);b._onMessageEmitter.fire(A)}}$onMissingCsp(h,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,d,v){const b=new f(h,this._webviewProxy,n(d),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(h,b),b._onDidDispose(()=>{this._webviews.delete(h)}),b}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=S;function s(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=s;function i(a,h,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||c(a,h)}}e.serializeWebviewOptions=i;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(h=>I.URI.from(h))}}e.reviveOptions=n;function c(a,h){return[...(h?.getWorkspaceFolders()||[]).map(d=>d.uri),a.extensionLocation]}}),define(pe[255],ve([0,1,21,58,6,10,23,2,15,69,86,5,7]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(o,S){this.document=o,this._storagePath=S,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,S){await this.getEdit(o).undo(),S||this.disposeBackup()}async redo(o,S){await this.getEdit(o).redo(),S||this.disposeBackup()}disposeEdits(o){for(const S of o)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=r(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const S=this._edits.get(o,0);if(!S)throw new Error("No edit found");return S}}class p{constructor(){this._documents=new Map}get(o,S){return this._documents.get(this.key(o,S))}add(o,S,s){const i=this.key(o,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${o} resource:${S.uri}`);const n=new w(S,s);return this._documents.set(i,n),n}delete(o,S){const s=this.key(o,S.uri);this._documents.delete(s)}key(o,S){return`${o}@@@${S}`}}var g;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(g||(g={}));class E{constructor(){this._providers=new Map}addTextProvider(o,S,s){return this.add(0,o,S,s)}addCustomProvider(o,S,s){return this.add(1,o,S,s)}get(o){return this._providers.get(o)}add(o,S,s,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:o,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class F{constructor(o,S,s,i,n){this._extHostDocuments=S,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=n,this._editorProviders=new E,this._documents=new p,this._proxy=o.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,S,s,i){const n=new I.DisposableStore;return y(s)?(n.add(this._editorProviders.addTextProvider(S,o,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(o),S,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(S,o,s)),this.supportEditing(s)&&n.add(s.onDidChangeCustomDocument(c=>{const a=this.getCustomDocumentEntry(S,c.document.uri);if(u(c)){const h=a.addEdit(c);this._proxy.$onDidEdit(c.document.uri,S,h,c.label)}else this._proxy.$onContentChange(c.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(o),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(o))),l.Disposable.from(n,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(o,S,s,i,n){const c=this._editorProviders.get(S);if(!c)throw new Error(`No provider found for '${S}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${S}'`);const a=k.URI.revive(o),h=await c.provider.openCustomDocument(a,{backupId:s,untitledDocumentData:i?.buffer},n);let d;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(S,h,d),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(o,S){const s=this._editorProviders.get(S);if(!s)throw new Error(`No provider found for '${S}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(o),{document:n}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(o,S,s,i,n,c){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);const h=_.ViewColumn.to(n),d=this._extHostWebview.createNewWebview(S,i.webviewOptions,a.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(S,s,i.title,h,i.panelOptions,d),b=k.URI.revive(o);switch(a.type){case 1:{const{document:A}=this.getCustomDocumentEntry(s,b);return a.provider.resolveCustomEditor(A,v,c)}case 0:{const A=this._extHostDocuments.getDocument(b);return a.provider.resolveCustomTextEditor(A,v,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,S,s){this.getCustomDocumentEntry(S,o).disposeEdits(s)}async $onMoveCustomEditor(o,S,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const c=k.URI.revive(S),a=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(a,n,m.CancellationToken.None)}async $undo(o,S,s,i){return this.getCustomDocumentEntry(S,o).undo(s,i)}async $redo(o,S,s,i){return this.getCustomDocumentEntry(S,o).redo(s,i)}async $revert(o,S,s){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(o,S,s){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(o,S,s,i){const n=this.getCustomDocumentEntry(S,o);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,k.URI.revive(s),i)}async $backup(o,S,s){const i=this.getCustomDocumentEntry(S,o),c=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(c),c.id}getCustomDocumentEntry(o,S){const s=this._documents.get(o,k.URI.revive(S));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(o){const s=this._editorProviders.get(o)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function y(f){return typeof f.resolveCustomTextEditor=="function"}function u(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function r(f){const o=f.scheme===D.Schemas.file||f.scheme===D.Schemas.untitled?f.fsPath:f.toString();return(0,t.hash)(o)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[256],ve([0,1,3,6,2,33,15,69,5,7]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";var R,C,l,w,p,g,E,F,y,u,r,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(c,a,h,d,v,b,A){super();R.set(this,void 0),C.set(this,void 0),l.set(this,void 0),w.set(this,void 0),p.set(this,void 0),g.set(this,void 0),E.set(this,void 0),F.set(this,void 0),y.set(this,!0),u.set(this,!0),r.set(this,!1),f.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,f,"f").event,o.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Le(this,o,"f").event,nt(this,R,c,"f"),nt(this,C,a,"f"),nt(this,l,h,"f"),nt(this,p,b,"f"),nt(this,F,v,"f"),nt(this,g,d,"f"),nt(this,w,A,"f")}dispose(){Le(this,r,"f")||(nt(this,r,!0,"f"),Le(this,f,"f").fire(),Le(this,C,"f").$disposeWebview(Le(this,R,"f")),Le(this,w,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,w,"f")}get viewType(){return this.assertNotDisposed(),Le(this,l,"f")}get title(){return this.assertNotDisposed(),Le(this,g,"f")}set title(c){this.assertNotDisposed(),Le(this,g,"f")!==c&&(nt(this,g,c,"f"),Le(this,C,"f").$setTitle(Le(this,R,"f"),c))}get iconPath(){return this.assertNotDisposed(),Le(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Le(this,E,"f")!==c&&(nt(this,E,c,"f"),Le(this,C,"f").$setIconPath(Le(this,R,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,F,"f")=="number"&&Le(this,F,"f")<0))return Le(this,F,"f")}get active(){return this.assertNotDisposed(),Le(this,u,"f")}get visible(){return this.assertNotDisposed(),Le(this,y,"f")}_updateViewState(c){Le(this,r,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,u,c.active,"f"),nt(this,y,c.visible,"f"),nt(this,F,c.viewColumn,"f"),Le(this,o,"f").fire({webviewPanel:this}))}reveal(c,a){this.assertNotDisposed(),Le(this,C,"f").$reveal(Le(this,R,"f"),{viewColumn:c?T.ViewColumn.from(c):void 0,preserveFocus:!!a})}assertNotDisposed(){if(Le(this,r,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,l=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,F=new WeakMap,y=new WeakMap,u=new WeakMap,r=new WeakMap,f=new WeakMap,o=new WeakMap;class s{constructor(c,a,h){this.webviews=a,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,D.generateUuid)()}createWebviewPanel(c,a,h,d,v={}){const b=typeof d=="object"?d.viewColumn:d,A={viewColumn:T.ViewColumn.from(b),preserveFocus:typeof d=="object"&&!!d.preserveFocus},O=(0,k.shouldSerializeBuffersForPostMessage)(c),N=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(c),N,a,{title:h,panelOptions:i(v),webviewOptions:(0,k.serializeWebviewOptions)(c,this.workspace,v),serializeBuffersForPostMessage:O},A);const L=this.webviews.createNewWebview(N,v,c);return this.createNewWebviewPanel(N,a,h,b,v,L)}$onDidChangeWebviewPanelViewStates(c){const a=Object.keys(c);a.sort((h,d)=>{const v=c[h],b=c[d];return v.active?1:b.active?-1:+v.visible-+b.visible});for(const h of a){const d=this.getWebviewPanel(h);if(!d)continue;const v=c[h];d._updateViewState({active:v.active,visible:v.visible,viewColumn:T.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,a,h){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:h,extension:c}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(c,a,h,d){const v=this._serializers.get(a);if(!v)throw new Error(`No serializer found for '${a}'`);const{serializer:b,extension:A}=v,O=this.webviews.createNewWebview(c,h.webviewOptions,A),N=this.createNewWebviewPanel(c,a,h.title,d,h.panelOptions,O);await b.deserializeWebviewPanel(N,h.state)}createNewWebviewPanel(c,a,h,d,v,b){const A=new S(c,this._proxy,a,h,d,v,b);return this._webviewPanels.set(c,A),A}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=s;function i(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[257],ve([0,1,3,6,69,5,7]),function(Z,e,m,t,I,D,T){"use strict";var k,_,P,R,C,l,w,p,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(r,f,o,S,s,i){super();k.set(this,void 0),_.set(this,void 0),P.set(this,void 0),R.set(this,void 0),C.set(this,!1),l.set(this,void 0),w.set(this,void 0),p.set(this,void 0),g.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Le(this,g,"f").event,E.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,E,"f").event,nt(this,P,o,"f"),nt(this,w,S,"f"),nt(this,k,r,"f"),nt(this,_,f,"f"),nt(this,R,s,"f"),nt(this,l,i,"f")}dispose(){Le(this,C,"f")||(nt(this,C,!0,"f"),Le(this,E,"f").fire(),Le(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,w,"f")}set title(r){this.assertNotDisposed(),Le(this,w,"f")!==r&&(nt(this,w,r,"f"),Le(this,_,"f").$setWebviewViewTitle(Le(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Le(this,p,"f")}set description(r){this.assertNotDisposed(),Le(this,p,"f")!==r&&(nt(this,p,r,"f"),Le(this,_,"f").$setWebviewViewDescription(Le(this,k,"f"),r))}get visible(){return Le(this,l,"f")}get webview(){return Le(this,R,"f")}get viewType(){return Le(this,P,"f")}_setVisible(r){r===Le(this,l,"f")||Le(this,C,"f")||(nt(this,l,r,"f"),Le(this,g,"f").fire())}show(r){this.assertNotDisposed(),Le(this,_,"f").$show(Le(this,k,"f"),!!r)}assertNotDisposed(){if(Le(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,P=new WeakMap,R=new WeakMap,C=new WeakMap,l=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap;class y{constructor(r,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,f,o,S){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:o,extension:r}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(r),f,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(r,f,o,S,s){const i=this._viewProviders.get(f);if(!i)throw new Error(`No view provider found for '${f}'`);const{provider:n,extension:c}=i,a=this._extHostWebview.createNewWebview(r,{},c),h=new F(r,this._proxy,f,o,a,!0);this._webviewViews.set(r,h),await n.resolveWebviewView(h,{state:S},s)}async $onDidChangeWebviewViewVisibility(r,f){this.getWebviewView(r)._setVisible(f)}async $disposeWebviewView(r){const f=this.getWebviewView(r);this._webviewViews.delete(r),f.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const f=this._webviewViews.get(r);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=y}),define(pe[134],ve([0,1,3,5,2,10,8,4,14]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(C){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let w;if(typeof C=="string"){w=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,T.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,w,l)}async asExternalUri(C,l){if((0,T.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(C,l);return I.URI.from(w)}};P.InitialState={focused:!0},P=je([ze(0,_.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,33,38,6,5,2,14]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(l,w){super();const p=l.getProxy(k.MainContext.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async g=>{const E=_.URI.file((0,m.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await p.$download(g,E),E})}};R=je([ze(0,P.IExtHostRpcService),ze(1,D.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(pe[259],ve([0,1,132,10,188,33]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends m.ExtHostLoggerService{doCreateLogger(_,P,R){return _.scheme===t.Schemas.file?new I.SpdLogLogger(R?.name||(0,D.generateUuid)(),_.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,P):super.doCreateLogger(_,P,R)}}e.ExtHostLoggerService=T}),define(pe[260],ve([0,1,60,9,2,68,6,10,13,30]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends D.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const S=await super._getWorkspaceStorageURI(o);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const s=S.fsPath;let i=0;do{let n;i===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await C(n);const c=t.join(n,"vscode.lock"),a=await g(this._logService,c,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),I.URI.file(n);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function C(f){try{await P.Promises.stat(f);return}catch{}try{await P.Promises.mkdir(f,{recursive:!0})}catch{}}const l=1e3,w=10*60*1e3;class p extends T.Disposable{constructor(o,S){super();this.logService=o,this.filename=S,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await E(o,S);(!s||s.pid!==process.pid)&&(o.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){o.error(i),o.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+o};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function g(f,o,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(o,JSON.stringify(i),{flag:"wx"})}catch(i){f.error(i)}const s=await E(f,o);return!s||s.pid!==process.pid?S?(f.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),u(f,o)):(f.info(`Lock '${o}': Lock acquired.`),new p(f,o))}async function E(f,o){let S;try{S=await P.Promises.readFile(o)}catch(s){return f.error(s),null}try{return JSON.parse(String(S))}catch(s){return f.error(s),null}}async function F(f,o){let S;try{S=await P.Promises.stat(o)}catch(s){return f.error(s),0}return S.mtime.getTime()}function y(f){try{return process.kill(f,0),!0}catch{return!1}}async function u(f,o){const S=await E(f,o);if(!S)return f.info(`Lock '${o}': Could not read pid of lock holder.`),r(f,o);if(S.willReleaseAt){let a=S.willReleaseAt-Date.now();if(a<5e3){for(a>0?f.info(`Lock '${o}': The lockfile is scheduled to be released in ${a} ms.`):f.info(`Lock '${o}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,_.timeout)(Math.min(100,a)),await F(f,o)===0)return r(f,o);a=S.willReleaseAt-Date.now()}return r(f,o)}}if(!y(S.pid))return f.info(`Lock '${o}': The pid ${S.pid} appears to be gone.`),r(f,o);const s=await F(f,o),i=Date.now()-s;if(i<=w)return f.info(`Lock '${o}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;f.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const n=await F(f,o),c=Date.now()-n;return c<=w?(f.info(`Lock '${o}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(f.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),r(f,o))}async function r(f,o){f.info(`Lock '${o}': Deleting a stale lock.`);try{await P.Promises.unlink(o)}catch{}return g(f,o,!0)}}),define(pe[261],ve([0,1,33,14,34]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let D=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,P){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:P})}createTerminalFromOptions(k,_){const P=new I.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(P),P.create(k,this._serializeParentTerminal(k,_)),P.value}};D=je([ze(0,t.IExtHostRpcService)],D),e.ExtHostTerminalService=D}),define(pe[262],ve([0,1,5,14,171,6,26,2,37,23,30,7,12,51,3,121,94,11]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class y{constructor(h,d,v){this.remoteAddress=h,this.localAddress=d,this._dispose=v,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function u(a){const h=a.trim().split(`
`),d=[];return h.forEach(b=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);A&&A.length>=3&&d.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),d.reduce((b,A)=>(b[A.socket]=A,b),{})}e.getSockets=u;function r(...a){const h=[].concat(...a.map(o));return[...new Map(h.filter(d=>d.st==="0A").map(d=>{const v=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:f(v[0]),port:parseInt(v[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=r;function f(a){let h="";if(a.length===8)for(let d=a.length-2;d>=0;d-=2)h+=parseInt(a.substr(d,2),16),d!==0&&(h+=".");else for(let d=a.length-4;d>=0;d-=4)h+=parseInt(a.substr(d,4),16).toString(16),d!==0&&(h+=":");return h}e.parseIpAddress=f;function o(a){const h=a.trim().split(`
`),d=h.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return h.map(b=>b.trim().split(/\s+/).reduce((A,O,N)=>(A[d[N]||N]=O,A),{}))}e.loadConnectionTable=o;function S(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function s(a){const h=a.trim().split(`
`),d=[];return h.forEach(v=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(v);b&&b.length>=4&&d.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),d}e.getRootProcesses=s;async function i(a,h,d){const v=d.reduce((A,O)=>(A[O.pid]=O,A),{}),b=[];return a.forEach(({socket:A,ip:O,port:N})=>{const L=h[A]?h[A].pid:void 0,M=L?v[L]?.cmd:void 0;L&&M&&!S(M)&&b.push({host:O,port:N,detail:M,pid:L})}),b}e.findPorts=i;function n(a,h,d){const v=new Map,b=s(h);for(const A of a){const O=d.get(A.port);if(O){v.set(A.port,O);continue}const N=b.find(L=>L.cmd.includes(`${A.port}`));if(N){let L=N,M;do M=b.find(V=>V.ppid===L.pid),M&&(L=M);while(M);v.set(A.port,{host:A.ip,port:A.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else v.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return v}e.tryFindRootPorts=n;let c=class extends D.Disposable{constructor(h,d,v){super();this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(m.MainContext.MainThreadTunnelService),l.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(d,h.displayName);if(v){const b=new y(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,d){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:h,provider:d}),this._proxy.$registerPortsAttributesProvider(h,v),new C.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(h,d,v,b,A){const O=[];for(const L of h){const M=this._portAttributesProviders.get(L);if(!M)return[];O.push(...await Promise.all(d.map(async V=>M.provider.providePortAttributes(V,v,b,A))))}const N=O.filter(L=>!!L);return N.length>0?N.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let d=new E.MovingAverage,v;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),A=(await this.findCandidatePorts()).filter(N=>(0,g.isLocalhost)(N.host)||(0,g.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(N=>N.port).join(", ")}`);const O=new Date().getTime()-b;d.update(O),(!v||JSON.stringify(v)!==JSON.stringify(A))&&(v=A,await this._proxy.$onFoundNewCandidates(v)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(d.value)))}}async setTunnelFactory(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let d=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const v=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:d}:void 0;this._proxy.$setTunnelProvider(v)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,d){if(this._extensionTunnels.has(h.host)){const v=this._extensionTunnels.get(h.host);v.has(h.port)&&(d&&v.get(h.port).disposeListener.dispose(),await v.get(h.port).tunnel.dispose(),v.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(h,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const b=await v;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const A=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:b,disposeListener:A}),w.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const d=await Promise.all(h.map(b=>this._showCandidatePort(b.host,b.port,b.detail??""))),v=h.filter((b,A)=>d[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(b=>b.port).join(", ")} to ${v.map(b=>b.port).join(", ")}`),v}async findCandidatePorts(){let h="",d="";try{h=await R.Promises.readFile("/proc/net/tcp","utf8"),d=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const v=r(h,d),b=await new Promise(U=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,$,z)=>{U($)})}),A=u(b),O=await R.Promises.readdir("/proc"),N=[];for(let U of O)try{const B=Number(U),$=P.joinPath(k.URI.file("/proc"),U);if((await R.Promises.stat($.fsPath)).isDirectory()&&!isNaN(B)){const W=await R.Promises.readlink(P.joinPath($,"cwd").fsPath),J=await R.Promises.readFile(P.joinPath($,"cmdline").fsPath,"utf8");N.push({pid:B,cwd:W,cmd:J})}}catch{}const L=[],M=v.filter(U=>{const B=A[U.socket];return B||L.push(U),B}),V=i(M,A,N);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const U=await new Promise(B=>{(0,_.exec)("ps -F -A -l | grep root",($,z,W)=>{B(z)})});this._foundRootPorts=n(L,U,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return V.then(U=>H?U.concat(H):U)}};c=je([ze(0,t.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,F.ILogService)],c),e.ExtHostTunnelService=c}),define(pe[263],ve([0,1,13,22,21,16,3,6,103,226,52]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(v,b){try{return JSON.stringify(v,b)}catch{return"null"}}const w="$$ref$$",p={[w]:-1};class g{constructor(b,A){this.jsonString=b,this.referencedBuffers=A}}function E(v,b=null,A=!1){const O=[];return{jsonString:(A?l:JSON.stringify)(v,(L,M)=>{if(typeof M=="undefined")return p;if(typeof M=="object"){if(M instanceof t.VSBuffer){const V=O.push(M)-1;return{[w]:V}}if(b)return b(L,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=E;function F(v,b,A){return JSON.parse(v,(O,N)=>{if(N){const L=N[w];if(typeof L=="number")return b[L];if(A&&N.$mid===1)return A.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=F;function y(v,b){return JSON.stringify(v,b)}function u(v){return v?(b,A)=>A&&A.$mid===1?v.transformOutgoing(A):A:null}var r;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var f;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(f=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},S=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(b,A=null,O=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=A,this._uriTransformer=O,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,L=R.ProxyIdentifier.count;N<L;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,_.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:A,sid:O}=b;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,O)),this._proxies[A]}_createProxy(b,A){let O={get:(N,L)=>(typeof L=="string"&&!N[L]&&L.charCodeAt(0)===36&&(N[L]=(...M)=>this._remoteCall(b,L,M)),L===s?A:N[L])};return new Proxy(Object.create(null),O)}set(b,A){return this._locals[b.nid]=A,A}assertRegistered(b){for(let A=0,O=b.length;A<O;A++){const N=b[A];if(!this._locals[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}_receiveOneMessage(b){if(this._isDisposed)return;const A=b.byteLength,O=n.read(b,0),N=O.readUInt8(),L=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:M,method:V,args:H}=a.deserializeRequestJSONArgs(O);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(A,L,M,V,H,N===2);break}case 3:case 4:{let{rpcId:M,method:V,args:H}=a.deserializeRequestMixedArgs(O);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(A,L,M,V,H,N===4);break}case 5:{this._logger&&this._logger.logIncoming(A,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(A,L);break}case 7:{this._receiveReply(A,L,void 0);break}case 9:{let M=a.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(A,L,M);break}case 10:{const M=a.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(A,L,M);break}case 8:{let M=a.deserializeReplyOKVSBuffer(O);this._receiveReply(A,L,M);break}case 11:{let M=a.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(A,L,M);break}case 12:{this._receiveReplyErr(A,L,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,A,O,N,L,M){this._logger&&this._logger.logIncoming(b,A,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(O)}.${N}(`,L);const V=String(A);let H,U;if(M){const $=new I.CancellationTokenSource;L.push($.token),H=this._invokeHandler(O,N,L),U=()=>$.cancel()}else H=this._invokeHandler(O,N,L),U=o;this._cancelInvokedHandlers[V]=U;const B=a.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(B.byteLength,A,1,"ack"),this._protocol.send(B),H.then($=>{delete this._cancelInvokedHandlers[V];const z=a.serializeReplyOK(A,$,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,A,1,"reply:",$),this._protocol.send(z)},$=>{delete this._cancelInvokedHandlers[V];const z=a.serializeReplyErr(A,$);this._logger&&this._logger.logOutgoing(z.byteLength,A,1,"replyErr:",$),this._protocol.send(z)})}_receiveCancel(b,A){this._logger&&this._logger.logIncoming(b,A,1,"receiveCancel");const O=String(A);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(b,A,O){this._logger&&this._logger.logIncoming(b,A,0,"receiveReply:",O);const N=String(A);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const L=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],L.resolveOk(O)}_receiveReplyErr(b,A,O){this._logger&&this._logger.logIncoming(b,A,0,"receiveReplyErr:",O);const N=String(A);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const L=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),L.resolveErr(M)}_invokeHandler(b,A,O){try{return Promise.resolve(this._doInvokeHandler(b,A,O))}catch(N){return Promise.reject(N)}}_doInvokeHandler(b,A,O){const N=this._locals[b];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(b));let L=N[A];if(typeof L!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.getStringIdentifierForProxy)(b));return L.apply(N,O)}_remoteCall(b,A,O){if(this._isDisposed)return Promise.reject(D.canceled());let N=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(D.canceled());const L=a.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,V=String(M),H=new P.LazyPromise;N&&N.onCancellationRequested(()=>{const B=a.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(a.serializeCancel(M))}),this._pendingRPCReplies[V]=H,this._onWillSendRequest(M);const U=a.serializeRequest(M,b,A,L,!!N);return this._logger&&this._logger.logOutgoing(U.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(b)}.${A}(`,O),this._protocol.send(U),H}}e.RPCProtocol=i,C=S,i.UNRESPONSIVE_TIME=3*1e3;class n{constructor(b,A){this._buff=b,this._offset=A}static alloc(b,A,O){let N=new n(t.VSBuffer.alloc(O+1+4),0);return N.writeUInt8(b),N.writeUInt32(A),N}static read(b,A){return new n(b,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,O}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,O}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,A}static sizeMixedArray(b){let A=0;A+=1;for(let O=0,N=b.length;O<N;O++){const L=b[O];switch(A+=1,L.type){case 1:A+=this.sizeLongString(L.value);break;case 2:A+=this.sizeVSBuffer(L.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(L.value);for(let M=0;M<L.buffers.length;++M)A+=this.sizeVSBuffer(L.buffers[M]);break;case 4:break}}return A}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let A=0,O=b.length;A<O;A++){const N=b[A];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let L=0;L<N.buffers.length;++L)this.writeBuffer(N.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(b);for(let O=0;O<b;O++)switch(this.readUInt8()){case 1:A[O]=this.readLongString();break;case 2:A[O]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),M=this.readLongString(),V=[];for(let H=0;H<L;++H)V.push(this.readVSBuffer());A[O]=new R.SerializableObjectWithBuffers(F(M,V,null));break}case 4:A[O]=void 0;break}return A}}n.sizeUInt32=4;var c;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(c||(c={}));class a{static _useMixedArgSerialization(b){for(let A=0,O=b.length;A<O;A++)if(b[A]instanceof t.VSBuffer||b[A]instanceof R.SerializableObjectWithBuffers||typeof b[A]=="undefined")return!0;return!1}static serializeRequestArguments(b,A){if(this._useMixedArgSerialization(b)){const O=[];for(let N=0,L=b.length;N<L;N++){const M=b[N];if(M instanceof t.VSBuffer)O[N]={type:2,value:M};else if(typeof M=="undefined")O[N]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:H}=E(M.value,A);O[N]={type:3,value:t.VSBuffer.fromString(V),buffers:H}}else O[N]={type:1,value:t.VSBuffer.fromString(y(M,A))}}return{type:1,args:O}}return{type:0,args:y(b,A)}}static serializeRequest(b,A,O,N,L){switch(N.type){case 0:return this._requestJSONArgs(b,A,O,N.args,L);case 1:return this._requestMixedArgs(b,A,O,N.args,L)}}static _requestJSONArgs(b,A,O,N,L){const M=t.VSBuffer.fromString(O),V=t.VSBuffer.fromString(N);let H=0;H+=n.sizeUInt8(),H+=n.sizeShortString(M),H+=n.sizeLongString(V);let U=n.alloc(L?2:1,b,H);return U.writeUInt8(A),U.writeShortString(M),U.writeLongString(V),U.buffer}static deserializeRequestJSONArgs(b){const A=b.readUInt8(),O=b.readShortString(),N=b.readLongString();return{rpcId:A,method:O,args:JSON.parse(N)}}static _requestMixedArgs(b,A,O,N,L){const M=t.VSBuffer.fromString(O);let V=0;V+=n.sizeUInt8(),V+=n.sizeShortString(M),V+=n.sizeMixedArray(N);let H=n.alloc(L?4:3,b,V);return H.writeUInt8(A),H.writeShortString(M),H.writeMixedArray(N),H.buffer}static deserializeRequestMixedArgs(b){const A=b.readUInt8(),O=b.readShortString(),N=b.readMixedArray(),L=new Array(N.length);for(let M=0,V=N.length;M<V;M++){const H=N[M];typeof H=="string"?L[M]=JSON.parse(H):L[M]=H}return{rpcId:A,method:O,args:L}}static serializeAcknowledged(b){return n.alloc(5,b,0).buffer}static serializeCancel(b){return n.alloc(6,b,0).buffer}static serializeReplyOK(b,A,O){if(typeof A=="undefined")return this._serializeReplyOKEmpty(b);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(b,A);if(A instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:L}=E(A.value,O,!0);return this._serializeReplyOKJSONWithBuffers(b,N,L)}else return this._serializeReplyOKJSON(b,l(A,O))}static _serializeReplyOKEmpty(b){return n.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,A){let O=0;O+=n.sizeVSBuffer(A);let N=n.alloc(8,b,O);return N.writeVSBuffer(A),N.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,A){const O=t.VSBuffer.fromString(A);let N=0;N+=n.sizeLongString(O);let L=n.alloc(9,b,N);return L.writeLongString(O),L.buffer}static _serializeReplyOKJSONWithBuffers(b,A,O){const N=t.VSBuffer.fromString(A);let L=0;L+=n.sizeUInt32,L+=n.sizeLongString(N);for(const V of O)L+=n.sizeVSBuffer(V);let M=n.alloc(10,b,L);M.writeUInt32(O.length),M.writeLongString(N);for(const V of O)M.writeBuffer(V);return M.buffer}static deserializeReplyOKJSON(b){const A=b.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(b,A){const O=b.readUInt32(),N=b.readLongString(),L=[];for(let M=0;M<O;++M)L.push(b.readVSBuffer());return new R.SerializableObjectWithBuffers(F(N,L,A))}static serializeReplyErr(b,A){return A?this._serializeReplyErrEror(b,A):this._serializeReplyErrEmpty(b)}static _serializeReplyErrEror(b,A){const O=t.VSBuffer.fromString(l(D.transformErrorForSerialization(A),null));let N=0;N+=n.sizeLongString(O);let L=n.alloc(11,b,N);return L.writeLongString(O),L.buffer}static deserializeReplyErrError(b){const A=b.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(b){return n.alloc(12,b,0).buffer}}var h;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var d;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(d||(d={}))}),define(pe[264],ve([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,29,10,9,12,23,2,4,63,43,221,264]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let w=class qi{constructor(g,E,F,y){this.localUserHome=g,this.remoteAgentService=E,this.environmentService=F,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const u=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=u?.userHome||g})()}hasValidBasename(g,E,F){return typeof E=="string"||typeof E=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(g,y,E)):this.doHasValidBasename(g,E,F)}doHasValidBasename(g,E,F){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,m.isValidBasename)(F??(0,T.basename)(g),E===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,E){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,P.getVirtualWorkspaceScheme)(E.getWorkspace());if(F)return F;const y=E.getWorkspace().folders[0];if(y)return y.uri.scheme;const u=E.getWorkspace().configuration;return u?u.scheme:t.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?I.win32:I.posix)}async fileURI(g){let E="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const y=g.indexOf("/",2);y===-1?(E=g.substring(2),g="/"):(E=g.substring(2,y),g=g.substring(y)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:E,path:g,query:"",fragment:""})}};w=je([ze(1,l.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,R.IWorkspaceContextService)],w),e.AbstractPathService=w}),define(pe[70],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(T,k){this.line=T,this.character=k}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,k){return new m(0,0)}with(T){return new m(0,0)}}e.Position=m;class t{constructor(T,k,_,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(T,k),this.end=new m(_,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new t(0,0,0,0)}with(T){return new t(0,0,0,0)}}e.Range=t;var I;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,17,32,25,29,8,4,9,16,70,13]),function(Z,e,m,t,I,D,T,k,_,P,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",p=(l.length+w.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var g;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function F(B){return!!B.preview}e.resultIsMatch=F;function y(B){return!!B.resource}e.isFileMatch=y;function u(B){return!!B.message}e.isProgressMessage=u;var r;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor($){this.resource=$,this.results=[]}}e.FileMatch=f;class o{constructor($,z,W){this.ranges=z;const J=Array.isArray(z)?z:[z];if(W&&W.matchLines===1&&S(J)){$=(0,T.getNLines)($,W.matchLines);let ne="",se=0,K=0;const Q=Math.floor(W.charsPerLine/5),ae=[];for(const fe of J){const be=Math.max(fe.startColumn-Q,0),Me=fe.startColumn+W.charsPerLine;if(be>K+Q+p){const xe=l+(be-K)+w;ne+=xe+$.slice(be,Me),se+=be-(K+xe.length)}else ne+=$.slice(K,Me);ae.push(new i(0,fe.startColumn-se,fe.endColumn-se)),K=Me}this.preview={text:ne,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const ne=Array.isArray(z)?z[0].startLineNumber:z.startLineNumber;this.preview={text:$,matches:(0,m.mapArrayOrNot)(z,se=>new s(se.startLineNumber-ne,se.startColumn,se.endLineNumber-ne,se.endColumn))}}}}e.TextSearchMatch=o;function S(B){const $=B[0].startLineNumber;for(const z of B)if(z.startLineNumber!==$||z.endLineNumber!==$)return!1;return!0}class s{constructor($,z,W,J){this.startLineNumber=$,this.startColumn=z,this.endLineNumber=W,this.endColumn=J}}e.SearchRange=s;class i extends s{constructor($,z,W){super($,z,$,W)}}e.OneLineRange=i;var n;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function c(B,$=!0){const z=B&&B.files&&B.files.exclude,W=$&&B&&B.search&&B.search.exclude;if(!z&&!W)return;if(!z||!W)return z||W;let J=Object.create(null);return J=I.mixin(J,I.deepClone(z)),J=I.mixin(J,I.deepClone(W),!0),J}e.getExcludes=c;function a(B,$){return B.excludePattern&&t.match(B.excludePattern,$)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,$)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(z=>{const W=z.folder.fsPath;if(D.isEqualOrParent($,W)){const J=_.relative(W,$);return!z.includePattern||!!t.match(z.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var h;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor($,z){super($);this.code=z}}e.SearchError=d;function v(B){const $=B.message;if((0,P.isCancellationError)(B))return new d($,h.canceled);try{const z=JSON.parse($);return new d(z.message,z.code)}catch{return new d($,h.other)}}e.deserializeSearchError=v;function b(B){const $={message:B.message,code:B.code};return new Error(JSON.stringify($))}e.serializeSearchError=b;function A(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=A;function O(B){return B.type==="success"}e.isSerializedSearchSuccess=O;function N(B){return!!B.path}e.isSerializedFileMatch=N;function L(B,$){const z=B.searchPath?B.searchPath:B.relativePath;return(0,T.fuzzyContains)(z,$)}e.isFilePatternMatch=L;class M{constructor($){this.path=$,this.results=[]}addMatch($){this.results.push($)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function V(B,$){const z={...B||{},...$||{}};return Object.keys(z).filter(W=>{const J=z[W];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=V;class H{constructor($,z){this._parsedIncludeExpression=null,this._excludeExpression={...$.excludePattern||{},...z.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let W=$.includePattern;z.includePattern&&(W?W={...W,...z.includePattern}:W=z.includePattern),W&&(this._parsedIncludeExpression=t.parse(W))}matchesExcludesSync($,z,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression($,z,W))}includedInQuerySync($,z,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression($,z,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression($,z,W))}includedInQuery($,z,W){const J=this._parsedExcludeExpression($,z,W),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression($,z,W):!0;return(0,C.isThenable)(J)?J.then(se=>se?!1:ne()):ne()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=H;function U(B){for(const $ in B)if(typeof B[$]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,17,13,21,3,24,10,94,23,8,18,2,169,4,11,189,43,44,26,14,15,7,31,5]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r,f,o,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,O,N){return new P.ExtUri(L=>h(L,N)).isEqual(A,O)}function n(A,O,N){return i(A.uri,O.uri,N)?0:(0,R.compare)(A.uri.toString(),O.uri.toString())}function c(A,O,N){return A.index!==O.index?A.index<O.index?-1:1:i(A.uri,O.uri,N)?(0,R.compare)(A.name,O.name):(0,R.compare)(A.uri.toString(),O.uri.toString())}function a(A,O,N,L){const M=A.slice(0).sort((H,U)=>N(H,U,L)),V=O.slice(0).sort((H,U)=>N(H,U,L));return(0,m.delta)(M,V,(H,U)=>N(H,U,L))}function h(A,O){const N=O.getCapabilities(A.scheme);return!(N&&N&1024)}class d extends F.Workspace{constructor(O,N,L,M,V,H,U){super(O,L.map(B=>new F.WorkspaceFolder(B)),M,V,U);this._name=N,this._isUntitled=H,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(U),L.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(O,N,L,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:H,folders:U,configuration:B,transient:$,isUntitled:z}=O,W=[],J=N;N?U.forEach((Q,ae)=>{const fe=l.URI.revive(Q.uri),be=d._findFolder(L||N,fe,M);be?(be.name=Q.name,be.index=Q.index,W.push(be)):W.push({uri:fe,name:Q.name,index:ae})}):W.push(...U.map(({uri:Q,name:ae,index:fe})=>({uri:l.URI.revive(Q),name:ae,index:fe}))),W.sort((Q,ae)=>Q.index<ae.index?-1:1);const ne=new d(V,H,W,!!$,B?l.URI.revive(B):null,!!z,Q=>h(Q,M)),{added:se,removed:K}=a(J?J.workspaceFolders:[],ne.workspaceFolders,n,M);return{workspace:ne,added:se,removed:K}}static _findFolder(O,N,L){for(let M=0;M<O.folders.length;M++){const V=O.workspaceFolders[M];if(i(V.uri,N,L))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,N){return N&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let v=class{constructor(O,N,L,M){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=L,this._requestIdProvider=new _.Counter,this._barrier=new t.Barrier,this._proxy=O.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(s.MainContext.MainThreadMessageService);const V=N.workspace;this._confirmedWorkspace=V?new d(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,H=>h(H,L)):void 0}$initializeWorkspace(O,N){this._trusted=N,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,N,L,...M){const V=[];if(Array.isArray(M)&&M.forEach(z=>{l.URI.isUri(z.uri)&&!V.some(W=>i(W.uri,z.uri,this._extHostFileSystemInfo))&&V.push({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[N,L].some(z=>typeof z!="number"||z<0)||L===0&&V.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+L>H.length)return!1;const U=H.slice(0);U.splice(N,L,...V.map(z=>({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<U.length;z++){const W=U[z];if(U.some((J,ne)=>ne!==z&&i(W.uri,J.uri,this._extHostFileSystemInfo)))return!1}U.forEach((z,W)=>z.index=W);const{added:B,removed:$}=a(H,U,c,this._extHostFileSystemInfo);if(B.length===0&&$.length===0)return!1;if(this._proxy){const z=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(z,N,L,V).then(void 0,W=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(E.Severity.Error,(0,w.localize)(0,null,z,W.toString()),J,[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(O,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,N)}async getWorkspaceFolder2(O,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,N)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,N){let L,M="";if(typeof O=="string"?(L=l.URI.file(O),M=O):typeof O!="undefined"&&(L=O,M=O.fsPath),!L)return M;const V=this.getWorkspaceFolder(L,!0);if(!V)return M;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let H=(0,P.relativePath)(V.uri,L);return N&&V.name&&(H=`${V.name}/${H}`),H}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:N,added:L,removed:M}=d.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:M}))}findFiles(O,N,L,M,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let H;if(N===null?H=!1:N&&(typeof N=="string"?H=N:H=N.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:B}=b(f.GlobPattern.from(O));return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(B),(0,C.withUndefinedAsNull)(H),(0,C.withUndefinedAsNull)(L),V).then($=>Array.isArray($)?$.map(z=>l.URI.revive(z)):[])}async findTextInFiles(O,N,L,M,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),U=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:B,folder:$}=b(f.GlobPattern.from(N.include)),z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,W={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:U,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:B,excludePattern:z},J=!1;if(this._activeSearchCallbacks[H]=ne=>{if(J)return;const se=l.URI.revive(ne.resource);ne.results.forEach(K=>{(0,S.resultIsMatch)(K)?L({uri:se,preview:{text:K.preview.text,matches:(0,m.mapArrayOrNot)(K.preview.matches,Q=>new o.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,m.mapArrayOrNot)(K.ranges,Q=>new o.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):L({uri:se,text:K.text,lineNumber:K.lineNumber})})},V.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(O,(0,C.withUndefinedAsNull)($),W,H,V);return delete this._activeSearchCallbacks[H],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[H],ne}}$handleTextSearchResult(O,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=je([ze(0,r.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,y.IExtHostFileSystemInfo),ze(3,g.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function b(A){let O,N;return A&&(typeof A=="string"?O=A:(O=A.pattern,N=l.URI.revive(A.baseUri))),{includePattern:O,folder:N}}}),define(pe[36],ve([0,1,25,3,35,5,7,193,119,18,13,4,14,11,2]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(S,s){if(s){const i=s.split(".");let n=S;for(let c=0;n&&c<i.length;c++)n=n[i[c]];return n}}function E(S){return S instanceof p.URI}function F(S){return S&&S.uri instanceof p.URI&&S.languageId&&typeof S.languageId=="string"}function y(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function u(S){return S&&S.uri instanceof p.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function r(S){if(E(S))return{resource:S};if(F(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(y(S))return{overrideIdentifier:S.languageId};if(u(S))return{resource:S.uri};if(S===null)return{resource:null}}let f=class{constructor(s,i,n){this._proxy=s.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=n,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new o(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(s,i))}};f=je([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,w.ILogService)],f),e.ExtHostConfiguration=f;class o{constructor(s,i,n,c){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=c,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,n))}getConfiguration(s,i,n){const c=r(i)||{},a=this._toReadonlyValue(s?g(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,c,n?.identifier);function h(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(v){return typeof g(a,v)!="undefined"},get:(v,b)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,c,n?.identifier);let A=g(a,v);if(typeof A=="undefined")A=b;else{let O;const N=(L,M)=>{let V;const H=()=>{O=O||(0,m.deepClone)(a),V=V||g(O,M)};return(0,P.isObject)(L)?new Proxy(L,{get:(U,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return H(),()=>V;if(O)return V=V||g(O,M),V[B];const $=U[B];return typeof B=="string"?N($,`${M}.${B}`):$},set:(U,B,$)=>(H(),V&&(V[B]=$),!0),deleteProperty:(U,B)=>(H(),V&&delete V[B],!0),defineProperty:(U,B,$)=>(H(),V&&Object.defineProperty(V,B,$),!0)}):L};A=N(A,v)}return A},update:(v,b,A,O)=>{v=s?`${s}.${v}`:v;const N=h(A);return b!==void 0?this._proxy.$updateConfigurationOption(N,v,b,c,O):this._proxy.$removeConfigurationOption(N,v,c,O)},inspect:v=>{v=s?`${s}.${v}`:v;const b=(0,m.deepClone)(this._configuration.inspect(v,c,this._extHostWorkspace.workspace));if(b)return{key:v,defaultValue:b.default?.value,globalValue:b.user?.value,workspaceValue:b.workspace?.value,workspaceFolderValue:b.workspaceFolder?.value,defaultLanguageValue:b.default?.override,globalLanguageValue:b.user?.override,workspaceLanguageValue:b.workspace?.override,workspaceFolderLanguageValue:b.workspaceFolder?.override,languageIds:b.overrideIdentifiers}}};return typeof a=="object"&&(0,m.mixin)(d,a,!1),Object.freeze(d)}_toReadonlyValue(s){const i=n=>(0,P.isObject)(n)?new Proxy(n,{get:(c,a)=>i(c[a]),set:(c,a,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(c,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(c,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return i(s)}_validateConfigurationAccess(s,i,n){const c=_.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),a=n?`[${n.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const n=new k.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,a)=>n.affectsConfiguration(c,r(a))})}_toMap(s){return s.reduce((i,n)=>(i.set(n[0],n[1]),i),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[71],ve([0,1,2,13,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,16]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(M){function V(U){if(U!=null)return U}M.from=V;function H(U){if(U!=null)return U}M.to=H})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(M){function V(U){if(U!=null)return U}M.from=V;function H(U){if(U!=null)return U}M.to=H})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(M){function V(U){if(U!=null)return U}M.from=V;function H(U){if(U!=null)return U}M.to=H})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function V(B){if(B){const $=B;return $&&!!$.process}else return!1}M.is=V;function H(B){if(B==null)return;const $={process:B.process,args:B.args};return B.options&&($.options=s.from(B.options)),$}M.from=H;function U(B){if(B!=null)return new T.ProcessExecution(B.process,B.args,B.options)}M.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(M){function V(U){if(U!=null)return U}M.from=V;function H(U){if(U!=null)return U}M.to=H})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(M){function V(B){if(B){const $=B;return $&&(!!$.commandLine||!!$.command)}else return!1}M.is=V;function H(B){if(B==null)return;const $={};return B.commandLine!==void 0?$.commandLine=B.commandLine:($.command=B.command,$.args=B.args),B.options&&($.options=n.from(B.options)),$}M.from=H;function U(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new T.ShellExecution(B.commandLine,B.options):new T.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(M){function V(B){if(B){let $=B;return $&&$.customExecution==="customExecution"}else return!1}M.is=V;function H(B){return{customExecution:"customExecution"}}M.from=H;function U(B,$){return $.get(B)}M.to=U})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(M){function V(H,U){let B;return H.scope!==void 0&&typeof H.scope!="number"?B=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===T.TaskScope.Workspace&&U&&U.workspaceFile?B=U.workspaceFile:B=u.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:B}}M.from=V})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(M){function V(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}M.from=V})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(M){function V(B,$){if(B==null)return[];const z=[];for(let W of B){const J=H(W,$);J&&z.push(J)}return z}M.fromMany=V;function H(B,$){if(B==null)return;let z;B.execution instanceof T.ProcessExecution?z=i.from(B.execution):B.execution instanceof T.ShellExecution?z=c.from(B.execution):B.execution&&B.execution instanceof T.CustomExecution&&(z=a.from(B.execution));const W=o.from(B.definition);let J;return B.scope?typeof B.scope=="number"?J=B.scope:J=B.scope.uri:J=T.TaskScope.Workspace,!W||!J?void 0:{_id:B._id,definition:W,name:B.name,source:{extensionId:$.identifier.value,label:B.source,scope:J},execution:z,isBackground:B.isBackground,group:d.from(B.group),presentationOptions:S.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=H;async function U(B,$,z){if(B==null)return;let W;i.is(B.execution)?W=i.to(B.execution):c.is(B.execution)?W=c.to(B.execution):a.is(B.execution)&&(W=a.to(B._id,z));const J=o.to(B.definition);let ne;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ne=B.source.scope:ne=await $.resolveWorkspaceFolder(m.URI.revive(B.source.scope)):ne=T.TaskScope.Workspace),!J||!ne)return;const se=new T.Task(J,ne,B.name,B.source.label,W,B.problemMatchers);return B.isBackground!==void 0&&(se.isBackground=B.isBackground),B.group!==void 0&&(se.group=T.TaskGroup.from(B.group._id),se.group&&B.group.isDefault&&(se.group=new T.TaskGroup(se.group.id,se.group.label),B.group.isDefault&&(se.group.isDefault=B.group.isDefault))),B.presentationOptions&&(se.presentationOptions=S.to(B.presentationOptions)),B._id&&(se._id=B._id),B.detail&&(se.detail=B.detail),se}M.to=U})(v=e.TaskDTO||(e.TaskDTO={}));var b;(function(M){function V(U){return U}M.from=V;function H(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=H})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(V,H,U){this._id=H,this._task=U,f.set(this,void 0),nt(this,f,V,"f")}get task(){return this._task}terminate(){Le(this,f,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}f=new WeakMap;var O;(function(M){function V(H){return{id:H._id,task:void 0}}M.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(V,H,U,B,$,z,W,J){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=V.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=B,this._configurationService=$,this._terminalService=z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,H,U){if(!U)return new T.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:H,provider:U,extension:V}),this._proxy.$registerTaskProvider(B,H),new T.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(V,H){this._proxy.$registerTaskSystem(V,H)}fetchTasks(V){return this._proxy.$fetchTasks(b.from(V)).then(async H=>{const U=[];for(let B of H){const $=await v.to(B,this._workspaceProvider,this._providedCustomExecutions2);$&&U.push($)}return U})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(H=>V.push(H)),V}terminateTask(V){if(!(V instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,H,U){const B=this._providedCustomExecutions2.get(V.id);B&&(this._activeCustomExecutions2.set(V.id,B),this._terminalService.attachPtyToTerminal(H,await B.callback(U))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const H=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const H=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:H,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const H=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:V.exitCode})}$provideTasks(V,H){const U=this._handlers.get(V);if(!U)return Promise.reject(new Error("no handler found"));const B=[],$=(0,t.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(z=>this.provideTasksInternal(H,B,U,z));return new Promise(z=>{$.then(W=>{Promise.all(B).then(()=>{z(W)})})})}async $resolveTask(V,H){const U=this._handlers.get(V);if(!U)return Promise.reject(new Error("no handler found"));if(H.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${U.type}].`);const B=await v.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const $=await U.provider.resolveTask(B,R.CancellationToken.None);if(!$)return;this.checkDeprecation($,U);const z=v.from($,U.extension);if(!z)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(z.execution)&&await this.addCustomExecution(z,$,!0),await this.resolveTaskInternal(z)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,H,U){const B=await this._proxy.$createTaskId(V);!U&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,H.execution)),this._providedCustomExecutions2.set(B,H.execution)}async getTaskExecution(V,H){if(typeof V=="string"){const $=this._taskExecutionPromises.get(V);if(!$)throw new Error("Unexpected: The specified task is missing an execution");return $}let U=this._taskExecutionPromises.get(V.id);if(U)return U;const B=new Promise(($,z)=>{function W(J,ne,se){se?$(new A(J,ne.id,se)):z("Unexpected: Task does not exist.")}H?W(this,V,H):v.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>W(this,V,J))});return this._taskExecutionPromises.set(V.id,B),B.then($=>(this._taskExecutions.set(V.id,$),$),$=>Promise.reject($))}checkDeprecation(V,H){V._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let U=this._notProvidedCustomExecutions.values(),B=U.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=U.next()}};N=je([ze(0,l.IExtHostRpcService),ze(1,w.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,y.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let L=class extends N{constructor(V,H,U,B,$,z,W,J){super(V,H,U,B,$,z,W,J);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(V,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const U=v.from(H,V);if(U===void 0)throw new Error("Task is not valid");if(a.is(U.execution))await this.addCustomExecution(U,H,!1);else throw new r.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),H);return this._proxy.$executeTask(U).catch($=>{throw new Error($)}),B}provideTasksInternal(V,H,U,B){const $=[];if(B)for(let z of B){this.checkDeprecation(z,U),(!z.definition||!V[z.definition.type])&&this._logService.warn(`The task [${z.source}, ${z.name}] uses an undefined task type. The task will be ignored in the future.`);const W=v.from(z,U.extension);W&&a.is(W.execution)?($.push(W),H.push(this.addCustomExecution(W,z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:$,extension:U.extension}}async resolveTaskInternal(V){if(a.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,H,U){}};L=je([ze(0,l.IExtHostRpcService),ze(1,w.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,y.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,17,75,32,80,24,10,9,23,8,18,2,149,175,116,43,128,265,31]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,d,v,b){this.configurationService=h,this.workspaceContextService=d,this.editorGroupsService=v,this.pathService=b}text(h,d,v={}){h=this.getContentPattern(h,v);const b=this.configurationService.getValue(),A=d&&d.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(d?.map(E.toWorkspaceFolder),v),type:2,contentPattern:h,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:b.search.usePCRE2||A||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(h,d){const v=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const b={...h,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(h,d)&&(b.isCaseSensitive=!0),this.isMultiline(h)&&(b.isMultiline=!0),b}file(h,d={}){return{...this.commonQuery(h,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}handleIncludeExclude(h,d){return h?(h=Array.isArray(h)?h.map(i):i(h),d?this.parseSearchPaths(h):{pattern:o(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],d={}){const v=this.handleIncludeExclude(d.includePattern,d.expandPatterns),b=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),A=h.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,d,b)):h.map(M=>this.getFolderQueryForRoot(M,d,b,A))).filter(M=>!!M),N={_reason:d._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:b.pattern,includePattern:v.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const V=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(B=>B.resource)))).filter(U=>(0,u.pathIncludedInQuery)(N,U.fsPath)),H=this.commonQueryFromFileList(V);return{...N,...H}}const L=d.extraFileResources&&d.extraFileResources.filter(M=>(0,u.pathIncludedInQuery)(N,M.fsPath));return N.extraFileResources=L&&L.length?L:void 0,N}commonQueryFromFileList(h){const d=[],v=new T.ResourceMap,b={};let A=!1;return h.forEach(O=>{if(O.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(O)){const L=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:_.dirname(O.fsPath)});let M=v.get(L);M||(A=!0,M={folder:L,includePattern:{}},d.push(M),v.set(L,M));const V=_.relative(L.fsPath,O.fsPath);(0,C.assertIsDefined)(M.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(A=!0,b[O.fsPath]=!0)}),{folderQueries:d,includePattern:b,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(h,d){if(d.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,w.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const d=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),b=(Array.isArray(h)?h:S(h)).map(H=>{const U=this.pathService.resolvedUserHome;return U?(0,D.untildify)(H,U.scheme===k.Schemas.file?U.fsPath:U.path):H}),A=t.groupBy(b,H=>d(H)?"searchPaths":"exprSegments"),O=(A.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),N={},L=this.expandSearchPathPatterns(A.searchPaths||[]);L&&L.length&&(N.searchPaths=L);const M=m.flatten(O),V=o(...M);return V&&(N.pattern=V),N}getExcludesForFolder(h,d){return d.disregardExcludeSettings?void 0:(0,u.getExcludes)(h,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const d=m.flatten(h.map(b=>{let{pathPortion:A,globPortion:O}=f(b);O&&(O=n(O));const N=this.expandOneSearchPath(A);return m.flatten(N.map(L=>this.resolveOneSearchPathPattern(L,O)))})),v=new Map;return d.forEach(b=>{const A=b.searchPath.toString(),O=v.get(A);O?b.pattern&&(O.pattern=O.pattern||{},O.pattern[b.pattern]=!0):v.set(A,{searchPath:b.searchPath,pattern:b.pattern?o(b.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(h){if(_.isAbsolute(h)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==k.Schemas.file?[{searchPath:d[0].uri.with({path:h})}]:[{searchPath:l.URI.file(_.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=i(h),h.startsWith("../")||h===".."){const b=_.posix.resolve(d.path,h);return[{searchPath:d.with({path:b})}]}const v=n(h);return[{searchPath:d,pattern:v}]}else{if(h==="./"||h===".\\")return[];{const d=h.replace(/^\.[\/\\]/,""),b=this.workspaceContextService.getWorkspace().folders.map(A=>{const O=d.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return O?{match:O,folder:A}:null}).filter(C.isDefined);if(b.length)return b.map(A=>{const O=A.match[1];return{searchPath:A.folder.uri,pattern:O&&n(O)}});{const A=h.match(/\.[\/\\](.+)[\/\\]?/),O=A?A[1]:h,N=p.localize(0,null,O);throw new Error(N)}}}}resolveOneSearchPathPattern(h,d){const v=h.pattern&&d?`${h.pattern}/${d}`:h.pattern||d,b=[{searchPath:h.searchPath,pattern:v}];return v&&!v.endsWith("**")&&b.push({searchPath:h.searchPath,pattern:v+"/**"}),b}getFolderQueryForSearchPath(h,d,v){const b=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(h.searchPath),d,v,!1);return b?{...b,includePattern:h.pattern}:null}getFolderQueryForRoot(h,d,v,b){let A;const O=l.URI.isUri(h)?h:h.uri;if(v.searchPaths){const H=v.searchPaths.filter(U=>(0,P.isEqual)(U.searchPath,O))[0];if(H&&!H.pattern)return null;H&&(A=H.pattern)}const N=this.configurationService.getValue({resource:O}),M={...this.getExcludesForFolder(N,d)||{},...A||{}},V=l.URI.isUri(h)?(0,P.basename)(h):h.name;return{folder:O,folderName:b?V:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!N.search.followSymlinks}}};r=je([ze(0,g.IConfigurationService),ze(1,E.IWorkspaceContextService),ze(2,F.IEditorGroupsService),ze(3,y.IPathService)],r),e.QueryBuilder=r;function f(a){const h=a.match(/[\*\{\}\(\)\[\]\?]/);if(h){const d=h.index,v=a.substr(0,d).match(/[/|\\][^/\\]*$/);if(v){let b=a.substr(0,v.index);return b.match(/[/\\]/)||(b+="/"),{pathPortion:b,globPortion:a.substr((v.index||0)+1)}}}return{pathPortion:a}}function o(...a){return a.length?a.reduce((h,d)=>(h[d]=!0,h),Object.create(null)):void 0}function S(a){return I.splitGlobAware(a,",").map(h=>h.trim()).filter(h=>!!h.length)}function s(a){return[`**/${a}/**`,`**/${a}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function i(a){return a.replace(/\\/g,"/")}function n(a){return i(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(a,h){a=m.distinct(a,b=>b.toString());const d=[],v=h.getWorkspace();return a&&a.forEach(b=>{let A;if(h.getWorkbenchState()===2)A=(0,P.relativePath)(v.folders[0].uri,b),A&&A!=="."&&(A="./"+A);else{const O=h.getWorkspaceFolder(b);if(O){const N=O.name;if(v.folders.filter(M=>M.name===N).length===1){const M=(0,P.relativePath)(O.uri,b);M===""?A=`./${O.name}`:A=`./${O.name}/${M}`}else A=b.fsPath}}A&&d.push(A)}),d}e.resolveResourcesForSearchIncludes=c}),define(pe[267],ve([0,1,23,2,21,16,4,266,31,43]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(g,E){const F=E.activationEvents;if(!F)return Promise.resolve(void 0);const y=[],u=[];for(const i of F)if(/^workspaceContains:/.test(i)){const n=i.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||g.forceUsingSearch?u.push(n):y.push(n)}if(y.length===0&&u.length===0)return Promise.resolve(void 0);let r;const f=new Promise((i,n)=>{r=i}),o=i=>r({activationEvent:i}),S=Promise.all(y.map(i=>l(g,i,o))).then(()=>{}),s=w(g,E.identifier,u,o);return Promise.all([S,s]).then(()=>{r(void 0)}),f}e.checkActivateWorkspaceContainsExtension=C;async function l(g,E,F){for(const y of g.folders)if(await g.exists(m.joinPath(t.URI.revive(y),E))){F(`workspaceContains:${E}`);return}}async function w(g,E,F,y){if(F.length===0)return Promise.resolve(void 0);const u=new I.CancellationTokenSource,r=g.checkExists(g.folders,F,u.token),f=setTimeout(async()=>{u.cancel(),g.logService.info(`Not activating extension '${E.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},R);let o=!1;try{o=await r}catch(S){D.isCancellationError(S)||D.onUnexpectedError(S)}u.dispose(),clearTimeout(f),o&&y(`workspaceContains:${F.join(",")}`)}function p(g,E,F,y){const u=g.get(T.IInstantiationService),r=g.get(_.ISearchService),o=u.createInstance(k.QueryBuilder).file(E.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:F,exists:!0});return r.fileSearch(o,y).then(S=>!!S.limitHit,S=>D.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,m,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Le=this&&this.__classPrivateFieldGet||function(Z,e,m,t){if(m==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?t:m==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[39],ve([0,1,164,9,72,23,13,6,24,2,11,5,36,224,90,35,28,222,16,27,22,199,7,120,4,26,68,14,84,51,34,3,267,89,201,10]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r,f,o,S,s,i,n,c,a,h,d,v,b,A,O,N){"use strict";var L,M,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let H=class Gi extends k.Disposable{constructor(W,J,ne,se,K,Q,ae,fe,be,Me){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=ne,this._initData=ae,this._extHostWorkspace=se,this._extHostConfiguration=K,this._logService=Q,this._extHostTunnelService=be,this._extHostTerminalService=Me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=W.createChild(new a.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(Ge=>xe.add(u.ExtensionIdentifier.toKey(Ge))),this._activator=this._register(new w.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Je,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,y.transformErrorForSerialization(Je),q)},actualActivateExtension:async(Ge,Je)=>{if(xe.has(u.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Je),new w.HostExtension;const q=this._registry.getExtensionDescription(Ge);return this._activateExtension(q,Je)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(W){y.onUnexpectedError(W)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let W=[];try{W=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(W)}isActivated(W){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(W):!1}_activateByEvent(W,J){return this._activator.activateByEvent(W,J)}_activateById(W,J){return this._activator.activateById(W,J)}activateByIdWithErrors(W,J){return this._activateById(W,J).then(()=>{const ne=this._activator.getActivatedExtension(W);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(W=>this._registry)}getExtensionExports(W){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(W).exports:null}async _realPathExtensionUri(W){if(W.scheme!==N.Schemas.file)return W;const J=await this._hostUtils.realpath(W.fsPath);return P.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const W=_.TernarySearchTree.forUris(J=>D.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const ne=await this._realPathExtensionUri(J.extensionLocation);W.set(ne,J)}return W})()),this._extensionPathIndex}_deactivate(W){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(W))return J;const ne=this._activator.getActivatedExtension(W);if(!ne)return J;try{typeof ne.module.deactivate=="function"&&(J=Promise.resolve(ne.module.deactivate()).then(void 0,se=>(this._logService.error(se),Promise.resolve(void 0))))}catch(se){this._logService.error(`An error occurred when deactivating the extension '${W.value}':`),this._logService.error(se)}try{(0,k.dispose)(ne.subscriptions)}catch(se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this._logService.error(se)}return J}async _activateExtension(W,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier),this._doActivateExtension(W,J).then(ne=>{const se=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(W.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,J),this._logExtensionActivationTimes(W,J,"success",se),ne},ne=>{throw this._logExtensionActivationTimes(W,J,"failure"),ne})}_logExtensionActivationTimes(W,J,ne,se){const K=U(W,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...se||{},outcome:ne})}_doActivateExtension(W,J){const ne=U(W,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const se=this._getEntryPoint(W);if(!se)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${W.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const K=new w.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(W.identifier,(0,D.joinPath)(W.extensionLocation,se),K),this._loadExtensionContext(W)]).then(Q=>(I.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),Gi._callActivate(this._logService,W.identifier,Q[0],Q[1],K))).then(Q=>(I.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),Q))}_loadExtensionContext(W){const J=new f.ExtensionGlobalMemento(W,this._storage),ne=new f.ExtensionMemento(W.identifier.value,!1,this._storage),se=new O.ExtensionSecrets(W,this._secretState),K=W.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Q=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([J.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;let fe,be;const Me=(0,E.isProposedApiEnabled)(W,"ipc")?this._initData.messagePorts?.get(u.ExtensionIdentifier.toKey(W.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ne,secrets:se,subscriptions:[],get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(xe){return t.join(W.extensionLocation.fsPath,xe)},get storagePath(){return ae._storagePath.workspaceValue(W)?.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(W).fsPath},get logPath(){return t.join(ae._initData.logsLocation.fsPath,W.identifier.value)},get logUri(){return P.URI.joinPath(ae._initData.logsLocation,W.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(W)},get globalStorageUri(){return ae._storagePath.globalValue(W)},get extensionMode(){return K},get extension(){return fe===void 0&&(fe=new B(ae,W.identifier,W,Q)),fe},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(W,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!be){if(!Me)return;const xe=v.Event.buffer(v.Event.fromDOMEventEmitter(Me,"message",Ge=>Ge.data));Me.start(),be={onDidReceiveMessage:xe,postMessage:Me.postMessage.bind(Me)}}return be}})})}static _callActivate(W,J,ne,se,K){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(W,J,ne,se,K).then(Q=>new w.ActivatedExtension(!1,null,K.build(),ne,Q,se.subscriptions))}static _callActivateOptional(W,J,ne,se,K){if(typeof ne.activate=="function")try{K.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Q=typeof global=="object"?global:self,ae=ne.activate.apply(Q,[se]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ae).then(fe=>(K.activateResolveStop(),fe))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(ne)}_activateOneStartupFinished(W,J){this._activateById(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:J}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const W of this._registry.getAllExtensionDescriptions())if(W.activationEvents)for(const J of W.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(W,J)}_handleEagerExtensions(){const W=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(J),se=Promise.all([W,ne]).then(()=>{});return Promise.race([se,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(W){return W.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(W,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(W,J){if(this.isActivated(J.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={logService:this._logService,folders:W.map(Q=>Q.uri),forceUsingSearch:ne,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,ae,fe)=>this._mainThreadWorkspaceProxy.$checkExists(Q,ae,fe)},K=await(0,b.checkActivateWorkspaceContainsExtension)(se,J);if(!!K)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:K.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(W){throw console.error(W),W}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:J}=this._initData.environment;if(!W||!J)throw new Error(m.localize(0,null));const ne=await this._loadCommonJSModule(null,J,new w.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(m.localize(1,null,J.toString()));return new Promise((se,K)=>{const Q=(be,Me)=>{be?K(be):se(typeof Me=="number"&&Me>0?1:0)},ae=(0,D.originalFSPath)(J),fe=ne.run(ae,Q);fe&&fe.then&&fe.then(()=>{se(0)}).catch(be=>{K(be instanceof Error&&be.stack?be.stack:String(be))})})}async $extensionTestsExit(W){this._logService.info(`Extension host terminating: test runner requested exit with code ${W}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`),this._logService.flush(),this._hostUtils.exit(W)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,J){return this._resolvers[W]=J,(0,k.toDisposable)(()=>{delete this._resolvers[W]})}async _activateAndGetResolver(W){const J=W.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ne=W.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(W,J){this._logService.info(`$resolveAuthority invoked for authority (${$(W)})`);const{authorityPrefix:ne,resolver:se}=await this._activateAndGetResolver(W);if(!se)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(se)),I.mark(`code/extHost/willResolveAuthority/${ne}`);const K=await se.resolve(W,{resolveAttempt:J});I.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const Q={authority:W,host:K.host,port:K.port,connectionToken:K.connectionToken},ae={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Q,options:ae,tunnelInformation:{environmentTunnels:K.environmentTunnels,features:K.tunnelFeatures}}}}catch(K){if(I.mark(`code/extHost/didResolveAuthorityError/${ne}`),K instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(W,J){this._logService.info(`$getCanonicalURI invoked for authority (${$(W)})`);const{authorityPrefix:ne,resolver:se}=await this._activateAndGetResolver(W);if(!se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const K=P.URI.revive(J);if(typeof se.getCanonicalURI=="undefined")return K;const Q=await(0,T.asPromise)(()=>se.getCanonicalURI(K));return Q||K}$startExtensionHost(W){return this._registry.keepOnly(W),this._startExtensionHost()}$activateByEvent(W,J){return J===1?this._activateByEvent(W,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(W,!1))}async $activate(W,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(W)?(await this._activateById(W,J),!0):!1}async $deltaExtensions(W,J){W.forEach(se=>se.extensionLocation=P.URI.revive(se.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(J.map(async se=>{const K=this._registry.getExtensionDescription(se);K&&ne.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(W.map(async se=>{const K=await this._realPathExtensionUri(se.extensionLocation);ne.set(K,se)})),this._registry.deltaExtensions(W,J),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){let J=r.VSBuffer.alloc(W),ne=Math.random()%256;for(let se=0;se<W;se++)J.writeUInt8(ne,se);return J}async $updateRemoteConnectionData(W){this._remoteConnectionData=W,this._onDidChangeRemoteConnectionData.fire()}};H=je([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,c.IExtHostRpcService),ze(3,g.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,R.ILogService),ze(6,i.IExtHostInitDataService),ze(7,n.IExtensionStoragePaths),ze(8,h.IExtHostTunnelService),ze(9,d.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function U(z,W){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class B{constructor(W,J,ne,se){L.set(this,void 0),M.set(this,void 0),V.set(this,void 0),nt(this,L,W,"f"),nt(this,M,J,"f"),nt(this,V,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=t.normalize((0,D.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=se}get isActive(){return Le(this,L,"f").isActivated(Le(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,L,"f").getExtensionExports(Le(this,V,"f"))}activate(){return Le(this,L,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,L=new WeakMap,M=new WeakMap,V=new WeakMap;function $(z){const W=z.indexOf("+");return W===-1?z:z.substring(0,W)}}),define(pe[54],ve([0,1,9,2,3,13,5,7,124,35,39,45,215,36,208,14,4,18,40,53]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let r=class{constructor(a,h,d,v,b,A){this._workspaceService=h,this._extensionService=d,this._editorsService=v,this._configurationService=b,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=a.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(N=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,h){const d=a;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,b="?";return h&&(v+=`${b}session=${encodeURIComponent(h.id)}`,b="&"),v+=`${b}ref=${d.sourceReference}`,t.URI.parse(v)}else{if(d.path)return t.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const h=[];for(const d of a.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const b of v)(0,p.isDebuggerMainContribution)(b)&&h.push(b.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(h=>a.push(h)),a}addBreakpoints(a){this.startBreakpoints();const h=a.filter(b=>{const A=b.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,b),!0)});this.fireBreakpointChanges(h,[],[]);const d=[],v=new Map;for(const b of h)if(b instanceof k.SourceBreakpoint){let A=v.get(b.location.uri.toString());A||(A={type:"sourceMulti",uri:b.location.uri,lines:[]},v.set(b.location.uri.toString(),A),d.push(A)),A.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof k.FunctionBreakpoint&&d.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(a){this.startBreakpoints();const h=a.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],h,[]);const d=h.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),v=h.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),b=h.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(d,v,b)}startDebugging(a,h,d){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,h,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,h,d){if(!h)return new k.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:v,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,d,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,v),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(a,h,d){if(!d)return new k.Disposable(()=>{});if(!this.definesDebugType(a,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:v,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,v),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(a,h){if(!h)return new k.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:d,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==h)})}async $runInTerminal(a,h){return Promise.resolve(void 0)}async $substituteVariables(a,h){if(!this._variableResolver){const[b,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,A)}let d;const v=await this.getFolder(a);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,h)}createDebugAdapter(a,h){if(a.type==="implementation")return new i(a.implementation)}createSignService(){}async $startDASession(a,h){const d=this,v=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const A=this.convertToDto(b),O=this.createDebugAdapter(A,v);if(!O)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const N=O;return this._debugAdapters.set(a,N),this.getDebugAdapterTrackers(v).then(L=>(L&&this._debugAdaptersTrackers.set(a,L),N.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const V=M,H={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(V.arguments.value);H.body={signature:U},N.sendResponse(H)}else throw new Error("no signer")}catch(U){H.success=!1,H.message=U.message,N.sendResponse(H)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,p.convertToVSCPaths)(M,!0),d._debugServiceProxy.$acceptDAMessage(a,M)}),N.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(a,M.name,M.message,M.stack)}),N.onExit(M=>{L&&L.onExit&&L.onExit((0,F.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,F.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),N.startSession()))})}$sendDAMessage(a,h){h=(0,p.convertToDAPaths)(h,!1);const d=this._debugAdaptersTrackers.get(a);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(h);const v=this._debugAdapters.get(a);v&&v.sendMessage(h)}$stopDASession(a){const h=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),h&&h.onWillStopSession&&h.onWillStopSession();const d=this._debugAdapters.get(a);return this._debugAdapters.delete(a),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const h=[],d=[],v=[];if(a.added)for(const b of a.added){const A=b.id;if(A&&!this._breakpoints.has(A)){let O;if(b.type==="function")O=new k.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")O=new k.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const N=t.URI.revive(b.uri);O=new k.SourceBreakpoint(new k.Location(N,new k.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}O._id=A,this._breakpoints.set(A,O),h.push(O)}}if(a.removed)for(const b of a.removed){const A=this._breakpoints.get(b);A&&(this._breakpoints.delete(b),d.push(A))}if(a.changed){for(const b of a.changed)if(b.id){const A=this._breakpoints.get(b.id);if(A){if(A instanceof k.FunctionBreakpoint&&b.type==="function"){const O=A;O.enabled=b.enabled,O.condition=b.condition,O.hitCondition=b.hitCondition,O.logMessage=b.logMessage,O.functionName=b.functionName}else if(A instanceof k.SourceBreakpoint&&b.type==="source"){const O=A;O.enabled=b.enabled,O.condition=b.condition,O.hitCondition=b.hitCondition,O.logMessage=b.logMessage,O.location=new k.Location(t.URI.revive(b.uri),new k.Position(b.line,b.character))}v.push(A)}}}this.fireBreakpointChanges(h,d,v)}$provideDebugConfigurations(a,h,d){return(0,D.asPromise)(async()=>{const v=this.getConfigProviderByHandle(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(h);return v.provideDebugConfigurations(b,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(a,h,d,v){return(0,D.asPromise)(async()=>{const b=this.getConfigProviderByHandle(a);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(h);return b.resolveDebugConfiguration(A,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(a,h,d,v){return(0,D.asPromise)(async()=>{const b=this.getConfigProviderByHandle(a);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(h);return b.resolveDebugConfigurationWithSubstitutedVariables(A,d,v)})}async $provideDebugAdapter(a,h){const d=this.getAdapterDescriptorFactoryByHandle(a);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(h);return this.getAdapterDescriptor(d,v).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(a){const h=await this.getSession(a);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(a){const h=await this.getSession(a);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,h){const d=await this.getSession(a);d&&d._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(a,h){const v={session:await this.getSession(a),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const h=this._adapterFactories.filter(d=>d.type===a);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(a){const h=this._adapterFactories.filter(d=>d.handle===a);if(h.length>0)return h[0].factory}getConfigProviderByHandle(a){const h=this._configProviders.filter(d=>d.handle===a);if(h.length>0)return h[0].provider}definesDebugType(a,h){if(a.contributes){const d=a.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===h)return!0}}return!1}getDebugAdapterTrackers(a){const d=a.configuration.type,v=this._trackerFactories.filter(b=>b.type===d||b.type==="*").map(b=>(0,D.asPromise)(()=>b.factory.createDebugAdapterTracker(a)).then(A=>A,A=>null));return Promise.race([Promise.all(v).then(b=>{const A=b.filter(O=>!!O);if(A.length>0)return new s(A)}),new Promise((b,A)=>{const O=setTimeout(()=>{clearTimeout(O),A(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(a,h){const d=h.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.DebugAdapterServer(d));if(a){const b=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>a.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,b))).then(A=>{if(A)return A})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,v))}daExecutableFromPackage(a,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,h,d){(a.length>0||h.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:h,changed:d}))}async getSession(a){if(a)if(typeof a=="string"){const h=this._debugSessions.get(a);if(h)return h}else{let h=this._debugSessions.get(a.id);if(!h){const d=await this.getFolder(a.folderUri),v=a.parent?this._debugSessions.get(a.parent):void 0;h=new f(this._debugServiceProxy,a.id,a.type,a.name,d,a.configuration,v),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(a){if(a){const h=t.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=je([ze(0,g.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,R.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,w.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class f{constructor(a,h,d,v,b,A,O){this._debugServiceProxy=a,this._id=h,this._type=d,this._name=v,this._workspaceFolder=b,this._configuration=A,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,h)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=f;class o{constructor(a){this.value=Object.freeze({append(h){a.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=o;class S extends l.AbstractVariableResolverService{constructor(a,h,d,v,b){function A(){if(h){const O=h.activeEditor();if(O)return O.document.uri;const N=v.tabs.filter(L=>L.isActive);if(N.length>0){const L=N[0].resource;return L&&(L.primary||L.secondary)?L.primary??L.secondary:N[0].resource}}}super({getFolderUri:O=>{const N=a.filter(L=>L.name===O);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(O,N)=>d.getConfiguration(void 0,O).get(N),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=A();if(O)return m.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const O=A();if(O){const N=b.getWorkspaceFolder(O);if(N)return m.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(h){const O=h.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(h){const O=h.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=S;class s{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(h=>h.onError?h.onError(a):void 0)}onExit(a,h){this.trackers.forEach(d=>d.onExit?d.onExit(a,h):void 0)}}class i extends _.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends r{constructor(a,h,d,v,b,A){super(a,h,d,v,b,A)}createVariableResolver(a,h,d){return new S(a,h,d,this._editorTabs)}};n=je([ze(0,g.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,R.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,w.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(pe[268],ve([0,1,72,2,5,36,28,27,14,26,4,39,40,11,8]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(f,o,S,s,i,n,c){this._apiFactory=f,this._extensionRegistry=o,this._instaService=S,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=n,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new F(this._apiFactory,o,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(y,o)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,o,this._initData.environment.appUriScheme))}register(f){if("nodeModuleName"in f)if(Array.isArray(f.nodeModuleName))for(let o of f.nodeModuleName)this._factories.set(o,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(o=>f.alternativeModuleName(o))}};g=je([ze(2,R.IInstantiationService),ze(3,D.IExtHostConfiguration),ze(4,C.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,w.ILogService)],g),e.RequireInterceptor=g;let E=class zi{constructor(f){if(f.environment.appRoot&&zi.aliased.size){const o=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(f.environment.appRoot.fsPath)),S="[a-z0-9_.-]",s=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(f){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(f));if(!o)return;const[,S,s,i]=o,n=zi.aliased.get(s);if(n!==void 0)return console.warn(`${s} as been renamed to ${n}, please update your imports`),S+n+i}forceForwardSlashes(f){return f.replace(/\\/g,"/")}};E.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),E=je([ze(0,P.IExtHostInitDataService)],E);class F{constructor(f,o,S,s,i){this._apiFactory=f,this._extensionPaths=o,this._extensionRegistry=S,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,o){const S=this._extensionPaths.findSubstr(o);if(S){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return s||(s=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,n)=>s+=`	${n} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(f,o,S){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=S,i=o.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let n=s.appRoot.fsPath;l.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,c)=>i.$getPassword(n,c),setPassword:(n,c,a)=>i.$setPassword(n,c,a),deletePassword:(n,c)=>i.$deletePassword(n,c),findPassword:n=>i.$findPassword(n),findCredentials(n){return i.$findCredentials(n)}}}load(f,o){const S=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const o=f.length;if(o<=7||!this.alternativeNames)return;const S=o-7;if((f.charAt(S)==="/"||f.charAt(S)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};y=je([ze(1,_.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],y);let u=class{constructor(f,o,S){this._extensionPaths=f,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const s=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,n)=>{const c=t.URI.parse(i);return n?this.callOriginal(i,n):c.scheme==="http"||c.scheme==="https"?s.$openUri(c,i,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?s.$openUri(c,i,{}):this.callOriginal(i,n)}}load(f,o,S){const s=this._extensionPaths.findSubstr(o);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=S(f),this._impl}callOriginal(f,o){return this.sendNoForwardTelemetry(),this._original(f,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=je([ze(2,_.IExtHostRpcService)],u)}),define(pe[269],ve([0,1,170,12,7,209,35,39,45,36,34,14,54,195,13,210,53]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let F=class extends l.ExtHostDebugServiceBase{constructor(r,f,o,S,s,i,n){super(r,f,o,S,s,n);this._terminalService=i,this._integratedTerminalInstances=new y}createDebugAdapter(r,f){switch(r.type){case"server":return new D.SocketDebugAdapter(r);case"pipeServer":return new D.NamedPipeDebugAdapter(r);case"executable":return new D.ExecutableDebugAdapter(r,f.type)}return super.createDebugAdapter(r,f)}daExecutableFromPackage(r,f){const o=D.ExecutableDebugAdapter.platformAdapterExecutable(f.getAllExtensionDescriptions(),r.type);if(o)return new I.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new w.SignService}async $runInTerminal(r,f){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const o=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),i=r.title||m.localize(0,null),n=JSON.stringify({shell:S,shellArgs:s});let c=await this._integratedTerminalInstances.checkout(n,i),a,h=!1;if(c)a=r.cwd;else{const A={shellPath:S,shellArgs:s,cwd:r.cwd,name:i,iconPath:new I.ThemeIcon("debug")};h=!0,c=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,n)}c.show(!0);const d=await c.processId;h?await new Promise(A=>setTimeout(A,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?c.sendText("cls"):S.indexOf("bash")>=0?c.sendText("clear"):t.isWindows?c.sendText("cls"):c.sendText("clear"));const v=(0,g.prepareCommand)(S,r.args,a,r.env);c.sendText(v);const b=this.onDidTerminateDebugSession(A=>{A.id===f&&(this._integratedTerminalInstances.free(c),b.dispose())});return d}else if(r.kind==="external")return(0,g.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,f)}createVariableResolver(r,f,o){return new l.ExtHostVariableResolverService(r,f,o,this._editorTabs,this._workspaceService)}};F=je([ze(0,C.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,R.IExtHostTerminalService),ze(6,E.IExtHostEditorTabs)],F),e.ExtHostDebugService=F;class y{constructor(){this._terminalInstances=new Map}async checkout(r,f){const S=[...this._terminalInstances.entries()].map(([s,i])=>(0,p.createCancelablePromise)(async n=>{if(s.name!==f||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await s.processId))return null;const c=Date.now();return i.lastUsedAt+y.minUseDelay>c||n.isCancellationRequested||i.config!==r?null:(i.lastUsedAt=c,s)}));return await(0,p.firstParallel)(S,s=>!!s)}insert(r,f){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:f})}free(r){const f=this._terminalInstances.get(r);f&&(f.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}y.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,113,35,54,45,36,43,34,14,26,71,10,11,66,53,23,81]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends w.ExtHostTaskBase{constructor(o,S,s,i,n,c,a,h,d){super(o,S,s,i,n,c,a,h);this.workspaceService=s,this.editorTabs=d,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,S){const s=S;if(!S.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const i=w.TaskHandleDTO.from(s,this.workspaceService),n=await this._proxy.$getTaskExecution(i);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(n,S);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=w.TaskDTO.from(S,o);if(i===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),n}}provideTasksInternal(o,S,s,i){const n=[];if(i)for(let c of i){this.checkDeprecation(c,s),(!c.definition||!o[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const a=w.TaskDTO.from(c,s.extension);a&&(n.push(a),w.CustomExecutionDTO.is(a.execution)&&S.push(this.addCustomExecution(a,c,!0)))}return{tasks:n,extension:s.extension}}async resolveTaskInternal(o){return o}async getVariableResolver(o){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(o,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(o){let S=o&&o.length>0?o[0]:void 0;if(!S){const s=t.URI.file((0,u.homedir)());S=new P.WorkspaceFolder({uri:s,name:y.basename(s),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,S){const s=t.URI.revive(o),i={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(s),c=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(c),h=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let d of S.variables)i.variables[d]=await a.resolveAsync(h,d);if(S.process!==void 0){let d;if(S.process.path!==void 0){d=S.process.path.split(m.delimiter);for(let v=0;v<d.length;v++)d[v]=await a.resolveAsync(h,d[v])}i.process=await I.win32.findExecutable(await a.resolveAsync(h,S.process.name),S.process.cwd!==void 0?await a.resolveAsync(h,S.process.cwd):void 0,d)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(o,S,s){return I.win32.findExecutable(o,S,s)}};r=je([ze(0,C.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,k.IExtHostDocumentsAndEditors),ze(4,_.IExtHostConfiguration),ze(5,R.IExtHostTerminalService),ze(6,g.ILogService),ze(7,E.IExtHostApiDeprecationService),ze(8,F.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(pe[271],ve([0,1,13,16,72,6,2,5,263,11,61,84,26,187,14,65,39,34]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(r,f,o,S,s){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new _.RPCProtocol(r,null,S),f=y._transform(f,this._rpcProtocol);const i=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...f,messagePorts:s}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(g.IURITransformerService,new g.URITransformerService(S)),i.set(E.IHostUtils,o);const n=new w.InstantiationService(i,!0);this._disposables.add(n.invokeFunction(d=>d.get(F.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(d=>d.get(E.IExtHostExtensionService))),this._logService=n.invokeFunction(d=>d.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",f),this._extensionService=n.invokeFunction(d=>d.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(v,b)=>{let A="",O,N;for(const L of b)A+=`
	at ${L.toString()}`,N=L.getFileName(),!O&&N&&(O=d.findSubstr(T.URI.file(N)));return c.set(v,O),`${v.name||"Error"}: ${v.message||""}${A}`}});const a=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(d=>{const v=t.transformErrorForSerialization(d),b=c.get(d);b?a.$onExtensionRuntimeError(b.identifier,v):h.$onUnexpectedError(v)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),f]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,f){r.extensions.forEach(S=>S.extensionLocation=T.URI.revive(f.transformIncomingURIs(S.extensionLocation))),r.environment.appRoot=T.URI.revive(f.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(S=>T.URI.revive(f.transformIncomingURIs(S)))),r.environment.extensionTestsLocationURI=T.URI.revive(f.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=T.URI.revive(f.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=T.URI.revive(f.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=T.URI.revive(f.transformIncomingURIs(r.logsLocation)),r.logFile=T.URI.revive(f.transformIncomingURIs(r.logFile)),r.workspace=f.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=y}),define(pe[272],ve([0,1,9,21,49,32,23,46,31]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,w,p){this.config=l,this.provider=w,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&D.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&D.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const w=this.config.folderQueries||[];return new Promise((p,g)=>{const E=F=>{this.resultCount++,l(F)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const y=F.toString(),u=m.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,u)||this.matchFile(E,{base:F,basename:u})}),Promise.all(w.map(F=>this.searchInFolder(F,E))).then(F=>{p({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{g(new Error((0,I.toErrorMessage)(F)))})})}async searchInFolder(l,w){const p=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),F=new _.QueryGlobTester(this.config,l),y=!F.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(p),u=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,p.token),f=u.elapsed(),o=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(S=>{const s=m.posix.relative(l.folder.path,S.path);if(y){const i=m.basename(S.path);this.matchFile(w,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(E,l.folder,s,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,F,w),{providerTime:f,postProcessTime:o.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(l){const w=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),p=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},w,p,g){if(p===this.filePattern){const F=m.basename(this.filePattern);this.matchFile(g,{base:w,relativePath:this.filePattern,basename:F})}function E(F){const y=m.basename(F),u=m.dirname(F);let r=l[u];r||(r=l[u]=[],E(u)),r.push({base:w,relativePath:F,basename:y})}E(p)}matchDirectoryTree({rootEntries:l,pathToEntries:w},p,g){const E=this,F=this.filePattern;function y(u){const r=D.hasSiblingFn(()=>u.map(f=>f.basename));for(let f=0,o=u.length;f<o;f++){const S=u[f],{relativePath:s,basename:i}=S;if(p.matchesExcludesSync(s,i,F!==i?r:void 0))continue;const n=w[s];if(n)y(n);else{if(s===F)continue;E.matchFile(g,S)}if(E.isLimitHit)break}}y(l)}matchFile(l,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(w))}}class R{constructor(){this.sessions=new Map}fileSearch(l,w,p,g){const E=this.getSessionTokenSource(l.cacheKey),F=new P(l,w,E&&E.token);let y=0;const u=r=>{y+=r.length,p(r.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(F,R.BATCH_SIZE,u,g).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:r.stats}}))}clearCache(l){const w=this.getSessionTokenSource(l);w&&w.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:T.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,w,p,g){g.onCancellationRequested(()=>{l.cancel()});const E=y=>{y&&(F.push(y),w>0&&F.length>=w&&(p(F),F=[]))};let F=[];return l.search(E).then(y=>(F.length&&p(F),y),y=>(F.length&&p(F),Promise.reject(y)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(pe[135],ve([0,1,17,13,21,49,32,10,9,23,18,2,31]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(r,f,o,S){this.query=r,this.provider=f,this.fileUtils=o,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(r,f){const o=this.query.folderQueries||[],S=new I.CancellationTokenSource;return f.onCancellationRequested(()=>S.cancel()),new Promise((s,i)=>{this.collector=new g(r);let n=!1;const c=(a,h)=>{if(!n&&!this.isLimitHit){const d=this.resultSize(a);F(a)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,n=!0,S.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const v=this.resultSize(a);this.resultCount+=v,(v>0||!F(a))&&this.collector.add(a,h)}};Promise.all(o.map((a,h)=>this.searchInFolder(a,d=>c(d,h),S.token))).then(a=>{S.dispose(),this.collector.flush();const h=a.some(d=>!!d&&!!d.limitHit);s({limitHit:this.isLimitHit||h,messages:(0,m.flatten)(a.map(d=>d?.message?(0,R.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},a=>{S.dispose();const h=(0,D.toErrorMessage)(a);i(new Error(h))})})}resultSize(r){return F(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}trimResultToSize(r,f){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],S=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,f),preview:{matches:S.slice(0,f),text:r.preview.text},uri:r.uri}}async searchInFolder(r,f,o){const S=new l.QueryGlobTester(this.query,r),s=[],i={report:a=>{if(!this.validateProviderResult(a))return;const h=r.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(a.uri))):void 0,d=P.relativePath(r.folder,a.uri);if(d){const v=S.includedInQuery(d,_.basename(d),h);(0,t.isThenable)(v)?s.push(v.then(b=>{b&&f(a)})):v&&f(a)}}},n=this.getSearchOptionsForFolder(r),c=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,i,o);return s.length&&await Promise.all(s),c}validateProviderResult(r){if(F(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(r){const f=(0,l.resolvePatternsForProvider)(this.query.includePattern,r.includePattern),o=(0,l.resolvePatternsForProvider)(this.query.excludePattern,r.excludePattern),S={folder:C.URI.from(r.folder),excludes:o,includes:f,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.fileUtils.toCanonicalName(r.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=w;function p(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class g{constructor(r){this._onResult=r,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new y(512,f=>this.sendItems(f))}add(r,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!P.isEqual(this._currentUri,r.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:r.uri,results:[]}),this._currentFileMatch.results.push(E(r))}pushToCollector(){const r=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,r)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(r){this._onResult(r)}}e.TextSearchResultsCollector=g;function E(u){return F(u)?{preview:{matches:(0,m.mapArrayOrNot)(u.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:u.preview.text},ranges:(0,m.mapArrayOrNot)(u.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function F(u){return!!u.preview}e.extensionResultIsMatch=F;class y{constructor(r,f){this.maxBatchSize=r,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(r,f){!r||this.addItemToBatch(r,f)}addItems(r,f){!r||this.addItemsToBatch(r,f)}addItemToBatch(r,f){this.batch.push(r),this.batchSize+=f,this.onUpdate()}addItemsToBatch(r,f){this.batch=this.batch.concat(r),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<y.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},y.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=y,y.TIMEOUT=4e3,y.START_BATCH_AFTER_COUNT=50}),define(pe[73],ve([0,1,6,5,4,272,14,65,11,2,135]),function(Z,e,m,t,I,D,T,k,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let C=class{constructor(g,E,F){this.extHostRpc=g,this._uriTransformer=E,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,E){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const F=this._handlePool++;return this._textSearchProvider.set(F,E),this._proxy.$registerTextSearchProvider(F,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(g,E){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const F=this._handlePool++;return this._fileSearchProvider.set(F,E),this._proxy.$registerFileSearchProvider(F,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(g,E,F,y){const u=l(F),r=this._fileSearchProvider.get(g);if(r)return this._fileSearchManager.fileSearch(u,r,f=>{this._proxy.$handleFileMatch(g,E,f.map(o=>o.resource))},y);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,E,F,y){const u=this._textSearchProvider.get(g);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const r=l(F);return this.createTextSearchManager(r,u).search(o=>this._proxy.$handleTextMatch(g,E,o),y)}$enableExtensionHostSearch(){}createTextSearchManager(g,E){return new R.TextSearchManager(g,E,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};C=je([ze(0,T.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,_.ILogService)],C),e.ExtHostSearch=C;function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(w),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>P.URI.revive(g))}}e.reviveQuery=l;function w(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(pe[273],ve([0,1,61,133,35,131,36,38,45,34,71,54,73,90,51,66,134,67,44,89,122,53,132,11,225]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r,f,o,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(S.ILoggerService,o.ExtHostLoggerService),(0,m.registerSingleton)(S.ILogService,s.ExtHostLogService),(0,m.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,m.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,m.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,m.registerSingleton)(D.IExtHostDecorations,D.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,m.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage),(0,m.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,m.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,m.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,m.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,m.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,m.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(f.IExtHostEditorTabs,f.ExtHostEditorTabs)}),define(pe[91],ve([0,1,17,11,31,70]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=T;function k(C,l,w,p){const g=(0,m.mapArrayOrNot)(w,_),E=new I.TextSearchMatch(l,g,p),F=E.preview.matches;return{ranges:(0,m.mapArrayOrNot)(g,P),uri:C,preview:{text:E.preview.text,matches:(0,m.mapArrayOrNot)(F,P)}}}e.createTextSearchResult=k;function _(C){return new I.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new D.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(l,w){this.prefix=l,this.logService=w}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};R=je([ze(1,t.ILogService)],R),e.OutputChannel=R}),define(pe[274],ve([0,1,37,9,79,29,12,8,91,275]),function(Z,e,m,t,I,D,T,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(u,r,f,o){const S=l(u,r,f,o),s=r.folder.fsPath;return{cmd:m.spawn(R,S.args,{cwd:s}),rgDiskPath:R,siblingClauses:S.siblingClauses,rgArgs:S,cwd:s}}e.spawnRipgrepCmd=C;function l(u,r,f,o){const S=["--files","--hidden","--case-sensitive"];p([r],f,!1).forEach(i=>{const n=(0,_.anchorGlob)(i);if(S.push("-g",n),T.isMacintosh){const c=(0,I.normalizeNFD)(n);c!==n&&S.push("-g",c)}});const s=w([r],o,void 0,!1);return s.globArgs.forEach(i=>{const n=`!${(0,_.anchorGlob)(i)}`;if(S.push("-g",n),T.isMacintosh){const c=(0,I.normalizeNFD)(n);c!==n&&S.push("-g",c)}}),r.disregardIgnoreFiles!==!1?S.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),r.ignoreSymlinks||S.push("--follow"),u.exists&&S.push("--quiet"),S.push("--no-config"),r.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:s.siblingClauses}}function w(u,r,f,o=!0){const S=[];let s={};return u.forEach(i=>{const n=Object.assign({},i.excludePattern||{},r||{}),c=g(n,o?i.folder.fsPath:void 0,f);S.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:S,siblingClauses:s}}e.foldersToRgExcludeGlobs=w;function p(u,r,f=!0){const o=[];return u.forEach(S=>{const s=Object.assign({},r||{},S.includePattern||{}),i=g(s,f?S.folder.fsPath:void 0);o.push(...i.globArgs)}),o}e.foldersToIncludeGlobs=p;function g(u,r,f){const o=[],S={};return Object.keys(u).forEach(s=>{if(f&&f.has(s)||!s)return;const i=u[s];s=F(r?E(r,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),o.push(y(s))):i&&i.when&&(S[s]=i)}),{globArgs:o,siblingClauses:S}}function E(u,r){return t.isAbsolute(r)?r:t.join(u,r)}e.getAbsoluteGlob=E;function F(u){return u=k.rtrim(u,"\\"),k.rtrim(u,"/")}function y(u){return D.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=y}),define(pe[276],ve([0,1,37,60,9,104,17,49,32,79,29,12,46,8,18,30,31,274,102]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class r{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&_.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,y.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&_.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(n=>{const c=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),a=n.folder.fsPath;i.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==a).forEach(h=>{(0,R.isEqualOrParent)(h,a)&&(c[I.relative(a,h)]=!0)}),this.folderExcludePatterns.set(a,new o(c,a))})}cancel(){this.isCanceled=!0,u.forEach(i=>i())}walk(i,n,c,a,h){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);n.forEach(d=>{const v=I.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,v)||this.matchFile(c,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(d,v)=>{this.call(this.cmdTraversal,this,d,c,a,b=>{if(b){const A=(0,k.toErrorMessage)(b);console.error(A),this.errors.push(A),v(b,void 0)}else v(null,void 0)})},(d,v)=>{this.fileWalkSW.stop();const b=d?T.coalesce(d)[0]:null;h(b,this.isLimitHit)})}parallel(i,n,c){const a=new Array(i.length),h=new Array(i.length);let d=!1,v=0;if(i.length===0)return c(null,[]);i.forEach((b,A)=>{n(b,(O,N)=>{if(O?(d=!0,a[A]=null,h[A]=O):(a[A]=N,h[A]=null),++v===i.length)return c(d?h:null,a)})})}call(i,n,...c){try{i.apply(n,c)}catch(a){c[c.length-1](a)}}cmdTraversal(i,n,c,a){const h=i.folder.fsPath,d=C.isMacintosh;let v;const b=()=>v&&v.kill();u.add(b);let A=U=>{u.delete(b),A=()=>{},a(U)},O="";const N=this.initDirectoryTree();let L;const M=(0,F.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=M.cmd,L=!Object.keys(M.siblingClauses).length;const V=M.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let H=`${M.rgDiskPath} ${V}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),c({message:H}),this.cmdResultCount=0,this.collectStdout(v,"utf8",c,(U,B,$)=>{if(U){A(U);return}if(this.isLimitHit){A();return}const W=(O+(d?P.normalizeNFC(B||""):B)).split(`
`);if($){const J=W.length;W[J-1]=W[J-1].trim(),W[J-1]||W.pop()}else O=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,L){for(const J of W)if(this.matchFile(n,{base:h,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){b();break}($||this.isLimitHit)&&A();return}this.addDirectoryEntries(i,N,h,W,n),$&&(this.matchDirectoryTree(N,h,n),A())})}spawnFindCmd(i){const n=this.folderExcludePatterns.get(i.folder.fsPath),c=n.getBasenameTerms(),a=n.getPathTerms(),h=["-L","."];if(c.length||a.length){h.push("-not","(","(");for(const d of c)h.push("-name",d),h.push("-o");for(const d of a)h.push("-path",d),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),m.spawn("find",h,{cwd:i.folder.fsPath})}readStdout(i,n,c){let a="";this.collectStdout(i,n,()=>{},(h,d,v)=>{if(h){c(h);return}a+=d,v&&c(null,a)})}collectStdout(i,n,c,a){let h=(b,A,O)=>{(b||O)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),a(b,A,O)},d=!1;i.stdout?(this.forwardData(i.stdout,n,h),i.stdout.once("data",()=>d=!0)):c({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",b=>{h(b)}),i.on("close",b=>{let A;!d&&(A=this.decodeData(v,n))&&S(A)?h(new Error(`command failed with error code ${b}: ${this.decodeData(v,n)}`)):(this.exists&&b===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(i,n,c){const a=new D.StringDecoder(n);return i.on("data",h=>{c(null,a.write(h))}),a}collectData(i){const n=[];return i.on("data",c=>{n.push(c)}),n}decodeData(i,n){const c=new D.StringDecoder(n);return i.map(a=>c.write(a)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:n},c,a,h){a.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const d=v=>{const b=I.basename(v),A=I.dirname(v);let O=n[A];O||(O=n[A]=[],d(A)),O.push({base:c,relativePath:v,basename:b,searchPath:this.getSearchPath(i,v)})};a.forEach(d)}matchDirectoryTree({rootEntries:i,pathToEntries:n},c,a){const h=this,d=this.folderExcludePatterns.get(c),v=this.filePattern;function b(A){h.directoriesWalked++;const O=_.hasSiblingFn(()=>A.map(N=>N.basename));for(let N=0,L=A.length;N<L;N++){const M=A[N],{relativePath:V,basename:H}=M;if(d.test(V,H,v!==H?O:void 0))continue;const U=n[V];if(U)b(U);else{if(h.filesWalked++,V===v)continue;h.matchFile(a,M)}if(h.isLimitHit)break}}b(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,n,c,a,h){const d=i.folder,v=_.hasSiblingFn(()=>c);this.parallel(c,(b,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const O=n?[n,b].join(I.sep):b;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,b,this.config.filePattern!==b?v:void 0))return A(null);const N=[d.fsPath,O].join(I.sep);t.lstat(N,(L,M)=>{if(L||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(N,M,(V,H)=>V||this.isCanceled||this.isLimitHit?A(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,M,(U,B)=>U||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?A(null):(this.walkedPaths[B]=!0,g.Promises.readdir(N).then($=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(i,O,$,a,z=>A(z||null))},$=>{A(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&p.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(a,{base:d.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),A(null,void 0)))})},b=>{const A=b&&T.coalesce(b);return h(A&&A.length>0?A[0]:void 0)})}matchFile(i,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,I.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(n))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,n,c){return n.isSymbolicLink()?t.stat(i,c):c(null,n)}realPathIfNeeded(i,n,c){return n.isSymbolicLink()?t.realpath(i,(a,h)=>a?c(a):c(null,h)):c(null,i)}getSearchPath(i,n){return i.folderName?I.join(i.folderName,n):n}}e.FileWalker=r;class f{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new r(i)}search(i,n,c){this.walker.walk(this.folderQueries,this.extraFiles,i,n,(a,h)=>{c(a,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class o{constructor(i,n){this.expression=i,this.root=n,this.init(i)}init(i){let n,c;Object.keys(i).filter(a=>i[a]).forEach(a=>{I.isAbsolute(a)?(n=n||_.getEmptyExpression(),n[a]=i[a]):(c=c||_.getEmptyExpression(),c[a]=i[a])}),this.absoluteParsedExpr=n&&_.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=c&&_.parse(c,{trimForExclusions:!0})}test(i,n,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,n,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),n,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getPathTerms(this.relativeParsedExpr)),i}}function S(s){const i=s.trim().split(`
`),n=i[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return w.uppercaseFirstLetter(i[i.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(pe[277],ve([0,1,97,22]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===s)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const D=512,T=512,k=512*8,_=512*128;var P;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(i,n){super(i);this.decodeStreamErrorKind=n}}e.DecodeStreamError=R;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let n;if(i!==e.UTF8)n=(await new Promise((a,h)=>{Z(["@vscode/iconv-lite-umd"],a,h)})).getDecoder(g(i));else{const c=new TextDecoder;n={write(a){return c.decode(a,{stream:!0})},end(){return c.decode()}}}return new C(n)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(s,i){const n=i.minBytesRequiredForDetection??i.guessEncoding?k:T;return new Promise((c,a)=>{const h=(0,m.newWriteableStream)(N=>N.join("")),d=[];let v=0,b,A;const O=async()=>{try{const N=await S({buffer:t.VSBuffer.concat(d),bytesRead:v},i.guessEncoding);if(N.seemsBinary&&i.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);N.encoding=await i.overwriteEncoding(N.encoding),b=await C.create(N.encoding);const L=b.write(t.VSBuffer.concat(d).buffer);h.write(L),d.length=0,v=0,c({stream:h,detected:N})}catch(N){A?.dispose(),h.destroy(),a(N)}};A=(0,m.listenStream)(s,{onData:async N=>{b?h.write(b.write(N.buffer)):(d.push(N),v+=N.byteLength,v>=n&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:N=>h.error(N),onEnd:async()=>{b||await O(),h.end(b?.end())}})})}e.toDecodeStream=l;async function w(s,i,n){const a=(await new Promise((v,b)=>{Z(["@vscode/iconv-lite-umd"],v,b)})).getEncoder(g(i),n);let h=!1,d=!1;return{read(){if(d)return null;const v=s.read();if(typeof v!="string"){if(d=!0,!h&&n?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=a.end();return b&&b.length>0?(h=!0,t.VSBuffer.wrap(b)):null}return h=!0,t.VSBuffer.wrap(a.write(v))}}}e.toEncodeReadable=w;async function p(s){return(await new Promise((n,c)=>{Z(["@vscode/iconv-lite-umd"],n,c)})).encodingExists(g(s))}e.encodingExists=p;function g(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=g;function E(s,i){if(!s||i<e.UTF16be_BOM.length)return null;const n=s.readUInt8(0),c=s.readUInt8(1);if(n===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const a=s.readUInt8(2);return n===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=E;const F=["ascii","utf-16","utf-32"];async function y(s){const i=await new Promise((d,v)=>{Z(["jschardet"],d,v)}),n=s.slice(0,_),c=f(n.buffer),a=i.detect(c);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=F.indexOf(h)?null:r(a.encoding)}const u={ibm866:"cp866",big5:"cp950"};function r(s){const i=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return u[i]||i}function f(s){let i="";for(let n=0;n<s.length;n++)i+=String.fromCharCode(s[n]);return i}function o(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=s.match(/windows(\d+)/);return i?"windows-"+i[1]:s}}}e.toCanonicalName=o;function S({buffer:s,bytesRead:i},n){let c=E(s,i),a=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&s){let h=!0,d=!0,v=!1;for(let b=0;b<i&&b<D;b++){const A=b%2==1,O=s.readUInt8(b)===0;if(O&&(v=!0),h&&(A&&!O||!A&&O)&&(h=!1),d&&(A&&O||!A&&!O)&&(d=!1),O&&!h&&!d)break}v&&(h?c=e.UTF16le:d?c=e.UTF16be:a=!0)}return n&&!a&&!c&&s?y(s.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:c}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[136],ve([0,1,277,30,135]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class D extends I.TextSearchManager{constructor(k,_,P=t,R="searchProcess"){super(k,_,{readdir:C=>P.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,m.toCanonicalName)(C)},R)}}e.NativeTextSearchManager=D}),define(pe[278],ve([0,1,61,4]),function(Z,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const k=this._dragOperations.get(T);return this._dragOperations.delete(T),k}}addDragOperationTransfer(T,k){this._dragOperations.set(T,k)}}e.TreeViewsDragAndDropService=I,(0,m.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(pe[279],ve([0,1,168,23,2,3,6,13,7,18,17,15,21,205,278]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(y,u){if((0,P.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let r;return Array.isArray(y.highlights)&&(r=y.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),r=r.length?r:void 0),{label:y.label,highlights:r}}}class E{constructor(u,r,f){this._proxy=u,this.commands=r,this.logService=f,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function o(S){return S&&S.$treeViewId&&S.$treeItemHandle}r.registerArgumentProcessor({processArgument:S=>o(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(s=>o(s)?this.convertArgument(s):s):S})}registerTreeDataProvider(u,r,f){const o=this.createTreeView(u,{treeDataProvider:r},f);return{dispose:()=>o.dispose()}}createTreeView(u,r,f){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=r.dragAndDropController?.supportedMimeTypes,S=!!r.dragAndDropController?.handleDrag,s=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dragAndDropMimeTypes:o,hasHandleDrag:S}),i=this.createExtHostTreeView(u,r,f);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(n){i.message=n},get title(){return i.title},set title(n){i.title=n},get description(){return i.description},set description(n){i.description=n},reveal:(n,c)=>i.reveal(n,c),dispose:async()=>{await s,this.treeViews.delete(u),i.dispose()}}}$getChildren(u,r){const f=this.treeViews.get(u);return f?f.getChildren(r):Promise.reject(new Error((0,m.localize)(0,null,u)))}async $handleDrop(u,r,f,o,S,s){const i=this.treeViews.get(u);if(!i)return Promise.reject(new Error((0,m.localize)(1,null,u)));const n=w.TreeDataTransferConverter.toITreeDataTransfer(r);return S===u&&s&&await this.addAdditionalTransferItems(n,i,s,o),i.onDrop(n,f)}async addAdditionalTransferItems(u,r,f,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);let s;if(S)s=await S;else if(o&&r.handleDrag){const i=r.handleDrag(f);this.treeDragAndDropService.addDragOperationTransfer(o,i),s=await i}return s&&s.forEach((i,n)=>{i&&u.set(n,i)}),u}async $handleDrag(u,r,f){const o=this.treeViews.get(u);if(!o)return Promise.reject(new Error((0,m.localize)(2,null,u)));const S=await this.addAdditionalTransferItems(new Map,o,r,f);if(!!S)return w.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(u){const r=this.treeViews.get(u);if(!r)throw new Error((0,m.localize)(3,null,u));return r.hasResolve}$resolve(u,r,f){const o=this.treeViews.get(u);if(!o)throw new Error((0,m.localize)(4,null,u));return o.resolveTreeItem(r,f)}$setExpanded(u,r,f){const o=this.treeViews.get(u);if(!o)throw new Error((0,m.localize)(5,null,u));o.setExpanded(r,f)}$setSelection(u,r){const f=this.treeViews.get(u);if(!f)throw new Error((0,m.localize)(6,null,u));f.setSelection(r)}$setVisible(u,r){const f=this.treeViews.get(u);if(!f)throw new Error((0,m.localize)(7,null,u));f.setVisible(r)}createExtHostTreeView(u,r,f){const o=new F(u,r,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(u,o),o}convertArgument(u){const r=this.treeViews.get(u.$treeViewId);return r?r.getExtensionElement(u.$treeItemHandle):null}}e.ExtHostTreeViews=E;class F extends T.Disposable{constructor(u,r,f,o,S,s){super();if(this.viewId=u,this.proxy=f,this.commands=o,this.logService=S,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const a of s.contributes.views[c])a.id===u&&(this._title=a.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,n;this._register(D.Event.debounce(this._onDidChangeData.event,(c,a)=>(c||(c={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(h=>n=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(a.element)?c.elements.push(...a.element):c.elements.push(a.element)),a.message&&(c.message=!0),c),200,!0)(({message:c,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=n;return i=null,this.refresh(a).then(()=>h())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,P.isUndefinedOrNull)(u))}async getChildren(u){const r=u?this.getExtensionElement(u):void 0;if(u&&!r)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.getChildrenNodes(u);return f||(f=await this.fetchChildrenNodes(r)),f?f.map(o=>o.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,r){r=r||{select:!0,focus:!1};const f=(0,P.isUndefinedOrNull)(r.select)?!0:r.select,o=(0,P.isUndefinedOrNull)(r.focus)?!1:r.focus,S=(0,P.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(s=>this.resolveTreeNode(u,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(n=>n.item)},{select:f,focus:o,expand:S})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:o,expand:S})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}setExpanded(u,r){const f=this.getExtensionElement(u);f&&(r?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(u){(0,R.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(u){const r=[];for(const f of u){const o=this.getExtensionElement(f);o&&r.push(o)}if(!(!this.dndController?.handleDrag||r.length===0))return this.dndController.handleDrag(r)}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,r){const f=this.getExtensionElement(r);if(!!f)return(0,k.asPromise)(()=>this.dndController?.handleDrop(u,f))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,r){if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(u);if(f){const o=this.nodes.get(f);if(o){const S=await this.dataProvider.resolveTreeItem(o.extensionItem,f,r)??o.extensionItem;return o.item.tooltip=this.getTooltip(S.tooltip),o.item.command=this.getCommand(o.disposableStore,S.command),o.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(r=>r?this.resolveUnknownParentChain(r).then(f=>this.resolveTreeNode(r,f[f.length-1]).then(o=>(f.push(o),f))):Promise.resolve([]))}resolveParent(u){const r=this.nodes.get(u);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,r){const f=this.nodes.get(u);return f?Promise.resolve(f):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(o=>this.createHandle(u,o,r,!0)).then(o=>this.getChildren(r?r.item.handle:void 0).then(()=>{const S=this.getExtensionElement(o);if(S){const s=this.nodes.get(S);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(u){if(u){let r;if(typeof u=="string"){const f=this.getExtensionElement(u);r=f?this.nodes.get(f):void 0}else r=u;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const r=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=u?this.nodes.get(u):void 0,o=await this.dataProvider.getChildren(u);if(r.token.isCancellationRequested)return;const S=await Promise.all((0,R.coalesce)(o||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,f):null}));return r.token.isCancellationRequested?void 0:(0,R.coalesce)(S)}finally{r.dispose()}}refresh(u){if(u.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(u);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const r=new Set,f=u.map(S=>this.nodes.get(S));for(const S of f)if(S&&!r.has(S.item.handle)){let s=S;for(;s&&s.parent&&f.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&r.add(S.item.handle)}const o=[];return r.forEach(S=>{const s=this.elements.get(S);if(s){const i=this.nodes.get(s);i&&(!i.parent||!r.has(i.parent.item.handle))&&o.push(S)}}),o}refreshHandles(u){const r={};return Promise.all(u.map(f=>this.refreshNode(f).then(o=>{o&&(r[f]=o.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(u){const r=this.getExtensionElement(u);if(r){const f=this.nodes.get(r);if(f)return this.clearChildren(r),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(o=>{if(o){const S=this.createTreeNode(r,o,f.parent);return this.updateNodeCache(r,S,f,f.parent),f.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,r,f){const o=this.createTreeNode(u,r,f);if(r.id&&this.elements.has(o.item.handle))throw new Error((0,m.localize)(8,null,r.id));return this.addNodeToCache(u,o),this.addNodeToParentCache(o,f),o}getTooltip(u){return _.MarkdownString.isMarkdownString(u)?C.MarkdownString.from(u):u}getCommand(u,r){return r?this.commands.toInternal(r,u):void 0}createTreeNode(u,r,f){const o=new T.DisposableStore,S=this.createHandle(u,r,f),s=this.getLightIconPath(r);return{item:{handle:S,parentHandle:f?f.item.handle:void 0,label:g(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(o,r.command),contextValue:r.contextValue,icon:s,iconDark:this.getDarkIconPath(r)||s,themeIcon:this.getThemeIcon(r),collapsibleState:(0,P.isUndefinedOrNull)(r.collapsibleState)?_.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation},extensionItem:r,parent:f,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(u){return u.iconPath instanceof _.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:r,label:f,resourceUri:o},S,s){if(r)return`${F.ID_HANDLE_PREFIX}/${r}`;const i=g(f,this.extension),n=S?S.item.handle:F.LABEL_HANDLE_PREFIX;let c=i?i.label:o?(0,t.basename)(o):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const a=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,h=this.getChildrenNodes(S)||[];let d,v=0;do{if(d=`${n}/${v}:${c}`,s||!this.elements.has(d)||a===d)break;v++}while(v<=h.length);return d}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof _.ThemeIcon))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof _.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return I.URI.isUri(u)?u:I.URI.file(u)}addNodeToCache(u,r){this.elements.set(r.item.handle,u),this.nodes.set(u,r)}updateNodeCache(u,r,f,o){this.elements.delete(r.item.handle),this.nodes.delete(u),r.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(u,r);const S=this.getChildrenNodes(o)||[],s=S.filter(i=>i.item.handle===f.item.handle)[0];s&&S.splice(S.indexOf(s),1,r)}addNodeToParentCache(u,r){r?(r.children||(r.children=[]),r.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const r=this.nodes.get(u);if(r){if(r.children)for(const f of r.children){const o=this.elements.get(f.item.handle);o&&this.clear(o)}r.children=void 0}}else this.clearAll()}clear(u){const r=this.nodes.get(u);if(r){if(r.children)for(const f of r.children){const o=this.elements.get(f.item.handle);o&&this.clear(o)}this.nodes.delete(u),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(pe[280],ve([0,1,21,16,3,47,2,114,109,146,82,42,5,230,229,38,231,36,232,233,234,217,235,45,39,236,237,240,241,242,133,219,247,248,249,90,34,251,279,15,7,254,69,134,35,75,206,239,63,131,71,54,73,11,65,14,26,243,203,51,66,227,252,202,68,67,257,255,256,228,44,250,253,89,53,122,245,70,246,10,190,244,200,238,6,28]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y,u,r,f,o,S,s,i,n,c,a,h,d,v,b,A,O,N,L,M,V,H,U,B,$,z,W,J,ne,se,K,Q,ae,fe,be,Me,xe,Ge,Je,q,te,G,X,oe,me,Ie,We,Ye,it,st,ot,tt,rt,gt,Ue,It,ee,ie,Se,re,ye,Fe,qe,Ve,ut,Re,Ae,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const we=de.get(Je.IExtHostInitDataService),Ce=de.get(rt.IExtHostFileSystemInfo),Oe=de.get(Ye.IExtHostConsumerFileSystem),Ke=de.get(s.IExtHostExtensionService),$e=de.get(W.IExtHostWorkspace),Ze=de.get(ie.IExtHostTelemetry),lt=de.get(F.IExtHostConfiguration),ct=de.get(xe.IURITransformerService),He=de.get(Ge.IExtHostRpcService),Ee=de.get(N.IExtHostStorage),_e=de.get(We.IExtensionStoragePaths),he=de.get(Me.ILoggerService),Y=de.get(Me.ILogService),ke=de.get(G.IExtHostTunnelService),Ne=de.get(X.IExtHostApiDeprecationService),Xe=de.get(z.IExtHostWindow),Qe=de.get(It.IExtHostSecretState),pt=de.get(ee.IExtHostEditorTabs);He.set(l.ExtHostContext.ExtHostFileSystemInfo,Ce),He.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),He.set(l.ExtHostContext.ExtHostWorkspace,$e),He.set(l.ExtHostContext.ExtHostConfiguration,lt),He.set(l.ExtHostContext.ExtHostExtensionService,Ke),He.set(l.ExtHostContext.ExtHostStorage,Ee),He.set(l.ExtHostContext.ExtHostTunnelService,ke),He.set(l.ExtHostContext.ExtHostWindow,Xe),He.set(l.ExtHostContext.ExtHostSecretState,Qe),He.set(l.ExtHostContext.ExtHostTelemetry,Ze),He.set(l.ExtHostContext.ExtHostEditorTabs,pt);const St=He.set(l.ExtHostContext.ExtHostDecorations,de.get(Q.IExtHostDecorations)),yt=He.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=He.set(l.ExtHostContext.ExtHostCommands,de.get(g.IExtHostCommands)),wt=He.set(l.ExtHostContext.ExtHostTerminalService,de.get(L.IExtHostTerminalService)),bt=He.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Ut=He.set(l.ExtHostContext.ExtHostSearch,de.get(be.IExtHostSearch)),Pt=He.set(l.ExtHostContext.ExtHostTask,de.get(ae.IExtHostTask)),Ft=He.set(l.ExtHostContext.ExtHostOutputService,de.get(d.IExtHostOutputService)),kt=He.set(l.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(He)),Ct=He.set(l.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(He,yt)),Qt=He.set(l.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(He,yt,Y)),Vt=He.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Y,Ct,He.getProxy(l.MainContext.MainThreadBulkEdits))),Et=He.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController(He,ft,yt,Ct,_e)),Xt=He.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(Y,Et)),qt=He.set(l.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(Y,He,Et)),Yt=He.set(l.ExtHostContext.ExtHostNotebookKernels,new Se.ExtHostNotebookKernels(He,we,Et,ft,Y)),ai=He.set(l.ExtHostContext.ExtHostNotebookRenderers,new ye.ExtHostNotebookRenderers(He,Et)),Rt=He.set(l.ExtHostContext.ExtHostEditors,new M.ExtHostEditors(He,yt)),Jt=He.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(He.getProxy(l.MainContext.MainThreadTreeViews),ft,Y)),li=He.set(l.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets(He.getProxy(l.MainContext.MainThreadEditorInsets),Rt,we)),jt=He.set(l.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(He,Y,Ce)),Zt=He.set(l.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(He,Ct,ft.converter,ct)),vt=He.set(l.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(He,ct,Ct,ft,jt,Y,Ne)),ci=He.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(He,vt)),Ot=He.set(l.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(He,Y,yt)),$t=He.set(l.ExtHostContext.ExtHostQuickOpen,(0,b.createExtHostQuickOpen)(He,$e,ft)),vi=He.set(l.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(He,ft,Y)),ui=He.set(l.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)(He,ft,Ct)),ei=He.set(l.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(He.getProxy(l.MainContext.MainThreadProgress))),Ci=He.set(l.ExtHostContext.ExtHosLabelService,new se.ExtHostLabelService(He)),wi=He.set(l.ExtHostContext.ExtHostTheming,new te.ExtHostTheming(He)),ti=He.set(l.ExtHostContext.ExtHostAuthentication,new oe.ExtHostAuthentication(He)),Di=He.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline(He,ft)),di=He.set(l.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(He,{remote:we.remote},$e,Y,Ne)),Gt=He.set(l.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels(He,di,$e)),hi=He.set(l.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(He,Ct,_e,di,Gt)),ki=He.set(l.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(He,di)),Kt=He.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(He,ft)),Ii=He.set(l.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(He));He.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(He,Et,yt,ft));const Pi=(0,J.values)(l.ExtHostContext);He.assertRegistered(Pi);const ii=new tt.ExtHostBulkEdits(He,yt),Ai=new p.ExtHostClipboard(He),fi=new h.ExtHostMessageService(He,Y),bi=new u.ExtHostDialogs(He),ni=new O.ExtHostStatusBar(He,ft.converter);return w.ExtHostApiCommands.register(ft),function(Be,Ht,Bt){const _t=function(){let le=!Be.isUnderDevelopment;function ge(){le||(Y.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Te(ht){if(Array.isArray(ht))ht.forEach(Te);else if(typeof ht=="string")ge();else{const Dt=ht;typeof Dt.scheme=="undefined"&&ge(),typeof Dt.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ht}}(),Mt={getSession(le,ge,Te){return ti.getSession(Be,le,ge,Te)},async hasSession(le,ge){return(0,De.checkProposedApiEnabled)(Be,"authSession"),!!await ti.getSession(Be,le,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(le,ge,Te,ht){return ti.registerAuthenticationProvider(le,ge,Te,ht)}},ri={registerCommand(le,ge,Te){return ft.registerCommand(!0,le,ge,Te,void 0,Be)},registerTextEditorCommand(le,ge,Te){return ft.registerCommand(!0,le,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}return Dt.edit(Tt=>{ge.apply(Te,[Dt,Tt,...ht])}).then(Tt=>{Tt||Y.warn("Edits from command "+le+" were not applied.")},Tt=>{Y.warn("An error occurred while running command "+le,Tt)})},void 0,void 0,Be)},registerDiffInformationCommand:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"diffCommand"),ft.registerCommand(!0,le,async(...ht)=>{const Dt=yt.activeEditor(!0);if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Dt.id);ge.apply(Te,[Tt,...ht])},void 0,void 0,Be)),executeCommand(le,...ge){return ft.executeCommand(le,...ge)},getCommands(le=!1){return ft.getCommands(le)}},Ei={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const le=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,ge){return Xe.openUri(le,{allowTunneling:!!we.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===we.environment.appUriScheme)return kt.createAppUri(le);try{return await Xe.asExternalUri(le,{allowTunneling:!!we.remote.authority})}catch(ge){if((0,qe.matchesScheme)(le,Fe.Schemas.http)||(0,qe.matchesScheme)(le,Fe.Schemas.https))return le;throw ge}},get remoteName(){return(0,K.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=we.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Ti={createTestController(le,ge,Te){return Te&&(0,De.checkProposedApiEnabled)(Be,"testRefresh"),Kt.createTestController(le,ge,Te)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.createTestObserver()},runTests(le){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.runTests(le)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.results}},Ri={getExtension(le){const ge=Ht.getExtensionDescription(le);if(ge)return new s.Extension(Ke,Be.identifier,ge,Si)},get all(){return Ht.getAllExtensionDescriptions().map(le=>new s.Extension(Ke,Be.identifier,le,Si))},get onDidChange(){return Ht.onDidChange}},Li={createDiagnosticCollection(le){return jt.createDiagnosticCollection(Be.identifier,le)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:le=>jt.getDiagnostics(le),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(le,ge){return Zt.changeLanguage(le.uri,ge)},match(le,ge){return(0,R.score)(H.LanguageSelector.from(le),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(le,ge,Te){return vt.registerCodeActionProvider(Be,_t(le),ge,Te)},registerCodeLensProvider(le,ge){return vt.registerCodeLensProvider(Be,_t(le),ge)},registerDefinitionProvider(le,ge){return vt.registerDefinitionProvider(Be,_t(le),ge)},registerDeclarationProvider(le,ge){return vt.registerDeclarationProvider(Be,_t(le),ge)},registerImplementationProvider(le,ge){return vt.registerImplementationProvider(Be,_t(le),ge)},registerTypeDefinitionProvider(le,ge){return vt.registerTypeDefinitionProvider(Be,_t(le),ge)},registerHoverProvider(le,ge){return vt.registerHoverProvider(Be,_t(le),ge,Be.identifier)},registerEvaluatableExpressionProvider(le,ge){return vt.registerEvaluatableExpressionProvider(Be,_t(le),ge,Be.identifier)},registerInlineValuesProvider(le,ge){return vt.registerInlineValuesProvider(Be,_t(le),ge,Be.identifier)},registerDocumentHighlightProvider(le,ge){return vt.registerDocumentHighlightProvider(Be,_t(le),ge)},registerLinkedEditingRangeProvider(le,ge){return vt.registerLinkedEditingRangeProvider(Be,_t(le),ge)},registerReferenceProvider(le,ge){return vt.registerReferenceProvider(Be,_t(le),ge)},registerRenameProvider(le,ge){return vt.registerRenameProvider(Be,_t(le),ge)},registerDocumentSymbolProvider(le,ge,Te){return vt.registerDocumentSymbolProvider(Be,_t(le),ge,Te)},registerWorkspaceSymbolProvider(le){return vt.registerWorkspaceSymbolProvider(Be,le)},registerDocumentFormattingEditProvider(le,ge){return vt.registerDocumentFormattingEditProvider(Be,_t(le),ge)},registerDocumentRangeFormattingEditProvider(le,ge){return vt.registerDocumentRangeFormattingEditProvider(Be,_t(le),ge)},registerOnTypeFormattingEditProvider(le,ge,Te,...ht){return vt.registerOnTypeFormattingEditProvider(Be,_t(le),ge,[Te].concat(ht))},registerDocumentSemanticTokensProvider(le,ge,Te){return vt.registerDocumentSemanticTokensProvider(Be,_t(le),ge,Te)},registerDocumentRangeSemanticTokensProvider(le,ge,Te){return vt.registerDocumentRangeSemanticTokensProvider(Be,_t(le),ge,Te)},registerSignatureHelpProvider(le,ge,Te,...ht){return typeof Te=="object"?vt.registerSignatureHelpProvider(Be,_t(le),ge,Te):vt.registerSignatureHelpProvider(Be,_t(le),ge,typeof Te=="undefined"?[]:[Te,...ht])},registerCompletionItemProvider(le,ge,...Te){return vt.registerCompletionItemProvider(Be,_t(le),ge,Te)},registerInlineCompletionItemProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),vt.registerInlineCompletionsProvider(Be,_t(le),ge)},registerDocumentLinkProvider(le,ge){return vt.registerDocumentLinkProvider(Be,_t(le),ge)},registerColorProvider(le,ge){return vt.registerColorProvider(Be,_t(le),ge)},registerFoldingRangeProvider(le,ge){return vt.registerFoldingRangeProvider(Be,_t(le),ge)},registerSelectionRangeProvider(le,ge){return vt.registerSelectionRangeProvider(Be,le,ge)},registerCallHierarchyProvider(le,ge){return vt.registerCallHierarchyProvider(Be,le,ge)},registerTypeHierarchyProvider(le,ge){return vt.registerTypeHierarchyProvider(Be,le,ge)},setLanguageConfiguration:(le,ge)=>vt.setLanguageConfiguration(Be,le,ge),getTokenInformationAtPosition(le,ge){return(0,De.checkProposedApiEnabled)(Be,"tokenInformation"),Zt.tokenAtPosition(le,ge)},registerInlayHintsProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlayHints"),vt.registerInlayHintsProvider(Be,le,ge)},createLanguageStatusItem(le,ge){return(0,De.checkProposedApiEnabled)(Be,"languageStatus"),Zt.createLanguageStatusItem(Be,le,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(le,ge,Te){const ht=await(T.URI.isUri(le)?Promise.resolve(_i.openTextDocument(le)):Promise.resolve(le));return Rt.showTextDocument(ht,ge,Te)},createTextEditorDecorationType(le){return Rt.createTextEditorDecorationType(Be,le)},onDidChangeActiveTextEditor(le,ge,Te){return Rt.onDidChangeActiveTextEditor(le,ge,Te)},onDidChangeVisibleTextEditors(le,ge,Te){return Rt.onDidChangeVisibleTextEditors(le,ge,Te)},onDidChangeTextEditorSelection(le,ge,Te){return Rt.onDidChangeTextEditorSelection(le,ge,Te)},onDidChangeTextEditorOptions(le,ge,Te){return Rt.onDidChangeTextEditorOptions(le,ge,Te)},onDidChangeTextEditorVisibleRanges(le,ge,Te){return Rt.onDidChangeTextEditorVisibleRanges(le,ge,Te)},onDidChangeTextEditorViewColumn(le,ge,Te){return Rt.onDidChangeTextEditorViewColumn(le,ge,Te)},onDidCloseTerminal(le,ge,Te){return wt.onDidCloseTerminal(le,ge,Te)},onDidOpenTerminal(le,ge,Te){return wt.onDidOpenTerminal(le,ge,Te)},onDidChangeActiveTerminal(le,ge,Te){return wt.onDidChangeActiveTerminal(le,ge,Te)},onDidChangeTerminalDimensions(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDimensions"),wt.onDidChangeTerminalDimensions(le,ge,Te)},onDidChangeTerminalState(le,ge,Te){return wt.onDidChangeTerminalState(le,ge,Te)},onDidWriteTerminalData(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(le,ge,Te)},get state(){return Xe.state},onDidChangeWindowState(le,ge,Te){return Xe.onDidChangeWindowState(le,ge,Te)},showInformationMessage(le,...ge){return fi.showMessage(Be,D.default.Info,le,ge[0],ge.slice(1))},showWarningMessage(le,...ge){return fi.showMessage(Be,D.default.Warning,le,ge[0],ge.slice(1))},showErrorMessage(le,...ge){return fi.showMessage(Be,D.default.Error,le,ge[0],ge.slice(1))},showQuickPick(le,ge,Te){return Array.isArray(le)&&le.some(ht=>ht.kind===U.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Be,"quickPickSeparators"),$t.showQuickPick(le,ge,Te)},showWorkspaceFolderPick(le){return $t.showWorkspaceFolderPick(le)},showInputBox(le,ge){return $t.showInput(le,ge)},showOpenDialog(le){return bi.showOpenDialog(le)},showSaveDialog(le){return bi.showSaveDialog(le)},createStatusBarItem(le,ge,Te){let ht,Dt,Tt;return typeof le=="string"?(ht=le,Dt=ge,Tt=Te):(Dt=le,Tt=ge),ni.createStatusBarEntry(Be,ht,Dt,Tt)},setStatusBarMessage(le,ge){return ni.setStatusBarMessage(le,ge)},withScmProgress(le){return Ne.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ei.withProgress(Be,{location:U.ProgressLocation.SourceControl},(ge,Te)=>le({report(ht){}}))},withProgress(le,ge){return ei.withProgress(Be,le,ge)},createOutputChannel(le){return Ft.createOutputChannel(le,Be)},createWebviewPanel(le,ge,Te,ht){return Gt.createWebviewPanel(Be,le,ge,Te,ht)},createWebviewTextEditorInset(le,ge,Te,ht){return(0,De.checkProposedApiEnabled)(Be,"editorInsets"),li.createWebviewEditorInset(le,ge,Te,ht,Be)},createTerminal(le,ge,Te){return typeof le=="object"?"pty"in le?wt.createExtensionTerminal(le):wt.createTerminalFromOptions(le):wt.createTerminal(le,ge,Te)},registerTerminalLinkProvider(le){return wt.registerLinkProvider(le)},registerTerminalProfileProvider(le,ge){return wt.registerProfileProvider(Be,le,ge)},registerTreeDataProvider(le,ge){return Jt.registerTreeDataProvider(le,ge,Be)},createTreeView(le,ge){return Jt.createTreeView(le,ge,Be)},registerWebviewPanelSerializer:(le,ge)=>Gt.registerWebviewPanelSerializer(Be,le,ge),registerCustomEditorProvider:(le,ge,Te={})=>hi.registerCustomEditorProvider(Be,le,ge,Te),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Be.identifier)},registerUriHandler(le){return kt.registerUriHandler(Be.identifier,le)},createQuickPick(){return $t.createQuickPick(Be)},createInputBox(){return $t.createInputBox(Be.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(le,ge,Te){return wi.onDidChangeActiveColorTheme(le,ge,Te)},registerWebviewViewProvider(le,ge,Te){return ki.registerWebviewViewProvider(Be,le,ge,Te?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(le,ge,Te)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(le,ge,Te)},onDidChangeNotebookEditorVisibleRanges(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(le,ge,Te)},showNotebookDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.showNotebookDocument(le,ge)},registerExternalUriOpener(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"externalUriOpener"),Ii.registerExternalUriOpener(Be.identifier,le,ge,Te)},get tabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),c.InlineCompletionController.get(le)}},_i={get rootPath(){return Ne.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return $e.getWorkspaceFolder(le)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(le){throw t.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,ge,...Te)=>$e.updateWorkspaceFolders(Be,le,ge||0,...Te),onDidChangeWorkspaceFolders:function(le,ge,Te){return $e.onDidChangeWorkspace(le,ge,Te)},asRelativePath:(le,ge)=>$e.getRelativePath(le,ge),findFiles:(le,ge,Te,ht)=>$e.findFiles(le,ge,Te,Be.identifier,ht),findTextInFiles:(le,ge,Te,ht)=>{(0,De.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Tt;return typeof ge=="object"?(Dt=ge,Tt=Te):(Dt={},Tt=ge,ht=Te),$e.findTextInFiles(le,Dt||{},Tt,Be.identifier,ht)},saveAll:le=>$e.saveAll(le),applyEdit(le){return ii.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,ge,Te,ht)=>Ot.createFileSystemWatcher($e,Be,le,ge,Te,ht),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let ge;const Te=le;if(typeof le=="string")ge=Promise.resolve(T.URI.file(le));else if(T.URI.isUri(le))ge=Promise.resolve(le);else if(!Te||typeof Te=="object")ge=Ct.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>Ct.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(le,ge,Te)=>Ct.onDidAddDocument(le,ge,Te),onDidCloseTextDocument:(le,ge,Te)=>Ct.onDidRemoveDocument(le,ge,Te),onDidChangeTextDocument:(le,ge,Te)=>Ct.onDidChangeDocument(le,ge,Te),onDidSaveTextDocument:(le,ge,Te)=>Ct.onDidSaveDocument(le,ge,Te),onWillSaveTextDocument:(le,ge,Te)=>Vt.getOnWillSaveTextDocumentEvent(Be)(le,ge,Te),get notebookDocuments(){return Et.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,ge){let Te;if(T.URI.isUri(le))Te=le,await Et.openNotebookDocument(le);else if(typeof le=="string")Te=T.URI.revive(await Et.createNotebookDocument({viewType:le,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(le,ge,Te,ht){return Et.registerNotebookSerializer(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(le,ge,Te,ht)=>((0,De.checkProposedApiEnabled)(Be,"notebookContentProvider"),Et.registerNotebookContentProvider(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(le,ge,Te)=>Bt.onDidChangeConfiguration(le,ge,Te),getConfiguration(le,ge){return ge=arguments.length===1?void 0:ge,Bt.getConfiguration(le,ge,Be)},registerTextDocumentContentProvider(le,ge){return Qt.registerTextDocumentContentProvider(le,ge)},registerTaskProvider:(le,ge)=>(Ne.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Be,le,ge)),registerFileSystemProvider(le,ge,Te){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Be,le,ge,Te),Oe.addFileSystemProvider(le,ge))},get fs(){return Oe.value},registerFileSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ut.registerFileSearchProvider(le,ge)),registerTextSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"textSearchProvider"),Ut.registerTextSearchProvider(le,ge)),registerRemoteAuthorityResolver:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ke.registerRemoteAuthorityResolver(le,ge)),registerResourceLabelFormatter:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,ge,Te)=>Ot.onDidCreateFile(le,ge,Te),onDidDeleteFiles:(le,ge,Te)=>Ot.onDidDeleteFile(le,ge,Te),onDidRenameFiles:(le,ge,Te)=>Ot.onDidRenameFile(le,ge,Te),onWillCreateFiles:(le,ge,Te)=>Ot.getOnWillCreateFileEvent(Be)(le,ge,Te),onWillDeleteFiles:(le,ge,Te)=>Ot.getOnWillDeleteFileEvent(Be)(le,ge,Te),onWillRenameFiles:(le,ge,Te)=>Ot.getOnWillRenameFileEvent(Be)(le,ge,Te),openTunnel:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.openTunnel(Be,le).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.onDidChangeTunnels(le,ge,Te)),registerPortAttributesProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"portsAttributes"),ke.registerPortsAttributesProvider(le,ge)),registerTimelineProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"timeline"),Di.registerTimelineProvider(le,ge,Be.identifier,ft.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:le=>((0,De.checkProposedApiEnabled)(Be,"workspaceTrust"),$e.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,ge,Te)=>$e.onDidGrantWorkspaceTrust(le,ge,Te)},mi={get inputBox(){return Ne.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Be)},createSourceControl(le,ge,Te){return vi.createSourceControl(Be,le,ge,Te)}},Mi={createCommentController(le,ge){return ui.createCommentController(Be,le,ge)}},Oi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(le,ge,Te){return bt.onDidStartDebugSession(le,ge,Te)},onDidTerminateDebugSession(le,ge,Te){return bt.onDidTerminateDebugSession(le,ge,Te)},onDidChangeActiveDebugSession(le,ge,Te){return bt.onDidChangeActiveDebugSession(le,ge,Te)},onDidReceiveDebugSessionCustomEvent(le,ge,Te){return bt.onDidReceiveDebugSessionCustomEvent(le,ge,Te)},onDidChangeBreakpoints(le,ge,Te){return bt.onDidChangeBreakpoints(le,ge,Te)},registerDebugConfigurationProvider(le,ge,Te){return bt.registerDebugConfigurationProvider(le,ge,Te||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,ge){return bt.registerDebugAdapterDescriptorFactory(Be,le,ge)},registerDebugAdapterTrackerFactory(le,ge){return bt.registerDebugAdapterTrackerFactory(le,ge)},startDebugging(le,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?bt.startDebugging(le,ge,{parentSession:Te}):bt.startDebugging(le,ge,Te||{})},stopDebugging(le){return bt.stopDebugging(le)},addBreakpoints(le){return bt.addBreakpoints(le)},removeBreakpoints(le){return bt.removeBreakpoints(le)},asDebugSourceUri(le,ge){return bt.asDebugSourceUri(le,ge)}},Ni={registerTaskProvider:(le,ge)=>Pt.registerTaskProvider(Be,le,ge),fetchTasks:le=>Pt.fetchTasks(le),executeTask:le=>Pt.executeTask(Be,le),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(le,ge,Te)=>Pt.onDidStartTask(le,ge,Te),onDidEndTask:(le,ge,Te)=>Pt.onDidEndTask(le,ge,Te),onDidStartTaskProcess:(le,ge,Te)=>Pt.onDidStartTaskProcess(le,ge,Te),onDidEndTaskProcess:(le,ge,Te)=>Pt.onDidEndTaskProcess(le,ge,Te)},Ui={createNotebookController(le,ge,Te,ht,Dt){return Yt.createNotebookController(Be,le,ge,Te,ht,(0,De.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(le,ge)=>Et.registerNotebookCellStatusBarItemProvider(Be,le,ge),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,De.checkProposedApiEnabled)(Be,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Be,le)},onDidChangeNotebookDocumentMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(le,ge,Te)},onDidChangeNotebookCells(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeNotebookCells(le,ge,Te)},onDidChangeNotebookCellExecutionState(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(le,ge,Te)},onDidChangeCellOutputs(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellOutputs(le,ge,Te)},onDidChangeCellMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellMetadata(le,ge,Te)},createConcatTextDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookConcatTextDocument"),new Ie.ExtHostNotebookConcatDocument(Et,Ct,le,ge)}};return{version:we.version,authentication:Mt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:P.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:l.UIKind,Uri:T.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(pe[281],ve([0,1,282,293,294,2,295]),function(Z,e,m,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,l,w,p,g,E){const F=E.environment.useHostProxy,y=typeof F=="boolean"?F:!E.remote.isRemote,u=(0,T.createProxyResolver)({resolveProxy:f=>C.resolveProxy(f),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(f,o,...S)=>{switch(f){case T.LogLevel.Trace:p.trace(o,...S);break;case T.LogLevel.Debug:p.debug(o,...S);break;case T.LogLevel.Info:p.info(o,...S);break;case T.LogLevel.Warning:p.warn(o,...S);break;case T.LogLevel.Error:p.error(o,...S);break;case T.LogLevel.Critical:p.critical(o,...S);break;case T.LogLevel.Off:break;default:s(f,o,S);break}function s(i,n,...c){p.error("Unknown log level",i),p.error(n,...c)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:f=>{g.$publicLog2("resolveProxy",f)},useHostProxy:y,env:process.env}),r=_(l,u);return R(w,r)}e.connectProxyResolver=k;function _(C,l){const w={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(g=>{w.config=C.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(g=>{p.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,T.createHttpPatch)(m,l,{config:"off"},p,!0)),on:Object.assign({},m,(0,T.createHttpPatch)(m,l,{config:"on"},p,!0)),override:Object.assign({},m,(0,T.createHttpPatch)(m,l,{config:"override"},p,!0)),onRequest:Object.assign({},m,(0,T.createHttpPatch)(m,l,w,p,!0)),default:Object.assign(m,(0,T.createHttpPatch)(m,l,w,p,!1))},https:{off:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"off"},p,!0)),on:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"on"},p,!0)),override:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,T.createHttpPatch)(t,l,w,p,!0)),default:Object.assign(t,(0,T.createHttpPatch)(t,l,w,p,!1))},tls:Object.assign(I,(0,T.createTlsPatch)(I))}}const P=new Map;function R(C,l){return C.getExtensionPathIndex().then(w=>{const p=Z.__$__nodeRequire("module"),g=p._load;p._load=function(F,y,u){if(F==="tls")return l.tls;if(F!=="http"&&F!=="https")return g.apply(this,arguments);const r=l[F],f=w.findSubstr(D.URI.file(y.filename));let o=P.get(f);if(o||P.set(f,o={}),!o[F]){let S=r.default;o[F]={...S}}return o[F]}})}}),define(pe[137],ve([0,1,37,296,104,17,75,32,9,8,2,31,70,297,275,91]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class F{constructor(d){this.outputChannel=d}provideTextSearchResults(d,v,b,A){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((O,N)=>{A.onCancellationRequested(()=>z());const L=S(d,v),M=v.folder.fsPath,V=L.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${M}`);let H=m.spawn(E,L,{cwd:M});H.on("error",K=>{console.error(K),this.outputChannel.appendLine("Error: "+(K&&K.message)),N((0,C.serializeSearchError)(new C.SearchError(K&&K.message,C.SearchErrorCode.rgProcessError)))});let U=!1;const B=new r(v.maxResults,M,v.previewOptions);B.on("result",K=>{U=!0,J="",b.report(K)});let $=!1;const z=()=>{$=!0,H&&H.kill(),B&&B.cancel()};let W=!1;B.on("hitLimit",()=>{W=!0,z()});let J="";H.stdout.on("data",K=>{B.handleData(K),U||(J+=K)});let ne=!1;H.stdout.once("data",()=>ne=!0);let se="";H.stderr.on("data",K=>{const Q=K.toString();this.outputChannel.appendLine(Q),se+=Q}),H.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),$)O({limitHit:W});else{B.flush(),H=null;let K;se&&!ne&&(K=y(se))?N((0,C.serializeSearchError)(new C.SearchError(K.message,K.code))):O({limitHit:W})}})})}}e.RipgrepTextSearchEngine=F;function y(h){const d=h.split(`
`),v=d[0].trim();if(d.some(A=>A.startsWith("regex parse error")))return new C.SearchError(u(d),C.SearchErrorCode.regexParseError);const b=v.match(/grep config error: unknown encoding: (.*)/);if(b)return new C.SearchError(`Unknown encoding: ${b[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=y;function u(h){const d=["Regex parse error"],v=h.filter(b=>b.startsWith("PCRE2:"));if(v.length>=1){const b=v[0].replace("PCRE2:","");if(b.indexOf(":")!==-1&&b.split(":").length>=2){const A=b.split(":")[1];d.push(":"+A)}}return d.join("")}e.buildRegexParseError=u;class r extends t.EventEmitter{constructor(d,v,b){super();this.maxResults=d,this.rootFolder=v,this.previewOptions=b,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,v){return super.on(d,v),this}handleData(d){if(this.isDone)return;const v=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(v)}handleDecodedData(d){let v=d.indexOf(`
`);const b=this.remainder+d;if(v>=0)v+=this.remainder.length;else{this.remainder=b;return}let A=0;for(;v>=0;)this.handleLine(b.substring(A,v).trim()),A=v+1,v=b.indexOf(`
`,A);this.remainder=b.substring(A)}handleLine(d){if(this.isDone||!d)return;let v;try{v=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(v.type==="match"){const b=f(v.data.path),A=R.URI.file(_.join(this.rootFolder,b)),O=this.createTextSearchMatch(v.data,A);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const b=f(v.data.path),A=R.URI.file(_.join(this.rootFolder,b));this.createTextSearchContext(v.data,A).forEach(N=>this.onResult(N))}}createTextSearchMatch(d,v){const b=d.line_number-1,A=f(d.lines),O=Buffer.from(A);let N=0,L=0,M=b;d.submatches.length===0&&d.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const V=(0,D.coalesce)(d.submatches.map((H,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=f(H.match),$=O.slice(N,H.start).toString().length,z=L+$,W=o(B),J=M,ne=W.numLines+J,se=W.numLines>0?W.lastLineLength:W.lastLineLength+z;return N=H.end,L=se,M=ne,new l.Range(J,z,ne,se)}));return(0,g.createTextSearchResult)(v,A,V,this.previewOptions)}createTextSearchContext(d,v){const b=f(d.lines),A=d.line_number;return b.replace(/\r?\n$/,"").split(`
`).map((O,N)=>({text:O,uri:v,lineNumber:A+N}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=r;function f(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function o(h){const d=/\n/g;let v=0,b=-1,A;for(;A=d.exec(h);)v++,b=A.index;const O=b>=0?h.length-b-1:h.length;return{numLines:v,lastLineLength:O}}function S(h,d){const v=["--hidden"];v.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:b,otherIncludes:A}=(0,T.groupBy)(d.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const N=new Set;A.forEach(L=>{N.add(L)}),v.push("-g","!*"),N.forEach(L=>{s(L).map(g.anchorGlob).forEach(M=>{v.push("-g",M)})})}b&&b.length&&b.forEach(N=>{v.push("-g",N)}),d.excludes.map(g.anchorGlob).forEach(N=>v.push("-g",`!${N}`)),d.maxFileSize&&v.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),d.followSymlinks&&v.push("--follow"),d.encoding&&d.encoding!=="utf8"&&v.push("--encoding",d.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,P.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),d.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),v.push("--engine","auto"));let O;if(h.isWordMatch){const L=(0,P.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",L)}else if(h.isRegExp){let N=c(h.pattern);N=a(N),v.push("--regexp",N)}else O=h.pattern,v.push("--fixed-strings");return v.push("--no-config"),d.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),h.isMultiline&&v.push("--multiline"),d.beforeContext&&v.push("--before-context",d.beforeContext+""),d.afterContext&&v.push("--after-context",d.afterContext+""),v.push("--"),O&&v.push(O),v.push("."),v}function s(h){const d=(0,k.splitGlobAware)(h,"/");return d.map((v,b)=>d.slice(0,b+1).join("/"))}e.spreadGlobComponents=s;function i(h){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(d);)h=h.replace(d,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(v);)h=h.replace(v,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const n=h=>h.type==="Assertion"&&h.kind==="lookbehind";function c(h){let d;try{d=new w.RegExpParser().parsePattern(h)}catch{return h}let v="",b=0;const A=(L,M,V)=>{v+=h.slice(b,L)+V,b=M},O=[];return new w.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const M=O[0];if(!M)A(L.start,L.end,"\\r?\\n");else if(!O.some(n))if(M.type==="CharacterClass")if(M.negate){const V=h.slice(M.start+2,L.start)+h.slice(L.end,M.end-1);if(M.parent?.type==="Quantifier"){const H=M.parent;A(H.start,H.end,(V?`[^${V}]`:".")+(H.greedy?"+":"*"))}else A(M.start,M.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=h.slice(M.start+1,L.start)+h.slice(L.end,M.end-1);A(M.start,M.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else M.type==="Quantifier"&&A(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){O.unshift(L)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(L){O.unshift(L)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(L){O.unshift(L)},onCharacterClassLeave(){O.shift()},onAssertionEnter(L){n(L)&&O.push(L)},onAssertionLeave(L){O[0]===L&&O.shift()}}).visit(d),v+=h.slice(b),v}e.fixRegexNewline=c;function a(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(pe[283],ve([0,1,21,137,118,10]),function(Z,e,m,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,R,C,l){const w=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===D.Schemas.userData){const p={...R,folder:R.folder.with({scheme:D.Schemas.file})},g=new I.Progress(E=>C.report({...E,uri:E.uri.with({scheme:R.folder.scheme})}));return this.withToken(l,E=>w.provideTextSearchResults(P,p,g,E))}else return this.withToken(l,p=>w.provideTextSearchResults(P,R,C,p))}async withToken(P,R){const C=k(P);this.inProgress.add(C);const l=await R(C.token);return this.inProgress.delete(C),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function k(_){const P=new m.CancellationTokenSource;return _.onCancellationRequested(()=>P.cancel()),P}}),define(pe[284],ve([0,1,30,137,136]),function(Z,e,m,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class D{constructor(_){this.query=_}search(_,P,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(w){R({message:w})}},l=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(C),m);return new Promise((w,p)=>l.search(g=>{P(g.map(T))},_).then(g=>w({limitHit:g.limitHit,type:"success",stats:g.stats}),p))}}e.TextSearchEngineAdapter=D;function T(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,P)=>{if(P.ranges){const R=P;return _+(Array.isArray(R.ranges)?R.ranges.length:1)}else return _+1},0)}}}),define(pe[285],ve([0,1,17,13,16,3,102,9,46,2,42,31,276,284]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let f;const o=F(r),S=new D.Emitter({onFirstListenerDidAdd:()=>{f=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(l.Engine,o,i=>S.fire(i),s)),f.then(s=>S.fire(s),s=>S.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return S.event}textSearch(r){let f;const o=F(r),S=new D.Emitter({onFirstListenerDidAdd:()=>{f=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(o,i=>S.fire(i),s)),f.then(s=>S.fire(s),s=>S.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return S.event}ripgrepTextSearch(r,f,o){return r.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(r).search(o,f,f)}doFileSearch(r,f,o){return this.doFileSearchWithEngine(l.Engine,r,f,o)}doFileSearchWithEngine(r,f,o,S,s=p.BATCH_SIZE){let i=0;const n=a=>{Array.isArray(a)?(i+=a.length,o(a.map(h=>this.rawMatchToSearchItem(h)))):a.relativePath?(i++,o(this.rawMatchToSearchItem(a))):o(a)};if(f.sortByScore){let a=this.trySortedSearchFromCache(f,n,S);if(!a){const h=f.maxResults?Object.assign({},f,{maxResults:null}):f,d=new r(h);a=this.doSortedSearch(d,f,o,n,S)}return new Promise((h,d)=>{a.then(([v,b])=>{const A=b.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(A,o,s),h(v)},d)})}const c=new r(f);return this.doSearch(c,n,s,S).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,f,o,S,s){const i=new D.Emitter;let n=(0,t.createCancelablePromise)(a=>{let h=[];const d=v=>{Array.isArray(v)?h=v:(S(v),i.fire(v))};return this.doSearch(r,d,-1,a).then(v=>[v,h])}),c;if(f.cacheKey){c=this.getOrCreateCache(f.cacheKey);const a={promise:n,event:i.event,resolved:!1};c.resultsToSearchCache[f.filePattern||""]=a,n.then(()=>{a.resolved=!0},h=>{delete c.resultsToSearchCache[f.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([a,h])=>{const d=c?c.scorerCache:Object.create(null),v=(typeof f.maxResults!="number"||f.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(f,h,d,s).then(b=>{const A=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:b.length},messages:a.messages,limitHit:a.limitHit||typeof f.maxResults=="number"&&h.length>f.maxResults},b]})})}getOrCreateCache(r){const f=this.caches[r];return f||(this.caches[r]=new g)}trySortedSearchFromCache(r,f,o){const S=r.cacheKey&&this.caches[r.cacheKey];if(!S)return;const s=this.getResultsFromCache(S,r.filePattern||"",f,o);if(s)return s.then(([i,n,c])=>{const a=_.StopWatch.create(!1);return this.sortResults(r,n,S.scorerCache,o).then(h=>{const d=a.elapsed(),v={fromCache:!0,detailStats:c,type:this.processType,resultCount:n.length,sortingTime:d};return[{type:"success",limitHit:i.limitHit||typeof r.maxResults=="number"&&n.length>r.maxResults,stats:v},h]})})}sortResults(r,f,o,S){const s=(0,T.prepareQuery)(r.filePattern||""),i=(c,a)=>(0,T.compareItemsByFuzzyScore)(c,a,s,!0,E,o),n=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(f,i,n,1e4,S)}sendProgress(r,f,o){if(o&&o>0)for(let S=0;S<r.length;S+=o)f(r.slice(S,S+o));else f(r)}getResultsFromCache(r,f,o,S){const s=_.StopWatch.create(!1),i=f.indexOf(k.sep)>=0;let n;for(const d in r.resultsToSearchCache)if(f.startsWith(d)){if(i&&d.indexOf(k.sep)<0&&d!=="")continue;const v=r.resultsToSearchCache[d];n={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!n)return null;const c=s.elapsed(),a=_.StopWatch.create(!1),h=n.event(o);return S&&S.onCancellationRequested(()=>{h.dispose()}),n.promise.then(([d,v])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const b=[],A=(0,T.prepareQuery)(f).normalizedLowercase;for(const O of v)!(0,C.isFilePatternMatch)(O,A)||b.push(O);return[d,b,{cacheWasResolved:n.resolved,cacheLookupTime:c,cacheFilterTime:a.elapsed(),cacheEntryCount:v.length}]})}doSearch(r,f,o,S){return new Promise((s,i)=>{let n=[];S&&S.onCancellationRequested(()=>r.cancel()),r.search(c=>{c&&(o?(n.push(c),o>0&&n.length>=o&&(f(n),n=[])):f(c))},c=>{f(c)},(c,a)=>{n.length&&f(n),c?i(c):s(a)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,o){return r.then(f,o)}catch(f){return this.then(void 0,f)}finally(f){return r.finally(f)}}}}e.SearchService=p,p.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(u){return(0,k.basename)(u.relativePath)}getItemDescription(u){return(0,k.dirname)(u.relativePath)}getItemPath(u){return u.relativePath}};function F(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(y),extraFileResources:u.extraFileResources&&u.extraFileResources.map(r=>P.URI.revive(r))}}function y(u){return{...u,folder:P.URI.revive(u.folder)}}}),define(pe[286],ve([0,1,6,10,2,30,11,26,14,73,65,31,285,283,91,136]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends P.ExtHostSearch{constructor(y,u,r,f){super(y,r,f);this._pfs=D,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new w.RipgrepSearchProvider(o)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const y=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new w.RipgrepSearchProvider(y)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(y,u){const r=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(y)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(y,u,r,f){const o=(0,P.reviveQuery)(r);return y===this._internalFileSearchHandle?this.doInternalFileSearch(y,u,o,f):super.$provideFileSearchResults(y,u,r,f)}doInternalFileSearch(y,u,r,f){const o=S=>{if((0,C.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(y,u,S.map(s=>I.URI.file(s.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,o,f)}$clearCache(y){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(y),super.$clearCache(y)}createTextSearchManager(y,u){return new g.NativeTextSearchManager(y,u,void 0,"textSearchProvider")}};E=je([ze(0,_.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,R.IURITransformerService),ze(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(pe[138],ve([0,1,298,125,81,22,16,3,6,9,12,33,106,107,299]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(v,b=""){this.debugLabel=b,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(v,b){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,b)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const b=A=>{this.traceSocketEvent("read",A),v(D.VSBuffer.wrap(A))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(v){const b=A=>{this.traceSocketEvent("close",{hadError:A}),v({type:0,hadError:A,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(v){const b=()=>{this.traceSocketEvent("nodeEndReceived"),v()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(v){if(!this.socket.destroyed)try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,T.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,T.onUnexpectedError)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var E;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var F;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(F||(F={}));class y extends _.Disposable{constructor(v,b,A,O){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:A?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new u(this,b,A,O,this._onData,(N,L)=>this._write(N,L))),this._register(this._flowManager.onError(N=>{console.error(N),(0,T.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(v,b){this.socket.traceSocketEvent(v,b)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._flowManager.writeMessage(v)}_write(v,b){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let A=2;v.byteLength<126?A+=0:v.byteLength<2**16?A+=2:A+=8;const O=D.VSBuffer.alloc(A);if(b?O.writeUInt8(194,0):O.writeUInt8(130,0),v.byteLength<126)O.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(v.byteLength>>>8&255,++N),O.writeUInt8(v.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(v.byteLength>>>24&255,++N),O.writeUInt8(v.byteLength>>>16&255,++N),O.writeUInt8(v.byteLength>>>8&255,++N),O.writeUInt8(v.byteLength>>>0&255,++N)}this.socket.write(D.VSBuffer.concat([O,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),A=b.readUInt8(0),O=(A&128)>>>7,N=(A&64)>>>6,L=b.readUInt8(1),M=(L&128)>>>7,V=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),A=b.readUInt8(1),O=(A&128)>>>7;let N=A&127,L=1;N===126?N=b.readUInt8(++L)*2**8+b.readUInt8(++L):N===127&&(N=b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*0+b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L));let M=0;O&&(M=b.readUInt8(++L)*2**24+b.readUInt8(++L)*2**16+b.readUInt8(++L)*2**8+b.readUInt8(++L)),this._state.state=3,this._state.readLen=N,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),o(b,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class u extends _.Disposable{constructor(v,b,A,O,N,L){super();this._tracer=v,this._onData=N,this._writeFn=L,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new r(this._tracer,O,A,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(v){this._writeQueue.push(v),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const v=this._writeQueue.shift();if(this._zlibDeflateStream){const b=await this._deflateMessage(this._zlibDeflateStream,v);this._writeFn(b,!0)}else this._writeFn(v,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(v,b){return new Promise((A,O)=>{v.write(b),v.flush(N=>A(N))})}acceptFrame(v,b,A){this._readQueue.push({data:v,isCompressed:b,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const v=this._readQueue.shift();if(this._zlibInflateStream&&v.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,v.data,v.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(v.data)}this._isProcessingReadQueue=!1}}_inflateFrame(v,b,A){return new Promise((O,N)=>{v.write(b),A&&v.write(D.VSBuffer.fromByteArray([0,0,255,255])),v.flush(L=>O(L))})}}class r extends _.Disposable{constructor(v,b,A,O){super();this._tracer=v,this._recordInflateBytes=b,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(O),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(D.VSBuffer.wrap(N))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(v){this._recordInflateBytes&&this._recordedInflateBytes.push(v.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",v),this._zlibInflate.write(v.buffer)}flush(v){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const b=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,v(b)})}}class f extends _.Disposable{constructor(v,b){super();this._tracer=v,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(D.VSBuffer.wrap(A))})}write(v){this._tracer.traceSocketEvent("zlibDeflateWrite",v.buffer),this._zlibDeflate.write(v.buffer)}flush(v){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let b=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),v(b)})}}function o(d,v){if(v===0)return;let b=d.byteLength>>>2;for(let V=0;V<b;V++){const H=d.readUInt32BE(V*4);d.writeUInt32BE(H^v,V*4)}let A=b*4,O=d.byteLength-A;const N=v>>>24&255,L=v>>>16&255,M=v>>>8&255;O>=1&&d.writeUInt8(d.readUInt8(A)^N,A),O>=2&&d.writeUInt8(d.readUInt8(A+1)^L,A+1),O>=3&&d.writeUInt8(d.readUInt8(A+2)^M,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function s(){const d=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):v=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${d}.sock`),n(v),v}e.createRandomIPCHandle=s;function i(d,v,b){const A=(0,m.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${b}-${v}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${b}-${v}.sock`):O=(0,P.join)(d,`${b}-${v}.sock`),n(O),O}e.createStaticIPCHandle=i;function n(d){const v=S[R.platform];typeof v=="number"&&d.length>=v&&console.warn(`WARNING: IPC handle "${d}" is longer than ${v} chars, try a shorter --user-data-dir`)}class c extends l.IPCServer{constructor(v){super(c.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const b=k.Event.fromNodeEventEmitter(v,"connection");return k.Event.map(b,A=>({protocol:new w.Protocol(new g(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function a(d){return new Promise((v,b)=>{const A=(0,t.createServer)();A.on("error",b),A.listen(d,()=>{A.removeListener("error",b),v(new c(A))})})}e.serve=a;function h(d,v){return new Promise((b,A)=>{const O=(0,t.createConnection)(d,()=>{O.removeListener("error",A),b(w.Client.fromSocket(new g(O,`ipc-client${v}`),v))});O.once("error",A)})}e.connect=h}),define(pe[287],ve([0,1,138,282,60,38,2,198,11]),function(Z,e,m,t,I,D,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,w,p){this._commands=l,this.logService=w,this._ipcHandlePath=p,this._server=t.createServer((g,E)=>this.onRequest(g,E)),this.setup().catch(g=>(w.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,w){const p=[];l.setEncoding("utf8"),l.on("data",g=>p.push(g)),l.on("end",()=>{const g=JSON.parse(p.join(""));switch(g.type){case"open":this.open(g,w);break;case"openExternal":this.openExternal(g,w);break;case"status":this.getStatus(g,w);break;case"extensionManagement":this.manageExtensions(g,w).catch(this.logService.error);break;default:w.writeHead(404),w.write(`Unknown message type: ${g.type}`,E=>{E&&this.logService.error(E)}),w.end();break}})}open(l,w){const{fileURIs:p,folderURIs:g,forceNewWindow:E,diffMode:F,addMode:y,forceReuseWindow:u,gotoLineMode:r,waitMarkerFilePath:f,remoteAuthority:o}=l,S=[];if(Array.isArray(g))for(const c of g)try{S.push({folderUri:T.URI.parse(c)})}catch{}if(Array.isArray(p))for(const c of p)try{(0,k.hasWorkspaceFileExtension)(c)?S.push({workspaceUri:T.URI.parse(c)}):S.push({fileUri:T.URI.parse(c)})}catch{}const s=f?T.URI.file(f):void 0,n={forceNewWindow:E,diffMode:F,addMode:y,gotoLineMode:r,forceReuseWindow:u,preferNewWindow:!u&&!s&&!y,waitMarkerFileURI:s,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),w.writeHead(200),w.end()}async openExternal(l,w){for(const p of l.uris){const g=T.URI.parse(p),E=g.scheme==="file"?g:p;await this._commands.executeCommand("_remoteCLI.openExternal",E)}w.writeHead(200),w.end()}async manageExtensions(l,w){try{const p=F=>F?.map(y=>/\.vsix$/i.test(y)?T.URI.parse(y):y),g={list:l.list,install:p(l.install),uninstall:p(l.uninstall),force:l.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);w.writeHead(200),w.write(E)}catch(p){w.writeHead(500),w.write(String(p),g=>{g&&this.logService.error(g)})}w.end()}async getStatus(l,w){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");w.writeHead(200),w.write(p),w.end()}catch(p){w.writeHead(500),w.write(String(p),g=>{g&&this.logService.error(g)}),w.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let R=class extends P{constructor(l,w){super(l,w,(0,m.createRandomIPCHandle)())}};R=je([ze(0,D.IExtHostCommands),ze(1,_.ILogService)],R),e.CLIServer=R}),define(pe[288],ve([0,1,72,280,268,5,281,39,258,2,10,7,287,105]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends I.RequireInterceptor{_installInterceptor(){const F=this,y=Z.__$__nodeRequire("module"),u=y._load;y._load=function(S,s,i){return S=f(S),F._factories.has(S)?F._factories.get(S).load(S,P.URI.file((0,w.realpathSync)(s.filename)),n=>u.apply(this,[n,s,i])):u.apply(this,arguments)};const r=y._resolveLookupPaths;y._resolveLookupPaths=(o,S)=>r.call(this,f(o),S);const f=o=>{for(let S of F._alternatives){let s=S(o);if(s){o=s;break}}return o}}}class g extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const F=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(p,F,this._registry).install(),m.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,f=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?r.apply(process,o):(f.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(F){return F.main}_loadCommonJSModule(F,y,u){if(y.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${y}', must be of file-scheme`);let r=null;u.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${y.toString(!0)}`),this._logService.flush();try{F&&m.mark(`code/extHost/willLoadExtensionCode/${F.value}`),r=Z.__$__nodeRequire(y.fsPath)}catch(f){return Promise.reject(f)}finally{F&&m.mark(`code/extHost/didLoadExtensionCode/${F.value}`),u.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(F){if(!!this._initData.remote.isRemote)for(const y in F){const u=F[y];u===null?delete process.env[y]:process.env[y]=u}}}e.ExtHostExtensionService=g}),define(pe[289],ve([0,1,61,261,270,269,286,288,262,54,39,73,71,34,51,68,260,259,11]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(y.ILoggerService,F.ExtHostLoggerService),(0,m.registerSingleton)(g.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,m.registerSingleton)(P.IExtHostDebugService,D.ExtHostDebugService),(0,m.registerSingleton)(C.IExtHostSearch,T.NativeExtHostSearch),(0,m.registerSingleton)(l.IExtHostTask,I.ExtHostTask),(0,m.registerSingleton)(w.IExtHostTerminalService,t.ExtHostTerminalService),(0,m.registerSingleton)(p.IExtHostTunnelService,_.ExtHostTunnelService)}),define(pe[290],ve([0,1,125,300,72,16,107,138,191,223,271,22,103,30,105,13,114,273,289]),function(Z,e,m,t,I,D,T,k,_,P,R,C,l,w,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const F=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=Z.__$__nodeRequire("module"),n=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const y=process.exit.bind(process);function u(i){process.exit=function(n){if(i)y(n);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let r=function(i){y()};function f(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let c=null,a=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,d=3e5,v=new g.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),b=new g.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),d);process.on("message",(O,N)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const L=C.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new k.NodeSocket(N,"extHost-socket");else{const V=C.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new k.WebSocketNodeSocket(new k.NodeSocket(N,"extHost-socket"),O.permessageDeflate,V,!1)}c?(v.cancel(),b.cancel(),c.beginAcceptReconnection(M,L),c.endAcceptReconnection(),c.sendResume()):(clearTimeout(a),c=new T.PersistentProtocol(M,L),c.sendResume(),c.onDidDispose(()=>r("renderer disconnected")),i(c),c.onSocketClose(()=>{v.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(b.isScheduled())return;v.isScheduled()&&b.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,c)=>{const a=m.createConnection(i,()=>{a.removeListener("error",c),n(new T.PersistentProtocol(new k.NodeSocket(a,"extHost-renderer")))});a.once("error",c),a.on("close",()=>{r("renderer closed the socket")})})}}async function o(){const i=await f();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function S(i){return new Promise(n=>{const c=i.onMessage(a=>{c.dispose();const h=JSON.parse(a.toString()),d=h.commit,v=_.default.commit;d&&v&&d!==v&&y(55);let b=0;setInterval(function(){try{process.kill(h.parentPid,0),b=0}catch(O){O&&O.code==="EPERM"?(b++,b>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let A;try{A=Z.__$__nodeRequire("native-watchdog"),A.start(h.parentPid)}catch(O){(0,D.onUnexpectedError)(O)}i.send((0,P.createMessageOfType)(0)),n({protocol:i,initData:h})});i.send((0,P.createMessageOfType)(1))})}async function s(){const i=[];process.on("unhandledRejection",(b,A)=>{i.push(A),setTimeout(()=>{const O=i.indexOf(A);O>=0&&A.catch(N=>{i.splice(O,1),(0,D.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),b&&(0,D.onUnexpectedError)(b))})},1e3)}),process.on("rejectionHandled",b=>{const A=i.indexOf(b);A>=0&&i.splice(A,1)}),process.on("uncaughtException",function(b){(0,D.onUnexpectedError)(b)}),I.mark("code/extHost/willConnectToRenderer");const n=await o();I.mark("code/extHost/didConnectToRenderer");const c=await S(n);I.mark("code/extHost/didWaitForInitData");const{initData:a}=c;u(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=!!F.useHostProxy,a.environment.skipWorkspaceStorageLock=(0,E.boolean)(F.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(A){y(A)}exists(A){return w.Promises.exists(A)}realpath(A){return(0,p.realpath)(A)}};let d=null;if(a.remote.authority&&F.uriTransformerPath)try{const A=Z.__$__nodeRequire(F.uriTransformerPath)(a.remote.authority);d=new l.URITransformer(A)}catch(b){console.error(b)}const v=new R.ExtensionHostMain(c.protocol,a,h,d);r=b=>v.terminate(b)}e.startExtensionHostProcess=s}),define(pe[301],ve([0,1,290]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23aa7ad51c95d90d48b1d352a316d7f0c2c4310d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
