/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],r=0,t=ee.length;r<t;r++)e[r]=ye[ee[r]];return e};define(ye[42],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(t,_){if(!t)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=r}),define(ye[52],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function r(P){return P?P.replace(/\$\((.*?)\)/g,(I,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=r;class t{constructor(I,D,T){this.id=I,this.definition=D,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function _(P,I){const D=["codicon","codicon-"+P];return I&&D.push("codicon-modifier-"+I),D}e.getClassNamesArray=_;var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function D(w){if(w instanceof t)return["codicon","codicon-"+w.id];const i=I.exec(w.id);if(!i)return D(t.error);let[,h,l]=i;const s=["codicon","codicon-"+h];return l&&s.push("codicon-modifier-"+l.substr(1)),s}P.asClassNameArray=D;function T(w){return D(w).join(" ")}P.asClassName=T;function R(w){return"."+D(w).join(".")}P.asCSSSelector=R})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ye[73],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function t(R){const w=[];for(let i in R)r.call(R,i)&&w.push(R[i]);return w}e.values=t;function _(R,w){for(let i in R)if(r.call(R,i)&&w({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=_;function A(R,w){const i=Object.create(null);for(const h of R){const l=w(h);let s=i[l];s||(s=i[l]=[]),s.push(h)}return i}e.groupBy=A;function P(R){const w=Object.create(null);return R&&R.forEach((i,h)=>{w[h]=i}),w}e.fromMap=P;function I(R,w){const i=[],h=[];for(let l of R)w.has(l)||i.push(l);for(let l of w)R.has(l)||h.push(l);return{removed:i,added:h}}e.diffSets=I;function D(R,w){const i=[],h=[];for(let[l,s]of R)w.has(l)||i.push(s);for(let[l,s]of w)R.has(l)||h.push(s);return{removed:i,added:h}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(w,i){let h=this.map.get(w);h||(h=new Set,this.map.set(w,h)),h.add(i)}delete(w,i){const h=this.map.get(w);!h||(h.delete(i),h.size===0&&this.map.delete(w))}forEach(w,i){const h=this.map.get(w);!h||h.forEach(i)}}e.SetMap=T}),define(ye[53],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(P){return(I,D,T)=>{let R=null,w=null;if(typeof T.value=="function"?(R="value",w=T.value):typeof T.get=="function"&&(R="get",w=T.get),!w)throw new Error("not supported");T[R]=P(w,D)}}e.createDecorator=r;function t(P,I,D){let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");const w=`$memoize$${I}`;D[T]=function(...i){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[w]}}e.memoize=t;function _(P,I,D){return r((T,R)=>{const w=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...h){this[i]||(this[i]=D?D():void 0),clearTimeout(this[w]),I&&(this[i]=I(this[i],...h),h=[this[i]]),this[w]=setTimeout(()=>{T.apply(this,h),this[i]=D?D():void 0},P)}})}e.debounce=_;function A(P,I,D){return r((T,R)=>{const w=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,h=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...s){if(this[i]||(this[i]=D?D():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[i]=I(this[i],...s)),this[l])return;const g=this[h]+P;g<=Date.now()?(this[h]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[h]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0},g-Date.now()))}})}e.throttle=A}),define(ye[54],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(ye[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(a){a.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function P(a,F=!1){let o=0,n=a.length,d="",p=0,c=16,m=0;function f(L){let W=0,x=0;for(;W<L;){const $=a.charCodeAt(o);if($>=48&&$<=57)x=x*16+$-48;else if($>=65&&$<=70)x=x*16+$-65+10;else if($>=97&&$<=102)x=x*16+$-97+10;else break;o++,W++}return W<L&&(x=-1),x}function E(L){o=L,d="",p=0,c=16,m=0}function v(){const L=o;if(a.charCodeAt(o)===48)o++;else for(o++;o<a.length&&T(a.charCodeAt(o));)o++;if(o<a.length&&a.charCodeAt(o)===46)if(o++,o<a.length&&T(a.charCodeAt(o)))for(o++;o<a.length&&T(a.charCodeAt(o));)o++;else return m=3,a.substring(L,o);let W=o;if(o<a.length&&(a.charCodeAt(o)===69||a.charCodeAt(o)===101))if(o++,(o<a.length&&a.charCodeAt(o)===43||a.charCodeAt(o)===45)&&o++,o<a.length&&T(a.charCodeAt(o))){for(o++;o<a.length&&T(a.charCodeAt(o));)o++;W=o}else m=3;return a.substring(L,W)}function k(){let L="",W=o;for(;;){if(o>=n){L+=a.substring(W,o),m=2;break}const x=a.charCodeAt(o);if(x===34){L+=a.substring(W,o),o++;break}if(x===92){if(L+=a.substring(W,o),o++,o>=n){m=2;break}switch(a.charCodeAt(o++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const q=f(4);q>=0?L+=String.fromCharCode(q):m=4;break}default:m=5}W=o;continue}if(x>=0&&x<=31)if(D(x)){L+=a.substring(W,o),m=2;break}else m=6;o++}return L}function U(){if(d="",m=0,p=o,o>=n)return p=n,c=17;let L=a.charCodeAt(o);if(I(L)){do o++,d+=String.fromCharCode(L),L=a.charCodeAt(o);while(I(L));return c=15}if(D(L))return o++,d+=String.fromCharCode(L),L===13&&a.charCodeAt(o)===10&&(o++,d+=`
`),c=14;switch(L){case 123:return o++,c=1;case 125:return o++,c=2;case 91:return o++,c=3;case 93:return o++,c=4;case 58:return o++,c=6;case 44:return o++,c=5;case 34:return o++,d=k(),c=10;case 47:{const W=o-1;if(a.charCodeAt(o+1)===47){for(o+=2;o<n&&!D(a.charCodeAt(o));)o++;return d=a.substring(W,o),c=12}if(a.charCodeAt(o+1)===42){o+=2;const x=n-1;let $=!1;for(;o<x;){if(a.charCodeAt(o)===42&&a.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,m=1),d=a.substring(W,o),c=13}return d+=String.fromCharCode(L),o++,c=16}case 45:if(d+=String.fromCharCode(L),o++,o===n||!T(a.charCodeAt(o)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=v(),c=11;default:for(;o<n&&N(L);)o++,L=a.charCodeAt(o);if(p!==o){switch(d=a.substring(p,o),d){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return d+=String.fromCharCode(L),o++,c=16}}function N(L){if(I(L)||D(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:E,getPosition:()=>o,scan:F?y:U,getToken:()=>c,getTokenValue:()=>d,getTokenOffset:()=>p,getTokenLength:()=>o-p,getTokenError:()=>m}}e.createScanner=P;function I(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function D(a){return a===10||a===13||a===8232||a===8233}function T(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function w(a,F){const o=[],n=new Object;let d;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(f,E,v,k){p.value=f,p.offset=E,p.length=v,p.type=k,p.colonOffset=void 0,d=p}try{b(a,{onObjectBegin:(f,E)=>{if(F<=f)throw n;d=void 0,c=F>f,o.push("")},onObjectProperty:(f,E,v)=>{if(F<E||(m(f,E,v,"property"),o[o.length-1]=f,F<=E+v))throw n},onObjectEnd:(f,E)=>{if(F<=f)throw n;d=void 0,o.pop()},onArrayBegin:(f,E)=>{if(F<=f)throw n;d=void 0,o.push(0)},onArrayEnd:(f,E)=>{if(F<=f)throw n;d=void 0,o.pop()},onLiteralValue:(f,E,v)=>{if(F<E||(m(f,E,v,S(f)),F<=E+v))throw n},onSeparator:(f,E,v)=>{if(F<=E)throw n;if(f===":"&&d&&d.type==="property")d.colonOffset=E,c=!1,d=void 0;else if(f===","){const k=o[o.length-1];typeof k=="number"?o[o.length-1]=k+1:(c=!0,o[o.length-1]=""),d=void 0}}})}catch(f){if(f!==n)throw f}return{path:o,previousNode:d,isAtPropertyKey:c,matches:f=>{let E=0;for(let v=0;E<f.length&&v<o.length;v++)if(f[E]===o[v]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}e.getLocation=w;function i(a,F=[],o=A.DEFAULT){let n=null,d=[];const p=[];function c(f){Array.isArray(d)?d.push(f):n!==null&&(d[n]=f)}return b(a,{onObjectBegin:()=>{const f={};c(f),p.push(d),d=f,n=null},onObjectProperty:f=>{n=f},onObjectEnd:()=>{d=p.pop()},onArrayBegin:()=>{const f=[];c(f),p.push(d),d=f,n=null},onArrayEnd:()=>{d=p.pop()},onLiteralValue:c,onError:(f,E,v)=>{F.push({error:f,offset:E,length:v})}},o),d[0]}e.parse=i;function h(a,F=[],o=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(f){n.type==="property"&&(n.length=f-n.offset,n=n.parent)}function p(f){return n.children.push(f),f}b(a,{onObjectBegin:f=>{n=p({type:"object",offset:f,length:-1,parent:n,children:[]})},onObjectProperty:(f,E,v)=>{n=p({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:f,offset:E,length:v,parent:n})},onObjectEnd:(f,E)=>{n.length=f+E-n.offset,n=n.parent,d(f+E)},onArrayBegin:(f,E)=>{n=p({type:"array",offset:f,length:-1,parent:n,children:[]})},onArrayEnd:(f,E)=>{n.length=f+E-n.offset,n=n.parent,d(f+E)},onLiteralValue:(f,E,v)=>{p({type:S(f),offset:E,length:v,parent:n,value:f}),d(E+v)},onSeparator:(f,E,v)=>{n.type==="property"&&(f===":"?n.colonOffset=E:f===","&&d(E))},onError:(f,E,v)=>{F.push({error:f,offset:E,length:v})}},o);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=h;function l(a,F){if(!a)return;let o=a;for(let n of F)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let d=!1;for(const p of o.children)if(Array.isArray(p.children)&&p.children[0].value===n){o=p.children[1],d=!0;break}if(!d)return}else{const d=n;if(o.type!=="array"||d<0||!Array.isArray(o.children)||d>=o.children.length)return;o=o.children[d]}return o}e.findNodeAtLocation=l;function s(a){if(!a.parent||!a.parent.children)return[];const F=s(a.parent);if(a.parent.type==="property"){const o=a.parent.children[0].value;F.push(o)}else if(a.parent.type==="array"){const o=a.parent.children.indexOf(a);o!==-1&&F.push(o)}return F}e.getNodePath=s;function g(a){switch(a.type){case"array":return a.children.map(g);case"object":{const F=Object.create(null);for(let o of a.children){const n=o.children[1];n&&(F[o.children[0].value]=g(n))}return F}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=g;function M(a,F,o=!1){return F>=a.offset&&F<a.offset+a.length||o&&F===a.offset+a.length}e.contains=M;function C(a,F,o=!1){if(M(a,F,o)){const n=a.children;if(Array.isArray(n))for(let d=0;d<n.length&&n[d].offset<=F;d++){const p=C(n[d],F,o);if(p)return p}return a}}e.findNodeAtOffset=C;function b(a,F,o=A.DEFAULT){const n=P(a,!1);function d(pe){return pe?()=>pe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function p(pe){return pe?fe=>pe(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=d(F.onObjectBegin),m=p(F.onObjectProperty),f=d(F.onObjectEnd),E=d(F.onArrayBegin),v=d(F.onArrayEnd),k=p(F.onLiteralValue),U=p(F.onSeparator),N=d(F.onComment),y=p(F.onError),L=o&&o.disallowComments,W=o&&o.allowTrailingComma;function x(){for(;;){const pe=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:L||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(pe){case 12:case 13:L?$(10):N();break;case 16:$(1);break;case 15:case 14:break;default:return pe}}}function $(pe,fe=[],oe=[]){if(y(pe),fe.length+oe.length>0){let Ee=n.getToken();for(;Ee!==17;){if(fe.indexOf(Ee)!==-1){x();break}else if(oe.indexOf(Ee)!==-1)break;Ee=x()}}}function q(pe){const fe=n.getTokenValue();return pe?k(fe):m(fe),x(),!0}function ie(){switch(n.getToken()){case 11:{let pe=0;try{pe=JSON.parse(n.getTokenValue()),typeof pe!="number"&&($(2),pe=0)}catch{$(2)}k(pe);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return x(),!0}function se(){return n.getToken()!==10?($(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(U(":"),x(),be()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function X(){c(),x();let pe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(pe||$(4,[],[]),U(","),x(),n.getToken()===2&&W)break}else pe&&$(6,[],[]);se()||$(4,[],[2,5]),pe=!0}return f(),n.getToken()!==2?$(7,[2],[]):x(),!0}function ge(){E(),x();let pe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(pe||$(4,[],[]),U(","),x(),n.getToken()===4&&W)break}else pe&&$(6,[],[]);be()||$(4,[],[4,5]),pe=!0}return v(),n.getToken()!==4?$(8,[4],[]):x(),!0}function be(){switch(n.getToken()){case 3:return ge();case 1:return X();case 10:return q(!0);default:return ie()}}return x(),n.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):be()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function u(a,F){let o=P(a),n=[],d,p=0,c;do switch(c=o.getPosition(),d=o.scan(),d){case 12:case 13:case 17:p!==c&&n.push(a.substring(p,c)),F!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,F)),p=o.getPosition();break}while(d!==17);return n.join("")}e.stripComments=u;function S(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ae,De){for(var ve=0;ve<De.length;ve++){var te=De[ve];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Ae,te.key,te)}}function e(Ae,De,ve){return De&&ee(Ae.prototype,De),ve&&ee(Ae,ve),Ae}function r(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,te=new Array(De);ve<De;ve++)te[ve]=Ae[ve];return te}function _(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=r(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var te=0;return function(){return te>=Ae.length?{done:!0}:{done:!1,value:Ae[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ae){A.exports.defaults=Ae}A.exports={defaults:P(),getDefaults:P,changeDefaults:I};var D=/[&<>"']/,T=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(De){return i[De]};function l(Ae,De){if(De){if(D.test(Ae))return Ae.replace(T,h)}else if(R.test(Ae))return Ae.replace(w,h);return Ae}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Ae){return Ae.replace(s,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var M=/(^|[^\[])\^/g;function C(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(ne,ue){return ue=ue.source||ue,ue=ue.replace(M,"$1"),Ae=Ae.replace(ne,ue),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var b=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Ae,De,ve){if(Ae){var te;try{te=decodeURIComponent(g(ve)).replace(b,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}De&&!u.test(ve)&&(ve=d(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var a={},F=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(Ae,De){a[" "+Ae]||(F.test(Ae)?a[" "+Ae]=Ae+"/":a[" "+Ae]=f(Ae,"/",!0)),Ae=a[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(o,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(n,"$1")+De:Ae+De}var p={exec:function(){}};function c(Ae){for(var De=1,ve,te;De<arguments.length;De++){ve=arguments[De];for(te in ve)Object.prototype.hasOwnProperty.call(ve,te)&&(Ae[te]=ve[te])}return Ae}function m(Ae,De){var ve=Ae.replace(/\|/g,function(ue,me,Te){for(var ze=!1,Le=me;--Le>=0&&Te[Le]==="\\";)ze=!ze;return ze?"|":" |"}),te=ve.split(/ \|/),ne=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>De)te.splice(De);else for(;te.length<De;)te.push("");for(;ne<te.length;ne++)te[ne]=te[ne].trim().replace(/\\\|/g,"|");return te}function f(Ae,De,ve){var te=Ae.length;if(te===0)return"";for(var ne=0;ne<te;){var ue=Ae.charAt(te-ne-1);if(ue===De&&!ve)ne++;else if(ue!==De&&ve)ne++;else break}return Ae.substr(0,te-ne)}function E(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,te=0,ne=0;ne<ve;ne++)if(Ae[ne]==="\\")ne++;else if(Ae[ne]===De[0])te++;else if(Ae[ne]===De[1]&&(te--,te<0))return ne;return-1}function v(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var U={escape:l,unescape:g,edit:C,cleanUrl:S,resolveUrl:d,noopTest:p,merge:c,splitCells:m,rtrim:f,findClosingBracket:E,checkSanitizeDeprecation:v,repeatString:k},N=A.exports.defaults,y=U.rtrim,L=U.splitCells,W=U.escape,x=U.findClosingBracket;function $(Ae,De,ve,te){var ne=De.href,ue=De.title?W(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){te.state.inLink=!0;var Te={type:"link",raw:ve,href:ne,title:ue,text:me,tokens:te.inlineTokens(me,[])};return te.state.inLink=!1,Te}else return{type:"image",raw:ve,href:ne,title:ue,text:W(me)}}function q(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var te=ve[1];return De.split(`
`).map(function(ne){var ue=ne.match(/^\s+/);if(ue===null)return ne;var me=ue[0];return me.length>=te.length?ne.slice(te.length):ne}).join(`
`)}var ie=function(){function Ae(ve){this.options=ve||N}var De=Ae.prototype;return De.space=function(te){var ne=this.rules.block.newline.exec(te);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},De.code=function(te){var ne=this.rules.block.code.exec(te);if(ne){var ue=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:y(ue,`
`)}}},De.fences=function(te){var ne=this.rules.block.fences.exec(te);if(ne){var ue=ne[0],me=q(ue,ne[3]||"");return{type:"code",raw:ue,lang:ne[2]?ne[2].trim():ne[2],text:me}}},De.heading=function(te){var ne=this.rules.block.heading.exec(te);if(ne){var ue=ne[2].trim();if(/#$/.test(ue)){var me=y(ue,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ue=me.trim())}var Te={type:"heading",raw:ne[0],depth:ne[1].length,text:ue,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(te){var ne=this.rules.block.hr.exec(te);if(ne)return{type:"hr",raw:ne[0]}},De.blockquote=function(te){var ne=this.rules.block.blockquote.exec(te);if(ne){var ue=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},De.list=function(te){var ne=this.rules.block.list.exec(te);if(ne){var ue,me,Te,ze,Le,Ge,ot,at,Ne,ce,he=ne[1].trim(),re=he.length>1,V={type:"list",raw:"",ordered:re,start:re?+he.slice(0,-1):"",loose:!1,items:[]};he=re?"\\d{1,9}\\"+he.slice(-1):"\\"+he,this.options.pedantic&&(he=re?he:"[*+-]");for(var we=new RegExp("^( {0,3}"+he+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(ne=we.exec(te)));){Ne=ne[2].split(`
`),this.options.pedantic?(ze=2,ce=Ne[0].trimLeft()):(ze=ne[2].search(/[^ ]/),ze=ne[1].length+(ze>4?1:ze),ce=Ne[0].slice(ze-ne[1].length)),Ge=!1,ue=ne[0],!Ne[0]&&/^ *$/.test(Ne[1])&&(ue=ne[1]+Ne.slice(0,2).join(`
`)+`
`,V.loose=!0,Ne=[]);var Re=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<Ne.length;Le++){if(at=Ne[Le],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Re.test(at)){ue=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}if(!Ge){at.trim()||(Ge=!0),at.search(/[^ ]/)>=ze?ce+=`
`+at.slice(ze):ce+=`
`+at;continue}if(at.search(/[^ ]/)>=ze||!at.trim()){ce+=`
`+at.slice(ze);continue}else{ue=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}}V.loose||(ot?V.loose=!0:/\n *\n *$/.test(ue)&&(ot=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ce),me&&(Te=me[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),V.items.push({type:"list_item",raw:ue,task:!!me,checked:Te,loose:!1,text:ce}),V.raw+=ue,te=te.slice(ue.length)}V.items[V.items.length-1].raw=ue.trimRight(),V.items[V.items.length-1].text=ce.trimRight(),V.raw=V.raw.trimRight();var We=V.items.length;for(Le=0;Le<We;Le++)this.lexer.state.top=!1,V.items[Le].tokens=this.lexer.blockTokens(V.items[Le].text,[]),V.items[Le].tokens.some(function(He){return He.type==="space"})&&(V.loose=!0,V.items[Le].loose=!0);return V}},De.html=function(te){var ne=this.rules.block.html.exec(te);if(ne){var ue={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};return this.options.sanitize&&(ue.type="paragraph",ue.text=this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]),ue.tokens=[],this.lexer.inline(ue.text,ue.tokens)),ue}},De.def=function(te){var ne=this.rules.block.def.exec(te);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ue=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:ne[0],href:ne[2],title:ne[3]}}},De.table=function(te){var ne=this.rules.block.table.exec(te);if(ne){var ue={type:"table",header:L(ne[1]).map(function(ot){return{text:ot}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=ne[0];var me=ue.align.length,Te,ze,Le,Ge;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(ue.align[Te])?ue.align[Te]="right":/^ *:-+: *$/.test(ue.align[Te])?ue.align[Te]="center":/^ *:-+ *$/.test(ue.align[Te])?ue.align[Te]="left":ue.align[Te]=null;for(me=ue.rows.length,Te=0;Te<me;Te++)ue.rows[Te]=L(ue.rows[Te],ue.header.length).map(function(ot){return{text:ot}});for(me=ue.header.length,ze=0;ze<me;ze++)ue.header[ze].tokens=[],this.lexer.inlineTokens(ue.header[ze].text,ue.header[ze].tokens);for(me=ue.rows.length,ze=0;ze<me;ze++)for(Ge=ue.rows[ze],Le=0;Le<Ge.length;Le++)Ge[Le].tokens=[],this.lexer.inlineTokens(Ge[Le].text,Ge[Le].tokens);return ue}}},De.lheading=function(te){var ne=this.rules.block.lheading.exec(te);if(ne){var ue={type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.paragraph=function(te){var ne=this.rules.block.paragraph.exec(te);if(ne){var ue={type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.text=function(te){var ne=this.rules.block.text.exec(te);if(ne){var ue={type:"text",raw:ne[0],text:ne[0],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.escape=function(te){var ne=this.rules.inline.escape.exec(te);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},De.tag=function(te){var ne=this.rules.inline.tag.exec(te);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},De.link=function(te){var ne=this.rules.inline.link.exec(te);if(ne){var ue=ne[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var me=y(ue.slice(0,-1),"\\");if((ue.length-me.length)%2==0)return}else{var Te=x(ne[2],"()");if(Te>-1){var ze=ne[0].indexOf("!")===0?5:4,Le=ze+ne[1].length+Te;ne[2]=ne[2].substring(0,Te),ne[0]=ne[0].substring(0,Le).trim(),ne[3]=""}}var Ge=ne[2],ot="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ge);at&&(Ge=at[1],ot=at[3])}else ot=ne[3]?ne[3].slice(1,-1):"";return Ge=Ge.trim(),/^</.test(Ge)&&(this.options.pedantic&&!/>$/.test(ue)?Ge=Ge.slice(1):Ge=Ge.slice(1,-1)),$(ne,{href:Ge&&Ge.replace(this.rules.inline._escapes,"$1"),title:ot&&ot.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},De.reflink=function(te,ne){var ue;if((ue=this.rules.inline.reflink.exec(te))||(ue=this.rules.inline.nolink.exec(te))){var me=(ue[2]||ue[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var Te=ue[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(ue,me,ue[0],this.lexer)}},De.emStrong=function(te,ne,ue){ue===void 0&&(ue="");var me=this.rules.inline.emStrong.lDelim.exec(te);if(!!me&&!(me[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(ue===""||this.rules.inline.punctuation.exec(ue))){var ze=me[0].length-1,Le,Ge,ot=ze,at=0,Ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,ne=ne.slice(-1*te.length+ze);(me=Ne.exec(ne))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ge=Le.length,me[3]||me[4]){ot+=Ge;continue}else if((me[5]||me[6])&&ze%3&&!((ze+Ge)%3)){at+=Ge;continue}if(ot-=Ge,!(ot>0)){if(Ge=Math.min(Ge,Ge+ot+at),Math.min(ze,Ge)%2){var ce=te.slice(1,ze+me.index+Ge);return{type:"em",raw:te.slice(0,ze+me.index+Ge+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var he=te.slice(2,ze+me.index+Ge-1);return{type:"strong",raw:te.slice(0,ze+me.index+Ge+1),text:he,tokens:this.lexer.inlineTokens(he,[])}}}}}},De.codespan=function(te){var ne=this.rules.inline.code.exec(te);if(ne){var ue=ne[2].replace(/\n/g," "),me=/[^ ]/.test(ue),Te=/^ /.test(ue)&&/ $/.test(ue);return me&&Te&&(ue=ue.substring(1,ue.length-1)),ue=W(ue,!0),{type:"codespan",raw:ne[0],text:ue}}},De.br=function(te){var ne=this.rules.inline.br.exec(te);if(ne)return{type:"br",raw:ne[0]}},De.del=function(te){var ne=this.rules.inline.del.exec(te);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2],[])}},De.autolink=function(te,ne){var ue=this.rules.inline.autolink.exec(te);if(ue){var me,Te;return ue[2]==="@"?(me=W(this.options.mangle?ne(ue[1]):ue[1]),Te="mailto:"+me):(me=W(ue[1]),Te=me),{type:"link",raw:ue[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(te,ne){var ue;if(ue=this.rules.inline.url.exec(te)){var me,Te;if(ue[2]==="@")me=W(this.options.mangle?ne(ue[0]):ue[0]),Te="mailto:"+me;else{var ze;do ze=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(ze!==ue[0]);me=W(ue[0]),ue[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:ue[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(te,ne){var ue=this.rules.inline.text.exec(te);if(ue){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):W(ue[0]):ue[0]:me=W(this.options.smartypants?ne(ue[0]):ue[0]),{type:"text",raw:ue[0],text:me}}},Ae}(),se=U.noopTest,X=U.edit,ge=U.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:se,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=X(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=X(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=X(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=X(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=X(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=X(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=ge({},be),be.gfm=ge({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=X(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=ge({},be.normal,{html:X(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:se,paragraph:X(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var pe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:se,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:se,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};pe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",pe.punctuation=X(pe.punctuation).replace(/punctuation/g,pe._punctuation).getRegex(),pe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,pe.escapedEmSt=/\\\*|\\_/g,pe._comment=X(be._comment).replace("(?:-->|$)","-->").getRegex(),pe.emStrong.lDelim=X(pe.emStrong.lDelim).replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimAst=X(pe.emStrong.rDelimAst,"g").replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimUnd=X(pe.emStrong.rDelimUnd,"g").replace(/punct/g,pe._punctuation).getRegex(),pe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,pe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,pe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,pe.autolink=X(pe.autolink).replace("scheme",pe._scheme).replace("email",pe._email).getRegex(),pe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,pe.tag=X(pe.tag).replace("comment",pe._comment).replace("attribute",pe._attribute).getRegex(),pe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,pe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,pe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,pe.link=X(pe.link).replace("label",pe._label).replace("href",pe._href).replace("title",pe._title).getRegex(),pe.reflink=X(pe.reflink).replace("label",pe._label).getRegex(),pe.reflinkSearch=X(pe.reflinkSearch,"g").replace("reflink",pe.reflink).replace("nolink",pe.nolink).getRegex(),pe.normal=ge({},pe),pe.pedantic=ge({},pe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:X(/^!?\[(label)\]\((.*?)\)/).replace("label",pe._label).getRegex(),reflink:X(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",pe._label).getRegex()}),pe.gfm=ge({},pe.normal,{escape:X(pe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),pe.gfm.url=X(pe.gfm.url,"i").replace("email",pe.gfm._extended_email).getRegex(),pe.breaks=ge({},pe.gfm,{br:X(pe.br).replace("{2,}","*").getRegex(),text:X(pe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:be,inline:pe},oe=ie,Ee=A.exports.defaults,Pe=fe.block,Oe=fe.inline,je=U.repeatString;function st(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function et(Ae){var De="",ve,te,ne=Ae.length;for(ve=0;ve<ne;ve++)te=Ae.charCodeAt(ve),Math.random()>.5&&(te="x"+te.toString(16)),De+="&#"+te+";";return De}var tt=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Pe.normal,inline:Oe.normal};this.options.pedantic?(te.block=Pe.pedantic,te.inline=Oe.pedantic):this.options.gfm&&(te.block=Pe.gfm,this.options.breaks?te.inline=Oe.breaks:te.inline=Oe.gfm),this.tokenizer.rules=te}Ae.lex=function(te,ne){var ue=new Ae(ne);return ue.lex(te)},Ae.lexInline=function(te,ne){var ue=new Ae(ne);return ue.inlineTokens(te)};var De=Ae.prototype;return De.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},De.blockTokens=function(te,ne){var ue=this;ne===void 0&&(ne=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var me,Te,ze,Le;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ot){return(me=ot.call({lexer:ue},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.space(te)){te=te.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(me=this.tokenizer.fences(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.list(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.html(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.def(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(ze=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var ot=1/0,at=te.slice(1),Ne=void 0;ue.options.extensions.startBlock.forEach(function(ce){Ne=ce.call({lexer:this},at),typeof Ne=="number"&&Ne>=0&&(ot=Math.min(ot,Ne))}),ot<1/0&&ot>=0&&(ze=te.substring(0,ot+1))}(),this.state.top&&(me=this.tokenizer.paragraph(ze))){Te=ne[ne.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me),Le=ze.length!==te.length,te=te.substring(me.raw.length);continue}if(me=this.tokenizer.text(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(te){var Ge="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return this.state.top=!0,ne},De.inline=function(te,ne){this.inlineQueue.push({src:te,tokens:ne})},De.inlineTokens=function(te,ne){var ue=this;ne===void 0&&(ne=[]);var me,Te,ze,Le=te,Ge,ot,at;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(Ge=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)Ne.includes(Ge[0].slice(Ge[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ge=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ge=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(ot||(at=""),ot=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(me=he.call({lexer:ue},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.escape(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.tag(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.link(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.emStrong(te,Le,at)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.codespan(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.br(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.del(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.autolink(te,et)){te=te.substring(me.raw.length),ne.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(te,et))){te=te.substring(me.raw.length),ne.push(me);continue}if(ze=te,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,re=te.slice(1),V=void 0;ue.options.extensions.startInline.forEach(function(we){V=we.call({lexer:this},re),typeof V=="number"&&V>=0&&(he=Math.min(he,V))}),he<1/0&&he>=0&&(ze=te.substring(0,he+1))}(),me=this.tokenizer.inlineText(ze,st)){te=te.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(at=me.raw.slice(-1)),ot=!0,Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(te){var ce="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return ne},e(Ae,null,[{key:"rules",get:function(){return{block:Pe,inline:Oe}}}]),Ae}(),z=A.exports.defaults,K=U.cleanUrl,H=U.escape,j=function(){function Ae(ve){this.options=ve||z}var De=Ae.prototype;return De.code=function(te,ne,ue){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(te,me);Te!=null&&Te!==te&&(ue=!0,te=Te)}return te=te.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+H(me,!0)+'">'+(ue?te:H(te,!0))+`</code></pre>
`:"<pre><code>"+(ue?te:H(te,!0))+`</code></pre>
`},De.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},De.html=function(te){return te},De.heading=function(te,ne,ue,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(ue)+'">'+te+"</h"+ne+`>
`:"<h"+ne+">"+te+"</h"+ne+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(te,ne,ue){var me=ne?"ol":"ul",Te=ne&&ue!==1?' start="'+ue+'"':"";return"<"+me+Te+`>
`+te+"</"+me+`>
`},De.listitem=function(te){return"<li>"+te+`</li>
`},De.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(te){return"<p>"+te+`</p>
`},De.table=function(te,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ne+`</table>
`},De.tablerow=function(te){return`<tr>
`+te+`</tr>
`},De.tablecell=function(te,ne){var ue=ne.header?"th":"td",me=ne.align?"<"+ue+' align="'+ne.align+'">':"<"+ue+">";return me+te+"</"+ue+`>
`},De.strong=function(te){return"<strong>"+te+"</strong>"},De.em=function(te){return"<em>"+te+"</em>"},De.codespan=function(te){return"<code>"+te+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(te){return"<del>"+te+"</del>"},De.link=function(te,ne,ue){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return ue;var me='<a href="'+H(te)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+ue+"</a>",me},De.image=function(te,ne,ue){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return ue;var me='<img src="'+te+'" alt="'+ue+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(te){return te},Ae}(),Y=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(te){return te},De.em=function(te){return te},De.codespan=function(te){return te},De.del=function(te){return te},De.html=function(te){return te},De.text=function(te){return te},De.link=function(te,ne,ue){return""+ue},De.image=function(te,ne,ue){return""+ue},De.br=function(){return""},Ae}(),ae=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(te,ne){var ue=te,me=0;if(this.seen.hasOwnProperty(ue)){me=this.seen[te];do me++,ue=te+"-"+me;while(this.seen.hasOwnProperty(ue))}return ne||(this.seen[te]=me,this.seen[ue]=0),ue},De.slug=function(te,ne){ne===void 0&&(ne={});var ue=this.serialize(te);return this.getNextSafeSlug(ue,ne.dryrun)},Ae}(),Se=j,Ue=Y,Ve=ae,Qe=A.exports.defaults,nt=U.unescape,rt=function(){function Ae(ve){this.options=ve||Qe,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ue,this.slugger=new Ve}Ae.parse=function(te,ne){var ue=new Ae(ne);return ue.parse(te)},Ae.parseInline=function(te,ne){var ue=new Ae(ne);return ue.parseInline(te)};var De=Ae.prototype;return De.parse=function(te,ne){ne===void 0&&(ne=!0);var ue="",me,Te,ze,Le,Ge,ot,at,Ne,ce,he,re,V,we,Re,We,He,mt,Et,_t,dt=te.length;for(me=0;me<dt;me++){if(he=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(_t=this.options.extensions.renderers[he.type].call({parser:this},he),_t!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){ue+=_t||"";continue}switch(he.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(he.tokens),he.depth,nt(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(Ne="",at="",Le=he.header.length,Te=0;Te<Le;Te++)at+=this.renderer.tablecell(this.parseInline(he.header[Te].tokens),{header:!0,align:he.align[Te]});for(Ne+=this.renderer.tablerow(at),ce="",Le=he.rows.length,Te=0;Te<Le;Te++){for(ot=he.rows[Te],at="",Ge=ot.length,ze=0;ze<Ge;ze++)at+=this.renderer.tablecell(this.parseInline(ot[ze].tokens),{header:!1,align:he.align[ze]});ce+=this.renderer.tablerow(at)}ue+=this.renderer.table(Ne,ce);continue}case"blockquote":{ce=this.parse(he.tokens),ue+=this.renderer.blockquote(ce);continue}case"list":{for(re=he.ordered,V=he.start,we=he.loose,Le=he.items.length,ce="",Te=0;Te<Le;Te++)We=he.items[Te],He=We.checked,mt=We.task,Re="",We.task&&(Et=this.renderer.checkbox(He),we?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Et+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Et+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Et}):Re+=Et),Re+=this.parse(We.tokens,we),ce+=this.renderer.listitem(Re,mt,He);ue+=this.renderer.list(ce,re,V);continue}case"html":{ue+=this.renderer.html(he.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ce=he.tokens?this.parseInline(he.tokens):he.text;me+1<dt&&te[me+1].type==="text";)he=te[++me],ce+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);ue+=ne?this.renderer.paragraph(ce):ce;continue}default:{var vt='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return ue},De.parseInline=function(te,ne){ne=ne||this.renderer;var ue="",me,Te,ze,Le=te.length;for(me=0;me<Le;me++){if(Te=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(ze=this.options.extensions.renderers[Te.type].call({parser:this},Te),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){ue+=ze||"";continue}switch(Te.type){case"escape":{ue+=ne.text(Te.text);break}case"html":{ue+=ne.html(Te.text);break}case"link":{ue+=ne.link(Te.href,Te.title,this.parseInline(Te.tokens,ne));break}case"image":{ue+=ne.image(Te.href,Te.title,Te.text);break}case"strong":{ue+=ne.strong(this.parseInline(Te.tokens,ne));break}case"em":{ue+=ne.em(this.parseInline(Te.tokens,ne));break}case"codespan":{ue+=ne.codespan(Te.text);break}case"br":{ue+=ne.br();break}case"del":{ue+=ne.del(this.parseInline(Te.tokens,ne));break}case"text":{ue+=ne.text(Te.text);break}default:{var Ge='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}}return ue},Ae}(),Je=tt,Ze=rt,pt=ie,Fe=j,At=Y,G=ae,Q=U.merge,de=U.checkSanitizeDeprecation,Be=U.escape,qe=A.exports.getDefaults,lt=A.exports.changeDefaults,ht=A.exports.defaults;function Ye(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=Q({},Ye.defaults,De||{}),de(De),ve){var te=De.highlight,ne;try{ne=Je.lex(Ae,De)}catch(ze){return ve(ze)}var ue=function(Le){var Ge;if(!Le)try{De.walkTokens&&Ye.walkTokens(ne,De.walkTokens),Ge=Ze.parse(ne,De)}catch(ot){Le=ot}return De.highlight=te,Le?ve(Le):ve(null,Ge)};if(!te||te.length<3||(delete De.highlight,!ne.length))return ue();var me=0;Ye.walkTokens(ne,function(ze){ze.type==="code"&&(me++,setTimeout(function(){te(ze.text,ze.lang,function(Le,Ge){if(Le)return ue(Le);Ge!=null&&Ge!==ze.text&&(ze.text=Ge,ze.escaped=!0),me--,me===0&&ue()})},0))}),me===0&&ue();return}try{var Te=Je.lex(Ae,De);return De.walkTokens&&Ye.walkTokens(Te,De.walkTokens),Ze.parse(Te,De)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(ze.message+"",!0)+"</pre>";throw ze}}Ye.options=Ye.setOptions=function(Ae){return Q(Ye.defaults,Ae),lt(Ye.defaults),Ye},Ye.getDefaults=qe,Ye.defaults=ht,Ye.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),te=0;te<De;te++)ve[te]=arguments[te];var ne=Q.apply(void 0,[{}].concat(ve)),ue=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ge=ue.renderers?ue.renderers[Le.name]:null;Ge?ue.renderers[Le.name]=function(){for(var ot=arguments.length,at=new Array(ot),Ne=0;Ne<ot;Ne++)at[Ne]=arguments[Ne];var ce=Le.renderer.apply(this,at);return ce===!1&&(ce=Ge.apply(this,at)),ce}:ue.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[Le.level]?ue[Le.level].unshift(Le.tokenizer):ue[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ue.startBlock?ue.startBlock.push(Le.start):ue.startBlock=[Le.start]:Le.level==="inline"&&(ue.startInline?ue.startInline.push(Le.start):ue.startInline=[Le.start]))}Le.childTokens&&(ue.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Ye.defaults.renderer||new Fe,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var he=arguments.length,re=new Array(he),V=0;V<he;V++)re[V]=arguments[V];var we=Te.renderer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.renderer)Ge(ot);ne.renderer=Le}(),Te.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var he=arguments.length,re=new Array(he),V=0;V<he;V++)re[V]=arguments[V];var we=Te.tokenizer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.tokenizer)Ge(ot);ne.tokenizer=Le}(),Te.walkTokens){var ze=Ye.defaults.walkTokens;ne.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),ze&&ze(Le)}}me&&(ne.extensions=ue),Ye.setOptions(ne)})},Ye.walkTokens=function(Ae,De){for(var ve=function(){var me=ne.value;switch(De(me),me.type){case"table":{for(var Te=_(me.header),ze;!(ze=Te()).done;){var Le=ze.value;Ye.walkTokens(Le.tokens,De)}for(var Ge=_(me.rows),ot;!(ot=Ge()).done;)for(var at=ot.value,Ne=_(at),ce;!(ce=Ne()).done;){var he=ce.value;Ye.walkTokens(he.tokens,De)}break}case"list":{Ye.walkTokens(me.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(re){Ye.walkTokens(me[re],De)}):me.tokens&&Ye.walkTokens(me.tokens,De)}},te=_(Ae),ne;!(ne=te()).done;)ve()},Ye.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Ye.defaults,De||{}),de(De);try{var ve=Je.lexInline(Ae,De);return De.walkTokens&&Ye.walkTokens(ve,De.walkTokens),Ze.parseInline(ve,De)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(te.message+"",!0)+"</pre>";throw te}},Ye.Parser=Ze,Ye.parser=Ze.parse,Ye.Renderer=Fe,Ye.TextRenderer=At,Ye.Lexer=Je,Ye.lexer=Je.lex,Ye.Tokenizer=pt,Ye.Slugger=G,Ye.parse=Ye;var kt=Ye;return kt}),define(ye[100],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(I,D,T){return Math.min(Math.max(I,D),T)}e.clamp=r;function t(I,D){return(D+I%D)%D}e.rot=t;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class P{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const T=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=P}),function(){function ee(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function P(D){A.push(D,Date.now())}function I(){const D=[];for(let T=0;T<A.length;T+=2)D.push({name:A[T],startTime:A[T+1]});return D}return{mark:P,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(_+P.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function r(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=r(t))}(),define(ye[74],_e([0,1,17]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(w){w.text="text/plain",w.binary="application/octet-stream",w.unknown="application/unknown",w.markdown="text/markdown",w.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(w){const i=(0,r.extname)(w),h=_[i.toLowerCase()];return h!==void 0?h:I(w)}e.getMediaOrTextMime=P;function I(w){const i=(0,r.extname)(w);return A[i.toLowerCase()]}e.getMediaMime=I;function D(w){for(const i in A)if(A[i]===w)return i}e.getExtensionForMimeType=D;const T=/^(.+)\/(.+?)(;.+)?$/;function R(w,i){const h=T.exec(w);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:i?void 0:w}e.normalizeMimeType=R}),define(ye[101],_e([0,1,15,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=_;function A(b){const u=b;return u?_(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(b,u){return new I(b,u)}e.newWriteableStream=P;class I{constructor(u,S){this.reducer=u,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(S=>S(u))}emitError(u){this.listeners.error.length===0?(0,r.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(S=>S(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,S){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(u,S){if(this.state.destroyed)return;let a;switch(u){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const F=a.indexOf(S);F>=0&&a.splice(F,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(b,u){const S=[];let a;for(;(a=b.read())!==null;)S.push(a);return u(S)}e.consumeReadable=D;function T(b,u,S){const a=[];let F;for(;(F=b.read())!==null&&a.length<S;)a.push(F);return F===null&&a.length>0?u(a):{read:()=>{if(a.length>0)return a.shift();if(typeof F!="undefined"){const o=F;return F=void 0,o}return b.read()}}}e.peekReadable=T;function R(b,u){return new Promise((S,a)=>{const F=[];w(b,{onData:o=>{u&&F.push(o)},onError:o=>{u?a(o):S(void 0)},onEnd:()=>{S(u?u(F):void 0)}})})}e.consumeStream=R;function w(b,u){let S=!1;return b.on("error",a=>{S||u.onError(a)}),b.on("end",()=>{S||u.onEnd()}),b.on("data",a=>{S||u.onData(a)}),(0,t.toDisposable)(()=>S=!0)}e.listenStream=w;function i(b,u){return new Promise((S,a)=>{const F=new t.DisposableStore,o=[],n=c=>{if(o.push(c),o.length>u)return F.dispose(),b.pause(),S({stream:b,buffer:o,ended:!1})},d=c=>a(c),p=()=>S({stream:b,buffer:o,ended:!0});F.add((0,t.toDisposable)(()=>b.removeListener("error",d))),b.on("error",d),F.add((0,t.toDisposable)(()=>b.removeListener("end",p))),b.on("end",p),F.add((0,t.toDisposable)(()=>b.removeListener("data",n))),b.on("data",n)})}e.peekStream=i;function h(b,u){const S=P(u);return S.end(b),S}e.toStream=h;function l(){const b=P(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=l;function s(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}e.toReadable=s;function g(b,u,S){const a=P(S);return w(b,{onData:F=>a.write(u.data(F)),onError:F=>a.error(u.error?u.error(F):F),onEnd:()=>a.end()}),a}e.transform=g;function M(b,u,S){let a=!1;return{read:()=>{const F=u.read();return a?F:(a=!0,F!==null?S([b,F]):b)}}}e.prefixedReadable=M;function C(b,u,S){let a=!1;const F=P(S);return w(u,{onData:o=>a?F.write(o):(a=!0,F.write(S([b,o]))),onError:o=>F.error(o),onEnd:()=>{a||(a=!0,F.write(b)),F.end()}}),F}e.prefixedStream=C}),define(ye[21],_e([0,1,101]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let _,A;class P{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return t?new P(Buffer.allocUnsafe(m)):new P(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new P(m)}static fromString(m,f){return!(f?.dontUseNodeBuffer||!1)&&t?new P(Buffer.from(m)):(_||(_=new TextEncoder),new P(_.encode(m)))}static fromByteArray(m){const f=P.alloc(m.length);for(let E=0,v=m.length;E<v;E++)f.buffer[E]=m[E];return f}static concat(m,f){if(typeof f=="undefined"){f=0;for(let k=0,U=m.length;k<U;k++)f+=m[k].byteLength}const E=P.alloc(f);let v=0;for(let k=0,U=m.length;k<U;k++){const N=m[k];E.set(N,v),v+=N.byteLength}return E}clone(){const m=P.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(m,f){return new P(this.buffer.subarray(m,f))}set(m,f){if(m instanceof P)this.buffer.set(m.buffer,f);else if(m instanceof Uint8Array)this.buffer.set(m,f);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),f);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(m){return T(this.buffer,m)}writeUInt32BE(m,f){R(this.buffer,m,f)}readUInt32LE(m){return w(this.buffer,m)}writeUInt32LE(m,f){i(this.buffer,m,f)}readUInt8(m){return h(this.buffer,m)}writeUInt8(m,f){l(this.buffer,m,f)}}e.VSBuffer=P;function I(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0}e.readUInt16LE=I;function D(c,m,f){c[f+0]=m&255,m=m>>>8,c[f+1]=m&255}e.writeUInt16LE=D;function T(c,m){return c[m]*2**24+c[m+1]*2**16+c[m+2]*2**8+c[m+3]}e.readUInt32BE=T;function R(c,m,f){c[f+3]=m,m=m>>>8,c[f+2]=m,m=m>>>8,c[f+1]=m,m=m>>>8,c[f]=m}e.writeUInt32BE=R;function w(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0|c[m+2]<<16>>>0|c[m+3]<<24>>>0}e.readUInt32LE=w;function i(c,m,f){c[f+0]=m&255,m=m>>>8,c[f+1]=m&255,m=m>>>8,c[f+2]=m&255,m=m>>>8,c[f+3]=m&255}e.writeUInt32LE=i;function h(c,m){return c[m]}e.readUInt8=h;function l(c,m,f){c[f]=m}e.writeUInt8=l;function s(c){return r.consumeReadable(c,m=>P.concat(m))}e.readableToBuffer=s;function g(c){return r.toReadable(c)}e.bufferToReadable=g;function M(c){return r.consumeStream(c,m=>P.concat(m))}e.streamToBuffer=M;async function C(c){return c.ended?P.concat(c.buffer):P.concat([...c.buffer,await M(c.stream)])}e.bufferedStreamToBuffer=C;function b(c){return r.toStream(c,m=>P.concat(m))}e.bufferToStream=b;function u(c){return r.transform(c,{data:m=>typeof m=="string"?P.fromString(m):P.wrap(m)},m=>P.concat(m))}e.streamToBufferReadableStream=u;function S(c){return r.newWriteableStream(m=>P.concat(m),c)}e.newWriteableBufferStream=S;function a(c,m){return r.prefixedReadable(c,m,f=>P.concat(f))}e.prefixedBufferReadable=a;function F(c,m){return r.prefixedStream(c,m,f=>P.concat(f))}e.prefixedBufferStream=F;function o(c){let m=0,f=0,E=0;const v=new Uint8Array(Math.floor(c.length/4*3)),k=N=>{switch(f){case 3:v[E++]=m|N,f=0;break;case 2:v[E++]=m|N>>>2,m=N<<6,f=3;break;case 1:v[E++]=m|N>>>4,m=N<<4,f=2;break;default:m=N<<2,f=1}};for(let N=0;N<c.length;N++){const y=c.charCodeAt(N);if(y>=65&&y<=90)k(y-65);else if(y>=97&&y<=122)k(y-97+26);else if(y>=48&&y<=57)k(y-48+52);else if(y===43||y===45)k(62);else if(y===47||y===95)k(63);else{if(y===61)break;throw new SyntaxError(`Unexpected base64 character ${c[N]}`)}}const U=E;for(;f>0;)k(0);return P.wrap(v).slice(0,U)}e.decodeBase64=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:c},m=!0,f=!1){const E=f?d:n;let v="";const k=c.byteLength%3;let U=0;for(;U<c.byteLength-k;U+=3){const N=c[U+0],y=c[U+1],L=c[U+2];v+=E[N>>>2],v+=E[(N<<4|y>>>4)&63],v+=E[(y<<2|L>>>6)&63],v+=E[L&63]}if(k===1){const N=c[U+0];v+=E[N>>>2],v+=E[N<<4&63],m&&(v+="==")}else if(k===2){const N=c[U+0],y=c[U+1];v+=E[N>>>2],v+=E[(N<<4|y>>>4)&63],v+=E[y<<2&63],m&&(v+="=")}return v}e.encodeBase64=p});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[22],_e([0,1,16,9]),function(ee,e,r,t){"use strict";var _,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(o,n,d){let p=o.get(n);return p===void 0&&(p=d,o.set(n,p)),p}e.getOrSet=I;function D(o){const n=[];return o.forEach((d,p)=>{n.push(`${p} => ${d}`)}),`Map(${o.size}) {${n.join(", ")}}`}e.mapToString=D;function T(o){const n=[];return o.forEach(d=>{n.push(d)}),`Set(${o.size}) {${n.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const d=n.charCodeAt(0),p=this._value.charCodeAt(this._pos);return d-p}value(){return this._value[this._pos]}}e.StringIterator=R;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class i{constructor(n=!0,d=!0){this._splitOnBackslash=n,this._caseSensitive=d}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let d=n.length-1;d>=0;d--,this._valueLen--){const p=this._value.charCodeAt(d);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var h;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(h||(h={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class s{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(g||(g={}));class M{constructor(n){this._iter=n}static forUris(n=()=>!1){return new M(new l(n))}static forPaths(n=!1){return new M(new i(void 0,!n))}static forStrings(){return new M(new R)}static forConfigKeys(){return new M(new w)}clear(){this._root=void 0}fill(n,d){if(d){const p=d.slice(0);(0,r.shuffle)(p);for(let c of p)this.set(c,n)}else{const p=n.slice(0);(0,r.shuffle)(p);for(let c of p)this.set(c[0],c[1])}}set(n,d){const p=this._iter.reset(n);let c;this._root||(this._root=new s,this._root.segment=p.value());const m=[];for(c=this._root;;){const E=p.cmp(c.segment);if(E>0)c.left||(c.left=new s,c.left.segment=p.value()),m.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new s,c.right.segment=p.value()),m.push([1,c]),c=c.right;else if(p.hasNext())p.next(),c.mid||(c.mid=new s,c.mid.segment=p.value()),m.push([0,c]),c=c.mid;else break}const f=c.value;c.value=d,c.key=n;for(let E=m.length-1;E>=0;E--){const v=m[E][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const U=m[E][0],N=m[E+1][0];if(U===1&&N===1)m[E][1]=v.rotateLeft();else if(U===-1&&N===-1)m[E][1]=v.rotateRight();else if(U===1&&N===-1)v.right=m[E+1][1]=m[E+1][1].rotateRight(),m[E][1]=v.rotateLeft();else if(U===-1&&N===1)v.left=m[E+1][1]=m[E+1][1].rotateLeft(),m[E][1]=v.rotateRight();else throw new Error;if(E>0)switch(m[E-1][0]){case-1:m[E-1][1].left=m[E][1];break;case 1:m[E-1][1].right=m[E][1];break;case 0:m[E-1][1].mid=m[E][1];break}else this._root=m[0][1]}}return f}get(n){return this._getNode(n)?.value}_getNode(n){const d=this._iter.reset(n);let p=this._root;for(;p;){const c=d.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(n){const d=this._getNode(n);return!(d?.value===void 0&&d?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,d){const p=this._iter.reset(n),c=[];let m=this._root;for(;m;){const f=p.cmp(m.segment);if(f>0)c.push([-1,m]),m=m.left;else if(f<0)c.push([1,m]),m=m.right;else if(p.hasNext())p.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this._min(m.right),{key:E,value:v,segment:k}=f;this._delete(f.key,!1),m.key=E,m.value=v,m.segment=k}else{const f=m.left??m.right;if(c.length>0){const[E,v]=c[c.length-1];switch(E){case-1:v.left=f;break;case 0:v.mid=f;break;case 1:v.right=f;break}}else this._root=f}for(let f=c.length-1;f>=0;f--){const E=c[f][1];E.updateHeight();const v=E.balanceFactor();if(v>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),c[f][1]=E.rotateLeft()):v<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),c[f][1]=E.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const d=this._iter.reset(n);let p=this._root,c;for(;p;){const m=d.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(d.hasNext())d.next(),c=p.value||c,p=p.mid;else break}return p&&p.value||c}findSuperstr(n){const d=this._iter.reset(n);let p=this._root;for(;p;){const c=d.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else return p.mid?this._entries(p.mid):void 0}}forEach(n){for(const[d,p]of this)n(p,d)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:n(d.left)&&n(d.right)};return n(this._root)}}e.TernarySearchTree=M;class C{constructor(n,d){this.uri=n,this.value=d}}class b{constructor(n,d){this[_]="ResourceMap",n instanceof b?(this.map=new Map(n.map),this.toKey=d??b.defaultToKey):(this.map=new Map,this.toKey=n??b.defaultToKey)}set(n,d){return this.map.set(this.toKey(n),new C(n,d)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,d){typeof d!="undefined"&&(n=n.bind(d));for(let[p,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=b,b.defaultToKey=o=>o.toString();var u;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class S{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,d=0){const p=this._map.get(n);if(!!p)return d!==0&&this.touch(p,d),p.value}set(n,d,p=0){let c=this._map.get(n);if(c)c.value=d,p!==0&&this.touch(c,p);else{switch(c={key:n,value:d,next:void 0,previous:void 0},p){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const d=this._map.get(n);if(!!d)return this._map.delete(n),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,d){const p=this._state;let c=this._head;for(;c;){if(d?n.bind(d)(c.value,c.key,this):n(c.value,c.key,this),this._state!==p)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,d=this._state;let p=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(p){const m={value:p.key,done:!1};return p=p.next,m}else return{value:void 0,done:!0}}};return c}values(){const n=this,d=this._state;let p=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(p){const m={value:p.value,done:!1};return p=p.next,m}else return{value:void 0,done:!0}}};return c}entries(){const n=this,d=this._state;let p=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(p){const m={value:[p.key,p.value],done:!1};return p=p.next,m}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let d=this._head,p=this.size;for(;d&&p>n;)this._map.delete(d.key),d=d.next,p--;this._head=d,this._size=p,d&&(d.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const d=n.next,p=n.previous;if(!d||!p)throw new Error("Invalid list");d.previous=p,p.next=d}n.next=void 0,n.previous=void 0,this._state++}touch(n,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(n===this._head)return;const p=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(p.previous=c,c.next=p),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(d===2){if(n===this._tail)return;const p=n.next,c=n.previous;n===this._head?(p.previous=void 0,this._head=p):(p.previous=c,c.next=p),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((d,p)=>{n.push([p,d])}),n}fromJSON(n){this.clear();for(const[d,p]of n)this.set(d,p)}}e.LinkedMap=S;class a extends S{constructor(n,d=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,d=2){return super.get(n,d)}peek(n){return super.get(n,0)}set(n,d){return super.set(n,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class F{constructor(n){P.set(this,void 0),Xe(this,P,n,"f")}get size(){return Ie(this,P,"f").size}forEach(n,d){Ie(this,P,"f").forEach(n,d)}get(n){return Ie(this,P,"f").get(n)}has(n){return Ie(this,P,"f").has(n)}entries(){return Ie(this,P,"f").entries()}keys(){return Ie(this,P,"f").keys()}values(){return Ie(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ie(this,P,"f").entries()}}e.ReadonlyMapView=F}),define(ye[102],_e([0,1,22,9]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...H){return function(j,Y){for(let ae=0,Se=H.length;ae<Se;ae++){const Ue=H[ae](j,Y);if(Ue)return Ue}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(H,j,Y){if(!Y||Y.length<j.length)return null;let ae;return H?ae=t.startsWithIgnoreCase(Y,j):ae=Y.indexOf(j)===0,ae?j.length>0?[{start:0,end:j.length}]:[]:null}function P(H,j){const Y=j.toLowerCase().indexOf(H.toLowerCase());return Y===-1?null:[{start:Y,end:Y+H.length}]}e.matchesContiguousSubString=P;function I(H,j){return D(H.toLowerCase(),j.toLowerCase(),0,0)}e.matchesSubString=I;function D(H,j,Y,ae){if(Y===H.length)return[];if(ae===j.length)return null;if(H[Y]===j[ae]){let Se=null;return(Se=D(H,j,Y+1,ae+1))?M({start:ae,end:ae+1},Se):null}return D(H,j,Y,ae+1)}function T(H){return 97<=H&&H<=122}function R(H){return 65<=H&&H<=90}e.isUpper=R;function w(H){return 48<=H&&H<=57}function i(H){return H===32||H===9||H===10||H===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>h.add(H.charCodeAt(0)));function l(H){return i(H)||h.has(H)}function s(H,j){return H===j||l(H)&&l(j)}function g(H){return T(H)||R(H)||w(H)}function M(H,j){return j.length===0?j=[H]:H.end===j[0].start?j[0].start=H.start:j.unshift(H),j}function C(H,j){for(let Y=j;Y<H.length;Y++){const ae=H.charCodeAt(Y);if(R(ae)||w(ae)||Y>0&&!g(H.charCodeAt(Y-1)))return Y}return H.length}function b(H,j,Y,ae){if(Y===H.length)return[];if(ae===j.length)return null;if(H[Y]!==j[ae].toLowerCase())return null;{let Se=null,Ue=ae+1;for(Se=b(H,j,Y+1,ae+1);!Se&&(Ue=C(j,Ue))<j.length;)Se=b(H,j,Y+1,Ue),Ue++;return Se===null?null:M({start:ae,end:ae+1},Se)}}function u(H){let j=0,Y=0,ae=0,Se=0,Ue=0;for(let Je=0;Je<H.length;Je++)Ue=H.charCodeAt(Je),R(Ue)&&j++,T(Ue)&&Y++,g(Ue)&&ae++,w(Ue)&&Se++;const Ve=j/H.length,Qe=Y/H.length,nt=ae/H.length,rt=Se/H.length;return{upperPercent:Ve,lowerPercent:Qe,alphaPercent:nt,numericPercent:rt}}function S(H){const{upperPercent:j,lowerPercent:Y}=H;return Y===0&&j>.6}function a(H){const{upperPercent:j,lowerPercent:Y,alphaPercent:ae,numericPercent:Se}=H;return Y>.2&&j<.8&&ae>.6&&Se<.2}function F(H){let j=0,Y=0,ae=0,Se=0;for(let Ue=0;Ue<H.length;Ue++)ae=H.charCodeAt(Ue),R(ae)&&j++,T(ae)&&Y++,i(ae)&&Se++;return(j===0||Y===0)&&Se===0?H.length<=30:j<=5}function o(H,j){if(!j||(j=j.trim(),j.length===0)||!F(H)||j.length>60)return null;const Y=u(j);if(!a(Y)){if(!S(Y))return null;j=j.toLowerCase()}let ae=null,Se=0;for(H=H.toLowerCase();Se<j.length&&(ae=b(H,j,0,Se))===null;)Se=C(j,Se+1);return ae}e.matchesCamelCase=o;function n(H,j,Y=!1){if(!j||j.length===0)return null;let ae=null,Se=0;for(H=H.toLowerCase(),j=j.toLowerCase();Se<j.length&&(ae=d(H,j,0,Se,Y))===null;)Se=p(j,Se+1);return ae}e.matchesWords=n;function d(H,j,Y,ae,Se){if(Y===H.length)return[];if(ae===j.length)return null;if(s(H.charCodeAt(Y),j.charCodeAt(ae))){let Ue=null,Ve=ae+1;if(Ue=d(H,j,Y+1,ae+1,Se),!Se)for(;!Ue&&(Ve=p(j,Ve))<j.length;)Ue=d(H,j,Y+1,Ve,Se),Ve++;return Ue===null?null:M({start:ae,end:ae+1},Ue)}else return null}function p(H,j){for(let Y=j;Y<H.length;Y++)if(l(H.charCodeAt(Y))||Y>0&&l(H.charCodeAt(Y-1)))return Y;return H.length}const c=_(e.matchesPrefix,o,P),m=_(e.matchesPrefix,o,I),f=new r.LRUCache(1e4);function E(H,j,Y=!1){if(typeof H!="string"||typeof j!="string")return null;let ae=f.get(H);ae||(ae=new RegExp(t.convertSimple2RegExpPattern(H),"i"),f.set(H,ae));const Se=ae.exec(j);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Y?m(H,j):c(H,j)}e.matchesFuzzy=E;function v(H,j){const Y=Oe(H,H.toLowerCase(),0,j,j.toLowerCase(),0,!0);return Y?U(Y):null}e.matchesFuzzy2=v;function k(H,j,Y,ae,Se,Ue){const Ve=Math.min(13,H.length);for(;Y<Ve;Y++){const Qe=Oe(H,j,Y,ae,Se,Ue,!1);if(Qe)return Qe}return[0,Ue]}e.anyScore=k;function U(H){if(typeof H=="undefined")return[];const j=[],Y=H[1];for(let ae=H.length-1;ae>1;ae--){const Se=H[ae]+Y,Ue=j[j.length-1];Ue&&Ue.end===Se?Ue.end=Se+1:j.push({start:Se,end:Se+1})}return j}e.createMatches=U;const N=128;function y(){const H=[],j=[];for(let Y=0;Y<=N;Y++)j[Y]=0;for(let Y=0;Y<=N;Y++)H.push(j.slice(0));return H}function L(H){const j=[];for(let Y=0;Y<=H;Y++)j[Y]=0;return j}const W=L(2*N),x=L(2*N),$=y(),q=y(),ie=y(),se=!1;function X(H,j,Y,ae,Se){function Ue(Qe,nt,rt=" "){for(;Qe.length<nt;)Qe=rt+Qe;return Qe}let Ve=` |   |${ae.split("").map(Qe=>Ue(Qe,3)).join("|")}
`;for(let Qe=0;Qe<=Y;Qe++)Qe===0?Ve+=" |":Ve+=`${j[Qe-1]}|`,Ve+=H[Qe].slice(0,Se+1).map(nt=>Ue(nt.toString(),3)).join("|")+`
`;return Ve}function ge(H,j,Y,ae){H=H.substr(j),Y=Y.substr(ae),console.log(X(q,H,H.length,Y,Y.length)),console.log(X(ie,H,H.length,Y,Y.length)),console.log(X($,H,H.length,Y,Y.length))}function be(H,j){if(j<0||j>=H.length)return!1;const Y=H.codePointAt(j);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Y)}}function pe(H,j){if(j<0||j>=H.length)return!1;switch(H.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function fe(H,j,Y){return j[H]!==Y[H]}function oe(H,j,Y,ae,Se,Ue,Ve=!1){for(;j<Y&&Se<Ue;)H[j]===ae[Se]&&(Ve&&(W[j]=Se),j+=1),Se+=1;return j===Y}e.isPatternInWord=oe;var Ee;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(H){H.Default=[-100,0];function j(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}H.isDefault=j})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Oe(H,j,Y,ae,Se,Ue,Ve){const Qe=H.length>N?N:H.length,nt=ae.length>N?N:ae.length;if(Y>=Qe||Ue>=nt||Qe-Y>nt-Ue||!oe(j,Y,Qe,Se,Ue,nt,!0))return;je(Qe,nt,Y,Ue,j,Se);let rt=1,Je=1,Ze=Y,pt=Ue;const Fe=[!1];for(rt=1,Ze=Y;Ze<Qe;rt++,Ze++){const Be=W[Ze],qe=x[Ze],lt=Ze+1<Qe?x[Ze+1]:nt;for(Je=Be-Ue+1,pt=Be;pt<lt;Je++,pt++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=qe&&(ht=st(H,j,Ze,Y,ae,Se,pt,nt,Ue,$[rt-1][Je-1]===0,Fe));let kt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,kt=ht+q[rt-1][Je-1]);const Ae=pt>Be,De=Ae?q[rt][Je-1]+($[rt][Je-1]>0?-5:0):0,ve=pt>Be+1&&$[rt][Je-1]>0,te=ve?q[rt][Je-2]+($[rt][Je-2]>0?-5:0):0;if(ve&&(!Ae||te>=De)&&(!Ye||te>=kt))q[rt][Je]=te,ie[rt][Je]=3,$[rt][Je]=0;else if(Ae&&(!Ye||De>=kt))q[rt][Je]=De,ie[rt][Je]=2,$[rt][Je]=0;else if(Ye)q[rt][Je]=kt,ie[rt][Je]=1,$[rt][Je]=$[rt-1][Je-1]+1;else throw new Error("not possible")}}if(se&&ge(H,Y,ae,Ue),!Fe[0]&&!Ve)return;rt--,Je--;const At=[q[rt][Je],Ue];let G=0,Q=0;for(;rt>=1;){let Be=Je;do{const qe=ie[rt][Be];if(qe===3)Be=Be-2;else if(qe===2)Be=Be-1;else break}while(Be>=1);G>1&&j[Y+rt-1]===Se[Ue+Je-1]&&!fe(Be+Ue-1,ae,Se)&&G+1>$[rt][Be]&&(Be=Je),Be===Je?G++:G=1,Q||(Q=Be),rt--,Je=Be-1,At.push(Je)}nt===Qe&&(At[0]+=2);const de=Q-Qe;return At[0]-=de,At}e.fuzzyScore=Oe;function je(H,j,Y,ae,Se,Ue){let Ve=H-1,Qe=j-1;for(;Ve>=Y&&Qe>=ae;)Se[Ve]===Ue[Qe]&&(x[Ve]=Qe,Ve--),Qe--}function st(H,j,Y,ae,Se,Ue,Ve,Qe,nt,rt,Je){if(j[Y]!==Ue[Ve])return Number.MIN_SAFE_INTEGER;let Ze=1,pt=!1;return Ve===Y-ae?Ze=H[Y]===Se[Ve]?7:5:fe(Ve,Se,Ue)&&(Ve===0||!fe(Ve-1,Se,Ue))?(Ze=H[Y]===Se[Ve]?7:5,pt=!0):be(Ue,Ve)&&(Ve===0||!be(Ue,Ve-1))?Ze=5:(be(Ue,Ve-1)||pe(Ue,Ve-1))&&(Ze=5,pt=!0),Ze>1&&Y===ae&&(Je[0]=!0),pt||(pt=fe(Ve,Se,Ue)||be(Ue,Ve-1)||pe(Ue,Ve-1)),Y===ae?Ve>nt&&(Ze-=pt?3:5):rt?Ze+=pt?2:0:Ze+=pt?0:1,Ve+1===Qe&&(Ze-=pt?3:5),Ze}function et(H,j,Y,ae,Se,Ue,Ve){return z(H,j,Y,ae,Se,Ue,!0,Ve)}e.fuzzyScoreGracefulAggressive=et;function tt(H,j,Y,ae,Se,Ue,Ve){return z(H,j,Y,ae,Se,Ue,!1,Ve)}e.fuzzyScoreGraceful=tt;function z(H,j,Y,ae,Se,Ue,Ve,Qe){let nt=Oe(H,j,Y,ae,Se,Ue,Qe);if(nt&&!Ve)return nt;if(H.length>=3){const rt=Math.min(7,H.length-1);for(let Je=Y+1;Je<rt;Je++){const Ze=K(H,Je);if(Ze){const pt=Oe(Ze,Ze.toLowerCase(),Y,ae,Se,Ue,Qe);pt&&(pt[0]-=3,(!nt||pt[0]>nt[0])&&(nt=pt))}}}return nt}function K(H,j){if(j+1>=H.length)return;const Y=H[j],ae=H[j+1];if(Y!==ae)return H.slice(0,j)+ae+Y+H.slice(j+2)}}),define(ye[103],_e([0,1,52,102,9]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(r.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${A.source}`,"g");function D(g){return g.replace(I,(M,C)=>C?M:`\\${M}`)}e.escapeIcons=D;const T=new RegExp(`\\\\${A.source}`,"g");function R(g){return g.replace(T,M=>`\\${M}`)}e.markdownEscapeEscapedIcons=R;const w=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function i(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(w,(M,C,b,u)=>b?M:C||u||"")}e.stripIcons=i;function h(g){const M=g.indexOf(e.iconStartMarker);return M===-1?{text:g}:l(g,M)}e.parseLabelWithIcons=h;function l(g,M){const C=[];let b="";function u(c){if(c){b+=c;for(const m of c)C.push(F)}}let S=-1,a="",F=0,o,n,d=M;const p=g.length;for(u(g.substr(0,M));d<p;)o=g[d],n=g[d+1],o===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(S=d,u(a),a=e.iconStartMarker,d++):o===")"&&S!==-1?(F+=d-S+1,S=-1,a=""):S!==-1?P.test(o)?a+=o:(u(a),S=-1,a=""):u(o),d++;return u(a),{text:b,iconOffsets:C}}function s(g,M,C=!1){const{text:b,iconOffsets:u}=M;if(!u||u.length===0)return(0,t.matchesFuzzy)(g,b,C);const S=(0,_.ltrim)(b," "),a=b.length-S.length,F=(0,t.matchesFuzzy)(g,S,C);if(F)for(const o of F){const n=u[o.start+a]+a;o.start+=n,o.end+=n}return F}e.matchesFuzzyIconAware=s}),define(ye[75],_e([0,1,15,103]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",l=!1){if(this.value=h,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(h,l=0){return this.value+=T(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(s,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,l){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=A;function P(i){return I(i)?!i.value:Array.isArray(i)?i.every(P):!0}e.isEmptyMarkdownString=P;function I(i){return i instanceof A?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(i,h){return i===h?!0:!i||!h?!1:i.value===h.value&&i.isTrusted===h.isTrusted&&i.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=D;function T(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function w(i){const h=[],l=i.split("|").map(g=>g.trim());i=l[0];const s=l[1];if(s){const g=/height=(\d+)/.exec(s),M=/width=(\d+)/.exec(s),C=g?g[1]:"",b=M?M[1]:"",u=isFinite(parseInt(b)),S=isFinite(parseInt(C));u&&h.push(`width="${b}"`),S&&h.push(`height="${C}"`)}return{href:i,dimensions:h}}e.parseHrefAndDimensions=w}),define(ye[34],_e([0,1,9]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(t||(t={})),function(_){const A="error",P="warning",I="warn",D="info",T="ignore";function R(i){return i?r.equalsIgnoreCase(A,i)?_.Error:r.equalsIgnoreCase(P,i)||r.equalsIgnoreCase(I,i)?_.Warning:r.equalsIgnoreCase(D,i)?_.Info:_.Ignore:_.Ignore}_.fromValue=R;function w(i){switch(i){case _.Error:return A;case _.Warning:return P;case _.Info:return D;default:return T}}_.toString=w}(t||(t={})),e.default=t}),define(ye[35],_e([0,1,17,23,9,13]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(d){return d===47||d===92}e.isPathSeparator=P;function I(d){return d.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=I;function D(d){return d.indexOf("/")===-1&&(d=I(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=D;function T(d,p=r.posix.sep){if(!d)return"";const c=d.length,m=d.charCodeAt(0);if(P(m)){if(P(d.charCodeAt(1))&&!P(d.charCodeAt(2))){let E=3;const v=E;for(;E<c&&!P(d.charCodeAt(E));E++);if(v!==E&&!P(d.charCodeAt(E+1))){for(E+=1;E<c;E++)if(P(d.charCodeAt(E)))return d.slice(0,E+1).replace(/[\\/]/g,p)}}return p}else if(M(m)&&d.charCodeAt(1)===58)return P(d.charCodeAt(2))?d.slice(0,2)+p:d.slice(0,2);let f=d.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(P(d.charCodeAt(f)))return d.slice(0,f+1)}return""}e.getRoot=T;function R(d){if(!t.isWindows||!d||d.length<5)return!1;let p=d.charCodeAt(0);if(p!==92||(p=d.charCodeAt(1),p!==92))return!1;let c=2;const m=c;for(;c<d.length&&(p=d.charCodeAt(c),p!==92);c++);return!(m===c||(p=d.charCodeAt(c+1),isNaN(p)||p===92))}e.isUNC=R;const w=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(d,p=t.isWindows){const c=p?w:i;return!(!d||d.length===0||/^\s+$/.test(d)||(c.lastIndex=0,c.test(d))||p&&h.test(d)||d==="."||d===".."||p&&d[d.length-1]==="."||p&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=l;function s(d,p,c){const m=d===p;return!c||m?m:!d||!p?!1:(0,_.equalsIgnoreCase)(d,p)}e.isEqual=s;function g(d,p,c,m=r.sep){if(d===p)return!0;if(!d||!p||p.length>d.length)return!1;if(c){if(!(0,_.startsWithIgnoreCase)(d,p))return!1;if(p.length===d.length)return!0;let E=p.length;return p.charAt(p.length-1)===m&&E--,d.charAt(E)===m}return p.charAt(p.length-1)!==m&&(p+=m),d.indexOf(p)===0}e.isEqualOrParent=g;function M(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=M;function C(d,p){return t.isWindows&&d.endsWith(":")&&(d+=r.sep),(0,r.isAbsolute)(d)||(d=(0,r.join)(p,d)),d=(0,r.normalize)(d),t.isWindows?(d=(0,_.rtrim)(d,r.sep),d.endsWith(":")&&(d+=r.sep)):(d=(0,_.rtrim)(d,r.sep),d||(d=r.sep)),d}e.sanitizeFilePath=C;function b(d){const p=(0,r.normalize)(d);return t.isWindows?d.length>3?!1:u(p)&&(d.length===2||p.charCodeAt(2)===92):p===r.posix.sep}e.isRootOrDriveLetter=b;function u(d,p){return(p!==void 0?p:t.isWindows)?M(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function S(d){return u(d)?d[0]:void 0}e.getDriveLetter=S;function a(d,p,c){return p.length>d.length?-1:d===p?0:(c&&(d=d.toLowerCase(),p=p.toLowerCase()),d.indexOf(p))}e.indexOfPath=a;function F(d){const p=d.split(":");let c,m,f;for(const E of p){const v=Number(E);(0,A.isNumber)(v)?m===void 0?m=v:f===void 0&&(f=v):c=c?[c,E].join(":"):E}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=F;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(d,p,c=8){let m="";for(let E=0;E<c;E++)m+=o.charAt(Math.floor(Math.random()*o.length));let f;return p?f=`${p}-${m}`:f=m,d?(0,r.join)(d,f):f}e.randomPath=n}),define(ye[55],_e([0,1,21,9,2]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(R){return JSON.stringify(R,D)}e.stringify=A;function P(R){let w=JSON.parse(R);return w=T(w),w}e.parse=P;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function D(R,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,t.regExpFlags)(w)}:w}function T(R,w=0){if(!R||w>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return _.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof r.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=T(R[i],w+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=T(R[i],w+1))}return R}e.revive=T}),define(ye[11],_e([0,1,23,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,R){this._hosts[D]=T,this._ports[D]=R}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const w=this._ports[T],i=this._connectionTokens[T];let h=`path=${encodeURIComponent(D.path)}`;return typeof i=="string"&&(h+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:r.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${R}:${w}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class P{asBrowserUri(D,T){const R=this.toUri(D,T);return R.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===_.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${_.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?R.with({scheme:_.vscodeFileResource,authority:R.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(D,T){const R=this.toUri(D,T);return R.scheme===_.vscodeFileResource?R.with({scheme:_.file,authority:R.authority!==P.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(D,T){return t.URI.isUri(D)?D:t.URI.parse(T.toUrl(D))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(ye[24],_e([0,1,35,11,17,23,9,2]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=D;class T{constructor(l){this._ignorePathCasing=l}compare(l,s,g=!1){return l===s?0:(0,P.compare)(this.getComparisonKey(l,g),this.getComparisonKey(s,g))}isEqual(l,s,g=!1){return l===s?!0:!l||!s?!1:this.getComparisonKey(l,g)===this.getComparisonKey(s,g)}getComparisonKey(l,s=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,s,g=!1){if(l.scheme===s.scheme){if(l.scheme===t.Schemas.file)return r.isEqualOrParent(D(l),D(s),this._ignorePathCasing(l))&&l.query===s.query&&(g||l.fragment===s.fragment);if((0,e.isEqualAuthority)(l.authority,s.authority))return r.isEqualOrParent(l.path,s.path,this._ignorePathCasing(l),"/")&&l.query===s.query&&(g||l.fragment===s.fragment)}return!1}joinPath(l,...s){return I.URI.joinPath(l,...s)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return _.posix.basename(l.path)}extname(l){return _.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let s;return l.scheme===t.Schemas.file?s=I.URI.file(_.dirname(D(l))).path:(s=_.posix.dirname(l.path),l.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),s="/")),l.with({path:s})}normalizePath(l){if(!l.path.length)return l;let s;return l.scheme===t.Schemas.file?s=I.URI.file(_.normalize(D(l))).path:s=_.posix.normalize(l.path),l.with({path:s})}relativePath(l,s){if(l.scheme!==s.scheme||!(0,e.isEqualAuthority)(l.authority,s.authority))return;if(l.scheme===t.Schemas.file){const C=_.relative(D(l),D(s));return A.isWindows?r.toSlashes(C):C}let g=l.path||"/",M=s.path||"/";if(this._ignorePathCasing(l)){let C=0;for(const b=Math.min(g.length,M.length);C<b&&!(g.charCodeAt(C)!==M.charCodeAt(C)&&g.charAt(C).toLowerCase()!==M.charAt(C).toLowerCase());C++);g=M.substr(0,C)+g.substr(C)}return _.posix.relative(g,M)}resolvePath(l,s){if(l.scheme===t.Schemas.file){const g=I.URI.file(_.resolve(D(l),s));return l.with({authority:g.authority,path:g.path})}return s=r.toPosixPath(s),l.with({path:_.posix.resolve(l.path,s)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,s){return l===s||l!==void 0&&s!==void 0&&(0,P.equalsIgnoreCase)(l,s)}hasTrailingPathSeparator(l,s=_.sep){if(l.scheme===t.Schemas.file){const g=D(l);return g.length>r.getRoot(g).length&&g[g.length-1]===s}else{const g=l.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,s=_.sep){return(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,s=_.sep){let g=!1;if(l.scheme===t.Schemas.file){const M=D(l);g=M!==void 0&&M.length===r.getRoot(M).length&&M[M.length-1]===s}else{s="/";const M=l.path;g=M.length===1&&M.charCodeAt(M.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path+"/"}):l}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(h,l){const s=[];for(let g=0;g<h.length;g++){const M=l(h[g]);h.some((C,b)=>b===g?!1:(0,e.isEqualOrParent)(M,l(C)))||s.push(h[g])}return s}e.distinctParents=R;var w;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function l(s){const g=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(b=>{const[u,S]=b.split(":");u&&S&&g.set(u,S)});const C=s.path.substring(0,s.path.indexOf(";"));return C&&g.set(h.META_DATA_MIME,C),g}h.parseMetaData=l})(w=e.DataUri||(e.DataUri={}));function i(h,l,s){if(l){let g=h.path;return g&&g[0]!==_.posix.sep&&(g=_.posix.sep+g),h.with({scheme:s,authority:l,path:g})}return h.with({scheme:s})}e.toLocalResource=i}),define(ye[10],_e([0,1,20,15,4,6,24,23]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=D;function T(fe){const oe=new r.CancellationTokenSource,Ee=fe(oe.token),Pe=new Promise((Oe,je)=>{const st=oe.token.onCancellationRequested(()=>{st.dispose(),oe.dispose(),je(new t.CancellationError)});Promise.resolve(Ee).then(et=>{st.dispose(),oe.dispose(),Oe(et)},et=>{st.dispose(),oe.dispose(),je(et)})});return new class{cancel(){oe.cancel()}then(Oe,je){return Pe.then(Oe,je)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Pe.finally(Oe)}}}e.createCancelablePromise=T;function R(fe,oe,Ee){return new Promise((Pe,Oe)=>{const je=oe.onCancellationRequested(()=>{je.dispose(),Pe(Ee)});fe.then(Pe,Oe).finally(()=>je.dispose())})}e.raceCancellation=R;function w(fe,oe){return new Promise((Ee,Pe)=>{const Oe=oe.onCancellationRequested(()=>{Oe.dispose(),Pe(new t.CancellationError)});fe.then(Ee,Pe).finally(()=>Oe.dispose())})}e.raceCancellationError=w;async function i(fe){let oe=-1;const Ee=fe.map((Oe,je)=>Oe.then(st=>(oe=je,st))),Pe=await Promise.race(Ee);return fe.forEach((Oe,je)=>{je!==oe&&Oe.cancel()}),Pe}e.raceCancellablePromises=i;function h(fe,oe,Ee){let Pe;const Oe=setTimeout(()=>{Pe?.(void 0),Ee?.()},oe);return Promise.race([fe.finally(()=>clearTimeout(Oe)),new Promise(je=>Pe=je)])}e.raceTimeout=h;function l(fe){return new Promise((oe,Ee)=>{const Pe=fe();D(Pe)?Pe.then(oe,Ee):oe(Pe)})}e.asPromise=l;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(oe){if(this.activePromise){if(this.queuedPromiseFactory=oe,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=oe(),new Promise((Ee,Pe)=>{this.activePromise.then(Oe=>{this.activePromise=null,Ee(Oe)},Oe=>{this.activePromise=null,Pe(Oe)})})}}e.Throttler=s;class g{constructor(){this.current=Promise.resolve(null)}queue(oe){return this.current=this.current.then(()=>oe(),()=>oe())}}e.Sequencer=g;class M{constructor(){this.promiseMap=new Map}queue(oe,Ee){const Oe=(this.promiseMap.get(oe)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(oe)===Oe&&this.promiseMap.delete(oe)});return this.promiseMap.set(oe,Oe),Oe}}e.SequencerByKey=M;const C=(fe,oe)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,oe()},fe);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},b=fe=>{let oe=!0;return queueMicrotask(()=>{oe&&(oe=!1,fe())}),{isTriggered:()=>oe,dispose:()=>{oe=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(oe){this.defaultDelay=oe,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(oe,Ee=this.defaultDelay){this.task=oe,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,je)=>{this.doResolve=Oe,this.doReject=je}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?b(Pe):C(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class S{constructor(oe){this.delayer=new u(oe),this.throttler=new s}trigger(oe,Ee){return this.delayer.trigger(()=>this.throttler.queue(oe),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class a{constructor(){this._isOpen=!1,this._promise=new Promise((oe,Ee)=>{this._completePromise=oe})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class F extends a{constructor(oe){super();this._timeout=setTimeout(()=>this.open(),oe)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=F;function o(fe,oe){return oe?new Promise((Ee,Pe)=>{const Oe=setTimeout(()=>{je.dispose(),Ee()},fe),je=oe.onCancellationRequested(()=>{clearTimeout(Oe),je.dispose(),Pe(new t.CancellationError)})}):T(Ee=>o(fe,Ee))}e.timeout=o;function n(fe,oe=0){const Ee=setTimeout(fe,oe);return(0,A.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=n;function d(fe){const oe=[];let Ee=0;const Pe=fe.length;function Oe(){return Ee<Pe?fe[Ee++]():null}function je(st){st!=null&&oe.push(st);const et=Oe();return et?et.then(je):Promise.resolve(oe)}return Promise.resolve(null).then(je)}e.sequence=d;function p(fe,oe=Pe=>!!Pe,Ee=null){let Pe=0;const Oe=fe.length,je=()=>{if(Pe>=Oe)return Promise.resolve(Ee);const st=fe[Pe++];return Promise.resolve(st()).then(tt=>oe(tt)?Promise.resolve(tt):je())};return je()}e.first=p;function c(fe,oe=Pe=>!!Pe,Ee=null){if(fe.length===0)return Promise.resolve(Ee);let Pe=fe.length;const Oe=()=>{Pe=-1;for(const je of fe)je.cancel?.()};return new Promise((je,st)=>{for(const et of fe)et.then(tt=>{--Pe>=0&&oe(tt)?(Oe(),je(tt)):Pe===0&&je(Ee)}).catch(tt=>{--Pe>=0&&(Oe(),st(tt))})})}e.firstParallel=c;class m{constructor(oe){this._size=0,this.maxDegreeOfParalellism=oe,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(oe){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:oe,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const oe=this.outstandingPromises.shift();this.runningPromises++;const Ee=oe.factory();Ee.then(oe.c,oe.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const oe=new ie;return this.drainers.add(oe),oe.p}isDrained(){for(const[,oe]of this.queues)if(oe.size>0)return!1;return!0}queueFor(oe,Ee=P.extUri){const Pe=Ee.getComparisonKey(oe);let Oe=this.queues.get(Pe);return Oe||(Oe=new f,_.Event.once(Oe.onFinished)(()=>{Oe?.dispose(),this.queues.delete(Pe),this.onDidQueueFinish()}),this.queues.set(Pe,Oe)),Oe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const oe of this.drainers)oe.complete();this.drainers.clear()}dispose(){for(const[,oe]of this.queues)oe.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class v{constructor(oe,Ee){this._token=-1,typeof oe=="function"&&typeof Ee=="number"&&this.setIfNotSet(oe,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,oe()},Ee)}setIfNotSet(oe,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,oe()},Ee))}}e.TimeoutTimer=v;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setInterval(()=>{oe()},Ee)}}e.IntervalTimer=k;class U{constructor(oe,Ee){this.timeoutToken=-1,this.runner=oe,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(oe=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,oe)}get delay(){return this.timeout}set delay(oe){this.timeout=oe}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class N{constructor(oe,Ee){Ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=oe,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(oe=this.timeout){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(oe/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class y extends U{constructor(oe,Ee){super(oe,Ee);this.units=[]}work(oe){this.units.push(oe),this.isScheduled()||this.schedule()}doRun(){const oe=this.units;this.units=[],this.runner&&this.runner(oe)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=y;class L extends A.Disposable{constructor(oe,Ee){super();this.options=oe,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(oe){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+oe.length>this.options.maxBufferedWork)return!1}else if(this.pending+oe.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...oe),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,I.setTimeout0)(()=>{if(oe)return;const Ee=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.runWhenIdle=(fe,oe)=>{const Ee=requestIdleCallback(fe,typeof oe=="number"?{timeout:oe}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class W{constructor(oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function x(fe,oe,Ee){let Pe;for(let Oe=0;Oe<Ee;Oe++)try{return await fe()}catch(je){Pe=je,await o(oe)}throw Pe}e.retry=x;class ${hasPending(oe){return this._pending?typeof oe=="number"?this._pending.taskId===oe:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(oe,Ee,Pe){return this._pending={taskId:oe,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(oe),()=>this.donePending(oe)),Ee}donePending(oe){this._pending&&oe===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const oe=this._next;this._next=void 0,oe.run().then(oe.promiseResolve,oe.promiseReject)}}setNext(oe){if(this._next)this._next.run=oe;else{let Ee,Pe;const Oe=new Promise((je,st)=>{Ee=je,Pe=st});this._next={run:oe,promise:Oe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=$;class q{constructor(oe,Ee=()=>Date.now()){this.interval=oe,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const oe=this.nowFn();return oe-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=oe,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((oe,Ee)=>{this.completeCallback=oe,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(oe){return new Promise(Ee=>{this.completeCallback(oe),this.resolved=!0,Ee()})}error(oe){return new Promise(Ee=>{this.errorCallback(oe),this.rejected=!0,Ee()})}cancel(){new Promise(oe=>{this.errorCallback(new t.CancellationError),this.rejected=!0,oe()})}}e.DeferredPromise=ie;var se;(function(fe){async function oe(Pe){let Oe;const je=await Promise.all(Pe.map(st=>st.then(et=>et,et=>{Oe||(Oe=et)})));if(typeof Oe!="undefined")throw Oe;return je}fe.settled=oe;function Ee(Pe){return new Promise(async(Oe,je)=>{try{await Pe(Oe,je)}catch(st){je(st)}})}fe.withAsyncBody=Ee})(se=e.Promises||(e.Promises={}));var X;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(X||(X={}));class ge{constructor(oe){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(oe(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(oe){return new ge(Ee=>{Ee.emitMany(oe)})}static fromPromise(oe){return new ge(async Ee=>{Ee.emitMany(await oe)})}static fromPromises(oe){return new ge(async Ee=>{await Promise.all(oe.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(oe){return new ge(async Ee=>{await Promise.all(oe.map(async Pe=>{for await(const Oe of Pe)Ee.emitOne(Oe)}))})}[Symbol.asyncIterator](){let oe=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(oe<this._results.length)return{done:!1,value:this._results[oe++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(oe,Ee){return new ge(async Pe=>{for await(const Oe of oe)Pe.emitOne(Ee(Oe))})}map(oe){return ge.map(this,oe)}static filter(oe,Ee){return new ge(async Pe=>{for await(const Oe of oe)Ee(Oe)&&Pe.emitOne(Oe)})}filter(oe){return ge.filter(this,oe)}static coalesce(oe){return ge.filter(oe,Ee=>!!Ee)}coalesce(){return ge.coalesce(this)}static async toPromise(oe){const Ee=[];for await(const Pe of oe)Ee.push(Pe);return Ee}toPromise(){return ge.toPromise(this)}emitOne(oe){this._state===0&&(this._results.push(oe),this._onStateChanged.fire())}emitMany(oe){this._state===0&&(this._results=this._results.concat(oe),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(oe){this._state===0&&(this._state=2,this._error=oe,this._onStateChanged.fire())}}e.AsyncIterableObject=ge,ge.EMPTY=ge.fromArray([]);class be extends ge{constructor(oe,Ee){super(Ee);this._source=oe}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function pe(fe){const oe=new r.CancellationTokenSource,Ee=fe(oe.token);return new be(oe,async Pe=>{const Oe=oe.token.onCancellationRequested(()=>{Oe.dispose(),oe.dispose(),Pe.reject(new t.CancellationError)});try{for await(const je of Ee){if(oe.token.isCancellationRequested)return;Pe.emitOne(je)}Oe.dispose(),oe.dispose()}catch(je){Oe.dispose(),oe.dispose(),Pe.reject(je)}})}e.createCancelableAsyncIterable=pe}),define(ye[104],_e([0,1,10,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new r.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),A=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(f,E,v=!1){const k=f||"",U=E||"",N=_.value.collator.compare(k,U);return _.value.collatorIsNumeric&&N===0&&k!==U?k<U?-1:1:N}e.compareFileNames=I;function D(f,E){const v=A.value.collator;return f=f||"",E=E||"",S(v,f,E)}e.compareFileNamesDefault=D;function T(f,E){const v=A.value.collator;return f=f||"",E=E||"",n(f,E)||S(v,f,E)}e.compareFileNamesUpper=T;function R(f,E){const v=A.value.collator;return f=f||"",E=E||"",o(f,E)||S(v,f,E)}e.compareFileNamesLower=R;function w(f,E){return f=f||"",E=E||"",f===E?0:f<E?-1:1}e.compareFileNamesUnicode=w;function i(f,E,v=!1){v||(f=f&&f.toLowerCase(),E=E&&E.toLowerCase());const[k,U]=b(f),[N,y]=b(E);return k!==N?k<N?-1:1:U===y?0:U<y?-1:1}e.noIntlCompareFileNames=i;function h(f,E){const[v,k]=b(f),[U,N]=b(E);let y=_.value.collator.compare(k,N);if(y===0){if(_.value.collatorIsNumeric&&k!==N)return k<N?-1:1;if(y=_.value.collator.compare(v,U),_.value.collatorIsNumeric&&y===0&&v!==U)return v<U?-1:1}return y}e.compareFileExtensions=h;function l(f,E){f=f||"",E=E||"";const v=u(f),k=u(E),U=A.value.collator,N=P.value.collator;return S(N,v,k)||S(U,f,E)}e.compareFileExtensionsDefault=l;function s(f,E){f=f||"",E=E||"";const v=u(f),k=u(E),U=A.value.collator,N=P.value.collator;return S(N,v,k)||n(f,E)||S(U,f,E)}e.compareFileExtensionsUpper=s;function g(f,E){f=f||"",E=E||"";const v=u(f),k=u(E),U=A.value.collator,N=P.value.collator;return S(N,v,k)||o(f,E)||S(U,f,E)}e.compareFileExtensionsLower=g;function M(f,E){f=f||"",E=E||"";const v=u(f).toLowerCase(),k=u(E).toLowerCase();return v!==k?v<k?-1:1:f!==E?f<E?-1:1:0}e.compareFileExtensionsUnicode=M;const C=/^(.*?)(\.([^.]*))?$/;function b(f,E=!1){const v=f?C.exec(f):[];let k=[v&&v[1]||"",v&&v[3]||""];return E&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function u(f){const E=f?C.exec(f):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function S(f,E,v){let k=f.compare(E,v);return k!==0?k:E.length!==v.length?E.length<v.length?-1:1:0}function a(f){const E=f.charAt(0);return E.toLocaleUpperCase()!==E}function F(f){const E=f.charAt(0);return E.toLocaleLowerCase()!==E}function o(f,E){return a(f)&&F(E)?-1:F(f)&&a(E)?1:0}function n(f,E){return F(f)&&a(E)?-1:a(f)&&F(E)?1:0}function d(f,E,v=!1){return v||(f=f&&f.toLowerCase(),E=E&&E.toLowerCase()),f===E?0:f<E?-1:1}function p(f,E,v=!1){const k=f.split(t.sep),U=E.split(t.sep),N=k.length-1,y=U.length-1;let L,W;for(let x=0;;x++){if(L=N===x,W=y===x,L&&W)return I(k[x],U[x],v);if(L)return-1;if(W)return 1;const $=d(k[x],U[x],v);if($!==0)return $}}e.comparePaths=p;function c(f,E,v){const k=f.toLowerCase(),U=E.toLowerCase(),N=m(f,E,v);if(N)return N;const y=k.endsWith(v),L=U.endsWith(v);if(y!==L)return y?-1:1;const W=I(k,U);return W!==0?W:k.localeCompare(U)}e.compareAnything=c;function m(f,E,v){const k=f.toLowerCase(),U=E.toLowerCase(),N=k.startsWith(v),y=U.startsWith(v);if(N!==y)return N?-1:1;if(N&&y){if(k.length<U.length)return-1;if(k.length>U.length)return 1}return 0}e.compareByPrefix=m}),define(ye[29],_e([0,1,10,35,22,17,9]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",T="[^/\\\\]",R=/\//g;function w(q){switch(q){case 0:return"";case 1:return`${T}*?`;default:return`(?:${D}|${T}+${D}|${D}${T}+)*?`}}function i(q,ie){if(!q)return[];const se=[];let X=!1,ge=!1,be="";for(const pe of q){switch(pe){case ie:if(!X&&!ge){se.push(be),be="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}be+=pe}return be&&se.push(be),se}e.splitGlobAware=i;function h(q){if(!q)return"";let ie="";const se=i(q,e.GLOB_SPLIT);if(se.every(X=>X===e.GLOBSTAR))ie=".*";else{let X=!1;se.forEach((ge,be)=>{if(ge===e.GLOBSTAR){X||(ie+=w(2),X=!0);return}let pe=!1,fe="",oe=!1,Ee="";for(const Pe of ge){if(Pe!=="}"&&pe){fe+=Pe;continue}if(oe&&(Pe!=="]"||!Ee)){let Oe;Pe==="-"?Oe=Pe:(Pe==="^"||Pe==="!")&&!Ee?Oe="^":Pe===e.GLOB_SPLIT?Oe="":Oe=P.escapeRegExpCharacters(Pe),Ee+=Oe;continue}switch(Pe){case"{":pe=!0;continue;case"[":oe=!0;continue;case"}":{ie+=`(?:${i(fe,",").map(st=>h(st)).join("|")})`,pe=!1,fe="";break}case"]":ie+="["+Ee+"]",oe=!1,Ee="";break;case"?":ie+=T;continue;case"*":ie+=w(1);continue;default:ie+=P.escapeRegExpCharacters(Pe)}}be<se.length-1&&(se[be+1]!==e.GLOBSTAR||be+2<se.length)&&(ie+=D),X=!1})}return ie}const l=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,M=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new _.LRUCache(1e4),S=function(){return!1},a=function(){return null};function F(q,ie){if(!q)return a;let se;typeof q!="string"?se=q.pattern:se=q,se=se.trim();const X=`${se}_${!!ie.trimForExclusions}`;let ge=u.get(X);if(ge)return o(ge,q);let be;if(l.test(se)){const pe=se.substr(4);ge=function(fe,oe){return typeof fe=="string"&&fe.endsWith(pe)?se:null}}else(be=s.exec(n(se,ie)))?ge=d(be[1],se):(ie.trimForExclusions?M:g).test(se)?ge=p(se,ie):(be=C.exec(n(se,ie)))?ge=c(be[1].substr(1),se,!0):(be=b.exec(n(se,ie)))?ge=c(be[1],se,!1):ge=m(se);return u.set(X,ge),o(ge,q)}function o(q,ie){return typeof ie=="string"?q:function(se,X){return t.isEqualOrParent(se,ie.base)?q(A.relative(ie.base,se),X):null}}function n(q,ie){return ie.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function d(q,ie){const se=`/${q}`,X=`\\${q}`,ge=function(pe,fe){return typeof pe!="string"?null:fe?fe===q?ie:null:pe===q||pe.endsWith(se)||pe.endsWith(X)?ie:null},be=[q];return ge.basenames=be,ge.patterns=[ie],ge.allBasenames=be,ge}function p(q,ie){const se=$(q.slice(1,-1).split(",").map(fe=>F(fe,ie)).filter(fe=>fe!==a),q),X=se.length;if(!X)return a;if(X===1)return se[0];const ge=function(fe,oe){for(let Ee=0,Pe=se.length;Ee<Pe;Ee++)if(se[Ee](fe,oe))return q;return null},be=se.find(fe=>!!fe.allBasenames);be&&(ge.allBasenames=be.allBasenames);const pe=se.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return pe.length&&(ge.allPaths=pe),ge}function c(q,ie,se){const X=A.sep===A.posix.sep,ge=X?q:q.replace(R,A.sep),be=A.sep+ge,pe=A.posix.sep+q,fe=se?function(oe,Ee){return typeof oe=="string"&&(oe===ge||oe.endsWith(be)||!X&&(oe===q||oe.endsWith(pe)))?ie:null}:function(oe,Ee){return typeof oe=="string"&&(oe===ge||!X&&oe===q)?ie:null};return fe.allPaths=[(se?"*/":"./")+q],fe}function m(q){try{const ie=new RegExp(`^${h(q)}$`);return function(se){return ie.lastIndex=0,typeof se=="string"&&ie.test(se)?q:null}}catch{return a}}function f(q,ie,se){return!q||typeof ie!="string"?!1:E(q)(ie,void 0,se)}e.match=f;function E(q,ie={}){if(!q)return S;if(typeof q=="string"||N(q)){const se=F(q,ie);if(se===a)return S;const X=function(ge,be){return!!se(ge,be)};return se.allBasenames&&(X.allBasenames=se.allBasenames),se.allPaths&&(X.allPaths=se.allPaths),X}return W(q,ie)}e.parse=E;function v(q){if(!q)return;let ie;return se=>(ie||(ie=(q()||Promise.resolve([])).then(X=>X?U(X):{})),ie.then(X=>!!X[se]))}e.hasSiblingPromiseFn=v;function k(q){if(!q)return;let ie;return se=>{if(!ie){const X=q();ie=X?U(X):{}}return!!ie[se]}}e.hasSiblingFn=k;function U(q){const ie={};for(const se of q)ie[se]=!0;return ie}function N(q){const ie=q;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=N;function y(q){return q.allBasenames||[]}e.getBasenameTerms=y;function L(q){return q.allPaths||[]}e.getPathTerms=L;function W(q,ie){const se=$(Object.getOwnPropertyNames(q).map(fe=>x(fe,q[fe],ie)).filter(fe=>fe!==a)),X=se.length;if(!X)return a;if(!se.some(fe=>!!fe.requiresSiblings)){if(X===1)return se[0];const fe=function(Pe,Oe){for(let je=0,st=se.length;je<st;je++){const et=se[je](Pe,Oe);if(et)return et}return null},oe=se.find(Pe=>!!Pe.allBasenames);oe&&(fe.allBasenames=oe.allBasenames);const Ee=se.reduce((Pe,Oe)=>Oe.allPaths?Pe.concat(Oe.allPaths):Pe,[]);return Ee.length&&(fe.allPaths=Ee),fe}const ge=function(fe,oe,Ee){let Pe;for(let Oe=0,je=se.length;Oe<je;Oe++){const st=se[Oe];st.requiresSiblings&&Ee&&(oe||(oe=A.basename(fe)),Pe||(Pe=oe.substr(0,oe.length-A.extname(fe).length)));const et=st(fe,oe,Pe,Ee);if(et)return et}return null},be=se.find(fe=>!!fe.allBasenames);be&&(ge.allBasenames=be.allBasenames);const pe=se.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return pe.length&&(ge.allPaths=pe),ge}function x(q,ie,se){if(ie===!1)return a;const X=F(q,se);if(X===a)return a;if(typeof ie=="boolean")return X;if(ie){const ge=ie.when;if(typeof ge=="string"){const be=(pe,fe,oe,Ee)=>{if(!Ee||!X(pe,fe))return null;const Pe=ge.replace("$(basename)",oe),Oe=Ee(Pe);return(0,r.isThenable)(Oe)?Oe.then(je=>je?q:null):Oe?q:null};return be.requiresSiblings=!0,be}}return X}function $(q,ie){const se=q.filter(fe=>!!fe.basenames);if(se.length<2)return q;const X=se.reduce((fe,oe)=>{const Ee=oe.basenames;return Ee?fe.concat(Ee):fe},[]);let ge;if(ie){ge=[];for(let fe=0,oe=X.length;fe<oe;fe++)ge.push(ie)}else ge=se.reduce((fe,oe)=>{const Ee=oe.patterns;return Ee?fe.concat(Ee):fe},[]);const be=function(fe,oe){if(typeof fe!="string")return null;if(!oe){let Pe;for(Pe=fe.length;Pe>0;Pe--){const Oe=fe.charCodeAt(Pe-1);if(Oe===47||Oe===92)break}oe=fe.substr(Pe)}const Ee=X.indexOf(oe);return Ee!==-1?ge[Ee]:null};be.basenames=X,be.patterns=ge,be.allBasenames=X;const pe=q.filter(fe=>!fe.basenames);return pe.push(be),pe}}),define(ye[76],_e([0,1,35,11,17,23,24,9,2]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(n,d,p){if(typeof n=="string"&&(n=D.URI.file(n)),p){const m=p.getWorkspaceFolder(n);if(m){const f=p.getWorkspace().folders.length>1;let E;if((0,P.isEqual)(m.uri,n)?E="":E=(0,P.relativePath)(m.uri,n),f){const v=m.name?m.name:(0,P.basename)(m.uri);E=E?v+" \u2022 "+E:v}return E}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(n.fsPath))return(0,_.normalize)(w(n.fsPath));let c=(0,_.normalize)(n.fsPath);return!A.isWindows&&d?.userHome&&(c=h(c,d.userHome.fsPath)),c}e.getPathLabel=T;function R(n){if(!n)return;typeof n=="string"&&(n=D.URI.file(n));const d=(0,P.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return A.isWindows&&(0,r.isRootOrDriveLetter)(d)?w(d):d}e.getBaseLabel=R;function w(n,d){return(0,r.hasDriveLetter)(n,d)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=w;let i=Object.create(null);function h(n,d){if(A.isWindows||!n||!d)return n;let p=i.original===d?i.normalized:void 0;return p||(p=`${(0,I.rtrim)(d,_.posix.sep)}${_.posix.sep}`,i={original:d,normalized:p}),(A.isLinux?n.startsWith(p):(0,I.startsWithIgnoreCase)(n,p))&&(n=`~/${n.substr(p.length)}`),n}e.tildify=h;function l(n,d){return n.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=l;const s="\u2026",g="\\\\",M="~";function C(n,d=_.sep){const p=new Array(n.length);let c=!1;for(let m=0;m<n.length;m++){let f=n[m];if(f===""){p[m]=`.${d}`;continue}if(!f){p[m]=f;continue}c=!0;let E="";f.indexOf(g)===0?(E=f.substr(0,f.indexOf(g)+g.length),f=f.substr(f.indexOf(g)+g.length)):f.indexOf(d)===0?(E=f.substr(0,f.indexOf(d)+d.length),f=f.substr(f.indexOf(d)+d.length)):f.indexOf(M)===0&&(E=f.substr(0,f.indexOf(M)+M.length),f=f.substr(f.indexOf(M)+M.length));const v=f.split(d);for(let k=1;c&&k<=v.length;k++)for(let U=v.length-k;c&&U>=0;U--){c=!1;let N=v.slice(U,U+k).join(d);for(let y=0;!c&&y<n.length;y++)if(y!==m&&n[y]&&n[y].indexOf(N)>-1){const L=U+k===v.length,W=U>0&&n[y].indexOf(d)>-1?d+N:N,x=n[y].endsWith(W);c=!L||x}if(!c){let y="";(v[0].endsWith(":")||E!=="")&&(U===1&&(U=0,k++,N=v[0]+d+N),U>0&&(y=v[0]+d),y=E+y),U>0&&(y=y+s+d),y=y+N,U+k<v.length&&(y=y+d+s),p[m]=y}}c&&(p[m]=f)}return p}e.shorten=C;var b;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function u(n,d=Object.create(null)){const p=[];let c=!1,m="";for(const f of n)if(f==="$"||c&&f==="{")m&&p.push({value:m,type:b.TEXT}),m="",c=!0;else if(f==="}"&&c){const E=d[m];if(typeof E=="string")E.length&&p.push({value:E,type:b.VARIABLE});else if(E){const v=p[p.length-1];(!v||v.type!==b.SEPARATOR)&&p.push({value:E.label,type:b.SEPARATOR})}m="",c=!1}else m+=f;return m&&!c&&p.push({value:m,type:b.TEXT}),p.filter((f,E)=>{if(f.type===b.SEPARATOR){const v=p[E-1],k=p[E+1];return[v,k].every(U=>U&&(U.type===b.VARIABLE||U.type===b.TEXT)&&U.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=u;function S(n,d){return A.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function a(n,d){return A.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,p=>p==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function F(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=F;function o(n){const d=n.indexOf("/")!==-1?_.posix:_.win32,p=d.basename(n),c=d.dirname(n);return p.length?{name:p,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(ye[105],_e([0,1,2]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class _{constructor(w){this._uriTransformer=w}transformIncoming(w){const i=this._uriTransformer.transformIncoming(w);return i===w?w:t(r.URI.from(i))}transformOutgoing(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:t(r.URI.from(i))}transformOutgoingURI(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:r.URI.from(i)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,w,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return w.transformOutgoing(R);for(let h in R)if(Object.hasOwnProperty.call(R,h)){const l=A(R[h],w,i+1);l!==null&&(R[h]=l)}}return null}function P(R,w){const i=A(R,w,0);return i===null?R:i}e.transformOutgoingURIs=P;function I(R,w,i,h){if(!R||h>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?r.URI.revive(w.transformIncoming(R)):w.transformIncoming(R);for(let l in R)if(Object.hasOwnProperty.call(R,l)){const s=I(R[l],w,i,h+1);s!==null&&(R[l]=s)}}return null}function D(R,w){const i=I(R,w,!1,0);return i===null?R:i}e.transformIncomingURIs=D;function T(R,w){const i=I(R,w,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=T}),define(ye[36],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return r.test(D)}e.isUUID=t;const _=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function I(){P(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let D=0,T="";return T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T}e.generateUuid=I}),define(ye[106],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let D=0,T=I.notIn.length;D<T;D++)switch(I.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,D){if(I.getTokenCount()===0)return!0;const T=I.findTokenIndexAtOffset(D-2),R=I.getStandardTokenType(T);return this.isOK(R)}_findNeutralCharacterInRange(I,D){for(let T=I;T<=D;T++){const R=String.fromCharCode(T);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class _{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=_;function A(P,I,D){P.has(I)?P.get(I).push(D):P.set(I,[D])}}),define(ye[56],_e([0,1,29,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,P,I,D){if(Array.isArray(A)){let T=0;for(const R of A){const w=_(R,P,I,D);if(w===10)return w;w>T&&(T=w)}return T}else{if(typeof A=="string")return D?A==="*"?5:A===I?10:0:0;if(A){const{language:T,pattern:R,scheme:w,hasAccessToAllModels:i}=A;if(!D&&!i)return 0;let h=0;if(w)if(w===P.scheme)h=10;else if(w==="*")h=5;else return 0;if(T)if(T===I)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(R){let l;if(typeof R=="string"?l=R:l={...R,base:(0,t.normalize)(R.base)},l===P.fsPath||(0,r.match)(l,P.fsPath))h=10;else return 0}return h}else return 0}}e.score=_}),define(ye[107],_e([0,1,4,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class _{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,D){return this._map.set(I,D),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===D&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,D){this._factories.get(I)?.dispose();const T=new A(this,I,D);return this._factories.set(I,T),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==T||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const D=this.get(I);if(D)return D;const T=this._factories.get(I);return!T||T.isResolved?null:(await T.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const T=this._factories.get(I);return!!(!T||T.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=_;class A extends t.Disposable{constructor(I,D,T){super();this._registry=I,this._languageId=D,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(ye[77],_e([0,1,21,23]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(_||(_={}));function A(w){for(let i=0,h=w.length;i<h;i+=4){const l=w[i+0],s=w[i+1],g=w[i+2],M=w[i+3];w[i+0]=M,w[i+1]=g,w[i+2]=s,w[i+3]=l}}function P(w){const i=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return t.isLittleEndian()||A(i),r.VSBuffer.wrap(i)}function I(w){const i=w.buffer;if(t.isLittleEndian()||A(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const h=new Uint8Array(i.byteLength);return h.set(i),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(w){const i=new Uint32Array(T(w));let h=0;if(i[h++]=w.id,w.type==="full")i[h++]=1,i[h++]=w.data.length,i.set(w.data,h),h+=w.data.length;else{i[h++]=2,i[h++]=w.deltas.length;for(const l of w.deltas)i[h++]=l.start,i[h++]=l.deleteCount,l.data?(i[h++]=l.data.length,i.set(l.data,h),h+=l.data.length):i[h++]=0}return P(i)}e.encodeSemanticTokensDto=D;function T(w){let i=0;if(i+=1+1,w.type==="full")i+=1+w.data.length;else{i+=1,i+=(1+1+1)*w.deltas.length;for(const h of w.deltas)h.data&&(i+=h.data.length)}return i}function R(w){const i=I(w);let h=0;const l=i[h++];if(i[h++]===1){const C=i[h++],b=i.subarray(h,h+C);return h+=C,{id:l,type:"full",data:b}}const g=i[h++],M=[];for(let C=0;C<g;C++){const b=i[h++],u=i[h++],S=i[h++];let a;S>0&&(a=i.subarray(h,h+S),h+=S),M[C]={start:b,deleteCount:u,data:a}}return{id:l,type:"delta",deltas:M}}e.decodeSemanticTokensDto=R}),define(ye[108],_e([18,19]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ye[109],_e([0,1,108]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,_=t*60,A=_*24,P=A*7,I=A*30,D=A*365;function T(w,i,h){typeof w!="number"&&(w=w.getTime());const l=Math.round((new Date().getTime()-w)/1e3);if(l<-30)return(0,r.localize)(0,null,T(new Date().getTime()+l*1e3,!1));if(l<30)return(0,r.localize)(1,null);let s;return l<t?(s=l,i?s===1?h?(0,r.localize)(2,null,s):(0,r.localize)(3,null,s):h?(0,r.localize)(4,null,s):(0,r.localize)(5,null,s):s===1?h?(0,r.localize)(6,null,s):(0,r.localize)(7,null,s):h?(0,r.localize)(8,null,s):(0,r.localize)(9,null,s)):l<_?(s=Math.floor(l/t),i?s===1?h?(0,r.localize)(10,null,s):(0,r.localize)(11,null,s):h?(0,r.localize)(12,null,s):(0,r.localize)(13,null,s):s===1?h?(0,r.localize)(14,null,s):(0,r.localize)(15,null,s):h?(0,r.localize)(16,null,s):(0,r.localize)(17,null,s)):l<A?(s=Math.floor(l/_),i?s===1?h?(0,r.localize)(18,null,s):(0,r.localize)(19,null,s):h?(0,r.localize)(20,null,s):(0,r.localize)(21,null,s):s===1?h?(0,r.localize)(22,null,s):(0,r.localize)(23,null,s):h?(0,r.localize)(24,null,s):(0,r.localize)(25,null,s)):l<P?(s=Math.floor(l/A),i?s===1?(0,r.localize)(26,null,s):(0,r.localize)(27,null,s):s===1?(0,r.localize)(28,null,s):(0,r.localize)(29,null,s)):l<I?(s=Math.floor(l/P),i?s===1?h?(0,r.localize)(30,null,s):(0,r.localize)(31,null,s):h?(0,r.localize)(32,null,s):(0,r.localize)(33,null,s):s===1?h?(0,r.localize)(34,null,s):(0,r.localize)(35,null,s):h?(0,r.localize)(36,null,s):(0,r.localize)(37,null,s)):l<D?(s=Math.floor(l/I),i?s===1?h?(0,r.localize)(38,null,s):(0,r.localize)(39,null,s):h?(0,r.localize)(40,null,s):(0,r.localize)(41,null,s):s===1?h?(0,r.localize)(42,null,s):(0,r.localize)(43,null,s):h?(0,r.localize)(44,null,s):(0,r.localize)(45,null,s)):(s=Math.floor(l/D),i?s===1?h?(0,r.localize)(46,null,s):(0,r.localize)(47,null,s):h?(0,r.localize)(48,null,s):(0,r.localize)(49,null,s):s===1?h?(0,r.localize)(50,null,s):(0,r.localize)(51,null,s):h?(0,r.localize)(52,null,s):(0,r.localize)(53,null,s))}e.fromNow=T;function R(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[110],_e([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ye[43],_e([0,1,16,13,110]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,R){return R&&(T.stack||T.stacktrace)?_.localize(0,null,I(T),P(T.stack)||P(T.stacktrace)):I(T)}function P(T){return Array.isArray(T)?T.join(`
`):T}function I(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?_.localize(1,null,T.message):T.message||_.localize(2,null)}function D(T=null,R=!1){if(!T)return _.localize(3,null);if(Array.isArray(T)){const w=r.coalesce(T),i=D(w[0],R);return w.length>1?_.localize(4,null,i,w.length):i}if(t.isString(T))return T;if(T.detail){const w=T.detail;if(w.error)return A(w.error,R);if(w.exception)return A(w.exception,R)}return T.stack?A(T,R):T.message?T.message:_.localize(5,null)}e.toErrorMessage=D}),define(ye[111],_e([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],_e([0,1,111,23,113,16,27]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=D;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class R{constructor(Q,de,Be,qe){this.id=Q,this.name=de,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,de){return i(Q,de)}compute(Q,de,Be){return Be}}class w{constructor(Q,de){this.newValue=Q,this.didChange=de}}e.ApplyUpdateResult=w;function i(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new w(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Be=Array.isArray(G)&&Array.isArray(Q)&&A.equals(G,Q);return new w(Q,Be)}let de=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const qe=i(G[Be],Q[Be]);qe.didChange&&(G[Be]=qe.newValue,de=!0)}return new w(G,de)}class h{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,de){return i(Q,de)}validate(Q){return this.defaultValue}}class l{constructor(Q,de,Be,qe){this.id=Q,this.name=de,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,de){return i(Q,de)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,de,Be){return Be}}function s(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=s;class g extends l{constructor(Q,de,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Be);super(Q,de,Be,qe)}validate(Q){return s(Q,this.defaultValue)}}function M(G,Q,de,Be){if(typeof G=="undefined")return Q;let qe=parseInt(G,10);return isNaN(qe)?Q:(qe=Math.max(de,qe),qe=Math.min(Be,qe),qe|0)}e.clampedInt=M;class C extends l{constructor(Q,de,Be,qe,lt,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Be,ht.minimum=qe,ht.maximum=lt);super(Q,de,Be,ht);this.minimum=qe,this.maximum=lt}static clampedInt(Q,de,Be,qe){return M(Q,de,Be,qe)}validate(Q){return C.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class b extends l{constructor(Q,de,Be,qe,lt){typeof lt!="undefined"&&(lt.type="number",lt.default=Be);super(Q,de,Be,lt);this.validationFn=qe}static clamp(Q,de,Be){return Q<de?de:Q>Be?Be:Q}static float(Q,de){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return de;const Be=parseFloat(Q);return isNaN(Be)?de:Be}validate(Q){return this.validationFn(b.float(Q,this.defaultValue))}}class u extends l{static string(Q,de){return typeof Q!="string"?de:Q}constructor(Q,de,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Be);super(Q,de,Be,qe)}validate(Q){return u.string(Q,this.defaultValue)}}function S(G,Q,de){return typeof G!="string"||de.indexOf(G)===-1?Q:G}e.stringSet=S;class a extends l{constructor(Q,de,Be,qe,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=qe,lt.default=Be);super(Q,de,Be,lt);this._allowedValues=qe}validate(Q){return S(Q,this.defaultValue,this._allowedValues)}}class F extends R{constructor(Q,de,Be,qe,lt,ht,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=lt,Ye.default=qe);super(Q,de,Be,Ye);this._allowedValues=lt,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function o(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,de,Be){return Be===0?Q.accessibilitySupport:Be}}class d extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertSpace:s(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(p=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(G){switch(G){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function E(G){switch(G){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class v extends h{constructor(){super(128)}compute(Q,de,Be){const qe=["monaco-editor"];return de.get(33)&&qe.push(de.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),de.get(66)==="default"?qe.push("mouse-default"):de.get(66)==="copy"&&qe.push("mouse-copy"),de.get(100)&&qe.push("showUnused"),de.get(126)&&qe.push("showDeprecated"),qe.join(" ")}}class k extends g{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,de,Be){return Be&&Q.emptySelectionClipboard}}class U extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{cursorMoveOnType:s(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":S(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":S(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(de.loop,this.defaultValue.loop)}}}class N extends R{constructor(){super(45,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Boolean(Q)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class y extends h{constructor(){super(44)}compute(Q,de,Be){return Q.fontInfo}}class L extends l{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const de=b.float(Q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(de,6,100)}compute(Q,de,Be){return Q.fontInfo.fontSize}}class W extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(C.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class x extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...de},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...de},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...de},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{multiple:S(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??S(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??S(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??S(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??S(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??S(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),delay:C.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:s(de.sticky,this.defaultValue.sticky),above:s(de.above,this.defaultValue.above)}}}var q;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class ie extends h{constructor(){super(131)}compute(Q,de,Be){return ie.computeLayout(de,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const de=Q.height/Q.lineHeight,Be=Q.scrollBeyondLastLine?de-1:0,qe=(Q.viewLineCount+Be)/(Q.pixelRatio*Q.height),lt=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Be,desiredRatio:qe,minimapLineCount:lt}}static _computeMinimapLayout(Q,de){const Be=Q.outerWidth,qe=Q.outerHeight,lt=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=de.stableMinimapLayoutInput,Ye=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,kt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,ve=Q.minimap.renderCharacters;let te=lt>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ne=Q.minimap.maxColumn,ue=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,ze=Q.viewLineCount,Le=Q.remainingWidth,Ge=Q.isViewportWrapping,ot=ve?2:3;let at=Math.floor(lt*qe);const Ne=at/lt;let ce=!1,he=!1,re=ot*te,V=te/lt,we=1;if(ue==="fill"||ue==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:vt,desiredRatio:bt,minimapLineCount:Ut}=ie.computeContainedMinimapLineCount({viewLineCount:ze,scrollBeyondLastLine:De,height:qe,lineHeight:kt,pixelRatio:lt});if(ze/Ut>1)ce=!0,he=!0,te=1,re=1,V=te/lt;else{let Mt=!1,Dt=te+1;if(ue==="fit"){const St=Math.ceil((ze+vt)*re);Ge&&Ye&&Le<=de.stableFitRemainingWidth?(Mt=!0,Dt=de.stableFitMaxMinimapScale):Mt=St>at}if(ue==="fill"||Mt){ce=!0;const St=te;re=Math.min(kt*lt,Math.max(1,Math.floor(1/bt))),Ge&&Ye&&Le<=de.stableFitRemainingWidth&&(Dt=de.stableFitMaxMinimapScale),te=Math.min(Dt,Math.max(1,Math.floor(re/ot))),te>St&&(we=Math.min(2,te/St)),V=te/lt/we,at=Math.ceil(Math.max(dt,ze+vt)*re),Ge?(de.stableMinimapLayoutInput=Q,de.stableFitRemainingWidth=Le,de.stableFitMaxMinimapScale=te):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Re=Math.floor(ne*V),We=Math.min(Re,Math.max(0,Math.floor((Le-Te-2)*V/(Ae+V)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(lt*We);const mt=He/lt;He=Math.floor(He*we);const Et=ve?1:2,_t=me==="left"?0:Be-We-Te;return{renderMinimap:Et,minimapLeft:_t,minimapWidth:We,minimapHeightIsEditorHeight:ce,minimapIsSampling:he,minimapScale:te,minimapLineHeight:re,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:at,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Ne}}static computeLayout(Q,de){const Be=de.outerWidth|0,qe=de.outerHeight|0,lt=de.lineHeight|0,ht=de.lineNumbersDigitCount|0,Ye=de.typicalHalfwidthCharacterWidth,kt=de.maxDigitWidth,Ae=de.pixelRatio,De=de.viewLineCount,ve=Q.get(123),te=ve==="inherit"?Q.get(122):ve,ne=te==="inherit"?Q.get(118):te,ue=Q.get(121),me=Q.get(2),Te=de.isDominatedByLongLines,ze=Q.get(50),Le=Q.get(60).renderType!==0,Ge=Q.get(61),ot=Q.get(94),at=Q.get(65),Ne=Q.get(92),ce=Ne.verticalScrollbarSize,he=Ne.verticalHasArrows,re=Ne.arrowSize,V=Ne.horizontalScrollbarSize,we=Q.get(58),Re=Q.get(37);let We;if(typeof we=="string"&&/^\d+(\.\d+)?ch$/.test(we)){const wt=parseFloat(we.substr(0,we.length-2));We=C.clampedInt(wt*Ye,0,0,1e3)}else We=C.clampedInt(we,0,0,1e3);Re&&(We+=16);let He=0;if(Le){const wt=Math.max(ht,Ge);He=Math.round(wt*kt)}let mt=0;ze&&(mt=lt);let Et=0,_t=Et+mt,dt=_t+He,vt=dt+We;const bt=Be-mt-He-We;let Ut=!1,It=!1,Mt=-1;me!==2&&(te==="inherit"&&Te?(Ut=!0,It=!0):ne==="on"||ne==="bounded"?It=!0:ne==="wordWrapColumn"&&(Mt=ue));const Dt=ie._computeMinimapLayout({outerWidth:Be,outerHeight:qe,lineHeight:lt,typicalHalfwidthCharacterWidth:Ye,pixelRatio:Ae,scrollBeyondLastLine:ot,minimap:at,verticalScrollbarWidth:ce,viewLineCount:De,remainingWidth:bt,isViewportWrapping:It},de.memory||new T);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Et+=Dt.minimapWidth,_t+=Dt.minimapWidth,dt+=Dt.minimapWidth,vt+=Dt.minimapWidth);const St=bt-Dt.minimapWidth,Qt=Math.max(1,Math.floor((St-ce-2)/Ye)),Vt=he?re:0;return It&&(Mt=Math.max(1,Qt),ne==="bounded"&&(Mt=Math.min(Mt,ue))),{width:Be,height:qe,glyphMarginLeft:Et,glyphMarginWidth:mt,lineNumbersLeft:_t,lineNumbersWidth:He,decorationsLeft:dt,decorationsWidth:We,contentLeft:vt,contentWidth:St,minimap:Dt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:It,wrappingColumn:Mt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:V,overviewRuler:{top:Vt,width:ce,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=ie;class se extends R{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class X extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),fontSize:C.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends b{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>b.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,de,Be){return Q.fontInfo.lineHeight}}class be extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),size:S(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:S(de.side,this.defaultValue.side,["right","left"]),showSlider:S(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(de.renderCharacters,this.defaultValue.renderCharacters),scale:C.clampedInt(de.scale,1,1,3),maxColumn:C.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(G){return G==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{top:C.clampedInt(de.top,0,0,1e3),bottom:C.clampedInt(de.bottom,0,0,1e3)}}}class oe extends R{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),cycle:s(de.cycle,this.defaultValue.cycle)}}}class Ee extends h{constructor(){super(129)}compute(Q,de,Be){return Q.pixelRatio}}class Pe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const de=Q,Be={other:s(de.other,this.defaultValue.other),comments:s(de.comments,this.defaultValue.comments),strings:s(de.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var Oe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class je extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let de=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(de=4,Be=Q):Q==="interval"?de=3:Q==="relative"?de=2:Q==="on"?de=1:de=0),{renderType:de,renderFn:Be}}}function st(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=st;class et extends R{constructor(){const Q=[],de={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const de=[];for(let Be of Q)if(typeof Be=="number")de.push({column:C.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const qe=Be;de.push({column:C.clampedInt(qe.column,0,0,1e4),color:qe.color})}return de.sort((Be,qe)=>Be.column-qe.column),de}return this.defaultValue}}function tt(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q,Be=C.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=C.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:C.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:tt(de.vertical,this.defaultValue.vertical),horizontal:tt(de.horizontal,this.defaultValue.horizontal),useShadows:s(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:C.clampedInt(de.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:C.clampedInt(de.verticalSliderSize,qe,0,1e3),scrollByPage:s(de.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,de){let Be=!1;de.allowedCharacters&&(P.equals(Q.allowedCharacters,de.allowedCharacters)||(Q={...Q,allowedCharacters:de.allowedCharacters},Be=!0)),de.allowedLocales&&(P.equals(Q.allowedLocales,de.allowedLocales)||(Q={...Q,allowedLocales:de.allowedLocales},Be=!0));const qe=super.applyUpdate(Q,de);return Be?new w(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{nonBasicASCII:ae(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,de){if(typeof Q!="object"||!Q)return de;const Be={};for(const[qe,lt]of Object.entries(Q))lt===!0&&(Be[qe]=!0);return Be}}class H extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),mode:S(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class Y extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{bracketPairs:ae(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:s(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(G,Q,de){const Be=de.indexOf(G);return Be===-1?Q:de[Be]}class Se extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertMode:S(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:s(de.showIcons,this.defaultValue.showIcons),showStatusBar:s(de.showStatusBar,this.defaultValue.showStatusBar),preview:s(de.preview,this.defaultValue.preview),previewMode:S(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(de.showMethods,this.defaultValue.showMethods),showFunctions:s(de.showFunctions,this.defaultValue.showFunctions),showConstructors:s(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(de.showDeprecated,this.defaultValue.showDeprecated),showFields:s(de.showFields,this.defaultValue.showFields),showVariables:s(de.showVariables,this.defaultValue.showVariables),showClasses:s(de.showClasses,this.defaultValue.showClasses),showStructs:s(de.showStructs,this.defaultValue.showStructs),showInterfaces:s(de.showInterfaces,this.defaultValue.showInterfaces),showModules:s(de.showModules,this.defaultValue.showModules),showProperties:s(de.showProperties,this.defaultValue.showProperties),showEvents:s(de.showEvents,this.defaultValue.showEvents),showOperators:s(de.showOperators,this.defaultValue.showOperators),showUnits:s(de.showUnits,this.defaultValue.showUnits),showValues:s(de.showValues,this.defaultValue.showValues),showConstants:s(de.showConstants,this.defaultValue.showConstants),showEnums:s(de.showEnums,this.defaultValue.showEnums),showEnumMembers:s(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(de.showKeywords,this.defaultValue.showKeywords),showWords:s(de.showWords,this.defaultValue.showWords),showColors:s(de.showColors,this.defaultValue.showColors),showFiles:s(de.showFiles,this.defaultValue.showFiles),showReferences:s(de.showReferences,this.defaultValue.showReferences),showFolders:s(de.showFolders,this.defaultValue.showFolders),showTypeParameters:s(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(de.showSnippets,this.defaultValue.showSnippets),showUsers:s(de.showUsers,this.defaultValue.showUsers),showIssues:s(de.showIssues,this.defaultValue.showIssues)}}}class Ue extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ve extends h{constructor(){super(130)}compute(Q,de,Be){return de.get(81)?!0:Q.tabFocusMode}}var Qe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Qe=e.WrappingIndent||(e.WrappingIndent={}));function nt(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends h{constructor(){super(132)}compute(Q,de,Be){const qe=de.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const Je="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?pt:Je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(G){return e.editorOptionsRegistry[G.id]=G,G}var At;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:Fe(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:Fe(new n),accessibilityPageSize:Fe(new C(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:Fe(new u(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:Fe(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:Fe(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:Fe(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:Fe(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:Fe(new F(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:Fe(new g(10,"automaticLayout",!1)),autoSurround:Fe(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:Fe(new j),bracketPairGuides:Fe(new Y),stickyTabStops:Fe(new g(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:Fe(new g(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:Fe(new u(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:Fe(new C(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:Fe(new g(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:Fe(new g(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:Fe(new d),contextmenu:Fe(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new g(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:Fe(new F(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:Fe(new g(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:Fe(new F(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:r.localize(182,null)})),cursorSurroundingLines:Fe(new C(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:Fe(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:Fe(new C(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:Fe(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new g(30,"domReadOnly",!1)),dragAndDrop:Fe(new g(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:Fe(new k),extraEditorClassName:Fe(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new b(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(189,null)})),find:Fe(new U),fixedOverflowWidgets:Fe(new g(36,"fixedOverflowWidgets",!1)),folding:Fe(new g(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:Fe(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:Fe(new g(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:Fe(new g(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:Fe(new C(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:Fe(new g(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:Fe(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:Fe(new y),fontLigatures2:Fe(new N),fontSize:Fe(new L),fontWeight:Fe(new W),formatOnPaste:Fe(new g(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:Fe(new g(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:Fe(new g(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:Fe(new x),hideCursorInOverviewRuler:Fe(new g(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:Fe(new $),inDiffEditor:Fe(new g(54,"inDiffEditor",!1)),letterSpacing:Fe(new b(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>b.clamp(G,-5,20),{description:r.localize(203,null)})),lightbulb:Fe(new se),lineDecorationsWidth:Fe(new l(58,"lineDecorationsWidth",10)),lineHeight:Fe(new ge),lineNumbers:Fe(new je),lineNumbersMinChars:Fe(new C(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new g(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:Fe(new g(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:Fe(new a(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:Fe(new be),mouseStyle:Fe(new a(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new b(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:Fe(new g(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:Fe(new g(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:Fe(new F(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:Fe(new a(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:Fe(new g(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:Fe(new g(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:Fe(new C(74,"overviewRulerLanes",3,0,3)),padding:Fe(new fe),parameterHints:Fe(new oe),peekWidgetDefaultFocus:Fe(new a(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:Fe(new g(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:Fe(new Pe),quickSuggestionsDelay:Fe(new C(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:Fe(new g(81,"readOnly",!1)),renameOnType:Fe(new g(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:Fe(new g(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:Fe(new g(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:Fe(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Fe(new g(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:Fe(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:Fe(new C(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new g(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:Fe(new et),scrollbar:Fe(new z),scrollBeyondLastColumn:Fe(new C(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:Fe(new g(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:Fe(new g(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:Fe(new g(96,"selectionClipboard",!0,{description:r.localize(238,null),included:t.isLinux})),selectionHighlight:Fe(new g(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:Fe(new g(98,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:Fe(new g(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:Fe(new g(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:Fe(new X),snippetSuggestions:Fe(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:Fe(new Ue),smoothScrolling:Fe(new g(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:Fe(new C(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new Se),inlineSuggest:Fe(new H),suggestFontSize:Fe(new C(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:Fe(new C(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:Fe(new g(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:Fe(new a(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:Fe(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:Fe(new C(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new K),unusualLineTerminators:Fe(new a(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:Fe(new g(115,"useShadowDOM",!0)),useTabStops:Fe(new g(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:Fe(new u(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:Fe(new a(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:Fe(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new C(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:Fe(new a(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new a(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new F(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],nt,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:Fe(new a(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:Fe(new v),pixelRatio:Fe(new Ee),tabFocusMode:Fe(new Ve),layoutInfo:Fe(new ie),wrappingInfo:Fe(new rt)}}),define(ye[114],_e([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],_e([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],_e([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ye[117],_e([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ye[118],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],_e([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ye[126],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],_e([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var t;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var _;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],_e([0,1,115]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=A;function P(i){if(!A(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=i.match(t);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=P;function I(i){if(!i)return null;let h=i.majorBase,l=i.majorMustEqual,s=i.minorBase,g=i.minorMustEqual,M=i.patchBase,C=i.patchMustEqual;i.hasCaret&&(h===0||(g=!1),C=!1);let b=0;if(i.preRelease){const u=_.exec(i.preRelease);if(u){const[,S,a,F]=u;b=Date.UTC(Number(S),Number(a)-1,Number(F))}}return{majorBase:h,majorMustEqual:l,minorBase:s,minorMustEqual:g,patchBase:M,patchMustEqual:C,isMinimum:i.hasGreaterEquals,notBefore:b}}e.normalizeVersion=I;function D(i,h,l){let s;typeof i=="string"?s=I(P(i)):s=i;let g;h instanceof Date?g=h.getTime():typeof h=="string"&&(g=new Date(h).getTime());let M;if(typeof l=="string"?M=I(P(l)):M=l,!s||!M)return!1;let C=s.majorBase,b=s.minorBase,u=s.patchBase,S=M.majorBase,a=M.minorBase,F=M.patchBase,o=M.notBefore,n=M.majorMustEqual,d=M.minorMustEqual,p=M.patchMustEqual;return M.isMinimum?C>S?!0:C<S?!1:b>a?!0:b<a||g&&g<o?!1:u>=F:(C===1&&S===0&&(!n||!d||!p)&&(S=1,a=0,F=0,n=!0,d=!1,p=!1),C<S?!1:C>S?!n:b<a?!1:b>a?!d:u<F?!1:u>F?!p:!(g&&g<o))}e.isValidVersion=D;function T(i,h,l,s){return l.isBuiltin||typeof l.main=="undefined"?!0:w(i,h,l.engines.vscode,s)}e.isValidExtensionVersion=T;function R(i,h,l){return i==="*"||w(h,l,i)}e.isEngineValid=R;function w(i,h,l,s=[]){let g=I(P(l));if(!g)return s.push(r.localize(0,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return s.push(r.localize(1,null,l)),!1}else if(!g.majorMustEqual)return s.push(r.localize(2,null,l)),!1;return D(i,h,g)?!0:(s.push(r.localize(3,null,i,l)),!1)}}),define(ye[78],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(_,A=[],P=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=r}),define(ye[44],_e([0,1,78]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function _(P,I,D){I instanceof r.SyncDescriptor||(I=new r.SyncDescriptor(I,[],D)),t.push([P,I])}e.registerSingleton=_;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ye[132],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=r;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let P of this._nodes.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const I=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(P);I.outgoing.set(this._hashFn(P),D),D.incoming.set(this._hashFn(A),I)}removeNode(A){const P=this._hashFn(A);this._nodes.delete(P);for(let I of this._nodes.values())I.outgoing.delete(P),I.incoming.delete(P)}lookupOrInsertNode(A){const P=this._hashFn(A);let I=this._nodes.get(P);return I||(I=new r(A),this._nodes.set(P,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[P,I]of this._nodes)A.push(`${P}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,P]of this._nodes){const I=new Set([A]),D=this._findCycle(P,I);if(D)return D}}_findCycle(A,P){for(let[I,D]of A.outgoing){if(P.has(I))return[...P,I].join(" -> ");P.add(I);const T=this._findCycle(D,P);if(T)return T;P.delete(I)}}}e.Graph=t}),define(ye[3],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function I(D){return D[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=I})(r=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function t(P,I,D,T){I[r.DI_TARGET]===I?I[r.DI_DEPENDENCIES].push({id:P,index:D,optional:T}):(I[r.DI_DEPENDENCIES]=[{id:P,index:D,optional:T}],I[r.DI_TARGET]=I)}function _(P){if(r.serviceIds.has(P))return r.serviceIds.get(P);const I=function(D,T,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,D,R,!1)};return I.toString=()=>P,r.serviceIds.set(P,I),I}e.createDecorator=_;function A(P){return P}e.refineServiceDecorator=A}),define(ye[133],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,r.createDecorator)("modelService");function t(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],_e([0,1,4,6,56,133]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function P(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(P):!!D.exclusive}class I{constructor(){this._clock=0,this._entries=[],this._onDidChange=new r.Emitter}get onDidChange(){return this._onDidChange.event}register(T,R){let w={selector:T,provider:R,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(w){const i=this._entries.indexOf(w);i>=0&&(this._entries.splice(i,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(T){return this.all(T).length>0}all(T){if(!T)return[];this._updateScores(T);const R=[];for(let w of this._entries)w._score>0&&R.push(w.provider);return R}ordered(T){const R=[];return this._orderedForEach(T,w=>R.push(w.provider)),R}orderedGroups(T){const R=[];let w,i;return this._orderedForEach(T,h=>{w&&i===h._score?w.push(h.provider):(i=h._score,w=[h.provider],R.push(w))}),R}_orderedForEach(T,R){if(!!T){this._updateScores(T);for(const w of this._entries)w._score>0&&R(w)}}_updateScores(T){const R={uri:T.uri.toString(),language:T.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let w of this._entries)if(w._score=(0,_.score)(w.selector,T.uri,T.getLanguageId(),(0,A.shouldSynchronizeModel)(T)),P(w.selector)&&w._score>0){for(let i of this._entries)i._score=0;w._score=1e3;break}this._entries.sort(I._compareByScoreAndTime)}}static _compareByScoreAndTime(T,R){return T._score<R._score?1:T._score>R._score?-1:T._time<R._time?1:T._time>R._time?-1:0}}e.LanguageFeatureRegistry=I}),define(ye[57],_e([0,1,2,58,134,107,52]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var D;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var T;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var R;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=1024]="ITALIC_MASK",v[v.BOLD_MASK=2048]="BOLD_MASK",v[v.UNDERLINE_MASK=4096]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&768)>>>8}static getFontStyle(k){return(k&15360)>>>10}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){const U=this.getForeground(k);let N="mtk"+U;const y=this.getFontStyle(k);return y&1&&(N+=" mtki"),y&2&&(N+=" mtkb"),y&4&&(N+=" mtku"),y&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(k,U){const N=this.getForeground(k),y=this.getFontStyle(k);let L=`color: ${U[N]};`;y&1&&(L+="font-style: italic;"),y&2&&(L+="font-weight: bold;");let W="";return y&4&&(W+=" underline"),y&8&&(W+=" line-through"),W&&(L+=`text-decoration:${W};`),L}static getPresentationFromMetadata(k){const U=this.getForeground(k),N=this.getFontStyle(k);return{foreground:U,italic:Boolean(N&1),bold:Boolean(N&2),underline:Boolean(N&4),strikethrough:Boolean(N&8)}}}e.TokenMetadata=i;var h;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={}));var l;(function(v){const k=new Map;k.set(0,P.Codicon.symbolMethod),k.set(1,P.Codicon.symbolFunction),k.set(2,P.Codicon.symbolConstructor),k.set(3,P.Codicon.symbolField),k.set(4,P.Codicon.symbolVariable),k.set(5,P.Codicon.symbolClass),k.set(6,P.Codicon.symbolStruct),k.set(7,P.Codicon.symbolInterface),k.set(8,P.Codicon.symbolModule),k.set(9,P.Codicon.symbolProperty),k.set(10,P.Codicon.symbolEvent),k.set(11,P.Codicon.symbolOperator),k.set(12,P.Codicon.symbolUnit),k.set(13,P.Codicon.symbolValue),k.set(15,P.Codicon.symbolEnum),k.set(14,P.Codicon.symbolConstant),k.set(15,P.Codicon.symbolEnum),k.set(16,P.Codicon.symbolEnumMember),k.set(17,P.Codicon.symbolKeyword),k.set(27,P.Codicon.symbolSnippet),k.set(18,P.Codicon.symbolText),k.set(19,P.Codicon.symbolColor),k.set(20,P.Codicon.symbolFile),k.set(21,P.Codicon.symbolReference),k.set(22,P.Codicon.symbolCustomColor),k.set(23,P.Codicon.symbolFolder),k.set(24,P.Codicon.symbolTypeParameter),k.set(25,P.Codicon.account),k.set(26,P.Codicon.issues);function U(L){let W=k.get(L);return W||(console.info("No codicon found for CompletionItemKind "+L),W=P.Codicon.symbolProperty),W}v.toIcon=U;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function y(L,W){let x=N.get(L);return typeof x=="undefined"&&!W&&(x=9),x}v.fromString=y})(l=e.CompletionItemKinds||(e.CompletionItemKinds={}));var s;(function(v){v[v.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var M;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(M=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var S;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(S=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(v){return v&&r.URI.isUri(v.uri)&&t.Range.isIRange(v.range)&&(t.Range.isIRange(v.originSelectionRange)||t.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=a;var F;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(F=e.SymbolKind||(e.SymbolKind={}));var o;(function(v){v[v.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var n;(function(v){const k=new Map;k.set(0,P.Codicon.symbolFile),k.set(1,P.Codicon.symbolModule),k.set(2,P.Codicon.symbolNamespace),k.set(3,P.Codicon.symbolPackage),k.set(4,P.Codicon.symbolClass),k.set(5,P.Codicon.symbolMethod),k.set(6,P.Codicon.symbolProperty),k.set(7,P.Codicon.symbolField),k.set(8,P.Codicon.symbolConstructor),k.set(9,P.Codicon.symbolEnum),k.set(10,P.Codicon.symbolInterface),k.set(11,P.Codicon.symbolFunction),k.set(12,P.Codicon.symbolVariable),k.set(13,P.Codicon.symbolConstant),k.set(14,P.Codicon.symbolString),k.set(15,P.Codicon.symbolNumber),k.set(16,P.Codicon.symbolBoolean),k.set(17,P.Codicon.symbolArray),k.set(18,P.Codicon.symbolObject),k.set(19,P.Codicon.symbolKey),k.set(20,P.Codicon.symbolNull),k.set(21,P.Codicon.symbolEnumMember),k.set(22,P.Codicon.symbolStruct),k.set(23,P.Codicon.symbolEvent),k.set(24,P.Codicon.symbolOperator),k.set(25,P.Codicon.symbolTypeParameter);function U(N){let y=k.get(N);return y||(console.info("No codicon found for SymbolKind "+N),y=P.Codicon.symbolProperty),y}v.toIcon=U})(n=e.SymbolKinds||(e.SymbolKinds={}));class d{constructor(k){this.value=k}}e.FoldingRangeKind=d,d.Comment=new d("comment"),d.Imports=new d("imports"),d.Region=new d("region");var p;(function(v){function k(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}v.is=k})(p=e.Command||(e.Command={}));var c;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var f;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistry;var E;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[79],_e([0,1,13,2,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=A;function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||r.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=P;var I;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function T(g,M){const C=Object.create(null);for(let b in g)R(C,b,g[b],M);return C}e.toValuesTree=T;function R(g,M,C,b){const u=M.split("."),S=u.pop();let a=g;for(let F=0;F<u.length;F++){let o=u[F],n=a[o];switch(typeof n){case"undefined":n=a[o]=Object.create(null);break;case"object":break;default:b(`Ignoring ${M} as ${u.slice(0,F+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[S]=C}catch{b(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function w(g,M){const C=M.split(".");i(g,C)}e.removeFromValueTree=w;function i(g,M){const C=M.shift();if(M.length===0){delete g[C];return}if(Object.keys(g).indexOf(C)!==-1){const b=g[C];typeof b=="object"&&!Array.isArray(b)&&(i(b,M),Object.keys(b).length===0&&delete g[C])}}function h(g,M,C){function b(a,F){let o=a;for(const n of F){if(typeof o!="object"||o===null)return;o=o[n]}return o}const u=M.split("."),S=b(g,u);return typeof S=="undefined"?C:S}e.getConfigurationValue=h;function l(g,M,C){Object.keys(M).forEach(b=>{b!=="__proto__"&&(b in g?r.isObject(g[b])&&r.isObject(M[b])?l(g[b],M[b],C):C&&(g[b]=M[b]):g[b]=M[b])})}e.merge=l;function s(g,M,C){const b=g.inspect(M),u=g.inspect(C);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:b.defaultValue}e.getMigratedSettingValue=s}),define(ye[45],_e([0,1,23,9,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=r.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",r.isMacintosh),P.set("isLinux",r.isLinux),P.set("isWindows",r.isWindows),P.set("isWeb",r.isWeb),P.set("isMacNative",r.isMacintosh&&!r.isWeb),P.set("isEdge",A.indexOf("Edg/")>=0),P.set("isFirefox",A.indexOf("Firefox")>=0),P.set("isChrome",A.indexOf("Chrome")>=0),P.set("isSafari",A.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return i.INSTANCE}static true(){return h.INSTANCE}static has(y){return l.create(y)}static equals(y,L){return s.create(y,L)}static notEquals(y,L){return C.create(y,L)}static regex(y,L){return n.create(y,L)}static in(y,L){return g.create(y,L)}static not(y){return b.create(y)}static and(...y){return c.create(y,null)}static or(...y){return m.create(y,null,!0)}static greater(y,L){return S.create(y,L)}static greaterEquals(y,L){return a.create(y,L)}static smaller(y,L){return F.create(y,L)}static smallerEquals(y,L){return o.create(y,L)}static deserialize(y,L=!1){if(!!y)return this._deserializeOrExpression(y,L)}static _deserializeOrExpression(y,L){let W=y.split("||");return m.create(W.map(x=>this._deserializeAndExpression(x,L)),null,!0)}static _deserializeAndExpression(y,L){let W=y.split("&&");return c.create(W.map(x=>this._deserializeOne(x,L)),null)}static _deserializeOne(y,L){if(y=y.trim(),y.indexOf("!=")>=0){let W=y.split("!=");return C.create(W[0].trim(),this._deserializeValue(W[1],L))}if(y.indexOf("==")>=0){let W=y.split("==");return s.create(W[0].trim(),this._deserializeValue(W[1],L))}if(y.indexOf("=~")>=0){let W=y.split("=~");return n.create(W[0].trim(),this._deserializeRegexValue(W[1],L))}if(y.indexOf(" in ")>=0){let W=y.split(" in ");return g.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const W=y.split(">=");return a.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const W=y.split(">");return S.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const W=y.split("<=");return o.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const W=y.split("<");return F.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(y)?b.create(y.substr(1).trim()):l.create(y)}static _deserializeValue(y,L){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let W=/^'([^']*)'$/.exec(y);return W?W[1].trim():y}static _deserializeRegexValue(y,L){if((0,t.isFalsyOrWhitespace)(y)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=y.indexOf("/"),x=y.lastIndexOf("/");if(W===x||W<0){if(L)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let $=y.slice(W+1,x),q=y[x+1]==="i"?"i":"";try{return new RegExp($,q)}catch(ie){if(L)throw new Error(`bad regexp-value '${y}', parse error: ${ie}`);return console.warn(`bad regexp-value '${y}', parse error: ${ie}`),null}}}e.ContextKeyExpr=T;function R(N,y){const L=N?N.substituteConstants():void 0,W=y?y.substituteConstants():void 0;return!L&&!W?!0:!L||!W?!1:L.equals(W)}e.expressionsAreEqualWithConstantSubstitution=R;function w(N,y){return N.cmp(y)}class i{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=i,i.INSTANCE=new i;class h{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class l{constructor(y,L){this.key=y,this.negated=L,this.type=2}static create(y,L=null){const W=P.get(y);return typeof W=="boolean"?W?h.INSTANCE:i.INSTANCE:new l(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=P.get(this.key);return typeof y=="boolean"?y?h.INSTANCE:i.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class s{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=4}static create(y,L,W=null){if(typeof L=="boolean")return L?l.create(y,W):b.create(y,W);const x=P.get(y);return typeof x=="boolean"?L===(x?"true":"false")?h.INSTANCE:i.INSTANCE:new s(y,L,W)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=P.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?h.INSTANCE:i.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class g{constructor(y,L){this.key=y,this.valueKey=L,this.type=10,this.negated=null}static create(y,L){return new g(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const L=y.getValue(this.valueKey),W=y.getValue(this.key);return Array.isArray(L)?L.indexOf(W)>=0:typeof W=="string"&&typeof L=="object"&&L!==null?I.call(L,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=M.create(this)),this.negated}}e.ContextKeyInExpr=g;class M{constructor(y){this._actual=y,this.type=11}static create(y){return new M(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new M(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=M;class C{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=5}static create(y,L,W=null){if(typeof L=="boolean")return L?b.create(y,W):l.create(y,W);const x=P.get(y);return typeof x=="boolean"?L===(x?"true":"false")?i.INSTANCE:h.INSTANCE:new C(y,L,W)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=P.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?i.INSTANCE:h.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class b{constructor(y,L){this.key=y,this.negated=L,this.type=3}static create(y,L=null){const W=P.get(y);return typeof W=="boolean"?W?i.INSTANCE:h.INSTANCE:new b(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=P.get(this.key);return typeof y=="boolean"?y?i.INSTANCE:h.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function u(N,y){if(typeof N=="string"){const L=parseFloat(N);isNaN(L)||(N=L)}return typeof N=="string"||typeof N=="number"?y(N):i.INSTANCE}class S{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=12}static create(y,L,W=null){return u(L,x=>new S(y,x,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class a{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=13}static create(y,L,W=null){return u(L,x=>new a(y,x,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class F{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=14}static create(y,L,W=null){return u(L,x=>new F(y,x,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=F;class o{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=15}static create(y,L,W=null){return u(L,x=>new o(y,x,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{constructor(y,L){this.key=y,this.regexp=L,this.type=7,this.negated=null}static create(y,L){return new n(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const L=this.regexp?this.regexp.source:"",W=y.regexp?y.regexp.source:"";return L<W?-1:L>W?1:0}equals(y){if(y.type===this.type){const L=this.regexp?this.regexp.source:"",W=y.regexp?y.regexp.source:"";return this.key===y.key&&L===W}return!1}substituteConstants(){return this}evaluate(y){let L=y.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class d{constructor(y){this._actual=y,this.type=8}static create(y){return new d(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new d(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;function p(N){let y=null;for(let L=0,W=N.length;L<W;L++){const x=N[L].substituteConstants();if(N[L]!==x&&y===null){y=[];for(let $=0;$<L;$++)y[$]=N[$]}y!==null&&(y[L]=x)}return y===null?N:y}class c{constructor(y,L){this.expr=y,this.negated=L,this.type=6}static create(y,L){return c._normalizeArr(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,W=this.expr.length;L<W;L++){const x=w(this.expr[L],y.expr[L]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=p(this.expr);return y===this.expr?this:c.create(y,this.negated)}evaluate(y){for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].evaluate(y))return!1;return!0}static _normalizeArr(y,L){const W=[];let x=!1;for(const $ of y)if(!!$){if($.type===1){x=!0;continue}if($.type===0)return i.INSTANCE;if($.type===6){W.push(...$.expr);continue}W.push($)}if(W.length===0&&x)return h.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(w);for(let $=1;$<W.length;$++)W[$-1].equals(W[$])&&(W.splice($,1),$--);if(W.length===1)return W[0];for(;W.length>1;){const $=W[W.length-1];if($.type!==9)break;W.pop();const q=W.pop(),ie=W.length===0,se=m.create($.expr.map(X=>c.create([X,q],null)),null,ie);se&&(W.push(se),W.sort(w))}return W.length===1?W[0]:new c(W,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new c(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){const y=[];for(let L of this.expr)y.push(L.negate());this.negated=m.create(y,this,!0)}return this.negated}}class m{constructor(y,L){this.expr=y,this.negated=L,this.type=9}static create(y,L,W){return m._normalizeArr(y,L,W)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,W=this.expr.length;L<W;L++){const x=w(this.expr[L],y.expr[L]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=p(this.expr);return y===this.expr?this:m.create(y,this.negated,!1)}evaluate(y){for(let L=0,W=this.expr.length;L<W;L++)if(this.expr[L].evaluate(y))return!0;return!1}static _normalizeArr(y,L,W){let x=[],$=!1;if(y){for(let q=0,ie=y.length;q<ie;q++){const se=y[q];if(!!se){if(se.type===0){$=!0;continue}if(se.type===1)return h.INSTANCE;if(se.type===9){x=x.concat(se.expr);continue}x.push(se)}}if(x.length===0&&$)return i.INSTANCE;x.sort(w)}if(x.length!==0){if(x.length===1)return x[0];for(let q=1;q<x.length;q++)x[q-1].equals(x[q])&&(x.splice(q,1),q--);if(x.length===1)return x[0];if(W){for(let q=0;q<x.length;q++)for(let ie=q+1;ie<x.length;ie++)k(x[q],x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0]}return new m(x,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new m(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){let y=[];for(let L of this.expr)y.push(L.negate());for(;y.length>1;){const L=y.shift(),W=y.shift(),x=[];for(const q of U(L))for(const ie of U(W))x.push(c.create([q,ie],null));const $=y.length===0;y.unshift(m.create(x,null,$))}this.negated=y[0]}return this.negated}}class f extends l{constructor(y,L,W){super(y,null);this._defaultValue=L,typeof W=="object"?f._info.push({...W,key:y}):W!==!0&&f._info.push({key:y,description:W,type:L!=null?typeof L:void 0})}static all(){return f._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return s.create(this.key,y)}notEqualsTo(y){return C.create(this.key,y)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(N,y){return N<y?-1:N>y?1:0}function v(N,y,L,W){return N<L?-1:N>L?1:y<W?-1:y>W?1:0}function k(N,y){if(y.type===6&&N.type!==9&&N.type!==6){for(const x of y.expr)if(N.equals(x))return!0}const L=N.negate(),W=U(L).concat(U(y));W.sort(w);for(let x=0;x<W.length;x++){const q=W[x].negate();for(let ie=x+1;ie<W.length;ie++){const se=W[ie];if(q.equals(se))return!0}}return!1}e.implies=k;function U(N){return N.type===9?N.expr:[N]}}),define(ye[135],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[46],_e([0,1,22,17,9,13,2,116,3]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(x){return x.create===!0}e.isFileOpenForWriteOptions=T;var R;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var w;(function(x){x[x.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var i;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=h;function l(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=l;function s(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function g(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=g;function M(x){return h(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=M;var C;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor($,q){super($);this.code=q}}e.FileSystemProviderError=b;function u(x,$){const q=new b(x.toString(),$);return a(q,$),q}e.createFileSystemProviderError=u;function S(x){return x||u((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=S;function a(x,$){return x.name=$?`${$} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=a;function F(x){if(!x)return C.Unknown;if(x instanceof b)return x.code;const $=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!$)return C.Unknown;switch($[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=F;function o(x){if(x instanceof f)return x.fileOperationResult;switch(F(x)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class d{constructor($,q,ie){this.resource=$,this.operation=q,this.target=ie}isOperation($){return this.operation===$}}e.FileOperationEvent=d;var p;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const ie=new Map;for(const se of $){const X=ie.get(se.type);switch(X?X.push([se.resource,se]):ie.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,X]of ie)switch(se){case 1:this.added=r.TernarySearchTree.forUris(()=>q),this.added.fill(X);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>q),this.updated.fill(X);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>q),this.deleted.fill(X);break}}contains($,...q){return this.doContains($,{includeChildren:!1},...q)}affects($,...q){return this.doContains($,{includeChildren:!0},...q)}doContains($,q,...ie){if(!$)return!1;const se=ie.length>0;return!!((!se||ie.includes(1))&&(this.added?.get($)||q.includeChildren&&this.added?.findSuperstr($))||(!se||ie.includes(0))&&(this.updated?.get($)||q.includeChildren&&this.updated?.findSuperstr($))||(!se||ie.includes(2))&&(this.deleted?.findSubstr($)||q.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function m(x,$,q){return!x||!$||x===$||$.length>x.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),q?(0,_.startsWithIgnoreCase)(x,$):x.indexOf($)===0)}e.isParent=m;class f extends Error{constructor($,q,ie){super($);this.fileOperationResult=q,this.options=ie}}e.FileOperationError=f;class E extends f{constructor($,q,ie){super($,2,ie);this.stat=q}}e.NotModifiedSinceFileOperationError=E;var v;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=U;async function N(x,$){if(!$.hasProvider(P.URI.from({scheme:x.scheme})))return new Promise(q=>{const ie=$.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===x.scheme&&se.added&&(ie.dispose(),q())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class y{static formatSize($){return(0,A.isNumber)($)||($=0),$<y.KB?(0,I.localize)(1,null,$.toFixed(0)):$<y.MB?(0,I.localize)(2,null,($/y.KB).toFixed(2)):$<y.GB?(0,I.localize)(3,null,($/y.MB).toFixed(2)):$<y.TB?(0,I.localize)(4,null,($/y.GB).toFixed(2)):(0,I.localize)(5,null,($/y.TB).toFixed(2))}}e.ByteSize=y,y.KB=1024,y.MB=y.KB*y.KB,y.GB=y.MB*y.KB,y.TB=y.GB*y.KB;var L;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function W(x){return{maxFileSize:x===0?300*y.MB:16*y.GB,maxHeapSize:x===0?700*y.MB:2*700*y.MB}}e.getPlatformLimits=W}),define(ye[59],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(..._){this._entries=new Map;for(let[A,P]of _)this.set(A,P)}set(_,A){const P=this._entries.get(_);return this._entries.set(_,A),P}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=r}),define(ye[136],_e([0,1,10,15,78,132,3,59]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class R{constructor(l=new I.ServiceCollection,s=!1,g){this._activeInstantiations=new Set,this._services=l,this._strict=s,this._parent=g,this._services.set(P.IInstantiationService,this)}createChild(l){return new R(l,this._strict,this)}invokeFunction(l,...s){let g=i.traceInvocation(l),M=!1;try{return l({get:b=>{if(M)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(b,g);if(!u)throw new Error(`[invokeFunction] unknown service '${b}'`);return u}},...s)}finally{M=!0,g.stop()}}createInstance(l,...s){let g,M;return l instanceof _.SyncDescriptor?(g=i.traceCreation(l.ctor),M=this._createInstance(l.ctor,l.staticArguments.concat(s),g)):(g=i.traceCreation(l),M=this._createInstance(l,s,g)),g.stop(),M}_createInstance(l,s=[],g){let M=P._util.getServiceDependencies(l).sort((u,S)=>u.index-S.index),C=[];for(const u of M){let S=this._getOrCreateServiceInstance(u.id,g);if(!S&&this._strict&&!u.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${u.id}.`);C.push(S)}let b=M.length>0?M[0].index:s.length;if(s.length!==b){console.warn(`[createInstance] First service dependency of ${l.name} at position ${b+1} conflicts with ${s.length} static arguments`);let u=b-s.length;u>0?s=s.concat(new Array(u)):s=s.slice(0,b)}return new l(...[...s,...C])}_setServiceInstance(l,s){if(this._services.get(l)instanceof _.SyncDescriptor)this._services.set(l,s);else if(this._parent)this._parent._setServiceInstance(l,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let s=this._services.get(l);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):s}_getOrCreateServiceInstance(l,s){let g=this._getServiceInstanceOrDescriptor(l);return g instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,g,s.branch(l,!0)):(s.branch(l,!1),g)}_safeCreateAndCacheServiceInstance(l,s,g){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,s,g)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,s,g){const M=new A.Graph(u=>u.id.toString());let C=0;const b=[{id:l,desc:s,_trace:g}];for(;b.length;){const u=b.pop();if(M.lookupOrInsertNode(u),C++>1e3)throw new T(M);for(let S of P._util.getServiceDependencies(u.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(S.id);if(!a&&!S.optional&&console.warn(`[createInstance] ${l} depends on ${S.id} which is NOT registered.`),a instanceof _.SyncDescriptor){const F={id:S.id,desc:a,_trace:u._trace.branch(S.id,!0)};M.insertEdge(u,F),b.push(F)}}}for(;;){const u=M.roots();if(u.length===0){if(!M.isEmpty())throw new T(M);break}for(const{data:S}of u){if(this._getServiceInstanceOrDescriptor(S.id)instanceof _.SyncDescriptor){const F=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,F)}M.removeNode(S)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,s,g=[],M,C){if(this._services.get(l)instanceof _.SyncDescriptor)return this._createServiceInstance(s,g,M,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,s,g,M,C);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(l,s=[],g,M){if(g){const C=new r.IdleValue(()=>this._createInstance(l,s,M));return new Proxy(Object.create(null),{get(b,u){if(u in b)return b[u];let S=C.value,a=S[u];return typeof a!="function"||(a=a.bind(S),b[u]=a),a},set(b,u,S){return C.value[u]=S,!0}})}else return this._createInstance(l,s,M)}}e.InstantiationService=R;var w;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(w||(w={}));class i{constructor(l,s){this.type=l,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new i(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(l){return D?new i(0,l.name):i._None}branch(l,s){let g=new i(2,l.toString());return this._dep.push([l,s,g]),g}stop(){let l=Date.now()-this._start;i._totals+=l;let s=!1;function g(C,b){let u=[],S=new Array(C+1).join("	");for(const[a,F,o]of b._dep)if(F&&o){s=!0,u.push(`${S}CREATES -> ${a}`);let n=g(C+1,o);n&&u.push(n)}else u.push(`${S}uses -> ${a}`);return u.join(`
`)}let M=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(l>2||s)&&console.log(M.join(`
`))}}e.Trace=i,i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(ye[12],_e([0,1,43,4,6,23,3]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(F){F[F.Trace=0]="Trace",F[F.Debug=1]="Debug",F[F.Info=2]="Info",F[F.Warning=3]="Warning",F[F.Error=4]="Error",F[F.Critical=5]="Critical",F[F.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function T(F,o,n){switch(o){case D.Trace:F.trace(n);break;case D.Debug:F.debug(n);break;case D.Info:F.info(n);break;case D.Warning:F.warn(n);break;case D.Error:F.error(n);break;case D.Critical:F.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function R(F){let o="";for(let n=0;n<F.length;n++){let d=F[n];if(typeof d=="object")try{d=JSON.stringify(d)}catch{}o+=(n>0?" ":"")+d}return o}e.format=R;class w extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,R([o,...n]))}debug(o,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,R([o,...n]))}info(o,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,R([o,...n]))}warn(o,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,R([o,...n]))}error(o,...n){if(this.checkLogLevel(D.Error))if(o instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=o.stack,this.log(D.Error,R(d))}else this.log(D.Error,R([o,...n]))}critical(o,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,R([o,...n]))}flush(){}}e.AbstractMessageLogger=i;class h extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...n):console.log(`[main ${I()}]`,o,...n))}debug(o,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...n):console.log(`[main ${I()}]`,o,...n))}info(o,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...n):console.log(`[main ${I()}]`,o,...n))}warn(o,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,o,...n):console.warn(`[main ${I()}]`,o,...n))}error(o,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,o,...n):console.error(`[main ${I()}]`,o,...n))}critical(o,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,o,...n):console.error(`[main ${I()}]`,o,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class l extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",o,...n)}debug(o,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...n)}info(o,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",o,...n)}warn(o,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",o,...n)}error(o,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",o,...n)}critical(o,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...n)}dispose(){}flush(){}}e.ConsoleLogger=l;class s extends w{constructor(o,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(n)}trace(o,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(o),...n])}debug(o,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(o),...n])}info(o,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(o),...n])}warn(o,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(o),...n])}error(o,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(o),...n])}critical(o,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(o),...n])}extractMessage(o){return typeof o=="string"?o:(0,r.toErrorMessage)(o,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=s;class g extends w{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const n of this.logServices)n.setLevel(o);super.setLevel(o)}trace(o,...n){for(const d of this.logServices)d.trace(o,...n)}debug(o,...n){for(const d of this.logServices)d.debug(o,...n)}info(o,...n){for(const d of this.logServices)d.info(o,...n)}warn(o,...n){for(const d of this.logServices)d.warn(o,...n)}error(o,...n){for(const d of this.logServices)d.error(o,...n)}critical(o,...n){for(const d of this.logServices)d.critical(o,...n)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=g;class M extends _.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...n){this.logger.trace(o,...n)}debug(o,...n){this.logger.debug(o,...n)}info(o,...n){this.logger.info(o,...n)}warn(o,...n){this.logger.warn(o,...n)}error(o,...n){this.logger.error(o,...n)}critical(o,...n){this.logger.critical(o,...n)}flush(){this.logger.flush()}}e.LogService=M;class C extends _.Disposable{constructor(o,n){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(d=>{this.logLevel=d,this.logLevelChangeableLoggers.forEach(p=>p.setLevel(d))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,n){let d=this.loggers.get(o.toString());return d||(d=this.doCreateLogger(o,n?.always?D.Trace:this.logLevel,n),this.loggers.set(o.toString(),d),n?.always||this.logLevelChangeableLoggers.push(d)),d}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return D.Info}trace(o,...n){}debug(o,...n){}info(o,...n){}warn(o,...n){}error(o,...n){}critical(o,...n){}dispose(){}flush(){}}e.NullLogService=b;function u(F){if(F.verbose)return D.Trace;if(typeof F.logLevel=="string"){const o=S(F.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function S(F){switch(F){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=S;function a(F){switch(F){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(ye[80],_e([0,1,34,117,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var P;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(l,s){return s-l}D.compare=T;const R=Object.create(null);R[D.Error]=(0,t.localize)(0,null),R[D.Warning]=(0,t.localize)(1,null),R[D.Info]=(0,t.localize)(2,null);function w(l){return R[l]||""}D.toString=w;function i(l){switch(l){case r.default.Error:return D.Error;case r.default.Warning:return D.Warning;case r.default.Info:return D.Info;case r.default.Ignore:return D.Hint}}D.fromSeverity=i;function h(l){switch(l){case D.Error:return r.default.Error;case D.Warning:return r.default.Warning;case D.Info:return r.default.Info;case D.Hint:return r.default.Ignore}}D.toSeverity=h}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const T="";function R(i){return w(i,!0)}D.makeKey=R;function w(i,h){let l=[T];return i.source?l.push(i.source.replace("\xA6","\\\xA6")):l.push(T),i.code?typeof i.code=="string"?l.push(i.code.replace("\xA6","\\\xA6")):l.push(i.code.value.replace("\xA6","\\\xA6")):l.push(T),i.severity!==void 0&&i.severity!==null?l.push(P.toString(i.severity)):l.push(T),i.message&&h?l.push(i.message.replace("\xA6","\\\xA6")):l.push(T),i.startLineNumber!==void 0&&i.startLineNumber!==null?l.push(i.startLineNumber.toString()):l.push(T),i.startColumn!==void 0&&i.startColumn!==null?l.push(i.startColumn.toString()):l.push(T),i.endLineNumber!==void 0&&i.endLineNumber!==null?l.push(i.endLineNumber.toString()):l.push(T),i.endColumn!==void 0&&i.endColumn!==null?l.push(i.endColumn.toString()):l.push(T),l.push(T),l.join("\xA6")}D.makeKeyOptionalMessage=w})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ye[137],_e([0,1,4,34,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=D}),define(ye[138],_e([0,1,6,9,2,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function P(D,T){return _.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,T):(0,t.startsWithIgnoreCase)(D,T+":")}e.matchesScheme=P;function I(D,...T){return T.some(R=>P(D,R))}e.matchesSomeScheme=I});var xe=this&&this.__decorate||function(ee,e,r,t){var _=arguments.length,A=_<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,r):t,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,r,t);else for(var I=ee.length-1;I>=0;I--)(P=ee[I])&&(A=(_<3?P(A):_>3?P(e,r,A):P(e,r))||A);return _>3&&A&&Object.defineProperty(e,r,A),A},$e=this&&this.__param||function(ee,e){return function(r,t){e(r,t,ee)}};define(ye[139],_e([0,1,10,20,6,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var P;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends _.Disposable{constructor(w,i){super();this.deferred=new r.DeferredPromise,i.withProgress(w,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};D=xe([$e(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends _.Disposable{constructor(w){super();this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(w){this.stop();const i=++this.currentOperationId,h=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:h.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ye[37],_e([0,1,42,13]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(P,I){r.ok(t.isString(P)),r.ok(t.isObject(I)),r.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,I)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new _}),define(ye[140],_e([0,1,4,37]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[_(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new A;t.Registry.add(e.Extensions.JSONContribution,P)}),define(ye[81],_e([0,1,16,4,13,114,140,37]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(P.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(S,a=!0){this.registerConfigurations([S],a)}registerConfigurations(S,a=!0){const F=this.doRegisterConfigurations(S,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:F})}deregisterConfigurations(S){const a=this.doDeregisterConfigurations(S);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:S,remove:a}){const F=[];F.push(...this.doDeregisterConfigurations(a)),F.push(...this.doRegisterConfigurations(S,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(F)})}registerDefaultConfigurations(S){const a=[],F=[];for(const{overrides:o,source:n}of S)for(const d in o)if(a.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const p={...this.configurationDefaultsOverrides.get(d)?.value||{},...o[d]};this.configurationDefaultsOverrides.set(d,{source:n,value:p});const c={type:"object",default:p,description:A.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:_.isString(n)?void 0:n};F.push(...l(d)),this.configurationProperties[d]=c,this.defaultLanguageConfigurationOverridesNode.properties[d]=c}else{this.configurationDefaultsOverrides.set(d,{value:o[d],source:n});const p=this.configurationProperties[d];p&&(this.updatePropertyDefaultValue(d,p),this.updateSchema(d,p))}this.registerOverrideIdentifiers(F),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(S){const a=[];for(const{overrides:F,source:o}of S)for(const n in F){const d=this.configurationDefaultsOverrides.get(n),p=_.isString(o)?o:o?.id,c=_.isString(d?.source)?d?.source:d?.source?.id;if(p===c)if(a.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const m=this.configurationProperties[n];m&&(this.updatePropertyDefaultValue(n,m),this.updateSchema(n,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const a of S)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(S,a){const F=[];return S.forEach(o=>{F.push(...this.validateAndRegisterProperties(o,a,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),F}doDeregisterConfigurations(S){const a=[],F=o=>{if(o.properties)for(const n in o.properties)a.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,o.properties[n]);o.allOf&&o.allOf.forEach(n=>F(n))};for(const o of S){F(o);const n=this.configurationContributors.indexOf(o);n!==-1&&this.configurationContributors.splice(n,1)}return a}validateAndRegisterProperties(S,a=!0,F,o,n=3){n=_.isUndefinedOrNull(S.scope)?n:S.scope;let d=[],p=S.properties;if(p)for(let m in p){if(a&&C(m)){delete p[m];continue}const f=p[m];if(f.source=F,f.defaultDefaultValue=p[m].default,this.updatePropertyDefaultValue(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=_.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=_.isUndefinedOrNull(f.restricted)?!!o?.includes(m):f.restricted),p[m].hasOwnProperty("included")&&!p[m].included){this.excludedConfigurationProperties[m]=p[m],delete p[m];continue}else this.configurationProperties[m]=p[m];!p[m].deprecationMessage&&p[m].markdownDeprecationMessage&&(p[m].deprecationMessage=p[m].markdownDeprecationMessage),d.push(m)}let c=S.allOf;if(c)for(let m of c)d.push(...this.validateAndRegisterProperties(m,a,F,o,n));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(S){const a=F=>{let o=F.properties;if(o)for(const d in o)this.updateSchema(d,o[d]);let n=F.allOf;n&&n.forEach(a)};a(S)}updateSchema(S,a){switch(e.allSettings.properties[S]=a,a.scope){case 1:e.applicationSettings.properties[S]=a;break;case 2:e.machineSettings.properties[S]=a;break;case 6:e.machineOverridableSettings.properties[S]=a;break;case 3:e.windowSettings.properties[S]=a;break;case 4:e.resourceSettings.properties[S]=a;break;case 5:e.resourceSettings.properties[S]=a,this.resourceLanguageSettingsSchema.properties[S]=a;break}}removeFromSchema(S,a){switch(delete e.allSettings.properties[S],a.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S],delete this.resourceLanguageSettingsSchema.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const a=`[${S}]`,F={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,F),e.allSettings.properties[a]=F,e.applicationSettings.properties[a]=F,e.machineSettings.properties[a]=F,e.machineOverridableSettings.properties[a]=F,e.windowSettings.properties[a]=F,e.resourceSettings.properties[a]=F}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const S={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,a){const F=this.configurationDefaultsOverrides.get(S);let o=F?.value,n=F?.source;_.isUndefined(o)&&(o=a.defaultDefaultValue,n=void 0),_.isUndefined(o)&&(o=g(a.type)),a.default=o,a.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",h=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(u){const S=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let a=h.exec(u);for(;a?.length;){const F=a[1].trim();F&&S.push(F),a=h.exec(u)}}return(0,r.distinct)(S)}e.overrideIdentifiersFromKey=l;function s(u){return u.reduce((S,a)=>`${S}[${a}]`,"")}e.keyFromOverrideIdentifiers=s;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const M=new w;I.Registry.add(e.Extensions.Configuration,M);function C(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?A.localize(7,null,u):M.getConfigurationProperties()[u]!==void 0?A.localize(8,null,u):null:A.localize(6,null)}e.validateProperty=C;function b(){const u=[],S=M.getConfigurationProperties();for(const a of Object.keys(S))u.push([a,S[a].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=b}),define(ye[141],_e([0,1,16,4,99,6,22,27,13,2,79,81,37]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(o={},n=[],d=[]){this._contents=o,this._keys=n,this._overrides=d,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,R.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,n){const d=this.getContentsForOverrideIdentifer(n);return d?o?(0,R.getConfigurationValue)(d,o):d:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const d of this.overrides)d.identifiers.includes(o)&&n.push(...d.keys);return r.distinct(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return r.distinct(o)}override(o){let n=this.overrideConfigurations.get(o);return n||(n=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,n)),n}merge(...o){const n=I.deepClone(this.contents),d=I.deepClone(this.overrides),p=[...this.keys];for(const c of o){this.mergeContents(n,c.contents);for(const m of c.overrides){const[f]=d.filter(E=>r.equals(E.identifiers,m.identifiers));f?(this.mergeContents(f.contents,m.contents),f.keys.push(...m.keys),f.keys=r.distinct(f.keys)):d.push(I.deepClone(m))}for(const m of c.keys)p.indexOf(m)===-1&&p.push(m)}return new h(n,p,d)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const n=this.getContentsForOverrideIdentifer(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let d={};for(const p of r.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[p],m=n[p];m&&(typeof c=="object"&&typeof m=="object"?(c=I.deepClone(c),this.mergeContents(c,m)):c=m),d[p]=c}return new h(d,this.keys,this.overrides)}mergeContents(o,n){for(const d of Object.keys(n)){if(d in o&&D.isObject(o[d])&&D.isObject(n[d])){this.mergeContents(o[d],n[d]);continue}o[d]=I.deepClone(n[d])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?I.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let n=null,d=null;const p=c=>{c&&(d?this.mergeContents(d,c):d=I.deepClone(c))};for(const c of this.overrides)r.equals(c.identifiers,[o])?n=c.contents:c.identifiers.includes(o)&&p(c.contents);return p(n),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,n){this.addKey(o),(0,R.addToValueTree)(this.contents,o,n,d=>{throw new Error(d)})}removeValue(o){this.removeKey(o)&&(0,R.removeFromValueTree)(this.contents,o)}addKey(o){let n=this.keys.length;for(let d=0;d<n;d++)o.indexOf(this.keys[d])===0&&(n=d);this.keys.splice(n,1,o)}removeKey(o){let n=this.keys.indexOf(o);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class l extends h{constructor(o={}){const n=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(n),p=Object.create(null),c=[];for(const m in n){const f=o[m],E=f!==void 0?f:n[m].default;(0,R.addToValueTree)(p,m,E,v=>console.error(`Conflict in default settings: ${v}`))}for(const m of Object.keys(p))w.OVERRIDE_PROPERTY_REGEX.test(m)&&c.push({identifiers:(0,w.overrideIdentifiersFromKey)(m),keys:Object.keys(p[m]),contents:(0,R.toValuesTree)(p[m],f=>console.error(`Conflict in default settings file: ${f}`))});super(p,d,c)}}e.DefaultConfigurationModel=l;class s{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,n){if(!D.isUndefinedOrNull(o)){const d=this.doParseContent(o);this.parseRaw(d,n)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,n){this._raw=o;const{contents:d,keys:p,overrides:c,restricted:m}=this.doParseRaw(o,n);this._configurationModel=new h(d,p,c),this._restrictedConfigurations=m||[]}doParseContent(o){let n={},d=null,p=[],c=[],m=[];function f(v){Array.isArray(p)?p.push(v):d!==null&&(p[d]=v)}let E={onObjectBegin:()=>{let v={};f(v),c.push(p),p=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{p=c.pop()},onArrayBegin:()=>{let v=[];f(v),c.push(p),p=v,d=null},onArrayEnd:()=>{p=c.pop()},onLiteralValue:f,onError:(v,k,U)=>{m.push({error:v,offset:k,length:U})}};if(o)try{_.visit(o,E),n=p[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(o,n){const d=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),p=this.filter(o,d,!0,n);o=p.raw;const c=(0,R.toValuesTree)(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),m=Object.keys(o),f=this.toOverrides(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:c,keys:m,overrides:f,restricted:p.restricted}}filter(o,n,d,p){if(!p?.scopes&&!p?.skipRestricted)return{raw:o,restricted:[]};const c={},m=[];for(let f in o)if(w.OVERRIDE_PROPERTY_REGEX.test(f)&&d){const E=this.filter(o[f],n,!1,p);c[f]=E.raw,m.push(...E.restricted)}else{const E=n[f],v=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&m.push(f),(v===void 0||p.scopes===void 0||p.scopes.includes(v))&&(p.skipRestricted&&E?.restricted||(c[f]=o[f]))}return{raw:c,restricted:m}}toOverrides(o,n){const d=[];for(const p of Object.keys(o))if(w.OVERRIDE_PROPERTY_REGEX.test(p)){const c={};for(const m in o[p])c[m]=o[p][m];d.push({identifiers:(0,w.overrideIdentifiersFromKey)(p),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,n)})}return d}}e.ConfigurationModelParser=s;class g extends A.Disposable{constructor(o,n,d,p){super();this.userSettingsResource=o,this.scopes=n,this.fileService=p,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class M{constructor(o,n,d=new h,p=new h,c=new P.ResourceMap,m=new h,f=new P.ResourceMap,E=!0){this._defaultConfiguration=o,this._localUserConfiguration=n,this._remoteUserConfiguration=d,this._workspaceConfiguration=p,this._folderConfigurations=c,this._memoryConfiguration=m,this._memoryConfigurationByResource=f,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(o,n,d){return this.getConsolidateConfigurationModel(n,d).getValue(o)}updateValue(o,n,d={}){let p;d.resource?(p=this._memoryConfigurationByResource.get(d.resource),p||(p=new h,this._memoryConfigurationByResource.set(d.resource,p))):p=this._memoryConfiguration,n===void 0?p.removeValue(o):p.setValue(o,n),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,n,d){const p=this.getConsolidateConfigurationModel(n,d),c=this.getFolderConfigurationModelForResource(n.resource,d),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,f=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),k=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),U=d?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,N=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(o):c.freeze().getValue(o):void 0,y=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(o):m.getValue(o),L=p.getValue(o),W=r.distinct(r.flatten(p.overrides.map(x=>x.identifiers))).filter(x=>p.getOverrideValue(o,x)!==void 0);return{defaultValue:f,userValue:E,userLocalValue:v,userRemoteValue:k,workspaceValue:U,workspaceFolderValue:N,memoryValue:y,value:L,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(o),override:n.overrideIdentifier?c?.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:m.getValue(o),override:n.overrideIdentifier?m.getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(o){const n=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,n){this._folderConfigurations.set(o,n),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const d=[];if(!n){const{added:p,updated:c,removed:m}=S(this._defaultConfiguration,o);n=[...p,...c,...m]}for(const p of n)for(const c of(0,w.overrideIdentifiersFromKey)(p)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(c),f=o.getKeysForOverrideIdentifier(c),E=[...f.filter(v=>m.indexOf(v)===-1),...m.filter(v=>f.indexOf(v)===-1),...m.filter(v=>!I.equals(this._defaultConfiguration.override(c).getValue(v),o.override(c).getValue(v)))];d.push([c,E])}return this.updateDefaultConfiguration(o),{keys:n,overrides:d}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:d,removed:p,overrides:c}=S(this.localUserConfiguration,o),m=[...n,...d,...p];return m.length&&this.updateLocalUserConfiguration(o),{keys:m,overrides:c}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:d,removed:p,overrides:c}=S(this.remoteUserConfiguration,o);let m=[...n,...d,...p];return m.length&&this.updateRemoteUserConfiguration(o),{keys:m,overrides:c}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:d,removed:p,overrides:c}=S(this.workspaceConfiguration,o);let m=[...n,...d,...p];return m.length&&this.updateWorkspaceConfiguration(o),{keys:m,overrides:c}}compareAndUpdateFolderConfiguration(o,n){const d=this.folderConfigurations.get(o),{added:p,updated:c,removed:m,overrides:f}=S(d,n);let E=[...p,...c,...m];return(E.length||!d)&&this.updateFolderConfiguration(o,n),{keys:E,overrides:f}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:d,updated:p,removed:c,overrides:m}=S(n,void 0);return{keys:[...d,...p,...c],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,n){let d=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier?d.override(o.overrideIdentifier):d}getConsolidatedConfigurationModelForResource({resource:o},n){let d=this.getWorkspaceConsolidatedConfiguration();if(n&&o){const p=n.getFolder(o);p&&(d=this.getFolderConsolidatedConfiguration(p.uri)||d);const c=this._memoryConfigurationByResource.get(o);c&&(d=d.merge(c))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let n=this._foldersConsolidatedConfigurations.get(o);if(!n){const d=this.getWorkspaceConsolidatedConfiguration(),p=this._folderConfigurations.get(o);p?(n=d.merge(p),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(o,n)):n=d}return n}getFolderConfigurationModelForResource(o,n){if(n&&o){const d=n.getFolder(o);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,n)=>{const{contents:d,overrides:p,keys:c}=this._folderConfigurations.get(n);return o.push([n,{contents:d,overrides:p,keys:c}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>o.add(n)),this.userConfiguration.freeze().keys.forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(d=>o.add(d))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(d=>o.add(d))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(d=>n.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(d=>n.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(o).forEach(p=>n.add(p))),[...n.values()]}static parse(o){const n=this.parseConfigurationModel(o.defaults),d=this.parseConfigurationModel(o.user),p=this.parseConfigurationModel(o.workspace),c=o.folders.reduce((m,f)=>(m.set(T.URI.revive(f[0]),this.parseConfigurationModel(f[1])),m),new P.ResourceMap);return new M(n,d,new h,p,c,new h,new P.ResourceMap,!1)}static parseConfigurationModel(o){return new h(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=M;function C(...F){if(F.length===0)return{keys:[],overrides:[]};if(F.length===1)return F[0];const o=new Set,n=new Map;for(const p of F)p.keys.forEach(c=>o.add(c)),p.overrides.forEach(([c,m])=>{const f=(0,P.getOrSet)(n,c,new Set);m.forEach(E=>f.add(E))});const d=[];return n.forEach((p,c)=>d.push([c,[...p.values()]])),{keys:[...o.values()],overrides:d}}e.mergeChanges=C;class b{constructor(o,n,d,p){this.change=o,this.previous=n,this.currentConfiguraiton=d,this.currentWorkspace=p,this._previousConfiguration=void 0;const c=new Set;o.keys.forEach(f=>c.add(f)),o.overrides.forEach(([,f])=>f.forEach(E=>c.add(E))),this.affectedKeys=[...c.values()];const m=new h;this.affectedKeys.forEach(f=>m.setValue(f,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=M.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(n){const d=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.previous?.workspace):void 0,p=this.currentConfiguraiton.getValue(o,n,this.currentWorkspace);return!I.equals(d,p)}return!0}return!1}doesAffectedKeysTreeContains(o,n){let d=(0,R.toValuesTree)({[n]:!0},()=>{}),p;for(;typeof d=="object"&&(p=Object.keys(d)[0]);){if(o=o[p],!o)return!1;d=d[p]}return!0}}e.ConfigurationChangeEvent=b;class u extends b{constructor(o,n,d,p){super({keys:o.allKeys(),overrides:[]},void 0,o,n);this.source=d,this.sourceConfig=p}}e.AllKeysConfigurationChangeEvent=u;function S(F,o){const{added:n,removed:d,updated:p}=a(o,F),c=[],m=F?.getAllOverrideIdentifiers()||[],f=o?.getAllOverrideIdentifiers()||[];if(o){const E=f.filter(v=>!m.includes(v));for(const v of E)c.push([v,o.getKeysForOverrideIdentifier(v)])}if(F){const E=m.filter(v=>!f.includes(v));for(const v of E)c.push([v,F.getKeysForOverrideIdentifier(v)])}if(o&&F){for(const E of m)if(f.includes(E)){const v=a({contents:F.getOverrideValue(void 0,E)||{},keys:F.getKeysForOverrideIdentifier(E)},{contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)});c.push([E,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:d,updated:p,overrides:c}}function a(F,o){const n=F?o?F.keys.filter(c=>o.keys.indexOf(c)===-1):[...F.keys]:[],d=o?F?o.keys.filter(c=>F.keys.indexOf(c)===-1):[...o.keys]:[],p=[];if(F&&o){for(const c of o.keys)if(F.keys.indexOf(c)!==-1){const m=(0,R.getConfigurationValue)(o.contents,c),f=(0,R.getConfigurationValue)(F.contents,c);I.equals(m,f)||p.push(c)}}return{added:n,removed:d,updated:p}}}),define(ye[82],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(P,I=t.Unknown,D){super(P);this._message=P,this._code=I,this._detail=D,this.isHandled=I===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(P){return P instanceof _&&P._code===t.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof _&&P._code===t.NoResolverFound}static isHandled(P){return P instanceof _&&P.isHandled}}e.RemoteAuthorityResolverError=_}),define(ye[60],_e([0,1,11]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function _(T){if(!T)return;const R=T.indexOf("+");return R<0?T:T.substr(0,R)}e.getRemoteName=_;function A(T){return T.scheme!==r.Schemas.file&&T.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=A;function P(T){if(T.folders.length)return T.folders.every(R=>A(R.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=P;function I(T){return P(T)?.scheme}e.getVirtualWorkspaceScheme=I;function D(T){return P(T)!==void 0}e.isVirtualWorkspace=D}),define(ye[25],_e([0,1,9,3,60]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,l){if(typeof h=="undefined"||h===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof h=="string"||typeof l=="string"){let s=typeof h=="string"?h:h.value,g=typeof l=="string"?l:l.value;return r.equalsIgnoreCase(s,g)}return h._lower===l._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=D;function T(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function w(i,h){if(h){const l=`onResolveRemoteAuthority:${(0,_.getRemoteName)(h)}`;return i.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],_e([0,1,9,25]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(l,s){return l.uuid&&s.uuid?l.uuid===s.uuid:l.id===s.id?!0:(0,r.compareIgnoreCase)(l.id,s.id)===0}e.areSameExtensions=_;class A{constructor(s,g){this.version=g,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof A?_(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=A;function P(l,s){return`${l}.${s}`}e.getExtensionId=P;function I(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(l,s){return I(P(l,s))}e.getGalleryExtensionId=D;function T(l,s){const g=[],M=C=>{for(const b of g)if(b.some(u=>_(s(u),s(C))))return b;return null};for(const C of l){const b=M(C);b?b.push(C):g.push([C])}return g}e.groupByExtension=T;function R(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function w(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(l){const s=new Set;if(l.malicious)for(const g of l.malicious)s.add(g.id);return s}e.getMaliciousExtensionsSet=i;function h(l,s){const g=[],M=s.manifest.extensionDependencies?.slice(0)??[];for(;M.length;){const C=M.shift();if(C&&g.every(b=>!_(b.identifier,{id:C}))){const b=l.filter(u=>_(u.identifier,{id:C}));b.length===1&&(g.push(b[0]),M.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=h}),define(ye[143],_e([0,1,4,23,3,12]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var P;(function(l){l.Http="http",l.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=w;function i(l,s){return s?s!==1&&l<1024:!t.isWindows&&l<1024}e.isPortPrivileged=i;let h=class{constructor(s){this.logService=s,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],g=Array.from(this._tunnels.values());for(let M of g){const C=Array.from(M.values());for(let b of C){const u=await b.value;u&&s.push(u)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:g}of s.values())await g.then(M=>M?.dispose());s.clear()}this._tunnels.clear()}openTunnel(s,g,M,C,b=!1,u=I.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${M} on local port ${C}.`),!s)return;g||(g="localhost");const a=this.retainOrCreateTunnel(s,g,M,C,b,u,S);return a?a.then(F=>{if(!F){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,M);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(F);return(F.tunnelRemoteHost!==g||F.tunnelRemotePort!==M)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const g=this._tunnels.get(s.tunnelRemoteHost);if(g){const M=g.get(s.tunnelRemotePort);M&&(M.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,M))}}}}async tryDisposeTunnel(s,g,M){if(M.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${g}.`);const C=M.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(g),C}}async closeTunnel(s,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${g} `);const M=this._tunnels.get(s);if(M&&M.has(g)){const C=M.get(g);C.refcount=0,await this.tryDisposeTunnel(s,g,C)}}addTunnelToMap(s,g,M){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(g,{refcount:1,value:M})}async removeEmptyTunnelFromMap(s,g){const M=this._tunnels.get(s);M&&(await M.get(g)||M.delete(g),M.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,g){let M=[s];R(s)?(M.push(...e.LOCALHOST_ADDRESSES),M.push(...e.ALL_INTERFACES_ADDRESSES)):w(s)&&M.push(...e.ALL_INTERFACES_ADDRESSES);const C=M.map(b=>this._tunnels.get(b));for(const b of C){const u=b?.get(g);if(u)return u}}canTunnel(s){return!!T(s)}createWithProvider(s,g,M,C,b,u,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${M} on local port ${C}.`);const F={elevationRequired:b?i(C===void 0?M:C):!1},o={remoteAddress:{host:g,port:M},localAddressPort:C,privacy:u,public:u!==I.Private,protocol:S},n=s.forwardPort(o,F);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(g,M,n),n}};h=xe([$e(0,A.ILogService)],h),e.AbstractTunnelService=h}),define(ye[144],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,P=5){let I;return I=A(D=>{const T=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(_);if(R){R.data.push(T);return}const w=setTimeout(()=>this.flushBuffer(_),P);R={data:[T],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(_),I.dispose()}},this._terminalBufferMap.set(_,R)}),I}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=r}),define(ye[145],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(ye[61],_e([0,1,52,4,6,3,37,145]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(g){function M(C){return C&&typeof C=="object"&&typeof C.id=="string"}g.isThemeColor=M})(D=e.ThemeColor||(e.ThemeColor={}));function T(g){return{id:g}}e.themeColorFromId=T;var R;(function(g){function M(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}g.isThemeIcon=M;const C=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function b(n){const d=C.exec(n);if(!d)return;let[,p]=d;return{id:p}}g.fromString=b;function u(n){return{id:n}}g.fromId=u;function S(n,d){let p=n.id;const c=p.lastIndexOf("~");return c!==-1&&(p=p.substring(0,c)),d&&(p=`${p}~${d}`),{id:p}}g.modify=S;function a(n){const d=n.id.lastIndexOf("~");if(d!==-1)return n.id.substring(d+1)}g.getModifier=a;function F(n,d){return n.id===d.id&&n.color?.id===d.color?.id}g.isEqual=F;function o(n,d){return{id:n.id,color:d?T(d):void 0}}g.asThemeIcon=o,g.asClassNameArray=r.CSSIcon.asClassNameArray,g.asClassName=r.CSSIcon.asClassName,g.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function w(g){switch(g){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(M){return this.themingParticipants.push(M),this.onThemingParticipantAddedEmitter.fire(M),(0,_.toDisposable)(()=>{const C=this.themingParticipants.indexOf(M);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new i;P.Registry.add(e.Extensions.ThemingContribution,h);function l(g){return h.onColorThemeChange(g)}e.registerThemingParticipant=l;class s extends _.Disposable{constructor(M){super();this.themeService=M,this.theme=M.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(M){this.theme=M,this.updateStyles()}updateStyles(){}getColor(M,C){let b=this.theme.getColor(M);return b&&C&&(b=C(b,this.theme)),b?b.toString():null}}e.Themable=s}),define(ye[47],_e([0,1,22,24,2,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function I(i){const h=i;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=I;function D(i){const h=i;return!!(h&&typeof h=="object"&&_.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(h,l,s,g,M){this._id=h,this._transient=s,this._configuration=g,this._ignorePathCasing=M,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(h){this._id=h.id,this._configuration=h.configuration,this._transient=h.transient,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class R{constructor(h,l){this.raw=l,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,t.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function w(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w}),define(ye[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(ye[30],_e([0,1,11,24,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const D=this._providerInfo.get(I.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(I,D){D===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,D)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(ye[146],_e([0,1,10]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(P,I,D){this._deferredPromises=new Map,this._id=P,this._shared=I,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of T.values())R.complete()}catch(R){for(const w of T.values())w.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,I){let D=this._value[P];return typeof D=="undefined"&&(D=I),D}update(P,I){this._value[P]=I;let D=this._deferredPromises.get(P);if(D!==void 0)return D.p;const T=new r.DeferredPromise;return this._deferredPromises.set(P,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class _ extends t{constructor(P,I){super(P.identifier.value,!0,I);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=_}),define(ye[147],_e([0,1,4,2,12]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=xe([$e(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ye[14],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[148],_e([0,1,25,4]),function(ee,e,r,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,D){_.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(I.identifier),Xe(this,_,D,"f"),Ie(this,_,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(I){return Ie(this,_,"f").get(this._id,I)}store(I,D){return Ie(this,_,"f").store(this._id,I,D)}delete(I){return Ie(this,_,"f").delete(this._id,I)}}e.ExtensionSecrets=A,_=new WeakMap}),define(ye[83],_e([0,1,3,4]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(ye[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(C){C[C.Upsert=0]="Upsert",C[C.RemoveChild=1]="RemoveChild",C[C.Invalidated=2]="Invalidated",C[C.SetProp=3]="SetProp",C[C.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,_=(C,b)=>{const u={controllerId:b};return t.set(C,u),u};e.createPrivateApiFor=_;const A=C=>t.get(C);e.getPrivateApiFor=A;const P=(C,b,u,S)=>{let a=u;return{enumerable:!0,configurable:!1,get(){return a},set(F){if(!S(a,F)){const o=a;a=F,C.listener?.({op:3,key:b,value:F,previous:o})}}}},I=(C,b)=>C===b,D={range:(C,b)=>C===b?!0:!C||!b?!1:C.isEqual(b),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(C,b)=>!(C.length!==b.length||C.some(u=>!b.find(S=>u.id===S.id)))},T=Object.keys(D),R=(C,b)=>({range:P(C,"range",void 0,D.range),label:P(C,"label",b,D.label),description:P(C,"description",void 0,D.description),canResolveChildren:P(C,"canResolveChildren",!1,D.canResolveChildren),busy:P(C,"busy",!1,D.busy),error:P(C,"error",void 0,D.error),tags:P(C,"tags",[],D.tags)}),w=(C,b)=>{const u=new Map;for(const S of T)D[S](C[S],b[S])||u.set(S,b[S]);return u};e.diffTestItems=w;class i extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=i;class h extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class l extends Error{constructor(b,u,S){super(`TestItem with ID "${b}" is from controller "${u}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=l;const s=C=>{const b=(0,e.getPrivateApiFor)(C);let u=new Map;return{get size(){return u.size},forEach(S,a){for(const F of u.values())S.call(a,F,this)},replace(S){const a=new Map,F=new Set(u.keys()),o={op:4,ops:[]};for(const n of S){if(!(n instanceof g))throw new h(n.id);const d=(0,e.getPrivateApiFor)(n).controllerId;if(d!==b.controllerId)throw new l(n.id,d,b.controllerId);if(a.has(n.id))throw new i(n.id);a.set(n.id,n),F.delete(n.id),o.ops.push({op:0,item:n})}for(const n of F.keys())o.ops.push({op:1,id:n});b.listener?.(o),u=a},add(S){if(!(S instanceof g))throw new h(S.id);u.set(S.id,S),b.listener?.({op:0,item:S})},delete(S){u.delete(S)&&b.listener?.({op:1,id:S})},get(S){return u.get(S)},toJSON(){return Array.from(u.values())},[Symbol.iterator](){return u.values()}}};class g{constructor(b,u,S,a){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const F=(0,e.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return F.parent instanceof M?void 0:F.parent}},children:{value:s(this),enumerable:!0,writable:!1},...R(F,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class M extends g{constructor(b,u){super(b,b,u,void 0)}}e.TestItemRootImpl=M}),define(ye[63],_e([0,1,3,143,4,14]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(D){function T(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:w.protocol}}D.fromApiTunnel=T;function R(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==t.TunnelPrivacyId.ConstantPrivate&&w.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}D.fromServiceTunnel=R})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let I=class{constructor(T){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,R){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,R){return{dispose:()=>{}}}async $providePortAttributes(T,R,w,i,h){return[]}async $forwardPort(T,R){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=xe([$e(0,A.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[7],_e([0,1,16,15,75,22,74,9,13,2,36,46,82]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";var h,l,s,g,M,C,b,u,S,a,F,o,n,d,p,c,m,f,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(B){function O(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(O,B),Object.setPrototypeOf(O.prototype,B.prototype),O}let U=M=class{constructor(O){h.set(this,void 0),Xe(this,h,O,"f")}static from(...O){let Z=O;return new M(function(){if(Z){for(const Ce of Z)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();Z=void 0}})}dispose(){typeof Ie(this,h,"f")=="function"&&(Ie(this,h,"f").call(this),Xe(this,h,void 0,"f"))}};h=new WeakMap,U=M=xe([k],U),e.Disposable=U;let N=C=class{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=Z}static Min(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let Ce=1;Ce<O.length;Ce++){const Ke=O[Ce];Ke.isBefore(Z)&&(Z=Ke)}return Z}static Max(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let Ce=1;Ce<O.length;Ce++){const Ke=O[Ce];Ke.isAfter(Z)&&(Z=Ke)}return Z}static isPosition(O){if(!O)return!1;if(O instanceof C)return!0;let{line:Z,character:Ce}=O;return typeof Z=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,Z=0){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof O=="undefined"?Ce=0:typeof O=="number"?Ce=O:(Ce=typeof O.lineDelta=="number"?O.lineDelta:0,Z=typeof O.characterDelta=="number"?O.characterDelta:0),Ce===0&&Z===0?this:new C(this.line+Ce,this.character+Z)}with(O,Z=this.character){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof O=="undefined"?Ce=this.line:typeof O=="number"?Ce=O:(Ce=typeof O.line=="number"?O.line:this.line,Z=typeof O.character=="number"?O.character:this.character),Ce===this.line&&Z===this.character?this:new C(Ce,Z)}toJSON(){return{line:this.line,character:this.character}}};N=C=xe([k],N),e.Position=N;let y=b=class{constructor(O,Z,Ce,Ke){let it,ct;if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new N(O,Z),ct=new N(Ce,Ke)):O instanceof N&&Z instanceof N&&(it=O,ct=Z),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this._start=it,this._end=ct):(this._start=ct,this._end=it)}static isRange(O){return O instanceof b?!0:O?N.isPosition(O.start)&&N.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof b?this.contains(O._start)&&this.contains(O._end):O instanceof N?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const Z=N.Max(O.start,this._start),Ce=N.Min(O.end,this._end);if(!Z.isAfter(Ce))return new b(Z,Ce)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const Z=N.Min(O.start,this._start),Ce=N.Max(O.end,this.end);return new b(Z,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,Z=this.end){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return O?N.isPosition(O)?Ce=O:(Ce=O.start||this.start,Z=O.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&Z.isEqual(this.end)?this:new b(Ce,Z)}toJSON(){return[this.start,this.end]}};y=b=xe([k],y),e.Range=y;let L=u=class extends y{constructor(O,Z,Ce,Ke){let it,ct;if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new N(O,Z),ct=new N(Ce,Ke)):O instanceof N&&Z instanceof N&&(it=O,ct=Z),!it||!ct)throw new Error("Invalid arguments");super(it,ct);this._anchor=it,this._active=ct}static isSelection(O){return O instanceof u?!0:O?y.isRange(O)&&N.isPosition(O.anchor)&&N.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=u=xe([k],L),e.Selection=L;class W{constructor(O,Z,Ce){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(Z),this.connectionToken=Ce}}e.ResolvedAuthority=W;class x extends Error{constructor(O,Z=i.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(O);this._message=O,this._code=Z,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(O,Z){return new x(O,i.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(O){return new x(O,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var $;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var q;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=S=class{constructor(O,Z){this._range=O,this._newText=Z}static isTextEdit(O){return O instanceof S?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,Z){return new S(O,Z)}static insert(O,Z){return S.replace(new y(O,O),Z)}static delete(O){return S.replace(O,"")}static setEndOfLine(O){const Z=new S(new y(new N(0,0),new N(0,0)),"");return Z.newEol=O,Z}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=S=xe([k],ie),e.TextEdit=ie;var se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace"})(se=e.FileEditType||(e.FileEditType={}));let X=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,Z,Ce,Ke){this._edits.push({_type:1,from:O,to:Z,options:Ce,metadata:Ke})}createFile(O,Z,Ce){this._edits.push({_type:1,from:void 0,to:O,options:Z,metadata:Ce})}deleteFile(O,Z,Ce){this._edits.push({_type:1,from:O,to:void 0,options:Z,metadata:Ce})}replaceNotebookMetadata(O,Z,Ce){this._edits.push({_type:3,metadata:Ce,uri:O,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(O,Z,Ce,Ke,it){let ct,ft,Pt=[],Ft;if(zt.isNotebookRange(Z)&&Bt.isNotebookCellDataArray(Ce)&&!Bt.isNotebookCellDataArray(Ke)?(ct=Z.start,ft=Z.end,Pt=Ce,Ft=Ke):typeof Z=="number"&&typeof Ce=="number"&&Bt.isNotebookCellDataArray(Ke)&&(ct=Z,ft=Ce,Pt=Ke,Ft=it),ct===void 0||ft===void 0)throw new Error("Invalid arguments");(ct!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:O,index:ct,count:ft-ct,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(O,Z,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:Z,metadata:Ce}})}replace(O,Z,Ce,Ke){this._edits.push({_type:2,uri:O,edit:new ie(Z,Ce),metadata:Ke})}insert(O,Z,Ce,Ke){this.replace(O,new y(Z,Z),Ce,Ke)}delete(O,Z,Ce){this.replace(O,Z,"",Ce)}has(O){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===O.toString())}set(O,Z){if(Z)for(const Ce of Z)Ce&&this._edits.push({_type:2,uri:O,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[Ce]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(O){const Z=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===O.toString()&&Z.push(Ce.edit);return Z}entries(){const O=new A.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ce=O.get(Z.uri);Ce||(Ce=[Z.uri,[]],O.set(Z.uri,Ce)),Ce[1].push(Z.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};X=xe([k],X),e.WorkspaceEdit=X;let ge=a=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof a?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=a._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,Z=this._tabstop++){if(typeof O=="function"){const Ce=new a;Ce._tabstop=this._tabstop,O(Ce),this._tabstop=Ce._tabstop,O=Ce.value}else O=a._escape(O);return this.value+="${",this.value+=Z,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,Z=this._tabstop++){const Ce=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(O,Z){if(typeof Z=="function"){const Ce=new a;Ce._tabstop=this._tabstop,Z(Ce),this._tabstop=Ce._tabstop,Z=Ce.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ge=a=xe([k],ge),e.SnippetString=ge;var be;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var pe;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(pe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=F=class{constructor(O,Z){if(this.uri=O,Z)if(Z instanceof y)this.range=Z;else if(Z instanceof N)this.range=new y(Z,Z);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof F?!0:O?y.isRange(O.range)&&T.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=F=xe([k],fe),e.Location=fe;let oe=class{constructor(O,Z){this.location=O,this.message=Z}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&T.URI.isUri(O.location.uri):!1}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.location.range.isEqual(Z.location.range)&&O.location.uri.toString()===Z.location.uri.toString()}};oe=xe([k],oe),e.DiagnosticRelatedInformation=oe;let Ee=class{constructor(O,Z,Ce=pe.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=O,this.message=Z,this.severity=Ce}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.severity===Z.severity&&O.code===Z.code&&O.severity===Z.severity&&O.source===Z.source&&O.range.isEqual(Z.range)&&(0,r.equals)(O.tags,Z.tags)&&(0,r.equals)(O.relatedInformation,Z.relatedInformation,oe.isEqual)}};Ee=xe([k],Ee),e.Diagnostic=Ee;let Pe=class{constructor(O,Z){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=Z}};Pe=xe([k],Pe),e.Hover=Pe;var Oe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,Z=Oe.Text){this.range=O,this.kind=Z}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};je=xe([k],je),e.DocumentHighlight=je;var st;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(st=e.SymbolKind||(e.SymbolKind={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et=e.SymbolTag||(e.SymbolTag={}));let tt=o=class{constructor(O,Z,Ce,Ke,it){this.name=O,this.kind=Z,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof fe?this.location=Ke:Ce instanceof y&&(this.location=new fe(Ke,Ce)),o.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:st[this.kind],location:this.location,containerName:this.containerName}}};tt=o=xe([k],tt),e.SymbolInformation=tt;let z=n=class{constructor(O,Z,Ce,Ke,it){this.name=O,this.detail=Z,this.kind=Ce,this.range=Ke,this.selectionRange=it,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};z=n=xe([k],z),e.DocumentSymbol=z;var K;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let H=class{constructor(O,Z){this.title=O,this.kind=Z}};H=xe([k],H),e.CodeAction=H;let j=d=class{constructor(O){this.value=O}append(O){return new d(this.value?this.value+d.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+d.sep)}};j.sep=".",j=d=xe([k],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let Y=class{constructor(O,Z){if(this.range=O,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=xe([k],Y),e.SelectionRange=Y;class ae{constructor(O,Z,Ce,Ke,it,ct){this.kind=O,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.CallHierarchyItem=ae;class Se{constructor(O,Z){this.fromRanges=Z,this.from=O}}e.CallHierarchyIncomingCall=Se;class Ue{constructor(O,Z){this.fromRanges=Z,this.to=O}}e.CallHierarchyOutgoingCall=Ue;var Ve;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,Z){this.range=O,this.command=Z}get isResolved(){return!!this.command}};Qe=xe([k],Qe),e.CodeLens=Qe;let nt=p=class{constructor(O,Z=!1){l.set(this,void 0),Xe(this,l,new _.MarkdownString(O,{supportThemeIcons:Z}),"f")}static isMarkdownString(O){return O instanceof p?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ie(this,l,"f").value}set value(O){Ie(this,l,"f").value=O}get isTrusted(){return Ie(this,l,"f").isTrusted}set isTrusted(O){Ie(this,l,"f").isTrusted=O}get supportThemeIcons(){return Ie(this,l,"f").supportThemeIcons}set supportThemeIcons(O){Ie(this,l,"f").supportThemeIcons=O}get supportHtml(){return Ie(this,l,"f").supportHtml}set supportHtml(O){Ie(this,l,"f").supportHtml=O}appendText(O){return Ie(this,l,"f").appendText(O),this}appendMarkdown(O){return Ie(this,l,"f").appendMarkdown(O),this}appendCodeblock(O,Z){return Ie(this,l,"f").appendCodeblock(Z??"",O),this}};l=new WeakMap,nt=p=xe([k],nt),e.MarkdownString=nt;let rt=class{constructor(O,Z){this.label=O,this.documentation=Z}};rt=xe([k],rt),e.ParameterInformation=rt;let Je=class{constructor(O,Z){this.label=O,this.documentation=Z,this.parameters=[]}};Je=xe([k],Je),e.SignatureInformation=Je;let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ze=xe([k],Ze),e.SignatureHelp=Ze;var pt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor(O){this.label=O}toString(){return this.label}};At=xe([k],At),e.InlayHintLabelPart=At;let G=class{constructor(O,Z,Ce){this.label=O,this.position=Z,this.kind=Ce}};G=xe([k],G),e.InlayHint=G;var Q;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(de=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(B){B[B.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(O,Z){this.label=O,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&de[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=xe([k],qe),e.CompletionItem=qe;let lt=class{constructor(O=[],Z=!1){this.items=O,this.isIncomplete=Z}};lt=xe([k],lt),e.CompletionList=lt;let ht=class{constructor(O,Z,Ce){this.text=O,this.range=Z,this.command=Ce}};ht=xe([k],ht),e.InlineSuggestion=ht;let Ye=class{constructor(O){this.items=O}};Ye=xe([k],Ye),e.InlineSuggestions=Ye;var kt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var Ae;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var De;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(De=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(Z){switch(Z){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Te=class{constructor(O,Z){if(Z&&!T.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=Z}};Te=xe([k],Te),e.DocumentLink=Te;let ze=class{constructor(O,Z,Ce,Ke){this.red=O,this.green=Z,this.blue=Ce,this.alpha=Ke}};ze=xe([k],ze),e.Color=ze;let Le=class{constructor(O,Z){if(Z&&!(Z instanceof ze))throw(0,t.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=Z}};Le=xe([k],Le),e.ColorInformation=Le;let Ge=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Ge=xe([k],Ge),e.ColorPresentation=Ge;var ot;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ot=e.ColorFormat||(e.ColorFormat={}));var at;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ne{constructor(O,Z,Ce){if(this.startIndex=O,this.length=Z,this.tooltip=Ce,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ne;var ce;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=he;var re;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var V;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(V=e.TaskPanelKind||(e.TaskPanelKind={}));let we=c=class{constructor(O,Z){if(this.label=Z,typeof O!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};we.Clean=new c("clean","Clean"),we.Build=new c("build","Build"),we.Rebuild=new c("rebuild","Rebuild"),we.Test=new c("test","Test"),we=c=xe([k],we),e.TaskGroup=we;function Re(B){let O="";for(let Z=0;Z<B.length;Z++)O+=B[Z].replace(/,/g,",,")+",";return O}let We=class{constructor(O,Z,Ce){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ce):this._options=Z)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)O.push(Z);return Re(O)}};We=xe([k],We),e.ProcessExecution=We;let He=class{constructor(O,Z,Ce){if(this._args=[],Array.isArray(Z)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=Z,this._options=Ce}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)O.push(typeof Z=="string"?Z:Z.value);return Re(O)}};He=xe([k],He),e.ShellExecution=He;var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class _t{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=_t;let dt=m=class{constructor(O,Z,Ce,Ke,it,ct){this.__deprecated=!1,this._definition=this.definition=O;let ft;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ce,this.execution=Ke,ft=it,this.__deprecated=!0):Z===Et.Global||Z===Et.Workspace?(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct):(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof We?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof He?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const Z=this._definition.type;(m.EmptyType===Z||m.ProcessType===Z||m.ShellType===Z||m.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=m=xe([k],dt),e.Task=dt;var vt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(O,Z=Ut.None){this.collapsibleState=Z,T.URI.isUri(O)?this.resourceUri=O:this.label=O}};bt=xe([k],bt),e.TreeItem=bt;var Ut;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};It=xe([k],It),e.TreeDataTransferItem=It;let Mt=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,Z){this._items.set(O,Z)}forEach(O){this._items.forEach(O)}};Mt=xe([k],Mt),e.TreeDataTransfer=Mt;let Dt=class{constructor(O,Z){this.id=O,this.color=Z}};Dt=xe([k],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let St=class{constructor(O){this.id=O}};St=xe([k],St),e.ThemeColor=St;var Qt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(O,Z){if(typeof O!="string"&&(!O||!T.URI.isUri(O)&&!T.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?this.baseUri=T.URI.file(O):T.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=Z}get base(){return this._base}set base(O){this._base=O,this._baseUri=T.URI.file(O)}get baseUri(){return this._baseUri}set baseUri(O){this._baseUri=O,this._base=O.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=xe([k],Vt),e.RelativePattern=Vt;let wt=class{constructor(O,Z,Ce,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof Z=="string"&&(this.condition=Z),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};wt=xe([k],wt),e.Breakpoint=wt;let Yt=class extends wt{constructor(O,Z,Ce,Ke,it){super(Z,Ce,Ke,it);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};Yt=xe([k],Yt),e.SourceBreakpoint=Yt;let qt=class extends wt{constructor(O,Z,Ce,Ke,it){super(Z,Ce,Ke,it);this.functionName=O}};qt=xe([k],qt),e.FunctionBreakpoint=qt;let Xt=class extends wt{constructor(O,Z,Ce,Ke,it,ct,ft){super(Ke,it,ct,ft);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=Z,this.canPersist=Ce}};Xt=xe([k],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(O,Z,Ce){this.command=O,this.args=Z||[],this.options=Ce}};ai=xe([k],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(O,Z){this.port=O,this.host=Z}};Rt=xe([k],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(O){this.path=O}};Jt=xe([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(O){this.implementation=O}};li=xe([k],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(O,Z){this.range=O,this.expression=Z}};jt=xe([k],jt),e.EvaluatableExpression=jt;var Zt;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let gt=class{constructor(O,Z){this.range=O,this.text=Z}};gt=xe([k],gt),e.InlineValueText=gt;let ci=class{constructor(O,Z,Ce=!0){this.range=O,this.variableName=Z,this.caseSensitiveLookup=Ce}};ci=xe([k],ci),e.InlineValueVariableLookup=ci;let Lt=class{constructor(O,Z){this.range=O,this.expression=Z}};Lt=xe([k],Lt),e.InlineValueEvaluatableExpression=Lt;let $t=class{constructor(O,Z){this.frameId=O,this.stoppedLocation=Z}};$t=xe([k],$t),e.InlineValueContext=$t;var vi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=f=class extends Error{constructor(O,Z=w.FileSystemProviderErrorCode.Unknown,Ce){super(T.URI.isUri(O)?O.toString(!0):O);this.code=Ce?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(O){return new f(O,w.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,w.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,w.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,w.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,w.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,w.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};ui=f=xe([k],ui),e.FileSystemError=ui;let ei=class{constructor(O,Z,Ce){this.start=O,this.end=Z,this.kind=Ce}};ei=xe([k],ei),e.FoldingRange=ei;var Ci;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(O,Z=[]){this.tokenTypes=O,this.tokenModifiers=Z}}e.SemanticTokensLegend=Di;function di(B){return typeof B=="undefined"||(0,D.isStringArray)(B)}class Gt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let Z=0,Ce=O.tokenTypes.length;Z<Ce;Z++)this._tokenTypeStrToInt.set(O.tokenTypes[Z],Z);for(let Z=0,Ce=O.tokenModifiers.length;Z<Ce;Z++)this._tokenModifierStrToInt.set(O.tokenModifiers[Z],Z)}}push(O,Z,Ce,Ke,it){if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(O,Z,Ce,Ke,it);if(y.isRange(O)&&typeof Z=="string"&&di(Ce))return this._push(O,Z,Ce);throw(0,t.illegalArgument)()}_push(O,Z,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,it=O.start.character,ct=O.end.character-O.start.character,ft=this._tokenTypeStrToInt.get(Z);let Pt=0;if(Ce)for(const Ft of Ce){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Ke,it,ct,ft,Pt)}_pushEncoded(O,Z,Ce,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let xt=0;xt<Pt;xt++){let Ht=this._data[5*xt],gi=this._data[5*xt+1];Ht===0?(Ht=Ft,gi+=Nt):Ht+=Ft,this._data[5*xt]=Ht,this._data[5*xt+1]=gi,Ft=Ht,Nt=gi}}let ct=O,ft=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=O,this._prevChar=Z}static _sortAndDeltaEncode(O){let Z=[];const Ce=O.length/5|0;for(let ft=0;ft<Ce;ft++)Z[ft]=ft;Z.sort((ft,Pt)=>{const Ft=O[5*ft],Nt=O[5*Pt];if(Ft===Nt){const xt=O[5*ft+1],Ht=O[5*Pt+1];return xt-Ht}return Ft-Nt});const Ke=new Uint32Array(O.length);let it=0,ct=0;for(let ft=0;ft<Ce;ft++){const Pt=5*Z[ft],Ft=O[Pt+0],Nt=O[Pt+1],xt=O[Pt+2],Ht=O[Pt+3],gi=O[Pt+4],Wi=Ft-it,Ji=Wi===0?Nt-ct:Nt,pi=5*ft;Ke[pi+0]=Wi,Ke[pi+1]=Ji,Ke[pi+2]=xt,Ke[pi+3]=Ht,Ke[pi+4]=gi,it=Ft,ct=Nt}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),O):new hi(Gt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Gt;class hi{constructor(O,Z){this.resultId=Z,this.data=O}}e.SemanticTokens=hi;class ki{constructor(O,Z,Ce){this.start=O,this.deleteCount=Z,this.data=Ce}}e.SemanticTokensEdit=ki;class Kt{constructor(O,Z){this.resultId=Z,this.edits=O}}e.SemanticTokensEdits=Kt;var Ii;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Dt("arrow-left")},ii=xe([k],ii),e.QuickInputButtons=ii;var Ti;(function(B){B[B.Separator=-1]="Separator",B[B.Default=1]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class wi{constructor(O,Z,Ce){this.badge=O,this.tooltip=Z,this.color=Ce}static validate(O){if(O.badge){let Z=(0,I.nextCharLength)(O.badge,0);if(Z<O.badge.length&&(Z+=(0,I.nextCharLength)(O.badge,Z)),O.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=wi;let ni=class{constructor(O){this.kind=O}};ni=xe([k],ni),e.ColorTheme=ni;var Me;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(Me=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");O<=Z?(this._start=O,this._end=Z):(this._start=Z,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let Z=this._start,Ce=this._end;return O.start!==void 0&&(Z=O.start),O.end!==void 0&&(Ce=O.end),Z===this._start&&Ce===this._end?this:new zt(Z,Ce)}}e.NotebookRange=zt;class Bt{constructor(O,Z,Ce,Ke,it,ct,ft){this.kind=O,this.value=Z,this.languageId=Ce,this.mime=Ke,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,Bt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(Z=>Bt.isNotebookCellData(Z))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Bt;class yt{constructor(O){this.cells=O}}e.NotebookData=yt;class Ot{constructor(O,Z){this.data=O,this.mime=Z;const Ce=(0,P.normalizeMimeType)(Z,!0);if(!Ce)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(O){return O instanceof Ot?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const Z={name:O.name,message:O.message,stack:O.stack};return Ot.json(Z,"application/vnd.code.notebook.error")}static stdout(O){return Ot.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ot.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,Z="application/octet-stream"){return new Ot(O,Z)}static text(O,Z=P.Mimes.text){const Ce=Ie(Ot,s,"f",g).encode(String(O));return new Ot(Ce,Z)}static json(O,Z="application/json"){const Ce=JSON.stringify(O,void 0,"	");return Ot.text(Ce,Z)}}e.NotebookCellOutputItem=Ot,s=Ot,g={value:new TextEncoder};class ri{constructor(O,Z,Ce){this.items=ri.ensureUniqueMimeTypes(O,!0),typeof Z=="string"?(this.id=Z,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=Z??Ce)}static isNotebookCellOutput(O){return O instanceof ri?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,D.isArray)(O.items)}static ensureUniqueMimeTypes(O,Z=!1){const Ce=new Set,Ke=new Set;for(let it=0;it<O.length;it++){const ct=O[it],ft=(0,P.normalizeMimeType)(ct.mime);if(!Ce.has(ft)){Ce.add(ft);continue}Ke.add(it),Z&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?O:O.filter((it,ct)=>!Ke.has(ct))}}e.NotebookCellOutput=ri;var Ei;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var yi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(O,Z){this.text=O,this.alignment=Z}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(O,Z=[]){this.uri=O,this.provides=(0,r.asArray)(Z)}}e.NotebookRendererScript=_i;let mi=class{constructor(O,Z){this.label=O,this.timestamp=Z}};mi=xe([k],mi),e.TimelineItem=mi;var Oi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(O,Z){this.ranges=O,this.wordPattern=Z}}e.LinkedEditingRanges=Ui;class J{constructor(O,Z){this._port=O,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=J;var le;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(le=e.TestResultState||(e.TestResultState={}));var ke;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ke=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ut=class{constructor(O=void 0,Z=void 0,Ce=void 0){this.include=O,this.exclude=Z,this.profile=Ce}};ut=xe([k],ut),e.TestRunRequest=ut;let Ct=E=class{constructor(O){this.message=O}static diff(O,Z,Ce){const Ke=new E(O);return Ke.expectedOutput=Z,Ke.actualOutput=Ce,Ke}};Ct=E=xe([k],Ct),e.TestMessage=Ct;let Tt=class{constructor(O){this.id=O}};Tt=xe([k],Tt),e.TestTag=Tt;let oi=class{constructor(O,Z){this.covered=O,this.total=Z}};oi=xe([k],oi),e.CoveredCount=oi;let Bi=v=class{constructor(O,Z,Ce,Ke){this.uri=O,this.statementCoverage=Z,this.branchCoverage=Ce,this.functionCoverage=Ke}static fromDetails(O,Z){const Ce=new oi(0,0),Ke=new oi(0,0),it=new oi(0,0);for(const ft of Z)if("branches"in ft){Ce.total+=1,Ce.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Ke.total+=1,Ke.covered+=Pt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new v(O,Ce,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return ct.detailedCoverage=Z,ct}};Bi=v=xe([k],Bi),e.FileCoverage=Bi;let xi=class{constructor(O,Z,Ce=[]){this.executionCount=O,this.location=Z,this.branches=Ce}};xi=xe([k],xi),e.StatementCoverage=xi;let $i=class{constructor(O,Z){this.executionCount=O,this.location=Z}};$i=xe([k],$i),e.BranchCoverage=$i;let zi=class{constructor(O,Z){this.executionCount=O,this.location=Z}};zi=xe([k],zi),e.FunctionCoverage=zi;var Ki;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(O,Z,Ce,Ke,it,ct){this.kind=O,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.TypeHierarchyItem=Xi}),define(ye[84],_e([0,1,42,11,9,223,113,7,16]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function R(l,s){s?T.set(l,s):T.delete(l)}e.setWordDefinitionFor=R;function w(l){return T.get(l)}e.getWordDefinitionFor=w;class i extends A.MirrorTextModel{constructor(s,g,M,C,b,u,S,a){super(g,M,C,b);this._proxy=s,this._languageId=u,this._isDirty=S,this._notebook=a,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,D.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===t.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(g){return g?s._getTextInRange(g):s.getText()},get eol(){return s._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(g){return s._lineAt(g)},offsetAt(g){return s._offsetAt(g)},positionAt(g){return s._positionAt(g)},validateRange(g){return s._validateRange(g)},validatePosition(g){return s._validatePosition(g)},getWordRangeAtPosition(g,M){return s._getWordRangeAtPosition(g,M)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,r.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,r.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const g=this._validateRange(s);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const M=this._eol,C=g.start.line,b=g.end.line,u=[];u.push(this._lines[C].substring(g.start.character));for(let S=C+1;S<b;S++)u.push(this._lines[S]);return u.push(this._lines[b].substring(0,g.end.character)),u.join(M)}_lineAt(s){let g;if(s instanceof I.Position?g=s.line:typeof s=="number"&&(g=s),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new h(g,this._lines[g],g===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(s),M=this._lines[g.index].length;return new I.Position(g.index,Math.min(g.remainder,M))}_validateRange(s){if(!(s instanceof I.Range))throw new Error("Invalid argument");const g=this._validatePosition(s.start),M=this._validatePosition(s.end);return g===s.start&&M===s.end?s:new I.Range(g.line,g.character,M.line,M.character)}_validatePosition(s){if(!(s instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:g,character:M}=s,C=!1;if(g<0)g=0,M=0,C=!0;else if(g>=this._lines.length)g=this._lines.length-1,M=this._lines[g].length,C=!0;else{const b=this._lines[g].length;M<0?(M=0,C=!0):M>b&&(M=b,C=!0)}return C?new I.Position(g,M):s}_getWordRangeAtPosition(s,g){const M=this._validatePosition(s);if(!g)g=w(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const C=(0,P.getWordAtText)(M.character+1,(0,P.ensureValidWordDefinition)(g),this._lines[M.line],0);if(C)return new I.Range(M.line,C.startColumn-1,M.line,C.endColumn-1)}}e.ExtHostDocumentData=i;class h{constructor(s,g,M){this._line=s,this._text=g,this._isLastLine=M}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(ye[149],_e([0,1,7,4,224,6,56,22,2,36]),function(ee,e,r,t,_,A,P,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,h,l,s){this._notebook=l,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(M=>{const C=this._cellUris.get(M.document.uri);C!==void 0&&(this._cellLengths.setValue(C,this._cells[C].document.getText().length+1),this._cellLines.setValue(C,this._cells[C].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=M=>{M===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(M=>g(M.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const i=[],h=[];for(const l of this._notebook.getCells())l.kind===r.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),i.push(l.document.getText().length+1),h.push(l.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(i){if(!i){let C="";for(const b of this._cells)C+=b.document.getText()+`
`;return C=C.slice(0,-1),C}if(i.isEmpty)return"";const h=this.locationAt(i.start),l=this.locationAt(i.end),s=this._cellUris.get(h.uri),g=this._cellUris.get(l.uri);if(s===void 0||g===void 0)return"";if(s===g)return this._cells[s].document.getText(new r.Range(h.range.start,l.range.end));const M=[this._cells[s].document.getText(new r.Range(h.range.start,new r.Position(this._cells[s].document.lineCount,0)))];for(let C=s+1;C<g;C++)M.push(this._cells[C].document.getText());return M.push(this._cells[g].document.getText(new r.Range(new r.Position(0,0),l.range.end))),M.join(`
`)}offsetAt(i){const h=this._cellLines.getIndexOf(i.line),l=this._cellLengths.getPrefixSum(h.index-1),s=this._cells[h.index].document.offsetAt(i.with(h.remainder));return l+s}positionAt(i){if(typeof i=="number"){const l=this._cellLengths.getIndexOf(i),s=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(s)}const h=this._cellUris.get(i.uri);if(h!==void 0){const l=this._cellLines.getPrefixSum(h-1);return new r.Position(l+i.range.start.line,i.range.start.character)}return new r.Position(0,0)}locationAt(i){r.Range.isRange(i)||(i=new r.Range(i,i));const h=this._cellLines.getIndexOf(i.start.line);let l=h;i.isEmpty||(l=this._cellLines.getIndexOf(i.end.line));const s=new r.Position(h.remainder,i.start.character),g=new r.Position(l.remainder,i.end.character),M=new r.Range(s,g),C=this._cells[h.index];return new r.Location(C.document.uri,C.document.validateRange(M))}contains(i){return this._cellUris.has(i)}validateRange(i){const h=this.validatePosition(i.start),l=this.validatePosition(i.end);return i.with(h,l)}validatePosition(i){const h=this._cellLines.getIndexOf(i.line),l=new r.Position(h.remainder,i.character),s=this._cells[h.index].document.validatePosition(l),g=this._cellLines.getPrefixSum(h.index-1);return new r.Position(g+s.line,s.character)}}e.ExtHostNotebookConcatDocument=R}),define(ye[150],_e([0,1,7,14,4]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?r.ColorThemeKind.Light:I==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=xe([$e(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ye[64],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=t}),define(ye[151],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function _(I,D){if(D.serializeBuffersForPostMessage){const T=new t,R=(h,l)=>{if(l instanceof ArrayBuffer){const s=T.add(l);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(l)){const s=A(l);if(s){const g=T.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:s,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},w=JSON.stringify(I,R),i=T.buffers.map(h=>{const l=new Uint8Array(h);return r.VSBuffer.wrap(l)});return{message:w,buffers:i}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=_;function A(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(I,D){const T=D.map(i=>{const h=new ArrayBuffer(i.byteLength);return new Uint8Array(h).set(i.buffer),h}),R=D.length?(i,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const l=h,{index:s}=l,g=T[s];if(l.view)switch(l.view.type){case 1:return new Int8Array(g,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return h}:void 0;return{message:JSON.parse(I,R),arrayBuffers:T}}e.deserializeWebviewMessage=P}),define(ye[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(t){function _(P){const I=new Map;return P.types.forEach((D,T)=>{I.set(D,{asString:async()=>P.items[T].asString})}),I}t.toITreeDataTransfer=_;async function A(P){const I={types:[],items:[]},D=Array.from(P.entries());for(const T of D)I.types.push(T[0]),I.items.push({asString:await T[1].asString()});return I}t.toTreeDataTransferDTO=A})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[65],_e([0,1,11,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(I,D){return I.scheme===r.Schemas.http||I.scheme===r.Schemas.https?I:(D&&D.authority&&D.isRemote&&I.scheme===r.Schemas.file&&(I=t.URI.from({scheme:r.Schemas.vscodeRemote,authority:D.authority,path:I.path})),t.URI.from({scheme:r.Schemas.https,authority:`${I.scheme}+${A(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=_;function A(I){return I.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function P(I){return I.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=P}),define(ye[153],_e([0,1,4,6,65]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(I,D,T){this._proxy=I,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const w of this._insets.values())R.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,T,R,w){let i;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===I){i=b;break}if(!i)throw new Error("not a visible editor");const h=this,l=this._handlePool++,s=new r.Emitter,g=new r.Emitter,M=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,_.asWebviewUri)(b,h._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(b){this._options=b,h._proxy.$setOptions(l,b)}get options(){return this._options}set html(b){this._html=b,h._proxy.$setHtml(l,b)}get html(){return this._html}get onDidReceiveMessage(){return s.event}postMessage(b){return h._proxy.$postMessage(l,b)}},C=new class{constructor(){this.editor=I,this.line=D,this.height=T,this.webview=M,this.onDidDispose=g.event}dispose(){h._insets.has(l)&&(h._insets.delete(l),h._proxy.$disposeEditorInset(l),g.fire(),g.dispose(),s.dispose())}};return this._proxy.$createEditorInset(l,i.id,i.value.document.uri,D+1,T,R||{},w.identifier,w.extensionLocation),this._insets.set(l,{editor:I,inset:C,onDidReceiveMessage:s}),C}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const T=this._insets.get(I);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(ye[154],_e([0,1,125,13,2,6,3,45,37,46,16,11]),function(ee,e,r,t,_,A,P,I,D,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,r.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,r.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,r.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,r.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,r.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,r.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,r.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,r.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,r.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,r.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,r.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,r.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,r.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,r.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,r.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,r.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,r.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,r.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,r.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,r.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,r.localize)(22,null)),e.EditorTabsVisibleContext=new I.RawContextKey("editorTabsVisible",!0,(0,r.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(y,L,W){for(const x of W.visibleEditorPanes)if(x.group.id===L&&y.matches(x.input))return x.getViewState()}e.findViewStateForEditor=i;function h(y){if(S(y))return!1;const L=y;return _.URI.isUri(L?.resource)}e.isResourceEditorInput=h;function l(y){if(S(y))return!1;const L=y;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=l;function s(y){if(S(y)||l(y))return!1;const L=y;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function g(y){if(S(y))return!1;const L=y;return L?L.resource===void 0||L.resource.scheme===w.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var M;(function(y){y[y.SHORT=0]="SHORT",y[y.MEDIUM=1]="MEDIUM",y[y.LONG=2]="LONG"})(M=e.Verbosity||(e.Verbosity={}));var C;(function(y){y[y.EXPLICIT=1]="EXPLICIT",y[y.AUTO=2]="AUTO",y[y.FOCUS_CHANGE=3]="FOCUS_CHANGE",y[y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(C=e.SaveReason||(e.SaveReason={}));var b;(function(y){y[y.None=0]="None",y[y.Readonly=2]="Readonly",y[y.Untitled=4]="Untitled",y[y.Singleton=8]="Singleton",y[y.RequiresTrust=16]="RequiresTrust",y[y.CanSplitInGroup=32]="CanSplitInGroup",y[y.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function S(y){return y instanceof u}e.isEditorInput=S;function a(y){const L=y;return _.URI.isUri(L?.preferredResource)}function F(y){const L=y;return S(L?.primary)&&S(L?.secondary)}e.isSideBySideEditorInput=F;function o(y){const L=y;return S(L?.modified)&&S(L?.original)}e.isDiffEditorInput=o;function n(y){return S(y?.editor)}e.isEditorInputWithOptions=n;function d(y){const L=y;return n(y)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=d;function p(y){const L=y;return typeof L?.groupId=="number"&&S(L.editor)}e.isEditorIdentifier=p;var c;(function(y){y[y.UNKNOWN=0]="UNKNOWN",y[y.REPLACE=1]="REPLACE",y[y.MOVE=2]="MOVE",y[y.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(y){y[y.GROUP_ACTIVE=0]="GROUP_ACTIVE",y[y.GROUP_INDEX=1]="GROUP_INDEX",y[y.GROUP_LOCKED=2]="GROUP_LOCKED",y[y.EDITOR_OPEN=3]="EDITOR_OPEN",y[y.EDITOR_CLOSE=4]="EDITOR_CLOSE",y[y.EDITOR_MOVE=5]="EDITOR_MOVE",y[y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",y[y.EDITOR_LABEL=7]="EDITOR_LABEL",y[y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",y[y.EDITOR_PIN=9]="EDITOR_PIN",y[y.EDITOR_STICKY=10]="EDITOR_STICKY",y[y.EDITOR_DIRTY=11]="EDITOR_DIRTY",y[y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(m=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(y){y[y.PRIMARY=1]="PRIMARY",y[y.SECONDARY=2]="SECONDARY",y[y.BOTH=3]="BOTH",y[y.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class E{getOriginalUri(L,W){if(!L)return;if(W?.supportSideBySide){const{primary:$,secondary:q}=this.getSideEditors(L);if($&&q){if(W?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(q,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===f.ANY)return this.getOriginalUri($,{filterByScheme:W.filterByScheme})??this.getOriginalUri(q,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===f.PRIMARY?$:q}}if(l(L)||s(L))return;const x=a(L)?L.preferredResource:L.resource;return!x||!W||!W.filterByScheme?x:this.filterUri(x,W.filterByScheme)}getSideEditors(L){return F(L)||s(L)?{primary:L.primary,secondary:L.secondary}:o(L)||l(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,W){if(!L)return;if(W?.supportSideBySide){const{primary:$,secondary:q}=this.getSideEditors(L);if($&&q){if(W?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(q,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===f.ANY)return this.getCanonicalUri($,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(q,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===f.PRIMARY?$:q}}if(l(L)||s(L))return;const x=L.resource;return!x||!W||!W.filterByScheme?x:this.filterUri(x,W.filterByScheme)}filterUri(L,W){if(Array.isArray(W)){if(W.some(x=>L.scheme===x))return L}else if(W===L.scheme)return L}}e.EditorResourceAccessor=new E;var v;(function(y){y[y.LEFT=0]="LEFT",y[y.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const W=this.instantiationService=L.get(P.IInstantiationService);for(const[x,$]of this.editorSerializerConstructors)this.createEditorSerializer(x,$,W);this.editorSerializerConstructors.clear()}createEditorSerializer(L,W,x){const $=x.createInstance(W);this.editorSerializerInstances.set(L,$)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,W){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,W,this.instantiationService):this.editorSerializerConstructors.set(L,W),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new k);async function U(y,L){if(!y||!y.length)return[];const W=await Promise.all(y.map(async x=>{const $=_.URI.revive(x.fileUri);if(!$||!await L.canHandleResource($))return;let ie=x.exists,se=x.type;if(typeof ie!="boolean"||typeof se!="number")try{se=(await L.resolve($)).isDirectory?T.FileType.Directory:T.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&x.openOnlyIfExists||se===T.FileType.Directory)return;const X={selection:ie?x.selection:void 0,pinned:!0,override:x.editorOverrideId};let ge;return ie?ge={resource:$,options:X}:ge={resource:$,options:X,forceUntitled:!0},ge}));return(0,R.coalesce)(W)}e.pathsToEditors=U;var N;(function(y){y[y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",y[y.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],_e([0,1,4,10,126]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,T,R){const w={command:I};if(D&&Object.keys(D).length>0&&(w.arguments=D),this.internalSend("request",w),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const h=this.pendingRequests.get(w.seq);if(h){this.pendingRequests.delete(w.seq);const l={type:"response",seq:0,request_seq:w.seq,success:!1,command:I,message:(0,_.localize)(0,null,R,I)};h(l)}},R)}return T&&this.pendingRequests.set(w.seq,T),w.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const D=I,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,T)=>I.set(T,D)),await(0,t.timeout)(500),I.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ye[156],_e([0,1,9,2,17,27,11]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(o,n,d){return o.replace(I,function(p,c){return n&&c.length>0&&c[0]!=="_"?p:d&&d.hasOwnProperty(c)?d[c]:p})}e.formatPII=D;function T(o){const n={};for(const d of Object.keys(o))d.startsWith("!")||(n[d]=o[d]);return n}e.filterExceptionsFromTelemetry=T;function R(o){return o.configuration.request==="attach"&&!w(o)&&(!o.parentSession||R(o.parentSession))}e.isSessionAttach=R;function w(o){let n=o.configuration.type;if(!!n)return n==="vslsShare"&&(n=o.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?o:o.parentSession?w(o.parentSession):void 0}e.getExtensionHostDebugSession=w;function i(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=i;function h(o,n,d){let p,c=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=m.exec(o);){const E=f.index+1,v=E+f[0].length;if(E<=n&&v>=d){p=f[0],c=E;break}}if(p){const E=/\w+/g;let v=null;for(;(v=E.exec(p))&&!(v.index+1+c+v[0].length>=d););v&&(p=p.substring(0,E.lastIndex))}return p?{start:c,end:c+p.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(o){return!!(o&&o.match(l))}e.isUri=s;function g(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(s(o.path))return t.URI.parse(o.path);if((0,_.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function M(o){if(typeof o.path=="object"){const n=t.URI.revive(o.path);if(n)return n.scheme===P.Schemas.file?n.fsPath:n.toString()}return o.path}function C(o,n){const d=n?g:M,p=(0,A.deepClone)(o);return u(p,(c,m)=>{c&&m&&(m.path=d(m))}),p}e.convertToDAPaths=C;function b(o,n){const d=n?g:M,p=(0,A.deepClone)(o);return u(p,(c,m)=>{!c&&m&&(m.path=d(m))}),p}e.convertToVSCPaths=b;function u(o,n){switch(o.type){case"event":{const d=o;switch(d.event){case"output":n(!1,d.body.source);break;case"loadedSource":n(!1,d.body.source);break;case"breakpoint":n(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=o;switch(d.command){case"setBreakpoints":n(!0,d.arguments.source);break;case"breakpointLocations":n(!0,d.arguments.source);break;case"source":n(!0,d.arguments.source);break;case"gotoTargets":n(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(p=>n(!1,p));break;default:break}break}case"response":{const d=o;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(p=>n(!1,p.source));break;case"loadedSources":d.body.sources.forEach(p=>n(!1,p));break;case"scopes":d.body.scopes.forEach(p=>n(!1,p.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(p=>n(!1,p.source));break;case"setBreakpoints":d.body.breakpoints.forEach(p=>n(!1,p.source));break;default:break}break}}}function S(o){return o.filter(n=>!n.presentation?.hidden).sort((n,d)=>n.presentation?d.presentation?n.presentation.group?d.presentation.group?n.presentation.group!==d.presentation.group?n.presentation.group.localeCompare(d.presentation.group):a(n.presentation.order,d.presentation.order):-1:d.presentation.group?1:a(n.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=S;function a(o,n){return typeof o!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:o-n}async function F(o,n){const d=o.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(d!=="none"&&(await n.saveAll(),d==="allEditorsInActiveGroup")){const p=n.activeEditorPane;p&&p.input.resource?.scheme===P.Schemas.untitled&&await n.save({editor:p.input,groupId:p.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=F}),define(ye[85],_e([0,1,29,157,74,11,17,23,45]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var M;(function(E){E.scheme=A.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function k(x,$){return x.with({scheme:E.scheme,fragment:`ch${$.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}E.generate=k;function U(x){if(x.scheme!==E.scheme)return;const $=v.exec(x.fragment);return $?{handle:Number($[1]),notebook:x.with({scheme:x.fragment.substring($[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parse=U;function N(x,$,q){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${q??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}E.generateCellOutputUri=N;function y(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!$)return;const q=Number($[1]),ie=$[2]&&$[2]!==""?$[2]:void 0,se=$[3];return{handle:q,outputId:ie,notebook:x.with({scheme:se||A.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function L(x,$,q){return x.with({scheme:q,fragment:`ch${$.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}E.generateCellUri=L;function W(x,$){if(x.scheme!==$)return;const q=v.exec(x.fragment);return q?{handle:Number(q[1]),notebook:x.with({scheme:x.fragment.substring(q[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parseCellUri=W})(M=e.CellUri||(e.CellUri={}));const C=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(E){return C.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function u(E){return C.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function S(E){return C.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=S;const a=E=>I.isWindows?E.replace(/\//g,"\\"):E;class F{constructor(v=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(v)].map(U=>({pattern:U,matches:r.parse(a(U))}))}sort(v){const k=new Map(t.Iterable.map(v,N=>[N,a(N)]));let U=[];for(const{matches:N}of this.order)for(const[y,L]of k)if(N(L)){U.push(y),k.delete(y);break}return k.size&&(U=U.concat([...k.keys()].sort((N,y)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(y)))),U}prioritize(v,k){const U=this.findIndex(v);if(U===-1){this.order.unshift({pattern:v,matches:r.parse(a(v))});return}const N=new Set(k.map(L=>this.findIndex(L,U)));N.delete(-1);const y=Array.from(N).sort();this.order.splice(U+1,0,...y.map(L=>this.order[L]));for(let L=y.length-1;L>=0;L--)this.order.splice(y[L],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,k=this.order.length){const U=a(v);for(let N=0;N<k;N++)if(this.order[N].matches(U))return N;return-1}}e.MimeTypeDisplayOrder=F;function o(E,v,k,U=(N,y)=>N===y){const N=[];function y(x,$,q){if($===0&&q.length===0)return;const ie=N[N.length-1];ie&&ie.start+ie.deleteCount===x?(ie.deleteCount+=$,ie.toInsert.push(...q)):N.push({start:x,deleteCount:$,toInsert:q})}let L=0,W=0;for(;;){if(L===E.length){y(L,0,v.slice(W));break}if(W===v.length){y(L,E.length-L,[]);break}const x=E[L],$=v[W];if(U(x,$)){L+=1,W+=1;continue}k($)?(y(L,1,[]),L+=1):(y(L,0,[$]),W+=1)}return N}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(E){E.default="default",E.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(E){const v=E;return!!((typeof v.include=="string"||r.isRelativePattern(v.include))&&(typeof v.exclude=="string"||r.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=d;function p(E,v,k){if(Array.isArray(E.viewType)&&E.viewType.indexOf(v)>=0||E.viewType===v)return!0;if(E.filenamePattern){const U=d(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=d(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(r.match(U,(0,P.basename)(k.fsPath).toLowerCase()))return!(N&&r.match(N,(0,P.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class c{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)v[k]=this.textModel.cells[k].getHashValue();return v}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var m;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(v){return`${f._prefix}${v}`}static parse(v){if(v.startsWith(f._prefix))return v.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(ye[158],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(ye[159],_e([0,1,3,45]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],_e([0,1,128,3,45]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t}),define(ye[86],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(w){w[w.Unset=0]="Unset",w[w.Queued=1]="Queued",w[w.Running=2]="Running",w[w.Passed=3]="Passed",w[w.Failed=4]="Failed",w[w.Skipped=5]="Skipped",w[w.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var t;(function(w){w[w.Run=2]="Run",w[w.Debug=4]="Debug",w[w.Coverage=8]="Coverage",w[w.HasNonDefaultProfile=16]="HasNonDefaultProfile",w[w.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(w){w[w.Error=0]="Error",w[w.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(w){w[w.NotExpandable=0]="NotExpandable",w[w.Expandable=1]="Expandable",w[w.BusyExpanding=2]="BusyExpanding",w[w.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(w,i)=>{i.expand!==void 0&&(w.expand=i.expand),i.item!==void 0&&(w.item=w.item?Object.assign(w.item,i.item):i.item)};e.applyTestItemUpdate=P;var I;(function(w){w[w.Function=0]="Function",w[w.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(w){w[w.Add=0]="Add",w[w.Update=1]="Update",w[w.Remove=2]="Remove",w[w.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",w[w.Retire=4]="Retire",w[w.AddTag=5]="AddTag",w[w.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(i){}update(i){}remove(i,h){}complete(){}}e.IncrementalChangeCollector=T;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const h=this.createChangeCollector();for(const l of i)switch(l[0]){case 0:{const s=l[1];if(s.parent){if(this.items.has(s.parent)){const g=this.items.get(s.parent);g.children.add(s.item.extId);const M=this.createItem(s,g);this.items.set(s.item.extId,M),h.add(M)}}else{const g=this.createItem(s);this.roots.add(g),this.items.set(s.item.extId,g),h.add(g)}s.expand===2&&this.busyControllerCount++;break}case 1:{const s=l[1],g=this.items.get(s.extId);if(!g)break;s.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,s),h.update(g);break}case 2:{const s=this.items.get(l[1]);if(!s)break;s.parent?this.items.get(s.parent).children.delete(s.item.extId):this.roots.delete(s);const g=[[l[1]]];for(;g.length;)for(const M of g.pop()){const C=this.items.get(M);C&&(g.push(C.children),this.items.delete(M),h.remove(C,C!==s),C.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}h.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=R}),define(ye[66],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(A){A.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class _{constructor(P,I=P.length){if(this.path=P,this.viewEnd=I,P.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,I,D=P.parent){if(P.id===I)return new _([I]);let T=[P.id];for(let R=D;R&&R.id!==I;R=R.parent)T.push(R.id);return T.push(I),new _(T.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const I=P.indexOf("\0");return I===-1?P:P.slice(0,I)}static fromString(P){return new _(P.split("\0"))}static join(P,I){return new _([...P.path,I])}static joinToString(P,I){return P.toString()+"\0"+I}static compare(P,I){return P===I?0:I.startsWith(P+"\0")?2:P.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new _(this.path,P)}compare(P){if(typeof P=="string")return _.compare(this.toString(),P);for(let I=0;I<P.viewEnd&&I<this.viewEnd;I++)if(P.path[I]!==this.path[I])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=_}),define(ye[162],_e([0,1,17,87,13,27,23,76,129]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(w,i,h){this._contributedVariables=new Map,this._context=w,this._labelService=i,h&&(this._envVariablesPromise=h.then(l=>this.prepareEnv(l)))}prepareEnv(w){if(P.isWindows){const i=Object.create(null);return Object.keys(w).forEach(h=>{i[h.toLowerCase()]=w[h]}),i}return w}resolveWithEnvironment(w,i,h){return this.recursiveResolve(this.prepareEnv(w),i?i.uri:void 0,h)}async resolveAsync(w,i){return this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,i)}async resolveAnyBase(w,i,h,l){const s=A.deepClone(i);return P.isWindows&&s.windows?Object.keys(s.windows).forEach(g=>s[g]=s.windows[g]):P.isMacintosh&&s.osx?Object.keys(s.osx).forEach(g=>s[g]=s.osx[g]):P.isLinux&&s.linux&&Object.keys(s.linux).forEach(g=>s[g]=s.linux[g]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,s,h,l)}async resolveAnyAsync(w,i,h){return this.resolveAnyBase(w,i,h)}async resolveAnyMap(w,i,h){const l=new Map;return{newConfig:await this.resolveAnyBase(w,i,h,l),resolvedVariables:l}}resolveWithInteractionReplace(w,i,h,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,i,h,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,i){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,i)}recursiveResolve(w,i,h,l,s){if(_.isString(h))return this.resolveString(w,i,h,l,s);if(_.isArray(h))return h.map(g=>this.recursiveResolve(w,i,g,l,s));if(_.isObject(h)){let g=Object.create(null);return Object.keys(h).forEach(M=>{const C=this.resolveString(w,i,M,l,s);g[C]=this.recursiveResolve(w,i,h[M],l,s)}),g}return h}resolveString(w,i,h,l,s){return h.replace(T.VARIABLE_REGEXP,(M,C)=>{if(C.includes(T.VARIABLE_LHS))return M;let b=this.evaluateSingleVariable(w,M,C,i,l);return s&&s.set(C,b),b!==M&&_.isString(b)&&b.match(T.VARIABLE_REGEXP)&&(b=this.resolveString(w,i,b,l,s)),b})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}evaluateSingleVariable(w,i,h,l,s){let g;const M=h.split(":");M.length>1&&(h=M[0],g=M[1]);const C=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,D.localize)(0,null,i))},b=()=>{const S=C();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,D.localize)(1,null,i,r.basename(S)))},u=()=>{if(g){const S=this._context.getFolderUri(g);if(S)return S;throw new Error((0,D.localize)(2,null,i,g))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,i)):new Error((0,D.localize)(4,null,i))};switch(h){case"env":if(g){if(w){const S=w[P.isWindows?g.toLowerCase():g];if(_.isString(S))return S}return""}throw new Error((0,D.localize)(5,null,i));case"config":if(g){const S=this._context.getConfigurationValue(l,g);if(_.isUndefinedOrNull(S))throw new Error((0,D.localize)(6,null,i,g));if(_.isObject(S))throw new Error((0,D.localize)(7,null,i,g));return S}throw new Error((0,D.localize)(8,null,i));case"command":return this.resolveFromMap(i,g,s,"command");case"input":return this.resolveFromMap(i,g,s,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return l||g?(0,I.normalizeDriveLetter)(this.fsPath(u())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(u()));case"lineNumber":{const S=this._context.getLineNumber();if(S)return S;throw new Error((0,D.localize)(9,null,i))}case"selectedText":{const S=this._context.getSelectedText();if(S)return S;throw new Error((0,D.localize)(10,null,i))}case"file":return C();case"fileWorkspaceFolder":return b();case"relativeFile":return l||g?r.relative(this.fsPath(u()),C()):C();case"relativeFileDirname":{const S=r.dirname(C());if(l||g){const a=r.relative(this.fsPath(u()),S);return a.length===0?".":a}return S}case"fileDirname":return r.dirname(C());case"fileExtname":return r.extname(C());case"fileBasename":return r.basename(C());case"fileBasenameNoExtension":{const S=r.basename(C());return S.slice(0,S.length-r.extname(S).length)}case"fileDirnameBasename":return r.basename(r.dirname(C()));case"execPath":{const S=this._context.getExecPath();return S||i}case"execInstallFolder":{const S=this._context.getAppRoot();return S||i}case"pathSeparator":return r.sep;default:try{const S=g?`${h}:${g}`:h;return this.resolveFromMap(i,S,s,void 0)}catch{return i}}}}resolveFromMap(w,i,h,l){if(i&&h){const s=l===void 0?h[i]:h[l+":"+i];if(typeof s=="string")return s;throw new Error((0,D.localize)(11,null,w))}return w}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[88],_e([0,1,3,154]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var _;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var I;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(l){const s=l;return(0,t.isEditorInput)(s?.editor)&&(0,t.isEditorInput)(s?.replacement)}e.isEditorReplacement=T;var R;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function i(l){const s=l;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=i;function h(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(ye[163],_e([0,1,3,88]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const P=A;return typeof A=="number"||(0,t.isEditorGroup)(P)}e.isPreferredGroup=_}),define(ye[8],_e([0,1,16,21,75,225,55,27,13,2,58,57,130,80,48,85,66,163,7]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(ce){function he(V){const{selectionStartLineNumber:we,selectionStartColumn:Re,positionLineNumber:We,positionColumn:He}=V,mt=new C.Position(we-1,Re-1),Et=new C.Position(We-1,He-1);return new C.Selection(mt,Et)}ce.to=he;function re(V){const{anchor:we,active:Re}=V;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ce.from=re})(b=e.Selection||(e.Selection={}));var u;(function(ce){function he(V){if(!V)return;const{start:we,end:Re}=V;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ce.from=he;function re(V){if(!V)return;const{startLineNumber:we,startColumn:Re,endLineNumber:We,endColumn:He}=V;return new C.Range(we-1,Re-1,We-1,He-1)}ce.to=re})(u=e.Range||(e.Range={}));var S;(function(ce){function he(re){switch(re){case 1:return C.StandardTokenType.Comment;case 0:return C.StandardTokenType.Other;case 3:return C.StandardTokenType.RegEx;case 2:return C.StandardTokenType.String}}ce.to=he})(S=e.TokenType||(e.TokenType={}));var a;(function(ce){function he(V){return new C.Position(V.lineNumber-1,V.column-1)}ce.to=he;function re(V){return{lineNumber:V.line+1,column:V.character+1}}ce.from=re})(a=e.Position||(e.Position={}));var F;(function(ce){function he(we,Re){return(0,r.coalesce)((0,r.asArray)(we).map(We=>re(We,Re)))}ce.from=he;function re(we,Re){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:V(we.scheme,Re),pattern:de.from(we.pattern)??void 0,exclusive:we.exclusive}}function V(we,Re){return Re&&typeof we=="string"?Re.transformOutgoingScheme(we):we}})(F=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(ce){function he(V){switch(V){case C.DiagnosticTag.Unnecessary:return 1;case C.DiagnosticTag.Deprecated:return 2}}ce.from=he;function re(V){switch(V){case 1:return C.DiagnosticTag.Unnecessary;case 2:return C.DiagnosticTag.Deprecated;default:return}}ce.to=re})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ce){function he(V){let we;return V.code&&((0,D.isString)(V.code)||(0,D.isNumber)(V.code)?we=String(V.code):we={value:String(V.code.value),target:V.code.target}),{...u.from(V.range),message:V.message,source:V.source,code:we,severity:p.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(d.from),tags:Array.isArray(V.tags)?(0,r.coalesce)(V.tags.map(o.from)):void 0}}ce.from=he;function re(V){const we=new C.Diagnostic(u.to(V),V.message,p.to(V.severity));return we.source=V.source,we.code=(0,D.isString)(V.code)?V.code:V.code?.value,we.relatedInformation=V.relatedInformation&&V.relatedInformation.map(d.to),we.tags=V.tags&&(0,r.coalesce)(V.tags.map(o.to)),we}ce.to=re})(n=e.Diagnostic||(e.Diagnostic={}));var d;(function(ce){function he(V){return{...u.from(V.location.range),message:V.message,resource:V.location.uri}}ce.from=he;function re(V){return new C.DiagnosticRelatedInformation(new C.Location(V.resource,u.to(V)),V.message)}ce.to=re})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(ce){function he(V){switch(V){case C.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case C.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case C.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case C.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ce.from=he;function re(V){switch(V){case h.MarkerSeverity.Info:return C.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return C.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return C.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return C.DiagnosticSeverity.Hint;default:return C.DiagnosticSeverity.Error}}ce.to=re})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ce){function he(V){return typeof V=="number"&&V>=C.ViewColumn.One?V-1:V===C.ViewColumn.Beside?M.SIDE_GROUP:M.ACTIVE_GROUP}ce.from=he;function re(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=re})(c=e.ViewColumn||(e.ViewColumn={}));function m(ce){return typeof ce.range!="undefined"}function f(ce){return ce.length===0?!0:!!m(ce[0])}e.isDecorationOptionsArr=f;var E;(function(ce){function he(He){return He.map(ce.from)}ce.fromMany=he;function re(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function V(He){let mt;if(re(He)){const{language:vt,value:bt}=He;mt={value:"```"+vt+`
`+bt+"\n```\n"}}else C.MarkdownString.isMarkdownString(He)?mt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml}:typeof He=="string"?mt={value:He}:mt={value:""};const Et=Object.create(null);mt.uris=Et;const _t=vt=>{try{let bt=T.URI.parse(vt,!0);bt=bt.with({query:we(bt.query,Et)}),Et[vt]=bt}catch{}return""},dt=new A.Renderer;return dt.link=_t,dt.image=vt=>_t(_.parseHrefAndDimensions(vt).href),A(mt.value,{renderer:dt}),mt}ce.from=V;function we(He,mt){if(!He)return He;let Et;try{Et=(0,P.parse)(He)}catch{}if(!Et)return He;let _t=!1;return Et=(0,I.cloneAndChange)(Et,dt=>{if(T.URI.isUri(dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[vt]=dt,_t=!0,vt}else return}),_t?JSON.stringify(Et):He}function Re(He){const mt=new C.MarkdownString(He.value,He.supportThemeIcons);return mt.isTrusted=He.isTrusted,mt.supportHtml=He.supportHtml,mt}ce.to=Re;function We(He){if(!!He)return typeof He=="string"?He:ce.from(He)}ce.fromStrict=We})(E=e.MarkdownString||(e.MarkdownString={}));function v(ce){return f(ce)?ce.map(he=>({range:u.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?E.fromMany(he.hoverMessage):he.hoverMessage?E.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):ce.map(he=>({range:u.from(he)}))}e.fromRangeOrRangeWithMessage=v;function k(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?T.URI.file(ce):ce}e.pathOrURIToURI=k;var U;(function(ce){function he(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?k(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ce.from=he})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(ce){function he(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?U.from(re.before):void 0,after:re.after?U.from(re.after):void 0}}ce.from=he})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ce){function he(re){if(typeof re=="undefined")return re;switch(re){case C.DecorationRangeBehavior.OpenOpen:return 0;case C.DecorationRangeBehavior.ClosedClosed:return 1;case C.DecorationRangeBehavior.OpenClosed:return 2;case C.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=he})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ce){function he(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?y.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?N.from(re.light):void 0,dark:re.dark?N.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?U.from(re.before):void 0,after:re.after?U.from(re.after):void 0}}ce.from=he})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(ce){function he(V){return{text:V.newText,eol:V.newEol&&pt.from(V.newEol),range:u.from(V.range)}}ce.from=he;function re(V){const we=new C.TextEdit(u.to(V.range),V.text);return we.newEol=typeof V.eol=="undefined"?void 0:pt.to(V.eol),we}ce.to=re})(W=e.TextEdit||(e.TextEdit={}));var x;(function(ce){function he(V,we,Re){const We={edits:[]};if(V instanceof C.WorkspaceEdit)for(let He of V._allEntries())if(He._type===1)We.edits.push({_type:1,oldUri:He.from,newUri:He.to,options:He.options,metadata:He.metadata});else if(He._type===2){const mt=we?.getDocument(He.uri);We.edits.push({_type:2,resource:He.uri,edit:W.from(He.edit),modelVersionId:mt?.version,metadata:He.metadata})}else He._type===3?We.edits.push({_type:3,metadata:He.metadata,resource:He.uri,edit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(He.uri,!0)?.apiNotebook.version}):He._type===5&&We.edits.push({_type:3,metadata:He.metadata,resource:He.uri,notebookVersionId:Re?.getNotebookDocument(He.uri,!0)?.apiNotebook.version,edit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(kt.from)}});return We}ce.from=he;function re(V){const we=new C.WorkspaceEdit;for(const Re of V.edits)Re.edit?we.replace(T.URI.revive(Re.resource),u.to(Re.edit.range),Re.edit.text):we.renameFile(T.URI.revive(Re.oldUri),T.URI.revive(Re.newUri),Re.options);return we}ce.to=re})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ce){const he=Object.create(null);he[C.SymbolKind.File]=0,he[C.SymbolKind.Module]=1,he[C.SymbolKind.Namespace]=2,he[C.SymbolKind.Package]=3,he[C.SymbolKind.Class]=4,he[C.SymbolKind.Method]=5,he[C.SymbolKind.Property]=6,he[C.SymbolKind.Field]=7,he[C.SymbolKind.Constructor]=8,he[C.SymbolKind.Enum]=9,he[C.SymbolKind.Interface]=10,he[C.SymbolKind.Function]=11,he[C.SymbolKind.Variable]=12,he[C.SymbolKind.Constant]=13,he[C.SymbolKind.String]=14,he[C.SymbolKind.Number]=15,he[C.SymbolKind.Boolean]=16,he[C.SymbolKind.Array]=17,he[C.SymbolKind.Object]=18,he[C.SymbolKind.Key]=19,he[C.SymbolKind.Null]=20,he[C.SymbolKind.EnumMember]=21,he[C.SymbolKind.Struct]=22,he[C.SymbolKind.Event]=23,he[C.SymbolKind.Operator]=24,he[C.SymbolKind.TypeParameter]=25;function re(we){return typeof he[we]=="number"?he[we]:6}ce.from=re;function V(we){for(const Re in he)if(he[Re]===we)return Number(Re);return C.SymbolKind.Property}ce.to=V})($=e.SymbolKind||(e.SymbolKind={}));var q;(function(ce){function he(V){switch(V){case C.SymbolTag.Deprecated:return 1}}ce.from=he;function re(V){switch(V){case 1:return C.SymbolTag.Deprecated}}ce.to=re})(q=e.SymbolTag||(e.SymbolTag={}));var ie;(function(ce){function he(V){return{name:V.name,kind:$.from(V.kind),tags:V.tags&&V.tags.map(q.from),containerName:V.containerName,location:pe.from(V.location)}}ce.from=he;function re(V){const we=new C.SymbolInformation(V.name,$.to(V.kind),V.containerName,pe.to(V.location));return we.tags=V.tags&&V.tags.map(q.to),we}ce.to=re})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var se;(function(ce){function he(V){const we={name:V.name||"!!MISSING: name!!",detail:V.detail,range:u.from(V.range),selectionRange:u.from(V.selectionRange),kind:$.from(V.kind),tags:V.tags?.map(q.from)??[]};return V.children&&(we.children=V.children.map(he)),we}ce.from=he;function re(V){const we=new C.DocumentSymbol(V.name,V.detail,$.to(V.kind),u.to(V.range),u.to(V.selectionRange));return(0,r.isNonEmptyArray)(V.tags)&&(we.tags=V.tags.map(q.to)),V.children&&(we.children=V.children.map(re)),we}ce.to=re})(se=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(ce){function he(V){const we=new C.CallHierarchyItem($.to(V.kind),V.name,V.detail||"",T.URI.revive(V.uri),u.to(V.range),u.to(V.selectionRange));return we._sessionId=V._sessionId,we._itemId=V._itemId,we}ce.to=he;function re(V,we,Re){if(we=we??V._sessionId,Re=Re??V._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,name:V.name,detail:V.detail,kind:$.from(V.kind),uri:V.uri,range:u.from(V.range),selectionRange:u.from(V.selectionRange),tags:V.tags?.map(q.from)}}ce.from=re})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(ce){function he(re){return new C.CallHierarchyIncomingCall(X.to(re.from),re.fromRanges.map(V=>u.to(V)))}ce.to=he})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ce){function he(re){return new C.CallHierarchyOutgoingCall(X.to(re.to),re.fromRanges.map(V=>u.to(V)))}ce.to=he})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(ce){function he(V){return{range:V.range&&u.from(V.range),uri:V.uri}}ce.from=he;function re(V){return new C.Location(T.URI.revive(V.uri),u.to(V.range))}ce.to=re})(pe=e.location||(e.location={}));var fe;(function(ce){function he(V){const we=V,Re=V;return{originSelectionRange:we.originSelectionRange?u.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Re.uri,range:u.from(we.targetRange?we.targetRange:Re.range),targetSelectionRange:we.targetSelectionRange?u.from(we.targetSelectionRange):void 0}}ce.from=he;function re(V){return{targetUri:T.URI.revive(V.uri),targetRange:u.to(V.range),targetSelectionRange:V.targetSelectionRange?u.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?u.to(V.originSelectionRange):void 0}}ce.to=re})(fe=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(ce){function he(V){return{range:u.from(V.range),contents:E.fromMany(V.contents)}}ce.from=he;function re(V){return new C.Hover(V.contents.map(E.to),u.to(V.range))}ce.to=re})(oe=e.Hover||(e.Hover={}));var Ee;(function(ce){function he(V){return{range:u.from(V.range),expression:V.expression}}ce.from=he;function re(V){return new C.EvaluatableExpression(u.to(V.range),V.expression)}ce.to=re})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ce){function he(V){if(V instanceof C.InlineValueText)return{type:"text",range:u.from(V.range),text:V.text};if(V instanceof C.InlineValueVariableLookup)return{type:"variable",range:u.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof C.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=he;function re(V){switch(V.type){case"text":return{range:u.to(V.range),text:V.text};case"variable":return{range:u.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:u.to(V.range),expression:V.expression}}}ce.to=re})(Pe=e.InlineValue||(e.InlineValue={}));var Oe;(function(ce){function he(V){return{frameId:V.frameId,stoppedLocation:u.from(V.stoppedLocation)}}ce.from=he;function re(V){return new C.InlineValueContext(V.frameId,u.to(V.stoppedLocation))}ce.to=re})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ce){function he(V){return{range:u.from(V.range),kind:V.kind}}ce.from=he;function re(V){return new C.DocumentHighlight(u.to(V.range),V.kind)}ce.to=re})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var st;(function(ce){function he(re){switch(re){case 1:return C.CompletionTriggerKind.TriggerCharacter;case 2:return C.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return C.CompletionTriggerKind.Invoke}}ce.to=he})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var et;(function(ce){function he(re){return{triggerKind:st.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ce.to=he})(et=e.CompletionContext||(e.CompletionContext={}));var tt;(function(ce){function he(V){switch(V){case C.CompletionItemTag.Deprecated:return 1}}ce.from=he;function re(V){switch(V){case 1:return C.CompletionItemTag.Deprecated}}ce.to=re})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(ce){const he=new Map([[C.CompletionItemKind.Method,0],[C.CompletionItemKind.Function,1],[C.CompletionItemKind.Constructor,2],[C.CompletionItemKind.Field,3],[C.CompletionItemKind.Variable,4],[C.CompletionItemKind.Class,5],[C.CompletionItemKind.Interface,7],[C.CompletionItemKind.Struct,6],[C.CompletionItemKind.Module,8],[C.CompletionItemKind.Property,9],[C.CompletionItemKind.Unit,12],[C.CompletionItemKind.Value,13],[C.CompletionItemKind.Constant,14],[C.CompletionItemKind.Enum,15],[C.CompletionItemKind.EnumMember,16],[C.CompletionItemKind.Keyword,17],[C.CompletionItemKind.Snippet,27],[C.CompletionItemKind.Text,18],[C.CompletionItemKind.Color,19],[C.CompletionItemKind.File,20],[C.CompletionItemKind.Reference,21],[C.CompletionItemKind.Folder,23],[C.CompletionItemKind.Event,10],[C.CompletionItemKind.Operator,11],[C.CompletionItemKind.TypeParameter,24],[C.CompletionItemKind.Issue,26],[C.CompletionItemKind.User,25]]);function re(Re){return he.get(Re)??9}ce.from=re;const V=new Map([[0,C.CompletionItemKind.Method],[1,C.CompletionItemKind.Function],[2,C.CompletionItemKind.Constructor],[3,C.CompletionItemKind.Field],[4,C.CompletionItemKind.Variable],[5,C.CompletionItemKind.Class],[7,C.CompletionItemKind.Interface],[6,C.CompletionItemKind.Struct],[8,C.CompletionItemKind.Module],[9,C.CompletionItemKind.Property],[12,C.CompletionItemKind.Unit],[13,C.CompletionItemKind.Value],[14,C.CompletionItemKind.Constant],[15,C.CompletionItemKind.Enum],[16,C.CompletionItemKind.EnumMember],[17,C.CompletionItemKind.Keyword],[27,C.CompletionItemKind.Snippet],[18,C.CompletionItemKind.Text],[19,C.CompletionItemKind.Color],[20,C.CompletionItemKind.File],[21,C.CompletionItemKind.Reference],[23,C.CompletionItemKind.Folder],[10,C.CompletionItemKind.Event],[11,C.CompletionItemKind.Operator],[24,C.CompletionItemKind.TypeParameter],[25,C.CompletionItemKind.User],[26,C.CompletionItemKind.Issue]]);function we(Re){return V.get(Re)??C.CompletionItemKind.Property}ce.to=we})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(ce){function he(re,V){const we=new C.CompletionItem(re.label);return we.insertText=re.insertText,we.kind=z.to(re.kind),we.tags=re.tags?.map(tt.to),we.detail=re.detail,we.documentation=_.isMarkdownString(re.documentation)?E.to(re.documentation):re.documentation,we.sortText=re.sortText,we.filterText=re.filterText,we.preselect=re.preselect,we.commitCharacters=re.commitCharacters,R.Range.isIRange(re.range)?we.range=u.to(re.range):typeof re.range=="object"&&(we.range={inserting:u.to(re.range.insert),replacing:u.to(re.range.replace)}),we.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?we.insertText=new C.SnippetString(re.insertText):(we.insertText=re.insertText,we.textEdit=we.range instanceof C.Range?new C.TextEdit(we.range,we.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(we.additionalTextEdits=re.additionalTextEdits.map(Re=>W.to(Re))),we.command=V&&re.command?V.fromInternal(re.command):void 0,we}ce.to=he})(K=e.CompletionItem||(e.CompletionItem={}));var H;(function(ce){function he(V){return{label:V.label,documentation:V.documentation?E.fromStrict(V.documentation):void 0}}ce.from=he;function re(V){return{label:V.label,documentation:_.isMarkdownString(V.documentation)?E.to(V.documentation):V.documentation}}ce.to=re})(H=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ce){function he(V){return{label:V.label,documentation:V.documentation?E.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(H.from):[],activeParameter:V.activeParameter}}ce.from=he;function re(V){return{label:V.label,documentation:_.isMarkdownString(V.documentation)?E.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(H.to):[],activeParameter:V.activeParameter}}ce.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ce){function he(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(j.from):[]}}ce.from=he;function re(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(j.to):[]}}ce.to=re})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(ce){function he(re,V){const we=new C.InlayHint(typeof V.label=="string"?V.label:V.label.map(Se.to.bind(void 0,re)),a.to(V.position),Ue.to(V.kind));return we.tooltip=_.isMarkdownString(V.tooltip)?E.to(V.tooltip):V.tooltip,we.whitespaceAfter=V.whitespaceAfter,we.whitespaceBefore=V.whitespaceBefore,we}ce.to=he})(ae=e.InlayHint||(e.InlayHint={}));var Se;(function(ce){function he(re,V){const we=new C.InlayHintLabelPart(V.label);return we.collapsible=V.collapsible,w.Command.is(V.action)?we.action=re.fromInternal(V.action):V.action&&(we.action=pe.to(V.action)),we}ce.to=he})(Se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ue;(function(ce){function he(V){return V}ce.from=he;function re(V){return V}ce.to=re})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var Ve;(function(ce){function he(V){return{range:u.from(V.range),url:V.target,tooltip:V.tooltip}}ce.from=he;function re(V){let we;if(V.url)try{we=typeof V.url=="string"?T.URI.parse(V.url,!0):T.URI.revive(V.url)}catch{}return new C.DocumentLink(u.to(V.range),we)}ce.to=re})(Ve=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ce){function he(V){const we=new C.ColorPresentation(V.label);return V.textEdit&&(we.textEdit=W.to(V.textEdit)),V.additionalTextEdits&&(we.additionalTextEdits=V.additionalTextEdits.map(Re=>W.to(Re))),we}ce.to=he;function re(V){return{label:V.label,textEdit:V.textEdit?W.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(we=>W.from(we)):void 0}}ce.from=re})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var nt;(function(ce){function he(V){return new C.Color(V[0],V[1],V[2],V[3])}ce.to=he;function re(V){return[V.red,V.green,V.blue,V.alpha]}ce.from=re})(nt=e.Color||(e.Color={}));var rt;(function(ce){function he(V){return{range:u.from(V.range)}}ce.from=he;function re(V){return new C.SelectionRange(u.to(V.range))}ce.to=re})(rt=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ce){function he(re){switch(re){case 2:return C.TextDocumentSaveReason.AfterDelay;case 1:return C.TextDocumentSaveReason.Manual;case 3:case 4:return C.TextDocumentSaveReason.FocusOut}}ce.to=he})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(ce){function he(V){switch(V){case C.TextEditorLineNumbersStyle.Off:return 0;case C.TextEditorLineNumbersStyle.Relative:return 2;case C.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=he;function re(V){switch(V){case 0:return C.TextEditorLineNumbersStyle.Off;case 2:return C.TextEditorLineNumbersStyle.Relative;case 1:default:return C.TextEditorLineNumbersStyle.On}}ce.to=re})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(ce){function he(V){if(V===C.EndOfLine.CRLF)return 1;if(V===C.EndOfLine.LF)return 0}ce.from=he;function re(V){if(V===1)return C.EndOfLine.CRLF;if(V===0)return C.EndOfLine.LF}ce.to=re})(pt=e.EndOfLine||(e.EndOfLine={}));var Fe;(function(ce){function he(re){if(typeof re=="object")return re.viewId;switch(re){case C.ProgressLocation.SourceControl:return 3;case C.ProgressLocation.Window:return 10;case C.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=he})(Fe=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(ce){function he(re){const V={start:re.start+1,end:re.end+1};return re.kind&&(V.kind=G.from(re.kind)),V}ce.from=he})(At=e.FoldingRange||(e.FoldingRange={}));var G;(function(ce){function he(re){if(re)switch(re){case C.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case C.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case C.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}ce.from=he})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ce){function he(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?u.from(re.selection):void 0,override:typeof re.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ce.from=he})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var de;(function(ce){function he(Re){return Re instanceof C.RelativePattern?Re.toJSON():typeof Re=="string"?Re:re(Re)||V(Re)?new C.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ce.from=he;function re(Re){const We=Re;return We?T.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function V(Re){const We=Re;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function we(Re){return typeof Re=="string"?Re:new C.RelativePattern(T.URI.revive(Re.baseUri),Re.pattern)}ce.to=we})(de=e.GlobPattern||(e.GlobPattern={}));var Be;(function(ce){function he(re){if(re){if(Array.isArray(re))return re.map(he);if(typeof re=="string")return re;{const V=re;return{language:V.language,scheme:V.scheme,pattern:de.from(V.pattern),exclusive:V.exclusive}}}else return}ce.from=he})(Be=e.LanguageSelector||(e.LanguageSelector={}));var qe;(function(ce){function he(V){return{start:V.start,end:V.end}}ce.from=he;function re(V){return new C.NotebookRange(V.start,V.end)}ce.to=re})(qe=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ce){function he(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ce.to=he;function re(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}ce.from=re})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ht;(function(ce){function he(V){switch(V){case C.NotebookCellKind.Markup:return s.CellKind.Markup;case C.NotebookCellKind.Code:default:return s.CellKind.Code}}ce.from=he;function re(V){switch(V){case s.CellKind.Markup:return C.NotebookCellKind.Markup;case s.CellKind.Code:default:return C.NotebookCellKind.Code}}ce.to=re})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ce){function he(V){const we={metadata:V.metadata??Object.create(null),cells:[]};for(let Re of V.cells)C.NotebookCellData.validate(Re),we.cells.push(kt.from(Re));return we}ce.from=he;function re(V){const we=new C.NotebookData(V.cells.map(kt.to));return(0,D.isEmptyObject)(V.metadata)||(we.metadata=V.metadata),we}ce.to=re})(Ye=e.NotebookData||(e.NotebookData={}));var kt;(function(ce){function he(V){return{cellKind:ht.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:lt.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(De.from):[]}}ce.from=he;function re(V){return new C.NotebookCellData(ht.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(De.to):void 0,V.metadata,V.internalMetadata?lt.to(V.internalMetadata):void 0)}ce.to=re})(kt=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(ce){function he(V){return{mime:V.mime,valueBytes:t.VSBuffer.wrap(V.data)}}ce.from=he;function re(V){return new C.NotebookCellOutputItem(V.valueBytes.buffer,V.mime)}ce.to=re})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var De;(function(ce){function he(V){return{outputId:V.id,items:V.items.map(Ae.from),metadata:V.metadata}}ce.from=he;function re(V){const we=V.items.map(Ae.to);return new C.NotebookCellOutput(we,V.outputId,V.metadata)}ce.to=re})(De=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ce){function he(we){return V(we)?{include:(0,D.withNullAsUndefined)(de.from(we.include)),exclude:(0,D.withNullAsUndefined)(de.from(we.exclude))}:(0,D.withNullAsUndefined)(de.from(we))}ce.from=he;function re(we){return V(we)?{include:de.to(we.include),exclude:de.to(we.exclude)}:de.to(we)}ce.to=re;function V(we){const Re=we;return Re?!!Re.include&&!!Re.exclude:!1}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var te;(function(ce){function he(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?U.from(re.top):void 0}}ce.from=he})(te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(ce){function he(re,V,we){const Re=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===C.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Re,we),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ce.from=he})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ce){function he(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ce.from=he})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(ce){function he(V){return{uri:V.uri,provides:V.provides}}ce.from=he;function re(V){return new C.NotebookRendererScript(T.URI.revive(V.uri),V.provides)}ce.to=re})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Te;(function(ce){function he(V){return{message:E.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,location:V.location?pe.from(V.location):void 0}}ce.from=he;function re(V){const we=new C.TestMessage(typeof V.message=="string"?V.message:E.to(V.message));return we.actualOutput=V.actual,we.expectedOutput=V.expected,we.location=V.location?pe.to(V.location):void 0,we}ce.to=re})(Te=e.TestMessage||(e.TestMessage={}));var ze;(function(ce){let he;(function(re){re.Delimiter="\0"})(he||(he={})),ce.namespace=(re,V)=>re+"\0"+V,ce.denamespace=re=>{const V=re.indexOf("\0");return{ctrlId:re.slice(0,V),tagId:re.slice(V+1)}}})(ze=e.TestTag||(e.TestTag={}));var Le;(function(ce){function he(Re){const We=(0,l.getPrivateApiFor)(Re).controllerId;return{extId:g.TestId.fromExtHostTestItem(Re,We).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(He=>ze.namespace(We,He.id)),range:u.from(Re.range)||null,description:Re.description||null,error:Re.error&&E.fromStrict(Re.error)||null}}ce.from=he;function re(Re){return{parent:void 0,error:void 0,id:g.TestId.fromString(Re.extId).localId,label:Re.label,uri:T.URI.revive(Re.uri),tags:(Re.tags||[]).map(We=>{const{tagId:He}=ze.denamespace(We);return new C.TestTag(He)}),range:u.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}ce.toPlain=re;function V(Re){const We=g.TestId.fromString(Re.extId),He=new l.TestItemImpl(We.controllerId,We.localId,Re.label,T.URI.revive(Re.uri));return He.range=u.to(Re.range||void 0),He.description=Re.description||void 0,He}function we(Re){let We;for(const He of Re.tests){const mt=V(He.item);(0,l.getPrivateApiFor)(mt).parent=We,We=mt}return We}ce.toItemFromContext=we})(Le=e.TestItem||(e.TestItem={})),function(ce){function he(V){return{id:V.id}}ce.from=he;function re(V){return new C.TestTag(V.id)}ce.to=re}(ze=e.TestTag||(e.TestTag={}));var Ge;(function(ce){const he=(V,we)=>{const Re={...Le.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(He=>He.type===0).map(Te.to)})),children:V.children.map(We=>we.get(We)).filter(D.isDefined).map(We=>he(We,we))};for(const We of Re.children)We.parent=Re;return Re};function re(V){const we=[],Re=new Map;for(const We of V.items)Re.set(We.item.extId,We),V.request.targets.some(He=>He.controllerId===We.controllerId&&He.testIds.includes(We.item.extId))&&we.push(We);return{completedAt:V.completedAt,results:we.map(We=>he(We,Re))}}ce.to=re})(Ge=e.TestResults||(e.TestResults={}));var ot;(function(ce){function he(Re){return{covered:Re.covered,total:Re.covered}}function re(Re){return"line"in Re?a.from(Re):u.from(Re)}function V(Re){return"branches"in Re?{count:Re.executionCount,location:re(Re.location),type:1,branches:Re.branches.length?Re.branches.map(We=>({count:We.executionCount,location:We.location&&re(We.location)})):void 0}:{type:0,count:Re.executionCount,location:re(Re.location)}}ce.fromDetailed=V;function we(Re){return{uri:Re.uri,statement:he(Re.statementCoverage),branch:Re.branchCoverage&&he(Re.branchCoverage),function:Re.functionCoverage&&he(Re.functionCoverage),details:Re.detailedCoverage?.map(V)}}ce.fromFile=we})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(ce){function he(re){switch(re){case 1:return C.CodeActionTriggerKind.Invoke;case 2:return C.CodeActionTriggerKind.Automatic}}ce.to=he})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ne;(function(ce){function he(V){const we=new C.TypeHierarchyItem($.to(V.kind),V.name,V.detail||"",T.URI.revive(V.uri),u.to(V.range),u.to(V.selectionRange));return we._sessionId=V._sessionId,we._itemId=V._itemId,we}ce.to=he;function re(V,we,Re){if(we=we??V._sessionId,Re=Re??V._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,kind:$.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:u.from(V.range),selectionRange:u.from(V.selectionRange),tags:V.tags?.map(q.from)}}ce.from=re})(Ne=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],_e([0,1,2,15,7,8,226]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(T,R,w,i={timeout:1500,errors:3}){this._logService=T,this._documents=R,this._mainThreadBulkEdits=w,this._thresholds=i,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(R,w,i)=>{const l={dispose:this._callbacks.push([R,w,T])};return Array.isArray(i)&&i.push(l),l}}async $participateInSave(T,R){const w=r.URI.revive(T);let i=!1;const h=setTimeout(()=>i=!0,this._thresholds.timeout),l=[];try{for(let s of[...this._callbacks]){if(i)break;const g=this._documents.getDocument(w),M=await this._deliverEventAsyncAndBlameBadListeners(s,{document:g,reason:A.TextDocumentSaveReason.to(R)});l.push(M)}}finally{clearTimeout(h)}return l}_deliverEventAsyncAndBlameBadListeners([T,R,w],i){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,T,R,i).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const s=this._badListeners.get(T);this._badListeners.set(T,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,R,w,i){const h=[],l=Date.now(),{document:s,reason:g}=i,{version:M}=s,C=Object.freeze({document:s,reason:g,waitUntil(b){if(Object.isFrozen(h))throw(0,t.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(b))}});try{R.apply(w,[C])}catch(b){return Promise.reject(b)}return Object.freeze(h),new Promise((b,u)=>{const S=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(S),b(a)}).catch(a=>{clearTimeout(S),u(a)})}).then(b=>{const u={edits:[]};for(const S of b)if(Array.isArray(S)&&S.every(a=>a instanceof _.TextEdit))for(const{newText:a,newEol:F,range:o}of S)u.edits.push({_type:2,resource:s.uri,edit:{range:o&&A.Range.from(o),text:a,eol:F&&A.EndOfLine.from(F)}});if(u.edits.length!==0)return M===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ye[165],_e([0,1,11,27,2,8,85]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(w,i,h,l){this.start=w,this.deletedCount=i,this.deletedItems=h,this.items=l}static asApiEvents(w){return w.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(h=>h.apiCell)}))}}class D{constructor(w,i,h){this.notebook=w,this._extHostDocument=i,this._cellData=h,this.handle=h.handle,this.uri=_.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(w,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return w._mime},set mime(h){w._mime=h},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}})}return this._apiCell}setOutputs(w){this._outputs=w.map(A.NotebookCellOutput.to)}setOutputItems(w,i,h){const l=h.map(A.NotebookCellOutputItem.to),s=this._outputs.find(g=>g.id===w);s&&(i||(s.items.length=0),s.items.push(...l))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=D;class T{constructor(w,i,h,l,s,g){this._proxy=w,this._textDocumentsAndEditors=i,this._textDocuments=h,this._emitter=l,this.uri=s,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=g.viewType,this._metadata=Object.freeze(g.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,g.cells]],!0),this._versionId=g.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this;this._notebook={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===r.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(i){return i=w._validateIndex(i),w._cells[i].apiCell},getCells(i){return(i?w._getCells(i):w._cells).map(l=>l.apiCell)},save(){return w._save()}}}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,i){this._versionId=w.versionId,this._isDirty=i;for(const h of w.rawEvents)h.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===P.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let i=w.start|0,h=w.end|0;return i<0&&(i=0),h>this._cells.length&&(h=this._cells.length),w.with({start:i,end:h})}_getCells(w){w=this._validateRange(w);const i=[];for(let h=w.start;h<w.end;h++)i.push(this._cells[h]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,i){if(this._disposed)return;const h=[],l=[],s=[];w.reverse().forEach(g=>{const C=g[2].map(S=>{const a=new D(this,this._textDocumentsAndEditors,S);return i||l.push(D.asModelAddData(this.apiNotebook,S)),a}),b=new I(g[0],g[1],[],C),u=this._cells.splice(g[0],g[1],...C);for(const S of u)s.push(S.uri),b.deletedItems.push(S.apiCell);h.push(b)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:s}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(h)}))}_moveCell(w,i){const h=this._cells.splice(w,1);this._cells.splice(i,0,...h);const l=[new I(w,1,h.map(s=>s.apiCell),[]),new I(i,0,[],h)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(l)}))}_setCellOutputs(w,i){const h=this._cells[w];h.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(w,i,h,l){const s=this._cells[w];s.setOutputItems(i,h,l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_changeCellLanguage(w,i){const h=this._cells[w];h.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(h.uri,i)}_changeCellMime(w,i){const h=this._cells[w];h.apiCell.mime=i}_changeCellMetadata(w,i){const h=this._cells[w],l=h.apiCell.metadata;h.setMetadata(i);const s=h.apiCell.metadata;(0,t.equals)(l,s)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(w,i){this._cells[w].setInternalMetadata(i)}getCellFromApiCell(w){return this._cells.find(i=>i.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(i=>i.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ye[89],_e([0,1,7,8,15]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,R){this._throwIfFinalized(),!(D===T&&R.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:R.map(t.NotebookCellData.from)})}}class P{constructor(D,T,R,w,i,h){this.id=D,this._proxy=T,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=w,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(r.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,R){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(T),R??r.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const R=new A(this.document.version);return T(R),D._applyEdit(R.finalize())},setDecorations(T,R){return D.setDecorations(T,R)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let R=-1;for(let w=0;w<D.cellEdits.length;w++){if(R<0){T.push(D.cellEdits[w]),R++;continue}const h=T[R],l=D.cellEdits[w];if(h.editType===1&&l.editType===1&&h.index===l.index){h.cells.push(...D.cellEdits[w].cells),h.count+=D.cellEdits[w].count;continue}T.push(D.cellEdits[w]),R++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(ye[166],_e([0,1,8,139,120,20,53,15]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,h,l){const s=this._handles++,{title:g,location:M,cancellable:C}=h,b={label:(0,_.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(s,{location:r.ProgressLocation.from(M),title:g,source:b,cancellable:C},i.isUnderDevelopment?void 0:i.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(s,l,!!C)}_withProgress(i,h,l){let s;l&&(s=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,s));const g=C=>{this._proxy.$progressEnd(C),this._mapHandleToCancellationSource.delete(C),s&&s.dispose()};let M;try{M=h(new R(this._proxy,i),l&&s?s.token:A.CancellationToken.None)}catch(C){throw g(i),C}return M.then(C=>g(i),C=>g(i)),M}$acceptProgressCanceled(i){const h=this._mapHandleToCancellationSource.get(i);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=D;function T(w,i){return w.message=i.message,typeof i.increment=="number"&&(typeof w.increment=="number"?w.increment+=i.increment:w.increment=i.increment),w}class R extends t.Progress{constructor(i,h){super(l=>this.throttledReport(l));this._proxy=i,this._handle=h}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}xe([(0,P.throttle)(100,(w,i)=>T(w,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[90],_e([0,1,42,15,54,8,7]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(i,h,l){const s=I._Keys.nextId();i.$registerTextEditorDecorationType(h.identifier,s,A.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:s,dispose(){i.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=I,I._Keys=new _.IdGenerator("TextEditorDecorationType");class D{constructor(i,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,h){this._throwIfFinalized();let l=null;if(i instanceof P.Position)l=new P.Range(i,i);else if(i instanceof P.Range)l=i;else throw new Error("Unrecognized location");this._pushEdit(l,h,!1)}insert(i,h){this._throwIfFinalized(),this._pushEdit(new P.Range(i,i),h,!0)}delete(i){this._throwIfFinalized();let h=null;if(i instanceof P.Range)h=i;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(i,h,l){const s=this._document.validateRange(i);this._collectedEdits.push({range:s,text:h,forceMoveMarkers:l})}setEndOfLine(i){if(this._throwIfFinalized(),i!==P.EndOfLine.LF&&i!==P.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=D;class T{constructor(i,h,l,s){this._proxy=i,this._id=h,this._accept(l),this._logService=s;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(M){g._setTabSize(M)},get insertSpaces(){return g._insertSpaces},set insertSpaces(M){g._setInsertSpaces(M)},get cursorStyle(){return g._cursorStyle},set cursorStyle(M){g._setCursorStyle(M)},get lineNumbers(){return g._lineNumbers},set lineNumbers(M){g._setLineNumbers(M)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const h=Math.floor(i);return h>0?h:null}if(typeof i=="string"){const h=parseInt(i,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(i){const h=this._validateTabSize(i);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const h=this._validateInsertSpaces(i);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(i)})))}assign(i){const h={};let l=!1;if(typeof i.tabSize!="undefined"){const s=this._validateTabSize(i.tabSize);s==="auto"?(l=!0,h.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,l=!0,h.tabSize=s)}if(typeof i.insertSpaces!="undefined"){const s=this._validateInsertSpaces(i.insertSpaces);s==="auto"?(l=!0,h.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,l=!0,h.insertSpaces=s)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,l=!0,h.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,l=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(i.lineNumbers)),l&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,h))}_warnOnError(i,h){h.catch(l=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(l)})}}e.ExtHostTextEditorOptions=T;class R{constructor(i,h,l,s,g,M,C,b){this.id=i,this._proxy=h,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new T(this._proxy,this.id,M,l),this._visibleRanges=C,this._viewColumn=b;const u=this;this.value=Object.freeze({get document(){return s.getValue()},set document(S){throw(0,t.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(S){if(!(S instanceof P.Selection))throw(0,t.illegalArgument)("selection");u._selections=[S],u._trySetSelection()},get selections(){return u._selections},set selections(S){if(!Array.isArray(S)||S.some(a=>!(a instanceof P.Selection)))throw(0,t.illegalArgument)("selections");u._selections=S,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(S){throw(0,t.readonly)("visibleRanges")},get options(){return u._options.value},set options(S){u._disposed||u._options.assign(S)},get viewColumn(){return u._viewColumn},set viewColumn(S){throw(0,t.readonly)("viewColumn")},edit(S,a={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const F=new D(s.getValue(),a);return S(F),u._applyEdit(F)},insertSnippet(S,a,F={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!a||Array.isArray(a)&&a.length===0)o=u._selections.map(n=>A.Range.from(n));else if(a instanceof P.Position){const{lineNumber:n,column:d}=A.Position.from(a);o=[{startLineNumber:n,startColumn:d,endLineNumber:n,endColumn:d}]}else if(a instanceof P.Range)o=[A.Range.from(a)];else{o=[];for(const n of a)if(n instanceof P.Range)o.push(A.Range.from(n));else{const{lineNumber:d,column:p}=A.Position.from(n);o.push({startLineNumber:d,startColumn:p,endLineNumber:d,endColumn:p})}}return h.$tryInsertSnippet(i,S.value,o,F)},setDecorations(S,a){const F=a.length===0;F&&!u._hasDecorationsForKey.has(S.key)||(F?u._hasDecorationsForKey.delete(S.key):u._hasDecorationsForKey.add(S.key),u._runOnProxy(()=>{if(A.isDecorationOptionsArr(a))return h.$trySetDecorations(i,S.key,A.fromRangeOrRangeWithMessage(a));{const o=new Array(4*a.length);for(let n=0,d=a.length;n<d;n++){const p=a[n];o[4*n]=p.start.line+1,o[4*n+1]=p.start.character+1,o[4*n+2]=p.end.line+1,o[4*n+3]=p.end.character+1}return h.$trySetDecorationsFast(i,S.key,o)}}))},revealRange(S,a){u._runOnProxy(()=>h.$tryRevealRange(i,A.Range.from(S),a||P.TextEditorRevealType.Default))},show(S){h.$tryShowEditor(i,A.ViewColumn.from(S))},hide(){h.$tryHideEditor(i)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,r.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,r.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,r.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,r.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const h=i.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const l=h.edits.map(g=>g.range);l.sort((g,M)=>g.end.line===M.end.line?g.end.character===M.end.character?g.start.line===M.start.line?g.start.character-M.start.character:g.start.line-M.start.line:g.end.character-M.end.character:g.end.line-M.end.line);for(let g=0,M=l.length-1;g<M;g++){const C=l[g].end;if(l[g+1].start.isBefore(C))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=h.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,s,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=R}),define(ye[167],_e([0,1,10,4,6,13,48,8,86,66]),function(ee,e,r,t,_,A,P,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends _.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const h=this.diff[this.diff.length-1];if(h&&i[0]===1){if(h[0]===1&&h[1].extId===i[1].extId){(0,D.applyTestItemUpdate)(h[1],i[1]);return}if(h[0]===0&&h[1].item.extId===i[1].extId){(0,D.applyTestItemUpdate)(h[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,h){const l=this.tree.get(i);if(!!l){if((l.expandLevels===void 0||h>l.expandLevels)&&(l.expandLevels=h),l.expand===1){const s=this.resolveChildren(l);return s.isOpen()?this.expandChildren(l,h-1):s.wait().then(()=>this.expandChildren(l,h-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,h-1)):this.expandChildren(l,h-1)}}dispose(){for(const i of this.tree.values())(0,P.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,h){switch(h.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(i.fullId,h.id));break;case 0:this.upsertItem(h.item,i);break;case 4:for(const l of h.ops)this.onTestItemEvent(i,l);break;case 3:{const{key:l,value:s,previous:g}=h,M=i.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(s,g,M);break;case"range":this.pushDiff([1,{extId:M,item:{range:I.Range.from(s)}}]);break;case"error":this.pushDiff([1,{extId:M,item:{error:I.MarkdownString.fromStrict(s)||null}}]);break;default:this.pushDiff([1,{extId:M,item:{[l]:s??null}}]);break}break}default:(0,A.assertNever)(h)}}upsertItem(i,h){if(!(i instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const l=T.TestId.fromExtHostTestItem(i,this.root.id,h?.actual),s=(0,P.getPrivateApiFor)(i);s.parent&&s.parent!==h?.actual&&s.parent.children.delete(i.id);let g=this.tree.get(l.toString());if(!g){g={fullId:l,actual:i,parent:h?l.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(i,h),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:I.TestItem.from(i)}]),this.connectItemAndChildren(i,g,h);return}if(g.actual===i){this.connectItem(i,g,h);return}const M=g.actual.children,C=g.actual,b=(0,P.diffTestItems)(C,i);(0,P.getPrivateApiFor)(C).listener=void 0,g.actual=i,g.expand=0;for(const[u,S]of b)this.onTestItemEvent(g,{op:3,key:u,value:S,previous:C[u]});this.connectItemAndChildren(i,g,h);for(const u of M)i.children.get(u.id)||this.removeItem(T.TestId.joinToString(l,u.id))}diffTagRefs(i,h,l){const s=new Set(h.map(g=>g.id));for(const g of i)s.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:l,item:{tags:i.map(g=>I.TestTag.namespace(this.controllerId,g.id))}}]),s.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const h=this.tags.get(i.id);h?h.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const h=this.tags.get(i);h&&!--h.refCount&&(this.tags.delete(i),this.pushDiff([6,I.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,h){(0,P.getPrivateApiFor)(i).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(i,h,l){this.setItemParent(i,l);const s=(0,P.getPrivateApiFor)(i);s.parent=l?.actual,s.listener=g=>this.onTestItemEvent(h,g),this.updateExpandability(h)}connectItemAndChildren(i,h,l){this.connectItem(i,h,l);for(const s of i.children)this.upsertItem(s,h)}updateExpandability(i){let h;this._resolveHandler?i.resolveBarrier?h=i.resolveBarrier.isOpen()?3:2:h=i.actual.canResolveChildren?1:0:h=0,h!==i.expand&&(i.expand=h,this.pushDiff([1,{extId:i.fullId.toString(),expand:h}]),h===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,h){if(h<0)return;const l=[];for(const s of i.actual.children){const g=this.expand(T.TestId.joinToString(i.fullId,s.id),h);(0,r.isThenable)(g)&&l.push(g)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const g=new r.Barrier;return g.open(),g}i.expand=2,this.pushExpandStateUpdate(i);const h=i.resolveBarrier=new r.Barrier,l=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=g.stack||g.message||String(g))};let s;try{s=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(g){l(g)}return(0,r.isThenable)(s)?s.catch(l).then(()=>{h.open(),this.updateExpandability(i)}):(h.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const h=this.tree.get(i);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const l=[h];for(;l.length;){const s=l.pop();if(!!s){(0,P.getPrivateApiFor)(s.actual).listener=void 0;for(const g of s.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(s.fullId.toString());for(const g of s.actual.children)l.push(this.tree.get(T.TestId.joinToString(s.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(ye[168],_e([0,1,3,135]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[169],_e([0,1,25,4,17]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=A;class P{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let w of R.activationEvents)w==="onUri"&&(w=`onUri:${r.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(R)}}keepOnly(R){const w=new Set;R.forEach(i=>w.add(r.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>w.has(r.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,w){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=P._findLoopingExtensions(this._extensionDescriptions);if(w=w.concat(i.map(h=>h.identifier)),w.length>0){const h=new Set;w.forEach(l=>h.add(r.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!h.has(r.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(i)}static _findLoopingExtensions(R){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,M){this.addNode(g),this.addNode(M),this._arcs.has(g)?this._arcs.get(g).push(M):this._arcs.set(g,[M])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,M){const C=w.getArcs(g);for(let b=0;b<C.length;b++)if(!M.has(C[b]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let g of R){const M=r.ExtensionIdentifier.toKey(g.identifier);if(i.set(M,g),g.extensionDependencies)for(let C of g.extensionDependencies){const b=r.ExtensionIdentifier.toKey(C);w.addArc(M,b)}}let h=new Set;w.getNodes().filter(g=>w.getArcs(g).length===0).forEach(g=>h.add(g));let l=w.getNodes().filter(g=>!h.has(g)),s;do{s=!1;for(let g=0;g<l.length;g++){const M=l[g];w.hasOnlyGoodArcs(M,h)&&(l.splice(g,1),g--,h.add(M),s=!0)}}while(s);return l.map(g=>i.get(g))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const w=this._activationMap.get(R);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const w=this._extensionsMap.get(r.ExtensionIdentifier.toKey(R));return w||void 0}}e.ExtensionDescriptionRegistry=P;var I;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(I||(I={}));function D(T,R){const w=T.isBuiltin?0:T.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(w!==i)return w-i;const h=_.posix.basename(T.extensionLocation.path),l=_.posix.basename(R.extensionLocation.path);return h<l?-1:h>l?1:0}}),define(ye[170],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(I){const D=r.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function P(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=P}),define(ye[26],_e([0,1,4,2,3,25,142]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var I;(function(u){u[u.None=0]="None",u[u.LocalProcess=1]="LocalProcess",u[u.LocalWebWorker=2]="LocalWebWorker",u[u.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(u){switch(u){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(S){this.dependency=S}}e.MissingExtensionDependency=T;var R;(function(u){u[u.LocalProcess=0]="LocalProcess",u[u.LocalWebWorker=1]="LocalWebWorker",u[u.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(u){switch(u){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=w;function i(u,S){return u.enabledApiProposals?u.enabledApiProposals.includes(S):!1}e.isProposedApiEnabled=i;function h(u,S){if(!i(u,S))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${S}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${S}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.checkProposedApiEnabled=h;class l{constructor(S,a,F,o){this.codeLoadingTime=S,this.activateCallTime=a,this.activateResolvedTime=F,this.activationReason=o}}e.ActivationTimes=l;class s{constructor(S,a){this.description=S,this.value=a}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var g;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(g=e.ActivationKind||(e.ActivationKind={}));function M(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation}}e.toExtension=M;function C(u,S){return{identifier:new A.ExtensionIdentifier((0,P.getExtensionId)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!S,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid}}e.toExtensionDescription=C;class b{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,a){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,a,F,o,n){}_onDidActivateExtensionError(S,a){}_onExtensionRuntimeError(S,a){}_onExtensionHostExit(S){}}e.NullExtensionService=b}),define(ye[171],_e([0,1,15,25,26,12]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class I{constructor(s,g,M,C){this.startup=s,this.codeLoadingTime=g,this.activateCallTime=M,this.activateResolvedTime=C}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class D{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,g){return s===-1||g===-1?-1:g-s}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class T{constructor(s,g,M,C,b,u){this.activationFailed=s,this.activationFailedError=g,this.activationTimes=M,this.module=C,this.exports=b,this.subscriptions=u}}e.ActivatedExtension=T;class R extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class w extends T{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class i extends T{constructor(s){super(!0,s,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let h=class{constructor(s,g,M,C,b){this._logService=b,this._isDisposed=!1,this._registry=s,this._resolvedExtensionsSet=new Set,g.forEach(u=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,M.forEach(u=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(u),u)),this._host=C,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(s){const g=t.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(g)}getActivatedExtension(s){const g=t.ExtensionIdentifier.toKey(s),M=this._activatedExtensions.get(g);if(!M)throw new Error("Extension `"+s.value+"` is not known or not activated");return M}activateByEvent(s,g){if(this._alreadyActivatedEvents[s])return P;const M=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(M.map(C=>({id:C.identifier,reason:{startup:g,extensionId:C.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,g){const M=this._registry.getExtensionDescription(s);if(!M)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:M.identifier,reason:g}])}_handleActivateRequest(s,g,M){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(s.id))){g[t.ExtensionIdentifier.toKey(s.id)]=s;return}const C=this._registry.getExtensionDescription(s.id);if(!C){const S=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,S,new _.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(s.id),new i(S));return}const b=typeof C.extensionDependencies=="undefined"?[]:C.extensionDependencies;let u=!0;for(let S=0,a=b.length;S<a;S++){const F=b[S];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(F)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(F));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const c=C.displayName||C.identifier.value,m=this._registry.getExtensionDescription(F),f=m&&m.displayName||F,E=new Error(`Cannot activate the '${c}' extension because its dependency '${f}' failed to activate`);E.detail=o.activationFailedError,this._host.onExtensionActivationError(C.identifier,E,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new i(E));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(F))){u=!1,g[t.ExtensionIdentifier.toKey(F)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(F)),reason:s.reason};continue}const n=this._registry.getExtensionDescription(F);if(n){if(!n.main&&!n.browser)continue;u=!1,g[t.ExtensionIdentifier.toKey(F)]={id:n.identifier,reason:s.reason};continue}const d=C.displayName||C.identifier.value,p=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${F}'`);this._host.onExtensionActivationError(C.identifier,p,new _.MissingExtensionDependency(F)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new i(p));return}u?g[t.ExtensionIdentifier.toKey(C.identifier)]=s:M.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(b=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(b.id))),s.length===0))return Promise.resolve(void 0);const g=Object.create(null),M=[];for(let b=0,u=s.length;b<u;b++)this._handleActivateRequest(s[b],g,M);for(let b=0,u=M.length;b<u;b++){const S=t.ExtensionIdentifier.toKey(M[b].id);g[S]&&delete g[S]}const C=Object.keys(g).map(b=>g[b]);return M.length===0?Promise.all(C.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(C).then(b=>this._activateExtensions(M))}_activateExtension(s,g){const M=t.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(M))return Promise.resolve(void 0);const C=this._activatingExtensions.get(M);if(C)return C;const b=this._host.actualActivateExtension(s,g).then(void 0,u=>{const S=new Error;return u&&u.name&&(S.name=u.name),u&&u.message?S.message=`Activating extension '${s.value}' failed: ${u.message}.`:S.message=`Activating extension '${s.value}' failed: ${u}.`,u&&u.stack&&(S.stack=u.stack),this._isDisposed&&r.isCancellationError(u)?new i(u):(this._host.onExtensionActivationError(s,S,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(u),new i(u))}).then(u=>{this._activatedExtensions.set(M,u),this._activatingExtensions.delete(M)});return this._activatingExtensions.set(M,b),b}};h=xe([$e(4,A.ILogService)],h),e.ExtensionsActivator=h}),define(ye[172],_e([0,1,12,28,26]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends r.LogService{constructor(I,D){super(I.createLogger(D.logFile,{name:_.ExtensionHostLogFileName}))}};A=xe([$e(0,r.ILoggerService),$e(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ye[173],_e([0,1,15]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,P)=>{this._actualOk=A,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,r.onUnexpectedError)(A))}then(A,P){return this._ensureActual().then(A,P)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(ye[38],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const t=[];function _(I){const D=new r(I);return t[D.nid]=D,D}e.createProxyIdentifier=_;function A(I){return t[I].sid}e.getStringIdentifierForProxy=A;class P{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=P}),define(ye[5],_e([0,1,55,2,38]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var P;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(b){b.name="$ident";function u(a,F){return Object.defineProperty(a,b.name,{value:F,enumerable:!0}),a}b.mixin=u;function S(a){return a[b.name]}b.of=S})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(u){return u._id=h._n++,u}}e.IdObject=h,h._n=0;var l;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.command="m",b.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(b){b[b.File=1]="File",b[b.Text=2]="Text",b[b.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function M(b){if(b&&b.edits)for(const u of b.edits)typeof u.resource=="object"?u.resource=t.URI.revive(u.resource):(u.newUri=t.URI.revive(u.newUri),u.oldUri=t.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,r.revive)(u.metadata));return b}e.reviveWorkspaceEditDto=M;var C;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],_e([0,1,5,4,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,T){return this._proxy.$setPassword(I,D,T)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ye[68],_e([0,1,3,12,5,14]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(_.MainContext.MainThreadTelemetry)}report(D,T,R){const w=this.getUsageKey(D,T);this._reportedUsages.has(w)||(this._reportedUsages.add(w),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};P=xe([$e(0,A.IExtHostRpcService),$e(1,t.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,T){}})}),define(ye[174],_e([0,1,4,5,7,25]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,R,w={}){const i=A.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(i)||[],l=[...R].sort().join(" ");let s=h.find(g=>g.scopes===l);if(s)return s.result;{const g=this._getSession(D,i,T,R,w);s={scopes:l,result:g},h.push(s),this._inFlightRequests.set(i,h);try{await g}finally{const M=h.findIndex(C=>C.scopes===l);M>-1&&(h.splice(M),this._inFlightRequests.set(i,h))}return g}}async _getSession(D,T,R,w,i={}){await this._proxy.$ensureProvider(R);const h=D.displayName||D.name;return this._proxy.$getSession(R,w,T,h,i)}async removeSession(D,T){const R=this._authenticationProviders.get(D);return R?R.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,R,w){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:R,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===D)||this._providers.push({id:D,label:T});const i=R.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(D,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,w?.supportsMultipleAccounts??!1),new _.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(D);const h=this._providers.findIndex(l=>l.id===D);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(ye[175],_e([0,1,5,14,8]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(r.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=_.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=xe([$e(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ye[176],_e([0,1,5]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const P=A.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(I){return P.$writeText(I)}})}}e.ExtHostClipboard=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[39],_e([0,1,13,7,8,27,5,16,12,55,58,227,2,6,3,14,48,21,38,43]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(p,c){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,u,p.getProxy(P.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new a(this,m=>{const f=this._apiCommands.get(m);return f?.result===o.Void?f:void 0},c),this._argumentProcessors=[{processArgument(m){return(0,T.revive)(m)}},{processArgument(m){return(0,A.cloneAndChange)(m,function(f){if(R.Range.isIRange(f))return _.Range.to(f);if(w.Position.isIPosition(f))return _.Position.to(f);if(R.Range.isIRange(f.range)&&i.URI.isUri(f.uri))return _.location.to(f);if(f instanceof M.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const c=this.registerCommand(!1,p.id,async(...m)=>{const f=p.args.map((v,k)=>{if(!v.validate(m[k]))throw new Error(`Invalid argument '${v.name}' when running '${p.id}', received: ${m[k]}`);return v.convert(m[k])}),E=await this.executeCommand(p.internalId,...f);return p.result.convert(E,m,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,c,m,f,E,v){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:m,thisArg:f,description:E,extension:v}),p&&Ie(this,u,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&p&&Ie(this,u,"f").$unregisterCommand(c)})}executeCommand(p,...c){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,c,!0)}async _doExecuteCommand(p,c,m){if(this._commands.has(p))return this._executeContributedCommand(p,c,!1);{let f=!1;const E=(0,A.cloneAndChange)(c,function(v){if(v instanceof t.Position)return _.Position.from(v);if(v instanceof t.Range)return _.Range.from(v);if(v instanceof t.Location)return _.location.from(v);if(t.NotebookRange.isNotebookRange(v))return _.NotebookRange.from(v);if(v instanceof ArrayBuffer)return f=!0,M.VSBuffer.wrap(new Uint8Array(v));if(v instanceof Uint8Array)return f=!0,M.VSBuffer.wrap(v);if(!Array.isArray(v))return v});try{const v=await Ie(this,u,"f").$executeCommand(p,f?new C.SerializableObjectWithBuffers(E):E,m);return(0,T.revive)(v)}catch(v){if(v instanceof Error&&v.message==="$executeCommand:retry")return this._doExecuteCommand(p,c,!1);throw v}}}async _executeContributedCommand(p,c,m){const f=this._commands.get(p);if(!f)throw new Error("Unknown command");let{callback:E,thisArg:v,description:k}=f;if(k)for(let U=0;U<k.args.length;U++)try{(0,r.validateConstraint)(c[U],k.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${k.args[U].name}' - ${k.args[U].description}`)}try{return await E.apply(v,c)}catch(U){if(p===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...c);N&&(p=N.command)}throw this._logService.error(U,p,f.extension?.identifier),m?new class extends Error{constructor(){super((0,b.toErrorMessage)(U));this.id=p,this.source=f.extension?.displayName??f.extension?.name}}:U}}$executeContributedCommand(p,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(c=c.map(m=>this._argumentProcessors.reduce((f,E)=>E.processArgument(f),m)),this._executeContributedCommand(p,c,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),Ie(this,u,"f").$getCommands().then(c=>(p&&(c=c.filter(m=>m[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[c,m]of this._commands){let{description:f}=m;f&&(p[c]=f)}return Promise.resolve(p)}};u=new WeakMap,S=xe([$e(0,s.IExtHostRpcService),$e(1,D.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class a{constructor(p,c,m){this._commands=p,this._lookupApiCommand=c,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,c){if(!p)return;const m={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return m;const f=this._lookupApiCommand(p.command);if(f)m.id=f.internalId,m.arguments=f.args.map((E,v)=>E.convert(p.arguments&&p.arguments[v]));else if((0,I.isNonEmptyArray)(p.arguments)){const E=++this._cachIdPool;this._cache.set(E,p),c.add((0,h.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),m.$ident=E,m.id=this.delegatingCommandId,m.arguments=[E],this._logService.trace("CommandsConverter#CREATE",p.command,E)}return m}fromInternal(p){const c=P.ObjectIdentifier.of(p);return typeof c=="number"?this._cache.get(c):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const c=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class F{constructor(p,c,m,f){this.name=p,this.description=c,this.validate=m,this.convert=f}optional(){return new F(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,c){return new F(p??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=F,F.Uri=new F("uri","Uri of a text document",d=>i.URI.isUri(d),d=>d),F.Position=new F("position","A position in a text document",d=>t.Position.isPosition(d),_.Position.from),F.Range=new F("range","A range in a text document",d=>t.Range.isRange(d),_.Range.from),F.Selection=new F("selection","A selection in a text document",d=>t.Selection.isSelection(d),_.Selection.from),F.Number=new F("number","",d=>typeof d=="number",d=>d),F.String=new F("string","",d=>typeof d=="string",d=>d),F.CallHierarchyItem=new F("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,_.CallHierarchyItem.from),F.TypeHierarchyItem=new F("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,_.TypeHierarchyItem.from),F.TestItem=new F("testItem","A VS Code TestItem",d=>d instanceof g.TestItemImpl,_.TestItem.from);class o{constructor(p,c){this.description=p,this.convert=c}}e.ApiCommandResult=o,o.Void=new o("no result",d=>d);class n{constructor(p,c,m,f,E){this.id=p,this.internalId=c,this.description=m,this.args=f,this.result=E}}e.ApiCommand=n}),define(ye[177],_e([0,1,8,7,57,39,16,77]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(r.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,h)=>{if((0,P.isFalsyOrEmpty)(i))return;class l extends t.SymbolInformation{static to(g){const M=new l(g.name,r.SymbolKind.to(g.kind),g.containerName||"",new t.Location(h[0],r.Range.to(g.range)));return M.detail=g.detail,M.range=M.location.range,M.selectionRange=r.Range.to(g.selectionRange),M.children=g.children?g.children.map(l.to):[],M}}return i.map(l.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(r.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(r.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(h=>t.Position.isPosition(h)),i=>i.map(r.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(h=>{let l;for(const s of h.reverse())l=new t.SelectionRange(r.Range.to(s),l);return l}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(r.WorkspaceSymbol.to))),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:r.Range.to(i.range),placeholder:i.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return r.WorkspaceEdit.to(i)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(r.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const h=(0,I.decodeSemanticTokensDto)(i);if(h.type==="full")return new t.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const h=(0,I.decodeSemanticTokensDto)(i);if(h.type==="full")return new t.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,h,l)=>{if(!i)return new t.CompletionList([]);const s=i.suggestions.map(g=>r.CompletionItem.to(g,l));return new t.CompletionList(s,i.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return r.SignatureHelp.to(i)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,h,l)=>R(s=>new t.CodeLens(r.Range.to(s.range),s.command&&l.fromInternal(s.command)))(i))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?r.Selection.from(i):r.Range.from(i)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,h,l)=>R(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(s.command)}else{const g=new t.CodeAction(s.title,s.kind?new t.CodeActionKind(s.kind):void 0);return s.edit&&(g.edit=r.WorkspaceEdit.to(s.edit)),s.command&&(g.command=l.fromInternal(s.command)),g.isPreferred=s.isPreferred,g}})(i))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(h=>new t.ColorInformation(r.Range.to(h.range),r.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,r.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:r.Range.from(i.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(r.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,h,l)=>i.map(r.InlayHint.to.bind(void 0,l)))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(h=>r.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(r.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(h){D.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=T;function R(i){return h=>{if(Array.isArray(h))return h.map(i)}}function w(i){if(!Array.isArray(i))return;const h=[];for(const l of i)_.isLocationLink(l)?h.push(r.DefinitionLink.to(l)):h.push(r.location.to(l));return h}}),define(ye[178],_e([0,1,10,53,4,6,2,57,25,8,7,26,5]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(l,s,g){const M=l.getProxy(i.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const p=this._commentControllers.get(d.handle);return p||d}else if(d&&d.$mid===7){const p=this._commentControllers.get(d.commentControlHandle);if(!p)return d;const c=p.getCommentThread(d.commentThreadHandle);return c||d}else if(d&&d.$mid===8){const p=this._commentControllers.get(d.thread.commentControlHandle);if(!p)return d;const c=p.getCommentThread(d.thread.commentThreadHandle);return c?{thread:c,text:d.text}:d}else if(d&&d.$mid===9){const p=this._commentControllers.get(d.thread.commentControlHandle);if(!p)return d;const c=p.getCommentThread(d.thread.commentThreadHandle);if(!c)return d;let m=d.commentUniqueId,f=c.getCommentByUniqueId(m);return f||d}else if(d&&d.$mid===10){const p=this._commentControllers.get(d.thread.commentControlHandle);if(!p)return d;const c=p.getCommentThread(d.thread.commentThreadHandle);if(!c)return d;let m=d.text,f=d.commentUniqueId,E=c.getCommentByUniqueId(f);return E?(E.body=m,E):d}return d}})}createCommentController(d,p,c){const m=C.handlePool++,f=new u(d,m,p,c);this._commentControllers.set(f.handle,f);const E=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(d.identifier))||[];return E.push(f),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(d.identifier),E),f.value}$createCommentThreadTemplate(d,p,c){const m=this._commentControllers.get(d);!m||m.$createCommentThreadTemplate(p,c)}async $updateCommentThreadTemplate(d,p,c){const m=this._commentControllers.get(d);!m||m.$updateCommentThreadTemplate(p,c)}$deleteCommentThread(d,p){const c=this._commentControllers.get(d);c&&c.$deleteCommentThread(p)}$provideCommentingRanges(d,p,c){const m=this._commentControllers.get(d);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const f=g.getDocument(P.URI.revive(p));return(0,r.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(f,c)).then(E=>E?E.map(v=>T.Range.from(v)):void 0)}$toggleReaction(d,p,c,m,f){const E=this._commentControllers.get(d);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const v=E.getCommentThread(p);if(v){const k=v.getCommentByUniqueId(m.uniqueIdInThread);if(E!==void 0&&k&&E.reactionHandler)return E.reactionHandler(k,F(f))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class b{constructor(d,p,c,m,f,E,v){this._commentControllerHandle=p,this._id=c,this._uri=m,this._range=f,this._comments=E,this.extensionDescription=v,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),M.$createCommentThread(p,this.handle,this._id,this._uri,T.Range.from(this._range),v.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{M.$deleteCommentThread(p,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(U){k.range=U},get comments(){return k.comments},set comments(U){k.comments=U},get collapsibleState(){return k.collapsibleState},set collapsibleState(U){k.collapsibleState=U},get canReply(){return k.canReply},set canReply(U){k.canReply=U},get contextValue(){return k.contextValue},set contextValue(U){k.contextValue=U},get label(){return k.label},set label(U){k.label=U},dispose:()=>{k.dispose()}}}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const d=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),p={};d("range")&&(p.range=T.Range.from(this._range)),d("label")&&(p.label=this.label),d("contextValue")&&(p.contextValue=this.contextValue??null),d("comments")&&(p.comments=this._comments.map(c=>S(this,c,this._commentsMap))),d("collapsibleState")&&(p.collapseState=o(this._collapseState)),d("canReply")&&(p.canReply=this.canReply),this.modifications={},M.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(d){for(let p of this._commentsMap){let c=p[0],m=p[1];if(d===m)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}b._handlePool=0,xe([(0,t.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(d,p,c,m){this._extension=d,this._handle=p,this._id=c,this._label=m,this._threads=new Map,M.$registerCommentController(this.handle,c,m);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(E){f.options=E},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(E){f.commentingRangeProvider=E},get reactionHandler(){return f.reactionHandler},set reactionHandler(E){f.reactionHandler=E},createCommentThread(E,v,k){return f.createCommentThread(E,v,k).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{M.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,M.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,M.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,M.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,p,c,m){if(typeof d=="string"){const f=new b(this.id,this.handle,d,p,c,m,this._extension);return this._threads.set(f.handle,f),f}else{const f=new b(this.id,this.handle,void 0,d,p,c,this._extension);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(d,p){const c=new b(this.id,this.handle,void 0,P.URI.revive(d),T.Range.to(p),[],this._extension);return c.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(d,p){let c=this._threads.get(d);c&&(c.range=T.Range.to(p))}$deleteCommentThread(d){let p=this._threads.get(d);p&&p.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function S(n,d,p){let c=p.get(d);c||(c=++n.commentHandle,p.set(d,c));const m=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;d.detail&&(0,w.checkProposedApiEnabled)(n.extensionDescription,"commentTimestamp");let f;return d.detail&&typeof d.detail!="string"?f={source:d.detail,$mid:14}:f=d.detail,{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:c,body:T.MarkdownString.from(d.body),userName:d.author.name,userIconPath:m,label:d.label,commentReactions:d.reactions?d.reactions.map(E=>a(E)):void 0,detail:f}}function a(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function F(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?P.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function o(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=h}),define(ye[91],_e([0,1,2,5,7,3,14,12,16,9,17]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Si{constructor(h,l){this._logService=l,this._provider=new Map,this._proxy=h.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,l){const s=Si._handlePool++;this._provider.set(s,{provider:h,extensionId:l}),this._proxy.$registerDecorationProvider(s,l.value);const g=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(M=>{if(!M){this._proxy.$onDidChange(s,null);return}let C=(0,D.asArray)(M);if(C.length<=Si._maxEventSize){this._proxy.$onDidChange(s,C);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,C.length);const b=C.map(a=>({uri:a,rank:(0,T.count)(a.path,"/")})),u=(0,D.groupBy)(b,(a,F)=>a.rank-F.rank||(0,T.compare)(a.uri.path,F.uri.path));let S=[];e:for(let a of u){let F;for(let o of a){let n=(0,R.dirname)(o.uri.path);if(F!==n&&(F=n,S.push(o.uri)>=Si._maxEventSize))break e}}this._proxy.$onDidChange(s,S)});return new _.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(h,l,s){if(!this._provider.has(h))return Object.create(null);const g=Object.create(null),{provider:M,extensionId:C}=this._provider.get(h);return await Promise.all(l.map(async b=>{try{const{uri:u,id:S}=b,a=await Promise.resolve(M.provideFileDecoration(r.URI.revive(u),s));if(!a)return;try{_.FileDecoration.validate(a),g[S]=[a.propagate,a.tooltip,a.badge,a.color]}catch(F){this._logService.warn(`INVALID decoration from extension '${C.value}': ${F}`)}}catch(u){this._logService.error(u)}})),g}};w._handlePool=0,w._maxEventSize=250,w=xe([$e(0,P.IExtHostRpcService),$e(1,I.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[179],_e([0,1,118,80,2,5,7,8,4,12,22,30]),function(ee,e,r,t,_,A,P,I,D,T,R,w){"use strict";var i,h,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class s{constructor(C,b,u,S,a,F){this._name=C,this._owner=b,this._maxDiagnosticsPerFile=u,i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Xe(this,l,new R.ResourceMap(o=>S.getComparisonKey(o)),"f"),Xe(this,i,a,"f"),Xe(this,h,F,"f")}dispose(){this._isDisposed||(Ie(this,h,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner),Ie(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(C,b){if(!C){this.clear();return}this._checkDisposed();let u=[];if(_.URI.isUri(C)){if(!b){this.delete(C);return}Ie(this,l,"f").set(C,b.slice()),u=[C]}else if(Array.isArray(C)){u=[];let a;C=[...C].sort(s._compareIndexedTuplesByUri);for(const F of C){const[o,n]=F;if((!a||o.toString()!==a.toString())&&(a&&Ie(this,l,"f").get(a).length===0&&Ie(this,l,"f").delete(a),a=o,u.push(o),Ie(this,l,"f").set(o,[])),n){const d=Ie(this,l,"f").get(o);d&&d.push(...n)}else{const d=Ie(this,l,"f").get(o);d&&(d.length=0)}}}if(Ie(this,h,"f").fire(u),!Ie(this,i,"f"))return;const S=[];for(let a of u){let F=[];const o=Ie(this,l,"f").get(a);if(o)if(o.length>this._maxDiagnosticsPerFile){F=[];const n=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(let p of o)if(p.severity===n[d]&&F.push(I.Diagnostic.from(p))===this._maxDiagnosticsPerFile)break e;F.push({severity:t.MarkerSeverity.Info,message:(0,r.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:F[F.length-1].startLineNumber,startColumn:F[F.length-1].startColumn,endLineNumber:F[F.length-1].endLineNumber,endColumn:F[F.length-1].endColumn})}else F=o.map(n=>I.Diagnostic.from(n));S.push([a,F])}Ie(this,i,"f").$changeMany(this._owner,S)}delete(C){this._checkDisposed(),Ie(this,h,"f").fire([C]),Ie(this,l,"f").delete(C),Ie(this,i,"f")&&Ie(this,i,"f").$changeMany(this._owner,[[C,void 0]])}clear(){this._checkDisposed(),Ie(this,h,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,l,"f").clear(),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner)}forEach(C,b){this._checkDisposed();for(let u of Ie(this,l,"f").keys())C.apply(b,[u,this.get(u),this])}get(C){this._checkDisposed();const b=Ie(this,l,"f").get(C);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(C){return this._checkDisposed(),Array.isArray(Ie(this,l,"f").get(C))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(C,b){return C[0].toString()<b[0].toString()?-1:C[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=s,i=new WeakMap,h=new WeakMap,l=new WeakMap;let g=class si{constructor(C,b,u){this._logService=b,this._fileSystemInfoService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=C.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(C){const b=new R.ResourceMap;for(const u of C)b.set(u,u);return{uris:Object.freeze(Array.from(b.values()))}}createDiagnosticCollection(C,b){const{_collections:u,_proxy:S,_onDidChangeDiagnostics:a,_logService:F,_fileSystemInfoService:o}=this,n=new class{$changeMany(c,m){S.$changeMany(c,m),F.trace("[DiagnosticCollection] change many (extension, owner, uris)",C.value,c,m.length===0?"CLEARING":m)}$clear(c){S.$clear(c),F.trace("[DiagnosticCollection] remove all (extension, owner)",C.value,c)}dispose(){S.dispose()}};let d;if(!b)b="_generated_diagnostic_collection_name_#"+si._idPool++,d=b;else if(!u.has(b))d=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do d=b+si._idPool++;while(u.has(d))}return new class extends s{constructor(){super(b,d,si._maxDiagnosticsPerFile,o.extUri,n,a);u.set(d,this)}dispose(){super.dispose(),u.delete(d)}}}getDiagnostics(C){if(C)return this._getDiagnostics(C);{const b=new Map,u=[];for(const S of this._collections.values())S.forEach((a,F)=>{let o=b.get(a.toString());typeof o=="undefined"&&(o=u.length,b.set(a.toString(),o),u.push([a,[]])),u[o][1]=u[o][1].concat(...F)});return u}}_getDiagnostics(C){let b=[];for(let u of this._collections.values())u.has(C)&&(b=b.concat(u.get(C)));return b}$acceptMarkersChange(C){if(!this._mirrorCollection){const b="_generated_mirror",u=new s(b,b,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,u),this._mirrorCollection=u}for(const[b,u]of C)this._mirrorCollection.set(_.URI.revive(b),u.map(I.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=xe([$e(1,T.ILogService),$e(2,w.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(ye[180],_e([0,1,2,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(P){this._proxy=P.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(I=>I?I.map(D=>r.URI.revive(D)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(I=>I?r.URI.revive(I):void 0)}}e.ExtHostDialogs=_}),define(ye[181],_e([0,1,15,2,7,5,11,20,9]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(w,i,h){this._documentsAndEditors=i,this._logService=h,this._documentContentProviders=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,i){if(Object.keys(P.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const h=T._handlePool++;this._documentContentProviders.set(h,i),this._proxy.$registerTextContentProvider(h,w);let l;return typeof i.onDidChange=="function"&&(l=i.onDidChange(s=>{if(s.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(h,s).then(g=>{if(!g&&typeof g!="string")return;const M=this._documentsAndEditors.getDocument(s);if(!M)return;const C=(0,D.splitLines)(g);if(!M.equalLines(C))return this._proxy.$onVirtualDocumentChange(s,g)},r.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(w,i){const h=this._documentContentProviders.get(w);return h?Promise.resolve(h.provideTextDocumentContent(t.URI.revive(i),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ye[182],_e([0,1,4,6,2,5,84,8,13,27,7]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(h,l){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const g of s)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const g of s)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const l=this._documentsAndEditors.getDocument(h);if(l)return l}getDocument(h){const l=this.getDocumentData(h);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return l.document}ensureDocumentData(h){const l=this._documentsAndEditors.getDocument(h);if(l)return Promise.resolve(l);let s=this._documentLoader.get(h.toString());return s||(s=this._proxy.$tryOpenDocument(h).then(g=>{this._documentLoader.delete(h.toString());const M=_.URI.revive(g);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(M))},g=>(this._documentLoader.delete(h.toString()),Promise.reject(g))),this._documentLoader.set(h.toString(),s)),s}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(l=>_.URI.revive(l))}$acceptModelLanguageChanged(h,l){const s=_.URI.revive(h),g=this._documentsAndEditors.getDocument(s);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(l),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(h){const l=_.URI.revive(h),s=this._documentsAndEditors.getDocument(l);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(h,l){const s=_.URI.revive(h),g=this._documentsAndEditors.getDocument(s);if(!g)throw new Error("unknown document");g._acceptIsDirty(l),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,l,s){const g=_.URI.revive(h),M=this._documentsAndEditors.getDocument(g);if(!M)throw new Error("unknown document");M._acceptIsDirty(s),M.onEvents(l);let C;l.isUndoing?C=R.TextDocumentChangeReason.Undo:l.isRedoing&&(C=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:M.document,contentChanges:l.changes.map(b=>({range:I.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:C}))}setWordDefinitionFor(h,l){(0,P.setWordDefinitionFor)(h,l)}}e.ExtHostDocuments=w}),define(ye[49],_e([0,1,42,4,6,2,3,5,84,14,90,8,12,22,11,157,228]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class M{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let C=class{constructor(u,S){this._extHostRpc=u,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const S=[],a=[],F=[];if(u.removedDocuments)for(const o of u.removedDocuments){const n=A.URI.revive(o),d=this._documents.get(n);d?.unref()&&(this._documents.delete(n),S.push(d.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const n=A.URI.revive(o.uri);let d=this._documents.get(n);if(d&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);d||(d=new M(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(n,d),a.push(d.value)),d.ref()}if(u.removedEditors)for(const o of u.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&F.push(n)}if(u.addedEditors)for(const o of u.addedEditors){const n=A.URI.revive(o.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const d=this._documents.get(n).value,p=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>d.document),o.selections.map(w.Selection.to),o.options,o.visibleRanges.map(c=>w.Range.to(c)),typeof o.editorPosition=="number"?w.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,p)}u.newActiveEditor!==void 0&&(r.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,_.dispose)(S),(0,_.dispose)(F),u.removedDocuments&&this._onDidRemoveDocuments.fire(S),u.addedDocuments&&this._onDidAddDocuments.fire(a),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return s.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return u?S:S?.value}allEditors(){return[...this._editors.values()]}};C=xe([$e(0,T.IExtHostRpcService),$e(1,i.ILogService)],C),e.ExtHostDocumentsAndEditors=C,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[69],_e([0,1,8,5,2,4,3,14,10]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let T=class{constructor(w){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=w.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(w){let i=-1;this._tabs=w.map((l,s)=>(l.isActive&&(i=s),Object.freeze({label:l.label,viewColumn:r.ViewColumn.to(l.viewColumn),index:s,resource:_.URI.revive(l.resource),additionalResourcesAndViewIds:l.additionalResourcesAndViewIds.map(({resource:g,viewId:M})=>({resource:_.URI.revive(g),viewId:M})),viewId:l.editorId,isActive:l.isActive,move:async(g,M)=>{this._proxy.$moveTab(l,g,r.ViewColumn.from(M)),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(l),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((l,s)=>l.viewColumn===s.viewColumn?l.index-s.index:l.viewColumn-s.viewColumn);const h=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==h&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=xe([$e(0,I.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(ye[183],_e([0,1,2,5,6,7,8,229,9,21,26]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const s=this._schemes.indexOf(l);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),s=[];let g,M,C=14,b=14;for(const u of l){let S=g?(0,D.commonPrefixLength)(g,u):0;for(S===0?M=1:M=b;S<u.length;S++)S+1===u.length?(C=b,b=9):b+=1,s.push([M,u.toUpperCase().charCodeAt(S),b]),s.push([M,u.toLowerCase().charCodeAt(S),b]),M=b;g=u,b=C}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new I.StateMachine(s)}}provideDocumentLinks(l){this._initStateMachine();const s=[],g=I.LinkComputer.computeLinks({getLineContent(M){return l.lineAt(M-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const M of g){const C=P.DocumentLink.to(M);C.target&&s.push(C)}return s}}class i{constructor(l,s){this._extHostLanguageFeatures=s,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,s,g,M={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const C=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(C,g);let b=2;M.isCaseSensitive&&(b+=1024),M.isReadonly&&(b+=2048),typeof g.copy=="function"&&(b+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(l,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(C,s,b).catch(S=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${s}`),console.error(S)});const u=g.onDidChangeFile(S=>{const a=[];for(const F of S){let{uri:o,type:n}=F;if(o.scheme!==s)continue;let d;switch(n){case A.FileChangeType.Changed:d=0;break;case A.FileChangeType.Created:d=1;break;case A.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:o,type:d})}this._proxy.$onFileSystemChange(C,a)});return(0,_.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(C),this._proxy.$unregisterProvider(C)})}static _asIStat(l){const{type:s,ctime:g,mtime:M,size:C,permissions:b}=l;return{type:s,ctime:g,mtime:M,size:C,permissions:b}}$stat(l,s){return Promise.resolve(this._getFsProvider(l).stat(r.URI.revive(s))).then(g=>i._asIStat(g))}$readdir(l,s){return Promise.resolve(this._getFsProvider(l).readDirectory(r.URI.revive(s)))}$readFile(l,s){return Promise.resolve(this._getFsProvider(l).readFile(r.URI.revive(s))).then(g=>T.VSBuffer.wrap(g))}$writeFile(l,s,g,M){return Promise.resolve(this._getFsProvider(l).writeFile(r.URI.revive(s),g.buffer,M))}$delete(l,s,g){return Promise.resolve(this._getFsProvider(l).delete(r.URI.revive(s),g))}$rename(l,s,g,M){return Promise.resolve(this._getFsProvider(l).rename(r.URI.revive(s),r.URI.revive(g),M))}$copy(l,s,g,M){const C=this._getFsProvider(l);if(!C.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(C.copy(r.URI.revive(s),r.URI.revive(g),M))}$mkdir(l,s){return Promise.resolve(this._getFsProvider(l).createDirectory(r.URI.revive(s)))}$watch(l,s,g,M){const C=this._getFsProvider(l).watch(r.URI.revive(g),M);this._watches.set(s,C)}$unwatch(l,s){const g=this._watches.get(s);g&&(g.dispose(),this._watches.delete(s))}$open(l,s,g){const M=this._getFsProvider(l);if(!M.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(M.open(r.URI.revive(s),g))}$close(l,s){const g=this._getFsProvider(l);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(s))}$read(l,s,g,M){const C=this._getFsProvider(l);if(!C.read)throw new Error('FileSystemProvider does not implement "read"');const b=T.VSBuffer.alloc(M);return Promise.resolve(C.read(s,g,b.buffer,0,M)).then(u=>b.slice(0,u))}$write(l,s,g,M){const C=this._getFsProvider(l);if(!C.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(C.write(s,g,M.buffer,0,M.byteLength))}_getFsProvider(l){const s=this._fsProvider.get(l);if(!s){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return s}}e.ExtHostFileSystem=i}),define(ye[50],_e([0,1,5,46,7,21,3,14,30,6]),function(ee,e,r,t,_,A,P,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Wt{constructor(i,h){this._fileSystemProvider=new Map,this._proxy=i.getProxy(r.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(s){try{const g=l._fileSystemProvider.get(s.scheme);if(!g)return await l._proxy.$stat(s);await l._proxy.$ensureActivation(s.scheme);const M=await g.stat(s);return{type:M.type,ctime:M.ctime,mtime:M.mtime,size:M.size,permissions:M.permissions}}catch(g){Wt._handleError(g)}},async readDirectory(s){try{const g=l._fileSystemProvider.get(s.scheme);return g?(await l._proxy.$ensureActivation(s.scheme),(await g.readDirectory(s)).slice()):await l._proxy.$readdir(s)}catch(g){return Wt._handleError(g)}},async createDirectory(s){try{return await l._proxy.$mkdir(s)}catch(g){return Wt._handleError(g)}},async readFile(s){try{const g=l._fileSystemProvider.get(s.scheme);return g?(await l._proxy.$ensureActivation(s.scheme),(await g.readFile(s)).slice()):(await l._proxy.$readFile(s)).buffer}catch(g){return Wt._handleError(g)}},async writeFile(s,g){try{return await l._proxy.$writeFile(s,A.VSBuffer.wrap(g))}catch(M){return Wt._handleError(M)}},async delete(s,g){try{const M=l._fileSystemProvider.get(s.scheme);return M?(await l._proxy.$ensureActivation(s.scheme),await M.delete(s,{recursive:!1,...g})):await l._proxy.$delete(s,{recursive:!1,useTrash:!1,...g})}catch(M){return Wt._handleError(M)}},async rename(s,g,M){try{return await l._proxy.$rename(s,g,{overwrite:!1,...M})}catch(C){return Wt._handleError(C)}},async copy(s,g,M){try{return await l._proxy.$copy(s,g,{overwrite:!1,...M})}catch(C){return Wt._handleError(C)}},isWritableFileSystem(s){const g=h.getCapabilities(s);if(typeof g=="number")return!(g&2048)}})}static _handleError(i){if(i instanceof _.FileSystemError)throw i;if(!(i instanceof Error))throw new _.FileSystemError(String(i));if(i.name==="ENOPRO")throw _.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(i.message);default:throw new _.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,h){return this._fileSystemProvider.set(i,h),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=xe([$e(0,I.IExtHostRpcService),$e(1,D.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[184],_e([0,1,4,29,2,5,8,7]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(w,i,h,l,s,g,M,C){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const b=this.ensureWatching(w,h,s);this._config=0,g&&(this._config+=1),M&&(this._config+=2),C&&(this._config+=4);const u=(0,t.parse)(s),S=typeof s=="string",a=l(F=>{if(!g)for(let o of F.created){const n=_.URI.revive(o);u(n.fsPath)&&(!S||i.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!M)for(let o of F.changed){const n=_.URI.revive(o);u(n.fsPath)&&(!S||i.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!C)for(let o of F.deleted){const n=_.URI.revive(o);u(n.fsPath)&&(!S||i.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=I.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(w,i,h){let l=I.Disposable.from();if(typeof h=="string")return l;const s=w.getProxy(A.MainContext.MainThreadFileSystem);let g=!1;(h.pattern.includes(t.GLOBSTAR)||h.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const M=Math.random();return s.$watch(i.identifier.value,M,h.baseUri,{recursive:g,excludes:[]}),I.Disposable.from({dispose:()=>s.$unwatch(M)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(w,i,h){this._mainContext=w,this._logService=i,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,i,h,l,s,g){return new D(this._mainContext,w,i,this._onFileSystemEvent.event,P.GlobPattern.from(h),l,s,g)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,i){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:i.map(h=>({oldUri:_.URI.revive(h.source),newUri:_.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:i.map(h=>_.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:i.map(h=>_.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,i){return(h,l,s)=>{const g=function(C){h.call(l,C)};return g.extension=w,i.event(g,void 0,s)}}async $onWillRunFileOperation(w,i,h,l){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:i.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},h,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:i.map(s=>_.URI.revive(s.target))},h,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:i.map(s=>_.URI.revive(s.target))},h,l)}}async _fireWillEvent(w,i,h,l){const s=new Set,g=[];if(await w.fireAsync(i,l,async(C,b)=>{const u=Date.now(),S=await Promise.resolve(C);S instanceof I.WorkspaceEdit&&(g.push(S),s.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-u>h&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),l.isCancellationRequested||g.length===0)return;const M={edits:[]};for(let C of g){let{edits:b}=P.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);M.edits=M.edits.concat(b)}return{edit:M,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=T}),define(ye[185],_e([0,1,2,39]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(P,I,D,T){this._extHostNotebooks=I,this._textDocumentsAndEditors=D,this._commands=T;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(w.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(w.notebookEditorId);return{notebookUri:r.URI.revive(w.notebookUri),inputUri:r.URI.revive(w.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:r.URI.revive(w.notebookUri),inputUri:r.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(P,I,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:D,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=_}),define(ye[186],_e([0,1,6,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(P){this._handlePool=0,this._proxy=P.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,P),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=_}),define(ye[187],_e([0,1,2,27,8,7,5,9,58,16,13,230,20,6,77,54,62,188,15,4,10]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class S{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentSymbols(z,K){const H=this._documents.getDocument(z),j=await this._provider.provideDocumentSymbols(H,K);if(!(0,T.isFalsyOrEmpty)(j))return j[0]instanceof A.DocumentSymbol?j.map(_.DocumentSymbol.from):S._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((j,Y)=>{let ae=j.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(j.location.range.end)),ae});const K=[],H=[];for(const j of z){const Y={name:j.name||"!!MISSING: name!!",kind:_.SymbolKind.from(j.kind),tags:j.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:_.Range.from(j.location.range),selectionRange:_.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(Y),K.push(Y);break}const ae=H[H.length-1];if(D.Range.containsRange(ae.range,Y.range)&&!D.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),H.push(Y);break}H.pop()}}return K}}class a{constructor(z,K,H){this._documents=z,this._commands=K,this._provider=H,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,K){const H=this._documents.getDocument(z),j=await this._provider.provideCodeLenses(H,K);if(!j||K.isCancellationRequested)return;const Y=this._cache.add(j),ae=new h.DisposableStore;this._disposables.set(Y,ae);const Se={cacheId:Y,lenses:[]};for(let Ue=0;Ue<j.length;Ue++)Se.lenses.push({cacheId:[Y,Ue],range:_.Range.from(j[Ue].range),command:this._commands.toInternal(j[Ue].command,ae)});return Se}async resolveCodeLens(z,K){const H=z.cacheId&&this._cache.get(...z.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,K),j||(j=H),K.isCancellationRequested)return;const Y=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Y)return z.command=this._commands.toInternal(j.command??a._badCmd,Y),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function F(tt){return Array.isArray(tt)?tt.map(_.DefinitionLink.from):tt?[_.DefinitionLink.from(tt)]:[]}class o{constructor(z,K){this._documents=z,this._provider=K}async provideDefinition(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideDefinition(j,Y,H);return F(ae)}}class n{constructor(z,K){this._documents=z,this._provider=K}async provideDeclaration(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideDeclaration(j,Y,H);return F(ae)}}class d{constructor(z,K){this._documents=z,this._provider=K}async provideImplementation(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideImplementation(j,Y,H);return F(ae)}}class p{constructor(z,K){this._documents=z,this._provider=K}async provideTypeDefinition(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideTypeDefinition(j,Y,H);return F(ae)}}class c{constructor(z,K){this._documents=z,this._provider=K}async provideHover(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideHover(j,Y,H);if(!(!ae||(0,T.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=j.getWordRangeAtPosition(Y)),ae.range||(ae.range=new A.Range(Y,Y)),_.Hover.from(ae)}}class m{constructor(z,K){this._documents=z,this._provider=K}async provideEvaluatableExpression(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideEvaluatableExpression(j,Y,H);if(ae)return _.EvaluatableExpression.from(ae)}}class f{constructor(z,K){this._documents=z,this._provider=K}async provideInlineValues(z,K,H,j){const Y=this._documents.getDocument(z),ae=await this._provider.provideInlineValues(Y,_.Range.to(K),_.InlineValueContext.to(H),j);if(Array.isArray(ae))return ae.map(Se=>_.InlineValue.from(Se))}}class E{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentHighlights(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideDocumentHighlights(j,Y,H);if(Array.isArray(ae))return ae.map(_.DocumentHighlight.from)}}class v{constructor(z,K){this._documents=z,this._provider=K}async provideLinkedEditingRanges(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.provideLinkedEditingRanges(j,Y,H);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,T.coalesce)(ae.ranges.map(_.Range.from)),wordPattern:ae.wordPattern}}}class k{constructor(z,K){this._documents=z,this._provider=K}async provideReferences(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Position.to(K),Se=await this._provider.provideReferences(Y,ae,H,j);if(Array.isArray(Se))return Se.map(_.location.from)}}class U{constructor(z,K,H,j,Y,ae,Se){this._documents=z,this._commands=K,this._diagnostics=H,this._provider=j,this._logService=Y,this._extension=ae,this._apiDeprecation=Se,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,K,H,j){const Y=this._documents.getDocument(z),ae=w.Selection.isISelection(K)?_.Selection.to(K):_.Range.to(K),Se=[];for(const Je of this._diagnostics.getDiagnostics(z))if(ae.intersection(Je.range)&&Se.push(Je)>U._maxCodeActionsPerFile)break;const Ue={diagnostics:Se,only:H.only?new A.CodeActionKind(H.only):void 0,triggerKind:_.CodeActionTriggerKind.to(H.trigger)},Ve=await this._provider.provideCodeActions(Y,ae,Ue,j);if(!(0,T.isNonEmptyArray)(Ve)||j.isCancellationRequested)return;const Qe=this._cache.add(Ve),nt=new h.DisposableStore;this._disposables.set(Qe,nt);const rt=[];for(let Je=0;Je<Ve.length;Je++){const Ze=Ve[Je];!Ze||(U._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,nt)})):(Ue.only&&(Ze.kind?Ue.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Qe,Je],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,nt),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(_.Diagnostic.from),edit:Ze.edit&&_.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:Qe,actions:rt}}async resolveCodeAction(z,K){const[H,j]=z,Y=this._cache.get(H,j);if(!Y||U._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,K)??Y;return ae?.edit?_.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}U._maxCodeActionsPerFile=1e3;class N{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentFormattingEdits(z,K,H){const j=this._documents.getDocument(z),Y=await this._provider.provideDocumentFormattingEdits(j,K,H);if(Array.isArray(Y))return Y.map(_.TextEdit.from)}}class y{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeFormattingEdits(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Range.to(K),Se=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,H,j);if(Array.isArray(Se))return Se.map(_.TextEdit.from)}}class L{constructor(z,K){this._documents=z,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,K,H,j,Y){const ae=this._documents.getDocument(z),Se=_.Position.to(K),Ue=await this._provider.provideOnTypeFormattingEdits(ae,Se,H,j,Y);if(Array.isArray(Ue))return Ue.map(_.TextEdit.from)}}class W{constructor(z,K){this._provider=z,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,K){const H=P.IdObject.mixin({symbols:[]}),j=await this._provider.provideWorkspaceSymbols(z,K);if((0,T.isNonEmptyArray)(j))for(const Y of j){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=P.IdObject.mixin(_.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),H.symbols.push(ae)}return H.symbols.length>0&&this._resultCache.set(H._id,[H.symbols[0]._id,H.symbols[H.symbols.length-1]._id]),H}async resolveWorkspaceSymbol(z,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const H=this._symbolCache.get(z._id);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,K);return j&&(0,t.mixin)(z,_.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(z){const K=this._resultCache.get(z);if(K){for(let[H,j]=K;H<=j;H++)this._symbolCache.delete(H);this._resultCache.delete(z)}}}class x{constructor(z,K,H){this._documents=z,this._provider=K,this._logService=H}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Position.to(K);try{const Se=await this._provider.provideRenameEdits(Y,ae,H,j);return Se?_.WorkspaceEdit.from(Se):void 0}catch(Se){const Ue=x._asMessage(Se);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(z,K,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(z),Y=_.Position.to(K);try{const ae=await this._provider.prepareRename(j,Y,H);let Se,Ue;if(A.Range.isRange(ae)?(Se=ae,Ue=j.getText(ae)):(0,R.isObject)(ae)&&(Se=ae.range,Ue=ae.placeholder),!Se||!Ue)return;if(Se.start.line>Y.line||Se.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(Se),text:Ue}}catch(ae){const Se=x._asMessage(ae);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,K){this.resultId=z,this.tokens=K}}class q{constructor(z,K){this._documents=z,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,K,H){const j=this._documents.getDocument(z),Y=K!==0?this._previousResults.get(K):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,Y.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return Y&&this._previousResults.delete(K),ae?(ae=q._fixProvidedSemanticTokens(ae),this._send(q._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return q._isSemanticTokens(z)?q._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):q._isSemanticTokensEdits(z)?q._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const K of z.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,K){if(!q._isSemanticTokens(K)||!z||!z.tokens)return K;const H=z.tokens,j=H.length,Y=K.data,ae=Y.length;let Se=0;const Ue=Math.min(j,ae);for(;Se<Ue&&H[Se]===Y[Se];)Se++;if(Se===j&&Se===ae)return new A.SemanticTokensEdits([],K.resultId);let Ve=0;const Qe=Ue-Se;for(;Ve<Qe&&H[j-Ve-1]===Y[ae-Ve-1];)Ve++;return new A.SemanticTokensEdits([{start:Se,deleteCount:j-Se-Ve,data:Y.subarray(Se,ae-Ve)}],K.resultId)}_send(z,K){if(q._isSemanticTokens(z)){const H=this._nextResultId++;return this._previousResults.set(H,new $(z.resultId,z.data)),(0,l.encodeSemanticTokensDto)({id:H,type:"full",data:z.data})}if(q._isSemanticTokensEdits(z)){const H=this._nextResultId++;return q._isSemanticTokens(K)?this._previousResults.set(H,new $(K.resultId,K.data)):this._previousResults.set(H,new $(z.resultId)),(0,l.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(z.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=q;class ie{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeSemanticTokens(z,K,H){const j=this._documents.getDocument(z),Y=await this._provider.provideDocumentRangeSemanticTokens(j,_.Range.to(K),H);return Y?this._send(Y):null}_send(z){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class se{constructor(z,K,H,j,Y){this._documents=z,this._commands=K,this._provider=H,this._apiDeprecation=j,this._extension=Y,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Position.to(K),Se=Y.getWordRangeAtPosition(ae)||new A.Range(ae,ae),Ue=Se.with({end:ae}),Ve=new M.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Y,ae,j,_.CompletionContext.to(H));if(!Qe||j.isCancellationRequested)return;const nt=Array.isArray(Qe)?new A.CompletionList(Qe):Qe,rt=se.supportsResolving(this._provider)?this._cache.add(nt.items):this._cache.add([]),Je=new h.DisposableStore;this._disposables.set(rt,Je);const Ze=[],pt={x:rt,b:Ze,a:{replace:_.Range.from(Se),insert:_.Range.from(Ue)},c:nt.isIncomplete||void 0,d:Ve.elapsed()};for(let Fe=0;Fe<nt.items.length;Fe++){const At=nt.items[Fe],G=this._convertCompletionItem(At,[rt,Fe],Ue,Se);Ze.push(G)}return pt}async resolveCompletionItem(z,K){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...z);if(!H)return;const j=await this._provider.resolveCompletionItem(H,K);if(!!j)return this._convertCompletionItem(j,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,K,H,j){const Y=this._disposables.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:K,a:z.label,b:z.kind!==void 0?_.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(_.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(z.command,Y)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=z.textEdit.newText):typeof z.insertText=="string"?ae.h=z.insertText:z.insertText instanceof A.SnippetString&&(ae.h=z.insertText.value,ae.i|=4);let Se;return z.textEdit?Se=z.textEdit.range:z.range&&(Se=z.range),A.Range.isRange(Se)?ae.j=_.Range.from(Se):Se&&(!H?.isEqual(Se.inserting)||!j?.isEqual(Se.replacing))&&(ae.j={insert:_.Range.from(Se.inserting),replace:_.Range.from(Se.replacing)}),ae}}class X{constructor(z,K,H){this._documents=z,this._provider=K,this._commands=H,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Position.to(K),Se=await this._provider.provideInlineCompletionItems(Y,ae,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:_.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text,isSnippetText:H.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(H.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:H.triggerKind},j);if(!Se||j.isCancellationRequested)return;const Ue=(0,R.isArray)(Se)?{items:Se}:Se,Ve=this._cache.add(Ue.items);let Qe;return{pid:Ve,items:Ue.items.map((nt,rt)=>{let Je;return nt.command&&(Qe||(Qe=new h.DisposableStore,this._disposables.set(Ve,Qe)),Je=this._commands.toInternal(nt.command,Qe)),{text:nt.text,range:nt.range?_.Range.from(nt.range):void 0,command:Je,idx:rt}})}}disposeCompletions(z){this._cache.delete(z);const K=this._disposables.get(z);K&&K.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,K){const H=this._cache.get(z,K);H&&ge.get(this._provider).fireOnDidShowCompletionItem({completionItem:H})}}class ge{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let K=ge.map.get(z);return K||(K=new ge,ge.map.set(z,K)),K}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=ge,ge.map=new WeakMap;class be{constructor(z,K){this._documents=z,this._provider=K,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(z,K,H,j){const Y=this._documents.getDocument(z),ae=_.Position.to(K),Se=this.reviveContext(H),Ue=await this._provider.provideSignatureHelp(Y,ae,j,Se);if(Ue){const Ve=this._cache.add([Ue]);return{..._.SignatureHelp.from(Ue),id:Ve}}}reviveContext(z){let K;if(z.activeSignatureHelp){const H=_.SignatureHelp.to(z.activeSignatureHelp),j=this._cache.get(z.activeSignatureHelp.id,0);j?(K=j,K.activeSignature=H.activeSignature,K.activeParameter=H.activeParameter):K=H}return{...z,activeSignatureHelp:K}}releaseSignatureHelp(z){this._cache.delete(z)}}class pe{constructor(z,K,H,j,Y){this._documents=z,this._commands=K,this._provider=H,this._logService=j,this._extension=Y,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,K,H){const j=this._documents.getDocument(z),Y=_.Range.to(K),ae=await this._provider.provideInlayHints(j,Y,H);if(!Array.isArray(ae)||ae.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(H.isCancellationRequested)return;const Se=this._cache.add(ae);this._disposables.set(Se,new h.DisposableStore);const Ue={hints:[],cacheId:Se};for(let Ve=0;Ve<ae.length;Ve++)this._isValidInlayHint(ae[Ve],Y)&&Ue.hints.push(this._convertInlayHint(ae[Ve],[Se,Ve]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),Ue}async resolveInlayHint(z,K){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...z);if(!H)return;const j=await this._provider.resolveInlayHint(H,K);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,K){return z.label.length===0||Array.isArray(z.label)&&z.label.every(H=>H.label.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(K&&!K.contains(z.position))}_convertInlayHint(z,K){const H=this._disposables.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:K,tooltip:z.tooltip&&_.MarkdownString.from(z.tooltip),position:_.Position.from(z.position),kind:_.InlayHintKind.from(z.kind??A.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter};return typeof z.label=="string"?j.label=z.label:j.label=z.label.map(Y=>{let ae={label:Y.label};return ae.collapsible=Y.collapsible,A.Location.isLocation(Y.action)?ae.action=_.location.from(Y.action):Y.action&&(ae.action=this._commands.toInternal(Y.action,H)),ae}),j}}class fe{constructor(z,K){this._documents=z,this._provider=K,this._cache=new g.Cache("DocumentLink")}async provideLinks(z,K){const H=this._documents.getDocument(z),j=await this._provider.provideDocumentLinks(H,K);if(!(!Array.isArray(j)||j.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(fe._validateLink).map(_.DocumentLink.from)};{const Y=this._cache.add(j),ae={links:[],id:Y};for(let Se=0;Se<j.length;Se++){if(!fe._validateLink(j[Se]))continue;const Ue=_.DocumentLink.from(j[Se]);Ue.cacheId=[Y,Se],ae.links.push(Ue)}return ae}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,K){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...z);if(!H)return;const j=await this._provider.resolveDocumentLink(H,K);if(!(!j||!fe._validateLink(j)))return _.DocumentLink.from(j)}releaseLinks(z){this._cache.delete(z)}}class oe{constructor(z,K){this._documents=z,this._provider=K}async provideColors(z,K){const H=this._documents.getDocument(z),j=await this._provider.provideDocumentColors(H,K);return Array.isArray(j)?j.map(ae=>({color:_.Color.from(ae.color),range:_.Range.from(ae.range)})):[]}async provideColorPresentations(z,K,H){const j=this._documents.getDocument(z),Y=_.Range.to(K.range),ae=_.Color.to(K.color),Se=await this._provider.provideColorPresentations(ae,{document:j,range:Y},H);if(!!Array.isArray(Se))return Se.map(_.ColorPresentation.from)}}class Ee{constructor(z,K){this._documents=z,this._provider=K}async provideFoldingRanges(z,K,H){const j=this._documents.getDocument(z),Y=await this._provider.provideFoldingRanges(j,K,H);if(!!Array.isArray(Y))return Y.map(_.FoldingRange.from)}}class Pe{constructor(z,K,H){this._documents=z,this._provider=K,this._logService=H}async provideSelectionRanges(z,K,H){const j=this._documents.getDocument(z),Y=K.map(_.Position.to),ae=await this._provider.provideSelectionRanges(j,Y,H);if(!(0,T.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Ue=0;Ue<Y.length;Ue++){const Ve=[];Se.push(Ve);let Qe=Y[Ue],nt=ae[Ue];for(;;){if(!nt.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(_.SelectionRange.from(nt)),!nt.parent)break;Qe=nt.range,nt=nt.parent}}return Se}}class Oe{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.prepareCallHierarchy(j,Y,H);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,ae)]}async provideCallsTo(z,K,H){const j=this._itemFromCache(z,K);if(!j)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(z,ae.from),fromRanges:ae.fromRanges.map(Se=>_.Range.from(Se))}))}async provideCallsFrom(z,K,H){const j=this._itemFromCache(z,K);if(!j)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(z,ae.to),fromRanges:ae.fromRanges.map(Se=>_.Range.from(Se))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const H=this._cache.get(z),j=_.CallHierarchyItem.from(K,z,H.size.toString(36));return H.set(j._itemId,K),j}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class je{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,H){const j=this._documents.getDocument(z),Y=_.Position.to(K),ae=await this._provider.prepareTypeHierarchy(j,Y,H);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,ae)]}async provideSupertypes(z,K,H){const j=this._itemFromCache(z,K);if(!j)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(z,ae))}async provideSubtypes(z,K,H){const j=this._itemFromCache(z,K);if(!j)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(z,ae))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const H=this._cache.get(z),j=_.TypeHierarchyItem.from(K,z,H.size.toString(36));return H.set(j._itemId,K),j}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class st{constructor(z,K){this.adapter=z,this.extension=K}}class et{constructor(z,K,H,j,Y,ae,Se){this._adapter=new Map,this._uriTransformer=K,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=Se}_transformDocumentSelector(z){return _.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return et._handlePool++}async _withAdapter(z,K,H,j,Y){const ae=this._adapter.get(z);if(!ae||!(ae.adapter instanceof K))return j;const Se=Date.now();this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${K.name}'`);const Ue=H(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Ve=>{(0,C.isCancellationError)(Ve)||(this._logService.error(`[${ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ve))}).finally(()=>{this._logService.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Se}ms`)}),i.CancellationToken.isCancellationToken(Y)?(0,u.raceCancellationError)(Ue,Y):Ue}_addNewAdapter(z,K){const H=this._nextHandle();return this._adapter.set(H,new st(z,K)),H}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,K,H,j){const Y=this._addNewAdapter(new S(this._documents,H),z),ae=j&&j.label||et._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(K),ae),this._createDisposable(Y)}$provideDocumentSymbols(z,K,H){return this._withAdapter(z,S,j=>j.provideDocumentSymbols(r.URI.revive(K),H),void 0)}registerCodeLensProvider(z,K,H){const j=this._nextHandle(),Y=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new st(new a(this._documents,this._commands.converter,H),z)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(K),Y);let ae=this._createDisposable(j);if(Y!==void 0){const Se=H.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(Y));ae=A.Disposable.from(ae,Se)}return ae}$provideCodeLenses(z,K,H){return this._withAdapter(z,a,j=>j.provideCodeLenses(r.URI.revive(K),H),void 0)}$resolveCodeLens(z,K,H){return this._withAdapter(z,a,j=>j.resolveCodeLens(K,H),void 0)}$releaseCodeLenses(z,K){this._withAdapter(z,a,H=>Promise.resolve(H.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(z,K,H){const j=this._addNewAdapter(new o(this._documents,H),z);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDefinition(z,K,H,j){return this._withAdapter(z,o,Y=>Y.provideDefinition(r.URI.revive(K),H,j),[])}registerDeclarationProvider(z,K,H){const j=this._addNewAdapter(new n(this._documents,H),z);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDeclaration(z,K,H,j){return this._withAdapter(z,n,Y=>Y.provideDeclaration(r.URI.revive(K),H,j),[])}registerImplementationProvider(z,K,H){const j=this._addNewAdapter(new d(this._documents,H),z);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideImplementation(z,K,H,j){return this._withAdapter(z,d,Y=>Y.provideImplementation(r.URI.revive(K),H,j),[])}registerTypeDefinitionProvider(z,K,H){const j=this._addNewAdapter(new p(this._documents,H),z);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideTypeDefinition(z,K,H,j){return this._withAdapter(z,p,Y=>Y.provideTypeDefinition(r.URI.revive(K),H,j),[])}registerHoverProvider(z,K,H,j){const Y=this._addNewAdapter(new c(this._documents,H),z);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideHover(z,K,H,j){return this._withAdapter(z,c,Y=>Y.provideHover(r.URI.revive(K),H,j),void 0)}registerEvaluatableExpressionProvider(z,K,H,j){const Y=this._addNewAdapter(new m(this._documents,H),z);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideEvaluatableExpression(z,K,H,j){return this._withAdapter(z,m,Y=>Y.provideEvaluatableExpression(r.URI.revive(K),H,j),void 0)}registerInlineValuesProvider(z,K,H,j){const Y=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new f(this._documents,H),z);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(K),Y);let Se=this._createDisposable(ae);if(Y!==void 0){const Ue=H.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Y));Se=A.Disposable.from(Se,Ue)}return Se}$provideInlineValues(z,K,H,j,Y){return this._withAdapter(z,f,ae=>ae.provideInlineValues(r.URI.revive(K),H,j,Y),void 0)}registerDocumentHighlightProvider(z,K,H){const j=this._addNewAdapter(new E(this._documents,H),z);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDocumentHighlights(z,K,H,j){return this._withAdapter(z,E,Y=>Y.provideDocumentHighlights(r.URI.revive(K),H,j),void 0)}registerLinkedEditingRangeProvider(z,K,H){const j=this._addNewAdapter(new v(this._documents,H),z);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideLinkedEditingRanges(z,K,H,j){return this._withAdapter(z,v,async Y=>{const ae=await Y.provideLinkedEditingRanges(r.URI.revive(K),H,j);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?et._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(z,K,H){const j=this._addNewAdapter(new k(this._documents,H),z);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideReferences(z,K,H,j,Y){return this._withAdapter(z,k,ae=>ae.provideReferences(r.URI.revive(K),H,j,Y),void 0)}registerCodeActionProvider(z,K,H,j){const Y=new h.DisposableStore,ae=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,H,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(K),{providedKinds:j?.providedCodeActionKinds?.map(Se=>Se.value),documentation:j?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,Y)}))},et._extLabel(z),Boolean(H.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(z,K,H,j,Y){return this._withAdapter(z,U,ae=>ae.provideCodeActions(r.URI.revive(K),H,j,Y),void 0)}$resolveCodeAction(z,K,H){return this._withAdapter(z,U,j=>j.resolveCodeAction(K,H),void 0)}$releaseCodeActions(z,K){this._withAdapter(z,U,H=>Promise.resolve(H.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(z,K,H){const j=this._addNewAdapter(new N(this._documents,H),z);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(j)}$provideDocumentFormattingEdits(z,K,H,j){return this._withAdapter(z,N,Y=>Y.provideDocumentFormattingEdits(r.URI.revive(K),H,j),void 0)}registerDocumentRangeFormattingEditProvider(z,K,H){const j=this._addNewAdapter(new y(this._documents,H),z);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(z,K,H,j,Y){return this._withAdapter(z,y,ae=>ae.provideDocumentRangeFormattingEdits(r.URI.revive(K),H,j,Y),void 0)}registerOnTypeFormattingEditProvider(z,K,H,j){const Y=this._addNewAdapter(new L(this._documents,H),z);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(K),j,z.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(z,K,H,j,Y,ae){return this._withAdapter(z,L,Se=>Se.provideOnTypeFormattingEdits(r.URI.revive(K),H,j,Y,ae),void 0)}registerWorkspaceSymbolProvider(z,K){const H=this._addNewAdapter(new W(K,this._logService),z);return this._proxy.$registerNavigateTypeSupport(H,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(z,K,H){return this._withAdapter(z,W,j=>j.provideWorkspaceSymbols(K,H),{symbols:[]})}$resolveWorkspaceSymbol(z,K,H){return this._withAdapter(z,W,j=>j.resolveWorkspaceSymbol(K,H),void 0)}$releaseWorkspaceSymbols(z,K){this._withAdapter(z,W,H=>H.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(z,K,H){const j=this._addNewAdapter(new x(this._documents,H,this._logService),z);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(K),x.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(z,K,H,j,Y){return this._withAdapter(z,x,ae=>ae.provideRenameEdits(r.URI.revive(K),H,j,Y),void 0)}$resolveRenameLocation(z,K,H,j){return this._withAdapter(z,x,Y=>Y.resolveRenameLocation(r.URI.revive(K),H,j),void 0)}registerDocumentSemanticTokensProvider(z,K,H,j){const Y=this._addNewAdapter(new q(this._documents,H),z),ae=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(K),j,ae);let Se=this._createDisposable(Y);if(ae){const Ue=H.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(ae));Se=A.Disposable.from(Se,Ue)}return Se}$provideDocumentSemanticTokens(z,K,H,j){return this._withAdapter(z,q,Y=>Y.provideDocumentSemanticTokens(r.URI.revive(K),H,j),null)}$releaseDocumentSemanticTokens(z,K){this._withAdapter(z,q,H=>H.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(z,K,H,j){const Y=this._addNewAdapter(new ie(this._documents,H),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(K),j),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(z,K,H,j){return this._withAdapter(z,ie,Y=>Y.provideDocumentRangeSemanticTokens(r.URI.revive(K),H,j),null)}registerCompletionItemProvider(z,K,H,j){const Y=this._addNewAdapter(new se(this._documents,this._commands.converter,H,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(K),j,se.supportsResolving(H),`${z.identifier.value}(${j.join("")})`),this._createDisposable(Y)}$provideCompletionItems(z,K,H,j,Y){return this._withAdapter(z,se,ae=>ae.provideCompletionItems(r.URI.revive(K),H,j,Y),void 0,Y)}$resolveCompletionItem(z,K,H){return this._withAdapter(z,se,j=>j.resolveCompletionItem(K,H),void 0,H)}$releaseCompletionItems(z,K){this._withAdapter(z,se,H=>H.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(z,K,H){const j=this._addNewAdapter(new X(this._documents,H,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideInlineCompletions(z,K,H,j,Y){return this._withAdapter(z,X,ae=>ae.provideInlineCompletions(r.URI.revive(K),H,j,Y),void 0)}$handleInlineCompletionDidShow(z,K,H){this._withAdapter(z,X,async j=>{j.handleDidShowCompletionItem(K,H)},void 0)}$freeInlineCompletionsList(z,K){this._withAdapter(z,X,async H=>{H.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(z,K,H,j){const Y=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ae=this._addNewAdapter(new be(this._documents,H),z);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(K),Y),this._createDisposable(ae)}$provideSignatureHelp(z,K,H,j,Y){return this._withAdapter(z,be,ae=>ae.provideSignatureHelp(r.URI.revive(K),H,j,Y),void 0)}$releaseSignatureHelp(z,K){this._withAdapter(z,be,H=>H.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(z,K,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new pe(this._documents,this._commands.converter,H,this._logService,z),z);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(K),typeof H.resolveInlayHint=="function",j);let ae=this._createDisposable(Y);if(j!==void 0){const Se=H.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(j));ae=A.Disposable.from(ae,Se)}return ae}$provideInlayHints(z,K,H,j){return this._withAdapter(z,pe,Y=>Y.provideInlayHints(r.URI.revive(K),H,j),void 0,j)}$resolveInlayHint(z,K,H){return this._withAdapter(z,pe,j=>j.resolveInlayHint(K,H),void 0,H)}$releaseInlayHints(z,K){this._withAdapter(z,pe,H=>H.releaseHints(K),void 0)}registerDocumentLinkProvider(z,K,H){const j=this._addNewAdapter(new fe(this._documents,H),z);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(K),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(z,K,H){return this._withAdapter(z,fe,j=>j.provideLinks(r.URI.revive(K),H),void 0)}$resolveDocumentLink(z,K,H){return this._withAdapter(z,fe,j=>j.resolveLink(K,H),void 0)}$releaseDocumentLinks(z,K){this._withAdapter(z,fe,H=>H.releaseLinks(K),void 0)}registerColorProvider(z,K,H){const j=this._addNewAdapter(new oe(this._documents,H),z);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDocumentColors(z,K,H){return this._withAdapter(z,oe,j=>j.provideColors(r.URI.revive(K),H),[])}$provideColorPresentations(z,K,H,j){return this._withAdapter(z,oe,Y=>Y.provideColorPresentations(r.URI.revive(K),H,j),void 0)}registerFoldingRangeProvider(z,K,H){const j=this._nextHandle(),Y=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new st(new Ee(this._documents,H),z)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(K),Y);let ae=this._createDisposable(j);if(Y!==void 0){const Se=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=A.Disposable.from(ae,Se)}return ae}$provideFoldingRanges(z,K,H,j){return this._withAdapter(z,Ee,Y=>Y.provideFoldingRanges(r.URI.revive(K),H,j),void 0)}registerSelectionRangeProvider(z,K,H){const j=this._addNewAdapter(new Pe(this._documents,H,this._logService),z);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideSelectionRanges(z,K,H,j){return this._withAdapter(z,Pe,Y=>Y.provideSelectionRanges(r.URI.revive(K),H,j),[])}registerCallHierarchyProvider(z,K,H){const j=this._addNewAdapter(new Oe(this._documents,H),z);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$prepareCallHierarchy(z,K,H,j){return this._withAdapter(z,Oe,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),H,j)),void 0)}$provideCallHierarchyIncomingCalls(z,K,H,j){return this._withAdapter(z,Oe,Y=>Y.provideCallsTo(K,H,j),void 0)}$provideCallHierarchyOutgoingCalls(z,K,H,j){return this._withAdapter(z,Oe,Y=>Y.provideCallsFrom(K,H,j),void 0)}$releaseCallHierarchy(z,K){this._withAdapter(z,Oe,H=>Promise.resolve(H.releaseSession(K)),void 0)}registerTypeHierarchyProvider(z,K,H){const j=this._addNewAdapter(new je(this._documents,H),z);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$prepareTypeHierarchy(z,K,H,j){return this._withAdapter(z,je,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),H,j)),void 0)}$provideTypeHierarchySupertypes(z,K,H,j){return this._withAdapter(z,je,Y=>Y.provideSupertypes(K,H,j),void 0)}$provideTypeHierarchySubtypes(z,K,H,j){return this._withAdapter(z,je,Y=>Y.provideSubtypes(K,H,j),void 0)}$releaseTypeHierarchy(z,K){this._withAdapter(z,je,H=>Promise.resolve(H.releaseSession(K)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,I.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:et._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:et._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?et._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?et._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:et._serializeRegExp(z.beforeText),afterText:z.afterText?et._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?et._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(et._serializeOnEnterRule)}setLanguageConfiguration(z,K,H){let{wordPattern:j}=H;if(j&&(0,I.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(K,j):this._documents.setWordDefinitionFor(K,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Y=this._nextHandle(),ae={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?et._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?et._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?et._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,K,ae),this._createDisposable(Y)}$setWordDefinitions(z){for(const K of z)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=et,et._handlePool=0}),define(ye[189],_e([0,1,5,8,7,34,10,6]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,w,i,h){this._documents=w,this._commands=i,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,w){await this._proxy.$changeLanguage(R,w);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,w){const i=R.version,h=t.Position.from(w),l=await this._proxy.$tokensAtPosition(R.uri,h),s={type:_.StandardTokenType.Other,range:R.getWordRangeAtPosition(w)??new _.Range(w.line,w.character,w.line,w.character)};if(!l)return s;const g={range:t.Range.to(l.range),type:t.TokenType.to(l.type)};return!g.range.contains(w)||i!==R.version?s:g}createLanguageStatusItem(R,w,i){const h=this._handlePool++,l=this._proxy,s=this._ids,g=`${R.identifier.value}/${w}`;if(s.has(g))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);s.add(g);const M={selector:i,id:w,name:R.displayName??R.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let C,b=new I.DisposableStore;const u=()=>{C?.dispose(),C=(0,P.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(h,{id:g,name:M.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(M.selector,this._uriTransformer),label:M.text,detail:M.detail??"",severity:M.severity===_.LanguageStatusSeverity.Error?A.default.Error:M.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:M.command&&this._commands.toInternal(M.command,b),accessibilityInfo:M.accessibilityInformation,busy:M.busy})},0)},S={dispose(){b.dispose(),C?.dispose(),l.$removeLanguageStatus(h),s.delete(g)},get id(){return M.id},get name(){return M.name},set name(a){M.name=a,u()},get selector(){return M.selector},set selector(a){M.selector=a,u()},get text(){return M.text},set text(a){M.text=a,u()},get detail(){return M.detail},set detail(a){M.detail=a,u()},get severity(){return M.severity},set severity(a){M.severity=a,u()},get accessibilityInformation(){return M.accessibilityInformation},set accessibilityInformation(a){M.accessibilityInformation=a,u()},get command(){return M.command},set command(a){M.command=a,u()},get busy(){return M.busy},set busy(a){M.busy=a,u()}};return u(),S}}e.ExtHostLanguages=D}),define(ye[190],_e([0,1,12,5,28,14,4]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends r.AbstractLoggerService{constructor(R,w){const i=new P.Emitter;super(w.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,w,i){return new D(this._proxy,R,w,i)}};I=xe([$e(0,A.IExtHostRpcService),$e(1,_.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class D extends r.AbstractMessageLogger{constructor(R,w,i,h){super(h?.always);this.proxy=R,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(w,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,w){const i=[[R,w]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[191],_e([0,1,5,12,26]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let P=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(r.MainContext.MainThreadMessageService)}showMessage(D,T,R,w,i){const h={source:{identifier:D.identifier,label:D.displayName||D.name}};let l;typeof w=="string"||A(w)?l=[w,...i]:(h.modal=w?.modal,h.useCustom=w?.useCustom,h.detail=w?.detail,l=i),h.useCustom&&(0,_.checkProposedApiEnabled)(D,"resolvers");const s=[];for(let g=0;g<l.length;g++){const M=l[g];if(typeof M=="string")s.push({title:M,handle:g,isCloseAffordance:!1});else if(typeof M=="object"){let{title:C,isCloseAffordance:b}=M;s.push({title:C,isCloseAffordance:!!b,handle:g})}else this._logService.warn("Invalid message item:",M)}return this._proxy.$showMessage(T,R,h,s).then(g=>{if(typeof g=="number")return l[g]})}};P=xe([$e(1,t.ILogService)],P),e.ExtHostMessageService=P}),define(ye[192],_e([0,1,21,4,92,6,22,9,13,2,62,5,8,7,38,165,89]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class M{constructor(b,u,S,a,F){this._textDocumentsAndEditors=S,this._textDocuments=a,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const n=o.notebookEditor?.notebookUri,d=o.cell.handle,c=this._documents.get(n)?.getCell(d);if(c)return c.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const u=this._editors.get(b);if(!u)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(b){for(const[u,S]of this._editors)if(S.apiEditor===b)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,u){const S=this._documents.get(b);if(!S&&!u)throw new Error(`NO notebook document for '${b}'`);return S}_getProviderData(b){const u=this._notebookContentProviders.get(b);if(!u)throw new Error(`NO provider for '${b}'`);return u}registerNotebookContentProvider(b,u,S,a,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:b,provider:S});let o;return S.onDidChangeNotebookContentOptions&&(o=S.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(u,n)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},u,i.NotebookDocumentContentOptions.from(a),M._convertNotebookRegistrationData(b,F)),new h.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(b,u){if(!u)return;const S=u.filenamePattern.map(a=>i.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(u.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:u.displayName,filenamePattern:S,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,u,S){const a=M._notebookStatusBarItemProviderHandlePool++,F=typeof S.onDidChangeCellStatusBarItems=="function"?M._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,F,u);let o;return F!==void 0&&(o=S.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(F))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,F),o&&o.dispose()})}async createNotebookDocument(b){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&i.NotebookData.from(b.content)});return T.URI.revive(u)}async openNotebookDocument(b){const u=this._documents.get(b);if(u)return u.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(b),a=this._documents.get(T.URI.revive(S));return(0,D.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(b,u){T.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let S;typeof u=="object"?S={position:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(i.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:S={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,S),F=a&&this._editors.get(a)?.apiEditor;if(F)return F;throw a?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,u,S,a){const F=this._notebookStatusBarItemProviders.get(b),o=T.URI.revive(u),n=this._documents.get(o);if(!n||!F)return;const d=n.getCellFromIndex(S);if(!d)return;const p=await F.provideCellStatusBarItems(d.apiCell,a);if(!p)return;const c=new A.DisposableStore,m=this._statusBarCache.add([c]),E=(Array.isArray(p)?p:[p]).map(v=>i.NotebookStatusBarItem.from(v,this._commandsConverter,c));return{cacheId:m,items:E}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,u,S,a,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,S),this._notebookProxy.$registerNotebookSerializer(o,{id:b.identifier,location:b.extensionLocation},u,i.NotebookDocumentContentOptions.from(a),M._convertNotebookRegistrationData(b,F)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(b,u,S){const a=this._notebookSerializer.get(b);if(!a)throw new Error("NO serializer found");const F=await a.deserializeNotebook(u.buffer,S);return new l.SerializableObjectWithBuffers(i.NotebookData.from(F))}async $notebookToData(b,u,S){const a=this._notebookSerializer.get(b);if(!a)throw new Error("NO serializer found");const F=await a.serializeNotebook(i.NotebookData.to(u.value),S);return r.VSBuffer.wrap(F)}async $openNotebook(b,u,S,a,F){const{provider:o}=this._getProviderData(b),n=await o.openNotebook(T.URI.revive(u),{backupId:S,untitledDocumentData:a?.buffer},F);return new l.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(b,u,S){const a=this.getNotebookDocument(T.URI.revive(u)),{provider:F}=this._getProviderData(b);return await F.saveNotebook(a.apiNotebook,S),!0}async $saveNotebookAs(b,u,S,a){const F=this.getNotebookDocument(T.URI.revive(u)),{provider:o}=this._getProviderData(b);return await o.saveNotebookAs(T.URI.revive(S),F.apiNotebook,a),!0}async $backupNotebook(b,u,S){const a=this.getNotebookDocument(T.URI.revive(u)),F=this._getProviderData(b),o=this._extensionStoragePaths.workspaceValue(F.extension)??this._extensionStoragePaths.globalValue(F.extension),n=String((0,_.hash)([a.uri.toString(),this._backupIdPool++])),d=T.URI.joinPath(o,n),p=await F.provider.backupNotebook(a.apiNotebook,{destination:d},S);return a.updateBackup(p),p.id}_createExtHostEditor(b,u,S){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const a=new g.ExtHostNotebookEditor(u,this._notebookEditorsProxy,b,S.visibleRanges.map(i.NotebookRange.to),S.selections.map(i.NotebookRange.to),typeof S.viewColumn=="number"?i.ViewColumn.to(S.viewColumn):void 0);this._editors.set(u,a)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const S of b.value.removedDocuments){const a=T.URI.revive(S),F=this._documents.get(a);F&&(F.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:F.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(F.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===a.toString()&&this._editors.delete(o.id)}if(b.value.addedDocuments){const S=[];for(const a of b.value.addedDocuments){const F=T.URI.revive(a.uri);if(this._documents.has(F))throw new Error(`adding EXISTING notebook ${F} `);const o=this,n=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(d){o._onDidChangeNotebookCells.fire(d)},emitCellOutputsChange(d){o._onDidChangeCellOutputs.fire(d)},emitCellMetadataChange(d){o._onDidChangeCellMetadata.fire(d)}},F,a);S.push(...a.cells.map(d=>s.ExtHostCell.asModelAddData(n.apiNotebook,d))),this._documents.get(F)?.dispose(),this._documents.set(F,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(b.value.addedEditors)for(const S of b.value.addedEditors){if(this._editors.has(S.id))return;const a=T.URI.revive(S.documentUri),F=this._documents.get(a);F&&this._createExtHostEditor(F,S.id,S)}const u=[];if(b.value.removedEditors)for(const S of b.value.removedEditors){const a=this._editors.get(S);a&&(this._editors.delete(S),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),u.push(a))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const S=new Set;this._visibleNotebookEditors.forEach(a=>S.add(a.id));for(const a of this._editors.values()){const F=S.has(a.id);a._acceptVisibility(F)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=M,M._notebookStatusBarItemProviderHandlePool=0}),define(ye[193],_e([0,1,4,54,12,5,14,8]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(w,i){const h=D._Keys.nextId();w.$registerNotebookEditorDecorationType(h,I.NotebookDecorationRenderOptions.from(i)),this.value={key:h,dispose(){w.$removeNotebookEditorDecorationType(h)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(w,i,h){this._logService=w,this._extHostRpc=i,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(w){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),w).value}$acceptEditorPropertiesChanged(w,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,i);const h=this._notebooksAndEditors.getEditorById(w);i.visibleRanges&&h._acceptVisibleRanges(i.visibleRanges.ranges.map(I.NotebookRange.to)),i.selections&&h._acceptSelections(i.selections.selections.map(I.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const i in w)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(I.ViewColumn.to(w[i]))}};T=xe([$e(0,_.ILogService),$e(1,P.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(ye[194],_e([0,1,16,10,20,4,6,22,2,25,12,5,39,8,7,65,158,26,38]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(o,n,d,p,c){this._initData=n,this._extHostNotebook=d,this._commands=p,this._logService=c,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(w.MainContext.MainThreadNotebookKernels);const m=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const E=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:E}}else if(f&&"notebookEditor"in f){const E=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return f})],i.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(o,n,d,p,c,m){for(const X of this._kernelData.values())if(X.controller.id===n&&T.ExtensionIdentifier.equals(o.identifier,X.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const f=this._handlePool++,E=this;this._logService.trace(`NotebookController[${f}], CREATED by ${o.identifier.value}, ${n}`);const v=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${o.identifier}'`);let k=!1;const U=new P.DisposableStore,N=new A.Emitter,y=new A.Emitter,L={id:`${o.identifier.value}/${n}`,notebookType:d,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:p||o.identifier.value,preloads:m?m.map(h.NotebookRendererScript.from):[]};let W=c??v,x;this._proxy.$addKernel(f,L).catch(X=>{console.log(X),k=!0});let $=0;const q=()=>{if(k)return;const X=++$;Promise.resolve().then(()=>{X===$&&this._proxy.$updateKernel(f,L)})},ie=new I.ResourceMap,se={get id(){return n},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return L.label},set label(X){L.label=X??o.displayName??o.name,q()},get detail(){return L.detail??""},set detail(X){L.detail=X,q()},get description(){return L.description??""},set description(X){L.description=X,q()},get kind(){return(0,M.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind??""},set kind(X){(0,M.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind=X,q()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(X){L.supportedLanguages=X,q()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(X){L.supportsExecutionOrder=X,q()},get rendererScripts(){return L.preloads?L.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(X){W=X??v},get interruptHandler(){return x},set interruptHandler(X){x=X,L.supportsInterrupt=Boolean(X),q()},createNotebookCellExecution(X){if(k)throw new Error("notebook controller is DISPOSED");if(!ie.has(X.notebook.uri))throw E._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return E._createNotebookCellExecution(X)},dispose:()=>{k||(this._logService.trace(`NotebookController[${f}], DISPOSED`),k=!0,this._kernelData.delete(f),U.dispose(),N.dispose(),y.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(X,ge){E._proxy.$updateNotebookPriority(f,X.uri,ge)},onDidReceiveMessage:y.event,postMessage(X,ge){return(0,M.checkProposedApiEnabled)(o,"notebookMessaging"),E._proxy.$postMessage(f,ge&&E._extHostNotebook.getIdByEditor(ge),X)},asWebviewUri(X){return(0,M.checkProposedApiEnabled)(o,"notebookMessaging"),(0,s.asWebviewUri)(X,E._initData.remote)}};return this._kernelData.set(f,{extensionId:o.identifier,controller:se,onDidReceiveMessage:y,onDidChangeSelection:N,associatedNotebooks:ie}),se}$acceptNotebookAssociation(o,n,d){const p=this._kernelData.get(o);if(p){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));d?p.associatedNotebooks.set(c.uri,!0):p.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,c.uri.toString(),d),p.onDidChangeSelection.fire({selected:d,notebook:c.apiNotebook})}}async $executeCells(o,n,d){const p=this._kernelData.get(o);if(!p)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)),m=[];for(const f of d){const E=c.getCell(f);E&&m.push(E.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,c.uri.toString(),m.length),await p.controller.executeHandler.call(p.controller,m,c.apiNotebook,p.controller)}catch(f){this._logService.error(`NotebookController[${o}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(o,n,d){const p=this._kernelData.get(o);if(!p)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,c.apiNotebook);else for(const m of d){const f=c.getCell(m);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,n,d){const p=this._kernelData.get(o);if(!p)return;const c=this._extHostNotebook.getEditorById(n);p.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:d}))}$cellExecutionChanged(o,n,d){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(o)).getCell(n);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:d??l.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!d)throw new Error("invalid cell");if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const p=new S(d.notebook,d,this._proxy);this._activeExecutions.set(d.uri,p);const c=p.onDidChangeState(()=>{p.state===u.Resolved&&(p.dispose(),c.dispose(),this._activeExecutions.delete(d.uri))});return p.asApiObject()}};b=xe([$e(4,R.ILogService)],b),e.ExtHostNotebookKernels=b;var u;(function(F){F[F.Init=0]="Init",F[F.Started=1]="Started",F[F.Resolved=2]="Resolved"})(u||(u={}));class S extends P.Disposable{constructor(o,n,d){super();this._document=o,this._cell=n,this._proxy=d,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new a(10,p=>this.update(p)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const n=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new C.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let n=this._cell;if(o&&(n=this._document.getCellFromApiCell(o)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(o){return o.map(n=>{const d=l.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return d===n.items?h.NotebookCellOutput.from(n):h.NotebookCellOutput.from({items:d,id:n.id,metadata:n.metadata})})}async updateOutputs(o,n,d){const p=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,r.asArray)(o));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:p,append:d,outputs:c})}async updateOutputItems(o,n,d){return o=l.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(o),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:o.map(h.NotebookCellOutputItem.from),outputId:n.id,append:d})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(d){o._executionOrder=d,o.update([{editType:g.CellExecutionUpdateType.ExecutionState,uri:o._document.uri,cellHandle:o._cell.handle,executionOrder:o._executionOrder}])},start(d){if(o._state===u.Resolved||o._state===u.Started)throw new Error("Cannot call start again");o._state=u.Started,o._onDidChangeState.fire(),o.update({editType:g.CellExecutionUpdateType.ExecutionState,uri:o._document.uri,cellHandle:o._cell.handle,runStartTime:d})},end(d,p){if(o._state===u.Resolved)throw new Error("Cannot call resolve twice");o._state=u.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._document.uri,o._cell.handle,new C.SerializableObjectWithBuffers({uri:o._document.uri,cellHandle:o._cell.handle,runEndTime:p,lastRunSuccess:d}))},clearOutput(d){return o.verifyStateForOutput(),o.updateOutputs([],d,!1)},appendOutput(d,p){return o.verifyStateForOutput(),o.updateOutputs(d,p,!0)},replaceOutput(d,p){return o.verifyStateForOutput(),o.updateOutputs(d,p,!1)},appendOutputItems(d,p){return o.verifyStateForOutput(),o.updateOutputItems(d,p,!0)},replaceOutputItems(d,p){return o.verifyStateForOutput(),o.updateOutputItems(d,p,!1)}})}}class a{constructor(o,n){this.delay=o,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>o.complete())}}}),define(ye[195],_e([0,1,4,5,89,26]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(D,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,T,R){const w=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(T)?.fire({editor:w.apiEditor,message:R})}createRendererMessaging(D,T){if(!D.contributes?.notebookRenderer?.some(h=>h.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const R=(0,A.isProposedApiEnabled)(D,"notebookEditor"),w=new WeakMap;return{onDidReceiveMessage:(h,l,s)=>{const g=R?h:M=>{const C={};w.set(C,M.editor),h({editor:C,message:M.message})};return this.getOrCreateEmitterFor(T).event(g,l,s)},postMessage:(h,l)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(h)&&([h,l]=[l,h]);const s=R?l:w.get(l),g=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(g?.id,T,h)}}}getOrCreateEmitterFor(D){let T=this._rendererMessageEmitters.get(D);return T||(T=new r.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,T),T)}}e.ExtHostNotebookRenderers=P}),define(ye[93],_e([0,1,5,6,3,14,12,159,50,28,30,109,21]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class h extends t.Disposable{constructor(g,M,C,b){super();this.id=g,this.name=M,this.logger=C,this.proxy=b,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,g)}replace(g){const M=this.offset;this.write(g),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,M),this.visible&&this.logger.flush()}show(g,M){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:M))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=i.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=h;let l=class{constructor(g,M,C,b,u){this.extHostFileSystem=C,this.extHostFileSystemInfo=b,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(M.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[M,C]of this.channels)C.visible=M===this.visibleChannelId}createOutputChannel(g,M){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const C=this.doCreateOutputChannel(g,M);return C.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,C)}async doCreateOutputChannel(g,M){const C=await this.createOutputDirectory(),b=this.extHostFileSystemInfo.extUri.joinPath(C,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(b,{always:!0,donotRotate:!0,donotUseFormatters:!0}),S=await this.proxy.$register(g,!1,b,M.identifier.value);return new h(S,g,u,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,M){let C=!1;const b=()=>{if(C)throw new Error("Channel has been closed")};return{get name(){return g},append(u){b(),M.then(S=>S.append(u))},appendLine(u){b(),M.then(S=>S.appendLine(u))},clear(){b(),M.then(u=>u.clear())},replace(u){b(),M.then(S=>S.replace(u))},show(u,S){b(),M.then(a=>a.show(u,S))},hide(){b(),M.then(u=>u.hide())},dispose(){C=!0,M.then(u=>u.dispose())}}}};l=xe([$e(0,A.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,P.ILoggerService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(ye[196],_e([0,1,10,20,4,6,5,2,7,15,16,34,61,26]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(s,g,M){const C=s.getProxy(P.MainContext.MainThreadQuickOpen);class b{constructor(c,m){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=m}showQuickPick(c,m,f=t.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(c),v=++this._instances,k=C.$show(v,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},f),U={},N=k.then(()=>U);return Promise.race([N,E]).then(y=>{if(y!==U)return E.then(L=>{const W=[];for(let x=0;x<L.length;x++){const $=L[x];typeof $=="string"?W.push({label:$,handle:x}):$.kind===D.QuickPickItemKind.Separator?W.push({type:"separator",label:$.label}):W.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:x})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{m.onDidSelectItem(L[x])}),C.$setItems(v,W),k.then(x=>{if(typeof x=="number")return L[x];if(Array.isArray(x))return x.map($=>L[$])})})}).then(void 0,y=>{if(!(0,T.isCancellationError)(y))return C.$setError(v,y),Promise.reject(y)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,m=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,C.$input(c,typeof this._validateInput=="function",m).then(void 0,f=>{if(!(0,T.isCancellationError)(f))return Promise.reject(f)})}$validateInput(c){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,m=t.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!f)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(v=>v.uri.toString()===f.uri.toString())}createQuickPick(c){const m=new n(c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(c){const m=new d(c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(c,m){const f=this._sessions.get(c);f&&f._fireDidChangeValue(m)}$onDidAccept(c){const m=this._sessions.get(c);m&&m._fireDidAccept()}$onDidChangeActive(c,m){const f=this._sessions.get(c);f instanceof n&&f._fireDidChangeActive(m)}$onDidChangeSelection(c,m){const f=this._sessions.get(c);f instanceof n&&f._fireDidChangeSelection(m)}$onDidTriggerButton(c,m){const f=this._sessions.get(c);f&&f._fireDidTriggerButton(m)}$onDidTriggerItemButton(c,m,f){const E=this._sessions.get(c);E instanceof n&&E._fireDidTriggerItemButton(m,f)}$onDidHide(c){const m=this._sessions.get(c);m&&m._fireDidHide()}}class u{constructor(c,m){this._extensionId=c,this._onDidDispose=m,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((m,f)=>{const E=m===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(E,m)}),this.update({buttons:c.map((m,f)=>({...o(m),tooltip:m.tooltip,handle:m===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const m=this._handlesToButtons.get(c);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(c){if(!this._disposed){for(const m of Object.keys(c)){const f=c[m];this._pendingUpdate[m]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function S(p){if(p instanceof D.ThemeIcon)return{id:p.id};const c=F(p),m=a(p);return{dark:typeof c=="string"?I.URI.file(c):c,light:typeof m=="string"?I.URI.file(m):m}}function a(p){return typeof p=="object"&&"light"in p?p.light:p}function F(p){return typeof p=="object"&&"dark"in p?p.dark:p}function o(p){const c=S(p.iconPath);let m,f;return"id"in c?f=i.ThemeIcon.asClassName(c):m=c,{iconPath:m,iconClass:f}}class n extends u{constructor(c,m){super(c.identifier,m);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(f=>f.kind!==void 0)&&(0,h.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((f,E)=>{this._handlesToItems.set(E,f),this._itemsToHandles.set(f,E)});const m=[];for(let f=0;f<c.length;f++){const E=c[f];E.kind===D.QuickPickItemKind.Separator?m.push({type:"separator",label:E.label}):m.push({handle:f,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((v,k)=>({...o(v),tooltip:v.tooltip,handle:k}))})}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(c){const m=(0,R.coalesce)(c.map(f=>this._handlesToItems.get(f)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(c){const m=(0,R.coalesce)(c.map(f=>this._handlesToItems.get(f)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(c,m){const f=this._handlesToItems.get(c);if(!f||!f.buttons||!f.buttons.length)return;const E=f.buttons[m];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:f})}}class d extends u{constructor(c,m){super(c,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?w.default.Error:w.default.Ignore})}}return new b(g,M)}e.createExtHostQuickOpen=l});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[197],_e([0,1,2,4,53,6,10,5,16,104,12,25,61,8,26]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l){"use strict";var s,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function M(m){if(m)return typeof m.iconPath=="string"?r.URI.file(m.iconPath):r.URI.isUri(m.iconPath)||i.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function C(m,f){if(!m.iconPath&&!f.iconPath)return 0;if(m.iconPath){if(!f.iconPath)return 1}else return-1;const E=typeof m.iconPath=="string"?m.iconPath:r.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,v=typeof f.iconPath=="string"?f.iconPath:r.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,T.comparePaths)(E,v)}function b(m,f){let E=0;if(m.strikeThrough!==f.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==f.faded)return m.faded?1:-1;if(m.tooltip!==f.tooltip)return(m.tooltip||"").localeCompare(f.tooltip||"");if(E=C(m,f),E!==0)return E;if(m.light&&f.light)E=C(m.light,f.light);else{if(m.light)return 1;if(f.light)return-1}if(E!==0)return E;if(m.dark&&f.dark)E=C(m.dark,f.dark);else{if(m.dark)return 1;if(f.dark)return-1}return E}function u(m,f){if(m.command!==f.command)return m.command<f.command?-1:1;if(m.title!==f.title)return m.title<f.title?-1:1;if(m.tooltip!==f.tooltip){if(m.tooltip!==void 0&&f.tooltip!==void 0)return m.tooltip<f.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(m.arguments===f.arguments)return 0;if(m.arguments)if(f.arguments){if(m.arguments.length!==f.arguments.length)return m.arguments.length-f.arguments.length}else return 1;else return-1;for(let E=0;E<m.arguments.length;E++){const v=m.arguments[E],k=f.arguments[E];if(v!==k)return v<k?-1:1}return 0}function S(m,f){let E=(0,T.comparePaths)(m.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(E!==0)return E;if(m.command&&f.command)E=u(m.command,f.command);else{if(m.command)return 1;if(f.command)return-1}if(E!==0)return E;if(m.decorations&&f.decorations)E=b(m.decorations,f.decorations);else{if(m.decorations)return 1;if(f.decorations)return-1}return E}function a(m,f){for(let E=0;E<m.length;E++)if(m[E]!==f[E])return!1;return!0}function F(m,f){return m.command===f.command&&m.title===f.title&&m.tooltip===f.tooltip&&(m.arguments&&f.arguments?a(m.arguments,f.arguments):m.arguments===f.arguments)}function o(m,f){return(0,D.equals)(m,f,F)}class n{constructor(f,E,v){this._extension=f,this._sourceControlHandle=v,s.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Xe(this,s,E,"f")}get value(){return this._value}set value(f){f=f??"",Ie(this,s,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Ie(this,s,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Ie(this,s,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Ie(this,s,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,E){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,s,"f").$showValidationMessage(this._sourceControlHandle,f,E)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=n,s=new WeakMap;class d{constructor(f,E,v,k,U){this._proxy=f,this._commands=E,this._sourceControlHandle=v,this._id=k,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=d._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,E){const v=this._resourceStatesCommandsMap.get(f);return v?(0,P.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(S),v=(0,D.sortedDiff)(this._resourceSnapshot,f,S).map(N=>{const y=N.toInsert.map(L=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,L);const x=L.resourceUri;let $;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Ee=new A.DisposableStore;$=this._commands.converter.toInternal(L.command,Ee),this._resourceStatesDisposablesMap.set(W,Ee)}else this._resourceStatesCommandsMap.set(W,L.command);const q=M(L.decorations),ie=L.decorations&&M(L.decorations.light)||q,se=L.decorations&&M(L.decorations.dark)||q,X=[ie,se],ge=L.decorations&&L.decorations.tooltip||"",be=L.decorations&&!!L.decorations.strikeThrough,pe=L.decorations&&!!L.decorations.faded,fe=L.contextValue||"";return{rawResource:[W,x,X,ge,be,pe,fe,$],handle:W}});return{start:N.start,deleteCount:N.deleteCount,toInsert:y}}),k=v.map(({start:N,deleteCount:y,toInsert:L})=>[N,y,L.map(W=>W.rawResource)]),U=v.reverse();for(const{start:N,deleteCount:y,toInsert:L}of U){const W=L.map($=>$.handle),x=this._handlesSnapshot.splice(N,y,...W);for(const $ of x)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=f,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}d._handlePool=0;class p{constructor(f,E,v,k,U,N){this._extension=f,this._commands=v,this._id=k,this._label=U,this._rootUri=N,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=p._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,g,E,"f"),this._inputBox=new n(f,Ie(this,g,"f"),this.handle),Ie(this,g,"f").$registerSourceControl(this.handle,k,U,N)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Ie(this,g,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Ie(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Ie(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=f;const E=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Ie(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=f;const E=f!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,g,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&o(this._statusBarCommands,f))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=f;const E=(f||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));Ie(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(f,E){const v=new d(Ie(this,g,"f"),this._commands,this.handle,f,E),k=t.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const f=[],E=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const U=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});t.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),U.dispose(),this._groups.delete(v.handle),Ie(this,g,"f").$unregisterGroup(this.handle,v.handle)}),f.push([v.handle,v.id,v.label,v.features]);const N=v._takeResourceStateSnapshot();N.length>0&&E.push([v.handle,N]),this._groups.set(v.handle,v)}Ie(this,g,"f").$registerGroups(this.handle,f,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(E=>{const v=E._takeResourceStateSnapshot();v.length!==0&&f.push([E.handle,v])}),f.length>0&&Ie(this,g,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Ie(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,p._handlePool=0,xe([(0,_.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),xe([(0,_.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let c=class Vi{constructor(f,E,v){this._commands=E,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const U=this._sourceControls.get(k.sourceControlHandle);if(!U)return k;const N=U.getResourceGroup(k.groupHandle);return N?N.getResourceState(k.handle):k}else if(k&&k.$mid===4){const U=this._sourceControls.get(k.sourceControlHandle);return U?U.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const U=this._sourceControls.get(k.handle);return U||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,E,v,k){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,E,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const U=Vi._handlePool++,N=new p(f,this._proxy,this._commands,E,v,k);this._sourceControls.set(U,N);const y=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(f.identifier))||[];return y.push(N),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(f.identifier),y),N}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const E=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(f.identifier)),v=E&&E[E.length-1];return v&&v.inputBox}$provideOriginalResource(f,E,v){const k=r.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,k.toString());const U=this._sourceControls.get(f);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(k,v)).then(N=>N||null)}$onInputBoxValueChange(f,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const v=this._sourceControls.get(f);return v&&v.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(f,E,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,E,v);const U=this._sourceControls.get(f);if(!U)return Promise.resolve(void 0);const N=U.getResourceGroup(E);return N?N.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(f,E,v){this.logService.trace("ExtHostSCM#$validateInput",f);const k=this._sourceControls.get(f);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>k.inputBox.validateInput(E,v)).then(U=>{if(!U)return Promise.resolve(void 0);const N=h.MarkdownString.fromStrict(U.message);return N?Promise.resolve([N,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};c._handlePool=0,c=xe([$e(2,R.ILogService)],c),e.ExtHostSCM=c});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[198],_e([0,1,7,5,121,6,8,13]),function(ee,e,r,t,_,A,P,I){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(l,s,g,M,C=r.StatusBarAlignment.Left,b){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Xe(this,D,l,"f"),Xe(this,T,s,"f"),this._entryId=R.ID_GEN++,this._extension=g,this._id=M,this._alignment=C,this._priority=this.validatePriority(b)}validatePriority(l){if(!!(0,I.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!R.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let s;this._name?s=this._name:s=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const M=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,D,"f").$setEntry(this._entryId,l,s,this._text,M,this._command?.internal,g,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,D=new WeakMap,T=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const s={message:l};return this._messages.unshift(s),this._update(),new r.Disposable(()=>{const g=this._messages.indexOf(s);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(l,s){this._proxy=l.getProxy(t.MainContext.MainThreadStatusBar),this._commands=s,this._statusMessage=new w(this)}createStatusBarEntry(l,s,g,M){return new R(this._proxy,this._commands,l,s,g,M)}setStatusBarMessage(l,s){const g=this._statusMessage.setMessage(l);let M;return typeof s=="number"?M=setTimeout(()=>g.dispose(),s):typeof s!="undefined"&&s.then(()=>g.dispose(),()=>g.dispose()),new r.Disposable(()=>{g.dispose(),clearTimeout(M)})}}e.ExtHostStatusBar=i}),define(ye[70],_e([0,1,5,4,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}initializeExtensionStorage(I,D,T){return this._proxy.$initializeExtensionStorage(I,D).then(R=>R||T)}setValue(I,D,T){return this._proxy.$setValue(I,D,T)}$acceptValue(I,D,T){this._onDidChangeStorage.fire({shared:I,key:D,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ye[71],_e([0,1,3,28,12,50,2]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let I=class{constructor(T,R,w){this._logService=R,this._extHostFileSystem=w,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(T){return P.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,R=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(T){if(this._value)return P.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return P.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=xe([$e(0,t.IExtHostInitDataService),$e(1,_.ILogService),$e(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ye[40],_e([0,1,4,5,3,2,14,6,7,122,15,161,20,36,144,61,13,10]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class C{constructor(p,c,m,f){this._proxy=p,this._id=c,this._creationOptions=m,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(v,k=!0){E._checkDisposed(),E._proxy.$sendText(E._id,v,k)},show(v){E._checkDisposed(),E._proxy.$show(E._id,v)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(p,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:p.name,shellPath:(0,g.withNullAsUndefined)(p.shellPath),shellArgs:(0,g.withNullAsUndefined)(p.shellArgs),cwd:(0,g.withNullAsUndefined)(p.cwd),env:(0,g.withNullAsUndefined)(p.env),icon:(0,g.withNullAsUndefined)(o(p.iconPath)),color:s.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:(0,g.withNullAsUndefined)(p.message),strictEnv:(0,g.withNullAsUndefined)(p.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(p.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(p.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,g.withNullAsUndefined)(p.disablePersistence)})}async createExtensionTerminal(p,c,m,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:s.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(p,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(p,c){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in p?{viewColumn:p.viewColumn,preserveFocus:p.preserveFocus}:void 0:p}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(p){this._name=p}setExitCode(p){this._exitStatus=Object.freeze({code:p})}setDimensions(p,c){return p===this._cols&&c===this._rows||p===0||c===0?!1:(this._cols=p,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(p){this._pidPromiseComplete?(this._pidPromiseComplete(p),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==p&&(this._pidPromise=Promise.resolve(p))})}}e.ExtHostTerminal=C;class b{constructor(p){this._pty=p,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(p){this._pty.handleInput?.(p)}resize(p,c){this._pty.setDimensions?.({columns:p,rows:c})}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(p){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(p||void 0),p&&this._pty.setDimensions?.(p),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let u=1,S=class extends I.Disposable{constructor(p,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(p),this._register({dispose:()=>{for(const[m,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(p=>p.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(p,c){const m=new C(this._proxy,(0,h.generateUuid)(),p,p.name),f=new b(p.pty);return m.createExtensionTerminal(p.location,this._serializeParentTerminal(p,c).resolvedExtHostIdentifier,o(p.iconPath),n(p.color)).then(E=>{const v=this._setupExtHostProcessListeners(E,f);this._terminalProcessDisposables[E]=v}),this._terminals.push(m),m.value}_serializeParentTerminal(p,c){if(c=c||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const m=p.location.parentTerminal;if(m){const f=this._terminals.find(E=>E.value===m);f&&(c.resolvedExtHostIdentifier=f._id)}}else p.location&&typeof p.location!="object"?c.location=p.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(p,c){if(!this._getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const f=new b(c),E=this._setupExtHostProcessListeners(p,f);this._terminalProcessDisposables[p]=E}async $acceptActiveTerminalChanged(p){const c=this._activeTerminal;if(p===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(p);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(p,c){const m=this._getTerminalById(p);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(p,c,m){const f=this._getTerminalById(p);f&&f.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(p,c,m){this._terminalProcesses.get(p)?.resize(c,m)}async $acceptTerminalTitleChange(p,c){const m=this._getTerminalById(p);m&&(m.name=c)}async $acceptTerminalClosed(p,c){const m=this._getTerminalObjectIndexById(this._terminals,p);if(m!==null){const f=this._terminals.splice(m,1)[0];f.setExitCode(c),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(p,c,m,f){if(c){const k=this._getTerminalObjectIndexById(this._terminals,c);if(k!==null){this._terminals[k]._id=p,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const E={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:A.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},v=new C(this._proxy,p,E,m);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(p,c){const m=this._getTerminalById(p);m&&m._setProcessId(c)}async $startExtensionTerminal(p,c){const m=this._getTerminalById(p);if(!m)return{message:(0,T.localize)(0,null,p)};m.isOpen||await new Promise(E=>{const v=this.onDidOpenTerminal(async k=>{k===m.value&&(v.dispose(),E())})});const f=this._terminalProcesses.get(p);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[p]={initialDimensions:c}}_setupExtHostProcessListeners(p,c){const m=new I.DisposableStore;m.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(p,E.pid,E.cwd))),m.add(c.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(p,E))),this._bufferer.startBuffering(p,c.onProcessData),m.add(c.onProcessExit(E=>this._onProcessExit(p,E))),this._terminalProcesses.set(p,c);const f=this._extensionTerminalAwaitingStart[p];return f&&c instanceof b&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[p]),m}$acceptProcessAckDataEvent(p,c){this._terminalProcesses.get(p)?.acknowledgeDataEvent(c)}$acceptProcessInput(p,c){this._terminalProcesses.get(p)?.input(c)}$acceptTerminalInteraction(p){const c=this._getTerminalById(p);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(p,c,m){try{this._terminalProcesses.get(p)?.resize(c,m)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(p,c){this._terminalProcesses.get(p)?.shutdown(c)}$acceptProcessRequestInitialCwd(p){this._terminalProcesses.get(p)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(p,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(p){this._terminalProcesses.get(p)?.getCwd().then(c=>this._proxy.$sendProcessProperty(p,{type:"cwd",value:c}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this._linkProviders.add(p),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(p),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(p,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,p.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(p,c){const m=new i.CancellationTokenSource().token;let f=await this._profileProviders.get(p)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(p,c){const m=this._getTerminalById(p);if(!m)return[];this._terminalLinkCache.delete(p);const f=this._terminalLinkCancellationSource.get(p);f&&f.dispose(!0);const E=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(p,E);const v=[],k={terminal:m.value,line:c},U=[];for(const L of this._linkProviders)U.push(M.Promises.withAsyncBody(async W=>{E.token.onCancellationRequested(()=>W({provider:L,links:[]}));const x=await L.provideTerminalLinks(k,E.token)||[];E.token.isCancellationRequested||W({provider:L,links:x})}));const N=await Promise.all(U);if(E.token.isCancellationRequested)return[];const y=new Map;for(const L of N)L&&L.links.length>0&&v.push(...L.links.map(W=>{const x={id:u++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return y.set(x.id,{provider:L.provider,link:W}),x}));return this._terminalLinkCache.set(p,y),v}$activateLink(p,c){const m=this._terminalLinkCache.get(p)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(p,c){this._bufferer.stopBuffering(p),this._terminalProcesses.delete(p),delete this._extensionTerminalAwaitingStart[p];const m=this._terminalProcessDisposables[p];m&&(m.dispose(),delete this._terminalProcessDisposables[p]),this._proxy.$sendProcessExit(p,c)}_getTerminalById(p){return this._getTerminalObjectById(this._terminals,p)}_getTerminalObjectById(p,c){const m=this._getTerminalObjectIndexById(p,c);return m!==null?p[m]:null}_getTerminalObjectIndexById(p,c){let m=null;return p.some((f,E)=>f._id===c?(m=E,!0):!1),m}getEnvironmentVariableCollection(p){let c=this._environmentVariableCollections.get(p.identifier.value);return c||(c=new a,this._setEnvironmentVariableCollection(p.identifier.value,c)),c}_syncEnvironmentVariableCollection(p,c){const m=(0,w.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(p,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(p){p.forEach(c=>{const m=c[0],f=new a(c[1]);this._setEnvironmentVariableCollection(m,f)})}$acceptDefaultProfile(p,c){this._defaultProfile=p,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(p,c){this._environmentVariableCollections.set(p,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(p,c)})}};S=xe([$e(1,P.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class a{constructor(p){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(p)}get persistent(){return this._persistent}set persistent(p){this._persistent=p,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(p,c){this._setIfDiffers(p,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(p,c){this._setIfDiffers(p,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(p,c){this._setIfDiffers(p,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(p,c){const m=this.map.get(p);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(p,c),this._onDidChangeCollection.fire())}get(p){return this.map.get(p)}forEach(p,c){this.map.forEach((m,f)=>p.call(c,f,m,this))}delete(p){this.map.delete(p),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let F=class extends S{constructor(p){super(!1,p)}createTerminal(p,c,m){throw new R.NotSupportedError}createTerminalFromOptions(p,c){throw new R.NotSupportedError}};F=xe([$e(0,P.IExtHostRpcService)],F),e.WorkerExtHostTerminalService=F;function o(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function n(d){return s.ThemeColor.isThemeColor(d)?d:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[199],_e([0,1,16,21,20,4,231,92,6,27,13,36,5,14,48,8,7,167,86,66]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(k,U){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(i.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new F(this.proxy),U.registerArgumentProcessor({processArgument:N=>N?.$mid===13?s.TestItem.toItemFromContext(N):N})}createTestController(k,U,N){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const y=new D.DisposableStore,L=y.add(new M.SingleUseTestCollection(k));L.root.label=U;const W=new Map,x=this.proxy,$={items:L.root.children,get label(){return U},set label(ie){U=ie,L.root.label=ie,x.$updateController(k,{label:U})},get refreshHandler(){return N},set refreshHandler(ie){N=ie,x.$updateController(k,{canRefresh:!!ie})},get id(){return k},createRunProfile:(ie,se,X,ge,be)=>{let pe=(0,I.hash)(ie);for(;W.has(pe);)pe++;const fe=new f(this.proxy,k,pe,ie,se,X,ge,be);return W.set(pe,fe),fe},createTestItem(ie,se,X){return new l.TestItemImpl(k,ie,se,X)},createTestRun:(ie,se,X=!0)=>this.runTracker.createTestRun(k,L,ie,se,X),set resolveHandler(ie){L.resolveHandler=ie},get resolveHandler(){return L.resolveHandler},dispose:()=>{y.dispose()}};x.$registerTestController(k,U,!!N),y.add((0,D.toDisposable)(()=>x.$unregisterTestController(k)));const q={controller:$,collection:L,profiles:W};return this.controllers.set(k,q),y.add((0,D.toDisposable)(()=>this.controllers.delete(k))),y.add(L.onDidGenerateDiff(ie=>x.$publishDiff(k,ie))),$}createTestObserver(){return this.observer.checkout()}async runTests(k,U=_.CancellationToken.None){const N=o(k);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(N.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(L=>L.id)??[y.collection.root.id],profileGroup:E[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:k.exclude?.map(L=>L.id)},U)}$provideFileCoverage(k,U,N){return(0,r.mapFind)(this.runTracker.trackers,L=>L.id===k?L.getCoverage(U):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(k,U,N,y){return(0,r.mapFind)(this.runTracker.trackers,W=>W.id===k?W.getCoverage(U):void 0)?.resolveFileCoverage(N,y)??Promise.resolve([])}$configureRunProfile(k,U){this.controllers.get(k)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(k,U){await this.controllers.get(k)?.controller.refreshHandler?.(U)}$publishTestResults(k){this.results=Object.freeze(k.map(U=>(0,T.deepFreeze)(s.TestResults.to(U))).concat(this.results).sort((U,N)=>N.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,U){const N=this.controllers.get(b.TestId.fromString(k).controllerId)?.collection;N&&(await N.expand(k,U<0?1/0:U),N.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,U){const N=this.controllers.get(k.controllerId);if(!N)return;const{collection:y,profiles:L}=N,W=L.get(k.profileId);if(!W)return;const x=k.testIds.map(se=>y.tree.get(se)).filter(R.isDefined),$=k.excludeExtIds.map(se=>N.collection.tree.get(se)).filter(R.isDefined).filter(se=>x.some(X=>X.fullId.compare(se.fullId)===2));if(!x.length)return;const q=new g.TestRunRequest(x.some(se=>se.actual instanceof l.TestItemRootImpl)?void 0:x.map(se=>se.actual),$.map(se=>se.actual),W),ie=this.runTracker.prepareForMainThreadTestRun(q,n.fromInternal(k,N.collection),U);try{await W.runHandler(q,U)}finally{ie.isRunning&&!U.isCancellationRequested&&await A.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};S=xe([$e(0,h.IExtHostRpcService)],S),e.ExtHostTesting=S;class a extends D.Disposable{constructor(k,U,N){super();this.dto=k,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const U=this.dto.id,N=this.dto.controllerId,y=(0,w.generateUuid)(),L=new d(this.proxy,U,y),W=ie=>(se,...X)=>{if($){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(se)||(this.ensureTestIsKnown(se),ie(se,...X))},x=(ie,se)=>{const X=se instanceof Array?se.map(s.TestMessage.from):[s.TestMessage.from(se)];if(ie.uri&&ie.range){const ge={range:s.Range.from(ie.range),uri:ie.uri};for(const be of X)be.location=be.location||ge}this.proxy.$appendTestMessagesInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),X)};let $=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return L.coverageProvider},set coverageProvider(ie){L.coverageProvider=ie},enqueued:W(ie=>{this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),1)}),skipped:W(ie=>{this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),5)}),started:W(ie=>{this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),2)}),errored:W((ie,se,X)=>{x(ie,se),this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),6,X)}),failed:W((ie,se,X)=>{x(ie,se),this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,N).toString(),4,X)}),passed:W((ie,se)=>{this.proxy.$updateTestStateInRun(U,y,b.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,se)}),appendOutput:(ie,se,X)=>{$||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(U,y,t.VSBuffer.fromString(ie),se&&s.location.from(se),X&&b.TestId.fromExtHostTestItem(X,N).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(U,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:L}),this.proxy.$startedTestRunTask(U,{id:y,name:k,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof l.TestItemImpl))throw new l.InvalidTestItemError(k.id);if(this.sharedTestIds.has(b.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const U=[],N=this.dto.colllection.root;for(;;){const y=s.TestItem.from(k);if(U.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),k===N))break;k=k.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class F{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,U,N){return this.getTracker(k,U,N)}cancelRunById(k){for(const U of this.tracked.values())if(U.id===k){U.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,U,N,y,L){const W=this.tracked.get(N);if(W)return W.createRun(y);const x=n.fromPublic(k,U,N,L),$=o(N);this.proxy.$startedExtensionTestRun({controllerId:k,profile:$&&{group:E[$.kind],id:$.profileId},exclude:N.exclude?.map(ie=>ie.id)??[],id:x.id,include:N.include?.map(ie=>ie.id)??[U.root.id],persist:L});const q=this.getTracker(N,x);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),q.createRun(y)}getTracker(k,U,N){const y=new a(U,this.proxy,N);return this.tracked.set(k,y),y.onEnd(()=>this.tracked.delete(k)),y}}e.TestRunCoordinator=F;const o=v=>{if(!!v.profile){if(!(v.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return v.profile}};class n{constructor(k,U,N,y,L,W){this.controllerId=k,this.id=U,this.isPersisted=L,this.colllection=W,this.includePrefix=N.map(x=>x+"\0"),this.excludePrefix=y.map(x=>x+"\0")}static fromPublic(k,U,N,y){return new n(k,(0,w.generateUuid)(),N.include?.map(L=>b.TestId.fromExtHostTestItem(L,k).toString())??[k],N.exclude?.map(L=>b.TestId.fromExtHostTestItem(L,k).toString())??[],y,U)}static fromInternal(k,U){return new n(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,U)}isIncluded(k){const U=b.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(U===N||U.startsWith(N))return!1;for(const N of this.includePrefix)if(U===N||U.startsWith(N))return!0;return!1}}e.TestRunDto=n;class d{constructor(k,U,N){this.proxy=k,this.runId=U,this.taskId=N}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(s.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(k,U){const N=await this.fileCoverage;let y=N?.[k];return!this._coverageProvider||!N||!y?[]:(y.detailedCoverage||(y=N[k]=await this._coverageProvider.resolveFileCoverage?.(y,U)??y),y.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class p extends C.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,s.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:U,removed:N}=this;return{get added(){return[...k].map(y=>y.revived)},get updated(){return[...U].map(y=>y.revived)},get removed(){return[...N].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,U){return{...k,revived:s.TestItem.toPlain(k.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new p(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class f{constructor(k,U,N,y,L,W,x=!1,$=void 0){this.controllerId=U,this.profileId=N,this._label=y,this.kind=L,this.runHandler=W,this._isDefault=x,this._tag=$,u.set(this,void 0),Xe(this,u,k,"f");const q=E[L];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${L}`);Ie(this,u,"f").$publishTestRunProfile({profileId:N,controllerId:U,tag:$?s.TestTag.namespace(this.controllerId,$.id):null,label:y,group:q,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?s.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ie(this,u,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,u=new WeakMap;const E={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ye[200],_e([0,1,4,16,5,90,8,7]),function(ee,e,r,t,_,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(R,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const w=this._extHostDocumentsAndEditors.allEditors();return R?w:w.map(i=>i.value)}async showTextDocument(R,w,i){let h;typeof w=="number"?h={position:P.ViewColumn.from(w),preserveFocus:i}:typeof w=="object"?h={position:P.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?P.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:h={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(R.uri,h),s=l&&this._extHostDocumentsAndEditors.getEditor(l);if(s)return s.value;throw l?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,w){return new A.TextEditorDecorationType(this._proxy,R,w).value}$acceptEditorPropertiesChanged(R,w){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(w.options&&i._acceptOptions(w.options),w.selections){const h=w.selections.selections.map(P.Selection.to);i._acceptSelections(h)}if(w.visibleRanges){const h=t.coalesce(w.visibleRanges.map(P.Range.to));i._acceptVisibleRanges(h)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...w.options,lineNumbers:P.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const h=I.TextEditorSelectionChangeKind.fromValue(w.selections.source),l=w.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:l,kind:h})}if(w.visibleRanges){const h=t.coalesce(w.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:h})}}$acceptEditorPositionData(R){for(const w in R){const i=this._extHostDocumentsAndEditors.getEditor(w);if(!i)throw new Error("Unknown text editor");const h=P.ViewColumn.to(R[w]);i.value.viewColumn!==h&&(i._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:h}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=D}),define(ye[201],_e([0,1,2,3,5,6,7]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(R,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(_.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const h=i.uri===void 0?void 0:r.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(D(h))?.get(i.handle)}return i}})}async $getTimeline(R,w,i,h,l){return this._providers.get(R)?.provideTimeline(r.URI.revive(w),i,h,l)}registerTimelineProvider(R,w,i,h){const l=new A.DisposableStore,s=this.convertTimelineItem(w.id,h,l).bind(this);let g;w.onDidChange&&(g=w.onDidChange(C=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:w.id}),this));const M=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:R,onDidChange:void 0,async provideTimeline(C,b,u,S){S?.resetCache&&(l.clear(),M.get(w.id)?.clear());const a=await w.provideTimeline(C,b,u);if(a==null)return;const F=s(C,S);return{...a,source:w.id,items:a.items.map(F)}},dispose(){for(const C of M.values())C.get(w.id)?.clear();g?.dispose(),l.dispose()}})}convertTimelineItem(R,w,i){return(h,l)=>{let s;if(l?.cacheResults){let g=this._itemsBySourceAndUriMap.get(R);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(R,g));const M=D(h);s=g.get(M),s===void 0&&(s=new Map,g.set(M,s))}return g=>{const{iconPath:M,...C}=g,b=`${R}|${g.id??g.timestamp}`;s?.set(b,g);let u,S,a;return g.iconPath&&(M instanceof P.ThemeIcon?a={id:M.id,color:M.color}:r.URI.isUri(M)?(u=M,S=M):{light:u,dark:S}=M),{...C,id:C.id??void 0,handle:b,source:R,command:g.command?w.toInternal(g.command,i):void 0,icon:u,iconDark:S,themeIcon:a,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,A.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function D(T){return T?.toString()}}),define(ye[202],_e([0,1,6,11,2,5]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,R,w){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const i=w.schemes.find(h=>!P.supportedSchemes.has(h));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,R),this._proxy.$registerUriOpener(T,w.schemes,D,w.label),(0,r.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,R){const w=this._openers.get(D);if(!w)throw new Error(`Unknown opener with id: ${D}`);const i=_.URI.revive(T);return w.canOpenExternalUri(i,R)}async $openUri(D,T,R){const w=this._openers.get(D);if(!w)throw new Error(`Unknown opener id: '${D}'`);return w.openExternalUri(_.URI.revive(T.resolvedUri),{sourceUri:_.URI.revive(T.sourceUri)},R)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[203],_e([0,1,5,2,6,15,25]),function(ee,e,r,t,_,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,R){if(this.handles.has(P.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const w=I.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(T)),this.handlers.set(w,R),this._proxy.$registerUriHandler(w,T),(0,_.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(T)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(T,R){const w=this.handlers.get(T);if(!w)return Promise.resolve(void 0);try{w.handleUri(t.URI.revive(R))}catch(i){(0,A.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=I,I.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[51],_e([0,1,4,11,2,131,151,65,5]),function(ee,e,r,t,_,A,P,I,D){"use strict";var T,R,w,i,h,l,s,g,M,C,b,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(m,f,E,v,k,U,N){T.set(this,void 0),R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),s.set(this,""),g.set(this,void 0),M.set(this,!1),C.set(this,!1),b.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new r.Emitter),this._onDidDispose=Ie(this,u,"f").event,Xe(this,T,m,"f"),Xe(this,R,f,"f"),Xe(this,g,E,"f"),Xe(this,i,v,"f"),Xe(this,h,k,"f"),Xe(this,l,U,"f"),Xe(this,b,a(U),"f"),Xe(this,w,N,"f")}dispose(){Xe(this,M,!0,"f"),Ie(this,u,"f").fire(),Ie(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Xe(this,C,!0,"f"),(0,I.asWebviewUri)(m,Ie(this,i,"f").remote)}get cspSource(){const m=Ie(this,l,"f").extensionLocation;if(m.scheme===t.Schemas.https||m.scheme===t.Schemas.http){let f=m.toString();return f.endsWith("/")||(f+="/"),f+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,s,"f")}set html(m){this.assertNotDisposed(),Ie(this,s,"f")!==m&&(Xe(this,s,m,"f"),!Ie(this,C,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Xe(this,C,!0,"f"),Ie(this,w,"f").report("Webview vscode-resource: uris",Ie(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,T,"f"),m))}get options(){return this.assertNotDisposed(),Ie(this,g,"f")}set options(m){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,T,"f"),n(Ie(this,l,"f"),Ie(this,h,"f"),m)),Xe(this,g,m,"f")}async postMessage(m){if(Ie(this,M,"f"))return!1;const f=(0,P.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ie(this,b,"f")});return Ie(this,R,"f").$postMessage(Ie(this,T,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Ie(this,M,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,T=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,s=new WeakMap,g=new WeakMap,M=new WeakMap,C=new WeakMap,b=new WeakMap,u=new WeakMap;function a(c){try{const m=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class F{constructor(m,f,E,v,k){this.initData=f,this.workspace=E,this._logService=v,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=m.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(m,f,E){const v=this.getWebview(m);if(v){const{message:k}=(0,P.deserializeWebviewMessage)(f,E.value);v._onMessageEmitter.fire(k)}}$onMissingCsp(m,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,f,E){const v=new S(m,this._webviewProxy,d(f),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(m,v),v._onDidDispose(()=>{this._webviews.delete(m)}),v}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=F;function o(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=o;function n(c,m,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||p(c,m)}}e.serializeWebviewOptions=n;function d(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>_.URI.from(m))}}e.reviveOptions=d;function p(c,m){return[...(m?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(ye[204],_e([0,1,20,92,6,11,24,2,8,51,62,5,7]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(a,F){this.document=a,this._storagePath=F,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,F){await this.getEdit(a).undo(),F||this.disposeBackup()}async redo(a,F){await this.getEdit(a).redo(),F||this.disposeBackup()}disposeEdits(a){for(const F of a)this._edits.delete(F)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=u(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const F=this._edits.get(a,0);if(!F)throw new Error("No edit found");return F}}class l{constructor(){this._documents=new Map}get(a,F){return this._documents.get(this.key(a,F))}add(a,F,o){const n=this.key(a,F.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${a} resource:${F.uri}`);const d=new h(F,o);return this._documents.set(n,d),d}delete(a,F){const o=this.key(a,F.uri);this._documents.delete(o)}key(a,F){return`${a}@@@${F}`}}var s;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(s||(s={}));class g{constructor(){this._providers=new Map}addTextProvider(a,F,o){return this.add(0,a,F,o)}addCustomProvider(a,F,o){return this.add(1,a,F,o)}get(a){return this._providers.get(a)}add(a,F,o,n){if(this._providers.has(F))throw new Error(`Provider for viewType:${F} already registered`);return this._providers.set(F,{type:a,extension:o,provider:n}),new i.Disposable(()=>this._providers.delete(F))}}class M{constructor(a,F,o,n,d){this._extHostDocuments=F,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=d,this._editorProviders=new g,this._documents=new l,this._proxy=a.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,F,o,n){const d=new _.DisposableStore;return C(o)?(d.add(this._editorProviders.addTextProvider(F,a,o)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(a),F,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(a))):(d.add(this._editorProviders.addCustomProvider(F,a,o)),this.supportEditing(o)&&d.add(o.onDidChangeCustomDocument(p=>{const c=this.getCustomDocumentEntry(F,p.document.uri);if(b(p)){const m=c.addEdit(p);this._proxy.$onDidEdit(p.document.uri,F,m,p.label)}else this._proxy.$onContentChange(p.document.uri,F)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(a),F,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(a))),i.Disposable.from(d,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(F)}))}async $createCustomDocument(a,F,o,n,d){const p=this._editorProviders.get(F);if(!p)throw new Error(`No provider found for '${F}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${F}'`);const c=I.URI.revive(a),m=await p.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:n?.buffer},d);let f;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(F,m,f),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(a,F){const o=this._editorProviders.get(F);if(!o)throw new Error(`No provider found for '${F}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${F}'`);const n=I.URI.revive(a),{document:d}=this.getCustomDocumentEntry(F,n);this._documents.delete(F,d),d.dispose()}async $resolveWebviewEditor(a,F,o,n,d,p){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const m=D.ViewColumn.to(d),f=this._extHostWebview.createNewWebview(F,n.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(F,o,n.title,m,n.panelOptions,f),v=I.URI.revive(a);switch(c.type){case 1:{const{document:k}=this.getCustomDocumentEntry(o,v);return c.provider.resolveCustomEditor(k,E,p)}case 0:{const k=this._extHostDocuments.getDocument(v);return c.provider.resolveCustomTextEditor(k,E,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,F,o){this.getCustomDocumentEntry(F,a).disposeEdits(o)}async $onMoveCustomEditor(a,F,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this._extHostWebviewPanels.getWebviewPanel(a);if(!d)throw new Error("No webview found");const p=I.URI.revive(F),c=this._extHostDocuments.getDocument(p);await n.provider.moveCustomTextEditor(c,d,r.CancellationToken.None)}async $undo(a,F,o,n){return this.getCustomDocumentEntry(F,a).undo(o,n)}async $redo(a,F,o,n){return this.getCustomDocumentEntry(F,a).redo(o,n)}async $revert(a,F,o){const n=this.getCustomDocumentEntry(F,a);await this.getCustomEditorProvider(F).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(a,F,o){const n=this.getCustomDocumentEntry(F,a);await this.getCustomEditorProvider(F).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(a,F,o,n){const d=this.getCustomDocumentEntry(F,a);return this.getCustomEditorProvider(F).saveCustomDocumentAs(d.document,I.URI.revive(o),n)}async $backup(a,F,o){const n=this.getCustomDocumentEntry(F,a),p=await this.getCustomEditorProvider(F).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(p),p.id}getCustomDocumentEntry(a,F){const o=this._documents.get(a,I.URI.revive(F));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(a){const o=this._editorProviders.get(a)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=M;function C(S){return typeof S.resolveCustomTextEditor=="function"}function b(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function u(S){const a=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,t.hash)(a)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[205],_e([0,1,4,6,2,36,8,51,5,7]),function(ee,e,r,t,_,A,P,I,D,T){"use strict";var R,w,i,h,l,s,g,M,C,b,u,S,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class F extends t.Disposable{constructor(p,c,m,f,E,v,k){super();R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),s.set(this,void 0),g.set(this,void 0),M.set(this,void 0),C.set(this,!0),b.set(this,!0),u.set(this,!1),S.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,S,"f").event,a.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Ie(this,a,"f").event,Xe(this,R,p,"f"),Xe(this,w,c,"f"),Xe(this,i,m,"f"),Xe(this,l,v,"f"),Xe(this,M,E,"f"),Xe(this,s,f,"f"),Xe(this,h,k,"f")}dispose(){Ie(this,u,"f")||(Xe(this,u,!0,"f"),Ie(this,S,"f").fire(),Ie(this,w,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,i,"f")}get title(){return this.assertNotDisposed(),Ie(this,s,"f")}set title(p){this.assertNotDisposed(),Ie(this,s,"f")!==p&&(Xe(this,s,p,"f"),Ie(this,w,"f").$setTitle(Ie(this,R,"f"),p))}get iconPath(){return this.assertNotDisposed(),Ie(this,g,"f")}set iconPath(p){this.assertNotDisposed(),Ie(this,g,"f")!==p&&(Xe(this,g,p,"f"),Ie(this,w,"f").$setIconPath(Ie(this,R,"f"),_.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Ie(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,M,"f")=="number"&&Ie(this,M,"f")<0))return Ie(this,M,"f")}get active(){return this.assertNotDisposed(),Ie(this,b,"f")}get visible(){return this.assertNotDisposed(),Ie(this,C,"f")}_updateViewState(p){Ie(this,u,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Xe(this,b,p.active,"f"),Xe(this,C,p.visible,"f"),Xe(this,M,p.viewColumn,"f"),Ie(this,a,"f").fire({webviewPanel:this}))}reveal(p,c){this.assertNotDisposed(),Ie(this,w,"f").$reveal(Ie(this,R,"f"),{viewColumn:p?P.ViewColumn.from(p):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ie(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,w=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,s=new WeakMap,g=new WeakMap,M=new WeakMap,C=new WeakMap,b=new WeakMap,u=new WeakMap,S=new WeakMap,a=new WeakMap;class o{constructor(p,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(p,c,m,f,E={}){const v=typeof f=="object"?f.viewColumn:f,k={viewColumn:P.ViewColumn.from(v),preserveFocus:typeof f=="object"&&!!f.preserveFocus},U=(0,I.shouldSerializeBuffersForPostMessage)(p),N=o.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(p),N,c,{title:m,panelOptions:n(E),webviewOptions:(0,I.serializeWebviewOptions)(p,this.workspace,E),serializeBuffersForPostMessage:U},k);const y=this.webviews.createNewWebview(N,E,p);return this.createNewWebviewPanel(N,c,m,v,E,y)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((m,f)=>{const E=p[m],v=p[f];return E.active?1:v.active?-1:+E.visible-+v.visible});for(const m of c){const f=this.getWebviewPanel(m);if(!f)continue;const E=p[m];f._updateViewState({active:E.active,visible:E.visible,viewColumn:P.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:p}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(p)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,m,f){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:v,extension:k}=E,U=this.webviews.createNewWebview(p,m.webviewOptions,k),N=this.createNewWebviewPanel(p,c,m.title,f,m.panelOptions,U);await v.deserializeWebviewPanel(N,m.state)}createNewWebviewPanel(p,c,m,f,E,v){const k=new F(p,this._proxy,c,m,f,E,v);return this._webviewPanels.set(p,k),k}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=o;function n(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[206],_e([0,1,4,6,51,5,7]),function(ee,e,r,t,_,A,P){"use strict";var I,D,T,R,w,i,h,l,s,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class M extends t.Disposable{constructor(u,S,a,F,o,n){super();I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),R.set(this,void 0),w.set(this,!1),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),s.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Ie(this,s,"f").event,g.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,g,"f").event,Xe(this,T,a,"f"),Xe(this,h,F,"f"),Xe(this,I,u,"f"),Xe(this,D,S,"f"),Xe(this,R,o,"f"),Xe(this,i,n,"f")}dispose(){Ie(this,w,"f")||(Xe(this,w,!0,"f"),Ie(this,g,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,h,"f")}set title(u){this.assertNotDisposed(),Ie(this,h,"f")!==u&&(Xe(this,h,u,"f"),Ie(this,D,"f").$setWebviewViewTitle(Ie(this,I,"f"),u))}get description(){return this.assertNotDisposed(),Ie(this,l,"f")}set description(u){this.assertNotDisposed(),Ie(this,l,"f")!==u&&(Xe(this,l,u,"f"),Ie(this,D,"f").$setWebviewViewDescription(Ie(this,I,"f"),u))}get visible(){return Ie(this,i,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,T,"f")}_setVisible(u){u===Ie(this,i,"f")||Ie(this,w,"f")||(Xe(this,i,u,"f"),Ie(this,s,"f").fire())}show(u){this.assertNotDisposed(),Ie(this,D,"f").$show(Ie(this,I,"f"),!!u)}assertNotDisposed(){if(Ie(this,w,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,T=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,s=new WeakMap,g=new WeakMap;class C{constructor(u,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,S,a,F){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:a,extension:u}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(u),S,{retainContextWhenHidden:F?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(u,S,a,F,o){const n=this._viewProviders.get(S);if(!n)throw new Error(`No view provider found for '${S}'`);const{provider:d,extension:p}=n,c=this._extHostWebview.createNewWebview(u,{},p),m=new M(u,this._proxy,S,a,c,!0);this._webviewViews.set(u,m),await d.resolveWebviewView(m,{state:F},o)}async $onDidChangeWebviewViewVisibility(u,S){this.getWebviewView(u)._setVisible(S)}async $disposeWebviewView(u){const S=this.getWebviewView(u);this._webviewViews.delete(u),S.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const S=this._webviewViews.get(u);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=C}),define(ye[94],_e([0,1,4,5,2,11,9,3,14]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class ji{constructor(w){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=w.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,i){let h;if(typeof w=="string"){h=w;try{w=_.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,P.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,h,i)}async asExternalUri(w,i){if((0,P.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(w,i);return _.URI.from(h)}};T.InitialState={focused:!0},T=xe([$e(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ye[207],_e([0,1,10,21,20,15,4,6,105,173,38]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(E,v){try{return JSON.stringify(E,v)}catch{return"null"}}const h="$$ref$$",l={[h]:-1};class s{constructor(v,k){this.jsonString=v,this.referencedBuffers=k}}function g(E,v=null,k=!1){const U=[];return{jsonString:(k?i:JSON.stringify)(E,(y,L)=>{if(typeof L=="undefined")return l;if(typeof L=="object"){if(L instanceof t.VSBuffer){const W=U.push(L)-1;return{[h]:W}}if(v)return v(y,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=g;function M(E,v,k){return JSON.parse(E,(U,N)=>{if(N){const y=N[h];if(typeof y=="number")return v[y];if(k&&N.$mid===1)return k.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=M;function C(E,v){return JSON.stringify(E,v)}function b(E){return E?(v,k)=>k&&k.$mid===1?E.transformOutgoing(k):k:null}var u;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},F=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class n extends I.Disposable{constructor(v,k=null,U=null){super();this[w]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=v,this._logger=k,this._uriTransformer=U,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,y=R.ProxyIdentifier.count;N<y;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(v=>{this._pendingRPCReplies[v].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(v){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(v){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(v){this._responsiveState!==v&&(this._responsiveState=v,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(v){return this._uriTransformer?(0,D.transformIncomingURIs)(v,this._uriTransformer):v}getProxy(v){const{nid:k,sid:U}=v;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,U)),this._proxies[k]}_createProxy(v,k){let U={get:(N,y)=>(typeof y=="string"&&!N[y]&&y.charCodeAt(0)===36&&(N[y]=(...L)=>this._remoteCall(v,y,L)),y===o?k:N[y])};return new Proxy(Object.create(null),U)}set(v,k){return this._locals[v.nid]=k,k}assertRegistered(v){for(let k=0,U=v.length;k<U;k++){const N=v[k];if(!this._locals[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}_receiveOneMessage(v){if(this._isDisposed)return;const k=v.byteLength,U=d.read(v,0),N=U.readUInt8(),y=U.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:W,args:x}=c.deserializeRequestJSONArgs(U);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(k,y,L,W,x,N===2);break}case 3:case 4:{let{rpcId:L,method:W,args:x}=c.deserializeRequestMixedArgs(U);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(k,y,L,W,x,N===4);break}case 5:{this._logger&&this._logger.logIncoming(k,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(k,y);break}case 7:{this._receiveReply(k,y,void 0);break}case 9:{let L=c.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(k,y,L);break}case 10:{const L=c.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(k,y,L);break}case 8:{let L=c.deserializeReplyOKVSBuffer(U);this._receiveReply(k,y,L);break}case 11:{let L=c.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(k,y,L);break}case 12:{this._receiveReplyErr(k,y,void 0);break}default:console.error("received unexpected message"),console.error(v)}}_receiveRequest(v,k,U,N,y,L){this._logger&&this._logger.logIncoming(v,k,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(U)}.${N}(`,y);const W=String(k);let x,$;if(L){const ie=new _.CancellationTokenSource;y.push(ie.token),x=this._invokeHandler(U,N,y),$=()=>ie.cancel()}else x=this._invokeHandler(U,N,y),$=a;this._cancelInvokedHandlers[W]=$;const q=c.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"ack"),this._protocol.send(q),x.then(ie=>{delete this._cancelInvokedHandlers[W];const se=c.serializeReplyOK(k,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(se.byteLength,k,1,"reply:",ie),this._protocol.send(se)},ie=>{delete this._cancelInvokedHandlers[W];const se=c.serializeReplyErr(k,ie);this._logger&&this._logger.logOutgoing(se.byteLength,k,1,"replyErr:",ie),this._protocol.send(se)})}_receiveCancel(v,k){this._logger&&this._logger.logIncoming(v,k,1,"receiveCancel");const U=String(k);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(v,k,U){this._logger&&this._logger.logIncoming(v,k,0,"receiveReply:",U);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const y=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],y.resolveOk(U)}_receiveReplyErr(v,k,U){this._logger&&this._logger.logIncoming(v,k,0,"receiveReplyErr:",U);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const y=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),y.resolveErr(L)}_invokeHandler(v,k,U){try{return Promise.resolve(this._doInvokeHandler(v,k,U))}catch(N){return Promise.reject(N)}}_doInvokeHandler(v,k,U){const N=this._locals[v];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(v));let y=N[k];if(typeof y!="function")throw new Error("Unknown method "+k+" on actor "+(0,R.getStringIdentifierForProxy)(v));return y.apply(N,U)}_remoteCall(v,k,U){if(this._isDisposed)return Promise.reject(A.canceled());let N=null;if(U.length>0&&_.CancellationToken.isCancellationToken(U[U.length-1])&&(N=U.pop()),N&&N.isCancellationRequested)return Promise.reject(A.canceled());const y=c.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,W=String(L),x=new T.LazyPromise;N&&N.onCancellationRequested(()=>{const q=c.serializeCancel(L);this._logger&&this._logger.logOutgoing(q.byteLength,L,0,"cancel"),this._protocol.send(c.serializeCancel(L))}),this._pendingRPCReplies[W]=x,this._onWillSendRequest(L);const $=c.serializeRequest(L,v,k,y,!!N);return this._logger&&this._logger.logOutgoing($.byteLength,L,0,`request: ${(0,R.getStringIdentifierForProxy)(v)}.${k}(`,U),this._protocol.send($),x}}e.RPCProtocol=n,w=F,n.UNRESPONSIVE_TIME=3*1e3;class d{constructor(v,k){this._buff=v,this._offset=k}static alloc(v,k,U){let N=new d(t.VSBuffer.alloc(U+1+4),0);return N.writeUInt8(v),N.writeUInt32(k),N}static read(v,k){return new d(v,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(v){this._buff.writeUInt8(v,this._offset),this._offset+=1}readUInt8(){const v=this._buff.readUInt8(this._offset);return this._offset+=1,v}writeUInt32(v){this._buff.writeUInt32BE(v,this._offset),this._offset+=4}readUInt32(){const v=this._buff.readUInt32BE(this._offset);return this._offset+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this._buff.writeUInt8(v.byteLength,this._offset),this._offset+=1,this._buff.set(v,this._offset),this._offset+=v.byteLength}readShortString(){const v=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,U}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readLongString(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,U}writeBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readVSBuffer(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+v);return this._offset+=v,k}static sizeMixedArray(v){let k=0;k+=1;for(let U=0,N=v.length;U<N;U++){const y=v[U];switch(k+=1,y.type){case 1:k+=this.sizeLongString(y.value);break;case 2:k+=this.sizeVSBuffer(y.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(y.value);for(let L=0;L<y.buffers.length;++L)k+=this.sizeVSBuffer(y.buffers[L]);break;case 4:break}}return k}writeMixedArray(v){this._buff.writeUInt8(v.length,this._offset),this._offset+=1;for(let k=0,U=v.length;k<U;k++){const N=v[k];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let y=0;y<N.buffers.length;++y)this.writeBuffer(N.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(v);for(let U=0;U<v;U++)switch(this.readUInt8()){case 1:k[U]=this.readLongString();break;case 2:k[U]=this.readVSBuffer();break;case 3:{const y=this.readUInt32(),L=this.readLongString(),W=[];for(let x=0;x<y;++x)W.push(this.readVSBuffer());k[U]=new R.SerializableObjectWithBuffers(M(L,W,null));break}case 4:k[U]=void 0;break}return k}}d.sizeUInt32=4;var p;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(p||(p={}));class c{static _useMixedArgSerialization(v){for(let k=0,U=v.length;k<U;k++)if(v[k]instanceof t.VSBuffer||v[k]instanceof R.SerializableObjectWithBuffers||typeof v[k]=="undefined")return!0;return!1}static serializeRequestArguments(v,k){if(this._useMixedArgSerialization(v)){const U=[];for(let N=0,y=v.length;N<y;N++){const L=v[N];if(L instanceof t.VSBuffer)U[N]={type:2,value:L};else if(typeof L=="undefined")U[N]={type:4};else if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:x}=g(L.value,k);U[N]={type:3,value:t.VSBuffer.fromString(W),buffers:x}}else U[N]={type:1,value:t.VSBuffer.fromString(C(L,k))}}return{type:1,args:U}}return{type:0,args:C(v,k)}}static serializeRequest(v,k,U,N,y){switch(N.type){case 0:return this._requestJSONArgs(v,k,U,N.args,y);case 1:return this._requestMixedArgs(v,k,U,N.args,y)}}static _requestJSONArgs(v,k,U,N,y){const L=t.VSBuffer.fromString(U),W=t.VSBuffer.fromString(N);let x=0;x+=d.sizeUInt8(),x+=d.sizeShortString(L),x+=d.sizeLongString(W);let $=d.alloc(y?2:1,v,x);return $.writeUInt8(k),$.writeShortString(L),$.writeLongString(W),$.buffer}static deserializeRequestJSONArgs(v){const k=v.readUInt8(),U=v.readShortString(),N=v.readLongString();return{rpcId:k,method:U,args:JSON.parse(N)}}static _requestMixedArgs(v,k,U,N,y){const L=t.VSBuffer.fromString(U);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(L),W+=d.sizeMixedArray(N);let x=d.alloc(y?4:3,v,W);return x.writeUInt8(k),x.writeShortString(L),x.writeMixedArray(N),x.buffer}static deserializeRequestMixedArgs(v){const k=v.readUInt8(),U=v.readShortString(),N=v.readMixedArray(),y=new Array(N.length);for(let L=0,W=N.length;L<W;L++){const x=N[L];typeof x=="string"?y[L]=JSON.parse(x):y[L]=x}return{rpcId:k,method:U,args:y}}static serializeAcknowledged(v){return d.alloc(5,v,0).buffer}static serializeCancel(v){return d.alloc(6,v,0).buffer}static serializeReplyOK(v,k,U){if(typeof k=="undefined")return this._serializeReplyOKEmpty(v);if(k instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(v,k);if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:y}=g(k.value,U,!0);return this._serializeReplyOKJSONWithBuffers(v,N,y)}else return this._serializeReplyOKJSON(v,i(k,U))}static _serializeReplyOKEmpty(v){return d.alloc(7,v,0).buffer}static _serializeReplyOKVSBuffer(v,k){let U=0;U+=d.sizeVSBuffer(k);let N=d.alloc(8,v,U);return N.writeVSBuffer(k),N.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static _serializeReplyOKJSON(v,k){const U=t.VSBuffer.fromString(k);let N=0;N+=d.sizeLongString(U);let y=d.alloc(9,v,N);return y.writeLongString(U),y.buffer}static _serializeReplyOKJSONWithBuffers(v,k,U){const N=t.VSBuffer.fromString(k);let y=0;y+=d.sizeUInt32,y+=d.sizeLongString(N);for(const W of U)y+=d.sizeVSBuffer(W);let L=d.alloc(10,v,y);L.writeUInt32(U.length),L.writeLongString(N);for(const W of U)L.writeBuffer(W);return L.buffer}static deserializeReplyOKJSON(v){const k=v.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(v,k){const U=v.readUInt32(),N=v.readLongString(),y=[];for(let L=0;L<U;++L)y.push(v.readVSBuffer());return new R.SerializableObjectWithBuffers(M(N,y,k))}static serializeReplyErr(v,k){return k?this._serializeReplyErrEror(v,k):this._serializeReplyErrEmpty(v)}static _serializeReplyErrEror(v,k){const U=t.VSBuffer.fromString(i(A.transformErrorForSerialization(k),null));let N=0;N+=d.sizeLongString(U);let y=d.alloc(11,v,N);return y.writeLongString(U),y.buffer}static deserializeReplyErrError(v){const k=v.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(v){return d.alloc(12,v,0).buffer}}var m;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var f;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(f||(f={}))}),define(ye[208],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(A){const P=I=>{self.removeEventListener("message",P);const D=I.data;Object.defineProperties(self,{postMessage:{value(T,R){D.postMessage(T,R)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",P)}.toString();class t extends EventTarget{constructor(A,P,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${r})('${P}'))`,T=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(T),w=new MessageChannel,i=R,h={type:"_newWorker",id:i,port:w.port2,url:R,options:I};A(h,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:i};w.port1.postMessage(l),URL.revokeObjectURL(R),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(l){w.port1.onmessage=l}},onmessageerror:{get(){return w.port1.onmessageerror},set(l){w.port1.onmessageerror=l}}}),w.port1.addEventListener("messageerror",l=>{const s=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(s)}),w.port1.addEventListener("message",l=>{const s=new MessageEvent("message",{data:l.data});this.dispatchEvent(s)}),w.port1.start()}}e.NestedWorker=t}),define(ye[209],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(ye[210],_e([0,1,35,11,17,23,24,2,3,60,47,168,209]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let h=class qi{constructor(s,g,M,C){this.localUserHome=s,this.remoteAgentService=g,this.environmentService=M,this.contextService=C,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||s})()}hasValidBasename(s,g,M){return typeof g=="string"||typeof g=="undefined"?this.resolveOS.then(C=>this.doHasValidBasename(s,C,g)):this.doHasValidBasename(s,g,M)}doHasValidBasename(s,g,M){return s.scheme===t.Schemas.file||s.scheme===t.Schemas.vscodeRemote?(0,r.isValidBasename)(M??(0,P.basename)(s),g===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(s,g){if(s.remoteAuthority)return t.Schemas.vscodeRemote;const M=(0,T.getVirtualWorkspaceScheme)(g.getWorkspace());if(M)return M;const C=g.getWorkspace().folders[0];if(C)return C.uri.scheme;const b=g.getWorkspace().configuration;return b?b.scheme:t.Schemas.file}async userHome(s){return s?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?_.win32:_.posix)}async fileURI(s){let g="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const C=s.indexOf("/",2);C===-1?(g=s.substring(2),s="/"):(g=s.substring(2,C),s=s.substring(C)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:g,path:s,query:"",fragment:""})}};h=xe([$e(1,i.IRemoteAgentService),$e(2,w.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],h),e.AbstractPathService=h}),define(ye[95],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(P,I){this.line=P,this.character=I}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,I){return new r(0,0)}with(P){return new r(0,0)}}e.Position=r;class t{constructor(P,I,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(P,I),this.end=new r(D,T)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new t(0,0,0,0)}with(P){return new t(0,0,0,0)}}e.Range=t;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],_e([0,1,16,29,27,35,9,3,17,15,95,10]),function(ee,e,r,t,_,A,P,I,D,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",h=" characters skipped \u27EB",l=(i.length+h.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var s;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function M(q){return!!q.preview}e.resultIsMatch=M;function C(q){return!!q.resource}e.isFileMatch=C;function b(q){return!!q.message}e.isProgressMessage=b;var u;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=S;class a{constructor(ie,se,X){this.ranges=se;const ge=Array.isArray(se)?se:[se];if(X&&X.matchLines===1&&F(ge)){ie=(0,P.getNLines)(ie,X.matchLines);let be="",pe=0,fe=0;const oe=Math.floor(X.charsPerLine/5),Ee=[];for(const Pe of ge){const Oe=Math.max(Pe.startColumn-oe,0),je=Pe.startColumn+X.charsPerLine;if(Oe>fe+oe+l){const st=i+(Oe-fe)+h;be+=st+ie.slice(Oe,je),pe+=Oe-(fe+st.length)}else be+=ie.slice(fe,je);Ee.push(new n(0,Pe.startColumn-pe,Pe.endColumn-pe)),fe=je}this.preview={text:be,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const be=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(se,pe=>new o(pe.startLineNumber-be,pe.startColumn,pe.endLineNumber-be,pe.endColumn))}}}}e.TextSearchMatch=a;function F(q){const ie=q[0].startLineNumber;for(const se of q)if(se.startLineNumber!==ie||se.endLineNumber!==ie)return!1;return!0}class o{constructor(ie,se,X,ge){this.startLineNumber=ie,this.startColumn=se,this.endLineNumber=X,this.endColumn=ge}}e.SearchRange=o;class n extends o{constructor(ie,se,X){super(ie,se,ie,X)}}e.OneLineRange=n;var d;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function p(q,ie=!0){const se=q&&q.files&&q.files.exclude,X=ie&&q&&q.search&&q.search.exclude;if(!se&&!X)return;if(!se||!X)return se||X;let ge=Object.create(null);return ge=_.mixin(ge,_.deepClone(se)),ge=_.mixin(ge,_.deepClone(X),!0),ge}e.getExcludes=p;function c(q,ie){return q.excludePattern&&t.match(q.excludePattern,ie)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,ie)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(se=>{const X=se.folder.fsPath;if(A.isEqualOrParent(ie,X)){const ge=D.relative(X,ie);return!se.includePattern||!!t.match(se.includePattern,ge)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ie,se){super(ie);this.code=se}}e.SearchError=f;function E(q){const ie=q.message;if((0,T.isCancellationError)(q))return new f(ie,m.canceled);try{const se=JSON.parse(ie);return new f(se.message,se.code)}catch{return new f(ie,m.other)}}e.deserializeSearchError=E;function v(q){const ie={message:q.message,code:q.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=v;function k(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=k;function U(q){return q.type==="success"}e.isSerializedSearchSuccess=U;function N(q){return!!q.path}e.isSerializedFileMatch=N;function y(q,ie){const se=q.searchPath?q.searchPath:q.relativePath;return(0,P.fuzzyContains)(se,ie)}e.isFilePatternMatch=y;class L{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function W(q,ie){const se={...q||{},...ie||{}};return Object.keys(se).filter(X=>{const ge=se[X];return typeof ge=="boolean"&&ge})}e.resolvePatternsForProvider=W;class x{constructor(ie,se){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let X=ie.includePattern;se.includePattern&&(X?X={...X,...se.includePattern}:X=se.includePattern),X&&(this._parsedIncludeExpression=t.parse(X))}matchesExcludesSync(ie,se,X){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,se,X))}includedInQuerySync(ie,se,X){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,se,X)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,se,X))}includedInQuery(ie,se,X){const ge=this._parsedExcludeExpression(ie,se,X),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,se,X):!0;return(0,w.isThenable)(ge)?ge.then(pe=>pe?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=x;function $(q){for(const ie in q)if(typeof q[ie]!="boolean")return!0;return!1}}),define(ye[31],_e([0,1,16,10,20,4,22,11,100,24,9,13,2,124,3,12,137,47,30,28,14,8,7,41,5]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u,S,a,F,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,U,N){return new T.ExtUri(y=>m(y,N)).isEqual(k,U)}function d(k,U,N){return n(k.uri,U.uri,N)?0:(0,R.compare)(k.uri.toString(),U.uri.toString())}function p(k,U,N){return k.index!==U.index?k.index<U.index?-1:1:n(k.uri,U.uri,N)?(0,R.compare)(k.name,U.name):(0,R.compare)(k.uri.toString(),U.uri.toString())}function c(k,U,N,y){const L=k.slice(0).sort((x,$)=>N(x,$,y)),W=U.slice(0).sort((x,$)=>N(x,$,y));return(0,r.delta)(L,W,(x,$)=>N(x,$,y))}function m(k,U){const N=U.getCapabilities(k.scheme);return!(N&&N&1024)}class f extends M.Workspace{constructor(U,N,y,L,W,x,$){super(U,y.map(q=>new M.WorkspaceFolder(q)),L,W,$);this._name=N,this._isUntitled=x,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris($),y.forEach(q=>{this._workspaceFolders.push(q),this._structure.set(q.uri,q)})}static toExtHostWorkspace(U,N,y,L){if(!U)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:$,configuration:q,transient:ie,isUntitled:se}=U,X=[],ge=N;N?$.forEach((oe,Ee)=>{const Pe=i.URI.revive(oe.uri),Oe=f._findFolder(y||N,Pe,L);Oe?(Oe.name=oe.name,Oe.index=oe.index,X.push(Oe)):X.push({uri:Pe,name:oe.name,index:Ee})}):X.push(...$.map(({uri:oe,name:Ee,index:Pe})=>({uri:i.URI.revive(oe),name:Ee,index:Pe}))),X.sort((oe,Ee)=>oe.index<Ee.index?-1:1);const be=new f(W,x,X,!!ie,q?i.URI.revive(q):null,!!se,oe=>m(oe,L)),{added:pe,removed:fe}=c(ge?ge.workspaceFolders:[],be.workspaceFolders,d,L);return{workspace:be,added:pe,removed:fe}}static _findFolder(U,N,y){for(let L=0;L<U.folders.length;L++){const W=U.workspaceFolders[L];if(n(W.uri,N,y))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(U,N){return N&&this._structure.get(U)&&(U=(0,T.dirname)(U)),this._structure.findSubstr(U)}resolveWorkspaceFolder(U){return this._structure.get(U)}}let E=class{constructor(U,N,y,L){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=L,this._extHostFileSystemInfo=y,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=U.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=U.getProxy(o.MainContext.MainThreadMessageService);const W=N.workspace;this._confirmedWorkspace=W?new f(W.id,W.name,[],!!W.transient,W.configuration?i.URI.revive(W.configuration):null,!!W.isUntitled,x=>m(x,y)):void 0}$initializeWorkspace(U,N){this._trusted=N,this.$acceptWorkspaceData(U),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:I.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(U,N,y,...L){const W=[];if(Array.isArray(L)&&L.forEach(se=>{i.URI.isUri(se.uri)&&!W.some(X=>n(X.uri,se.uri,this._extHostFileSystemInfo))&&W.push({uri:se.uri,name:se.name||(0,T.basenameOrAuthority)(se.uri)})}),this._unconfirmedWorkspace||[N,y].some(se=>typeof se!="number"||se<0)||y===0&&W.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+y>x.length)return!1;const $=x.slice(0);$.splice(N,y,...W.map(se=>({uri:se.uri,name:se.name||(0,T.basenameOrAuthority)(se.uri),index:void 0})));for(let se=0;se<$.length;se++){const X=$[se];if($.some((ge,be)=>be!==se&&n(X.uri,ge.uri,this._extHostFileSystemInfo)))return!1}$.forEach((se,X)=>se.index=X);const{added:q,removed:ie}=c(x,$,p,this._extHostFileSystemInfo);if(q.length===0&&ie.length===0)return!1;if(this._proxy){const se=U.displayName||U.name;this._proxy.$updateWorkspaceFolders(se,N,y,W).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const ge={source:{identifier:U.identifier,label:U.displayName||U.name}};this._messageService.$showMessage(g.Severity.Error,(0,h.localize)(0,null,se,X.toString()),ge,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(U,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,N)}async getWorkspaceFolder2(U,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,N)}async resolveWorkspaceFolder(U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(U)}getPath(){if(!this._actualWorkspace)return;const{folders:U}=this._actualWorkspace;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,N){let y,L="";if(typeof U=="string"?(y=i.URI.file(U),L=U):typeof U!="undefined"&&(y=U,L=U.fsPath),!y)return L;const W=this.getWorkspaceFolder(y,!0);if(!W)return L;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let x=(0,T.relativePath)(W.uri,y);return N&&W.name&&(x=`${W.name}/${x}`),x}trySetWorkspaceFolders(U){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:U,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:N,added:y,removed:L}=f.toExtHostWorkspace(U,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:y,removed:L}))}findFiles(U,N,y,L,W=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let x;if(N===null?x=!1:N&&(typeof N=="string"?x=N:x=N.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:q}=v(S.GlobPattern.from(U));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)($),(0,w.withUndefinedAsNull)(q),(0,w.withUndefinedAsNull)(x),(0,w.withUndefinedAsNull)(y),W).then(ie=>Array.isArray(ie)?ie.map(se=>i.URI.revive(se)):[])}async findTextInFiles(U,N,y,L,W=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),$=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:q,folder:ie}=v(S.GlobPattern.from(N.include)),se=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,X={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:$,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:q,excludePattern:se},ge=!1;if(this._activeSearchCallbacks[x]=be=>{if(ge)return;const pe=i.URI.revive(be.resource);be.results.forEach(fe=>{(0,F.resultIsMatch)(fe)?y({uri:pe,preview:{text:fe.preview.text,matches:(0,r.mapArrayOrNot)(fe.preview.matches,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.mapArrayOrNot)(fe.ranges,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):y({uri:pe,text:fe.text,lineNumber:fe.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(U,(0,w.withUndefinedAsNull)(ie),X,x,W);return delete this._activeSearchCallbacks[x],be||{}}catch(be){throw delete this._activeSearchCallbacks[x],be}}$handleTextSearchResult(U,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](U)}saveAll(U){return this._proxy.$saveAll(U)}resolveProxy(U){return this._proxy.$resolveProxy(U)}get trusted(){return this._trusted}requestWorkspaceTrust(U){return this._proxy.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=xe([$e(0,u.IExtHostRpcService),$e(1,b.IExtHostInitDataService),$e(2,C.IExtHostFileSystemInfo),$e(3,s.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function v(k){let U,N;return k&&(typeof k=="string"?U=k:(U=k.pattern,N=i.URI.revive(k.baseUri))),{includePattern:U,folder:N}}}),define(ye[32],_e([0,1,27,4,31,5,7,141,81,13,10,3,14,12,2]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(F,o){if(o){const n=o.split(".");let d=F;for(let p=0;d&&p<n.length;p++)d=d[n[p]];return d}}function g(F){return F instanceof l.URI}function M(F){return F&&F.uri instanceof l.URI&&F.languageId&&typeof F.languageId=="string"}function C(F){return F&&!F.uri&&F.languageId&&typeof F.languageId=="string"}function b(F){return F&&F.uri instanceof l.URI&&(!F.name||typeof F.name=="string")&&(!F.index||typeof F.index=="number")}function u(F){if(g(F))return{resource:F};if(M(F))return{resource:F.uri,overrideIdentifier:F.languageId};if(C(F))return{overrideIdentifier:F.languageId};if(b(F))return{resource:F.uri};if(F===null)return{resource:null}}let S=class{constructor(o,n,d){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=d,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new a(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(o,n))}};S=xe([$e(0,i.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,h.ILogService)],S),e.ExtHostConfiguration=S;class a{constructor(o,n,d,p){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=p,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const d={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,d))}getConfiguration(o,n,d){const p=u(n)||{},c=this._toReadonlyValue(o?s(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,p,d?.identifier);function m(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(E){return typeof s(c,E)!="undefined"},get:(E,v)=>{this._validateConfigurationAccess(o?`${o}.${E}`:E,p,d?.identifier);let k=s(c,E);if(typeof k=="undefined")k=v;else{let U;const N=(y,L)=>{let W;const x=()=>{U=U||(0,r.deepClone)(c),W=W||s(U,L)};return(0,T.isObject)(y)?new Proxy(y,{get:($,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return x(),()=>W;if(U)return W=W||s(U,L),W[q];const ie=$[q];return typeof q=="string"?N(ie,`${L}.${q}`):ie},set:($,q,ie)=>(x(),W&&(W[q]=ie),!0),deleteProperty:($,q)=>(x(),W&&delete W[q],!0),defineProperty:($,q,ie)=>(x(),W&&Object.defineProperty(W,q,ie),!0)}):y};k=N(k,E)}return k},update:(E,v,k,U)=>{E=o?`${o}.${E}`:E;const N=m(k);return v!==void 0?this._proxy.$updateConfigurationOption(N,E,v,p,U):this._proxy.$removeConfigurationOption(N,E,p,U)},inspect:E=>{E=o?`${o}.${E}`:E;const v=(0,r.deepClone)(this._configuration.inspect(E,p,this._extHostWorkspace.workspace));if(v)return{key:E,defaultValue:v.default?.value,globalValue:v.user?.value,workspaceValue:v.workspace?.value,workspaceFolderValue:v.workspaceFolder?.value,defaultLanguageValue:v.default?.override,globalLanguageValue:v.user?.override,workspaceLanguageValue:v.workspace?.override,workspaceFolderLanguageValue:v.workspaceFolder?.override,languageIds:v.overrideIdentifiers}}};return typeof c=="object"&&(0,r.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(o){const n=d=>(0,T.isObject)(d)?new Proxy(d,{get:(p,c)=>n(p[c]),set:(p,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(p,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(p,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return n(o)}_validateConfigurationAccess(o,n,d){const p=D.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),c=d?`[${d.value}] `:"";if(p===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const d=new I.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,c)=>d.affectsConfiguration(p,u(c))})}_toMap(o){return o.reduce((n,d)=>(n.set(d[0],d[1]),n),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[96],_e([0,1,2,10,4,5,7,31,49,32,20,40,14,28,3,11,23,12,68,160,15]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(L){function W($){if($!=null)return $}L.from=W;function x($){if($!=null)return $}L.to=x})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var F;(function(L){function W($){if($!=null)return $}L.from=W;function x($){if($!=null)return $}L.to=x})(F=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(L){function W($){if($!=null)return $}L.from=W;function x($){if($!=null)return $}L.to=x})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function W(q){if(q){const ie=q;return ie&&!!ie.process}else return!1}L.is=W;function x(q){if(q==null)return;const ie={process:q.process,args:q.args};return q.options&&(ie.options=o.from(q.options)),ie}L.from=x;function $(q){if(q!=null)return new P.ProcessExecution(q.process,q.args,q.options)}L.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(L){function W($){if($!=null)return $}L.from=W;function x($){if($!=null)return $}L.to=x})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(L){function W(q){if(q){const ie=q;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}L.is=W;function x(q){if(q==null)return;const ie={};return q.commandLine!==void 0?ie.commandLine=q.commandLine:(ie.command=q.command,ie.args=q.args),q.options&&(ie.options=d.from(q.options)),ie}L.from=x;function $(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new P.ShellExecution(q.commandLine,q.options):new P.ShellExecution(q.command,q.args?q.args:[],q.options)}L.to=$})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(L){function W(q){if(q){let ie=q;return ie&&ie.customExecution==="customExecution"}else return!1}L.is=W;function x(q){return{customExecution:"customExecution"}}L.from=x;function $(q,ie){return ie.get(q)}L.to=$})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(L){function W(x,$){let q;return x.scope!==void 0&&typeof x.scope!="number"?q=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===P.TaskScope.Workspace&&$&&$.workspaceFile?q=$.workspaceFile:q=b.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:q}}L.from=W})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(L){function W(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}L.from=W})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(L){function W(q,ie){if(q==null)return[];const se=[];for(let X of q){const ge=x(X,ie);ge&&se.push(ge)}return se}L.fromMany=W;function x(q,ie){if(q==null)return;let se;q.execution instanceof P.ProcessExecution?se=n.from(q.execution):q.execution instanceof P.ShellExecution?se=p.from(q.execution):q.execution&&q.execution instanceof P.CustomExecution&&(se=c.from(q.execution));const X=a.from(q.definition);let ge;return q.scope?typeof q.scope=="number"?ge=q.scope:ge=q.scope.uri:ge=P.TaskScope.Workspace,!X||!ge?void 0:{_id:q._id,definition:X,name:q.name,source:{extensionId:ie.identifier.value,label:q.source,scope:ge},execution:se,isBackground:q.isBackground,group:f.from(q.group),presentationOptions:F.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}L.from=x;async function $(q,ie,se){if(q==null)return;let X;n.is(q.execution)?X=n.to(q.execution):p.is(q.execution)?X=p.to(q.execution):c.is(q.execution)&&(X=c.to(q._id,se));const ge=a.to(q.definition);let be;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?be=q.source.scope:be=await ie.resolveWorkspaceFolder(r.URI.revive(q.source.scope)):be=P.TaskScope.Workspace),!ge||!be)return;const pe=new P.Task(ge,be,q.name,q.source.label,X,q.problemMatchers);return q.isBackground!==void 0&&(pe.isBackground=q.isBackground),q.group!==void 0&&(pe.group=P.TaskGroup.from(q.group._id),pe.group&&q.group.isDefault&&(pe.group=new P.TaskGroup(pe.group.id,pe.group.label),q.group.isDefault&&(pe.group.isDefault=q.group.isDefault))),q.presentationOptions&&(pe.presentationOptions=F.to(q.presentationOptions)),q._id&&(pe._id=q._id),q.detail&&(pe.detail=q.detail),pe}L.to=$})(E=e.TaskDTO||(e.TaskDTO={}));var v;(function(L){function W($){return $}L.from=W;function x($){if(!!$)return Object.assign(Object.create(null),$)}L.to=x})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(W,x,$){this._id=x,this._task=$,S.set(this,void 0),Xe(this,S,W,"f")}get task(){return this._task}terminate(){Ie(this,S,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}S=new WeakMap;var U;(function(L){function W(x){return{id:x._id,task:void 0}}L.from=W})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(W,x,$,q,ie,se,X,ge){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=q,this._configurationService=ie,this._terminalService=se,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=X,this._deprecationService=ge,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,x,$){if(!$)return new P.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:x,provider:$,extension:W}),this._proxy.$registerTaskProvider(q,x),new P.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(W,x){this._proxy.$registerTaskSystem(W,x)}fetchTasks(W){return this._proxy.$fetchTasks(v.from(W)).then(async x=>{const $=[];for(let q of x){const ie=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ie&&$.push(ie)}return $})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(x=>W.push(x)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,x,$){const q=this._providedCustomExecutions2.get(W.id);q&&(this._activeCustomExecutions2.set(W.id,q),this._terminalService.attachPtyToTerminal(x,await q.callback($))),this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const x=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const x=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:x,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const x=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:W.exitCode})}$provideTasks(W,x){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));const q=[],ie=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(se=>this.provideTasksInternal(x,q,$,se));return new Promise(se=>{ie.then(X=>{Promise.all(q).then(()=>{se(X)})})})}async $resolveTask(W,x){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));if(x.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${$.type}].`);const q=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ie=await $.provider.resolveTask(q,R.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,$);const se=E.from(ie,$.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(se.execution)&&await this.addCustomExecution(se,ie,!0),await this.resolveTaskInternal(se)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,x,$){const q=await this._proxy.$createTaskId(W);!$&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,x.execution)),this._providedCustomExecutions2.set(q,x.execution)}async getTaskExecution(W,x){if(typeof W=="string"){const ie=this._taskExecutionPromises.get(W);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let $=this._taskExecutionPromises.get(W.id);if($)return $;const q=new Promise((ie,se)=>{function X(ge,be,pe){pe?ie(new k(ge,be.id,pe)):se("Unexpected: Task does not exist.")}x?X(this,W,x):E.to(W.task,this._workspaceProvider,this._providedCustomExecutions2).then(ge=>X(this,W,ge))});return this._taskExecutionPromises.set(W.id,q),q.then(ie=>(this._taskExecutions.set(W.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(W,x){W._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let $=this._notProvidedCustomExecutions.values(),q=$.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=$.next()}};N=xe([$e(0,i.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,M.ILogService),$e(7,C.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let y=class extends N{constructor(W,x,$,q,ie,se,X,ge){super(W,x,$,q,ie,se,X,ge);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(W,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const $=E.from(x,W);if($===void 0)throw new Error("Task is not valid");if(c.is($.execution))await this.addCustomExecution($,x,!1);else throw new u.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution($),x);return this._proxy.$executeTask($).catch(ie=>{throw new Error(ie)}),q}provideTasksInternal(W,x,$,q){const ie=[];if(q)for(let se of q){this.checkDeprecation(se,$),(!se.definition||!W[se.definition.type])&&this._logService.warn(`The task [${se.source}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`);const X=E.from(se,$.extension);X&&c.is(X.execution)?(ie.push(X),x.push(this.addCustomExecution(X,se,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:$.extension}}async resolveTaskInternal(W){if(c.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,x,$){}};y=xe([$e(0,i.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,M.ILogService),$e(7,C.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(ye[211],_e([0,1,16,73,29,76,22,11,17,24,9,13,2,232,127,79,47,88,210,41]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(m,f,E,v){this.configurationService=m,this.workspaceContextService=f,this.editorGroupsService=E,this.pathService=v}text(m,f,E={}){m=this.getContentPattern(m,E);const v=this.configurationService.getValue(),k=f&&f.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(f?.map(g.toWorkspaceFolder),E),type:2,contentPattern:m,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:v.search.usePCRE2||k||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(m,f){const E=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const v={...m,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(m,f)&&(v.isCaseSensitive=!0),this.isMultiline(m)&&(v.isMultiline=!0),v}file(m,f={}){return{...this.commonQuery(m,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(m,f){return m?(m=Array.isArray(m)?m.map(n):n(m),f?this.parseSearchPaths(m):{pattern:a(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],f={}){const E=this.handleIncludeExclude(f.includePattern,f.expandPatterns),v=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),k=m.length>1,U=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,f,v)):m.map(L=>this.getFolderQueryForRoot(L,f,v,k))).filter(L=>!!L),N={_reason:f._reason,folderQueries:U,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:v.pattern,includePattern:E.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const W=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(q=>q.resource)))).filter($=>(0,b.pathIncludedInQuery)(N,$.fsPath)),x=this.commonQueryFromFileList(W);return{...N,...x}}const y=f.extraFileResources&&f.extraFileResources.filter(L=>(0,b.pathIncludedInQuery)(N,L.fsPath));return N.extraFileResources=y&&y.length?y:void 0,N}commonQueryFromFileList(m){const f=[],E=new P.ResourceMap,v={};let k=!1;return m.forEach(U=>{if(U.scheme===I.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(U)){const y=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:D.dirname(U.fsPath)});let L=E.get(y);L||(k=!0,L={folder:y,includePattern:{}},f.push(L),E.set(y,L));const W=D.relative(y.fsPath,U.fsPath);(0,w.assertIsDefined)(L.includePattern)[W.replace(/\\/g,"/")]=!0}else U.fsPath&&(k=!0,v[U.fsPath]=!0)}),{folderQueries:f,includePattern:v,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(m,f){if(f.isSmartCase){if(m.isRegExp){if(R.containsUppercaseCharacter(m.pattern,!0))return!0}else if(R.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,h.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const f=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),v=(Array.isArray(m)?m:F(m)).map(x=>{const $=this.pathService.resolvedUserHome;return $?(0,A.untildify)(x,$.scheme===I.Schemas.file?$.fsPath:$.path):x}),k=t.groupBy(v,x=>f(x)?"searchPaths":"exprSegments"),U=(k.exprSegments||[]).map(x=>R.rtrim(x,"/")).map(x=>R.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),N={},y=this.expandSearchPathPatterns(k.searchPaths||[]);y&&y.length&&(N.searchPaths=y);const L=r.flatten(U),W=a(...L);return W&&(N.pattern=W),N}getExcludesForFolder(m,f){return f.disregardExcludeSettings?void 0:(0,b.getExcludes)(m,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const f=r.flatten(m.map(v=>{let{pathPortion:k,globPortion:U}=S(v);U&&(U=d(U));const N=this.expandOneSearchPath(k);return r.flatten(N.map(y=>this.resolveOneSearchPathPattern(y,U)))})),E=new Map;return f.forEach(v=>{const k=v.searchPath.toString(),U=E.get(k);U?v.pattern&&(U.pattern=U.pattern||{},U.pattern[v.pattern]=!0):E.set(k,{searchPath:v.searchPath,pattern:v.pattern?a(v.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(m){if(D.isAbsolute(m)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==I.Schemas.file?[{searchPath:f[0].uri.with({path:m})}]:[{searchPath:i.URI.file(D.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=n(m),m.startsWith("../")||m===".."){const v=D.posix.resolve(f.path,m);return[{searchPath:f.with({path:v})}]}const E=d(m);return[{searchPath:f,pattern:E}]}else{if(m==="./"||m===".\\")return[];{const f=m.replace(/^\.[\/\\]/,""),v=this.workspaceContextService.getWorkspace().folders.map(k=>{const U=f.match(new RegExp(`^${R.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return U?{match:U,folder:k}:null}).filter(w.isDefined);if(v.length)return v.map(k=>{const U=k.match[1];return{searchPath:k.folder.uri,pattern:U&&d(U)}});{const k=m.match(/\.[\/\\](.+)[\/\\]?/),U=k?k[1]:m,N=l.localize(0,null,U);throw new Error(N)}}}}resolveOneSearchPathPattern(m,f){const E=m.pattern&&f?`${m.pattern}/${f}`:m.pattern||f,v=[{searchPath:m.searchPath,pattern:E}];return E&&!E.endsWith("**")&&v.push({searchPath:m.searchPath,pattern:E+"/**"}),v}getFolderQueryForSearchPath(m,f,E){const v=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(m.searchPath),f,E,!1);return v?{...v,includePattern:m.pattern}:null}getFolderQueryForRoot(m,f,E,v){let k;const U=i.URI.isUri(m)?m:m.uri;if(E.searchPaths){const x=E.searchPaths.filter($=>(0,T.isEqual)($.searchPath,U))[0];if(x&&!x.pattern)return null;x&&(k=x.pattern)}const N=this.configurationService.getValue({resource:U}),L={...this.getExcludesForFolder(N,f)||{},...k||{}},W=i.URI.isUri(m)?(0,T.basename)(m):m.name;return{folder:U,folderName:v?W:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!N.search.followSymlinks}}};u=xe([$e(0,s.IConfigurationService),$e(1,g.IWorkspaceContextService),$e(2,M.IEditorGroupsService),$e(3,C.IPathService)],u),e.QueryBuilder=u;function S(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const f=m.index,E=c.substr(0,f).match(/[/|\\][^/\\]*$/);if(E){let v=c.substr(0,E.index);return v.match(/[/\\]/)||(v+="/"),{pathPortion:v,globPortion:c.substr((E.index||0)+1)}}}return{pathPortion:c}}function a(...c){return c.length?c.reduce((m,f)=>(m[f]=!0,m),Object.create(null)):void 0}function F(c){return _.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function d(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(c,m){c=r.distinct(c,v=>v.toString());const f=[],E=m.getWorkspace();return c&&c.forEach(v=>{let k;if(m.getWorkbenchState()===2)k=(0,T.relativePath)(E.folders[0].uri,v),k&&k!=="."&&(k="./"+k);else{const U=m.getWorkspaceFolder(v);if(U){const N=U.name;if(E.folders.filter(L=>L.name===N).length===1){const L=(0,T.relativePath)(U.uri,v);L===""?k=`./${U.name}`:k=`./${U.name}/${L}`}else k=v.fsPath}}k&&f.push(k)}),f}e.resolveResourcesForSearchIncludes=p}),define(ye[212],_e([0,1,24,2,20,15,3,211,41,47]),function(ee,e,r,t,_,A,P,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function w(s,g){const M=g.activationEvents;if(!M)return Promise.resolve(void 0);const C=[],b=[];for(const n of M)if(/^workspaceContains:/.test(n)){const d=n.substr("workspaceContains:".length);d.indexOf("*")>=0||d.indexOf("?")>=0||s.forceUsingSearch?b.push(d):C.push(d)}if(C.length===0&&b.length===0)return Promise.resolve(void 0);let u;const S=new Promise((n,d)=>{u=n}),a=n=>u({activationEvent:n}),F=Promise.all(C.map(n=>i(s,n,a))).then(()=>{}),o=h(s,g.identifier,b,a);return Promise.all([F,o]).then(()=>{u(void 0)}),S}e.checkActivateWorkspaceContainsExtension=w;async function i(s,g,M){for(const C of s.folders)if(await s.exists(r.joinPath(t.URI.revive(C),g))){M(`workspaceContains:${g}`);return}}async function h(s,g,M,C){if(M.length===0)return Promise.resolve(void 0);const b=new _.CancellationTokenSource,u=s.checkExists(s.folders,M,b.token),S=setTimeout(async()=>{b.cancel(),s.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${M.join(",")}`)},R);let a=!1;try{a=await u}catch(F){A.isCancellationError(F)||A.onUnexpectedError(F)}b.dispose(),clearTimeout(S),a&&C(`workspaceContains:${M.join(",")}`)}function l(s,g,M,C){const b=s.get(P.IInstantiationService),u=s.get(D.ISearchService),a=b.createInstance(I.QueryBuilder).file(g.map(F=>(0,T.toWorkspaceFolder)(t.URI.revive(F))),{_reason:"checkExists",includePattern:M,exists:!0});return u.fileSearch(a,C).then(F=>!!F.limitHit,F=>A.isCancellationError(F)?!1:Promise.reject(F))}e.checkGlobFileExists=l});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[33],_e([0,1,119,17,72,24,10,6,22,2,12,5,32,171,70,31,26,169,15,25,21,146,7,82,3,28,71,14,59,63,40,4,212,67,148,11]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u,S,a,F,o,n,d,p,c,m,f,E,v,k,U,N){"use strict";var y,L,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let x=class Gi extends I.Disposable{constructor(X,ge,be,pe,fe,oe,Ee,Pe,Oe,je){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ge,this._extHostContext=be,this._initData=Ee,this._extHostWorkspace=pe,this._extHostConfiguration=fe,this._logService=oe,this._extHostTunnelService=Oe,this._extHostTerminalService=je,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new M.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=X.createChild(new c.ServiceCollection([l.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const st=new Set;this._initData.hostExtensions.forEach(et=>st.add(b.ExtensionIdentifier.toKey(et))),this._activator=this._register(new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(et,tt,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(et,C.transformErrorForSerialization(tt),z)},actualActivateExtension:async(et,tt)=>{if(st.has(b.ExtensionIdentifier.toKey(et)))return await this._mainThreadExtensionsProxy.$activateExtension(et,tt),new h.HostExtension;const z=this._registry.getExtensionDescription(et);return this._activateExtension(z,tt)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){C.onUnexpectedError(X)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(X)}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}_activateByEvent(X,ge){return this._activator.activateByEvent(X,ge)}_activateById(X,ge){return this._activator.activateById(X,ge)}activateByIdWithErrors(X,ge){return this._activateById(X,ge).then(()=>{const be=this._activator.getActivatedExtension(X);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._registry)}getExtensionExports(X){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(X).exports:null}async _realPathExtensionUri(X){if(X.scheme!==N.Schemas.file)return X;const ge=await this._hostUtils.realpath(X.fsPath);return T.URI.file(ge)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const X=D.TernarySearchTree.forUris(ge=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ge));for(const ge of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ge)){const be=await this._realPathExtensionUri(ge.extensionLocation);X.set(be,ge)}return X})()),this._extensionPathIndex}_deactivate(X){let ge=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return ge;const be=this._activator.getActivatedExtension(X);if(!be)return ge;try{typeof be.module.deactivate=="function"&&(ge=Promise.resolve(be.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(pe)}try{(0,I.dispose)(be.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(pe)}return ge}async _activateExtension(X,ge){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,ge).then(be=>{const pe=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,ge),this._logExtensionActivationTimes(X,ge,"success",pe),be},be=>{throw this._logExtensionActivationTimes(X,ge,"failure"),be})}_logExtensionActivationTimes(X,ge,be,pe){const fe=$(X,ge);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...pe||{},outcome:be})}_doActivateExtension(X,ge){const be=$(X,ge);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const pe=this._getEntryPoint(X);if(!pe)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${ge.startup}, activationEvent: '${ge.activationEvent}'${X.identifier.value!==ge.extensionId.value?`, root cause: ${ge.extensionId.value}`:""}`),this._logService.flush();const fe=new h.ExtensionActivationTimesBuilder(ge.startup);return Promise.all([this._loadCommonJSModule(X.identifier,(0,A.joinPath)(X.extensionLocation,pe),fe),this._loadExtensionContext(X)]).then(oe=>(_.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Gi._callActivate(this._logService,X.identifier,oe[0],oe[1],fe))).then(oe=>(_.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),oe))}_loadExtensionContext(X){const ge=new S.ExtensionGlobalMemento(X,this._storage),be=new S.ExtensionMemento(X.identifier.value,!1,this._storage),pe=new U.ExtensionSecrets(X,this._secretState),fe=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,oe=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ge.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Pe,Oe;const je=(0,g.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:ge,workspaceState:be,secrets:pe,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(st){return t.join(X.extensionLocation.fsPath,st)},get storagePath(){return Ee._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(X).fsPath},get logPath(){return t.join(Ee._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return T.URI.joinPath(Ee._initData.logsLocation,X.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(X)},get globalStorageUri(){return Ee._storagePath.globalValue(X)},get extensionMode(){return fe},get extension(){return Pe===void 0&&(Pe=new q(Ee,X.identifier,X,oe)),Pe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(X,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!Oe){if(!je)return;const st=E.Event.buffer(E.Event.fromDOMEventEmitter(je,"message",et=>et.data));je.start(),Oe={onDidReceiveMessage:st,postMessage:je.postMessage.bind(je)}}return Oe}})})}static _callActivate(X,ge,be,pe,fe){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,ge,be,pe,fe).then(oe=>new h.ActivatedExtension(!1,null,fe.build(),be,oe,pe.subscriptions))}static _callActivateOptional(X,ge,be,pe,fe){if(typeof be.activate=="function")try{fe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${ge.value}`);const oe=typeof global=="object"?global:self,Ee=be.activate.apply(oe,[pe]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Ee).then(Pe=>(fe.activateResolveStop(),Pe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(be)}_activateOneStartupFinished(X,ge){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:ge}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const X of this._registry.getAllExtensionDescriptions())if(X.activationEvents)for(const ge of X.activationEvents)ge==="onStartupFinished"&&this._activateOneStartupFinished(X,ge)}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ge=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(ge),pe=Promise.all([X,be]).then(()=>{});return Promise.race([pe,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ge=>this._handleWorkspaceContainsEagerExtension(X,ge))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,ge){if(this.isActivated(ge.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:X.map(oe=>oe.uri),forceUsingSearch:be,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,Ee,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,Ee,Pe)},fe=await(0,v.checkActivateWorkspaceContainsExtension)(pe,ge);if(!!fe)return this._activateById(ge.identifier,{startup:!0,extensionId:ge.identifier,activationEvent:fe.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:ge}=this._initData.environment;if(!X||!ge)throw new Error(r.localize(0,null));const be=await this._loadCommonJSModule(null,ge,new h.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(r.localize(1,null,ge.toString()));return new Promise((pe,fe)=>{const oe=(Oe,je)=>{Oe?fe(Oe):pe(typeof je=="number"&&je>0?1:0)},Ee=(0,A.originalFSPath)(ge),Pe=be.run(Ee,oe);Pe&&Pe.then&&Pe.then(()=>{pe(0)}).catch(Oe=>{fe(Oe instanceof Error&&Oe.stack?Oe.stack:String(Oe))})})}async $extensionTestsExit(X){this._logService.info(`Extension host terminating: test runner requested exit with code ${X}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${X}`),this._logService.flush(),this._hostUtils.exit(X)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,ge){return this._resolvers[X]=ge,(0,I.toDisposable)(()=>{delete this._resolvers[X]})}async _activateAndGetResolver(X){const ge=X.indexOf("+");if(ge===-1)throw new Error("Not an authority that can be resolved!");const be=X.substr(0,ge);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(X,ge){this._logService.info(`$resolveAuthority invoked for authority (${ie(X)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(X);if(!pe)return{type:"error",error:{code:F.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),_.mark(`code/extHost/willResolveAuthority/${be}`);const fe=await pe.resolve(X,{resolveAttempt:ge});_.mark(`code/extHost/didResolveAuthorityOK/${be}`);const oe={authority:X,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},Ee={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:Ee,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(_.mark(`code/extHost/didResolveAuthorityError/${be}`),fe instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(X,ge){this._logService.info(`$getCanonicalURI invoked for authority (${ie(X)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(X);if(!pe)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${be}`);const fe=T.URI.revive(ge);if(typeof pe.getCanonicalURI=="undefined")return fe;const oe=await(0,P.asPromise)(()=>pe.getCanonicalURI(fe));return oe||fe}$startExtensionHost(X){return this._registry.keepOnly(X),this._startExtensionHost()}$activateByEvent(X,ge){return ge===1?this._activateByEvent(X,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(X,!1))}async $activate(X,ge){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(X)?(await this._activateById(X,ge),!0):!1}async $deltaExtensions(X,ge){X.forEach(pe=>pe.extensionLocation=T.URI.revive(pe.extensionLocation));const be=await this.getExtensionPathIndex();return await Promise.all(ge.map(async pe=>{const fe=this._registry.getExtensionDescription(pe);fe&&be.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(X.map(async pe=>{const fe=await this._realPathExtensionUri(pe.extensionLocation);be.set(fe,pe)})),this._registry.deltaExtensions(X,ge),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){let ge=u.VSBuffer.alloc(X),be=Math.random()%256;for(let pe=0;pe<X;pe++)ge.writeUInt8(be,pe);return ge}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};x=xe([$e(0,o.IInstantiationService),$e(1,e.IHostUtils),$e(2,p.IExtHostRpcService),$e(3,s.IExtHostWorkspace),$e(4,i.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,d.IExtensionStoragePaths),$e(8,m.IExtHostTunnelService),$e(9,f.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function $(se,X){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class q{constructor(X,ge,be,pe){y.set(this,void 0),L.set(this,void 0),W.set(this,void 0),Xe(this,y,X,"f"),Xe(this,L,ge,"f"),Xe(this,W,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=pe}get isActive(){return Ie(this,y,"f").isActivated(Ie(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,y,"f").getExtensionExports(Ie(this,W,"f"))}activate(){return Ie(this,y,"f").activateByIdWithErrors(Ie(this,W,"f"),{startup:!1,extensionId:Ie(this,L,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,L=new WeakMap,W=new WeakMap;function ie(se){const X=se.indexOf("+");return X===-1?se:se.substring(0,X)}}),define(ye[97],_e([0,1,17,2,4,10,5,7,155,31,33,49,162,32,156,14,3,13,87,69]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let u=class{constructor(c,m,f,E,v,k){this._workspaceService=m,this._extensionService=f,this._editorsService=E,this._configurationService=v,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=c.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(N=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const f=c;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let E=`debug:${encodeURIComponent(f.path||"")}`,v="?";return m&&(E+=`${v}session=${encodeURIComponent(m.id)}`,v="&"),E+=`${v}ref=${f.sourceReference}`,t.URI.parse(E)}else{if(f.path)return t.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const f of c.getAllExtensionDescriptions())if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0)for(const v of E)(0,l.isDebuggerMainContribution)(v)&&m.push(v.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(v=>{const k=v.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,v),!0)});this.fireBreakpointChanges(m,[],[]);const f=[],E=new Map;for(const v of m)if(v instanceof I.SourceBreakpoint){let k=E.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},E.set(v.location.uri.toString(),k),f.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof I.FunctionBreakpoint&&f.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],m,[]);const f=m.filter(k=>k instanceof I.SourceBreakpoint).map(k=>k.id),E=m.filter(k=>k instanceof I.FunctionBreakpoint).map(k=>k.id),v=m.filter(k=>k instanceof I.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(f,E,v)}startDebugging(c,m,f){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,f){if(!m)return new I.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:E,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,f,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,E),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(c,m,f){if(!f)return new I.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:E,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,E),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new I.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:f,factory:m}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[v,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,k)}let f;const E=await this.getFolder(c);return E&&(f={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,m){const f=this,E=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const k=this.convertToDto(v),U=this.createDebugAdapter(k,E);if(!U)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const N=U;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(c,y),N.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const W=L,x={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(W.arguments.value);x.body={signature:$},N.sendResponse(x)}else throw new Error("no signer")}catch($){x.success=!1,x.message=$.message,N.sendResponse(x)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(L),L=(0,l.convertToVSCPaths)(L,!0),f._debugServiceProxy.$acceptDAMessage(c,L)}),N.onError(L=>{y&&y.onError&&y.onError(L),this._debugServiceProxy.$acceptDAError(c,L.name,L.message,L.stack)}),N.onExit(L=>{y&&y.onExit&&y.onExit((0,M.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,M.withNullAsUndefined)(L),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,m){m=(0,l.convertToDAPaths)(m,!1);const f=this._debugAdaptersTrackers.get(c);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(m);const E=this._debugAdapters.get(c);E&&E.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const f=this._debugAdapters.get(c);return this._debugAdapters.delete(c),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],f=[],E=[];if(c.added)for(const v of c.added){const k=v.id;if(k&&!this._breakpoints.has(k)){let U;if(v.type==="function")U=new I.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")U=new I.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const N=t.URI.revive(v.uri);U=new I.SourceBreakpoint(new I.Location(N,new I.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}U._id=k,this._breakpoints.set(k,U),m.push(U)}}if(c.removed)for(const v of c.removed){const k=this._breakpoints.get(v);k&&(this._breakpoints.delete(v),f.push(k))}if(c.changed){for(const v of c.changed)if(v.id){const k=this._breakpoints.get(v.id);if(k){if(k instanceof I.FunctionBreakpoint&&v.type==="function"){const U=k;U.enabled=v.enabled,U.condition=v.condition,U.hitCondition=v.hitCondition,U.logMessage=v.logMessage,U.functionName=v.functionName}else if(k instanceof I.SourceBreakpoint&&v.type==="source"){const U=k;U.enabled=v.enabled,U.condition=v.condition,U.hitCondition=v.hitCondition,U.logMessage=v.logMessage,U.location=new I.Location(t.URI.revive(v.uri),new I.Position(v.line,v.character))}E.push(k)}}}this.fireBreakpointChanges(m,f,E)}$provideDebugConfigurations(c,m,f){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(m);return E.provideDebugConfigurations(v,f)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(c,m,f,E){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(m);return v.resolveDebugConfiguration(k,f,E)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,f,E){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(m);return v.resolveDebugConfigurationWithSubstitutedVariables(k,f,E)})}async $provideDebugAdapter(c,m){const f=this.getAdapterDescriptorFactoryByHandle(c);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(m);return this.getAdapterDescriptor(f,E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const f=await this.getSession(c);f&&f._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const E={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(c){if(c instanceof I.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof I.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(f=>f.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(f=>f.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(f=>f.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const f=c.contributes.debuggers;if(f&&f.length>0){for(const E of f)if(E.label&&E.type&&E.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const f=c.configuration.type,E=this._trackerFactories.filter(v=>v.type===f||v.type==="*").map(v=>(0,A.asPromise)(()=>v.factory.createDebugAdapterTracker(c)).then(k=>k,k=>null));return Promise.race([Promise.all(E).then(v=>{const k=v.filter(U=>!!U);if(k.length>0)return new o(k)}),new Promise((v,k)=>{const U=setTimeout(()=>{clearTimeout(U),k(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(c,m){const f=m.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new I.DebugAdapterServer(f));if(c){const v=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,v))).then(k=>{if(k)return k})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,E))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,f){(c.length>0||m.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:f}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const f=await this.getFolder(c.folderUri),E=c.parent?this._debugSessions.get(c.parent):void 0;m=new S(this._debugServiceProxy,c.id,c.type,c.name,f,c.configuration,E),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};u=xe([$e(0,s.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,b.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class S{constructor(c,m,f,E,v,k,U){this._debugServiceProxy=c,this._id=m,this._type=f,this._name=E,this._workspaceFolder=v,this._configuration=k,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=S;class a{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class F extends i.AbstractVariableResolverService{constructor(c,m,f,E,v){function k(){if(m){const U=m.activeEditor();if(U)return U.document.uri;const N=E.tabs.filter(y=>y.isActive);if(N.length>0){const y=N[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:N[0].resource}}}super({getFolderUri:U=>{const N=c.filter(y=>y.name===U);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(U,N)=>f.getConfiguration(void 0,U).get(N),getAppRoot:()=>C.cwd(),getExecPath:()=>C.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=k();if(U)return r.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const U=k();if(U){const N=v.getWorkspaceFolder(U);if(N)return r.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(m){const U=m.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(m){const U=m.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(C.env))}}e.ExtHostVariableResolverService=F;class o{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(f=>f.onExit?f.onExit(c,m):void 0)}}class n extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends u{constructor(c,m,f,E,v,k){super(c,m,f,E,v,k)}createVariableResolver(c,m,f){return new F(c,m,f,this._editorTabs)}};d=xe([$e(0,s.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,b.IExtHostEditorTabs)],d),e.WorkerExtHostDebugService=d}),define(ye[213],_e([0,1,72,2,5,32,26,25,14,28,3,33,87,12,9]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(S,a,F,o,n,d,p){this._apiFactory=S,this._extensionRegistry=a,this._instaService=F,this._extHostConfiguration=o,this._extHostExtensionService=n,this._initData=d,this._logService=p,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const S=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new M(this._apiFactory,a,this._extensionRegistry,S,this._logService)),this.register(this._instaService.createInstance(C,a)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,a,this._initData.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(let a of S.nodeModuleName)this._factories.set(a,S);else this._factories.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this._alternatives.push(a=>S.alternativeModuleName(a))}};s=xe([$e(2,R.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,w.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,h.ILogService)],s),e.RequireInterceptor=s;let g=class Hi{constructor(S){if(S.environment.appRoot&&Hi.aliased.size){const a=(0,l.escapeRegExpCharacters)(this.forceForwardSlashes(S.environment.appRoot.fsPath)),F="[a-z0-9_.-]",o=`@${F}+\\/${F}+|${F}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${n}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(S){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(S));if(!a)return;const[,F,o,n]=a,d=Hi.aliased.get(o);if(d!==void 0)return console.warn(`${o} as been renamed to ${d}, please update your imports`),F+d+n}forceForwardSlashes(S){return S.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),g=xe([$e(0,T.IExtHostInitDataService)],g);class M{constructor(S,a,F,o,n){this._apiFactory=S,this._extensionPaths=a,this._extensionRegistry=F,this._configProvider=o,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(S,a){const F=this._extensionPaths.findSubstr(a);if(F){let o=this._extApiImpl.get(I.ExtensionIdentifier.toKey(F.identifier));return o||(o=this._apiFactory(F,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(F.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((n,d)=>o+=`	${d} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let C=class{constructor(S,a,F){this._extensionPaths=S,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(_.MainContext.MainThreadTelemetry);const{environment:o}=F,n=a.getProxy(_.MainContext.MainThreadKeytar);if(o.appRoot){let d=o.appRoot.fsPath;i.platform==="win32"&&(d=d.replace(/\\/g,"/")),d[d.length-1]==="/"&&(d=d.substr(0,d.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${d}/node_modules.asar/keytar`),this.alternativeNames.add(`${d}/node_modules/keytar`)}this._impl={getPassword:(d,p)=>n.$getPassword(d,p),setPassword:(d,p,c)=>n.$setPassword(d,p,c),deletePassword:(d,p)=>n.$deletePassword(d,p),findPassword:d=>n.$findPassword(d),findCredentials(d){return n.$findCredentials(d)}}}load(S,a){const F=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:F?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(S){const a=S.length;if(a<=7||!this.alternativeNames)return;const F=a-7;if((S.charAt(F)==="/"||S.charAt(F)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.alternativeNames.has(S)))return"keytar"}};C=xe([$e(1,D.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],C);let b=class{constructor(S,a,F){this._extensionPaths=S,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=F.getProxy(_.MainContext.MainThreadTelemetry);const o=F.getProxy(_.MainContext.MainThreadWindow);this._impl=(n,d)=>{const p=t.URI.parse(n);return d?this.callOriginal(n,d):p.scheme==="http"||p.scheme==="https"?o.$openUri(p,n,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this._appUriScheme?o.$openUri(p,n,{}):this.callOriginal(n,d)}}load(S,a,F){const o=this._extensionPaths.findSubstr(a);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=F(S),this._impl}callOriginal(S,a){return this.sendNoForwardTelemetry(),this._original(S,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=xe([$e(2,D.IExtHostRpcService)],b)}),define(ye[214],_e([0,1,10,15,72,6,2,5,207,12,44,59,28,136,14,64,33,40]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class C{constructor(u,S,a,F,o){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new D.RPCProtocol(u,null,F),S=C._transform(S,this._rpcProtocol);const n=new w.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:o}),n.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),n.set(s.IURITransformerService,new s.URITransformerService(F)),n.set(g.IHostUtils,a);const d=new h.InstantiationService(n,!0);this._disposables.add(d.invokeFunction(f=>f.get(M.IExtHostTerminalService))),this._disposables.add(d.invokeFunction(f=>f.get(g.IExtHostExtensionService))),this._logService=d.invokeFunction(f=>f.get(T.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=d.invokeFunction(f=>f.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(E,v)=>{let k="",U,N;for(const y of v)k+=`
	at ${y.toString()}`,N=y.getFileName(),!U&&N&&(U=f.findSubstr(P.URI.file(N)));return p.set(E,U),`${E.name||"Error"}: ${E.message||""}${k}`}});const c=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(f=>{const E=t.transformErrorForSerialization(f),v=p.get(f);v?c.$onExtensionRuntimeError(v.identifier,E):m.$onUnexpectedError(E)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),S]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(u,S){u.extensions.forEach(F=>F.extensionLocation=P.URI.revive(S.transformIncomingURIs(F.extensionLocation))),u.environment.appRoot=P.URI.revive(S.transformIncomingURIs(u.environment.appRoot));const a=u.environment.extensionDevelopmentLocationURI;return a&&(u.environment.extensionDevelopmentLocationURI=a.map(F=>P.URI.revive(S.transformIncomingURIs(F)))),u.environment.extensionTestsLocationURI=P.URI.revive(S.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(S.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(S.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=P.URI.revive(S.transformIncomingURIs(u.logsLocation)),u.logFile=P.URI.revive(S.transformIncomingURIs(u.logFile)),u.workspace=S.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=C}),define(ye[215],_e([0,1,17,20,43,29,24,188,41]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(i,h,l){this.config=i,this.provider=h,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&A.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&A.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const h=this.config.folderQueries||[];return new Promise((l,s)=>{const g=M=>{this.resultCount++,i(M)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(M=>{const C=M.toString(),b=r.basename(C);this.globalExcludePattern&&this.globalExcludePattern(C,b)||this.matchFile(g,{base:M,basename:b})}),Promise.all(h.map(M=>this.searchInFolder(M,g))).then(M=>{l({limitHit:this.isLimitHit,stats:M[0]||void 0})},M=>{s(new Error((0,_.toErrorMessage)(M)))})})}async searchInFolder(i,h){const l=new t.CancellationTokenSource,s=this.getSearchOptionsForFolder(i),g=this.initDirectoryTree(),M=new D.QueryGlobTester(this.config,i),C=!M.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(l),b=I.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,l.token),S=b.elapsed(),a=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(F=>{const o=r.posix.relative(i.folder.path,F.path);if(C){const n=r.basename(F.path);this.matchFile(h,{base:i.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(g,i.folder,o,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,M,h),{providerTime:S,postProcessTime:a.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(i){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:l,includes:h,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},h,l,s){if(l===this.filePattern){const M=r.basename(this.filePattern);this.matchFile(s,{base:h,relativePath:this.filePattern,basename:M})}function g(M){const C=r.basename(M),b=r.dirname(M);let u=i[b];u||(u=i[b]=[],g(b)),u.push({base:h,relativePath:M,basename:C})}g(l)}matchDirectoryTree({rootEntries:i,pathToEntries:h},l,s){const g=this,M=this.filePattern;function C(b){const u=A.hasSiblingFn(()=>b.map(S=>S.basename));for(let S=0,a=b.length;S<a;S++){const F=b[S],{relativePath:o,basename:n}=F;if(l.matchesExcludesSync(o,n,M!==n?u:void 0))continue;const d=h[o];if(d)C(d);else{if(o===M)continue;g.matchFile(s,F)}if(g.isLimitHit)break}}C(i)}matchFile(i,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(h))}}class R{constructor(){this.sessions=new Map}fileSearch(i,h,l,s){const g=this.getSessionTokenSource(i.cacheKey),M=new T(i,h,g&&g.token);let C=0;const b=u=>{C+=u.length,l(u.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(M,R.BATCH_SIZE,b,s).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:C,detailStats:u.stats}}))}clearCache(i){const h=this.getSessionTokenSource(i);h&&h.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:P.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,h,l,s){s.onCancellationRequested(()=>{i.cancel()});const g=C=>{C&&(M.push(C),h>0&&M.length>=h&&(l(M),M=[]))};let M=[];return i.search(g).then(C=>(M.length&&l(M),C),C=>(M.length&&l(M),Promise.reject(C)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[216],_e([0,1,16,10,20,43,29,11,17,24,13,2,41]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(u,S,a,F){this.query=u,this.provider=S,this.fileUtils=a,this.processType=F,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,S){const a=this.query.folderQueries||[],F=new _.CancellationTokenSource;return S.onCancellationRequested(()=>F.cancel()),new Promise((o,n)=>{this.collector=new s(u);let d=!1;const p=(c,m)=>{if(!d&&!this.isLimitHit){const f=this.resultSize(c);M(c)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,d=!0,F.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const E=this.resultSize(c);this.resultCount+=E,(E>0||!M(c))&&this.collector.add(c,m)}};Promise.all(a.map((c,m)=>this.searchInFolder(c,f=>p(f,m),F.token))).then(c=>{F.dispose(),this.collector.flush();const m=c.some(f=>!!f&&!!f.limitHit);o({limitHit:this.isLimitHit||m,messages:(0,r.flatten)(c.map(f=>f?.message?(0,R.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},c=>{F.dispose();const m=(0,A.toErrorMessage)(c);n(new Error(m))})})}resultSize(u){return M(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,S){const a=Array.isArray(u.ranges)?u.ranges:[u.ranges],F=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:a.slice(0,S),preview:{matches:F.slice(0,S),text:u.preview.text},uri:u.uri}}async searchInFolder(u,S,a){const F=new i.QueryGlobTester(this.query,u),o=[],n={report:c=>{if(!this.validateProviderResult(c))return;const m=u.folder.scheme===I.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(c.uri))):void 0,f=T.relativePath(u.folder,c.uri);if(f){const E=F.includedInQuery(f,D.basename(f),m);(0,t.isThenable)(E)?o.push(E.then(v=>{v&&S(c)})):E&&S(c)}}},d=this.getSearchOptionsForFolder(u),p=await this.provider.provideTextSearchResults(l(this.query.contentPattern),d,n,a);return o.length&&await Promise.all(o),p}validateProviderResult(u){if(M(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const S=(0,i.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),a=(0,i.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),F={folder:w.URI.from(u.folder),excludes:a,includes:S,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return F.usePCRE2=this.query.usePCRE2,F}}e.TextSearchManager=h;function l(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class s{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,S=>this.sendItems(S))}add(u,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!T.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(g(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=s;function g(b){return M(b)?{preview:{matches:(0,r.mapArrayOrNot)(b.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:b.preview.text},ranges:(0,r.mapArrayOrNot)(b.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function M(b){return!!b.preview}e.extensionResultIsMatch=M;class C{constructor(u,S){this.maxBatchSize=u,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,S){!u||this.addItemToBatch(u,S)}addItems(u,S){!u||this.addItemsToBatch(u,S)}addItemToBatch(u,S){this.batch.push(u),this.batchSize+=S,this.onUpdate()}addItemsToBatch(u,S){this.batch=this.batch.concat(u),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(ye[98],_e([0,1,6,5,3,215,14,64,12,2,216]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let w=class{constructor(s,g,M){this.extHostRpc=s,this._uriTransformer=g,this._logService=M,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,g){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const M=this._handlePool++;return this._textSearchProvider.set(M,g),this._proxy.$registerTextSearchProvider(M,this._transformScheme(s)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}registerFileSearchProvider(s,g){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const M=this._handlePool++;return this._fileSearchProvider.set(M,g),this._proxy.$registerFileSearchProvider(M,this._transformScheme(s)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}$provideFileSearchResults(s,g,M,C){const b=i(M),u=this._fileSearchProvider.get(s);if(u)return this._fileSearchManager.fileSearch(b,u,S=>{this._proxy.$handleFileMatch(s,g,S.map(a=>a.resource))},C);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,g,M,C){const b=this._textSearchProvider.get(s);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const u=i(M);return this.createTextSearchManager(u,b).search(a=>this._proxy.$handleTextMatch(s,g,a),C)}$enableExtensionHostSearch(){}createTextSearchManager(s,g){return new R.TextSearchManager(s,g,{readdir:M=>Promise.resolve([]),toCanonicalName:M=>M},"textSearchProvider")}};w=xe([$e(0,P.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,D.ILogService)],w),e.ExtHostSearch=w;function i(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(h),extraFileResources:l.extraFileResources&&l.extraFileResources.map(s=>T.URI.revive(s))}}e.reviveQuery=i;function h(l){return{...l,folder:T.URI.revive(l.folder)}}}),define(ye[217],_e([0,1,44,93,31,91,32,39,49,40,96,97,98,70,63,68,94,50,30,67,83,69,190,12,172]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u,S,a,F,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(F.ILoggerService,a.ExtHostLoggerService),(0,r.registerSingleton)(F.ILogService,o.ExtHostLogService),(0,r.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService),(0,r.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,r.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,r.registerSingleton)(M.IExtHostConsumerFileSystem,M.ExtHostConsumerFileSystem),(0,r.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService),(0,r.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,r.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(C.IExtHostFileSystemInfo,C.ExtHostFileSystemInfo),(0,r.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,r.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,r.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,r.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,r.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,r.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,r.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState),(0,r.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry),(0,r.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(ye[218],_e([0,1,44,3]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(P){if(P&&this._dragOperations.has(P)){const I=this._dragOperations.get(P);return this._dragOperations.delete(P),I}}addDragOperationTransfer(P,I){this._dragOperations.set(P,I)}}e.TreeViewsDragAndDropService=_,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(ye[219],_e([0,1,123,24,2,4,6,10,7,13,16,8,20,152,218]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(C,b){if((0,T.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let u;return Array.isArray(C.highlights)&&(u=C.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),u=u.length?u:void 0),{label:C.label,highlights:u}}}class g{constructor(b,u,S){this._proxy=b,this.commands=u,this.logService=S,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDragAndDropService;function a(F){return F&&F.$treeViewId&&F.$treeItemHandle}u.registerArgumentProcessor({processArgument:F=>a(F)?this.convertArgument(F):Array.isArray(F)&&F.length>0?F.map(o=>a(o)?this.convertArgument(o):o):F})}registerTreeDataProvider(b,u,S){const a=this.createTreeView(b,{treeDataProvider:u},S);return{dispose:()=>a.dispose()}}createTreeView(b,u,S){if(!u||!u.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=u.dragAndDropController?.supportedMimeTypes,F=!!u.dragAndDropController?.handleDrag,o=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!u.showCollapseAll,canSelectMany:!!u.canSelectMany,dragAndDropMimeTypes:a,hasHandleDrag:F}),n=this.createExtHostTreeView(b,u,S);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(d){n.message=d},get title(){return n.title},set title(d){n.title=d},get description(){return n.description},set description(d){n.description=d},reveal:(d,p)=>n.reveal(d,p),dispose:async()=>{await o,this.treeViews.delete(b),n.dispose()}}}$getChildren(b,u){const S=this.treeViews.get(b);return S?S.getChildren(u):Promise.reject(new Error((0,r.localize)(0,null,b)))}async $handleDrop(b,u,S,a,F,o){const n=this.treeViews.get(b);if(!n)return Promise.reject(new Error((0,r.localize)(1,null,b)));const d=h.TreeDataTransferConverter.toITreeDataTransfer(u);return F===b&&o&&await this.addAdditionalTransferItems(d,n,o,a),n.onDrop(d,S)}async addAdditionalTransferItems(b,u,S,a){const F=this.treeDragAndDropService.removeDragOperationTransfer(a);let o;if(F)o=await F;else if(a&&u.handleDrag){const n=u.handleDrag(S);this.treeDragAndDropService.addDragOperationTransfer(a,n),o=await n}return o&&o.forEach((n,d)=>{n&&b.set(d,n)}),b}async $handleDrag(b,u,S){const a=this.treeViews.get(b);if(!a)return Promise.reject(new Error((0,r.localize)(2,null,b)));const F=await this.addAdditionalTransferItems(new Map,a,u,S);if(!!F)return h.TreeDataTransferConverter.toTreeDataTransferDTO(F)}async $hasResolve(b){const u=this.treeViews.get(b);if(!u)throw new Error((0,r.localize)(3,null,b));return u.hasResolve}$resolve(b,u,S){const a=this.treeViews.get(b);if(!a)throw new Error((0,r.localize)(4,null,b));return a.resolveTreeItem(u,S)}$setExpanded(b,u,S){const a=this.treeViews.get(b);if(!a)throw new Error((0,r.localize)(5,null,b));a.setExpanded(u,S)}$setSelection(b,u){const S=this.treeViews.get(b);if(!S)throw new Error((0,r.localize)(6,null,b));S.setSelection(u)}$setVisible(b,u){const S=this.treeViews.get(b);if(!S)throw new Error((0,r.localize)(7,null,b));S.setVisible(u)}createExtHostTreeView(b,u,S){const a=new M(b,u,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(b,a),a}convertArgument(b){const u=this.treeViews.get(b.$treeViewId);return u?u.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=g;class M extends P.Disposable{constructor(b,u,S,a,F,o){super();if(this.viewId=b,this.proxy=S,this.commands=a,this.logService=F,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,o.contributes&&o.contributes.views)for(const p in o.contributes.views)for(const c of o.contributes.views[p])c.id===b&&(this._title=c.name);this.dataProvider=u.treeDataProvider,this.dndController=u.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let n,d;this._register(A.Event.debounce(this._onDidChangeData.event,(p,c)=>(p||(p={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?p.elements.push(...c.element):p.elements.push(c.element)),c.message&&(p.message=!0),p),200,!0)(({message:p,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return n=null,this.refresh(c).then(()=>m())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,T.isUndefinedOrNull)(b))}async getChildren(b){const u=b?this.getExtensionElement(b):void 0;if(b&&!u)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(b);return S||(S=await this.fetchChildrenNodes(u)),S?S.map(a=>a.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,u){u=u||{select:!0,focus:!1};const S=(0,T.isUndefinedOrNull)(u.select)?!0:u.select,a=(0,T.isUndefinedOrNull)(u.focus)?!1:u.focus,F=(0,T.isUndefinedOrNull)(u.expand)?!1:u.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(o=>this.resolveTreeNode(b,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(d=>d.item)},{select:S,focus:a,expand:F})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:a,expand:F})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,u){const S=this.getExtensionElement(b);S&&(u?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(b){(0,R.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(b){const u=[];for(const S of b){const a=this.getExtensionElement(S);a&&u.push(a)}if(!(!this.dndController?.handleDrag||u.length===0))return this.dndController.handleDrag(u)}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(b,u){const S=this.getExtensionElement(u);if(!!S)return(0,I.asPromise)(()=>this.dndController?.handleDrop(b,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,u){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(b);if(S){const a=this.nodes.get(S);if(a){const F=await this.dataProvider.resolveTreeItem(a.extensionItem,S,u)??a.extensionItem;return a.item.tooltip=this.getTooltip(F.tooltip),a.item.command=this.getCommand(a.disposableStore,F.command),a.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(u=>u?this.resolveUnknownParentChain(u).then(S=>this.resolveTreeNode(u,S[S.length-1]).then(a=>(S.push(a),S))):Promise.resolve([]))}resolveParent(b){const u=this.nodes.get(b);return u?Promise.resolve(u.parent?this.elements.get(u.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,u){const S=this.nodes.get(b);return S?Promise.resolve(S):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(a=>this.createHandle(b,a,u,!0)).then(a=>this.getChildren(u?u.item.handle:void 0).then(()=>{const F=this.getExtensionElement(a);if(F){const o=this.nodes.get(F);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(b){if(b){let u;if(typeof b=="string"){const S=this.getExtensionElement(b);u=S?this.nodes.get(S):void 0}else u=b;return u&&u.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const u=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=b?this.nodes.get(b):void 0,a=await this.dataProvider.getChildren(b);if(u.token.isCancellationRequested)return;const F=await Promise.all((0,R.coalesce)(a||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!u.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,S):null}));return u.token.isCancellationRequested?void 0:(0,R.coalesce)(F)}finally{u.dispose()}}refresh(b){if(b.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(b);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const u=new Set,S=b.map(F=>this.nodes.get(F));for(const F of S)if(F&&!u.has(F.item.handle)){let o=F;for(;o&&o.parent&&S.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&u.add(F.item.handle)}const a=[];return u.forEach(F=>{const o=this.elements.get(F);if(o){const n=this.nodes.get(o);n&&(!n.parent||!u.has(n.parent.item.handle))&&a.push(F)}}),a}refreshHandles(b){const u={};return Promise.all(b.map(S=>this.refreshNode(S).then(a=>{a&&(u[S]=a.item)}))).then(()=>Object.keys(u).length?this.proxy.$refresh(this.viewId,u):void 0)}refreshNode(b){const u=this.getExtensionElement(b);if(u){const S=this.nodes.get(u);if(S)return this.clearChildren(u),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(a=>{if(a){const F=this.createTreeNode(u,a,S.parent);return this.updateNodeCache(u,F,S,S.parent),S.dispose(),F}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,u,S){const a=this.createTreeNode(b,u,S);if(u.id&&this.elements.has(a.item.handle))throw new Error((0,r.localize)(8,null,u.id));return this.addNodeToCache(b,a),this.addNodeToParentCache(a,S),a}getTooltip(b){return D.MarkdownString.isMarkdownString(b)?w.MarkdownString.from(b):b}getCommand(b,u){return u?this.commands.toInternal(u,b):void 0}createTreeNode(b,u,S){const a=new P.DisposableStore,F=this.createHandle(b,u,S),o=this.getLightIconPath(u);return{item:{handle:F,parentHandle:S?S.item.handle:void 0,label:s(u.label,this.extension),description:u.description,resourceUri:u.resourceUri,tooltip:this.getTooltip(u.tooltip),command:this.getCommand(a,u.command),contextValue:u.contextValue,icon:o,iconDark:this.getDarkIconPath(u)||o,themeIcon:this.getThemeIcon(u),collapsibleState:(0,T.isUndefinedOrNull)(u.collapsibleState)?D.TreeItemCollapsibleState.None:u.collapsibleState,accessibilityInformation:u.accessibilityInformation},extensionItem:u,parent:S,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(b){return b.iconPath instanceof D.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:u,label:S,resourceUri:a},F,o){if(u)return`${M.ID_HANDLE_PREFIX}/${u}`;const n=s(S,this.extension),d=F?F.item.handle:M.LABEL_HANDLE_PREFIX;let p=n?n.label:a?(0,t.basename)(a):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const c=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,m=this.getChildrenNodes(F)||[];let f,E=0;do{if(f=`${d}/${E}:${p}`,o||!this.elements.has(f)||c===f)break;E++}while(E<=m.length);return f}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon))return typeof b.iconPath=="string"||_.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return _.URI.isUri(b)?b:_.URI.file(b)}addNodeToCache(b,u){this.elements.set(u.item.handle,b),this.nodes.set(b,u)}updateNodeCache(b,u,S,a){this.elements.delete(u.item.handle),this.nodes.delete(b),u.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(b,u);const F=this.getChildrenNodes(a)||[],o=F.filter(n=>n.item.handle===S.item.handle)[0];o&&F.splice(F.indexOf(o),1,u)}addNodeToParentCache(b,u){u?(u.children||(u.children=[]),u.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const u=this.nodes.get(b);if(u){if(u.children)for(const S of u.children){const a=this.elements.get(S.item.handle);a&&this.clear(a)}u.children=void 0}}else this.clearAll()}clear(b){const u=this.nodes.get(b);if(u){if(u.children)for(const S of u.children){const a=this.elements.get(S.item.handle);a&&this.clear(a)}this.nodes.delete(b),this.elements.delete(u.item.handle),u.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}M.LABEL_HANDLE_PREFIX="0",M.ID_HANDLE_PREFIX="1"}),define(ye[220],_e([0,1,20,15,4,34,2,112,233,106,56,46,5,177,176,39,178,32,179,180,181,164,182,49,33,183,184,187,189,191,93,166,196,197,198,70,40,200,219,8,7,203,51,94,31,73,153,186,60,91,96,97,98,12,64,14,28,192,150,63,68,174,201,149,71,50,206,204,205,175,30,199,202,67,69,83,194,95,195,11,138,193,147,185,6,26]),function(ee,e,r,t,_,A,P,I,D,T,R,w,i,h,l,s,g,M,C,b,u,S,a,F,o,n,d,p,c,m,f,E,v,k,U,N,y,L,W,x,$,q,ie,se,X,ge,be,pe,fe,oe,Ee,Pe,Oe,je,st,et,tt,z,K,H,j,Y,ae,Se,Ue,Ve,Qe,nt,rt,Je,Ze,pt,Fe,At,G,Q,de,Be,qe,lt,ht,Ye,kt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function te(ne){const ue=ne.get(tt.IExtHostInitDataService),me=ne.get(Ze.IExtHostFileSystemInfo),Te=ne.get(Ve.IExtHostConsumerFileSystem),ze=ne.get(o.IExtHostExtensionService),Le=ne.get(X.IExtHostWorkspace),Ge=ne.get(Q.IExtHostTelemetry),ot=ne.get(M.IExtHostConfiguration),at=ne.get(st.IURITransformerService),Ne=ne.get(et.IExtHostRpcService),ce=ne.get(N.IExtHostStorage),he=ne.get(Ue.IExtensionStoragePaths),re=ne.get(je.ILoggerService),V=ne.get(je.ILogService),we=ne.get(H.IExtHostTunnelService),Re=ne.get(j.IExtHostApiDeprecationService),We=ne.get(se.IExtHostWindow),He=ne.get(At.IExtHostSecretState),mt=ne.get(G.IExtHostEditorTabs);Ne.set(i.ExtHostContext.ExtHostFileSystemInfo,me),Ne.set(i.ExtHostContext.ExtHostLogLevelServiceShape,re),Ne.set(i.ExtHostContext.ExtHostWorkspace,Le),Ne.set(i.ExtHostContext.ExtHostConfiguration,ot),Ne.set(i.ExtHostContext.ExtHostExtensionService,ze),Ne.set(i.ExtHostContext.ExtHostStorage,ce),Ne.set(i.ExtHostContext.ExtHostTunnelService,we),Ne.set(i.ExtHostContext.ExtHostWindow,We),Ne.set(i.ExtHostContext.ExtHostSecretState,He),Ne.set(i.ExtHostContext.ExtHostTelemetry,Ge),Ne.set(i.ExtHostContext.ExtHostEditorTabs,mt);const Et=Ne.set(i.ExtHostContext.ExtHostDecorations,ne.get(oe.IExtHostDecorations)),_t=Ne.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(F.IExtHostDocumentsAndEditors)),dt=Ne.set(i.ExtHostContext.ExtHostCommands,ne.get(s.IExtHostCommands)),vt=Ne.set(i.ExtHostContext.ExtHostTerminalService,ne.get(y.IExtHostTerminalService)),bt=Ne.set(i.ExtHostContext.ExtHostDebugService,ne.get(Pe.IExtHostDebugService)),Ut=Ne.set(i.ExtHostContext.ExtHostSearch,ne.get(Oe.IExtHostSearch)),It=Ne.set(i.ExtHostContext.ExtHostTask,ne.get(Ee.IExtHostTask)),Mt=Ne.set(i.ExtHostContext.ExtHostOutputService,ne.get(f.IExtHostOutputService)),Dt=Ne.set(i.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Ne)),St=Ne.set(i.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ne,_t)),Qt=Ne.set(i.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Ne,_t,V)),Vt=Ne.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(V,St,Ne.getProxy(i.MainContext.MainThreadBulkEdits))),wt=Ne.set(i.ExtHostContext.ExtHostNotebook,new z.ExtHostNotebookController(Ne,dt,_t,St,he)),Yt=Ne.set(i.ExtHostContext.ExtHostNotebookDocuments,new kt.ExtHostNotebookDocuments(V,wt)),qt=Ne.set(i.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(V,Ne,wt)),Xt=Ne.set(i.ExtHostContext.ExtHostNotebookKernels,new de.ExtHostNotebookKernels(Ne,ue,wt,dt,V)),ai=Ne.set(i.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(Ne,wt)),Rt=Ne.set(i.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ne,_t)),Jt=Ne.set(i.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(Ne.getProxy(i.MainContext.MainThreadTreeViews),dt,V)),li=Ne.set(i.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(Ne.getProxy(i.MainContext.MainThreadEditorInsets),Rt,ue)),jt=Ne.set(i.ExtHostContext.ExtHostDiagnostics,new C.ExtHostDiagnostics(Ne,V,me)),Zt=Ne.set(i.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ne,St,dt.converter,at)),gt=Ne.set(i.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(Ne,at,St,dt,jt,V,Re)),ci=Ne.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ne,gt)),Lt=Ne.set(i.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Ne,V,_t)),$t=Ne.set(i.ExtHostContext.ExtHostQuickOpen,(0,v.createExtHostQuickOpen)(Ne,Le,dt)),vi=Ne.set(i.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Ne,dt,V)),ui=Ne.set(i.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Ne,dt,St)),ei=Ne.set(i.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ne.getProxy(i.MainContext.MainThreadProgress))),Ci=Ne.set(i.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(Ne)),bi=Ne.set(i.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Ne)),ti=Ne.set(i.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ne)),Di=Ne.set(i.ExtHostContext.ExtHostTimeline,new ae.ExtHostTimeline(Ne,dt)),di=Ne.set(i.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ne,{remote:ue.remote},Le,V,Re)),Gt=Ne.set(i.ExtHostContext.ExtHostWebviewPanels,new rt.ExtHostWebviewPanels(Ne,di,Le)),hi=Ne.set(i.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(Ne,St,he,di,Gt)),ki=Ne.set(i.ExtHostContext.ExtHostWebviewViews,new Qe.ExtHostWebviewViews(Ne,di)),Kt=Ne.set(i.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(Ne,dt)),Ii=Ne.set(i.ExtHostContext.ExtHostUriOpeners,new Fe.ExtHostUriOpeners(Ne));Ne.set(i.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Ne,wt,_t,dt));const Pi=(0,ge.values)(i.ExtHostContext);Ne.assertRegistered(Pi);const ii=new Je.ExtHostBulkEdits(Ne,_t),Ti=new l.ExtHostClipboard(Ne),fi=new m.ExtHostMessageService(Ne,V),wi=new b.ExtHostDialogs(Ne),ni=new U.ExtHostStatusBar(Ne,dt.converter);return h.ExtHostApiCommands.register(dt),function(Me,zt,Bt){const yt=function(){let J=!Me.isUnderDevelopment;function le(){J||(V.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")le();else{const Ct=ut;typeof Ct.scheme=="undefined"&&le(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ut}}(),Ot={getSession(J,le,ke){return ti.getSession(Me,J,le,ke)},async hasSession(J,le){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,J,le,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(J,le,ke,ut){return ti.registerAuthenticationProvider(J,le,ke,ut)}},ri={registerCommand(J,le,ke){return dt.registerCommand(!0,J,le,ke,void 0,Me)},registerTextEditorCommand(J,le,ke){return dt.registerCommand(!0,J,(...ut)=>{const Ct=Rt.getActiveTextEditor();if(!Ct){V.warn("Cannot execute "+J+" because there is no active text editor.");return}return Ct.edit(Tt=>{le.apply(ke,[Ct,Tt,...ut])}).then(Tt=>{Tt||V.warn("Edits from command "+J+" were not applied.")},Tt=>{V.warn("An error occurred while running command "+J,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(J,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),dt.registerCommand(!0,J,async(...ut)=>{const Ct=_t.activeEditor(!0);if(!Ct){V.warn("Cannot execute "+J+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Ct.id);le.apply(ke,[Tt,...ut])},void 0,void 0,Me)),executeCommand(J,...le){return dt.executeCommand(J,...le)},getCommands(J=!1){return dt.getCommands(J)}},Ei={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ge.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ge.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,le){return We.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Dt.createAppUri(J);try{return await We.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(le){if((0,ht.matchesScheme)(J,lt.Schemas.http)||(0,ht.matchesScheme)(J,lt.Schemas.https))return J;throw le}},get remoteName(){return(0,fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(Ei);const yi=ue.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ai={createTestController(J,le,ke){return ke&&(0,ve.checkProposedApiEnabled)(Me,"testRefresh"),Kt.createTestController(J,le,ke)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.createTestObserver()},runTests(J){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.runTests(J)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.results}},Ri={getExtension(J){const le=zt.getExtensionDescription(J);if(le)return new o.Extension(ze,Me.identifier,le,yi)},get all(){return zt.getAllExtensionDescriptions().map(J=>new o.Extension(ze,Me.identifier,J,yi))},get onDidChange(){return zt.onDidChange}},Fi={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Me.identifier,J)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(J,le){return Zt.changeLanguage(J.uri,le)},match(J,le){return(0,R.score)(x.LanguageSelector.from(J),le.uri,le.languageId,!0)},registerCodeActionsProvider(J,le,ke){return gt.registerCodeActionProvider(Me,yt(J),le,ke)},registerCodeLensProvider(J,le){return gt.registerCodeLensProvider(Me,yt(J),le)},registerDefinitionProvider(J,le){return gt.registerDefinitionProvider(Me,yt(J),le)},registerDeclarationProvider(J,le){return gt.registerDeclarationProvider(Me,yt(J),le)},registerImplementationProvider(J,le){return gt.registerImplementationProvider(Me,yt(J),le)},registerTypeDefinitionProvider(J,le){return gt.registerTypeDefinitionProvider(Me,yt(J),le)},registerHoverProvider(J,le){return gt.registerHoverProvider(Me,yt(J),le,Me.identifier)},registerEvaluatableExpressionProvider(J,le){return gt.registerEvaluatableExpressionProvider(Me,yt(J),le,Me.identifier)},registerInlineValuesProvider(J,le){return gt.registerInlineValuesProvider(Me,yt(J),le,Me.identifier)},registerDocumentHighlightProvider(J,le){return gt.registerDocumentHighlightProvider(Me,yt(J),le)},registerLinkedEditingRangeProvider(J,le){return gt.registerLinkedEditingRangeProvider(Me,yt(J),le)},registerReferenceProvider(J,le){return gt.registerReferenceProvider(Me,yt(J),le)},registerRenameProvider(J,le){return gt.registerRenameProvider(Me,yt(J),le)},registerDocumentSymbolProvider(J,le,ke){return gt.registerDocumentSymbolProvider(Me,yt(J),le,ke)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Me,J)},registerDocumentFormattingEditProvider(J,le){return gt.registerDocumentFormattingEditProvider(Me,yt(J),le)},registerDocumentRangeFormattingEditProvider(J,le){return gt.registerDocumentRangeFormattingEditProvider(Me,yt(J),le)},registerOnTypeFormattingEditProvider(J,le,ke,...ut){return gt.registerOnTypeFormattingEditProvider(Me,yt(J),le,[ke].concat(ut))},registerDocumentSemanticTokensProvider(J,le,ke){return gt.registerDocumentSemanticTokensProvider(Me,yt(J),le,ke)},registerDocumentRangeSemanticTokensProvider(J,le,ke){return gt.registerDocumentRangeSemanticTokensProvider(Me,yt(J),le,ke)},registerSignatureHelpProvider(J,le,ke,...ut){return typeof ke=="object"?gt.registerSignatureHelpProvider(Me,yt(J),le,ke):gt.registerSignatureHelpProvider(Me,yt(J),le,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(J,le,...ke){return gt.registerCompletionItemProvider(Me,yt(J),le,ke)},registerInlineCompletionItemProvider(J,le){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),gt.registerInlineCompletionsProvider(Me,yt(J),le)},registerDocumentLinkProvider(J,le){return gt.registerDocumentLinkProvider(Me,yt(J),le)},registerColorProvider(J,le){return gt.registerColorProvider(Me,yt(J),le)},registerFoldingRangeProvider(J,le){return gt.registerFoldingRangeProvider(Me,yt(J),le)},registerSelectionRangeProvider(J,le){return gt.registerSelectionRangeProvider(Me,J,le)},registerCallHierarchyProvider(J,le){return gt.registerCallHierarchyProvider(Me,J,le)},registerTypeHierarchyProvider(J,le){return gt.registerTypeHierarchyProvider(Me,J,le)},setLanguageConfiguration:(J,le)=>gt.setLanguageConfiguration(Me,J,le),getTokenInformationAtPosition(J,le){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Zt.tokenAtPosition(J,le)},registerInlayHintsProvider(J,le){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),gt.registerInlayHintsProvider(Me,J,le)},createLanguageStatusItem(J,le){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Zt.createLanguageStatusItem(Me,J,le)}},Mi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,le,ke){const ut=await(P.URI.isUri(J)?Promise.resolve(_i.openTextDocument(J)):Promise.resolve(J));return Rt.showTextDocument(ut,le,ke)},createTextEditorDecorationType(J){return Rt.createTextEditorDecorationType(Me,J)},onDidChangeActiveTextEditor(J,le,ke){return Rt.onDidChangeActiveTextEditor(J,le,ke)},onDidChangeVisibleTextEditors(J,le,ke){return Rt.onDidChangeVisibleTextEditors(J,le,ke)},onDidChangeTextEditorSelection(J,le,ke){return Rt.onDidChangeTextEditorSelection(J,le,ke)},onDidChangeTextEditorOptions(J,le,ke){return Rt.onDidChangeTextEditorOptions(J,le,ke)},onDidChangeTextEditorVisibleRanges(J,le,ke){return Rt.onDidChangeTextEditorVisibleRanges(J,le,ke)},onDidChangeTextEditorViewColumn(J,le,ke){return Rt.onDidChangeTextEditorViewColumn(J,le,ke)},onDidCloseTerminal(J,le,ke){return vt.onDidCloseTerminal(J,le,ke)},onDidOpenTerminal(J,le,ke){return vt.onDidOpenTerminal(J,le,ke)},onDidChangeActiveTerminal(J,le,ke){return vt.onDidChangeActiveTerminal(J,le,ke)},onDidChangeTerminalDimensions(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),vt.onDidChangeTerminalDimensions(J,le,ke)},onDidChangeTerminalState(J,le,ke){return vt.onDidChangeTerminalState(J,le,ke)},onDidWriteTerminalData(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(J,le,ke)},get state(){return We.state},onDidChangeWindowState(J,le,ke){return We.onDidChangeWindowState(J,le,ke)},showInformationMessage(J,...le){return fi.showMessage(Me,A.default.Info,J,le[0],le.slice(1))},showWarningMessage(J,...le){return fi.showMessage(Me,A.default.Warning,J,le[0],le.slice(1))},showErrorMessage(J,...le){return fi.showMessage(Me,A.default.Error,J,le[0],le.slice(1))},showQuickPick(J,le,ke){return Array.isArray(J)&&J.some(ut=>ut.kind===$.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),$t.showQuickPick(J,le,ke)},showWorkspaceFolderPick(J){return $t.showWorkspaceFolderPick(J)},showInputBox(J,le){return $t.showInput(J,le)},showOpenDialog(J){return wi.showOpenDialog(J)},showSaveDialog(J){return wi.showSaveDialog(J)},createStatusBarItem(J,le,ke){let ut,Ct,Tt;return typeof J=="string"?(ut=J,Ct=le,Tt=ke):(Ct=J,Tt=le),ni.createStatusBarEntry(Me,ut,Ct,Tt)},setStatusBarMessage(J,le){return ni.setStatusBarMessage(J,le)},withScmProgress(J){return Re.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ei.withProgress(Me,{location:$.ProgressLocation.SourceControl},(le,ke)=>J({report(ut){}}))},withProgress(J,le){return ei.withProgress(Me,J,le)},createOutputChannel(J){return Mt.createOutputChannel(J,Me)},createWebviewPanel(J,le,ke,ut){return Gt.createWebviewPanel(Me,J,le,ke,ut)},createWebviewTextEditorInset(J,le,ke,ut){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),li.createWebviewEditorInset(J,le,ke,ut,Me)},createTerminal(J,le,ke){return typeof J=="object"?"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J):vt.createTerminal(J,le,ke)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,le){return vt.registerProfileProvider(Me,J,le)},registerTreeDataProvider(J,le){return Jt.registerTreeDataProvider(J,le,Me)},createTreeView(J,le){return Jt.createTreeView(J,le,Me)},registerWebviewPanelSerializer:(J,le)=>Gt.registerWebviewPanelSerializer(Me,J,le),registerCustomEditorProvider:(J,le,ke={})=>hi.registerCustomEditorProvider(Me,J,le,ke),registerFileDecorationProvider(J){return Et.registerFileDecorationProvider(J,Me.identifier)},registerUriHandler(J){return Dt.registerUriHandler(Me.identifier,J)},createQuickPick(){return $t.createQuickPick(Me)},createInputBox(){return $t.createInputBox(Me.identifier)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(J,le,ke){return bi.onDidChangeActiveColorTheme(J,le,ke)},registerWebviewViewProvider(J,le,ke){return ki.registerWebviewViewProvider(Me,J,le,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(J,le,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(J,le,ke)},onDidChangeNotebookEditorVisibleRanges(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(J,le,ke)},showNotebookDocument(J,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.showNotebookDocument(J,le)},registerExternalUriOpener(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Ii.registerExternalUriOpener(Me.identifier,J,le,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),p.InlineCompletionController.get(J)}},_i={get rootPath(){return Re.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(J){throw t.readonly()},getWorkspaceFolder(J){return Le.getWorkspaceFolder(J)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(J){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(J){throw t.readonly()},updateWorkspaceFolders:(J,le,...ke)=>Le.updateWorkspaceFolders(Me,J,le||0,...ke),onDidChangeWorkspaceFolders:function(J,le,ke){return Le.onDidChangeWorkspace(J,le,ke)},asRelativePath:(J,le)=>Le.getRelativePath(J,le),findFiles:(J,le,ke,ut)=>Le.findFiles(J,le,ke,Me.identifier,ut),findTextInFiles:(J,le,ke,ut)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let Ct,Tt;return typeof le=="object"?(Ct=le,Tt=ke):(Ct={},Tt=le,ut=ke),Le.findTextInFiles(J,Ct||{},Tt,Me.identifier,ut)},saveAll:J=>Le.saveAll(J),applyEdit(J){return ii.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,le,ke,ut)=>Lt.createFileSystemWatcher(Le,Me,J,le,ke,ut),get textDocuments(){return St.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw t.readonly()},openTextDocument(J){let le;const ke=J;if(typeof J=="string")le=Promise.resolve(P.URI.file(J));else if(P.URI.isUri(J))le=Promise.resolve(J);else if(!ke||typeof ke=="object")le=St.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(J,le,ke)=>St.onDidAddDocument(J,le,ke),onDidCloseTextDocument:(J,le,ke)=>St.onDidRemoveDocument(J,le,ke),onDidChangeTextDocument:(J,le,ke)=>St.onDidChangeDocument(J,le,ke),onDidSaveTextDocument:(J,le,ke)=>St.onDidSaveDocument(J,le,ke),onWillSaveTextDocument:(J,le,ke)=>Vt.getOnWillSaveTextDocumentEvent(Me)(J,le,ke),get notebookDocuments(){return wt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,le){let ke;if(P.URI.isUri(J))ke=J,await wt.openNotebookDocument(J);else if(typeof J=="string")ke=P.URI.revive(await wt.createNotebookDocument({viewType:J,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(J,le,ke,ut){return wt.registerNotebookSerializer(Me,J,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(J,le,ke,ut)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),wt.registerNotebookContentProvider(Me,J,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(J,le,ke)=>Bt.onDidChangeConfiguration(J,le,ke),getConfiguration(J,le){return le=arguments.length===1?void 0:le,Bt.getConfiguration(J,le,Me)},registerTextDocumentContentProvider(J,le){return Qt.registerTextDocumentContentProvider(J,le)},registerTaskProvider:(J,le)=>(Re.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,J,le)),registerFileSystemProvider(J,le,ke){return(0,De.combinedDisposable)(ci.registerFileSystemProvider(Me,J,le,ke),Te.addFileSystemProvider(J,le))},get fs(){return Te.value},registerFileSearchProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ut.registerFileSearchProvider(J,le)),registerTextSearchProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Ut.registerTextSearchProvider(J,le)),registerRemoteAuthorityResolver:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),ze.registerRemoteAuthorityResolver(J,le)),registerResourceLabelFormatter:J=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ci.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,le,ke)=>Lt.onDidCreateFile(J,le,ke),onDidDeleteFiles:(J,le,ke)=>Lt.onDidDeleteFile(J,le,ke),onDidRenameFiles:(J,le,ke)=>Lt.onDidRenameFile(J,le,ke),onWillCreateFiles:(J,le,ke)=>Lt.getOnWillCreateFileEvent(Me)(J,le,ke),onWillDeleteFiles:(J,le,ke)=>Lt.getOnWillDeleteFileEvent(Me)(J,le,ke),onWillRenameFiles:(J,le,ke)=>Lt.getOnWillRenameFileEvent(Me)(J,le,ke),openTunnel:J=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,J).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(J,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(J,le,ke)),registerPortAttributesProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(J,le)),registerTimelineProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),Di.registerTimelineProvider(J,le,Me.identifier,dt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:J=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,le,ke)=>Le.onDidGrantWorkspaceTrust(J,le,ke)},mi={get inputBox(){return Re.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Me)},createSourceControl(J,le,ke){return vi.createSourceControl(Me,J,le,ke)}},Oi={createCommentController(J,le){return ui.createCommentController(Me,J,le)}},Li={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(J,le,ke){return bt.onDidStartDebugSession(J,le,ke)},onDidTerminateDebugSession(J,le,ke){return bt.onDidTerminateDebugSession(J,le,ke)},onDidChangeActiveDebugSession(J,le,ke){return bt.onDidChangeActiveDebugSession(J,le,ke)},onDidReceiveDebugSessionCustomEvent(J,le,ke){return bt.onDidReceiveDebugSessionCustomEvent(J,le,ke)},onDidChangeBreakpoints(J,le,ke){return bt.onDidChangeBreakpoints(J,le,ke)},registerDebugConfigurationProvider(J,le,ke){return bt.registerDebugConfigurationProvider(J,le,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,le){return bt.registerDebugAdapterDescriptorFactory(Me,J,le)},registerDebugAdapterTrackerFactory(J,le){return bt.registerDebugAdapterTrackerFactory(J,le)},startDebugging(J,le,ke){return!ke||typeof ke=="object"&&"configuration"in ke?bt.startDebugging(J,le,{parentSession:ke}):bt.startDebugging(J,le,ke||{})},stopDebugging(J){return bt.stopDebugging(J)},addBreakpoints(J){return bt.addBreakpoints(J)},removeBreakpoints(J){return bt.removeBreakpoints(J)},asDebugSourceUri(J,le){return bt.asDebugSourceUri(J,le)}},Ni={registerTaskProvider:(J,le)=>It.registerTaskProvider(Me,J,le),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Me,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,le,ke)=>It.onDidStartTask(J,le,ke),onDidEndTask:(J,le,ke)=>It.onDidEndTask(J,le,ke),onDidStartTaskProcess:(J,le,ke)=>It.onDidStartTaskProcess(J,le,ke),onDidEndTaskProcess:(J,le,ke)=>It.onDidEndTaskProcess(J,le,ke)},Ui={createNotebookController(J,le,ke,ut,Ct){return Xt.createNotebookController(Me,J,le,ke,ut,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(J,le)=>wt.registerNotebookCellStatusBarItemProvider(Me,J,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ai.createRendererMessaging(Me,J)},onDidChangeNotebookDocumentMetadata(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookDocumentMetadata(J,le,ke)},onDidChangeNotebookCells(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeNotebookCells(J,le,ke)},onDidChangeNotebookCellExecutionState(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(J,le,ke)},onDidChangeCellOutputs(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellOutputs(J,le,ke)},onDidChangeCellMetadata(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellMetadata(J,le,ke)},createConcatTextDocument(J,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new Se.ExtHostNotebookConcatDocument(wt,St,J,le)}};return{version:ue.version,authentication:Ot,commands:ri,comments:Oi,debug:Li,env:Ei,extensions:Ri,languages:Fi,notebooks:Ui,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:_i,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:T.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:i.UIKind,Uri:P.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=te}),define(ye[221],_e([0,1,220,33,213,7,10,5,11]),function(ee,e,r,t,_,A,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends _.RequireInterceptor{_installInterceptor(){}getModule(l,s){for(let g of this._alternatives){let M=g(l);if(M){l=M;break}}if(this._factories.has(l))return this._factories.get(l).load(l,s,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);i(l,this._initData.environment.isExtensionDevelopmentDebug);const s=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,s,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,s,g){s=s.with({path:w(s.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const M=await fetch(D.FileAccess.asBrowserUri(s).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),M.status!==200)throw new Error(M.statusText);const C=await M.text(),b=`${s.toString(!0)}#vscode-extension`,u=`${C}
//# sourceURL=${b}`;let S;try{S=new Function("module","exports","require",u)}catch(n){throw console.error(l?`Loading code for extension ${l.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${s.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const a={},F={exports:a},o=n=>{const d=this._fakeModules.getModule(n,s);if(d===void 0)throw new Error(`Cannot load module '${n}'`);return d};try{return g.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),S(F,a,o),F.exports!==a?F.exports:a}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),g.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const s=Date.now()+l;for(;Date.now()<s&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=R;function w(h,l){return h.endsWith(l)?h:h+l}function i(h,l){s("info","log"),s("log","log"),s("warn","warn"),s("error","error");function s(C,b){const u=console[C];console[C]=function(){h.$logExtensionHostMessage({type:"__$console",severity:b,arguments:M(arguments)}),l&&u.apply(console,arguments)}}const g=1e5;function M(C){const b=[],u=[];if(C.length)for(let S=0;S<C.length;S++){if(typeof C[S]=="undefined")C[S]="undefined";else if(C[S]instanceof Error){const a=C[S];a.stack?C[S]=a.stack:C[S]=a.toString()}u.push(C[S])}try{const S=JSON.stringify(u,function(a,F){if(F&&typeof F=="object"){if(b.indexOf(F)!==-1)return"[Circular]";b.push(F)}return F});return S.length>g?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}}),define(ye[222],_e([0,1,44,33,71,221]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostExtensionService,A.ExtHostExtensionService),(0,r.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(ye[234],_e([0,1,21,4,170,214,208,17,72,11,2,217,222]),function(ee,e,r,t,_,A,P,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(b,u){return b instanceof Request||/^file:/i.test(String(b))&&(b=T.FileAccess.asBrowserUri(R.URI.parse(String(b))).toString(!0)),h(b,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,u,S,a,F){return/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0)),super.open(b,u,S??!0,a,F)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.Worker;Worker=function(u,S){/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0));const F=`(${function(p){function c(E){return typeof E=="string"||E instanceof URL?String(E).replace(/^file:\/\//i,"vscode-file://vscode-app"):E}const m=fetch.bind(self);self.fetch=function(E,v){return E instanceof Request?m(E,v):m(c(E),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,v,k,U,N){return super.open(E,c(v),k??!0,U,N)}};const f=importScripts.bind(self);self.importScripts=(...E)=>{f(...E.map(c))},f(p)}.toString()}('${u}'))`;S=S||{},S.name=S.name||I.basename(u.toString());const o=new Blob([F],{type:"application/javascript"}),n=URL.createObjectURL(o);return new b(n,S)}}else self.Worker=class extends P.NestedWorker{constructor(b,u){super(i,b,{name:I.basename(b.toString()),...u})}};const l=new class{constructor(){this.pid=void 0}exit(b){w()}async exists(b){return!0}async realpath(b){return b}};class s{constructor(){const u=new MessageChannel,S=new t.Emitter;let a=!1;i(u.port2,[u.port2]),u.port1.onmessage=F=>{const{data:o}=F;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const n=r.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,_.isMessageOfType)(n,2)){a=!0,M("received terminate message from renderer");return}S.fire(n)},this.protocol={onMessage:S.event,send:F=>{if(!a){const o=F.buffer.buffer.slice(F.buffer.byteOffset,F.buffer.byteOffset+F.buffer.byteLength);u.port1.postMessage(o,[o])}}}}}function g(b){return new Promise(u=>{const S=b.onMessage(a=>{S.dispose();const F=JSON.parse(a.toString());b.send((0,_.createMessageOfType)(0)),u({protocol:b,initData:F})});b.send((0,_.createMessageOfType)(1))})}let M=b=>w();function C(){D.mark("code/extHost/willConnectToRenderer");const b=new s;return{onmessage(u){g(b.protocol).then(S=>{D.mark("code/extHost/didWaitForInitData");const a=new A.ExtensionHostMain(S.protocol,S.initData,l,null,u);M=F=>a.terminate(F)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23aa7ad51c95d90d48b1d352a316d7f0c2c4310d/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
